/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/base/common/types","electron","vs/nls","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","fs","vs/base/node/pfs","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],J=function(H){for(var e=[],v=0,A=H.length;v<A;v++)e[v]=X[H[v]];return e};define(X[100],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(A,L){if(!A)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=v}),define(X[53],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function v(S){return(y,n,g)=>{let E=null,p=null;if(typeof g.value=="function"?(E="value",p=g.value):typeof g.get=="function"&&(E="get",p=g.get),!p)throw new Error("not supported");g[E]=S(p,n)}}e.createDecorator=v;let A=0;function L(){const S=`$memoize${A++}`;let y;const n=function(E,p,d){let w=null,P=null;if(typeof d.value=="function"?(w="value",P=d.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(w="get",P=d.get),!P)throw new Error("not supported");const I=`${S}:${p}`;d[w]=function(...a){return y=this,this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!0,enumerable:!1,writable:!0,value:P.apply(this,a)}),this[I]}};return n.clear=()=>{typeof y!="undefined"&&Object.getOwnPropertyNames(y).forEach(g=>{g.indexOf(S)===0&&delete y[g]})},n}e.createMemoizer=L;function b(S,y,n){return L()(S,y,n)}e.memoize=b;function M(S,y,n){return v((g,E)=>{const p=`$debounce$${E}`,d=`$debounce$result$${E}`;return function(...w){this[d]||(this[d]=n?n():void 0),clearTimeout(this[p]),y&&(this[d]=y(this[d],...w),w=[this[d]]),this[p]=setTimeout(()=>{g.apply(this,w),this[d]=n?n():void 0},S)}})}e.debounce=M;function i(S,y,n){return v((g,E)=>{const p=`$throttle$timer$${E}`,d=`$throttle$result$${E}`,w=`$throttle$lastRun$${E}`,P=`$throttle$pending$${E}`;return function(...I){if(this[d]||(this[d]=n?n():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),y&&(this[d]=y(this[d],...I)),!this[P]){const a=this[w]+S;a<=Date.now()?(this[w]=Date.now(),g.apply(this,[this[d]]),this[d]=n?n():void 0):(this[P]=!0,this[p]=setTimeout(()=>{this[P]=!1,this[w]=Date.now(),g.apply(this,[this[d]]),this[d]=n?n():void 0},a-Date.now()))}}})}e.throttle=i}),define(X[17],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function A(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=A;function L(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=L;function b(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=b;function M(c){if(c instanceof Error){let{name:t,message:r}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:r,stack:s}}return c}e.transformErrorForSerialization=M;const i="Canceled";function S(c){return c instanceof Error&&c.name===i&&c.message===i}e.isPromiseCanceledError=S;class y extends Error{constructor(){super(i);this.name=this.message}}e.CancellationError=y;function n(){const c=new Error(i);return c.name=c.message,c}e.canceled=n;function g(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=g;function E(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=E;function p(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function d(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=w;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class a extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=a;function l(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function o(c,t=Object.create(null)){const r=new Error(c);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(X[35],J([0,1,17]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(C,j=0){return C[C.length-(1+j)]}e.tail=A;function L(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=L;function b(C,j,N=(T,R)=>T===R){if(C===j)return!0;if(!C||!j||C.length!==j.length)return!1;for(let T=0,R=C.length;T<R;T++)if(!N(C[T],j[T]))return!1;return!0}e.equals=b;function M(C,j,N){let T=0,R=C.length-1;for(;T<=R;){const W=(T+R)/2|0,k=N(C[W],j);if(k<0)T=W+1;else if(k>0)R=W-1;else return W}return-(T+1)}e.binarySearch=M;function i(C,j){let N=0,T=C.length;if(T===0)return 0;for(;N<T;){const R=Math.floor((N+T)/2);j(C[R])?T=R:N=R+1}return N}e.findFirstInSorted=i;function S(C,j,N){if(C=C|0,C>=j.length)throw new TypeError("invalid index");let T=j[Math.floor(j.length*Math.random())],R=[],W=[],k=[];for(let F of j){const B=N(F,T);B<0?R.push(F):B>0?W.push(F):k.push(F)}return C<R.length?S(C,R,N):C<R.length+k.length?k[0]:S(C-(R.length+k.length),W,N)}e.quickSelect=S;function y(C,j){const N=[];let T;for(const R of C.slice(0).sort(j))!T||j(T[0],R)!==0?(T=[R],N.push(T)):T.push(R);return N}e.groupBy=y;function n(C,j,N){const T=[];function R(F,B,V){if(!(B===0&&V.length===0)){const G=T[T.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=B,G.toInsert.push(...V)):T.push({start:F,deleteCount:B,toInsert:V})}}let W=0,k=0;for(;;){if(W===C.length){R(W,0,j.slice(k));break}if(k===j.length){R(W,C.length-W,[]);break}const F=C[W],B=j[k],V=N(F,B);V===0?(W+=1,k+=1):V<0?(R(W,1,[]),W+=1):V>0&&(R(W,0,[B]),k+=1)}return T}e.sortedDiff=n;function g(C,j,N){const T=n(C,j,N),R=[],W=[];for(const k of T)R.push(...C.slice(k.start,k.start+k.deleteCount)),W.push(...k.toInsert);return{removed:R,added:W}}e.delta=g;function E(C,j,N){if(N===0)return[];const T=C.slice(0,N).sort(j);return d(C,j,T,N,C.length),T}e.top=E;function p(C,j,N,T,R){return N===0?Promise.resolve([]):new Promise((W,k)=>{(async()=>{const F=C.length,B=C.slice(0,N).sort(j);for(let V=N,G=Math.min(N+T,F);V<F;V=G,G=Math.min(G+T,F)){if(V>N&&await new Promise(Y=>setTimeout(Y)),R&&R.isCancellationRequested)throw(0,v.canceled)();d(C,j,B,V,G)}return B})().then(W,k)})}e.topAsync=p;function d(C,j,N,T,R){for(const W=N.length;T<R;T++){const k=C[T];if(j(k,N[W-1])<0){N.pop();const F=i(N,B=>j(k,B)<0);N.splice(F,0,k)}}}function w(C){return C.filter(j=>!!j)}e.coalesce=w;function P(C){let j=0;for(let N=0;N<C.length;N++)C[N]&&(C[j]=C[N],j+=1);C.length=j}e.coalesceInPlace=P;function I(C,j,N){C.splice(N,0,C.splice(j,1)[0])}e.move=I;function a(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=a;function l(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=l;function o(C,j){if(!j)return C.filter((T,R)=>C.indexOf(T)===R);const N=Object.create(null);return C.filter(T=>{const R=j(T);return N[R]?!1:(N[R]=!0,!0)})}e.distinct=o;function c(C){const j=new Set;return C.filter(N=>j.has(N)?!1:(j.add(N),!0))}e.distinctES6=c;function t(C){const j=Object.create(null);return N=>{const T=C(N);return j[T]?!1:(j[T]=!0,!0)}}e.uniqueFilter=t;function r(C,j){for(let N=C.length-1;N>=0;N--){const T=C[N];if(j(T))return N}return-1}e.lastIndex=r;function s(C,j){return C.length>0?C[0]:j}e.firstOrDefault=s;function u(C,j,N=(T,R)=>T===R){let T=0;for(let R=0,W=Math.min(C.length,j.length);R<W&&N(C[R],j[R]);R++)T++;return T}e.commonPrefixLength=u;function h(C){return[].concat(...C)}e.flatten=h;function f(C,j){let N=typeof j=="number"?C:0;typeof j=="number"?N=C:(N=0,j=C);const T=[];if(N<=j)for(let R=N;R<j;R++)T.push(R);else for(let R=N;R>j;R--)T.push(R);return T}e.range=f;function m(C,j,N){return C.reduce((T,R)=>(T[j(R)]=N?N(R):R,T),Object.create(null))}e.index=m;function D(C,j){return C.push(j),()=>_(C,j)}e.insert=D;function _(C,j){const N=C.indexOf(j);if(N>-1)return C.splice(N,1),j}e.remove=_;function U(C,j,N){const T=C.slice(0,j),R=C.slice(j);return T.concat(N,R)}e.arrayInsert=U;function q(C,j){let N;if(typeof j=="number"){let T=j;N=()=>{const R=Math.sin(T++)*179426549;return R-Math.floor(R)}}else N=Math.random;for(let T=C.length-1;T>0;T-=1){const R=Math.floor(N()*(T+1)),W=C[T];C[T]=C[R],C[R]=W}}e.shuffle=q;function Q(C,j){const N=C.indexOf(j);N>-1&&(C.splice(N,1),C.unshift(j))}e.pushToStart=Q;function ie(C,j){const N=C.indexOf(j);N>-1&&(C.splice(N,1),C.push(j))}e.pushToEnd=ie;function ae(C,j){return Array.isArray(C)?C.map(j):j(C)}e.mapArrayOrNot=ae;function O(C){return Array.isArray(C)?C:[C]}e.asArray=O;function $(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=$;function z(C,j){for(const N of C){const T=j(N);if(T!==void 0)return T}}e.mapFind=z}),define(X[42],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(A){const L=this;let b=!1,M;return function(){return b||(b=!0,M=A.apply(L,arguments)),M}}e.once=v}),define(X[62],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(A){function L(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}A.is=L;const b=Object.freeze([]);function M(){return b}A.empty=M;function*i(c){yield c}A.single=i;function S(c){return c||b}A.from=S;function y(c){return!c||c[Symbol.iterator]().next().done===!0}A.isEmpty=y;function n(c){return c[Symbol.iterator]().next().value}A.first=n;function g(c,t){for(const r of c)if(t(r))return!0;return!1}A.some=g;function E(c,t){for(const r of c)if(t(r))return r}A.find=E;function*p(c,t){for(const r of c)t(r)&&(yield r)}A.filter=p;function*d(c,t){for(const r of c)yield t(r)}A.map=d;function*w(...c){for(const t of c)for(const r of t)yield r}A.concat=w;function*P(c){for(const t of c)for(const r of t)yield r}A.concatNested=P;function I(c,t,r){let s=r;for(const u of c)s=t(s,u);return s}A.reduce=I;function*a(c,t,r=c.length){for(t<0&&(t+=c.length),r<0?r+=c.length:r>c.length&&(r=c.length);t<r;t++)yield c[t]}A.slice=a;function l(c,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,c];const s=c[Symbol.iterator]();for(let u=0;u<t;u++){const h=s.next();if(h.done)return[r,A.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return s}}]}A.consume=l;function o(c,t,r=(s,u)=>s===u){const s=c[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const h=s.next(),f=u.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!r(h.value,f.value))return!1}}A.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(X[43],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function M(t,r=!1){let s=0,u=t.length,h="",f=0,m=16,D=0;function _($){let z=0,C=0;for(;z<$;){const j=t.charCodeAt(s);if(j>=48&&j<=57)C=C*16+j-48;else if(j>=65&&j<=70)C=C*16+j-65+10;else if(j>=97&&j<=102)C=C*16+j-97+10;else break;s++,z++}return z<$&&(C=-1),C}function U($){s=$,h="",f=0,m=16,D=0}function q(){const $=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return D=3,t.substring($,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;z=s}else D=3;return t.substring($,z)}function Q(){let $="",z=s;for(;;){if(s>=u){$+=t.substring(z,s),D=2;break}const C=t.charCodeAt(s);if(C===34){$+=t.substring(z,s),s++;break}if(C===92){if($+=t.substring(z,s),s++,s>=u){D=2;break}switch(t.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const N=_(4);N>=0?$+=String.fromCharCode(N):D=4;break;default:D=5}z=s;continue}if(C>=0&&C<=31)if(S(C)){$+=t.substring(z,s),D=2;break}else D=6;s++}return $}function ie(){if(h="",D=0,f=s,s>=u)return f=u,m=17;let $=t.charCodeAt(s);if(i($)){do s++,h+=String.fromCharCode($),$=t.charCodeAt(s);while(i($));return m=15}if(S($))return s++,h+=String.fromCharCode($),$===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),m=14;switch($){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,h=Q(),m=10;case 47:const z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<u&&!S(t.charCodeAt(s));)s++;return h=t.substring(z,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const C=u-1;let j=!1;for(;s<C;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,j=!0;break}s++}return j||(s++,D=1),h=t.substring(z,s),m=13}return h+=String.fromCharCode($),s++,m=16;case 45:if(h+=String.fromCharCode($),s++,s===u||!y(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=q(),m=11;default:for(;s<u&&ae($);)s++,$=t.charCodeAt(s);if(f!==s){switch(h=t.substring(f,s),h){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return h+=String.fromCharCode($),s++,m=16}}function ae($){if(i($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let $;do $=ie();while($>=12&&$<=15);return $}return{setPosition:U,getPosition:()=>s,scan:r?O:ie,getToken:()=>m,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>D}}e.createScanner=M;function i(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function g(t,r){const s=[],u=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(_,U,q,Q){f.value=_,f.offset=U,f.length=q,f.type=Q,f.colonOffset=void 0,h=f}try{l(t,{onObjectBegin:(_,U)=>{if(r<=_)throw u;h=void 0,m=r>_,s.push("")},onObjectProperty:(_,U,q)=>{if(r<U||(D(_,U,q,"property"),s[s.length-1]=_,r<=U+q))throw u},onObjectEnd:(_,U)=>{if(r<=_)throw u;h=void 0,s.pop()},onArrayBegin:(_,U)=>{if(r<=_)throw u;h=void 0,s.push(0)},onArrayEnd:(_,U)=>{if(r<=_)throw u;h=void 0,s.pop()},onLiteralValue:(_,U,q)=>{if(r<U||(D(_,U,q,c(_)),r<=U+q))throw u},onSeparator:(_,U,q)=>{if(r<=U)throw u;if(_===":"&&h&&h.type==="property")h.colonOffset=U,m=!1,h=void 0;else if(_===","){const Q=s[s.length-1];typeof Q=="number"?s[s.length-1]=Q+1:(m=!0,s[s.length-1]=""),h=void 0}}})}catch(_){if(_!==u)throw _}return{path:s,previousNode:h,isAtPropertyKey:m,matches:_=>{let U=0;for(let q=0;U<_.length&&q<s.length;q++)if(_[U]===s[q]||_[U]==="*")U++;else if(_[U]!=="**")return!1;return U===_.length}}}e.getLocation=g;function E(t,r=[],s=b.DEFAULT){let u=null,h=[];const f=[];function m(_){Array.isArray(h)?h.push(_):u!==null&&(h[u]=_)}return l(t,{onObjectBegin:()=>{const _={};m(_),f.push(h),h=_,u=null},onObjectProperty:_=>{u=_},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const _=[];m(_),f.push(h),h=_,u=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:m,onError:(_,U,q)=>{r.push({error:_,offset:U,length:q})}},s),h[0]}e.parse=E;function p(t,r=[],s=b.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(_){u.type==="property"&&(u.length=_-u.offset,u=u.parent)}function f(_){return u.children.push(_),_}l(t,{onObjectBegin:_=>{u=f({type:"object",offset:_,length:-1,parent:u,children:[]})},onObjectProperty:(_,U,q)=>{u=f({type:"property",offset:U,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:_,offset:U,length:q,parent:u})},onObjectEnd:(_,U)=>{u.length=_+U-u.offset,u=u.parent,h(_+U)},onArrayBegin:(_,U)=>{u=f({type:"array",offset:_,length:-1,parent:u,children:[]})},onArrayEnd:(_,U)=>{u.length=_+U-u.offset,u=u.parent,h(_+U)},onLiteralValue:(_,U,q)=>{f({type:c(_),offset:U,length:q,parent:u,value:_}),h(U+q)},onSeparator:(_,U,q)=>{u.type==="property"&&(_===":"?u.colonOffset=U:_===","&&h(U))},onError:(_,U,q)=>{r.push({error:_,offset:U,length:q})}},s);const D=u.children[0];return D&&delete D.parent,D}e.parseTree=p;function d(t,r){if(!!t){let s=t;for(let u of r)if(typeof u=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===u){s=f.children[1],h=!0;break}if(!h)return}else{const h=u;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const r=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=w;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const r=Object.create(null);for(let s of t.children){const u=s.children[1];u&&(r[s.children[0].value]=P(u))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function I(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=I;function a(t,r,s=!1){if(I(t,r,s)){const u=t.children;if(Array.isArray(u))for(let h=0;h<u.length&&u[h].offset<=r;h++){const f=a(u[h],r,s);if(f)return f}return t}}e.findNodeAtOffset=a;function l(t,r,s=b.DEFAULT){const u=M(t,!1);function h(B){return B?()=>B(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(B){return B?V=>B(V,u.getTokenOffset(),u.getTokenLength()):()=>!0}const m=h(r.onObjectBegin),D=f(r.onObjectProperty),_=h(r.onObjectEnd),U=h(r.onArrayBegin),q=h(r.onArrayEnd),Q=f(r.onLiteralValue),ie=f(r.onSeparator),ae=h(r.onComment),O=f(r.onError),$=s&&s.disallowComments,z=s&&s.allowTrailingComma;function C(){for(;;){const B=u.scan();switch(u.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:$||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(B){case 12:case 13:$?j(10):ae();break;case 16:j(1);break;case 15:case 14:break;default:return B}}}function j(B,V=[],G=[]){if(O(B),V.length+G.length>0){let Y=u.getToken();for(;Y!==17;){if(V.indexOf(Y)!==-1){C();break}else if(G.indexOf(Y)!==-1)break;Y=C()}}}function N(B){const V=u.getTokenValue();return B?Q(V):D(V),C(),!0}function T(){switch(u.getToken()){case 11:let B=0;try{B=JSON.parse(u.getTokenValue()),typeof B!="number"&&(j(2),B=0)}catch(V){j(2)}Q(B);break;case 7:Q(null);break;case 8:Q(!0);break;case 9:Q(!1);break;default:return!1}return C(),!0}function R(){return u.getToken()!==10?(j(3,[],[2,5]),!1):(N(!1),u.getToken()===6?(ie(":"),C(),F()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function W(){m(),C();let B=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(B||j(4,[],[]),ie(","),C(),u.getToken()===2&&z)break}else B&&j(6,[],[]);R()||j(4,[],[2,5]),B=!0}return _(),u.getToken()!==2?j(7,[2],[]):C(),!0}function k(){U(),C();let B=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(B||j(4,[],[]),ie(","),C(),u.getToken()===4&&z)break}else B&&j(6,[],[]);F()||j(4,[],[4,5]),B=!0}return q(),u.getToken()!==4?j(8,[4],[]):C(),!0}function F(){switch(u.getToken()){case 3:return k();case 1:return W();case 10:return N(!0);default:return T()}}return C(),u.getToken()===17?s.allowEmptyContent?!0:(j(4,[],[]),!1):F()?(u.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=l;function o(t,r){let s=M(t),u=[],h,f=0,m;do switch(m=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:f!==m&&u.push(t.substring(f,m)),r!==void 0&&u.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(h!==17);return u.join("")}e.stripComments=o;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(X[101],J([0,1,43]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(S,y,n){let g,E,p,d,w;if(y){for(d=y.offset,w=d+y.length,p=d;p>0&&!i(S,p-1);)p--;let f=w;for(;f<S.length&&!i(S,f);)f++;E=S.substring(p,f),g=b(E,n)}else E=S,g=0,p=0,d=0,w=S.length;const P=M(n,S);let I=!1,a=0,l;n.insertSpaces?l=L(" ",n.tabSize||4):l="	";const o=(0,v.createScanner)(E,!1);let c=!1;function t(){return P+L(l,g+a)}function r(){let f=o.scan();for(I=!1;f===15||f===14;)I=I||f===14,f=o.scan();return c=f===16||o.getTokenError()!==0,f}const s=[];function u(f,m,D){!c&&m<w&&D>d&&S.substring(m,D)!==f&&s.push({offset:m,length:D-m,content:f})}let h=r();if(h!==17){const f=o.getTokenOffset()+p,m=L(l,g);u(m,p,f)}for(;h!==17;){let f=o.getTokenOffset()+o.getTokenLength()+p,m=r(),D="";for(;!I&&(m===12||m===13);){const U=o.getTokenOffset()+p;u(" ",f,U),f=o.getTokenOffset()+o.getTokenLength()+p,D=m===12?t():"",m=r()}if(m===2)h!==1&&(a--,D=t());else if(m===4)h!==3&&(a--,D=t());else{switch(h){case 3:case 1:a++,D=t();break;case 5:case 12:D=t();break;case 13:I?D=t():D=" ";break;case 6:D=" ";break;case 10:if(m===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?D=" ":m!==5&&m!==17&&(c=!0);break;case 16:c=!0;break}I&&(m===12||m===13)&&(D=t())}const _=o.getTokenOffset()+p;u(D,f,_),h=m}return s}e.format=A;function L(S,y){let n="";for(let g=0;g<y;g++)n+=S;return n}function b(S,y){let n=0,g=0;const E=y.tabSize||4;for(;n<S.length;){const p=S.charAt(n);if(p===" ")g++;else if(p==="	")g+=E;else break;n++}return Math.floor(g/E)}function M(S,y){for(let n=0;n<y.length;n++){const g=y.charAt(n);if(g==="\r")return n+1<y.length&&y.charAt(n+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=M;function i(S,y){return`\r
`.indexOf(S.charAt(y))!==-1}e.isEOL=i}),define(X[102],J([0,1,43,101]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(y,n,g){return b(y,n,void 0,g)}e.removeProperty=L;function b(y,n,g,E,p){const d=n.slice(),w=[],P=(0,v.parseTree)(y,w);let I,a;for(;d.length>0&&(a=d.pop(),I=(0,v.findNodeAtLocation)(P,d),I===void 0&&g!==void 0);)typeof a=="string"?g={[a]:g}:g=[g];if(I)if(I.type==="object"&&typeof a=="string"&&Array.isArray(I.children)){const l=(0,v.findNodeAtLocation)(I,[a]);if(l!==void 0)if(g===void 0){if(!l.parent)throw new Error("Malformed AST");const o=I.children.indexOf(l.parent);let c,t=l.parent.offset+l.parent.length;if(o>0){const r=I.children[o-1];c=r.offset+r.length}else c=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return M(y,{offset:c,length:t-c,content:""},E)}else return M(y,{offset:l.offset,length:l.length,content:JSON.stringify(g)},E);else{if(g===void 0)return[];const o=`${JSON.stringify(a)}: ${JSON.stringify(g)}`,c=p?p(I.children.map(r=>r.children[0].value)):I.children.length;let t;if(c>0){const r=I.children[c-1];t={offset:r.offset+r.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return M(y,t,E)}}else if(I.type==="array"&&typeof a=="number"&&Array.isArray(I.children))if(g!==void 0){const l=`${JSON.stringify(g)}`;let o;if(I.children.length===0||a===0)o={offset:I.offset+1,length:0,content:I.children.length===0?l:l+","};else{const c=a===-1||a>I.children.length?I.children.length:a,t=I.children[c-1];o={offset:t.offset+t.length,length:0,content:","+l}}return M(y,o,E)}else{const l=a,o=I.children[l];let c;if(I.children.length===1)c={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===l){const t=I.children[l-1],r=t.offset+t.length,s=I.offset+I.length;c={offset:r,length:s-2-r,content:""}}else c={offset:o.offset,length:I.children[l+1].offset-o.offset,content:""};return M(y,c,E)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${I.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return M(y,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(g)},E)}}e.setProperty=b;function M(y,n,g){let E=i(y,n),p=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;p>0&&!(0,A.isEOL)(E,p-1);)p--;for(;d<E.length&&!(0,A.isEOL)(E,d);)d++}const w=(0,A.format)(E,{offset:p,length:d-p},g);for(let I=w.length-1;I>=0;I--){const a=w[I];E=i(E,a),p=Math.min(p,a.offset),d=Math.max(d,a.offset+a.length),d+=a.content.length-a.length}const P=y.length-(E.length-d)-p;return[{offset:p,length:P,content:E.substring(p,d)}]}e.withFormatting=M;function i(y,n){return y.substring(0,n.offset)+n.content+y.substring(n.offset+n.length)}e.applyEdit=i;function S(y,n){let g=n.slice(0).sort((p,d)=>{const w=p.offset-d.offset;return w===0?p.length-d.length:w}),E=y.length;for(let p=g.length-1;p>=0;p--){let d=g[p];if(d.offset+d.length<=E)y=i(y,d);else throw new Error("Overlapping edit");E=d.offset}return y}e.applyEdits=S}),define(X[57],J([0,1,17]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var A;(function(a){a[a.DependsOnKbLayout=-1]="DependsOnKbLayout",a[a.Unknown=0]="Unknown",a[a.Backspace=1]="Backspace",a[a.Tab=2]="Tab",a[a.Enter=3]="Enter",a[a.Shift=4]="Shift",a[a.Ctrl=5]="Ctrl",a[a.Alt=6]="Alt",a[a.PauseBreak=7]="PauseBreak",a[a.CapsLock=8]="CapsLock",a[a.Escape=9]="Escape",a[a.Space=10]="Space",a[a.PageUp=11]="PageUp",a[a.PageDown=12]="PageDown",a[a.End=13]="End",a[a.Home=14]="Home",a[a.LeftArrow=15]="LeftArrow",a[a.UpArrow=16]="UpArrow",a[a.RightArrow=17]="RightArrow",a[a.DownArrow=18]="DownArrow",a[a.Insert=19]="Insert",a[a.Delete=20]="Delete",a[a.KEY_0=21]="KEY_0",a[a.KEY_1=22]="KEY_1",a[a.KEY_2=23]="KEY_2",a[a.KEY_3=24]="KEY_3",a[a.KEY_4=25]="KEY_4",a[a.KEY_5=26]="KEY_5",a[a.KEY_6=27]="KEY_6",a[a.KEY_7=28]="KEY_7",a[a.KEY_8=29]="KEY_8",a[a.KEY_9=30]="KEY_9",a[a.KEY_A=31]="KEY_A",a[a.KEY_B=32]="KEY_B",a[a.KEY_C=33]="KEY_C",a[a.KEY_D=34]="KEY_D",a[a.KEY_E=35]="KEY_E",a[a.KEY_F=36]="KEY_F",a[a.KEY_G=37]="KEY_G",a[a.KEY_H=38]="KEY_H",a[a.KEY_I=39]="KEY_I",a[a.KEY_J=40]="KEY_J",a[a.KEY_K=41]="KEY_K",a[a.KEY_L=42]="KEY_L",a[a.KEY_M=43]="KEY_M",a[a.KEY_N=44]="KEY_N",a[a.KEY_O=45]="KEY_O",a[a.KEY_P=46]="KEY_P",a[a.KEY_Q=47]="KEY_Q",a[a.KEY_R=48]="KEY_R",a[a.KEY_S=49]="KEY_S",a[a.KEY_T=50]="KEY_T",a[a.KEY_U=51]="KEY_U",a[a.KEY_V=52]="KEY_V",a[a.KEY_W=53]="KEY_W",a[a.KEY_X=54]="KEY_X",a[a.KEY_Y=55]="KEY_Y",a[a.KEY_Z=56]="KEY_Z",a[a.Meta=57]="Meta",a[a.ContextMenu=58]="ContextMenu",a[a.F1=59]="F1",a[a.F2=60]="F2",a[a.F3=61]="F3",a[a.F4=62]="F4",a[a.F5=63]="F5",a[a.F6=64]="F6",a[a.F7=65]="F7",a[a.F8=66]="F8",a[a.F9=67]="F9",a[a.F10=68]="F10",a[a.F11=69]="F11",a[a.F12=70]="F12",a[a.F13=71]="F13",a[a.F14=72]="F14",a[a.F15=73]="F15",a[a.F16=74]="F16",a[a.F17=75]="F17",a[a.F18=76]="F18",a[a.F19=77]="F19",a[a.NumLock=78]="NumLock",a[a.ScrollLock=79]="ScrollLock",a[a.US_SEMICOLON=80]="US_SEMICOLON",a[a.US_EQUAL=81]="US_EQUAL",a[a.US_COMMA=82]="US_COMMA",a[a.US_MINUS=83]="US_MINUS",a[a.US_DOT=84]="US_DOT",a[a.US_SLASH=85]="US_SLASH",a[a.US_BACKTICK=86]="US_BACKTICK",a[a.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",a[a.US_BACKSLASH=88]="US_BACKSLASH",a[a.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",a[a.US_QUOTE=90]="US_QUOTE",a[a.OEM_8=91]="OEM_8",a[a.OEM_102=92]="OEM_102",a[a.NUMPAD_0=93]="NUMPAD_0",a[a.NUMPAD_1=94]="NUMPAD_1",a[a.NUMPAD_2=95]="NUMPAD_2",a[a.NUMPAD_3=96]="NUMPAD_3",a[a.NUMPAD_4=97]="NUMPAD_4",a[a.NUMPAD_5=98]="NUMPAD_5",a[a.NUMPAD_6=99]="NUMPAD_6",a[a.NUMPAD_7=100]="NUMPAD_7",a[a.NUMPAD_8=101]="NUMPAD_8",a[a.NUMPAD_9=102]="NUMPAD_9",a[a.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",a[a.NUMPAD_ADD=104]="NUMPAD_ADD",a[a.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",a[a.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",a[a.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",a[a.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",a[a.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",a[a.ABNT_C1=110]="ABNT_C1",a[a.ABNT_C2=111]="ABNT_C2",a[a.MAX_VALUE=112]="MAX_VALUE"})(A=e.KeyCode||(e.KeyCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(l,o){this._keyCodeToStr[l]=o,this._strToKeyCode[o.toLowerCase()]=l}keyCodeToStr(l){return this._keyCodeToStr[l]}strToKeyCode(l){return this._strToKeyCode[l.toLowerCase()]||0}}const b=new L,M=new L,i=new L;(function(){function a(l,o,c=o,t=c){b.define(l,o),M.define(l,c),i.define(l,t)}a(0,"unknown"),a(1,"Backspace"),a(2,"Tab"),a(3,"Enter"),a(4,"Shift"),a(5,"Ctrl"),a(6,"Alt"),a(7,"PauseBreak"),a(8,"CapsLock"),a(9,"Escape"),a(10,"Space"),a(11,"PageUp"),a(12,"PageDown"),a(13,"End"),a(14,"Home"),a(15,"LeftArrow","Left"),a(16,"UpArrow","Up"),a(17,"RightArrow","Right"),a(18,"DownArrow","Down"),a(19,"Insert"),a(20,"Delete"),a(21,"0"),a(22,"1"),a(23,"2"),a(24,"3"),a(25,"4"),a(26,"5"),a(27,"6"),a(28,"7"),a(29,"8"),a(30,"9"),a(31,"A"),a(32,"B"),a(33,"C"),a(34,"D"),a(35,"E"),a(36,"F"),a(37,"G"),a(38,"H"),a(39,"I"),a(40,"J"),a(41,"K"),a(42,"L"),a(43,"M"),a(44,"N"),a(45,"O"),a(46,"P"),a(47,"Q"),a(48,"R"),a(49,"S"),a(50,"T"),a(51,"U"),a(52,"V"),a(53,"W"),a(54,"X"),a(55,"Y"),a(56,"Z"),a(57,"Meta"),a(58,"ContextMenu"),a(59,"F1"),a(60,"F2"),a(61,"F3"),a(62,"F4"),a(63,"F5"),a(64,"F6"),a(65,"F7"),a(66,"F8"),a(67,"F9"),a(68,"F10"),a(69,"F11"),a(70,"F12"),a(71,"F13"),a(72,"F14"),a(73,"F15"),a(74,"F16"),a(75,"F17"),a(76,"F18"),a(77,"F19"),a(78,"NumLock"),a(79,"ScrollLock"),a(80,";",";","OEM_1"),a(81,"=","=","OEM_PLUS"),a(82,",",",","OEM_COMMA"),a(83,"-","-","OEM_MINUS"),a(84,".",".","OEM_PERIOD"),a(85,"/","/","OEM_2"),a(86,"`","`","OEM_3"),a(110,"ABNT_C1"),a(111,"ABNT_C2"),a(87,"[","[","OEM_4"),a(88,"\\","\\","OEM_5"),a(89,"]","]","OEM_6"),a(90,"'","'","OEM_7"),a(91,"OEM_8"),a(92,"OEM_102"),a(93,"NumPad0"),a(94,"NumPad1"),a(95,"NumPad2"),a(96,"NumPad3"),a(97,"NumPad4"),a(98,"NumPad5"),a(99,"NumPad6"),a(100,"NumPad7"),a(101,"NumPad8"),a(102,"NumPad9"),a(103,"NumPad_Multiply"),a(104,"NumPad_Add"),a(105,"NumPad_Separator"),a(106,"NumPad_Subtract"),a(107,"NumPad_Decimal"),a(108,"NumPad_Divide")})();var S;(function(a){function l(s){return b.keyCodeToStr(s)}a.toString=l;function o(s){return b.strToKeyCode(s)}a.fromString=o;function c(s){return M.keyCodeToStr(s)}a.toUserSettingsUS=c;function t(s){return i.keyCodeToStr(s)}a.toUserSettingsGeneral=t;function r(s){return M.strToKeyCode(s)||i.strToKeyCode(s)}a.fromUserSettings=r})(S=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl",a[a.KeyCode=255]="KeyCode"})(y||(y={}));var n;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl"})(n=e.KeyMod||(e.KeyMod={}));function g(a,l){const o=(l&65535)<<16>>>0;return(a|o)>>>0}e.KeyChord=g;function E(a,l){if(a===0)return null;const o=(a&65535)>>>0,c=(a&4294901760)>>>16;return c!==0?new w([p(o,l),p(c,l)]):new w([p(o,l)])}e.createKeybinding=E;function p(a,l){const o=!!(a&2048),c=!!(a&256),t=l===2?c:o,r=!!(a&1024),s=!!(a&512),u=l===2?o:c,h=a&255;return new d(t,r,s,u,h)}e.createSimpleKeybinding=p;class d{constructor(l,o,c,t,r){this.ctrlKey=l,this.shiftKey=o,this.altKey=c,this.metaKey=t,this.keyCode=r}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",c=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${l}${o}${c}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class w{constructor(l){if(l.length===0)throw(0,v.illegalArgument)("parts");this.parts=l}getHashCode(){let l="";for(let o=0,c=this.parts.length;o<c;o++)o!==0&&(l+=";"),l+=this.parts[o].getHashCode();return l}equals(l){if(l===null||this.parts.length!==l.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(l.parts[o]))return!1;return!0}}e.ChordKeybinding=w;class P{constructor(l,o,c,t,r,s){this.ctrlKey=l,this.shiftKey=o,this.altKey=c,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=P;class I{}e.ResolvedKeybinding=I}),define(X[2],J([0,1,42,62]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let b=null;function M(l){b=l}if(e.setDisposableTracker=M,L){const l="__is_disposable_tracked__";b=new class{trackDisposable(o){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[l]||console.log(c)},3e3)}markTracked(o){if(o&&o!==w.None)try{o[l]=!0}catch(c){}}}}function i(l){!b||b.markTracked(l)}function S(l){return b&&b.trackDisposable(l),l}e.trackDisposable=S;class y extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=y;function n(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=n;function g(l){if(A.Iterable.is(l)){let o=[];for(const c of l)if(c){i(c);try{c.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new y(o);return Array.isArray(l)?[]:l}else if(l)return i(l),l.dispose(),l}e.dispose=g;function E(...l){return l.forEach(i),p(()=>g(l))}e.combinedDisposable=E;function p(l){const o=S({dispose:()=>{i(o),l()}});return o}e.toDisposable=p;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(i(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return i(o),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new d,S(this)}dispose(){i(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class P{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var c;this._isDisposed||o===this._value||((c=this._value)===null||c===void 0||c.dispose(),o&&i(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,i(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=P;class I{constructor(){this.references=new Map}acquire(o,...c){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...c)},this.references.set(o,t));const{object:r}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:r,dispose:s}}}e.ReferenceCollection=I;class a{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=a}),define(X[78],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(b){this.element=b,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class A{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,M){const i=new v(b);if(this._first===v.Undefined)this._first=i,this._last=i;else if(M){const y=this._last;this._last=i,i.prev=y,y.next=i}else{const y=this._first;this._first=i,i.next=y,y.prev=i}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(i))}}shift(){if(this._first!==v.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==v.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==v.Undefined&&b.next!==v.Undefined){const M=b.prev;M.next=b.next,b.next.prev=M}else b.prev===v.Undefined&&b.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):b.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):b.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==v.Undefined;)yield b.element,b=b.next}}e.LinkedList=A});"use strict";(function(){function H(L){const b=[];typeof L=="number"&&b.push("code/timeOrigin",L);function M(S){b.push(S,Date.now())}function i(){const S=[];for(let y=0;y<b.length;y+=2)S.push({name:b[y],startTime:b[y+1]});return S}return{mark:M,getMarks:i}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))b.push({name:M.name,startTime:Math.round(L+M.startTime)});return b}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function v(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=v(A))})(),define(X[3],J([0,1]),function(H,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let L=!1,b=!1,M=!1,i=!1,S=!1,y=!1,n=!1,g,E=A,p,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const P=typeof((v=w==null?void 0:w.versions)===null||v===void 0?void 0:v.electron)=="string"&&w.type==="renderer";if(e.isElectronSandboxed=P&&(w==null?void 0:w.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=w==null?void 0:w.env.VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!P)d=navigator.userAgent,L=d.indexOf("Windows")>=0,b=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=d.indexOf("Linux")>=0,y=!0,g=navigator.language,E=g;else if(typeof w=="object"){L=w.platform==="win32",b=w.platform==="darwin",M=w.platform==="linux",i=M&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,g=A,E=A;const u=w.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),f=h.availableLanguages["*"];g=h.locale,E=f||A,p=h._translationsConfigFile}catch(h){}S=!0}else console.error("Unable to resolve platform.");var I;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function a(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let l=0;b?l=1:L?l=3:M&&(l=2),e.isWindows=L,e.isMacintosh=b,e.isLinux=M,e.isLinuxSnap=i,e.isNative=S,e.isWeb=y,e.isIOS=n,e.platform=l,e.userAgent=d,e.language=E;var o;(function(u){function h(){return e.language}u.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function m(){return e.language==="en"}u.isDefault=m})(o=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let _=0,U=f.length;_<U;_++){const q=f[_];if(q.id===D.data.vscodeSetImmediateId){f.splice(_,1),q.callback();return}}});let m=0;return D=>{const _=++m;f.push({id:_,callback:D}),e.globals.postMessage({vscodeSetImmediateId:_},"*")}}if(typeof(w==null?void 0:w.nextTick)=="function")return w.nextTick.bind(w);const h=Promise.resolve();return f=>h.then(f)}();var c;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||n?2:L?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,t=new Uint16Array(u.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(X[32],J([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof v.globals.vscode!="undefined"){const L=v.globals.vscode.process;A={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(b){return(0,v.setImmediate)(b)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:A={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(L){return(0,v.setImmediate)(L)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(X[8],J([0,1,32]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,L=97,b=90,M=122,i=46,S=47,y=92,n=58,g=63;class E extends Error{constructor(o,c,t){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const s=o.indexOf(".")!==-1?"property":"argument";let u=`The "${o}" ${s} ${r} of type ${c}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function p(l,o){if(typeof l!="string")throw new E(o,"string",l)}function d(l){return l===S||l===y}function w(l){return l===S}function P(l){return l>=A&&l<=b||l>=L&&l<=M}function I(l,o,c,t){let r="",s=0,u=-1,h=0,f=0;for(let m=0;m<=l.length;++m){if(m<l.length)f=l.charCodeAt(m);else{if(t(f))break;f=S}if(t(f)){if(!(u===m-1||h===1))if(h===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==i||r.charCodeAt(r.length-2)!==i){if(r.length>2){const D=r.lastIndexOf(c);D===-1?(r="",s=0):(r=r.slice(0,D),s=r.length-1-r.lastIndexOf(c)),u=m,h=0;continue}else if(r.length!==0){r="",s=0,u=m,h=0;continue}}o&&(r+=r.length>0?`${c}..`:"..",s=2)}else r.length>0?r+=`${c}${l.slice(u+1,m)}`:r=l.slice(u+1,m),s=m-u-1;u=m,h=0}else f===i&&h!==-1?++h:h=-1}return r}function a(l,o){if(o===null||typeof o!="object")throw new E("pathObject","Object",o);const c=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${t}`:`${c}${l}${t}`:t}e.win32={resolve(...l){let o="",c="",t=!1;for(let r=l.length-1;r>=-1;r--){let s;if(r>=0){if(s=l[r],p(s,"path"),s.length===0)continue}else o.length===0?s=v.cwd():(s=v.env[`=${o}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${o}\\`));const u=s.length;let h=0,f="",m=!1;const D=s.charCodeAt(0);if(u===1)d(D)&&(h=1,m=!0);else if(d(D))if(m=!0,d(s.charCodeAt(1))){let _=2,U=_;for(;_<u&&!d(s.charCodeAt(_));)_++;if(_<u&&_!==U){const q=s.slice(U,_);for(U=_;_<u&&d(s.charCodeAt(_));)_++;if(_<u&&_!==U){for(U=_;_<u&&!d(s.charCodeAt(_));)_++;(_===u||_!==U)&&(f=`\\\\${q}\\${s.slice(U,_)}`,h=_)}}}else h=1;else P(D)&&s.charCodeAt(1)===n&&(f=s.slice(0,2),h=2,u>2&&d(s.charCodeAt(2))&&(m=!0,h=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(t){if(o.length>0)break}else if(c=`${s.slice(h)}\\${c}`,t=m,m&&o.length>0)break}return c=I(c,!t,"\\",d),t?`${o}\\${c}`:`${o}${c}`||"."},normalize(l){p(l,"path");const o=l.length;if(o===0)return".";let c=0,t,r=!1;const s=l.charCodeAt(0);if(o===1)return w(s)?"\\":l;if(d(s))if(r=!0,d(l.charCodeAt(1))){let h=2,f=h;for(;h<o&&!d(l.charCodeAt(h));)h++;if(h<o&&h!==f){const m=l.slice(f,h);for(f=h;h<o&&d(l.charCodeAt(h));)h++;if(h<o&&h!==f){for(f=h;h<o&&!d(l.charCodeAt(h));)h++;if(h===o)return`\\\\${m}\\${l.slice(f)}\\`;h!==f&&(t=`\\\\${m}\\${l.slice(f,h)}`,c=h)}}}else c=1;else P(s)&&l.charCodeAt(1)===n&&(t=l.slice(0,2),c=2,o>2&&d(l.charCodeAt(2))&&(r=!0,c=3));let u=c<o?I(l.slice(c),!r,"\\",d):"";return u.length===0&&!r&&(u="."),u.length>0&&d(l.charCodeAt(o-1))&&(u+="\\"),t===void 0?r?`\\${u}`:u:r?`${t}\\${u}`:`${t}${u}`},isAbsolute(l){p(l,"path");const o=l.length;if(o===0)return!1;const c=l.charCodeAt(0);return d(c)||o>2&&P(c)&&l.charCodeAt(1)===n&&d(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let o,c;for(let s=0;s<l.length;++s){const u=l[s];p(u,"path"),u.length>0&&(o===void 0?o=c=u:o+=`\\${u}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++r;const s=c.length;s>1&&d(c.charCodeAt(1))&&(++r,s>2&&(d(c.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&d(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(l,o){if(p(l,"from"),p(o,"to"),l===o)return"";const c=e.win32.resolve(l),t=e.win32.resolve(o);if(c===t||(l=c.toLowerCase(),o=t.toLowerCase(),l===o))return"";let r=0;for(;r<l.length&&l.charCodeAt(r)===y;)r++;let s=l.length;for(;s-1>r&&l.charCodeAt(s-1)===y;)s--;const u=s-r;let h=0;for(;h<o.length&&o.charCodeAt(h)===y;)h++;let f=o.length;for(;f-1>h&&o.charCodeAt(f-1)===y;)f--;const m=f-h,D=u<m?u:m;let _=-1,U=0;for(;U<D;U++){const Q=l.charCodeAt(r+U);if(Q!==o.charCodeAt(h+U))break;Q===y&&(_=U)}if(U!==D){if(_===-1)return t}else{if(m>D){if(o.charCodeAt(h+U)===y)return t.slice(h+U+1);if(U===2)return t.slice(h+U)}u>D&&(l.charCodeAt(r+U)===y?_=U:U===2&&(_=3)),_===-1&&(_=0)}let q="";for(U=r+_+1;U<=s;++U)(U===s||l.charCodeAt(U)===y)&&(q+=q.length===0?"..":"\\..");return h+=_,q.length>0?`${q}${t.slice(h,f)}`:(t.charCodeAt(h)===y&&++h,t.slice(h,f))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const o=e.win32.resolve(l);if(o.length<=2)return l;if(o.charCodeAt(0)===y){if(o.charCodeAt(1)===y){const c=o.charCodeAt(2);if(c!==g&&c!==i)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===n&&o.charCodeAt(2)===y)return`\\\\?\\${o}`;return l},dirname(l){p(l,"path");const o=l.length;if(o===0)return".";let c=-1,t=0;const r=l.charCodeAt(0);if(o===1)return d(r)?l:".";if(d(r)){if(c=t=1,d(l.charCodeAt(1))){let h=2,f=h;for(;h<o&&!d(l.charCodeAt(h));)h++;if(h<o&&h!==f){for(f=h;h<o&&d(l.charCodeAt(h));)h++;if(h<o&&h!==f){for(f=h;h<o&&!d(l.charCodeAt(h));)h++;if(h===o)return l;h!==f&&(c=t=h+1)}}}}else P(r)&&l.charCodeAt(1)===n&&(c=o>2&&d(l.charCodeAt(2))?3:2,t=c);let s=-1,u=!0;for(let h=o-1;h>=t;--h)if(d(l.charCodeAt(h))){if(!u){s=h;break}}else u=!1;if(s===-1){if(c===-1)return".";s=c}return l.slice(0,s)},basename(l,o){o!==void 0&&p(o,"ext"),p(l,"path");let c=0,t=-1,r=!0,s;if(l.length>=2&&P(l.charCodeAt(0))&&l.charCodeAt(1)===n&&(c=2),o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let u=o.length-1,h=-1;for(s=l.length-1;s>=c;--s){const f=l.charCodeAt(s);if(d(f)){if(!r){c=s+1;break}}else h===-1&&(r=!1,h=s+1),u>=0&&(f===o.charCodeAt(u)?--u==-1&&(t=s):(u=-1,t=h))}return c===t?t=h:t===-1&&(t=l.length),l.slice(c,t)}for(s=l.length-1;s>=c;--s)if(d(l.charCodeAt(s))){if(!r){c=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(c,t)},extname(l){p(l,"path");let o=0,c=-1,t=0,r=-1,s=!0,u=0;l.length>=2&&l.charCodeAt(1)===n&&P(l.charCodeAt(0))&&(o=t=2);for(let h=l.length-1;h>=o;--h){const f=l.charCodeAt(h);if(d(f)){if(!s){t=h+1;break}continue}r===-1&&(s=!1,r=h+1),f===i?c===-1?c=h:u!==1&&(u=1):c!==-1&&(u=-1)}return c===-1||r===-1||u===0||u===1&&c===r-1&&c===t+1?"":l.slice(c,r)},format:a.bind(null,"\\"),parse(l){p(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const c=l.length;let t=0,r=l.charCodeAt(0);if(c===1)return d(r)?(o.root=o.dir=l,o):(o.base=o.name=l,o);if(d(r)){if(t=1,d(l.charCodeAt(1))){let _=2,U=_;for(;_<c&&!d(l.charCodeAt(_));)_++;if(_<c&&_!==U){for(U=_;_<c&&d(l.charCodeAt(_));)_++;if(_<c&&_!==U){for(U=_;_<c&&!d(l.charCodeAt(_));)_++;_===c?t=_:_!==U&&(t=_+1)}}}}else if(P(r)&&l.charCodeAt(1)===n){if(c<=2)return o.root=o.dir=l,o;if(t=2,d(l.charCodeAt(2))){if(c===3)return o.root=o.dir=l,o;t=3}}t>0&&(o.root=l.slice(0,t));let s=-1,u=t,h=-1,f=!0,m=l.length-1,D=0;for(;m>=t;--m){if(r=l.charCodeAt(m),d(r)){if(!f){u=m+1;break}continue}h===-1&&(f=!1,h=m+1),r===i?s===-1?s=m:D!==1&&(D=1):s!==-1&&(D=-1)}return h!==-1&&(s===-1||D===0||D===1&&s===h-1&&s===u+1?o.base=o.name=l.slice(u,h):(o.name=l.slice(u,s),o.base=l.slice(u,h),o.ext=l.slice(s,h))),u>0&&u!==t?o.dir=l.slice(0,u-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let o="",c=!1;for(let t=l.length-1;t>=-1&&!c;t--){const r=t>=0?l[t]:v.cwd();p(r,"path"),r.length!==0&&(o=`${r}/${o}`,c=r.charCodeAt(0)===S)}return o=I(o,!c,"/",w),c?`/${o}`:o.length>0?o:"."},normalize(l){if(p(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===S,c=l.charCodeAt(l.length-1)===S;return l=I(l,!o,"/",w),l.length===0?o?"/":c?"./":".":(c&&(l+="/"),o?`/${l}`:l)},isAbsolute(l){return p(l,"path"),l.length>0&&l.charCodeAt(0)===S},join(...l){if(l.length===0)return".";let o;for(let c=0;c<l.length;++c){const t=l[c];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(l,o){if(p(l,"from"),p(o,"to"),l===o||(l=e.posix.resolve(l),o=e.posix.resolve(o),l===o))return"";const c=1,t=l.length,r=t-c,s=1,u=o.length-s,h=r<u?r:u;let f=-1,m=0;for(;m<h;m++){const _=l.charCodeAt(c+m);if(_!==o.charCodeAt(s+m))break;_===S&&(f=m)}if(m===h)if(u>h){if(o.charCodeAt(s+m)===S)return o.slice(s+m+1);if(m===0)return o.slice(s+m)}else r>h&&(l.charCodeAt(c+m)===S?f=m:m===0&&(f=0));let D="";for(m=c+f+1;m<=t;++m)(m===t||l.charCodeAt(m)===S)&&(D+=D.length===0?"..":"/..");return`${D}${o.slice(s+f)}`},toNamespacedPath(l){return l},dirname(l){if(p(l,"path"),l.length===0)return".";const o=l.charCodeAt(0)===S;let c=-1,t=!0;for(let r=l.length-1;r>=1;--r)if(l.charCodeAt(r)===S){if(!t){c=r;break}}else t=!1;return c===-1?o?"/":".":o&&c===1?"//":l.slice(0,c)},basename(l,o){o!==void 0&&p(o,"ext"),p(l,"path");let c=0,t=-1,r=!0,s;if(o!==void 0&&o.length>0&&o.length<=l.length){if(o===l)return"";let u=o.length-1,h=-1;for(s=l.length-1;s>=0;--s){const f=l.charCodeAt(s);if(f===S){if(!r){c=s+1;break}}else h===-1&&(r=!1,h=s+1),u>=0&&(f===o.charCodeAt(u)?--u==-1&&(t=s):(u=-1,t=h))}return c===t?t=h:t===-1&&(t=l.length),l.slice(c,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===S){if(!r){c=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(c,t)},extname(l){p(l,"path");let o=-1,c=0,t=-1,r=!0,s=0;for(let u=l.length-1;u>=0;--u){const h=l.charCodeAt(u);if(h===S){if(!r){c=u+1;break}continue}t===-1&&(r=!1,t=u+1),h===i?o===-1?o=u:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===c+1?"":l.slice(o,t)},format:a.bind(null,"/"),parse(l){p(l,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return o;const c=l.charCodeAt(0)===S;let t;c?(o.root="/",t=1):t=0;let r=-1,s=0,u=-1,h=!0,f=l.length-1,m=0;for(;f>=t;--f){const D=l.charCodeAt(f);if(D===S){if(!h){s=f+1;break}continue}u===-1&&(h=!1,u=f+1),D===i?r===-1?r=f:m!==1&&(m=1):r!==-1&&(m=-1)}if(u!==-1){const D=s===0&&c?1:s;r===-1||m===0||m===1&&r===u-1&&r===s+1?o.base=o.name=l.slice(D,u):(o.name=l.slice(D,r),o.base=l.slice(D,u),o.ext=l.slice(r,u))}return s>0?o.dir=l.slice(0,s-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[79],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(i){i[i.DependsOnKbLayout=-1]="DependsOnKbLayout",i[i.None=0]="None",i[i.Hyper=1]="Hyper",i[i.Super=2]="Super",i[i.Fn=3]="Fn",i[i.FnLock=4]="FnLock",i[i.Suspend=5]="Suspend",i[i.Resume=6]="Resume",i[i.Turbo=7]="Turbo",i[i.Sleep=8]="Sleep",i[i.WakeUp=9]="WakeUp",i[i.KeyA=10]="KeyA",i[i.KeyB=11]="KeyB",i[i.KeyC=12]="KeyC",i[i.KeyD=13]="KeyD",i[i.KeyE=14]="KeyE",i[i.KeyF=15]="KeyF",i[i.KeyG=16]="KeyG",i[i.KeyH=17]="KeyH",i[i.KeyI=18]="KeyI",i[i.KeyJ=19]="KeyJ",i[i.KeyK=20]="KeyK",i[i.KeyL=21]="KeyL",i[i.KeyM=22]="KeyM",i[i.KeyN=23]="KeyN",i[i.KeyO=24]="KeyO",i[i.KeyP=25]="KeyP",i[i.KeyQ=26]="KeyQ",i[i.KeyR=27]="KeyR",i[i.KeyS=28]="KeyS",i[i.KeyT=29]="KeyT",i[i.KeyU=30]="KeyU",i[i.KeyV=31]="KeyV",i[i.KeyW=32]="KeyW",i[i.KeyX=33]="KeyX",i[i.KeyY=34]="KeyY",i[i.KeyZ=35]="KeyZ",i[i.Digit1=36]="Digit1",i[i.Digit2=37]="Digit2",i[i.Digit3=38]="Digit3",i[i.Digit4=39]="Digit4",i[i.Digit5=40]="Digit5",i[i.Digit6=41]="Digit6",i[i.Digit7=42]="Digit7",i[i.Digit8=43]="Digit8",i[i.Digit9=44]="Digit9",i[i.Digit0=45]="Digit0",i[i.Enter=46]="Enter",i[i.Escape=47]="Escape",i[i.Backspace=48]="Backspace",i[i.Tab=49]="Tab",i[i.Space=50]="Space",i[i.Minus=51]="Minus",i[i.Equal=52]="Equal",i[i.BracketLeft=53]="BracketLeft",i[i.BracketRight=54]="BracketRight",i[i.Backslash=55]="Backslash",i[i.IntlHash=56]="IntlHash",i[i.Semicolon=57]="Semicolon",i[i.Quote=58]="Quote",i[i.Backquote=59]="Backquote",i[i.Comma=60]="Comma",i[i.Period=61]="Period",i[i.Slash=62]="Slash",i[i.CapsLock=63]="CapsLock",i[i.F1=64]="F1",i[i.F2=65]="F2",i[i.F3=66]="F3",i[i.F4=67]="F4",i[i.F5=68]="F5",i[i.F6=69]="F6",i[i.F7=70]="F7",i[i.F8=71]="F8",i[i.F9=72]="F9",i[i.F10=73]="F10",i[i.F11=74]="F11",i[i.F12=75]="F12",i[i.PrintScreen=76]="PrintScreen",i[i.ScrollLock=77]="ScrollLock",i[i.Pause=78]="Pause",i[i.Insert=79]="Insert",i[i.Home=80]="Home",i[i.PageUp=81]="PageUp",i[i.Delete=82]="Delete",i[i.End=83]="End",i[i.PageDown=84]="PageDown",i[i.ArrowRight=85]="ArrowRight",i[i.ArrowLeft=86]="ArrowLeft",i[i.ArrowDown=87]="ArrowDown",i[i.ArrowUp=88]="ArrowUp",i[i.NumLock=89]="NumLock",i[i.NumpadDivide=90]="NumpadDivide",i[i.NumpadMultiply=91]="NumpadMultiply",i[i.NumpadSubtract=92]="NumpadSubtract",i[i.NumpadAdd=93]="NumpadAdd",i[i.NumpadEnter=94]="NumpadEnter",i[i.Numpad1=95]="Numpad1",i[i.Numpad2=96]="Numpad2",i[i.Numpad3=97]="Numpad3",i[i.Numpad4=98]="Numpad4",i[i.Numpad5=99]="Numpad5",i[i.Numpad6=100]="Numpad6",i[i.Numpad7=101]="Numpad7",i[i.Numpad8=102]="Numpad8",i[i.Numpad9=103]="Numpad9",i[i.Numpad0=104]="Numpad0",i[i.NumpadDecimal=105]="NumpadDecimal",i[i.IntlBackslash=106]="IntlBackslash",i[i.ContextMenu=107]="ContextMenu",i[i.Power=108]="Power",i[i.NumpadEqual=109]="NumpadEqual",i[i.F13=110]="F13",i[i.F14=111]="F14",i[i.F15=112]="F15",i[i.F16=113]="F16",i[i.F17=114]="F17",i[i.F18=115]="F18",i[i.F19=116]="F19",i[i.F20=117]="F20",i[i.F21=118]="F21",i[i.F22=119]="F22",i[i.F23=120]="F23",i[i.F24=121]="F24",i[i.Open=122]="Open",i[i.Help=123]="Help",i[i.Select=124]="Select",i[i.Again=125]="Again",i[i.Undo=126]="Undo",i[i.Cut=127]="Cut",i[i.Copy=128]="Copy",i[i.Paste=129]="Paste",i[i.Find=130]="Find",i[i.AudioVolumeMute=131]="AudioVolumeMute",i[i.AudioVolumeUp=132]="AudioVolumeUp",i[i.AudioVolumeDown=133]="AudioVolumeDown",i[i.NumpadComma=134]="NumpadComma",i[i.IntlRo=135]="IntlRo",i[i.KanaMode=136]="KanaMode",i[i.IntlYen=137]="IntlYen",i[i.Convert=138]="Convert",i[i.NonConvert=139]="NonConvert",i[i.Lang1=140]="Lang1",i[i.Lang2=141]="Lang2",i[i.Lang3=142]="Lang3",i[i.Lang4=143]="Lang4",i[i.Lang5=144]="Lang5",i[i.Abort=145]="Abort",i[i.Props=146]="Props",i[i.NumpadParenLeft=147]="NumpadParenLeft",i[i.NumpadParenRight=148]="NumpadParenRight",i[i.NumpadBackspace=149]="NumpadBackspace",i[i.NumpadMemoryStore=150]="NumpadMemoryStore",i[i.NumpadMemoryRecall=151]="NumpadMemoryRecall",i[i.NumpadMemoryClear=152]="NumpadMemoryClear",i[i.NumpadMemoryAdd=153]="NumpadMemoryAdd",i[i.NumpadMemorySubtract=154]="NumpadMemorySubtract",i[i.NumpadClear=155]="NumpadClear",i[i.NumpadClearEntry=156]="NumpadClearEntry",i[i.ControlLeft=157]="ControlLeft",i[i.ShiftLeft=158]="ShiftLeft",i[i.AltLeft=159]="AltLeft",i[i.MetaLeft=160]="MetaLeft",i[i.ControlRight=161]="ControlRight",i[i.ShiftRight=162]="ShiftRight",i[i.AltRight=163]="AltRight",i[i.MetaRight=164]="MetaRight",i[i.BrightnessUp=165]="BrightnessUp",i[i.BrightnessDown=166]="BrightnessDown",i[i.MediaPlay=167]="MediaPlay",i[i.MediaRecord=168]="MediaRecord",i[i.MediaFastForward=169]="MediaFastForward",i[i.MediaRewind=170]="MediaRewind",i[i.MediaTrackNext=171]="MediaTrackNext",i[i.MediaTrackPrevious=172]="MediaTrackPrevious",i[i.MediaStop=173]="MediaStop",i[i.Eject=174]="Eject",i[i.MediaPlayPause=175]="MediaPlayPause",i[i.MediaSelect=176]="MediaSelect",i[i.LaunchMail=177]="LaunchMail",i[i.LaunchApp2=178]="LaunchApp2",i[i.LaunchApp1=179]="LaunchApp1",i[i.SelectTask=180]="SelectTask",i[i.LaunchScreenSaver=181]="LaunchScreenSaver",i[i.BrowserSearch=182]="BrowserSearch",i[i.BrowserHome=183]="BrowserHome",i[i.BrowserBack=184]="BrowserBack",i[i.BrowserForward=185]="BrowserForward",i[i.BrowserStop=186]="BrowserStop",i[i.BrowserRefresh=187]="BrowserRefresh",i[i.BrowserFavorites=188]="BrowserFavorites",i[i.ZoomToggle=189]="ZoomToggle",i[i.MailReply=190]="MailReply",i[i.MailForward=191]="MailForward",i[i.MailSend=192]="MailSend",i[i.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const A=[],L=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:i=>b[i]||0,toEnum:i=>L[i]||0,toString:i=>A[i]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class M{constructor(S,y,n,g,E){this.ctrlKey=S,this.shiftKey=y,this.altKey=n,this.metaKey=g,this.scanCode=E}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=M,function(){function i(S,y){A[S]=y,L[y]=S,b[y.toLowerCase()]=S}i(0,"None"),i(1,"Hyper"),i(2,"Super"),i(3,"Fn"),i(4,"FnLock"),i(5,"Suspend"),i(6,"Resume"),i(7,"Turbo"),i(8,"Sleep"),i(9,"WakeUp"),i(10,"KeyA"),i(11,"KeyB"),i(12,"KeyC"),i(13,"KeyD"),i(14,"KeyE"),i(15,"KeyF"),i(16,"KeyG"),i(17,"KeyH"),i(18,"KeyI"),i(19,"KeyJ"),i(20,"KeyK"),i(21,"KeyL"),i(22,"KeyM"),i(23,"KeyN"),i(24,"KeyO"),i(25,"KeyP"),i(26,"KeyQ"),i(27,"KeyR"),i(28,"KeyS"),i(29,"KeyT"),i(30,"KeyU"),i(31,"KeyV"),i(32,"KeyW"),i(33,"KeyX"),i(34,"KeyY"),i(35,"KeyZ"),i(36,"Digit1"),i(37,"Digit2"),i(38,"Digit3"),i(39,"Digit4"),i(40,"Digit5"),i(41,"Digit6"),i(42,"Digit7"),i(43,"Digit8"),i(44,"Digit9"),i(45,"Digit0"),i(46,"Enter"),i(47,"Escape"),i(48,"Backspace"),i(49,"Tab"),i(50,"Space"),i(51,"Minus"),i(52,"Equal"),i(53,"BracketLeft"),i(54,"BracketRight"),i(55,"Backslash"),i(56,"IntlHash"),i(57,"Semicolon"),i(58,"Quote"),i(59,"Backquote"),i(60,"Comma"),i(61,"Period"),i(62,"Slash"),i(63,"CapsLock"),i(64,"F1"),i(65,"F2"),i(66,"F3"),i(67,"F4"),i(68,"F5"),i(69,"F6"),i(70,"F7"),i(71,"F8"),i(72,"F9"),i(73,"F10"),i(74,"F11"),i(75,"F12"),i(76,"PrintScreen"),i(77,"ScrollLock"),i(78,"Pause"),i(79,"Insert"),i(80,"Home"),i(81,"PageUp"),i(82,"Delete"),i(83,"End"),i(84,"PageDown"),i(85,"ArrowRight"),i(86,"ArrowLeft"),i(87,"ArrowDown"),i(88,"ArrowUp"),i(89,"NumLock"),i(90,"NumpadDivide"),i(91,"NumpadMultiply"),i(92,"NumpadSubtract"),i(93,"NumpadAdd"),i(94,"NumpadEnter"),i(95,"Numpad1"),i(96,"Numpad2"),i(97,"Numpad3"),i(98,"Numpad4"),i(99,"Numpad5"),i(100,"Numpad6"),i(101,"Numpad7"),i(102,"Numpad8"),i(103,"Numpad9"),i(104,"Numpad0"),i(105,"NumpadDecimal"),i(106,"IntlBackslash"),i(107,"ContextMenu"),i(108,"Power"),i(109,"NumpadEqual"),i(110,"F13"),i(111,"F14"),i(112,"F15"),i(113,"F16"),i(114,"F17"),i(115,"F18"),i(116,"F19"),i(117,"F20"),i(118,"F21"),i(119,"F22"),i(120,"F23"),i(121,"F24"),i(122,"Open"),i(123,"Help"),i(124,"Select"),i(125,"Again"),i(126,"Undo"),i(127,"Cut"),i(128,"Copy"),i(129,"Paste"),i(130,"Find"),i(131,"AudioVolumeMute"),i(132,"AudioVolumeUp"),i(133,"AudioVolumeDown"),i(134,"NumpadComma"),i(135,"IntlRo"),i(136,"KanaMode"),i(137,"IntlYen"),i(138,"Convert"),i(139,"NonConvert"),i(140,"Lang1"),i(141,"Lang2"),i(142,"Lang3"),i(143,"Lang4"),i(144,"Lang5"),i(145,"Abort"),i(146,"Props"),i(147,"NumpadParenLeft"),i(148,"NumpadParenRight"),i(149,"NumpadBackspace"),i(150,"NumpadMemoryStore"),i(151,"NumpadMemoryRecall"),i(152,"NumpadMemoryClear"),i(153,"NumpadMemoryAdd"),i(154,"NumpadMemorySubtract"),i(155,"NumpadClear"),i(156,"NumpadClearEntry"),i(157,"ControlLeft"),i(158,"ShiftLeft"),i(159,"AltLeft"),i(160,"MetaLeft"),i(161,"ControlRight"),i(162,"ShiftRight"),i(163,"AltRight"),i(164,"MetaRight"),i(165,"BrightnessUp"),i(166,"BrightnessDown"),i(167,"MediaPlay"),i(168,"MediaRecord"),i(169,"MediaFastForward"),i(170,"MediaRewind"),i(171,"MediaTrackNext"),i(172,"MediaTrackPrevious"),i(173,"MediaStop"),i(174,"Eject"),i(175,"MediaPlayPause"),i(176,"MediaSelect"),i(177,"LaunchMail"),i(178,"LaunchApp2"),i(179,"LaunchApp1"),i(180,"SelectTask"),i(181,"LaunchScreenSaver"),i(182,"BrowserSearch"),i(183,"BrowserHome"),i(184,"BrowserBack"),i(185,"BrowserForward"),i(186,"BrowserStop"),i(187,"BrowserRefresh"),i(188,"BrowserFavorites"),i(189,"ZoomToggle"),i(190,"MailReply"),i(191,"MailForward"),i(192,"MailSend")}(),function(){for(let S=0;S<=193;S++)e.IMMUTABLE_CODE_TO_KEY_CODE[S]=-1;for(let S=0;S<=112;S++)e.IMMUTABLE_KEY_CODE_TO_CODE[S]=-1;function i(S,y){e.IMMUTABLE_CODE_TO_KEY_CODE[S]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[y]=S)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,i(0,0),i(1,0),i(2,0),i(3,0),i(4,0),i(5,0),i(6,0),i(7,0),i(8,0),i(9,0),i(46,3),i(47,9),i(48,1),i(49,2),i(50,10),i(63,8),i(64,59),i(65,60),i(66,61),i(67,62),i(68,63),i(69,64),i(70,65),i(71,66),i(72,67),i(73,68),i(74,69),i(75,70),i(76,0),i(77,79),i(78,7),i(79,19),i(80,14),i(81,11),i(82,20),i(83,13),i(84,12),i(85,17),i(86,15),i(87,18),i(88,16),i(89,78),i(90,108),i(91,103),i(92,106),i(93,104),i(94,3),i(95,94),i(96,95),i(97,96),i(98,97),i(99,98),i(100,99),i(101,100),i(102,101),i(103,102),i(104,93),i(105,107),i(107,58),i(108,0),i(109,0),i(110,71),i(111,72),i(112,73),i(113,74),i(114,75),i(115,76),i(116,77),i(117,0),i(118,0),i(119,0),i(120,0),i(121,0),i(122,0),i(123,0),i(124,0),i(125,0),i(126,0),i(127,0),i(128,0),i(129,0),i(130,0),i(131,0),i(132,0),i(133,0),i(134,105),i(136,0),i(138,0),i(139,0),i(140,0),i(141,0),i(142,0),i(143,0),i(144,0),i(145,0),i(146,0),i(147,0),i(148,0),i(149,0),i(150,0),i(151,0),i(152,0),i(153,0),i(154,0),i(155,0),i(156,0),i(157,5),i(158,4),i(159,6),i(160,57),i(161,5),i(162,4),i(163,6),i(164,57),i(165,0),i(166,0),i(167,0),i(168,0),i(169,0),i(170,0),i(171,0),i(172,0),i(173,0),i(174,0),i(175,0),i(176,0),i(177,0),i(178,0),i(179,0),i(180,0),i(181,0),i(182,0),i(183,0),i(184,0),i(185,0),i(186,0),i(187,0),i(188,0),i(189,0),i(190,0),i(191,0),i(192,0)}()}),define(X[103],J([0,1,57,79]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(M){M=M.toLowerCase().trim();let i=!1,S=!1,y=!1,n=!1,g;do g=!1,/^ctrl(\+|\-)/.test(M)&&(i=!0,M=M.substr("ctrl-".length),g=!0),/^shift(\+|\-)/.test(M)&&(S=!0,M=M.substr("shift-".length),g=!0),/^alt(\+|\-)/.test(M)&&(y=!0,M=M.substr("alt-".length),g=!0),/^meta(\+|\-)/.test(M)&&(n=!0,M=M.substr("meta-".length),g=!0),/^win(\+|\-)/.test(M)&&(n=!0,M=M.substr("win-".length),g=!0),/^cmd(\+|\-)/.test(M)&&(n=!0,M=M.substr("cmd-".length),g=!0);while(g);let E;const p=M.indexOf(" ");return p>0?(E=M.substring(0,p),M=M.substring(p)):(E=M,M=""),{remains:M,ctrl:i,shift:S,alt:y,meta:n,key:E}}static parseSimpleKeybinding(M){const i=this._readModifiers(M),S=v.KeyCodeUtils.fromUserSettings(i.key);return[new v.SimpleKeybinding(i.ctrl,i.shift,i.alt,i.meta,S),i.remains]}static parseKeybinding(M,i){if(!M)return null;const S=[];let y;do[y,M]=this.parseSimpleKeybinding(M),S.push(y);while(M.length>0);return new v.ChordKeybinding(S)}static parseSimpleUserBinding(M){const i=this._readModifiers(M),S=i.key.match(/^\[([^\]]+)\]$/);if(S){const n=S[1],g=A.ScanCodeUtils.lowerCaseToEnum(n);return[new A.ScanCodeBinding(i.ctrl,i.shift,i.alt,i.meta,g),i.remains]}const y=v.KeyCodeUtils.fromUserSettings(i.key);return[new v.SimpleKeybinding(i.ctrl,i.shift,i.alt,i.meta,y),i.remains]}static parseUserBinding(M){if(!M)return[];const i=[];let S;for(;M.length>0;)[S,M]=this.parseSimpleUserBinding(M),i.push(S);return i}}e.KeybindingParser=L}),define(X[104],J([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=v.globals.performance&&typeof v.globals.performance.now=="function";class L{constructor(M){this._highResolution=A&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new L(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=L}),define(X[5],J([0,1,17,42,2,78,104]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var i;(function(I){I.None=()=>L.Disposable.None;function a(O){return($,z=null,C)=>{let j=!1,N;return N=O(T=>{if(!j)return N?N.dispose():j=!0,$.call(z,T)},null,C),j&&N.dispose(),N}}I.once=a;function l(O,$){return u((z,C=null,j)=>O(N=>z.call(C,$(N)),null,j))}I.map=l;function o(O,$){return u((z,C=null,j)=>O(N=>{$(N),z.call(C,N)},null,j))}I.forEach=o;function c(O,$){return u((z,C=null,j)=>O(N=>$(N)&&z.call(C,N),null,j))}I.filter=c;function t(O){return O}I.signal=t;function r(...O){return($,z=null,C)=>(0,L.combinedDisposable)(...O.map(j=>j(N=>$.call(z,N),null,C)))}I.any=r;function s(O,$,z){let C=z;return l(O,j=>(C=$(C,j),C))}I.reduce=s;function u(O){let $;const z=new E({onFirstListenerAdd(){$=O(z.fire,z)},onLastListenerRemove(){$.dispose()}});return z.event}I.snapshot=u;function h(O,$,z=100,C=!1,j){let N,T,R,W=0;const k=new E({leakWarningThreshold:j,onFirstListenerAdd(){N=O(F=>{W++,T=$(T,F),C&&!R&&(k.fire(T),T=void 0),clearTimeout(R),R=setTimeout(()=>{const B=T;T=void 0,R=void 0,(!C||W>1)&&k.fire(B),W=0},z)})},onLastListenerRemove(){N.dispose()}});return k.event}I.debounce=h;function f(O){const $=new Date().getTime();return l(a(O),z=>new Date().getTime()-$)}I.stopwatch=f;function m(O){let $=!0,z;return c(O,C=>{const j=$||C!==z;return $=!1,z=C,j})}I.latch=m;function D(O,$=!1,z=[]){let C=z.slice(),j=O(R=>{C?C.push(R):T.fire(R)});const N=()=>{C&&C.forEach(R=>T.fire(R)),C=null},T=new E({onFirstListenerAdd(){j||(j=O(R=>T.fire(R)))},onFirstListenerDidAdd(){C&&($?setTimeout(N):N())},onLastListenerRemove(){j&&j.dispose(),j=null}});return T.event}I.buffer=D;class _{constructor($){this.event=$}map($){return new _(l(this.event,$))}forEach($){return new _(o(this.event,$))}filter($){return new _(c(this.event,$))}reduce($,z){return new _(s(this.event,$,z))}latch(){return new _(m(this.event))}debounce($,z=100,C=!1,j){return new _(h(this.event,$,z,C,j))}on($,z,C){return this.event($,z,C)}once($,z,C){return a(this.event)($,z,C)}}function U(O){return new _(O)}I.chain=U;function q(O,$,z=C=>C){const C=(...R)=>T.fire(z(...R)),j=()=>O.on($,C),N=()=>O.removeListener($,C),T=new E({onFirstListenerAdd:j,onLastListenerRemove:N});return T.event}I.fromNodeEventEmitter=q;function Q(O,$,z=C=>C){const C=(...R)=>T.fire(z(...R)),j=()=>O.addEventListener($,C),N=()=>O.removeEventListener($,C),T=new E({onFirstListenerAdd:j,onLastListenerRemove:N});return T.event}I.fromDOMEventEmitter=Q;function ie(O){const $=new E;let z=!1;return O.then(void 0,()=>null).then(()=>{z?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),z=!0,$.event}I.fromPromise=ie;function ae(O){return new Promise($=>a(O)($))}I.toPromise=ae})(i=e.Event||(e.Event={}));class S{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${S._idPool++}`}start(a){this._stopWatch=new M.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let y=-1;function n(I){const a=y;return y=I,{dispose(){y=a}}}e.setGlobalLeakWarningThreshold=n;class g{constructor(a,l=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let l=y;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),!(l<=0||a<l)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(o)||0;if(this._stacks.set(o,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,r=0;for(const[s,u]of this._stacks)(!t||r<u)&&(t=s,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class E{constructor(a){var l;this._disposed=!1,this._options=a,this._leakageMon=y>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(a,l,o)=>{var c;this._listeners||(this._listeners=new b.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(l?[a,l]:a);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,l);const s=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let u;return u={dispose:()=>{s&&s(),u.dispose=E._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof L.DisposableStore?o.add(u):Array.isArray(o)&&o.push(u),u}),this._event}fire(a){var l,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,a]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(r){(0,v.onUnexpectedError)(r)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var a,l,o;(a=this._listeners)===null||a===void 0||a.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class p extends E{constructor(a){super(a);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=p;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const l={event:a,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const o=()=>{this.hasListeners&&this.unhook(l);const c=this.events.indexOf(l);this.events.splice(c,1)};return(0,L.toDisposable)((0,A.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(l=>this.emitter.fire(l))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class w{constructor(){this.buffers=[]}wrapEvent(a){return(l,o,c)=>a(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>l.call(o,t)):l.call(o,t)},void 0,c)}bufferEvents(a){const l=[];this.buffers.push(l);const o=a();return this.buffers.pop(),l.forEach(c=>c()),o}}e.EventBufferer=w;class P{constructor(){this.listening=!1,this.inputEvent=i.None,this.inputEventListener=L.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(X[25],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(i,S){const y=setTimeout(i.bind(S),0);return{dispose(){clearTimeout(y)}}});var L;(function(i){function S(y){return y===i.None||y===i.Cancelled||y instanceof b?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}i.isCancellationToken=S,i.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),i.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(L=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=L.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=M}),define(X[105],J([0,1,5]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(g){const E=this._icons.get(g.id);E?g.description?E.description=g.description:console.error(`Duplicate registration of codicon ${g.id}`):(this._icons.set(g.id,g),this._onDidRegister.fire(g))}get(g){return this._icons.get(g)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new A;e.iconRegistry=L;function b(n,g){return new i(n,g)}e.registerCodicon=b;function M(n){return n?n.replace(/\$\((.*?)\)/g,(g,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=M;class i{constructor(g,E,p){this.id=g,this.definition=E,this.description=p,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i;function S(n,g){const E=["codicon","codicon-"+n];return g&&E.push("codicon-modifier-"+g),E}e.getClassNamesArray=S;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const g=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function E(w){if(w instanceof i)return["codicon","codicon-"+w.id];const P=g.exec(w.id);if(!P)return E(i.error);let[,I,a]=P;const l=["codicon","codicon-"+I];return a&&l.push("codicon-modifier-"+a.substr(1)),l}n.asClassNameArray=E;function p(w){return E(w).join(" ")}n.asClassName=p;function d(w){return"."+E(w).join(".")}n.asCSSSelector=d})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(i=e.Codicon||(e.Codicon={}))}),define(X[63],J([0,1,17,2]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(l){const o=l;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=L;function b(l){const o=l;return o?L(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=b;function M(l,o){return new i(l,o)}e.newWriteableStream=M;class i{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,v.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(!this.state.destroyed){let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(c);r>=0&&t.splice(r,1)}}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,o){const c=[];let t;for(;(t=l.read())!==null;)c.push(t);return o(c)}e.consumeReadable=S;function y(l,o,c){const t=[];let r;for(;(r=l.read())!==null&&t.length<c;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return l.read()}}}e.peekReadable=y;function n(l,o){return new Promise((c,t)=>{const r=[];g(l,{onData:s=>{o&&r.push(s)},onError:s=>{o?t(s):c(void 0)},onEnd:()=>{c(o?o(r):void 0)}})})}e.consumeStream=n;function g(l,o){l.on("error",c=>o.onError(c)),l.on("end",()=>o.onEnd()),l.on("data",c=>o.onData(c))}e.listenStream=g;function E(l,o){return new Promise((c,t)=>{const r=new A.DisposableStore,s=[],u=m=>{if(s.push(m),s.length>o)return r.dispose(),l.pause(),c({stream:l,buffer:s,ended:!1})},h=m=>t(m),f=()=>c({stream:l,buffer:s,ended:!0});r.add((0,A.toDisposable)(()=>l.removeListener("error",h))),l.on("error",h),r.add((0,A.toDisposable)(()=>l.removeListener("end",f))),l.on("end",f),r.add((0,A.toDisposable)(()=>l.removeListener("data",u))),l.on("data",u)})}e.peekStream=E;function p(l,o){const c=M(o);return c.end(l),c}e.toStream=p;function d(){const l=M(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=d;function w(l){let o=!1;return{read:()=>o?null:(o=!0,l)}}e.toReadable=w;function P(l,o,c){const t=M(c);return g(l,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=P;function I(l,o,c){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?c([l,r]):l)}}}e.prefixedReadable=I;function a(l,o,c){let t=!1;const r=M(c);return g(o,{onData:s=>t?r.write(s):(t=!0,r.write(c([l,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(l)),r.end()}}),r}e.prefixedStream=a}),define(X[22],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=v;const A=/{(\d+)}/g;function L(K,...te){return te.length===0?K:K.replace(A,function(oe,le){const de=parseInt(le,10);return isNaN(de)||de<0||de>=te.length?oe:te[de]})}e.format=L;function b(K){return K.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=b;function M(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=M;function i(K,te){let oe=0;const le=te.charCodeAt(0);for(let de=K.length-1;de>=0;de--)K.charCodeAt(de)===le&&oe++;return oe}e.count=i;function S(K,te,oe="\u2026"){return K.length<=te?K:`${K.substr(0,te)}${oe}`}e.truncate=S;function y(K,te=" "){const oe=n(K,te);return g(oe,te)}e.trim=y;function n(K,te){if(!K||!te)return K;const oe=te.length;if(oe===0||K.length===0)return K;let le=0;for(;K.indexOf(te,le)===le;)le=le+oe;return K.substring(le)}e.ltrim=n;function g(K,te){if(!K||!te)return K;const oe=te.length,le=K.length;if(oe===0||le===0)return K;let de=le,pe=-1;for(;pe=K.lastIndexOf(te,de-1),!(pe===-1||pe+oe!==de);){if(pe===0)return"";de=pe}return K.substring(0,de)}e.rtrim=g;function E(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function p(K){return K.replace(/\*/g,"")}e.stripWildcards=p;function d(K,te,oe={}){if(!K)throw new Error("Cannot create regex from empty string");te||(K=M(K)),oe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(K,le)}e.createRegExp=d;function w(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function P(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function I(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=I;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function l(K){for(let te=0,oe=K.length;te<oe;te++){const le=K.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=l;function o(K,te=0,oe=K.length){for(let le=te;le<oe;le++){const de=K.charCodeAt(le);if(de!==32&&de!==9)return K.substring(te,le)}return K.substring(te,oe)}e.getLeadingWhitespace=o;function c(K,te=K.length-1){for(let oe=te;oe>=0;oe--){const le=K.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=c;function t(K,te){return K<te?-1:K>te?1:0}e.compare=t;function r(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce<Ne)return-1;if(Ce>Ne)return 1}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstring=r;function s(K,te){return u(K,te,0,K.length,0,te.length)}e.compareIgnoreCase=s;function u(K,te,oe=0,le=K.length,de=0,pe=te.length){for(;oe<le&&de<pe;oe++,de++){let Ce=K.charCodeAt(oe),Ne=te.charCodeAt(de);if(Ce!==Ne){const He=Ce-Ne;if(!(He===32&&f(Ne))&&!(He===-32&&f(Ce)))return h(Ce)&&h(Ne)?He:r(K.toLowerCase(),te.toLowerCase(),oe,le,de,pe)}}const Ie=le-oe,Oe=pe-de;return Ie<Oe?-1:Ie>Oe?1:0}e.compareSubstringIgnoreCase=u;function h(K){return K>=97&&K<=122}e.isLowerAsciiLetter=h;function f(K){return K>=65&&K<=90}e.isUpperAsciiLetter=f;function m(K){return h(K)||f(K)}function D(K,te){return K.length===te.length&&_(K,te)}e.equalsIgnoreCase=D;function _(K,te,oe=K.length){for(let le=0;le<oe;le++){const de=K.charCodeAt(le),pe=te.charCodeAt(le);if(de!==pe){if(m(de)&&m(pe)){const Ie=Math.abs(de-pe);if(Ie!==0&&Ie!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(pe).toLowerCase())return!1}}return!0}function U(K,te){const oe=te.length;return te.length>K.length?!1:_(K,te,oe)}e.startsWithIgnoreCase=U;function q(K,te){let oe,le=Math.min(K.length,te.length);for(oe=0;oe<le;oe++)if(K.charCodeAt(oe)!==te.charCodeAt(oe))return oe;return le}e.commonPrefixLength=q;function Q(K,te){let oe,le=Math.min(K.length,te.length);const de=K.length-1,pe=te.length-1;for(oe=0;oe<le;oe++)if(K.charCodeAt(de-oe)!==te.charCodeAt(pe-oe))return oe;return le}e.commonSuffixLength=Q;function ie(K){return 55296<=K&&K<=56319}e.isHighSurrogate=ie;function ae(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ae;function O(K,te){return(K-55296<<10)+(te-56320)+65536}e.computeCodePoint=O;function $(K,te,oe){const le=K.charCodeAt(oe);if(ie(le)&&oe+1<te){const de=K.charCodeAt(oe+1);if(ae(de))return O(le,de)}return le}e.getNextCodePoint=$;function z(K,te){const oe=K.charCodeAt(te-1);if(ae(oe)&&te>1){const le=K.charCodeAt(te-2);if(ie(le))return O(le,oe)}return oe}function C(K,te){const oe=ze.getInstance(),le=te,de=K.length,pe=$(K,de,te);te+=pe>=65536?2:1;let Ie=oe.getGraphemeBreakType(pe);for(;te<de;){const Oe=$(K,de,te),Ce=oe.getGraphemeBreakType(Oe);if(Ke(Ie,Ce))break;te+=Oe>=65536?2:1,Ie=Ce}return te-le}e.nextCharLength=C;function j(K,te){const oe=ze.getInstance(),le=te,de=z(K,te);te-=de>=65536?2:1;let pe=oe.getGraphemeBreakType(de);for(;te>0;){const Ie=z(K,te),Oe=oe.getGraphemeBreakType(Ie);if(Ke(Oe,pe))break;te-=Ie>=65536?2:1,pe=Oe}return le-te}e.prevCharLength=j;function N(K,te){const oe=ze.getInstance(),le=K.length,de=te,pe=$(K,le,te),Ie=oe.getGraphemeBreakType(pe);te+=pe>=65536?2:1;let Oe=Ie;for(;te<le;){const Ne=$(K,le,te),He=oe.getGraphemeBreakType(Ne);if(Ke(Oe,He))break;te+=Ne>=65536?2:1,Oe=He}const Ce=te;for(te=de,Oe=Ie;te>0;){const Ne=z(K,te),He=oe.getGraphemeBreakType(Ne);if(Ke(He,Oe))break;te-=Ne>=65536?2:1,Oe=He}return[te,Ce]}function T(K,te){return te>0&&ae(K.charCodeAt(te))?N(K,te-1):N(K,te)}e.getCharContainingOffset=T;function R(K){const te=K.length;let oe=0,le=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?oe+=1:Ie<2048?oe+=2:Ie<65536?oe+=3:oe+=4}const de=new Uint8Array(oe);le=0;let pe=0;for(;le<te;){const Ie=$(K,te,le);le+=Ie>=65536?2:1,Ie<128?de[pe++]=Ie:Ie<2048?(de[pe++]=192|(Ie&1984)>>>6,de[pe++]=128|(Ie&63)>>>0):Ie<65536?(de[pe++]=224|(Ie&61440)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0):(de[pe++]=240|(Ie&1835008)>>>18,de[pe++]=128|(Ie&258048)>>>12,de[pe++]=128|(Ie&4032)>>>6,de[pe++]=128|(Ie&63)>>>0)}return de}e.encodeUTF8=R;function W(K){const te=K.byteLength,oe=[];let le=0;for(;le<te;){const de=K[le];let pe;if(de>=240&&le+3<te?pe=(K[le++]&7)<<18>>>0|(K[le++]&63)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=224&&le+2<te?pe=(K[le++]&15)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:de>=192&&le+1<te?pe=(K[le++]&31)<<6>>>0|(K[le++]&63)<<0>>>0:pe=K[le++],pe>=0&&pe<=55295||pe>=57344&&pe<=65535)oe.push(String.fromCharCode(pe));else if(pe>=65536&&pe<=1114111){const Ie=pe-65536,Oe=55296+((Ie&1047552)>>>10),Ce=56320+((Ie&1023)>>>0);oe.push(String.fromCharCode(Oe)),oe.push(String.fromCharCode(Ce))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=W;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(K){return k.test(K)}e.containsRTL=F;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(K){return B.test(K)}e.containsEmoji=V;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return G.test(K)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Z;function re(K){for(let te=0,oe=K.length;te<oe;te++)if(se(K.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=re;function se(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=se;function x(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=x;function ne(K,te){if(K.length<te)return K;const oe=/\b/g;let le=0;for(;oe.test(K)&&!(K.length-oe.lastIndex<te);)le=oe.lastIndex,oe.lastIndex+=1;return K.substring(le).replace(/^\s/,"")}e.lcut=ne;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(K){return K&&(K=K.replace(ue,""),K=K.replace(ye,""),K=K.replace(ge,"")),K}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=ve;function me(K,te){if(!K||!te||K.length<te.length)return!1;const oe=te.length,le=K.toLowerCase();let de=0,pe=-1;for(;de<oe;){const Ie=le.indexOf(te[de],pe+1);if(Ie<0)return!1;pe=Ie,de++}return!0}e.fuzzyContains=me;function be(K,te=!1){return K?(te&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=be;function Te(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Te;function _e(K,te=1){if(te===0)return"";let oe=-1;do oe=K.indexOf(`
`,oe+1),te--;while(te>0&&oe>=0);return oe===-1?K:(K[oe-1]==="\r"&&oe--,K.substr(0,oe))}e.getNLines=_e;function Ye(K){const te=90-65+1;return K=K%(2*te),K<te?String.fromCharCode(97+K):String.fromCharCode(65+K-te)}e.singleLetterHash=Ye;function xe(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=xe;function Ke(K,te){return K===0?te!==5&&te!==7:K===2&&te===3?!1:K===4||K===2||K===3||te===4||te===2||te===3?!0:!(K===8&&(te===8||te===9||te===11||te===12)||(K===11||K===9)&&(te===9||te===10)||(K===12||K===10)&&te===10||te===5||te===13||te===7||K===1||K===13&&te===14||K===6&&te===6)}e.breakBetweenGraphemeBreakType=Ke;var ot;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ot=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=nt()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const oe=this._data,le=oe.length/3;let de=1;for(;de<=le;)if(te<oe[3*de])de=2*de;else if(te>oe[3*de+1])de=2*de+1;else return oe[3*de+2];return 0}}ze._INSTANCE=null;function nt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(X[23],J([0,1,22,63]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",M=typeof TextDecoder!="undefined";let i,S;class y{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return L?new y(Buffer.allocUnsafe(m)):new y(new Uint8Array(m))}static wrap(m){return L&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new y(m)}static fromString(m,D){return!((D==null?void 0:D.dontUseNodeBuffer)||!1)&&L?new y(Buffer.from(m)):b?(i||(i=new TextEncoder),new y(i.encode(m))):new y(v.encodeUTF8(m))}static concat(m,D){if(typeof D=="undefined"){D=0;for(let q=0,Q=m.length;q<Q;q++)D+=m[q].byteLength}const _=y.alloc(D);let U=0;for(let q=0,Q=m.length;q<Q;q++){const ie=m[q];_.set(ie,U),U+=ie.byteLength}return _}toString(){return L?this.buffer.toString():M?(S||(S=new TextDecoder),S.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(m,D){return new y(this.buffer.subarray(m,D))}set(m,D){m instanceof y?this.buffer.set(m.buffer,D):this.buffer.set(m,D)}readUInt32BE(m){return E(this.buffer,m)}writeUInt32BE(m,D){p(this.buffer,m,D)}readUInt32LE(m){return d(this.buffer,m)}writeUInt32LE(m,D){w(this.buffer,m,D)}readUInt8(m){return P(this.buffer,m)}writeUInt8(m,D){I(this.buffer,m,D)}}e.VSBuffer=y;function n(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0}e.readUInt16LE=n;function g(f,m,D){f[D+0]=m&255,m=m>>>8,f[D+1]=m&255}e.writeUInt16LE=g;function E(f,m){return f[m]*2**24+f[m+1]*2**16+f[m+2]*2**8+f[m+3]}e.readUInt32BE=E;function p(f,m,D){f[D+3]=m,m=m>>>8,f[D+2]=m,m=m>>>8,f[D+1]=m,m=m>>>8,f[D]=m}e.writeUInt32BE=p;function d(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0|f[m+2]<<16>>>0|f[m+3]<<24>>>0}e.readUInt32LE=d;function w(f,m,D){f[D+0]=m&255,m=m>>>8,f[D+1]=m&255,m=m>>>8,f[D+2]=m&255,m=m>>>8,f[D+3]=m&255}e.writeUInt32LE=w;function P(f,m){return f[m]}e.readUInt8=P;function I(f,m,D){f[D]=m}e.writeUInt8=I;function a(f){return A.consumeReadable(f,m=>y.concat(m))}e.readableToBuffer=a;function l(f){return A.toReadable(f)}e.bufferToReadable=l;function o(f){return A.consumeStream(f,m=>y.concat(m))}e.streamToBuffer=o;async function c(f){return f.ended?y.concat(f.buffer):y.concat([...f.buffer,await o(f.stream)])}e.bufferedStreamToBuffer=c;function t(f){return A.toStream(f,m=>y.concat(m))}e.bufferToStream=t;function r(f){return A.transform(f,{data:m=>typeof m=="string"?y.fromString(m):y.wrap(m)},m=>y.concat(m))}e.streamToBufferReadableStream=r;function s(f){return A.newWriteableStream(m=>y.concat(m),f)}e.newWriteableBufferStream=s;function u(f,m){return A.prefixedReadable(f,m,D=>y.concat(D))}e.prefixedBufferReadable=u;function h(f,m){return A.prefixedStream(f,m,D=>y.concat(D))}e.prefixedBufferStream=h}),define(X[80],J([0,1,22]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(I){return L(I,0)}e.hash=A;function L(I,a){switch(typeof I){case"object":return I===null?b(349,a):Array.isArray(I)?S(I,a):y(I,a);case"string":return i(I,a);case"boolean":return M(I,a);case"number":return b(I,a);case"undefined":return b(937,a);default:return b(617,a)}}e.doHash=L;function b(I,a){return(a<<5)-a+I|0}function M(I,a){return b(I?433:863,a)}function i(I,a){a=b(149417,a);for(let l=0,o=I.length;l<o;l++)a=b(I.charCodeAt(l),a);return a}e.stringHash=i;function S(I,a){return a=b(104579,a),I.reduce((l,o)=>L(o,l),a)}function y(I,a){return a=b(181387,a),Object.keys(I).sort().reduce((l,o)=>(l=i(o,l),L(I[o],l)),a)}class n{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=L(a,this._value),this._value}}e.Hasher=n;var g;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function E(I,a,l=32){const o=l-a,c=~((1<<o)-1);return(I<<a|(c&I)>>>o)>>>0}function p(I,a=0,l=I.byteLength,o=0){for(let c=0;c<l;c++)I[a+c]=o}function d(I,a,l="0"){for(;I.length<a;)I=l+I;return I}function w(I,a=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(l=>l.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),a/4)}e.toHexString=w;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const l=a.length;if(l!==0){const o=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=a.charCodeAt(0),s=0);;){let u=r;if(v.isHighSurrogate(r))if(s+1<l){const h=a.charCodeAt(s+1);v.isLowSurrogate(h)?(s++,u=v.computeCodePoint(r,h)):u=65533}else{t=r;break}else v.isLowSurrogate(r)&&(u=65533);if(c=this._push(o,c,u),s++,s<l)r=a.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(a,l,o){return o<128?a[l++]=o:o<2048?(a[l++]=192|(o&1984)>>>6,a[l++]=128|(o&63)>>>0):o<65536?(a[l++]=224|(o&61440)>>>12,a[l++]=128|(o&4032)>>>6,a[l++]=128|(o&63)>>>0):(a[l++]=240|(o&1835008)>>>18,a[l++]=128|(o&258048)>>>12,a[l++]=128|(o&4032)>>>6,a[l++]=128|(o&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=P._bigBlock32,l=this._buffDV;for(let m=0;m<64;m+=4)a.setUint32(m,l.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)a.setUint32(m,E(a.getUint32(m-12,!1)^a.getUint32(m-32,!1)^a.getUint32(m-56,!1)^a.getUint32(m-64,!1),1),!1);let o=this._h0,c=this._h1,t=this._h2,r=this._h3,s=this._h4,u,h,f;for(let m=0;m<80;m++)m<20?(u=c&t|~c&r,h=1518500249):m<40?(u=c^t^r,h=1859775393):m<60?(u=c&t|c&r|t&r,h=2400959708):(u=c^t^r,h=3395469782),f=E(o,5)+u+s+h+a.getUint32(m*4,!1)&4294967295,s=r,r=t,t=E(c,30),c=o,o=f;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[12],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(m){return Array.isArray(m)}e.isArray=v;function A(m){return typeof m=="string"}e.isString=A;function L(m){return Array.isArray(m)&&m.every(D=>A(D))}e.isStringArray=L;function b(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=b;function M(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=M;function i(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=i;function S(m){return m===!0||m===!1}e.isBoolean=S;function y(m){return typeof m=="undefined"}e.isUndefined=y;function n(m){return!g(m)}e.isDefined=n;function g(m){return y(m)||m===null}e.isUndefinedOrNull=g;function E(m,D){if(!m)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=E;function p(m){if(g(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function d(...m){const D=[];for(let _=0;_<m.length;_++){const U=m[_];if(g(U))throw new Error(`Assertion Failed: argument at index ${_} is undefined or null`);D.push(U)}return D}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function P(m){if(!b(m))return!1;for(let D in m)if(w.call(m,D))return!1;return!0}e.isEmptyObject=P;function I(m){return typeof m=="function"}e.isFunction=I;function a(...m){return m.length>0&&m.every(I)}e.areFunctions=a;function l(m,D){const _=Math.min(m.length,D.length);for(let U=0;U<_;U++)o(m[U],D[U])}e.validateConstraints=l;function o(m,D){if(A(D)){if(typeof m!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(I(D)){try{if(m instanceof D)return}catch(_){}if(!g(m)&&m.constructor===D||D.length===1&&D.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(m){let D=[],_=Object.getPrototypeOf(m);for(;Object.prototype!==_;)D=D.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return D}e.getAllPropertyNames=c;function t(m){const D=[];for(const _ of c(m))typeof m[_]=="function"&&D.push(_);return D}e.getAllMethodNames=t;function r(m,D){const _=q=>function(){const Q=Array.prototype.slice.call(arguments,0);return D(q,Q)};let U={};for(const q of m)U[q]=_(q);return U}e.createProxyObject=r;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function u(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=u;function h(m){return class{constructor(){return new Proxy({},{get(D,_){if(D[_])return D[_];throw new Error(`Not Implemented: ${m}->${String(_)}`)}})}}}e.NotImplementedProxy=h;function f(m){throw new Error("Unreachable")}e.assertNever=f}),define(X[30],J([0,1,3,22,8,12]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function M(r){return r===47||r===92}e.isPathSeparator=M;function i(r){return r.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=i;function S(r,s=L.posix.sep){if(!r)return"";const u=r.length,h=r.charCodeAt(0);if(M(h)){if(M(r.charCodeAt(1))&&!M(r.charCodeAt(2))){let m=3;const D=m;for(;m<u&&!M(r.charCodeAt(m));m++);if(D!==m&&!M(r.charCodeAt(m+1))){for(m+=1;m<u;m++)if(M(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,s)}}return s}else if(P(h)&&r.charCodeAt(1)===58)return M(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(M(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=S;function y(r){if(!v.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let u=2;const h=u;for(;u<r.length&&(s=r.charCodeAt(u),s!==92);u++);return!(h===u||(s=r.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=y;const n=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(r,s=v.isWindows){const u=s?n:g;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||s&&E.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=p;function d(r,s,u){const h=r===s;return!u||h?h:!r||!s?!1:(0,A.equalsIgnoreCase)(r,s)}e.isEqual=d;function w(r,s,u,h=L.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(u){if(!(0,A.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let m=s.length;return s.charAt(s.length-1)===h&&m--,r.charAt(m)===h}return s.charAt(s.length-1)!==h&&(s+=h),r.indexOf(s)===0}e.isEqualOrParent=w;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function I(r,s){return v.isWindows&&r.endsWith(":")&&(r+=L.sep),(0,L.isAbsolute)(r)||(r=(0,L.join)(s,r)),r=(0,L.normalize)(r),v.isWindows?(r=(0,A.rtrim)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,A.rtrim)(r,L.sep),r||(r=L.sep)),r}e.sanitizeFilePath=I;function a(r){const s=(0,L.normalize)(r);return v.isWindows?r.length>3?!1:l(s)&&(r.length===2||s.charCodeAt(2)===92):s===L.posix.sep}e.isRootOrDriveLetter=a;function l(r){return v.isWindows?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function o(r){return l(r)?r[0]:void 0}e.getDriveLetter=o;function c(r,s,u){return s.length>r.length?-1:r===s?0:(u&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=c;function t(r){const s=r.split(":");let u,h,f;if(s.forEach(m=>{const D=Number(m);(0,b.isNumber)(D)?h===void 0?h=D:f===void 0&&(f=D):u=u?[u,m].join(":"):m}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(X[44],J([0,1,12]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const w=Array.isArray(d)?[]:{};return Object.keys(d).forEach(P=>{d[P]&&typeof d[P]=="object"?w[P]=A(d[P]):w[P]=d[P]}),w}e.deepClone=A;function L(d){if(!d||typeof d!="object")return d;const w=[d];for(;w.length>0;){const P=w.shift();Object.freeze(P);for(const I in P)if(b.call(P,I)){const a=P[I];typeof a=="object"&&!Object.isFrozen(a)&&w.push(a)}}return d}e.deepFreeze=L;const b=Object.prototype.hasOwnProperty;function M(d,w){return i(d,w,new Set)}e.cloneAndChange=M;function i(d,w,P){if((0,v.isUndefinedOrNull)(d))return d;const I=w(d);if(typeof I!="undefined")return I;if((0,v.isArray)(d)){const a=[];for(const l of d)a.push(i(l,w,P));return a}if((0,v.isObject)(d)){if(P.has(d))throw new Error("Cannot clone recursive data-structure");P.add(d);const a={};for(let l in d)b.call(d,l)&&(a[l]=i(d[l],w,P));return P.delete(d),a}return d}function S(d,w,P=!0){return(0,v.isObject)(d)?((0,v.isObject)(w)&&Object.keys(w).forEach(I=>{I in d?P&&((0,v.isObject)(d[I])&&(0,v.isObject)(w[I])?S(d[I],w[I],P):d[I]=w[I]):d[I]=w[I]}),d):w}e.mixin=S;function y(d,w){if(d===w)return!0;if(d==null||w===null||w===void 0||typeof d!=typeof w||typeof d!="object"||Array.isArray(d)!==Array.isArray(w))return!1;let P,I;if(Array.isArray(d)){if(d.length!==w.length)return!1;for(P=0;P<d.length;P++)if(!y(d[P],w[P]))return!1}else{const a=[];for(I in d)a.push(I);a.sort();const l=[];for(I in w)l.push(I);if(l.sort(),!y(a,l))return!1;for(P=0;P<a.length;P++)if(!y(d[a[P]],w[a[P]]))return!1}return!0}e.equals=y;function n(d){const w=new Set;return JSON.stringify(d,(P,I)=>{if((0,v.isObject)(I)||Array.isArray(I)){if(w.has(I))return"[Circular]";w.add(I)}return I})}e.safeStringify=n;function g(d,w,P){const I=w(d);return typeof I=="undefined"?P:I}e.getOrDefault=g;function E(d,w){const P=Object.create(null);return!d||!w||Object.keys(w).forEach(a=>{const l=d[a],o=w[a];y(l,o)||(P[a]=o)}),P}e.distinct=E;function p(d,w){const P=w.toLowerCase(),I=Object.keys(d).find(a=>a.toLowerCase()===P);return I?d[I]:d[w]}e.getCaseInsensitive=p}),define(X[7],J([0,1,3,8]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,b=/^\//,M=/^\/\//;function i(s,u){if(!s.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!b.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,u){return!s&&!u?"file":s}function y(s,u){switch(s){case"https":case"http":case"file":u?u[0]!==g&&(u=g+u):u=g;break}return u}const n="",g="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(u,h,f,m,D,_=!1){typeof u=="object"?(this.scheme=u.scheme||n,this.authority=u.authority||n,this.path=u.path||n,this.query=u.query||n,this.fragment=u.fragment||n):(this.scheme=S(u,_),this.authority=h||n,this.path=y(this.scheme,f||n),this.query=m||n,this.fragment=D||n,i(this,_))}static isUri(u){return u instanceof p?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return l(this,!1)}with(u){if(!u)return this;let{scheme:h,authority:f,path:m,query:D,fragment:_}=u;return h===void 0?h=this.scheme:h===null&&(h=n),f===void 0?f=this.authority:f===null&&(f=n),m===void 0?m=this.path:m===null&&(m=n),D===void 0?D=this.query:D===null&&(D=n),_===void 0?_=this.fragment:_===null&&(_=n),h===this.scheme&&f===this.authority&&m===this.path&&D===this.query&&_===this.fragment?this:new w(h,f,m,D,_)}static parse(u,h=!1){const f=E.exec(u);return f?new w(f[2]||n,r(f[4]||n),r(f[5]||n),r(f[7]||n),r(f[9]||n),h):new w(n,n,n,n,n)}static file(u){let h=n;if(v.isWindows&&(u=u.replace(/\\/g,g)),u[0]===g&&u[1]===g){const f=u.indexOf(g,2);f===-1?(h=u.substring(2),u=g):(h=u.substring(2,f),u=u.substring(f)||g)}return new w("file",h,u,n,n)}static from(u){return new w(u.scheme,u.authority,u.path,u.query,u.fragment)}static joinPath(u,...h){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return v.isWindows&&u.scheme==="file"?f=p.file(A.win32.join(l(u,!0),...h)).path:f=A.posix.join(u.path,...h),u.with({path:f})}toString(u=!1){return o(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof p)return u;{const h=new w(u);return h._formatted=u.external,h._fsPath=u._sep===d?u.fsPath:null,h}}else return u}}e.URI=p;const d=v.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(u=!1){return u?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=d),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(s,u){let h,f=-1;for(let m=0;m<s.length;m++){const D=s.charCodeAt(m);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||u&&D===47)f!==-1&&(h+=encodeURIComponent(s.substring(f,m)),f=-1),h!==void 0&&(h+=s.charAt(m));else{h===void 0&&(h=s.substr(0,m));const _=P[D];_!==void 0?(f!==-1&&(h+=encodeURIComponent(s.substring(f,m)),f=-1),h+=_):f===-1&&(f=m)}}return f!==-1&&(h+=encodeURIComponent(s.substring(f))),h!==void 0?h:s}function a(s){let u;for(let h=0;h<s.length;h++){const f=s.charCodeAt(h);f===35||f===63?(u===void 0&&(u=s.substr(0,h)),u+=P[f]):u!==void 0&&(u+=s[h])}return u!==void 0?u:s}function l(s,u){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?u?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,v.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=l;function o(s,u){const h=u?a:I;let f="",{scheme:m,authority:D,path:_,query:U,fragment:q}=s;if(m&&(f+=m,f+=":"),(D||m==="file")&&(f+=g,f+=g),D){let Q=D.indexOf("@");if(Q!==-1){const ie=D.substr(0,Q);D=D.substr(Q+1),Q=ie.indexOf(":"),Q===-1?f+=h(ie,!1):(f+=h(ie.substr(0,Q),!1),f+=":",f+=h(ie.substr(Q+1),!1)),f+="@"}D=D.toLowerCase(),Q=D.indexOf(":"),Q===-1?f+=h(D,!1):(f+=h(D.substr(0,Q),!1),f+=D.substr(Q))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const Q=_.charCodeAt(1);Q>=65&&Q<=90&&(_=`/${String.fromCharCode(Q+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const Q=_.charCodeAt(0);Q>=65&&Q<=90&&(_=`${String.fromCharCode(Q+32)}:${_.substr(2)}`)}f+=h(_,!0)}return U&&(f+="?",f+=h(U,!1)),q&&(f+="#",f+=u?q:I(q,!1)),f}function c(s){try{return decodeURIComponent(s)}catch(u){return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,u=>c(u)):s}}),define(X[106],J([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(y){const n=y;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=A;function L(y){const n=[];let g;try{const E=JSON.parse(y.arguments),p=E[E.length-1];p&&p.__$stack&&(E.pop(),g=p.__$stack),n.push(...E)}catch(E){n.push("Unable to log remote console arguments",y.arguments)}return{args:n,stack:g}}e.parse=L;function b(y){if(typeof y!="string")return b(L(y).stack);const n=y;if(n){const g=M(n),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=b;function M(y){if(!y)return y;const n=y.indexOf(`
`);return n===-1?y:y.substring(0,n)}function i(y,n){const{args:g,stack:E}=L(y),p=typeof g[0]=="string"&&g.length===1;let d=M(E);d&&(d=`(${d.trim()})`);let w=[];if(typeof g[0]=="string"?d&&p?w=[`%c[${n}] %c${g[0]} %c${d}`,S("blue"),S(""),S("grey")]:w=[`%c[${n}] %c${g[0]}`,S("blue"),S(""),...g.slice(1)]:w=[`%c[${n}]%`,S("blue"),...g],d&&!p&&w.push(d),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,w)}e.log=i;function S(y){return`color: ${y}`}});var yt=this&&this.__classPrivateFieldSet||function(H,e,v,A,L){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?H!==e||!L:!e.has(H))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?L.call(H,v):L?L.value=v:e.set(H,v),v},Ge=this&&this.__classPrivateFieldGet||function(H,e,v,A){if(v==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?H!==e||!A:!e.has(H))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?A:v==="a"?A.call(H):A?A.value:e.get(H)};define(X[36],J([0,1,7,22]),function(H,e,v,A){"use strict";var L,b,M;Object.defineProperty(e,"__esModule",{value:!0}),e.HashSet=e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function i(r,s,u){let h=r.get(s);return h===void 0&&(h=u,r.set(s,h)),h}e.getOrSet=i;function S(r){const s=[];return r.forEach((u,h)=>{s.push(`${h} => ${u}`)}),`Map(${r.size}) {${s.join(", ")}}`}e.mapToString=S;function y(r){const s=[];return r.forEach(u=>{s.push(u)}),`Set(${r.size}) {${s.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const u=s.charCodeAt(0),h=this._value.charCodeAt(this._pos);return u-h}value(){return this._value[this._pos]}}e.StringIterator=n;class g{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,A.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class E{constructor(s=!0,u=!0){this._splitOnBackslash=s,this._caseSensitive=u}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,A.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class d{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,A.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(s){this._iter=s}static forUris(s=()=>!1){return new P(new d(s))}static forPaths(){return new P(new E)}static forStrings(){return new P(new n)}static forConfigKeys(){return new P(new g)}clear(){this._root=void 0}set(s,u){const h=this._iter.reset(s);let f;for(this._root||(this._root=new w,this._root.segment=h.value()),f=this._root;;){const D=h.cmp(f.segment);if(D>0)f.left||(f.left=new w,f.left.segment=h.value()),f=f.left;else if(D<0)f.right||(f.right=new w,f.right.segment=h.value()),f=f.right;else if(h.hasNext())h.next(),f.mid||(f.mid=new w,f.mid.segment=h.value()),f=f.mid;else break}const m=f.value;return f.value=u,f.key=s,m}get(s){var u;return(u=this._getNode(s))===null||u===void 0?void 0:u.value}_getNode(s){const u=this._iter.reset(s);let h=this._root;for(;h;){const f=u.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(u.hasNext())u.next(),h=h.mid;else break}return h}has(s){const u=this._getNode(s);return!((u==null?void 0:u.value)===void 0&&(u==null?void 0:u.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,u){const h=this._iter.reset(s),f=[];let m=this._root;for(;m;){const D=h.cmp(m.segment);if(D>0)f.push([1,m]),m=m.left;else if(D<0)f.push([-1,m]),m=m.right;else if(h.hasNext())h.next(),f.push([0,m]),m=m.mid;else{for(u?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;f.length>0&&m.isEmpty();){let[_,U]=f.pop();switch(_){case 1:U.left=void 0;break;case 0:U.mid=void 0;break;case-1:U.right=void 0;break}m=U}break}}}findSubstr(s){const u=this._iter.reset(s);let h=this._root,f;for(;h;){const m=u.cmp(h.segment);if(m>0)h=h.left;else if(m<0)h=h.right;else if(u.hasNext())u.next(),f=h.value||f,h=h.mid;else break}return h&&h.value||f}findSuperstr(s){const u=this._iter.reset(s);let h=this._root;for(;h;){const f=u.cmp(h.segment);if(f>0)h=h.left;else if(f<0)h=h.right;else if(u.hasNext())u.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(s){for(const[u,h]of this)s(h,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=P;class I{constructor(s,u){this[L]="ResourceMap",s instanceof I?(this.map=new Map(s.map),this.toKey=u!=null?u:I.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:I.defaultToKey)}set(s,u){return this.map.set(this.toKey(s),u),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,u){typeof u!="undefined"&&(s=s.bind(u));for(let[h,f]of this.map)s(f,v.URI.parse(h),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield v.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[v.URI.parse(s[0]),s[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[v.URI.parse(s[0]),s[1]]}}e.ResourceMap=I,I.defaultToKey=r=>r.toString();var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,u=0){const h=this._map.get(s);if(!!h)return u!==0&&this.touch(h,u),h.value}set(s,u,h=0){let f=this._map.get(s);if(f)f.value=u,h!==0&&this.touch(f,h);else{switch(f={key:s,value:u,next:void 0,previous:void 0},h){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(s,f),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const u=this._map.get(s);if(!!u)return this._map.delete(s),this.removeItem(u),this._size--,u.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,u){const h=this._state;let f=this._head;for(;f;){if(u?s.bind(u)(f.value,f.key,this):s(f.value,f.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const s=this,u=this._state;let h=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.key,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return f}values(){const s=this,u=this._state;let h=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.value,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return f}entries(){const s=this,u=this._state;let h=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:[h.key,h.value],done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return f}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let u=this._head,h=this.size;for(;u&&h>s;)this._map.delete(u.key),u=u.next,h--;this._head=u,this._size=h,u&&(u.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const u=s.next,h=s.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}s.next=void 0,s.previous=void 0,this._state++}touch(s,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(s===this._head)return;const h=s.next,f=s.previous;s===this._tail?(f.next=void 0,this._tail=f):(h.previous=f,f.next=h),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(u===2){if(s===this._tail)return;const h=s.next,f=s.previous;s===this._head?(h.previous=void 0,this._head=h):(h.previous=f,f.next=h),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((u,h)=>{s.push([h,u])}),s}fromJSON(s){this.clear();for(const[u,h]of s)this.set(u,h)}}e.LinkedMap=l;class o extends l{constructor(s,u=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,u=2){return super.get(s,u)}peek(s){return super.get(s,0)}set(s,u){return super.set(s,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class c{constructor(s){M.set(this,void 0),yt(this,M,s,"f")}get size(){return Ge(this,M,"f").size}forEach(s,u){Ge(this,M,"f").forEach(s,u)}get(s){return Ge(this,M,"f").get(s)}has(s){return Ge(this,M,"f").has(s)}entries(){return Ge(this,M,"f").entries()}keys(){return Ge(this,M,"f").keys()}values(){return Ge(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Ge(this,M,"f").entries()}}e.ReadonlyMapView=c;class t{constructor(s,u){this.hash=u,this.map=new Map;for(const h of s)this.add(h)}get size(){return this.map.size}add(s){this.map.set(this.hash(s),s)}delete(s){return this.map.delete(this.hash(s))}clear(){this.map.clear()}has(s){return this.map.has(this.hash(s))}get(s){return this.map.get(this.hash(s))}}e.HashSet=t}),define(X[107],J([0,1,23,22,7]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(y){return JSON.stringify(y,i)}e.stringify=b;function M(y){let n=JSON.parse(y);return n=S(n),n}e.parse=M;function i(y,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,A.regExpFlags)(n)}:n}function S(y,n=0){if(!y||n>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return L.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof v.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let g=0;g<y.length;++g)y[g]=S(y[g],n+1);else for(const g in y)Object.hasOwnProperty.call(y,g)&&(y[g]=S(y[g],n+1))}return y}e.revive=S}),define(X[10],J([0,1,7,3]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(i){i.inMemory="inmemory",i.vscode="vscode",i.internal="private",i.walkThrough="walkThrough",i.walkThroughSnippet="walkThroughSnippet",i.http="http",i.https="https",i.file="file",i.mailto="mailto",i.untitled="untitled",i.data="data",i.command="command",i.vscodeRemote="vscode-remote",i.vscodeRemoteResource="vscode-remote-resource",i.userData="vscode-userdata",i.vscodeCustomEditor="vscode-custom-editor",i.vscodeNotebook="vscode-notebook",i.vscodeNotebookCell="vscode-notebook-cell",i.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",i.vscodeSettings="vscode-settings",i.vscodeWorkspaceTrust="vscode-workspace-trust",i.vscodeTerminal="vscode-terminal",i.webviewPanel="webview-panel",i.vscodeWebview="vscode-webview",i.extension="extension",i.vscodeFileResource="vscode-file"})(L=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,y,n){this._hosts[S]=y,this._ports[S]=n}setConnectionToken(S,y){this._connectionTokens[S]=y}rewrite(S){if(this._delegate)return this._delegate(S);const y=S.authority;let n=this._hosts[y];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const g=this._ports[y],E=this._connectionTokens[y];let p=`path=${encodeURIComponent(S.path)}`;return typeof E=="string"&&(p+=`&tkn=${encodeURIComponent(E)}`),v.URI.from({scheme:A.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${g}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new b;class M{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,y,n){const g=this.toUri(S,y);return g.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(g):A.isNative&&(n||A.isPreferringBrowserCodeLoad)&&g.scheme===L.file?g.with({scheme:L.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(S,y){const n=this.toUri(S,y);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,y){return v.URI.isUri(S)?S:v.URI.parse(y.toUrl(S))}}e.FileAccess=new M}),define(X[64],J([0,1,36]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new v.LRUCache(1e4);function L(y){return S(y,"NFC",A)}e.normalizeNFC=L;const b=new v.LRUCache(1e4);function M(y){return S(y,"NFD",b)}e.normalizeNFD=M;const i=/[^\u0000-\u0080]/;function S(y,n,g){if(!e.canNormalize||!y)return y;const E=g.get(y);if(E)return E;let p;return i.test(y)?p=y.normalize(n):p=y,g.set(y,p),p}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(n){return M(n).replace(y,"")}}else return function(y){return y}}()}),define(X[15],J([0,1,30,8,7,22,10,3]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(p){return(0,L.uriToFsPath)(p,!0)}e.originalFSPath=S;class y{constructor(d){this._ignorePathCasing=d}compare(d,w,P=!1){return d===w?0:(0,b.compare)(this.getComparisonKey(d,P),this.getComparisonKey(w,P))}isEqual(d,w,P=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,P)===this.getComparisonKey(w,P)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,P=!1){if(d.scheme===w.scheme){if(d.scheme===M.Schemas.file)return v.isEqualOrParent(S(d),S(w),this._ignorePathCasing(d))&&d.query===w.query&&(P||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return v.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(P||d.fragment===w.fragment)}return!1}joinPath(d,...w){return L.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return A.posix.basename(d.path)}extname(d){return A.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===M.Schemas.file?w=L.URI.file(A.dirname(S(d))).path:(w=A.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===M.Schemas.file?w=L.URI.file(A.normalize(S(d))).path:w=A.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(!(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))){if(d.scheme===M.Schemas.file){const a=A.relative(S(d),S(w));return i.isWindows?v.toSlashes(a):a}let P=d.path||"/",I=w.path||"/";if(this._ignorePathCasing(d)){let a=0;for(const l=Math.min(P.length,I.length);a<l&&!(P.charCodeAt(a)!==I.charCodeAt(a)&&P.charAt(a).toLowerCase()!==I.charAt(a).toLowerCase());a++);P=I.substr(0,a)+P.substr(a)}return A.posix.relative(P,I)}}resolvePath(d,w){if(d.scheme===M.Schemas.file){const P=L.URI.file(A.resolve(S(d),w));return d.with({authority:P.authority,path:P.path})}return w.indexOf("/")===-1&&(w=v.toSlashes(w),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w)),d.with({path:A.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,b.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=A.sep){if(d.scheme===M.Schemas.file){const P=S(d);return P.length>v.getRoot(P).length&&P[P.length-1]===w}else{const P=d.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=A.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=A.sep){let P=!1;if(d.scheme===M.Schemas.file){const I=S(d);P=I!==void 0&&I.length===v.getRoot(I).length&&I[I.length-1]===w}else{w="/";const I=d.path;P=I.length===1&&I.charCodeAt(I.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===M.Schemas.file?!i.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(p,d){const w=[];for(let P=0;P<p.length;P++){const I=d(p[P]);p.some((a,l)=>l===P?!1:(0,e.isEqualOrParent)(I,d(a)))||w.push(p[P])}return w}e.distinctParents=n;var g;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(w){const P=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(l=>{const[o,c]=l.split(":");o&&c&&P.set(o,c)});const a=w.path.substring(0,w.path.indexOf(";"));return a&&P.set(p.META_DATA_MIME,a),P}p.parseMetaData=d})(g=e.DataUri||(e.DataUri={}));function E(p,d,w){if(d){let P=p.path;return P&&P[0]!==A.posix.sep&&(P=A.posix.sep+P),p.with({scheme:w,authority:d,path:P})}return p.with({scheme:w})}e.toLocalResource=E}),define(X[9],J([0,1,25,17,5,2,78,15]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(N){return!!N&&typeof N.then=="function"}e.isThenable=S;function y(N){const T=new v.CancellationTokenSource,R=N(T.token),W=new Promise((k,F)=>{T.token.onCancellationRequested(()=>{F((0,A.canceled)())}),Promise.resolve(R).then(B=>{T.dispose(),k(B)},B=>{T.dispose(),F(B)})});return new class{cancel(){T.cancel()}then(k,F){return W.then(k,F)}catch(k){return this.then(void 0,k)}finally(k){return W.finally(k)}}}e.createCancelablePromise=y;function n(N,T,R){return Promise.race([N,new Promise(W=>T.onCancellationRequested(()=>W(R)))])}e.raceCancellation=n;async function g(N){let T=-1;const R=N.map((k,F)=>k.then(B=>(T=F,B))),W=await Promise.race(R);return N.forEach((k,F)=>{F!==T&&k.cancel()}),W}e.raceCancellablePromises=g;function E(N,T,R){let W;const k=setTimeout(()=>{W==null||W(void 0),R==null||R()},T);return Promise.race([N.finally(()=>clearTimeout(k)),new Promise(F=>W=F)])}e.raceTimeout=E;function p(N){return new Promise((T,R)=>{const W=N();S(W)?W.then(T,R):T(W)})}e.asPromise=p;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(R,R).then(W)})}return new Promise((R,W)=>{this.queuedPromise.then(R,W)})}return this.activePromise=T(),new Promise((R,W)=>{this.activePromise.then(k=>{this.activePromise=null,R(k)},k=>{this.activePromise=null,W(k)})})}}e.Throttler=d;class w{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=w;class P{constructor(){this.promiseMap=new Map}queue(T,R){var W;const F=((W=this.promiseMap.get(T))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(T)===F&&this.promiseMap.delete(T)});return this.promiseMap.set(T,F),F}}e.SequencerByKey=P;class I{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,R=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,k)=>{this.doResolve=W,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=I;class a{constructor(T){this.delayer=new I(T),this.throttler=new d}trigger(T,R){return this.delayer.trigger(()=>this.throttler.queue(T),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class l{constructor(){this._isOpen=!1,this._promise=new Promise((T,R)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class o extends l{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function c(N,T){return T?new Promise((R,W)=>{const k=setTimeout(R,N);T.onCancellationRequested(()=>{clearTimeout(k),W((0,A.canceled)())})}):y(R=>c(N,R))}e.timeout=c;function t(N,T=0){const R=setTimeout(N,T);return(0,b.toDisposable)(()=>clearTimeout(R))}e.disposableTimeout=t;function r(N){return N.then(void 0,T=>{})}e.ignoreErrors=r;function s(N){const T=[];let R=0;const W=N.length;function k(){return R<W?N[R++]():null}function F(B){B!=null&&T.push(B);const V=k();return V?V.then(F):Promise.resolve(T)}return Promise.resolve(null).then(F)}e.sequence=s;function u(N,T=W=>!!W,R=null){let W=0;const k=N.length,F=()=>{if(W>=k)return Promise.resolve(R);const B=N[W++];return Promise.resolve(B()).then(G=>T(G)?Promise.resolve(G):F())};return F()}e.first=u;function h(N,T=W=>!!W,R=null){if(N.length===0)return Promise.resolve(R);let W=N.length;const k=()=>{var F,B;W=-1;for(const V of N)(B=(F=V).cancel)===null||B===void 0||B.call(F)};return new Promise((F,B)=>{for(const V of N)V.then(G=>{--W>=0&&T(G)?(k(),F(G)):W===0&&F(R)}).catch(G=>{--W>=0&&(k(),B(G))})})}e.firstParallel=h;class f{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((R,W)=>{this.outstandingPromises.push({factory:T,c:R,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const R=T.factory();R.then(T.c,T.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class m extends f{constructor(){super(1)}}e.Queue=m;class D{constructor(){this.queues=new Map}queueFor(T,R=i.extUri){const W=R.getComparisonKey(T);let k=this.queues.get(W);return k||(k=new m,L.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(W)}),this.queues.set(W,k)),k}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=D;class _{constructor(T,R){this._token=-1,typeof T=="function"&&typeof R=="number"&&this.setIfNotSet(T,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},R)}setIfNotSet(T,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},R))}}e.TimeoutTimer=_;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,R){this.cancel(),this._token=setInterval(()=>{T()},R)}}e.IntervalTimer=U;class q{constructor(T,R){this.timeoutToken=-1,this.runner=T,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=q;class Q extends q{constructor(T,R){super(T,R);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Q,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const R=setTimeout(()=>T(N));let W=!1;return{dispose(){W||(W=!0,clearTimeout(R))}}}}else e.runWhenIdle=(N,T)=>{const R=requestIdleCallback(N,typeof T=="number"?{timeout:T}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(R))}}}}();class ie{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ie;async function ae(N,T,R){let W;for(let k=0;k<R;k++)try{return await N()}catch(F){W=F,await c(T)}throw W}e.retry=ae;class O{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,R,W){return this._pending={taskId:T,cancel:()=>W==null?void 0:W(),promise:R},R.then(()=>this.donePending(T),()=>this.donePending(T)),R}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let R,W;const k=new Promise((F,B)=>{R=F,W=B});this._next={run:T,promise:k,promiseResolve:R,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=O;class ${constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,R)=>{this.completeCallback=T,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(R=>{this.completeCallback(T),this.resolved=!0,R()})}error(T){return new Promise(R=>{this.errorCallback(T),this.rejected=!0,R()})}cancel(){new Promise(T=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=z;class C extends L.Emitter{async fireAsync(T,R,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,T]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[k,F]=this._asyncDeliveryQueue.shift(),B=[],V=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");W&&(G=W(G,typeof k=="function"?k:k[0])),B.push(G)}});try{typeof k=="function"?k.call(void 0,V):k[0].call(k[1],V)}catch(G){(0,A.onUnexpectedError)(G);continue}Object.freeze(B),await j.settled(B).catch(G=>(0,A.onUnexpectedError)(G))}}}}e.AsyncEmitter=C;var j;(function(N){async function T(F){return typeof Promise.allSettled=="function"?R(F):W(F)}N.allSettled=T;async function R(F){return Promise.allSettled(F)}async function W(F){return Promise.all(F.map(B=>B.then(V=>({status:"fulfilled",value:V}),V=>({status:"rejected",reason:V}))))}async function k(F){let B;const V=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{B||(B=Y)})));if(typeof B!="undefined")throw B;return V}N.settled=k})(j=e.Promises||(e.Promises={}))}),define(X[108],J([0,1,22,30,8,36,9]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function i(){return Object.create(null)}e.getEmptyExpression=i;const S="**",y="/",n="[/\\\\]",g="[^/\\\\]",E=/\//g;function p(R){switch(R){case 0:return"";case 1:return`${g}*?`;default:return`(?:${n}|${g}+${n}|${n}${g}+)*?`}}function d(R,W){if(!R)return[];const k=[];let F=!1,B=!1,V="";for(const G of R){switch(G){case W:if(!F&&!B){k.push(V),V="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":B=!0;break;case"]":B=!1;break}V+=G}return V&&k.push(V),k}e.splitGlobAware=d;function w(R){if(!R)return"";let W="";const k=d(R,y);if(k.every(F=>F===S))W=".*";else{let F=!1;k.forEach((B,V)=>{if(B===S){F||(W+=p(2),F=!0);return}let G=!1,Y="",Z=!1,re="";for(const se of B){if(se!=="}"&&G){Y+=se;continue}if(Z&&(se!=="]"||!re)){let x;se==="-"?x=se:(se==="^"||se==="!")&&!re?x="^":se===y?x="":x=v.escapeRegExpCharacters(se),re+=x;continue}switch(se){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":W+=`(?:${d(Y,",").map(ue=>w(ue)).join("|")})`,G=!1,Y="";break;case"]":W+="["+re+"]",Z=!1,re="";break;case"?":W+=g;continue;case"*":W+=p(1);continue;default:W+=v.escapeRegExpCharacters(se)}}V<k.length-1&&(k[V+1]!==S||V+2<k.length)&&(W+=n),F=!1})}return W}const P=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),r=function(){return!1},s=function(){return null};function u(R,W){if(!R)return s;let k;typeof R!="string"?k=R.pattern:k=R,k=k.trim();const F=`${k}_${!!W.trimForExclusions}`;let B=t.get(F);if(B)return h(B,R);let V;if(P.test(k)){const G=k.substr(4);B=function(Y,Z){return typeof Y=="string"&&Y.endsWith(G)?k:null}}else(V=I.exec(f(k,W)))?B=m(V[1],k):(W.trimForExclusions?l:a).test(k)?B=D(k,W):(V=o.exec(f(k,W)))?B=_(V[1].substr(1),k,!0):(V=c.exec(f(k,W)))?B=_(V[1],k,!1):B=U(k);return t.set(F,B),h(B,R)}function h(R,W){return typeof W=="string"?R:function(k,F){return A.isEqualOrParent(k,W.base)?R(L.relative(W.base,k),F):null}}function f(R,W){return W.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function m(R,W){const k=`/${R}`,F=`\\${R}`,B=function(G,Y){return typeof G!="string"?null:Y?Y===R?W:null:G===R||G.endsWith(k)||G.endsWith(F)?W:null},V=[R];return B.basenames=V,B.patterns=[W],B.allBasenames=V,B}function D(R,W){const k=T(R.slice(1,-1).split(",").map(Y=>u(Y,W)).filter(Y=>Y!==s),R),F=k.length;if(!F)return s;if(F===1)return k[0];const B=function(Y,Z){for(let re=0,se=k.length;re<se;re++)if(k[re](Y,Z))return R;return null},V=k.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function _(R,W,k){const F=L.sep===L.posix.sep,B=F?R:R.replace(E,L.sep),V=L.sep+B,G=L.posix.sep+R,Y=k?function(Z,re){return typeof Z=="string"&&(Z===B||Z.endsWith(V)||!F&&(Z===R||Z.endsWith(G)))?W:null}:function(Z,re){return typeof Z=="string"&&(Z===B||!F&&Z===R)?W:null};return Y.allPaths=[(k?"*/":"./")+R],Y}function U(R){try{const W=new RegExp(`^${w(R)}$`);return function(k){return W.lastIndex=0,typeof k=="string"&&W.test(k)?R:null}}catch(W){return s}}function q(R,W,k){return!R||typeof W!="string"?!1:Q(R)(W,void 0,k)}e.match=q;function Q(R,W={}){if(!R)return r;if(typeof R=="string"||$(R)){const k=u(R,W);if(k===s)return r;const F=function(B,V){return!!k(B,V)};return k.allBasenames&&(F.allBasenames=k.allBasenames),k.allPaths&&(F.allPaths=k.allPaths),F}return j(R,W)}e.parse=Q;function ie(R){if(!!R){let W;return k=>(W||(W=(R()||Promise.resolve([])).then(F=>F?O(F):{})),W.then(F=>!!F[k]))}}e.hasSiblingPromiseFn=ie;function ae(R){if(!!R){let W;return k=>{if(!W){const F=R();W=F?O(F):{}}return!!W[k]}}}e.hasSiblingFn=ae;function O(R){const W={};for(const k of R)W[k]=!0;return W}function $(R){const W=R;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function z(R){return R.allBasenames||[]}e.getBasenameTerms=z;function C(R){return R.allPaths||[]}e.getPathTerms=C;function j(R,W){const k=T(Object.getOwnPropertyNames(R).map(Y=>N(Y,R[Y],W)).filter(Y=>Y!==s)),F=k.length;if(!F)return s;if(!k.some(Y=>!!Y.requiresSiblings)){if(F===1)return k[0];const Y=function(se,x){for(let ne=0,ue=k.length;ne<ue;ne++){const ye=k[ne](se,x);if(ye)return ye}return null},Z=k.find(se=>!!se.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const re=k.reduce((se,x)=>x.allPaths?se.concat(x.allPaths):se,[]);return re.length&&(Y.allPaths=re),Y}const B=function(Y,Z,re){let se;for(let x=0,ne=k.length;x<ne;x++){const ue=k[x];ue.requiresSiblings&&re&&(Z||(Z=L.basename(Y)),se||(se=Z.substr(0,Z.length-L.extname(Y).length)));const ye=ue(Y,Z,se,re);if(ye)return ye}return null},V=k.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function N(R,W,k){if(W===!1)return s;const F=u(R,k);if(F===s)return s;if(typeof W=="boolean")return F;if(W){const B=W.when;if(typeof B=="string"){const V=(G,Y,Z,re)=>{if(!re||!F(G,Y))return null;const se=B.replace("$(basename)",Z),x=re(se);return(0,M.isThenable)(x)?x.then(ne=>ne?R:null):x?R:null};return V.requiresSiblings=!0,V}}return F}function T(R,W){const k=R.filter(Y=>!!Y.basenames);if(k.length<2)return R;const F=k.reduce((Y,Z)=>{const re=Z.basenames;return re?Y.concat(re):Y},[]);let B;if(W){B=[];for(let Y=0,Z=F.length;Y<Z;Y++)B.push(W)}else B=k.reduce((Y,Z)=>{const re=Z.patterns;return re?Y.concat(re):Y},[]);const V=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let se;for(se=Y.length;se>0;se--){const x=Y.charCodeAt(se-1);if(x===47||x===92)break}Z=Y.substr(se)}const re=F.indexOf(Z);return re!==-1?B[re]:null};V.basenames=F,V.patterns=B,V.allBasenames=F;const G=R.filter(Y=>!Y.basenames);return G.push(V),G}}),define(X[39],J([0,1,7,8,22,10,3,15,30]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(u,h,f){if(typeof u=="string"&&(u=v.URI.file(u)),f){const D=f.getWorkspaceFolder(u);if(D){const _=f.getWorkspace().folders.length>1;let U;if((0,i.isEqual)(D.uri,u)?U="":U=(0,i.relativePath)(D.uri,u),_){const q=D.name?D.name:(0,i.basename)(D.uri);U=U?q+" \u2022 "+U:q}return U}}if(u.scheme!==b.Schemas.file&&u.scheme!==b.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(u.fsPath))return(0,A.normalize)(g(u.fsPath));let m=(0,A.normalize)(u.fsPath);return!M.isWindows&&(h==null?void 0:h.userHome)&&(m=p(m,h.userHome.fsPath)),m}e.getPathLabel=y;function n(u){if(!!u){typeof u=="string"&&(u=v.URI.file(u));const h=(0,i.basename)(u)||(u.scheme===b.Schemas.file?u.fsPath:u.path);return M.isWindows&&(0,S.isRootOrDriveLetter)(h)?g(h):h}}e.getBaseLabel=n;function g(u){return(0,S.hasDriveLetter)(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=g;let E=Object.create(null);function p(u,h){if(M.isWindows||!u||!h)return u;let f=E.original===h?E.normalized:void 0;return f||(f=`${(0,L.rtrim)(h,A.posix.sep)}${A.posix.sep}`,E={original:h,normalized:f}),(M.isLinux?u.startsWith(f):(0,L.startsWithIgnoreCase)(u,f))&&(u=`~/${u.substr(f.length)}`),u}e.tildify=p;function d(u,h){return u.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const w="\u2026",P="\\\\",I="~";function a(u,h=A.sep){const f=new Array(u.length);let m=!1;for(let D=0;D<u.length;D++){let _=u[D];if(_===""){f[D]=`.${h}`;continue}if(!_){f[D]=_;continue}m=!0;let U="";_.indexOf(P)===0?(U=_.substr(0,_.indexOf(P)+P.length),_=_.substr(_.indexOf(P)+P.length)):_.indexOf(h)===0?(U=_.substr(0,_.indexOf(h)+h.length),_=_.substr(_.indexOf(h)+h.length)):_.indexOf(I)===0&&(U=_.substr(0,_.indexOf(I)+I.length),_=_.substr(_.indexOf(I)+I.length));const q=_.split(h);for(let Q=1;m&&Q<=q.length;Q++)for(let ie=q.length-Q;m&&ie>=0;ie--){m=!1;let ae=q.slice(ie,ie+Q).join(h);for(let O=0;!m&&O<u.length;O++)if(O!==D&&u[O]&&u[O].indexOf(ae)>-1){const $=ie+Q===q.length,z=ie>0&&u[O].indexOf(h)>-1?h+ae:ae,C=u[O].endsWith(z);m=!$||C}if(!m){let O="";(q[0].endsWith(":")||U!=="")&&(ie===1&&(ie=0,Q++,ae=q[0]+h+ae),ie>0&&(O=q[0]+h),O=U+O),ie>0&&(O=O+w+h),O=O+ae,ie+Q<q.length&&(O=O+h+w),f[D]=O}}m&&(f[D]=_)}return f}e.shorten=a;var l;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function o(u,h=Object.create(null)){const f=[];let m=!1,D="";for(const _ of u)if(_==="$"||m&&_==="{")D&&f.push({value:D,type:l.TEXT}),D="",m=!0;else if(_==="}"&&m){const U=h[D];if(typeof U=="string")U.length&&f.push({value:U,type:l.VARIABLE});else if(U){const q=f[f.length-1];(!q||q.type!==l.SEPARATOR)&&f.push({value:U.label,type:l.SEPARATOR})}D="",m=!1}else D+=_;return D&&!m&&f.push({value:D,type:l.TEXT}),f.filter((_,U)=>{if(_.type===l.SEPARATOR){const q=f[U-1],Q=f[U+1];return[q,Q].every(ie=>ie&&(ie.type===l.VARIABLE||ie.type===l.TEXT)&&ie.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=o;function c(u,h){return M.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):u.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(u,h){return M.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,""):M.isWindows?u.replace(/&&|&/g,f=>f==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(u){const h=u.indexOf("/")!==-1?A.posix:A.win32,f=h.basename(u),m=h.dirname(u);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(X[28],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(S){return v.test(S)}e.isUUID=A;const L=new Uint8Array(16),b=[];for(let S=0;S<256;S++)b.push(S.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(S){for(let y=0;y<S.length;y++)S[y]=Math.floor(Math.random()*256);return S};function i(){M(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,y="";return y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+="-",y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y+=b[L[S++]],y}e.generateUuid=i}),define(X[109],J([0,1,18,58,42]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(M,i){if(await new Promise((n,g)=>{const E=v.createReadStream(M),p=A.createHash("sha1");E.pipe(p);const d=(0,L.once)((w,P)=>{E.removeAllListeners(),p.removeAllListeners(),w?g(w):n(P)});E.once("error",d),E.once("end",d),p.once("error",d),p.once("data",w=>d(void 0,w.toString("hex")))})!==i)throw new Error("Hash mismatch")}e.checksum=b}),define(X[81],J([0,1,231]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(b="utf8"){this.stringDecoder=new v.StringDecoder(b),this.remaining=null}write(b){const M=[],i=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(i.length<1)return M;let S=0,y,n=S;for(;n<i.length;)if(y=i.charCodeAt(n),y===13||y===10){if(M.push(i.substring(S,n)),n++,n<i.length){const g=y;y=i.charCodeAt(n),(g===13&&y===10||g===10&&y===13)&&n++}S=n}else n++;return this.remaining=S<i.length?i.substr(S):null,M}end(){return this.remaining}}e.LineDecoder=A}),define(X[110],J([0,1,27]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(i){const S=i.replace(/\-/g,":").toLowerCase();return!A.has(S)}function b(){return new Promise(async(i,S)=>{const y=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{i(await M())}catch(n){S(n)}finally{clearTimeout(y)}})}e.getMac=b;function M(){return new Promise((i,S)=>{try{const y=(0,v.networkInterfaces)();for(let n in y){const g=y[n];if(g){for(const{mac:E}of g)if(L(E))return i(E)}}S("Unable to retrieve mac address (unexpected format)")}catch(y){S(y)}})}}),define(X[65],J([0,1,17,28,27,36,110]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,g=0;const E=(0,L.networkInterfaces)();for(let p in E){const d=E[p];if(d)for(const{mac:w,internal:P}of d)P||(g+=1,this._isVirtualMachineMacAdress(w.toUpperCase())&&(n+=1))}this._value=g>0?n/g:0}return this._value}};let i;async function S(){return i||(i=(async()=>await y()||A.generateUuid())()),i}e.getMachineId=S;async function y(){try{const n=await new Promise((E,p)=>{H(["crypto"],E,p)}),g=await(0,M.getMac)();return n.createHash("sha256").update(g,"utf8").digest("hex")}catch(n){v.onUnexpectedError(n);return}}}),define(X[19],J([0,1,18,27,8,9,3,30,28,64,15,7]),function(H,e,v,A,L,b,M,i,S,y,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function p(z,C=E.UNLINK){if((0,i.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return C===E.UNLINK?w(z):d(z)}e.rimraf=p;async function d(z){try{const C=(0,L.join)((0,A.tmpdir)(),(0,S.generateUuid)());try{await v.promises.rename(z,C)}catch(j){return w(z)}w(C).catch(j=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function w(z){return v.promises.rmdir(z,{recursive:!0,maxRetries:3})}function P(z){if((0,i.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(z,{recursive:!0})}e.rimrafSync=P;async function I(z,C){return o(await(C?a(z):v.promises.readdir(z)))}e.readdir=I;async function a(z){try{return await v.promises.readdir(z,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const C=[],j=await I(z);for(const N of j){let T=!1,R=!1,W=!1;try{const k=await v.promises.lstat((0,L.join)(z,N));T=k.isFile(),R=k.isDirectory(),W=k.isSymbolicLink()}catch(k){console.warn("[node.js fs] unexpected error from lstat after readdir: ",k)}C.push({name:N,isFile:()=>T,isDirectory:()=>R,isSymbolicLink:()=>W})}return C}function l(z){return o(v.readdirSync(z))}e.readdirSync=l;function o(z){return z.map(C=>typeof C=="string"?M.isMacintosh?(0,y.normalizeNFC)(C):C:(C.name=M.isMacintosh?(0,y.normalizeNFC)(C.name):C.name,C))}async function c(z){const C=await I(z),j=[];for(const N of C)await r.existsDirectory((0,L.join)(z,N))&&j.push(N);return j}e.readDirsInDir=c;function t(z,C=1e3){return new Promise(j=>{let N=!1;const T=setInterval(()=>{N||(N=!0,v.access(z,R=>{N=!1,R&&(clearInterval(T),j(void 0))}))},C)})}e.whenDeleted=t;var r;(function(z){async function C(T){let R;try{if(R=await v.promises.lstat(T),!R.isSymbolicLink())return{stat:R}}catch(W){}try{return{stat:await v.promises.stat(T),symbolicLink:(R==null?void 0:R.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(M.isWindows&&W.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(k){if(k.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw k}throw W}}z.stat=C;async function j(T){try{const{stat:R,symbolicLink:W}=await z.stat(T);return R.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsFile=j;async function N(T){try{const{stat:R,symbolicLink:W}=await z.stat(T);return R.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}z.existsDirectory=N})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new b.ResourceQueue;function u(z,C,j){return s.queueFor(g.URI.file(z),n.extUriBiasedIgnorePathCase).queue(()=>{const N=D(j);return new Promise((T,R)=>f(z,C,N,W=>W?R(W):T()))})}e.writeFile=u;let h=!0;function f(z,C,j,N){if(!h)return v.writeFile(z,C,{mode:j.mode,flag:j.flag},N);v.open(z,j.flag,j.mode,(T,R)=>{if(T)return N(T);v.writeFile(R,C,W=>{if(W)return v.close(R,()=>N(W));v.fdatasync(R,k=>(k&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",k),h=!1),v.close(R,F=>N(F))))})})}function m(z,C,j){const N=D(j);if(!h)return v.writeFileSync(z,C,{mode:N.mode,flag:N.flag});const T=v.openSync(z,N.flag,N.mode);try{v.writeFileSync(T,C);try{v.fdatasyncSync(T)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),h=!1}}finally{v.closeSync(T)}}e.writeFileSync=m;function D(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function _(z,C){if(z!==C){async function j(N){try{const T=await v.promises.lstat(N);if(T.isDirectory()||T.isSymbolicLink())return;const R=await v.promises.open(N,"a");try{await R.utimes(T.atime,new Date)}finally{await R.close()}}catch(T){}}try{await v.promises.rename(z,C),await j(C)}catch(N){if(z.toLowerCase()!==C.toLowerCase()&&N.code==="EXDEV"||z.endsWith("."))await U(z,C,{preserveSymlinks:!1}),await p(z,E.MOVE),await j(C);else throw N}}}e.move=_;async function U(z,C,j){return Q(z,C,{root:{source:z,target:C},options:j,handledSourcePaths:new Set})}e.copy=U;const q=511;async function Q(z,C,j){if(!j.handledSourcePaths.has(z)){j.handledSourcePaths.add(z);const{stat:N,symbolicLink:T}=await r.stat(z);if(T){if(j.options.preserveSymlinks)try{return await O(z,C,j)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(T.dangling)return}return N.isDirectory()?ie(z,C,N.mode&q,j):ae(z,C,N.mode&q)}}async function ie(z,C,j,N){await v.promises.mkdir(C,{recursive:!0,mode:j});const T=await I(z);for(const R of T)await Q((0,L.join)(z,R),(0,L.join)(C,R),N)}async function ae(z,C,j){await v.promises.copyFile(z,C),await v.promises.chmod(C,j)}async function O(z,C,j){let N=await v.promises.readlink(z);(0,i.isEqualOrParent)(N,j.root.source,!M.isLinux)&&(N=(0,L.join)(j.root.target,N.substr(j.root.source.length+1))),await v.promises.symlink(N,C)}async function $(z){try{return await v.promises.access(z),!0}catch(C){return!1}}e.exists=$}),define(X[111],J([0,1,18,112,22,8,19]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(g){const E=(0,b.dirname)(g);if(g===E)return g;const p=((0,b.basename)(g)||g).toLowerCase();try{const w=(0,M.readdirSync)(E).filter(P=>P.toLowerCase()===p);if(w.length===1){const P=i(E);if(P)return(0,b.join)(P,w[0])}else if(w.length>1){const P=w.indexOf(p);if(P>=0){const I=i(E);if(I)return(0,b.join)(I,w[P])}}}catch(d){}return null}e.realcaseSync=i;async function S(g){try{return await(0,A.promisify)(v.realpath)(g)}catch(E){const p=n(g);return await v.promises.access(p,v.constants.R_OK),p}}e.realpath=S;function y(g){try{return v.realpathSync(g)}catch(E){const p=n(g);return v.accessSync(p,v.constants.R_OK),p}}e.realpathSync=y;function n(g){return(0,L.rtrim)((0,b.normalize)(g),b.sep)}}),define(X[113],J([0,1,59]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function A(){const S=1025;return S+Math.floor((65535-S)*Math.random())}e.randomPort=A;function L(S,y,n){let g=!1;return new Promise(E=>{const p=setTimeout(()=>{if(!g)return g=!0,E(0)},n);b(S,y,d=>{if(!g)return g=!0,clearTimeout(p),E(d)})})}e.findFreePort=L;function b(S,y,n){if(y===0)return n(0);const g=new v.Socket;g.once("connect",()=>(i(g),b(S+1,y-1,n))),g.once("data",()=>{}),g.once("error",E=>(i(g),E.code!=="ECONNREFUSED"?b(S+1,y-1,n):n(S))),g.connect(S,"127.0.0.1")}function M(S,y,n){let g=!1,E,p=1;const d=v.createServer({pauseOnConnect:!0});function w(P,I){g||(g=!0,d.removeAllListeners(),d.close(),E&&clearTimeout(E),I(P))}return new Promise(P=>{E=setTimeout(()=>{w(0,P)},n),d.on("listening",()=>{w(S,P)}),d.on("error",I=>{I&&(I.code==="EADDRINUSE"||I.code==="EACCES")&&p<y?(S++,p++,d.listen(S,"127.0.0.1")):w(0,P)}),d.on("close",()=>{w(0,P)}),d.listen(S,"127.0.0.1")})}e.findFreePortFaster=M;function i(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(y){console.error(y)}}});var Fe=this&&this.__await||function(H){return this instanceof Fe?(this.v=H,this):new Fe(H)},ft=this&&this.__asyncGenerator||function(H,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=v.apply(H,e||[]),L,b=[];return L={},M("next"),M("throw"),M("return"),L[Symbol.asyncIterator]=function(){return this},L;function M(E){A[E]&&(L[E]=function(p){return new Promise(function(d,w){b.push([E,p,d,w])>1||i(E,p)})})}function i(E,p){try{S(A[E](p))}catch(d){g(b[0][3],d)}}function S(E){E.value instanceof Fe?Promise.resolve(E.value.v).then(y,n):g(b[0][2],E)}function y(E){i("next",E)}function n(E){i("throw",E)}function g(E,p){E(p),b.shift(),b.length&&i(b[0][0],b[0][1])}},gt=this&&this.__asyncValues||function(H){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=H[Symbol.asyncIterator],v;return e?e.call(H):(H=typeof __values=="function"?__values(H):H[Symbol.iterator](),v={},A("next"),A("throw"),A("return"),v[Symbol.asyncIterator]=function(){return this},v);function A(b){v[b]=H[b]&&function(M){return new Promise(function(i,S){M=H[b](M),L(i,S,M.done,M.value)})}}function L(b,M,i,S){Promise.resolve(S).then(function(y){b({value:y,done:i})},M)}};define(X[114],J([0,1,19,27,8]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const b=/^\d+$/,M=/^Microsoft.PowerShell_.*/,i=/^Microsoft.PowerShellPreview_.*/;var S;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(S||(S={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class g{constructor(c,t,r){this.exePath=c,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?y===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:c=!1}={}){const t=E({useAlternateBitness:o});if(!t)return null;const r=L.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let s=-1,u=null;for(const m of await v.readdir(r)){let D=-1;if(c){const U=m.indexOf("-");if(U<0)continue;const q=m.substring(0,U);if(!b.test(q)||m.substring(U+1)!=="preview")continue;D=parseInt(q,10)}else{if(!b.test(m))continue;D=parseInt(m,10)}if(!(D<=s)){const _=L.join(r,m,"pwsh.exe");!await v.SymlinkSupport.existsFile(_)||(u=_,s=D)}}if(!u)return null;const h=t.includes("x86")?" (x86)":"",f=c?" Preview":"";return new g(u,`PowerShell${f}${h}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:i,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await v.readdir(c))if(t.test(s)){const u=L.join(c,s,"pwsh.exe");return new g(u,r)}return null}function w(){const o=L.join(A.homedir(),".dotnet","tools","pwsh.exe");return new g(o,".NET Core PowerShell Global Tool")}function P(){const o=L.join(process.env.windir,y===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(o,"Windows PowerShell",!0)}function I(){return ft(this,arguments,function*(){let c=yield Fe(p());c&&(yield yield Fe(c)),c=yield Fe(p({useAlternateBitness:!0})),c&&(yield yield Fe(c)),c=yield Fe(d()),c&&(yield yield Fe(c)),c=w(),c&&(yield yield Fe(c)),c=yield Fe(p({findPreview:!0})),c&&(yield yield Fe(c)),c=yield Fe(d({findPreview:!0})),c&&(yield yield Fe(c)),c=yield Fe(p({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield Fe(c)),c=P(),c&&(yield yield Fe(c))})}function a(){return ft(this,arguments,function*(){var c,t;try{for(var r=gt(I()),s;s=yield Fe(r.next()),!s.done;){const u=s.value;(yield Fe(u.exists()))&&(yield yield Fe(u))}}catch(u){c={error:u}}finally{try{s&&!s.done&&(t=r.return)&&(yield Fe(t.call(r)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=a;async function l(){var o,c;try{for(var t=gt(a()),r;r=await t.next(),!r.done;)return r.value}catch(s){o={error:s}}finally{try{r&&!r.done&&(c=t.return)&&await c.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=l}),define(X[82],J([0,1,45,10]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(M){return new Promise((i,S)=>{let y;const n=new Map;function g(d,w,P,I,a){const l=n.get(w);if(d===M||l){const o={name:E(P),cmd:P,pid:d,ppid:w,load:I,mem:a};n.set(d,o),d===M&&(y=o),l&&(l.children||(l.children=[]),l.children.push(o),l.children.length>1&&(l.children=l.children.sort((c,t)=>c.pid-t.pid)))}}function E(d){const w=/--disable-blink-features=Auxclick/,P=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,a=/\\pipe\\winpty-control/,l=/conhost\.exe/,o=/--type=([a-zA-Z-]+)/;if(P.exec(d))return"watcherService ";if(I.exec(d))return"electron-crash-reporter";if(a.exec(d))return"winpty-process";if(l.exec(d))return"console-window-host (Windows internal process)";let c=o.exec(d);if(c&&c.length===2)return c[1]==="renderer"?w.exec(d)?"shared-process":"window":c[1];const t=/[a-zA-Z-]+\.js/g;let r="";do c=t.exec(d),c&&(r+=c+" ");while(c);return r&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${r}`:d}if(process.platform==="win32"){const d=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,P)=>{H(["windows-process-tree"],w,P)}).then(w=>{w.getProcessList(M,P=>{w.getProcessCpuUsage(P,I=>{const a=new Map;I.forEach(l=>{const o=d(l.commandLine||"");a.set(l.pid,{name:E(o),cmd:o,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),y=a.get(M),y?(a.forEach(l=>{const o=a.get(l.ppid);o&&(o.children||(o.children=[]),o.children.push(l))}),a.forEach(l=>{l.children&&(l.children=l.children.sort((o,c)=>o.pid-c.pid))}),i(y)):S(new Error(`Root process ${M} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{function p(){let d=[y];const w=[];for(;d.length;){const I=d.shift();I&&(w.push(I.pid),I.children&&(d=d.concat(I.children)))}let P=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",H).fsPath);P+=" "+w.join(" "),(0,v.exec)(P,{},(I,a,l)=>{if(I||l)S(I||new Error(l.toString()));else{const o=a.toString().split(`
`);for(let c=0;c<w.length;c++){const t=n.get(w[c]);t.load=parseFloat(o[c])}if(!y){S(new Error(`Root process ${M} not found`));return}i(y)}})}(0,v.exec)("which ps",{},(d,w,P)=>{if(d||P)if(process.platform!=="linux")S(d||new Error(P.toString()));else{const I=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",H).fsPath);(0,v.exec)(I,{},(a,l,o)=>{a||o?S(a||new Error(o.toString())):(b(l,g),p())})}else{const I=w.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${I} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,o,c)=>{l||c&&!c.includes("screen size is bogus")?S(l||new Error(c.toString())):(b(o,g),process.platform==="linux"?p():y?i(y):S(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=L;function b(M,i){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=M.toString().split(`
`);for(const n of y){const g=S.exec(n.trim());g&&g.length===6&&i(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(X[115],J([0,1,8,18,3,64,2,19]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(g,E,p){return n({path:g,isDirectory:!1},E,p)}e.watchFile=S;function y(g,E,p){return n({path:g,isDirectory:!0},E,p)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function n(g,E,p){const d=(0,v.basename)(g.path),w=new Map;let P=!1,I=[(0,M.toDisposable)(()=>{w.forEach(a=>(0,M.dispose)(a)),w.clear()})];try{const a=(0,A.watch)(g.path);I.push((0,M.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const l=new Set;g.isDirectory&&(0,i.readdir)(g.path).then(o=>o.forEach(c=>l.add(c))),a.on("error",(o,c)=>{P||p(`Failed to watch ${g.path} for changes using fs.watch() (${o}, ${c})`)}),a.on("change",(o,c)=>{if(!P){let t="";if(c&&(t=c.toString(),L.isMacintosh&&(t=(0,b.normalizeNFC)(t))),!(!t||o!=="change"&&o!=="rename")){const r=g.isDirectory?(0,v.join)(g.path,t):g.path;if(g.isDirectory)if(o==="rename"){const s=w.get(r);s&&(0,M.dispose)(s);const u=setTimeout(async()=>{w.delete(r);const h=await(0,i.exists)(r);if(!P){let f;h?l.has(t)?f="changed":(f="added",l.add(t)):(l.delete(t),f="deleted"),E(f,r)}},e.CHANGE_BUFFER_DELAY);w.set(r,(0,M.toDisposable)(()=>clearTimeout(u)))}else{let s;l.has(t)?s="changed":(s="added",l.add(t)),E(s,r)}else if(o==="rename"||t!==d){const s=setTimeout(async()=>{const u=await(0,i.exists)(r);P||(u?(E("changed",r),I=[n(g,E,p)]):E("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(I),I=[(0,M.toDisposable)(()=>clearTimeout(s))]}else E("changed",r)}}})}catch(a){(0,i.exists)(g.path).then(l=>{l&&!P&&p(`Failed to watch ${g.path} for changes using fs.watch() (${a.toString()})`)})}return(0,M.toDisposable)(()=>{P=!0,I=(0,M.dispose)(I)})}}),define(X[116],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[117],J([0,1,13,116,12]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){v.ipcMain.on(A.CONTEXT_MENU_CHANNEL,(i,S,y,n,g)=>{const E=M(i,n,y);E.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(i.sender)),x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{E&&i.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,S)}})})}e.registerContextMenuListener=b;function M(i,S,y){const n=new v.Menu;return y.forEach(g=>{let E;g.type==="separator"?E=new v.MenuItem({type:g.type}):Array.isArray(g.submenu)?E=new v.MenuItem({submenu:M(i,S,g.submenu),label:g.label}):E=new v.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(p,d,w)=>i.sender.send(S,g.id,w)}),n.append(E)}),n}}),define(X[33],J([0,1,5,2,9,25,17,23,35,12,107,22]),function(H,e,v,A,L,b,M,i,S,y,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function p(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function w(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(P||(P={}));class I{constructor(T){this.buffer=T,this.pos=0}read(T){const R=this.buffer.slice(this.pos,this.pos+T);return this.pos+=R.byteLength,R}}class a{constructor(){this.buffers=[]}get buffer(){return i.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var l;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(l||(l={}));function o(N){const T=i.VSBuffer.alloc(4);return T.writeUInt32BE(N,0),T}function c(N){return N.read(4).readUInt32BE(0)}function t(N){const T=i.VSBuffer.alloc(1);return T.writeUInt8(N,0),T}const r={Undefined:t(l.Undefined),String:t(l.String),Buffer:t(l.Buffer),VSBuffer:t(l.VSBuffer),Array:t(l.Array),Object:t(l.Object)},s=typeof Buffer!="undefined";function u(N,T){if(typeof T=="undefined")N.write(r.Undefined);else if(typeof T=="string"){const R=i.VSBuffer.fromString(T);N.write(r.String),N.write(o(R.byteLength)),N.write(R)}else if(s&&Buffer.isBuffer(T)){const R=i.VSBuffer.wrap(T);N.write(r.Buffer),N.write(o(R.byteLength)),N.write(R)}else if(T instanceof i.VSBuffer)N.write(r.VSBuffer),N.write(o(T.byteLength)),N.write(T);else if(Array.isArray(T)){N.write(r.Array),N.write(o(T.length));for(const R of T)u(N,R)}else{const R=i.VSBuffer.fromString(JSON.stringify(T));N.write(r.Object),N.write(o(R.byteLength)),N.write(R)}}function h(N){switch(N.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return N.read(c(N)).toString();case l.Buffer:return N.read(c(N)).buffer;case l.VSBuffer:return N.read(c(N));case l.Array:{const R=c(N),W=[];for(let k=0;k<R;k++)W.push(h(N));return W}case l.Object:return JSON.parse(N.read(c(N)).toString())}}class f{constructor(T,R,W=null,k=1e3){this.protocol=T,this.ctx=R,this.logger=W,this.timeoutDelay=k,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(T,R){this.channels.set(T,R),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const R=this.send([T.type]);this.logger&&this.logger.logOutgoing(R,0,1,w(T.type));return}case 201:case 202:case 204:case 203:{const R=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(R,T.id,1,w(T.type),T.data);return}}}send(T,R=void 0){const W=new a;return u(W,T),u(W,R),this.sendBuffer(W.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(R){return 0}}onRawMessage(T){const R=new I(T),W=h(R),k=h(R),F=W[0];switch(F){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}: ${W[2]}.${W[3]}`,k),this.onPromise({type:F,id:W[1],channelName:W[2],name:W[3],arg:k});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}: ${W[2]}.${W[3]}`,k),this.onEventListen({type:F,id:W[1],channelName:W[2],name:W[3],arg:k});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}`),this.disposeActiveRequest({type:F,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],1,`${p(F)}`),this.disposeActiveRequest({type:F,id:W[1]})}}onPromise(T){const R=this.channels.get(T.channelName);if(!R){this.collectPendingRequest(T);return}const W=new b.CancellationTokenSource;let k;try{k=R.call(this.ctx,T.name,T.arg,W.token)}catch(V){k=Promise.reject(V)}const F=T.id;k.then(V=>{this.sendResponse({id:F,data:V,type:201}),this.activeRequests.delete(T.id)},V=>{V instanceof Error?this.sendResponse({id:F,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:F,data:V,type:203}),this.activeRequests.delete(T.id)});const B=(0,A.toDisposable)(()=>W.cancel());this.activeRequests.set(T.id,B)}onEventListen(T){const R=this.channels.get(T.channelName);if(!R){this.collectPendingRequest(T);return}const W=T.id,F=R.listen(this.ctx,T.name,T.arg)(B=>this.sendResponse({id:W,data:B,type:204}));this.activeRequests.set(T.id,F)}disposeActiveRequest(T){const R=this.activeRequests.get(T.id);R&&(R.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let R=this.pendingRequests.get(T.channelName);R||(R=[],this.pendingRequests.set(T.channelName,R));const W=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);R.push({request:T,timeoutTimer:W})}flushPendingRequests(T){const R=this.pendingRequests.get(T);if(R){for(const W of R)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var m;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(T,R=null){this.protocol=T,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=R}getChannel(T){const R=this;return{call(W,k,F){return R.isDisposed?Promise.reject(M.canceled()):R.requestPromise(T,W,k,F)},listen(W,k){return R.isDisposed?Promise.reject(M.canceled()):R.requestEvent(T,W,k)}}}requestPromise(T,R,W,k=b.CancellationToken.None){const F=this.lastRequestId++,V={id:F,type:100,channelName:T,name:R,arg:W};if(k.isCancellationRequested)return Promise.reject(M.canceled());let G;return new Promise((Z,re)=>{if(k.isCancellationRequested)return re(M.canceled());const se=()=>{const ye=ge=>{switch(ge.type){case 201:this.handlers.delete(F),Z(ge.data);break;case 202:this.handlers.delete(F);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,re(Ee);break;case 203:this.handlers.delete(F),re(ge.data);break}};this.handlers.set(F,ye),this.sendRequest(V)};let x=null;this.state===P.Idle?se():(x=(0,L.createCancelablePromise)(ye=>this.whenInitialized()),x.then(()=>{x=null,se()}));const ne=()=>{x?(x.cancel(),x=null):this.sendRequest({id:F,type:101}),re(M.canceled())},ue=k.onCancellationRequested(ne);G=(0,A.combinedDisposable)((0,A.toDisposable)(ne),ue),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(T,R,W){const k=this.lastRequestId++,B={id:k,type:102,channelName:T,name:R,arg:W};let V=null;const G=new v.Emitter({onFirstListenerAdd:()=>{V=(0,L.createCancelablePromise)(Z=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(G),this.sendRequest(B)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(G),this.sendRequest({id:k,type:103}))}}),Y=Z=>G.fire(Z.data);return this.handlers.set(k,Y),G.event}sendRequest(T){switch(T.type){case 100:case 102:{const R=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(R,T.id,0,`${p(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const R=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(R,T.id,0,p(T.type));return}}}send(T,R=void 0){const W=new a;return u(W,T),u(W,R),this.sendBuffer(W.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(R){return 0}}onBuffer(T){const R=new I(T),W=h(R),k=h(R),F=W[0];switch(F){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,w(F)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,W[1],0,w(F),k),this.onResponse({type:W[0],id:W[1],data:k})}}onResponse(T){if(T.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const R=this.handlers.get(T.id);R&&R(T)}whenInitialized(){return this.state===P.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelClient=D;class _{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:R,onDidClientDisconnect:W})=>{v.Event.once(R.onMessage)(F=>{const B=new I(F),V=h(B),G=new f(R,V),Y=new D(R);this.channels.forEach((re,se)=>G.registerChannel(se,re));const Z={channelServer:G,channelClient:Y,ctx:V};this._connections.add(Z),this._onDidAddConnection.fire(Z),W(()=>{G.dispose(),Y.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const T=[];return this._connections.forEach(R=>T.push(R)),T}getChannel(T,R){const W=this;return{call(k,F,B){let V;if((0,y.isFunction)(R)){let Y=(0,S.getRandomElement)(W.connections.filter(R));V=Y?Promise.resolve(Y):v.Event.toPromise(v.Event.filter(W.onDidAddConnection,R))}else V=R.routeCall(W,k,F);const G=V.then(Y=>Y.channelClient.getChannel(T));return q(G).call(k,F,B)},listen(k,F){if((0,y.isFunction)(R))return W.getMulticastEvent(T,R,k,F);const B=R.routeEvent(W,k,F).then(V=>V.channelClient.getChannel(T));return q(B).listen(k,F)}}}getMulticastEvent(T,R,W,k){const F=this;let B=new A.DisposableStore;const V=new v.Emitter({onFirstListenerAdd:()=>{B=new A.DisposableStore;const G=new v.EventMultiplexer,Y=new Map,Z=se=>{const ne=se.channelClient.getChannel(T).listen(W,k),ue=G.add(ne);Y.set(se,ue)},re=se=>{const x=Y.get(se);!x||(x.dispose(),Y.delete(se))};F.connections.filter(R).forEach(Z),v.Event.filter(F.onDidAddConnection,R)(Z,void 0,B),F.onDidRemoveConnection(re,void 0,B),G.event(V.fire,V,B),B.add(G)},onLastListenerRemove:()=>{B.dispose()}});return V.event}registerChannel(T,R){this.channels.set(T,R),this._connections.forEach(W=>{W.channelServer.registerChannel(T,R)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class U{constructor(T,R,W=null){const k=new a;u(k,R),T.send(k.buffer),this.channelClient=new D(T,W),this.channelServer=new f(T,R,W)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,R){this.channelServer.registerChannel(T,R)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function q(N){return{call(T,R,W){return N.then(k=>k.call(T,R,W))},listen(T,R){const W=new v.Relay;return N.then(k=>W.input=k.listen(T,R)),W.event}}}e.getDelayedChannel=q;function Q(N){let T=!1;return{call(R,W,k){return T?N.call(R,W,k):(0,L.timeout)(0).then(()=>T=!0).then(()=>N.call(R,W,k))},listen(R,W){if(T)return N.listen(R,W);const k=new v.Relay;return(0,L.timeout)(0).then(()=>T=!0).then(()=>k.input=N.listen(R,W)),k.event}}}e.getNextTickChannel=Q;class ie{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const R of T.connections)if(await Promise.resolve(this.fn(R.ctx)))return Promise.resolve(R);return await v.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=ie;var ae;(function(N){function T(k,F){const B=k,V=F&&F.disableMarshalling,G=new Map;for(const Y in B)W(Y)&&G.set(Y,v.Event.buffer(B[Y],!0));return new class{listen(Y,Z){const re=G.get(Z);if(re)return re;throw new Error(`Event not found: ${Z}`)}call(Y,Z,re){const se=B[Z];if(typeof se=="function"){if(!V&&Array.isArray(re))for(let x=0;x<re.length;x++)re[x]=(0,n.revive)(re[x]);return se.apply(B,re)}throw new Error(`Method not found: ${Z}`)}}}N.fromService=T;function R(k,F){const B=F&&F.disableMarshalling;return new Proxy({},{get(V,G){var Y;if(typeof G=="string")return((Y=F==null?void 0:F.properties)===null||Y===void 0?void 0:Y.has(G))?F.properties.get(G):W(G)?k.listen(G):async function(...Z){let re;F&&!(0,y.isUndefinedOrNull)(F.context)?re=[F.context,...Z]:re=Z;const se=await k.call(G,re);return B?se:(0,n.revive)(se)};throw new Error(`Property not found: ${String(G)}`)}})}N.toService=R;function W(k){return k[0]==="o"&&k[1]==="n"&&g.isUpperAsciiLetter(k.charCodeAt(2))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let T=N.toString();if(T!=="[object Object]")return T}return N}function z(N){return Array.isArray(N)?N.map($):$(N)}function C(N,T,R,W,k,F,B){B=z(B);const V=O[k],G=V[W%V.length];let Y=[`%c[${N}]%c[${String(T).padStart(7," ")}]%c[len: ${String(R).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(F)?(Y=Y.concat(B),Y.push(")")):Y.push(B),console.log.apply(console,Y)}e.logWithColors=C;class j{constructor(T,R){this._outgoingPrefix=T,this._incomingPrefix=R,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,R,W,k,F){this._totalOutgoing+=T,C(this._outgoingPrefix,this._totalOutgoing,T,R,W,k,F)}logIncoming(T,R,W,k,F){this._totalIncoming+=T,C(this._incomingPrefix,this._totalIncoming,T,R,W,k,F)}}e.IPCLogger=j}),define(X[118],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(L,b){this.sender=L,this.onMessage=b}send(L){try{this.sender.send("vscode:message",L.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(X[119],J([0,1,5,33,23]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(S){this.port=S,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",y=>L.VSBuffer.wrap(y.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class M extends A.IPCClient{constructor(S,y){const n=new b(S);super(n,y);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=M}),define(X[83],J([0,1,5,33,2,23,3,32]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let S=null;function y(){return S||(S=b.VSBuffer.alloc(0)),S}class n{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,u){if(s===0)return y();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const D=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=s),D}if(this._chunks[0].byteLength>s){const D=this._chunks[0].slice(0,s);return u&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),D}let h=b.VSBuffer.alloc(s),f=0,m=0;for(;s>0;){const D=this._chunks[m];if(D.byteLength>s){const _=D.slice(0,s);h.set(_,f),f+=s,u&&(this._chunks[m]=D.slice(s),this._totalLength-=s),s-=s}else h.set(D,f),f+=D.byteLength,u?(this._chunks.shift(),this._totalLength-=D.byteLength):m++,s-=D.byteLength}return h}}e.ChunkStream=n;var g;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,u,h,f){this.type=s,this.id=u,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(s){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new n,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(h,f,m,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=b.VSBuffer.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this._writeSoon(u,s.data)}}_bufferAdd(s,u){const h=this._totalLength===0;return this._data.push(s,u),this._totalLength+=s.byteLength+u.byteLength,h}_bufferTake(){const s=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,u){this._bufferAdd(s,u)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends L.Disposable{constructor(s){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=P;class I extends A.IPCClient{constructor(s,u,h=null){super(s,u,h);this.protocol=s}static fromSocket(s,u){return new I(new P(s),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=I;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,i.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],u=0,h=this._first;for(;h;)s[u++]=h.data,h=h.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const u=new l(s);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let u=0;u<c._HISTORY_LENGTH;u++)this.lastRuns[u]=s-1e3*u;setInterval(()=>{for(let u=c._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),u=(1+c._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<c._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=u&&h++;return 1-h/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(s,u=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,y());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const u=new p(4,0,0,y());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,u){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let u=0,h=s.length;u<h;u++)this._socketWriter.write(s[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,y())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const u=this._outgoingUnackMsg.toArray();for(let h=0,f=u.length;h<f;h++)this._socketWriter.write(u[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new p(1,u,this._incomingAckId,s);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(s){const u=new p(2,0,0,s);this._socketWriter.write(u)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),u=Date.now()-s.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,y());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(X[120],J([0,1,13,5,33,118,2,23]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function S(n,g){const E=A.Event.fromNodeEventEmitter(v.ipcMain,g,(d,w)=>({event:d,message:w})),p=A.Event.filter(E,({event:d})=>d.sender.id===n);return A.Event.map(p,({message:d})=>d&&i.VSBuffer.wrap(d))}class y extends L.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const g=A.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:E})=>E);return A.Event.map(g,E=>{const p=E.id,d=y.Clients.get(p);d&&d.dispose();const w=new A.Emitter;y.Clients.set(p,(0,M.toDisposable)(()=>w.fire()));const P=S(p,"vscode:message"),I=A.Event.any(A.Event.signal(S(p,"vscode:disconnect")),w.event);return{protocol:new b.Protocol(E,P),onDidClientDisconnect:I}})}}e.Server=y,y.Clients=new Map}),define(X[84],J([0,1,13,5,28,119]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends b.Client{constructor(y,n){super({addEventListener:(g,E)=>y.addListener(g,E),removeEventListener:(g,E)=>y.removeListener(g,E),postMessage:g=>y.postMessage(g),start:()=>y.start(),close:()=>y.close()},n)}}e.Client=M;async function i(S){if(S.isDestroyed()||S.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=(0,L.generateUuid)();S.webContents.send("vscode:createMessageChannel",y);const n=A.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(E,p)=>({nonce:p,port:E.ports[0]})),{port:g}=await A.Event.toPromise(A.Event.once(A.Event.filter(n,E=>E.nonce===y)));return g}e.connect=i}),define(X[85],J([0,1,2,5,9,12]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var M;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));var i;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(i||(i={}));class S extends v.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=i.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var E,p;(E=g.changed)===null||E===void 0||E.forEach((d,w)=>this.accept(w,d)),(p=g.deleted)===null||p===void 0||p.forEach(d=>this.accept(d,void 0))}accept(g,E){if(this.state!==i.Closed){let p=!1;(0,b.isUndefinedOrNull)(E)?p=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),p=!0),p&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===i.None&&(this.state=i.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const p=this.cache.get(g);return(0,b.isUndefinedOrNull)(p)?E:p}getBoolean(g,E){const p=this.get(g);return(0,b.isUndefinedOrNull)(p)?E:p==="true"}getNumber(g,E){const p=this.get(g);return(0,b.isUndefinedOrNull)(p)?E:parseInt(p,10)}async set(g,E){if(this.state!==i.Closed){if((0,b.isUndefinedOrNull)(E))return this.delete(g);const p=String(E);if(this.cache.get(g)!==p)return this.cache.set(g,p),this.pendingInserts.set(g,p),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==i.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=i.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,p)=>this.items.set(p,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=y}),define(X[121],J([0,1,18,5,9,36,8,19]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class S{constructor(g,E=Object.create(null)){this.path=g,this.options=E,this.name=(0,M.basename)(this.path),this.logger=new y(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return A.Event.None}async getItems(){const g=await this.whenConnected,E=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(d=>E.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(g){const E=await this.whenConnected;return this.doUpdateItems(E,g)}doUpdateItems(g,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,b.mapToString)(E.insert):"0"}), delete(${E.delete?(0,b.setToString)(E.delete):"0"})`),this.transaction(g,()=>{const p=E.insert,d=E.delete;if(p&&p.size>0){const w=[];w.push([]);let P=0;p.forEach((I,a)=>{let l=w[P];l.length>S.MAX_HOST_PARAMETERS&&(P++,l=[],w.push(l)),l.push(a,I)}),w.forEach(I=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,a=>a.run(I),()=>{const a=[];let l=0;return p.forEach((o,c)=>{a.push(c),l+=o.length}),`Keys: ${a.join(", ")} Length: ${l}`})})}if(d&&d.size){const w=[];w.push([]);let P=0;d.forEach(I=>{let a=w[P];a.length>S.MAX_HOST_PARAMETERS&&(P++,a=[],w.push(a)),a.push(I)}),w.forEach(I=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,a=>a.run(I),()=>{const a=[];return d.forEach(l=>{a.push(l)}),`Keys: ${a.join(", ")}`})})}})}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,g)}doClose(g,E){return new Promise((p,d)=>{g.db.close(w=>(w&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${w}`),this.path===S.IN_MEMORY_PATH?p():!g.isErroneous&&!g.isInMemory?this.backup().then(p,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),p())):typeof E=="function"?v.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const I=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:E()}).then(()=>I(),a=>(I(),Promise.reject(a)))})).then(p,d):d(w||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return(0,i.copy)(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const E=await this.whenConnected,p=await this.get(E,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?p.integrity_check:p.quick_check;return E.isErroneous?`${d} (last error: ${E.lastError})`:E.isInMemory?`${d} (in-memory!)`:d}async connect(g,E=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${E})`);try{return await this.doConnect(g)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&E)return await(0,L.timeout)(S.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await v.promises.unlink(g);try{await v.promises.rename(this.toBackupPath(g),g)}catch(d){}return await this.doConnect(g)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(S.IN_MEMORY_PATH)}}}handleSQLiteError(g,E){g.isErroneous=!0,g.lastError=E,this.logger.error(E)}doConnect(g){return new Promise((E,p)=>{new Promise((d,w)=>{H(["vscode-sqlite3"],d,w)}).then(d=>{const w={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(g,P=>P?w.db?w.db.close(()=>p(P)):p(P):this.exec(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(w),I=>w.db.close(()=>p(I)))),isInMemory:g===S.IN_MEMORY_PATH};w.db.on("error",P=>this.handleSQLiteError(w,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&w.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},p)})}exec(g,E){return new Promise((p,d)=>{g.db.exec(E,w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${w}`),d(w)):p())})}get(g,E){return new Promise((p,d)=>{g.db.get(E,(w,P)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${w}`),d(w)):p(P))})}all(g,E){return new Promise((p,d)=>{g.db.all(E,(w,P)=>w?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${w}`),d(w)):p(P))})}transaction(g,E){return new Promise((p,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),E(),g.db.run("END TRANSACTION",w=>w?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${w}`),d(w)):p())})})}prepare(g,E,p,d){const w=g.db.prepare(E),P=I=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${I} (${E}). Details: ${d()}`)};w.on("error",P),p(w),w.finalize(I=>{I&&P(I),w.removeListener("error",P)})}}e.SQLiteStorageDatabase=S,S.IN_MEMORY_PATH=":memory:",S.BUSY_OPEN_TIMEOUT=2e3,S.MAX_HOST_PARAMETERS=256;class y{constructor(g){g&&typeof g.logTrace=="function"&&process.env[y.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace&&this.logTrace(g)}error(g){this.logError&&this.logError(g)}}y.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[122],J([14,11]),function(H,e){return H.create("vs/base/common/date",e)}),define(X[123],J([0,1,122]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,L=A*60,b=L*24,M=b*7,i=b*30,S=b*365;function y(g,E){typeof g!="number"&&(g=g.getTime());const p=Math.round((new Date().getTime()-g)/1e3);if(p<-30)return(0,v.localize)(0,null,y(new Date().getTime()+p*1e3,!1));if(p<30)return(0,v.localize)(1,null);let d;return p<A?(d=p,E?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):p<L?(d=Math.floor(p/A),E?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):p<b?(d=Math.floor(p/L),E?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):p<M?(d=Math.floor(p/b),E?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):p<i?(d=Math.floor(p/M),E?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):p<S?(d=Math.floor(p/i),E?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(p/S),E?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=y;function n(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(X[124],J([14,11]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(X[66],J([0,1,124,12,35]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(y,n){return n&&(y.stack||y.stacktrace)?v.localize(0,null,i(y),M(y.stack)||M(y.stacktrace)):i(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function i(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?v.localize(1,null,y.message):y.message||v.localize(2,null)}function S(y=null,n=!1){if(!y)return v.localize(3,null);if(Array.isArray(y)){const g=L.coalesce(y),E=S(g[0],n);return g.length>1?v.localize(4,null,E,g.length):E}if(A.isString(y))return y;if(y.detail){const g=y.detail;if(g.error)return b(g.error,n);if(g.exception)return b(g.exception,n)}return y.stack?b(y,n):y.message?y.message:v.localize(5,null)}e.toErrorMessage=S}),define(X[125],J([14,11]),function(H,e){return H.create("vs/base/common/keybindingLabels",e)}),define(X[126],J([0,1,125]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class A{constructor(M,i,S=i){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=i,this.modifierLabels[3]=S}toLabel(M,i,S){if(i.length===0)return null;const y=[];for(let n=0,g=i.length;n<g;n++){const E=i[n],p=S(E);if(p===null)return null;y[n]=L(E,p,this.modifierLabels[M])}return y.join(" ")}}e.ModifierLabelProvider=A,e.UILabelProvider=new A({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new A({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new A({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new A({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(b,M,i){if(M===null)return"";const S=[];return b.ctrlKey&&S.push(i.ctrlKey),b.shiftKey&&S.push(i.shiftKey),b.altKey&&S.push(i.altKey),b.metaKey&&S.push(i.metaKey),M!==""&&S.push(M),S.join(i.separator)}}),define(X[127],J([14,11]),function(H,e){return H.create("vs/base/node/processes",e)}),define(X[86],J([0,1,8,18,19,45,127,32,12,44,30,3,81,10]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(c,t){if(g.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const s=b.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],r);return new Promise(u=>{s.once("error",h=>{u({success:!1,error:h})}),s.once("exit",(h,f)=>{u(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?d(r.status):1})}else if(g.isLinux||g.isMacintosh)try{const r=p.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",H).fsPath;return new Promise(s=>{b.execFile(r,[c.pid.toString()],{encoding:"utf8",shell:!0},(u,h,f)=>{s(u?{success:!1,error:u}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function P(c=i.env){return c.comspec||"cmd.exe"}e.getWindowsShell=P;class I{constructor(t,r,s,u){if(r!==void 0&&s!==void 0&&u!==void 0)this.cmd=t,this.args=r,this.shell=s,this.options=u;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(i.env).forEach(f=>{h[f]=i.env[f]}),Object.keys(this.options.env).forEach(f=>{h[f]=this.options.env[f]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(v.sep);return r!==-1&&(t=t.substring(r+1)),I.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(i.cwd()))?Promise.reject(new Error(M.localize(0,null))):this.useExec().then(r=>{let s,u;const h=new Promise((f,m)=>{s=f,u=m});if(r){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=b.exec(f,this.options,(m,D,_)=>{this.childProcess=null;const U=m;U&&U.killed?u({killed:this.terminateRequested,stdout:D.toString(),stderr:_.toString()}):this.handleExec(s,t,m,D,_)})}else{let f=null;const m=D=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(D,s,t,u);const _={terminated:this.terminateRequested};S.isNumber(D)&&(_.cmdCode=D),s(_)};if(this.shell&&g.isWindows){const D=y.deepClone(this.options);D.windowsVerbatimArguments=!0,D.detached=!1;let _=!1,U=!1;const q=[];let Q=this.ensureQuotes(this.cmd);q.push(Q.value),_=Q.quoted,this.args&&this.args.forEach(ae=>{Q=this.ensureQuotes(ae),q.push(Q.value),U=U&&Q.quoted});const ie=["/s","/c"];_?U?ie.push('"'+q.join(" ")+'"'):q.length>1?ie.push('"'+q[0]+'" '+q.slice(1).join(" ")):ie.push('"'+q[0]+'"'):ie.push(q.join(" ")),f=b.spawn(P(),ie,D)}else this.cmd&&(f=b.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(S.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",D=>{this.childProcess=null,u({terminated:this.terminateRequested,error:D})}),f.pid&&(this.childProcess.on("close",m),this.handleSpawn(f,s,t,u,!0)))}return h})}handleClose(t,r,s,u){}ensureQuotes(t){return I.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,w(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const r=b.spawn(P(),["/s","/c"]);r.on("error",s=>t(!0)),r.on("exit",s=>t(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class a extends I{constructor(t,r,s,u){super(t,r,s,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,s,u,h){[u,h].forEach((f,m)=>{const D=new E.LineDecoder;D.write(f).forEach(q=>{r({line:q,source:m===0?0:1})});const U=D.end();U&&r({line:U,source:m===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,r,s,u,h){const f=new E.LineDecoder,m=new E.LineDecoder;t.stdout.on("data",D=>{f.write(D).forEach(U=>s({line:U,source:0}))}),t.stderr.on("data",D=>{m.write(D).forEach(U=>s({line:U,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=m}handleClose(t,r,s,u){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&s({line:h,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&s({line:f,source:1})}}e.LineProcess=a;function l(c){let t=[],r=!1;const s=function(u){if(r){t.push(u);return}(!c.send(u,f=>{if(f&&console.error(f),r=!1,t.length>0){const m=t.slice(0);t=[],m.forEach(D=>s(D))}})||g.isWindows)&&(r=!0)};return{send:s}}e.createQueuedSender=l;var o;(function(c){async function t(r,s,u){if(v.isAbsolute(r))return r;if(s===void 0&&(s=i.cwd()),v.dirname(r)!=="."||(u===void 0&&S.isString(i.env.PATH)&&(u=i.env.PATH.split(v.delimiter)),u===void 0||u.length===0))return v.join(s,r);async function f(m){return await L.exists(m)?!(await A.promises.stat(m)).isDirectory():!1}for(let m of u){let D;if(v.isAbsolute(m)?D=v.join(m,r):D=v.join(s,m,r),await f(D))return D;let _=D+".com";if(await f(_)||(_=D+".exe",await f(_)))return _}return v.join(s,r)}c.findExecutable=t})(o=e.win32||(e.win32={}))}),define(X[128],J([0,1,27,3,114,86]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(p,d){return p===1?A.isWindows?g():b.getWindowsShell(d):y(p,d)}e.getSystemShell=M;function i(p,d){return p===1?A.isWindows?E(d):b.getWindowsShell(d):y(p,d)}e.getSystemShellSync=i;let S=null;function y(p,d){if(A.isLinux&&p===2||A.isMacintosh&&p===3)return"/bin/bash";if(!S){let w;if(A.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,v.userInfo)().shell}catch(P){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}S=w}return S}let n=null;async function g(){return n||(n=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),n}function E(p){if(n)return n;const d=A.isWindows&&parseFloat((0,v.release)())>=10,w=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${p.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?P:b.getWindowsShell(p)}}),define(X[87],J([0,1,45,2,9,44,5,86,33,106,25,17,23,3]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends S.ChannelServer{constructor(I){super({send:a=>{try{process.send&&process.send(a.buffer.toString("base64"))}catch(l){}},onMessage:M.Event.fromNodeEventEmitter(process,"message",a=>E.VSBuffer.wrap(Buffer.from(a,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=d;class w{constructor(I,a){this.modulePath=I,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new M.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new L.Delayer(l),this.child=null,this._client=null}getChannel(I){const a=this;return{call(l,o,c){return a.requestPromise(I,l,o,c)},listen(l,o){return a.requestEvent(I,l,o)}}}requestPromise(I,a,l,o=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(I),t=(0,L.createCancelablePromise)(u=>c.call(a,l,u)),r=o.onCancellationRequested(()=>t.cancel()),s=(0,A.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,a,l){if(!this.disposeDelayer)return M.Event.None;this.disposeDelayer.cancel();let o;const c=new M.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(I).listen(a,l)(c.fire,c),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env=Object.assign(Object.assign({},(0,b.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(a.env=Object.assign(Object.assign({},a.env),this.options.env)),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),p.isMacintosh&&a.env&&delete a.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,I,a);const l=new M.Emitter;M.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,y.isRemoteConsoleLog)(h)){(0,y.log)(h,`IPC Library: ${this.options.serverName}`);return}l.fire(E.VSBuffer.wrap(Buffer.from(h,"base64")))});const c=this.options.useQueue?(0,i.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&c.send(h.buffer.toString("base64")),r=l.event,s={send:t,onMessage:r};this._client=new S.ChannelClient(s);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",u),this.activeRequests.forEach(m=>(0,A.dispose)(m)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(I){let a=this.channels.get(I);return a||(a=this.client.getChannel(I),this.channels.set(I,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(X[129],J([14,11]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(X[130],J([14,11]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[131],J([14,11]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[132],J([14,11]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(X[133],J([14,11]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(X[134],J([14,11]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[135],J([14,11]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[136],J([14,11]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(X[137],J([14,11]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(X[138],J([14,11]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(X[139],J([14,11]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[140],J([14,11]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[141],J([14,11]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[142],J([14,11]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(X[143],J([14,11]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[144],J([14,11]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(X[145],J([14,11]),function(H,e){return H.create("vs/platform/windows/electron-main/window",e)}),define(X[146],J([14,11]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[147],J([14,11]),function(H,e){return H.create("vs/platform/workspaces/common/workspaces",e)}),define(X[148],J([14,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[149],J([14,11]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[150],J([0,1,5,2]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(i,S,y){switch(S){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(i,S,y){switch(S){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class b extends A.Disposable{constructor(i){super();this.channel=i}reload(i){this.channel.call("reload",[i])}get onReload(){return this.channel.listen("reload")}close(i){this.channel.call("close",[i])}get onClose(){return this.channel.listen("close")}attachSession(i,S,y){this.channel.call("attach",[i,S,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(i,S){this.channel.call("terminate",[i,S])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(i,S,y){return this.channel.call("openExtensionDevelopmentHostWindow",[i,S||{},y])}}e.ExtensionHostDebugChannelClient=b});var ce=this&&this.__decorate||function(H,e,v,A){var L=arguments.length,b=L<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,v):A,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(H,e,v,A);else for(var i=H.length-1;i>=0;i--)(M=H[i])&&(b=(L<3?M(b):L>3?M(e,v,b):M(e,v))||b);return L>3&&b&&Object.defineProperty(e,v,b),b};define(X[151],J([0,1,8,15,53,123,10,7,32]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(d,w,P){this._args=d,this.paths=w,this.productService=P}get appRoot(){return(0,v.dirname)(M.FileAccess.asFileUri("",H).fsPath)}get userHome(){return i.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return i.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return i.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return i.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(i.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return i.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return i.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=S.env.VSCODE_PORTABLE;return d?i.URI.file((0,v.join)(d,"argv.json")):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,A.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return i.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,v.resolve)(d):(0,v.normalize)((0,v.join)(M.FileAccess.asFileUri("",H).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,v.resolve)(d):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,v.resolve)(d);const w=S.env.VSCODE_EXTENSIONS;if(w)return w;const P=S.env.VSCODE_PORTABLE;return P?(0,v.join)(P,"extensions"):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(w=>/^[^:/?#]+?:\/\//.test(w)?i.URI.parse(w):i.URI.file((0,v.normalize)(w)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?i.URI.parse(d):i.URI.file((0,v.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,A.joinPath)(i.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return i.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([L.memoize],y.prototype,"appRoot",null),ce([L.memoize],y.prototype,"userHome",null),ce([L.memoize],y.prototype,"userDataPath",null),ce([L.memoize],y.prototype,"appSettingsHome",null),ce([L.memoize],y.prototype,"tmpDir",null),ce([L.memoize],y.prototype,"userRoamingDataHome",null),ce([L.memoize],y.prototype,"settingsResource",null),ce([L.memoize],y.prototype,"userDataSyncHome",null),ce([L.memoize],y.prototype,"userDataSyncLogResource",null),ce([L.memoize],y.prototype,"sync",null),ce([L.memoize],y.prototype,"machineSettingsResource",null),ce([L.memoize],y.prototype,"globalStorageHome",null),ce([L.memoize],y.prototype,"workspaceStorageHome",null),ce([L.memoize],y.prototype,"keybindingsResource",null),ce([L.memoize],y.prototype,"keyboardLayoutResource",null),ce([L.memoize],y.prototype,"argvResource",null),ce([L.memoize],y.prototype,"snippetsHome",null),ce([L.memoize],y.prototype,"isExtensionDevelopment",null),ce([L.memoize],y.prototype,"untitledWorkspacesHome",null),ce([L.memoize],y.prototype,"installSourcePath",null),ce([L.memoize],y.prototype,"builtinExtensionsPath",null),ce([L.memoize],y.prototype,"extensionsPath",null),ce([L.memoize],y.prototype,"extensionDevelopmentLocationURI",null),ce([L.memoize],y.prototype,"extensionDevelopmentKind",null),ce([L.memoize],y.prototype,"extensionTestsLocationURI",null),ce([L.memoize],y.prototype,"debugExtensionHost",null),ce([L.memoize],y.prototype,"serviceMachineIdResource",null),ce([L.memoize],y.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=y;function n(p,d){return E(p["inspect-extensions"],p["inspect-brk-extensions"],5870,d,p.debugId)}e.parseExtensionHostPort=n;function g(p,d){return E(p["inspect-search"],p["inspect-brk-search"],5876,d)}e.parseSearchPort=g;function E(p,d,w,P,I){const l=Number(d||p)||(P?null:w),o=l?Boolean(!!d):!1;return{port:l,break:o,debugId:I}}}),define(X[88],J([0,1,232,132,3]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:(0,A.localize)(0,null),e:(0,A.localize)(1,null),t:(0,A.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,A.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,A.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,A.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,A.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,A.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,A.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,A.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,A.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,A.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,A.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,A.localize)(14,null)},category:{type:"string",cat:"e",description:(0,A.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,A.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,A.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,A.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,A.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,A.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,A.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,A.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,A.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,A.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,A.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,A.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,A.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,A.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,A.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{}};function i(d,w,P=M){const I={},a=[],l=[];for(let r in w){const s=w[r];s.alias&&(I[r]=s.alias),s.type==="string"||s.type==="string[]"?(a.push(r),s.deprecates&&a.push(s.deprecates)):s.type==="boolean"&&(l.push(r),s.deprecates&&l.push(s.deprecates))}const o=v(d,{string:a,boolean:l,alias:I}),c={},t=o;c._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in w){const s=w[r];s.alias&&delete t[s.alias];let u=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(u||(u=t[s.deprecates]),delete t[s.deprecates]),typeof u!="undefined"&&(s.type==="string[]"?u&&!Array.isArray(u)&&(u=[u]):s.type==="string"&&Array.isArray(u)&&(u=u.pop(),P.onMultipleValues(r,u)),c[r]=u),delete t[r]}for(let r in t)P.onUnknownOption(r);return c}e.parseArgs=i;function S(d,w){let P="";return w.args&&(Array.isArray(w.args)?P=` <${w.args.join("> <")}>`:P=` <${w.args}>`),w.alias?`-${w.alias} --${d}${P}`:`--${d}${P}`}function y(d,w){let P=0,I=[];for(const c in d){const t=d[c],r=S(c,t);P=Math.max(P,r.length),I.push([r,t.description])}let a=P+2+1;if(w-a<25)return I.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let l=w-a-1,o=[];for(const c of I){let t=c[0],r=g(c[1],l),s=n(a-t.length-2);o.push("  "+t+s+r[0]);for(let u=1;u<r.length;u++)o.push(n(a)+r[u])}return o}e.formatOptions=y;function n(d){return" ".repeat(d)}function g(d,w){let P=[];for(;d.length;){let I=d.length<w?d.length:d.lastIndexOf(" ",w),a=d.slice(0,I).trim();d=d.slice(I),P.push(a)}return P}function E(d,w,P,I,a=!0){const l=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${P}`];o.push(""),o.push(`${(0,A.localize)(32,null)}: ${w} [${(0,A.localize)(33,null)}][${(0,A.localize)(34,null)}...]`),o.push(""),a&&(L.isWindows?o.push((0,A.localize)(35,null,w)):o.push((0,A.localize)(36,null,w)),o.push(""));const c={};for(const t in I){const r=I[t];if(r.description&&r.cat){let s=c[r.cat];s||(c[r.cat]=s={}),s[t]=r}}for(let t in c){const r=t;let s=c[r];s&&(o.push(b[r]),o.push(...y(s,l)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=E;function p(d,w){return`${d||(0,A.localize)(37,null)}
${w||(0,A.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(X[152],J([0,1,88,59,150]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends L.ExtensionHostDebugBroadcastChannel{constructor(i){super();this.windowsMainService=i}call(i,S,y){return S==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1],y[2]):super.call(i,S,y)}async openExtensionDevelopmentHostWindow(i,S,y){const n=(0,v.parseArgs)(i,v.OPTIONS);n.debugRenderer=y;const g=n.extensionDevelopmentPath;if(!g)return{success:!1};let E;const p=Object.keys(S);for(let l of p){let o=S[l];o===null||(E||(E=Object.create(null)),E[l]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:n,userEnv:E});if(!y)return{success:!0};const w=d.win;if(!w)return{success:!0};const P=w.webContents.debugger;let I=P.isAttached()?Infinity:0;const a=(0,A.createServer)(l=>{I++==0&&P.attach();let o=!1;const c=s=>{o||l.write(JSON.stringify(s)+"\0")},t=(s,u,h,f)=>c({method:u,params:h,sessionId:f});w.on("close",()=>{P.removeListener("message",t),l.end(),o=!0}),P.addListener("message",t);let r=Buffer.alloc(0);l.on("data",s=>{r=Buffer.concat([r,s]);for(let u=r.indexOf(0);u!==-1;u=r.indexOf(0)){let h;try{const f=r.slice(0,u).toString("utf8");r=r.slice(u+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}P.sendCommand(h.method,h.params,h.sessionId).then(f=>c({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>c({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),l.on("error",s=>{console.error("error on cdp pipe:",s)}),l.on("close",()=>{o=!0,--I==0&&P.detach()})});return await new Promise(l=>a.listen(0,l)),w.on("close",()=>a.close()),{rendererDebugPort:a.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),function(){"use strict";function H(e,v,A,L){function b(i){const S=M(i),y=[S];return e.isAbsolute(S)||y.unshift(L),e.resolve(...y)}function M(i){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");const y=i["user-data-dir"];if(y)return y;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const g=process.env.USERPROFILE;if(typeof g!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(g,"AppData","Roaming")}break;case"darwin":n=e.join(v.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,A)}return{getUserDataPath:b}}if(typeof define=="function")define(X[153],J([0,154,27,10,15,32]),function(e,v,A,L,b,M){const i=b.dirname(L.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(b.joinPath(i,"package.json").fsPath);return H(v,A,S.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),A=require("os");module.exports=H(v,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[155],J([0,1,27,153,151]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class b extends L.AbstractNativeEnvironmentService{constructor(i,S){super(i,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,A.getUserDataPath)(i)},S)}}e.NativeEnvironmentService=b}),define(X[156],J([0,1,18,27,8]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(M){const i=(0,L.join)((0,A.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(i,""),M&&console.log(`Marker file for --wait created: ${i}`),i}catch(S){M&&console.error(`Failed to create marker file for --wait: ${S}`);return}}e.createWaitMarkerFile=b}),define(X[157],J([0,1,135]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function L(g){return g=g.trim(),g==="*"||A.test(g)}e.isValidVersionStr=L;function b(g){if(!L(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(A);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=b;function M(g){if(!g)return null;let E=g.majorBase,p=g.majorMustEqual,d=g.minorBase,w=g.minorMustEqual,P=g.patchBase,I=g.patchMustEqual;return g.hasCaret&&(E===0||(w=!1),I=!1),{majorBase:E,majorMustEqual:p,minorBase:d,minorMustEqual:w,patchBase:P,patchMustEqual:I,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=M;function i(g,E){let p;typeof g=="string"?p=M(b(g)):p=g;let d;if(typeof E=="string"?d=M(b(E)):d=E,!p||!d)return!1;let w=p.majorBase,P=p.minorBase,I=p.patchBase,a=d.majorBase,l=d.minorBase,o=d.patchBase,c=d.majorMustEqual,t=d.minorMustEqual,r=d.patchMustEqual;return d.isMinimum?w>a?!0:w<a?!1:P>l?!0:P<l?!1:I>=o:(w===1&&a===0&&(!c||!t||!r)&&(a=1,l=0,o=0,c=!0,t=!1,r=!1),w<a?!1:w>a?!c:P<l?!1:P>l?!t:I<o?!1:I>o?!r:!0)}e.isValidVersion=i;function S(g,E,p){return E.isBuiltin||typeof E.main=="undefined"?!0:n(g,E.engines.vscode,p)}e.isValidExtensionVersion=S;function y(g,E){return g==="*"||n(E,g)}e.isEngineValid=y;function n(g,E,p=[]){let d=M(b(E));if(!d)return p.push(v.localize(0,null,E)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return p.push(v.localize(1,null,E)),!1}else if(!d.majorMustEqual)return p.push(v.localize(2,null,E)),!1;return i(g,d)?!0:(p.push(v.localize(3,null,g,E)),!1)}e.isVersionValid=n}),define(X[158],J([0,1,33,87,2,10]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends L.Disposable{constructor(S,y,n,g){super();this.folders=S,this.onDidFilesChange=y,this.onLogMessage=n,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(X[159],J([0,1,33,87,2,10]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends L.Disposable{constructor(S,y,n,g,E={}){super();this.folders=S,this.onDidFilesChange=y,this.onLogMessage=n,this.verboseLogging=g,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",H).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(S.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(X[160],J([0,1,45,81,108,10]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class M{constructor(S,y,n,g,E){this.watchedFolder=S,this.eventCallback=n,this.logCallback=g,this.verboseLogging=E,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(p=>L.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=v.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",H).fsPath,S);const y=new A.LineDecoder;this.handle.stdout.on("data",n=>{const g=[];y.write(n).forEach(E=>{const p=E.split("|");if(p.length===2){const d=Number(p[0]),w=p[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(P=>P(w))){this.verboseLogging&&this.log(w);return}g.push({type:M.changeTypeMap[d],path:w})}else this.log(p[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,g)=>this.onExit(n,g))}onError(S){this.error("process error: "+S.toString())}onExit(S,y){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${y})`),this.restartCounter<=M.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=M,M.MAX_RESTARTS=5,M.changeTypeMap=[0,1,2]}),define(X[161],J([0,1,160,8,22]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(i,S,y,n){this.onDidFilesChange=S,this.onLogMessage=y,this.verboseLogging=n,this.service=void 0,this.folder=i[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,i=>this.onFileEvents(i),i=>this.onLogMessage(i),this.verboseLogging)}setVerboseLogging(i){this.verboseLogging=i,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(i){this.isDisposed||i.length>0&&this.onDidFilesChange(i)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(X[67],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(b,M=[],i=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=v;const A=(L,...b)=>new v(L,b);e.createSyncDescriptor=A}),define(X[162],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=v;class A{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let M of this._nodes.values())M.outgoing.size===0&&b.push(M);return b}insertEdge(b,M){const i=this.lookupOrInsertNode(b),S=this.lookupOrInsertNode(M);i.outgoing.set(this._hashFn(M),S),S.incoming.set(this._hashFn(b),i)}removeNode(b){const M=this._hashFn(b);this._nodes.delete(M);for(let i of this._nodes.values())i.outgoing.delete(M),i.incoming.delete(M)}lookupOrInsertNode(b){const M=this._hashFn(b);let i=this._nodes.get(M);return i||(i=new v(b),this._nodes.set(M,i)),i}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[M,i]of this._nodes)b.push(`${M}, (incoming)[${[...i.incoming.keys()].join(", ")}], (outgoing)[${[...i.outgoing.keys()].join(",")}]`);return b.join(`
`)}findCycleSlow(){for(let[b,M]of this._nodes){const i=new Set([b]),S=this._findCycle(M,i);if(S)return S}}_findCycle(b,M){for(let[i,S]of b.outgoing){if(M.has(i))return[...M,i].join(" -> ");M.add(i);const y=this._findCycle(S,M);if(y)return y;M.delete(i)}}}e.Graph=A}),define(X[4],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function S(y){return y[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=S})(v=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function A(i,S,y,n){S[v.DI_TARGET]===S?S[v.DI_DEPENDENCIES].push({id:i,index:y,optional:n}):(S[v.DI_DEPENDENCIES]=[{id:i,index:y,optional:n}],S[v.DI_TARGET]=S)}function L(i){if(v.serviceIds.has(i))return v.serviceIds.get(i);const S=function(y,n,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(S,y,g,!1)};return S.toString=()=>i,v.serviceIds.set(i,S),S}e.createDecorator=L;function b(i){return i}e.refineServiceDecorator=b;function M(i){return function(S,y,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(i,S,n,!0)}}e.optional=M}),define(X[68],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=A}),define(X[89],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class A{constructor(b){this.machineId=b}encryption(){return new Promise((b,M)=>H(["vscode-encrypt"],b,M))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(M){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(M){return b}}}e.EncryptionMainService=A}),define(X[46],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(X[163],J([0,1,134,4,10]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=b;var M;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(M=e.SortBy||(e.SortBy={}));var i;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(i=e.SortOrder||(e.SortOrder={}));var S;(function(g){g.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var y;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(E,p){super(E);this.code=p}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",H).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(X[164],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(X[165],J([0,1,22,4]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class M{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,g){if(typeof n=="undefined"||n===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof n=="string"||typeof g=="string"){let E=typeof n=="string"?n:n.value,p=typeof g=="string"?g:g.value;return v.equalsIgnoreCase(E,p)}return n._lower===g._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=M;function i(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=i;function S(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[166],J([0,1,22,165]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(p,d){return p.uuid&&d.uuid?p.uuid===d.uuid:p.id===d.id?!0:(0,v.compareIgnoreCase)(p.id,d.id)===0}e.areSameExtensions=L;class b{constructor(d,w){this.version=w,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof b?L(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=b;function M(p,d){return`${p}.${d}`}e.getExtensionId=M;function i(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=i;function S(p,d){return i(M(p,d))}e.getGalleryExtensionId=S;function y(p,d){const w=[],P=I=>{for(const a of w)if(a.some(l=>L(d(l),d(I))))return a;return null};for(const I of p){const a=P(I);a?a.push(I):w.push([I])}return w}e.groupByExtension=y;function n(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function g(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function E(p){const d=new Set;for(const w of p)w.malicious&&d.add(w.id.id);return d}e.getMaliciousExtensionsSet=E}),define(X[24],J([0,1,137,8,7,4,22,12,36]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function y(O){return O.create===!0}e.isFileOpenForWriteOptions=y;var n;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var g;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=E;function p(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=p;function d(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function w(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=w;var P;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor($,z){super($);this.code=z}}e.FileSystemProviderError=I;function a(O,$){const z=new I(O.toString(),$);return o(z,$),z}e.createFileSystemProviderError=a;function l(O){return O||a((0,v.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=l;function o(O,$){return O.name=$?`${$} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=o;function c(O){if(!O)return P.Unknown;if(O instanceof I)return O.code;const $=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!$)return P.Unknown;switch($[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=c;function t(O){if(O instanceof m)return O.fileOperationResult;switch(c(O)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor($,z,C){this.resource=$,this.operation=z,this.target=C}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var u;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class h{constructor($,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const C of $)switch(C.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(C.resource,C);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(C.resource,C);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(C.resource,C);break}}contains($,...z){return this.doContains($,{includeChildren:!1},...z)}affects($,...z){return this.doContains($,{includeChildren:!0},...z)}doContains($,z,...C){var j,N,T,R,W,k;if(!$)return!1;const F=C.length>0;return!!((!F||C.includes(1))&&(((j=this.added)===null||j===void 0?void 0:j.get($))||z.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr($)))||(!F||C.includes(0))&&(((T=this.updated)===null||T===void 0?void 0:T.get($))||z.includeChildren&&((R=this.updated)===null||R===void 0?void 0:R.findSuperstr($)))||(!F||C.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr($))||z.includeChildren&&((k=this.deleted)===null||k===void 0?void 0:k.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const z=[],C=$===1?this.added:$===0?this.updated:this.deleted;if(C)for(const[,j]of C)z.push(j);return z}filter($){return new h(this.changes.filter(z=>$(z)),this.ignorePathCasing)}}e.FileChangesEvent=h;function f(O,$,z){return!O||!$||O===$||$.length>O.length?!1:($.charAt($.length-1)!==A.sep&&($+=A.sep),z?(0,M.startsWithIgnoreCase)(O,$):O.indexOf($)===0)}e.isParent=f;class m extends Error{constructor($,z,C){super($);this.fileOperationResult=z,this.options=C}static isFileOperationError($){return $ instanceof Error&&!(0,i.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=m;var D;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=U;async function q(O,$){if(!$.canHandleResource(L.URI.from({scheme:O.scheme})))return new Promise(z=>{const C=$.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===O.scheme&&j.added&&(C.dispose(),z())})})}e.whenProviderRegistered=q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Q{static formatSize($){return(0,i.isNumber)($)||($=0),$<Q.KB?(0,v.localize)(1,null,$.toFixed(0)):$<Q.MB?(0,v.localize)(2,null,($/Q.KB).toFixed(2)):$<Q.GB?(0,v.localize)(3,null,($/Q.MB).toFixed(2)):$<Q.TB?(0,v.localize)(4,null,($/Q.GB).toFixed(2)):(0,v.localize)(5,null,($/Q.TB).toFixed(2))}}e.ByteSize=Q,Q.KB=1024,Q.MB=Q.KB*Q.KB,Q.GB=Q.MB*Q.KB,Q.TB=Q.GB*Q.KB;var ie;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(ie=e.Arch||(e.Arch={}));function ae(O){return{maxFileSize:O===0?300*Q.MB:16*Q.GB,maxHeapSize:O===0?700*Q.MB:2*700*Q.MB}}e.getPlatformLimits=ae}),define(X[54],J([0,1,233,133,24,88]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function M(E,p){const d={onUnknownOption:P=>{console.warn((0,A.localize)(0,null,P))},onMultipleValues:(P,I)=>{console.warn((0,A.localize)(1,null,P,I))}},w=(0,b.parseArgs)(E,b.OPTIONS,p?d:void 0);return w.goto&&w._.forEach(P=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,A.localize)(2,null))),w["max-memory"]&&v(parseInt(w["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function i(E){const p=E.findIndex(d=>!/^-/.test(d));if(p>-1)return[...E.slice(0,p),...E.slice(p+1)]}function S(E){let[,...p]=E;process.env.VSCODE_DEV&&(p=i(p)||[]);const d=!g(process.env);return M(p,d)}e.parseMainProcessArgv=S;function y(E){const[,,...p]=E;return M(p,!0)}e.parseCLIProcessArgv=y;function n(E,...p){const d=E.indexOf("--");return d===-1?E.push(...p):E.splice(d,0,...p),E}e.addArg=n;function g(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),define(X[69],J([0,1,154,45,28,3,54,66,128]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(E,p,d){return p["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,M.isLaunchedFromCli)(d)&&!p["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,M.isLaunchedFromCli)(d)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),n||(n=g(E)),n)}e.resolveShellEnv=y;let n;async function g(E){const p=new Promise(async(d,w)=>{const P=process.env.ELECTRON_RUN_AS_NODE;E.trace("getUnixShellEnvironment#runAsNode",P);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;E.trace("getUnixShellEnvironment#noAttach",I);const a=(0,L.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(a+"(.*)"+a),o=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});E.trace("getUnixShellEnvironment#env",o);const c=await(0,S.getSystemShell)(b.OS,o);E.trace("getUnixShellEnvironment#shell",c);let t=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,r=["-ilc"];const s=v.basename(c);/^pwsh(-preview)?$/.test(s)&&(t=`& ${t}`,r=["-Login","-Command"]),E.trace("getUnixShellEnvironment#spawn",JSON.stringify(r),t);const u=(0,A.spawn)(c,[...r,t],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});u.on("error",m=>{E.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(m)),d({})});const h=[];u.stdout.on("data",m=>h.push(m));const f=[];u.stderr.on("data",m=>f.push(m)),u.on("close",(m,D)=>{const _=Buffer.concat(h).toString("utf8");E.trace("getUnixShellEnvironment#raw",_);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&E.trace("getUnixShellEnvironment#stderr",U),m||D)return w(new Error(`Failed to get environment (code ${m}, signal ${D})`));const q=l.exec(_),Q=q?q[1]:"{}";try{const ie=JSON.parse(Q);P?ie.ELECTRON_RUN_AS_NODE=P:delete ie.ELECTRON_RUN_AS_NODE,I?ie.ELECTRON_NO_ATTACH_CONSOLE=I:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,E.trace("getUnixShellEnvironment#result",ie),d(ie)}catch(ie){E.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(ie)),w(ie)}})});try{return await p}catch(d){return E.error("getUnixShellEnvironment#error",(0,i.toErrorMessage)(d)),{}}}}),define(X[90],J([0,1,7,24,3]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(S){return S.map(y=>({type:y.type,resource:v.URI.file(y.path)}))}e.toFileChanges=b;function M(S){const y=new i;for(const n of S)y.processEvent(n);return y.normalize()}e.normalizeFileChanges=M;class i{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const n=this.mapPathToChange.get(y.path);if(n){const g=n.type,E=y.type;g===1&&E===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(n),1)):g===2&&E===1?n.type=0:g===1&&E===0||(n.type=E)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],n=[];return this.normalized.filter(g=>g.type!==2?(y.push(g),!1):!0).sort((g,E)=>g.path.length-E.path.length).filter(g=>n.some(E=>(0,A.isParent)(g.path,E,!L.isLinux))?!1:(n.push(g.path),!0)).concat(y)}}}),define(X[167],J([0,1,90,2,19,111,115,9,8]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends A.Disposable{constructor(g,E,p,d){super();this.path=g,this.onDidFilesChange=E,this.onLogMessage=p,this.verboseLogging=d,this.fileChangesDelayer=this._register(new i.ThrottledDelayer(M.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:E}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(E)try{p=await(0,b.realpath)(p)}catch(d){if(this.onError(d),E.dangling)return}g.isDirectory()?this._register((0,M.watchFolder)(p,(d,w)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(w))})},d=>this.onError(d))):this._register((0,M.watchFile)(p,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,v.normalizeFileChanges)(E);this.verboseLogging&&p.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),p.length>0&&this.onDidFilesChange(p)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(X[70],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...L){this._entries=new Map;for(let[b,M]of L)this.set(b,M)}set(L,b){const M=this._entries.get(L);return this._entries.set(L,b),M}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=v}),define(X[168],J([0,1,17,162,67,4,70,9]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class y extends Error{constructor(d){var w;super("cyclic dependency between services");this.message=(w=d.findCycleSlow())!==null&&w!==void 0?w:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new M.ServiceCollection,w=!1,P){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=P,this._services.set(b.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...w){let P=E.traceInvocation(d),I=!1;try{return d({get:(l,o)=>{if(I)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(l,P);if(!c&&o!==b.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return c}},...w)}finally{I=!0,P.stop()}}createInstance(d,...w){let P,I;return d instanceof L.SyncDescriptor?(P=E.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(w),P)):(P=E.traceCreation(d),I=this._createInstance(d,w,P)),P.stop(),I}_createInstance(d,w=[],P){let I=b._util.getServiceDependencies(d).sort((o,c)=>o.index-c.index),a=[];for(const o of I){let c=this._getOrCreateServiceInstance(o.id,P);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);a.push(c)}let l=I.length>0?I[0].index:w.length;if(w.length!==l){console.warn(`[createInstance] First service dependency of ${d.name} at position ${l+1} conflicts with ${w.length} static arguments`);let o=l-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,l)}return new d(...[...w,...a])}_setServiceInstance(d,w){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let P=this._getServiceInstanceOrDescriptor(d);return P instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,P,w.branch(d,!0)):(w.branch(d,!1),P)}_safeCreateAndCacheServiceInstance(d,w,P){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,P)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,P){const I=new A.Graph(o=>o.id.toString());let a=0;const l=[{id:d,desc:w,_trace:P}];for(;l.length;){const o=l.pop();if(I.lookupOrInsertNode(o),a++>1e3)throw new y(I);for(let c of b._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:c.id,desc:t,_trace:o._trace.branch(c.id,!0)};I.insertEdge(o,r),l.push(r)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new y(I);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}I.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,P=[],I,a){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(w,P,I,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,P,I,a);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],P,I){if(P){const a=new i.IdleValue(()=>this._createInstance(d,w,I));return new Proxy(Object.create(null),{get(l,o){if(o in l)return l[o];let c=a.value,t=c[o];return typeof t!="function"||(t=t.bind(c),l[o]=t),t},set(l,o,c){return a.value[o]=c,!0}})}else return this._createInstance(d,w,I)}}e.InstantiationService=n;var g;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(g||(g={}));class E{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return S?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return S?new E(0,d.name):E._None}branch(d,w){let P=new E(2,d.toString());return this._dep.push([d,w,P]),P}stop(){let d=Date.now()-this._start;E._totals+=d;let w=!1;function P(a,l){let o=[],c=new Array(a+1).join("	");for(const[t,r,s]of l._dep)if(r&&s){w=!0,o.push(`${c}CREATES -> ${t}`);let u=P(a+1,s);u&&o.push(u)}else o.push(`${c}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(I.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(X[169],J([0,1,17,126,57]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends L.ResolvedKeybinding{constructor(i,S){super();if(S.length===0)throw(0,v.illegalArgument)("parts");this._os=i,this._parts=S}getLabel(){return A.UILabelProvider.toLabel(this._os,this._parts,i=>this._getLabel(i))}getAriaLabel(){return A.AriaLabelProvider.toLabel(this._os,this._parts,i=>this._getAriaLabel(i))}getElectronAccelerator(){return this._parts.length>1?null:A.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,i=>this._getElectronAccelerator(i))}getUserSettingsLabel(){return A.UserSettingsLabelProvider.toLabel(this._os,this._parts,i=>this._getUserSettingsLabel(i))}isWYSIWYG(){return this._parts.every(i=>this._isWYSIWYG(i))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(i=>this._getPart(i))}_getPart(i){return new L.ResolvedKeybindingPart(i.ctrlKey,i.shiftKey,i.altKey,i.metaKey,this._getLabel(i),this._getAriaLabel(i))}getDispatchParts(){return this._parts.map(i=>this._getDispatchPart(i))}getSingleModifierDispatchParts(){return this._parts.map(i=>this._getSingleModifierDispatchPart(i))}}e.BaseResolvedKeybinding=b}),define(X[170],J([0,1,57,169]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class L extends A.BaseResolvedKeybinding{constructor(M,i){super(i,M.parts)}_keyCodeToUILabel(M){if(this._os===2)switch(M){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(M)}_getLabel(M){return M.isDuplicateModifierCase()?"":this._keyCodeToUILabel(M.keyCode)}_getAriaLabel(M){return M.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(M.keyCode)}_keyCodeToElectronAccelerator(M){if(M>=93&&M<=108)return null;switch(M){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(M)}_getElectronAccelerator(M){return M.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(M.keyCode)}_getUserSettingsLabel(M){if(M.isDuplicateModifierCase())return"";const i=v.KeyCodeUtils.toUserSettingsUS(M.keyCode);return i&&i.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(M){return L.getDispatchStr(M)}static getDispatchStr(M){if(M.isModifierKey())return null;let i="";return M.ctrlKey&&(i+="ctrl+"),M.shiftKey&&(i+="shift+"),M.altKey&&(i+="alt+"),M.metaKey&&(i+="meta+"),i+=v.KeyCodeUtils.toString(M.keyCode),i}_getSingleModifierDispatchPart(M){return M.keyCode===5&&!M.shiftKey&&!M.altKey&&!M.metaKey?"ctrl":M.keyCode===4&&!M.ctrlKey&&!M.altKey&&!M.metaKey?"shift":M.keyCode===6&&!M.ctrlKey&&!M.shiftKey&&!M.metaKey?"alt":M.keyCode===57&&!M.ctrlKey&&!M.shiftKey&&!M.altKey?"meta":null}}e.USLayoutResolvedKeybinding=L}),define(X[171],J([0,1,9]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function A(L,b){if(L.length===0)return Promise.resolve(!1);const M=[];let i=!1;for(let S of L){if(S===!0)return Promise.resolve(!0);(0,v.isThenable)(S)&&M.push(S.then(y=>{y&&(i=!0)},y=>{b(y),i=!0}))}return v.Promises.settled(M).then(()=>i)}e.handleVetos=A}),define(X[6],J([0,1,4,2,3,5,66]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function i(){return new Date().toISOString()}var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class y extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class n extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(S.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(S.Error,this.format(s))}else this.log(S.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let u=t[s];if(typeof u=="object")try{u=JSON.stringify(u)}catch(h){}r+=(s>0?" ":"")+u}return r}}e.AbstractMessageLogger=n;class g extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${i()}][0m`,t,...r):console.log(`[main ${i()}]`,t,...r))}debug(t,...r){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${i()}][0m`,t,...r):console.log(`[main ${i()}]`,t,...r))}info(t,...r){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${i()}][0m`,t,...r):console.log(`[main ${i()}]`,t,...r))}warn(t,...r){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${i()}][0m`,t,...r):console.warn(`[main ${i()}]`,t,...r))}error(t,...r){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${i()}][0m`,t,...r):console.error(`[main ${i()}]`,t,...r))}critical(t,...r){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${i()}][0m`,t,...r):console.error(`[main ${i()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class E extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=E;class p extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,M.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class d extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class w extends A.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=w;class P extends A.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?S.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class I{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=I;function a(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const t=l(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function o(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=o}),define(X[91],J([0,1,6]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(b,M){switch(M){case v.LogLevel.Trace:return b.trace;case v.LogLevel.Debug:return b.debug;case v.LogLevel.Info:return b.info;case v.LogLevel.Warning:return b.warn;case v.LogLevel.Error:return b.error;case v.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class L extends v.AbstractLogger{constructor(M=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(i=>{this._logger&&this._logger.setLevel(i)}))}set logger(M){this._logger=M;for(const{level:i,args:S}of this.buffer)A(M,i).apply(M,S);this.buffer=[]}_log(M,...i){this._logger?A(this._logger,M).apply(this._logger,i):this.getLevel()<=M&&this.buffer.push({level:M,args:i})}trace(M,...i){this._log(v.LogLevel.Trace,M,...i)}debug(M,...i){this._log(v.LogLevel.Debug,M,...i)}info(M,...i){this._log(v.LogLevel.Info,M,...i)}warn(M,...i){this._log(v.LogLevel.Warning,M,...i)}error(M,...i){this._log(v.LogLevel.Error,M,...i)}critical(M,...i){this._log(v.LogLevel.Critical,M,...i)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L});var ee=this&&this.__param||function(H,e){return function(v,A){e(v,A,H)}};define(X[172],J([0,1,6,24,9,23,15,4,91]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*A.ByteSize.MB;let n=class extends v.AbstractLogger{constructor(p,d,w,P){super();this.name=p,this.resource=d,this.fileService=P,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new L.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=p.stack,this._log(v.LogLevel.Error,this.format(d))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(p,d){this._log(p,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,d){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>y&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(w)),w=""),w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${d}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(w))})}getCurrentTimestamp(){const p=P=>P<10?`0${P}`:P,d=P=>P<10?`00${P}`:P<100?`0${P}`:P,w=new Date;return`${w.getFullYear()}-${p(w.getMonth()+1)}-${p(w.getDate())} ${p(w.getHours())}:${p(w.getMinutes())}:${p(w.getSeconds())}.${d(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(p){let d="";for(let w=0;w<p.length;w++){let P=p[w];if(typeof P=="object")try{P=JSON.stringify(P)}catch(I){}d+=(w>0?" ":"")+P}return d}};n=ce([ee(3,A.IFileService)],n),e.FileLogger=n;let g=class extends v.AbstractLoggerService{constructor(p,d,w){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=d,this.fileService=w}doCreateLogger(p,d){const w=new S.BufferLogService(d);return(0,A.whenProviderRegistered)(p,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(n,(0,M.basename)(p),p,w.getLevel())),w}};g=ce([ee(0,v.ILogService),ee(1,i.IInstantiationService),ee(2,A.IFileService)],g),e.FileLoggerService=g}),define(X[173],J([0,1,6,5,7]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(E){this.service=E,this.onDidChangeLogLevel=A.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(E,p,d){switch(p){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=b;class M{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){M.setLevel(this.channel,E)}static setLevel(E,p){return E.call("setLevel",p)}}e.LogLevelChannelClient=M;class i{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,p){throw new Error(`Event not found: ${p}`)}async call(E,p,d){switch(p){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${p}`)}createLogger(E,p){this.loggers.set(E.toString(),this.loggerService.createLogger(E,p))}consoleLog(E,p){let d=console.log;switch(E){case v.LogLevel.Error:d=console.error;break;case v.LogLevel.Warning:d=console.warn;break;case v.LogLevel.Info:d=console.info;break}d.call(console,...p)}log(E,p){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[w,P]of p)switch(w){case v.LogLevel.Trace:d.trace(P);break;case v.LogLevel.Debug:d.debug(P);break;case v.LogLevel.Info:d.info(P);break;case v.LogLevel.Warning:d.warn(P);break;case v.LogLevel.Error:d.error(P);break;case v.LogLevel.Critical:d.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=i;class S extends v.AbstractLoggerService{constructor(E,p,d){super(E,p);this.channel=d}createConsoleMainLogger(){return new v.AdapterLogger({log:(E,p)=>{this.channel.call("consoleLog",[E,p])}})}doCreateLogger(E,p,d){return new y(this.channel,E,p,d)}}e.LoggerChannelClient=S;class y extends v.AbstractMessageLogger{constructor(E,p,d,w){super(w==null?void 0:w.always);this.channel=E,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[p,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,p){const d=[[E,p]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class n extends v.LogService{constructor(E,p){super(p);this.parent=E,this._register(E.onDidChangeLogLevel(d=>p.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=n}),define(X[92],J([0,1,6,24]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function L(S,y,n,g){try{const E=await new Promise((p,d)=>{H(["spdlog"],p,d)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(S,y,n,g)}catch(E){console.error(E)}return null}function b(S,y,n,g){return H.__$__nodeRequire("spdlog").createRotatingLogger(S,y,n,g)}e.createRotatingLogger=b;function M(S,y,n){switch(y){case v.LogLevel.Trace:S.trace(n);break;case v.LogLevel.Debug:S.debug(n);break;case v.LogLevel.Info:S.info(n);break;case v.LogLevel.Warning:S.warn(n);break;case v.LogLevel.Error:S.error(n);break;case v.LogLevel.Critical:S.critical(n);break;default:throw new Error("Invalid log level")}}class i extends v.AbstractMessageLogger{constructor(y,n,g,E){super();this.name=y,this.filepath=n,this.rotating=g,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const y=this.rotating?6:1,n=30/y*A.ByteSize.MB;return L(this.name,this.filepath,n,y).then(g=>{if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:E,message:p}of this.buffer)M(this._logger,E,p);this.buffer=[]}})}log(y,n){this._logger?M(this._logger,y,n):this.getLevel()<=y&&this.buffer.push({level:y,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=i}),define(X[174],J([0,1,6,15,10,172,92,24,28]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends v.AbstractLoggerService{constructor(g,E){super(g.getLevel(),g.onDidChangeLogLevel);this.fileService=E}doCreateLogger(g,E,p){var d;if(g.scheme===L.Schemas.file){const w=new M.SpdLogLogger((p==null?void 0:p.name)||(0,S.generateUuid)(),g.fsPath,!(p==null?void 0:p.donotRotate),E);return(p==null?void 0:p.donotUseFormatters)&&w.clearFormatters(),w}else return new b.FileLogger((d=p==null?void 0:p.name)!==null&&d!==void 0?d:(0,A.basename)(g),g,E,this.fileService)}};y=ce([ee(0,v.ILogService),ee(1,i.IFileService)],y),e.LoggerService=y}),define(X[175],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function A(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function L(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function b(M){return!v(M)&&!A(M)&&!L(M)}e.isMenubarMenuItemAction=b}),define(X[47],J([0,1,10,3,32,15]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof A.globals.vscode!="undefined"){const i=A.globals.vscode.context.configuration();if(i)M=i.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(H==null?void 0:H.__$__nodeRequire)=="function"){const i=(0,b.dirname)(v.FileAccess.asFileUri("",H));M=H.__$__nodeRequire((0,b.joinPath)(i,"product.json").fsPath);const S=H.__$__nodeRequire((0,b.joinPath)(i,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`}),Object.assign(M,{version:S.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.56.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=M}),define(X[93],J([0,1,138,23,24,17,47]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(g,E,p,d,w,P){let I;try{await S(g,E,p,d,w,P)}catch(a){I=a}finally{I&&w.errorTransformer&&(I=w.errorTransformer(I)),typeof I!="undefined"&&p.error(I),p.end()}}e.readFileIntoStream=i;async function S(g,E,p,d,w,P){y(P);const I=await g.open(E,{create:!1});try{y(P);let a=0,l=0,o=w&&typeof w.length=="number"?w.length:void 0,c=A.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,r=0;do l=await g.read(I,t,c.buffer,r,c.byteLength-r),t+=l,r+=l,a+=l,typeof o=="number"&&(o-=l),r===c.byteLength&&(await p.write(d(c)),c=A.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),r=0);while(l>0&&(typeof o!="number"||o>0)&&y(P)&&n(a,w));if(r>0){let s=r;typeof o=="number"&&(s=Math.min(r,o)),p.write(d(c.slice(0,s)))}}catch(a){throw(0,L.ensureFileSystemProviderError)(a)}finally{await g.close(I)}}function y(g){if(g.isCancellationRequested)throw(0,b.canceled)();return!0}function n(g,E){if(E==null?void 0:E.limits){if(typeof E.limits.memory=="number"&&g>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,v.localize)(0,null,M.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&g>E.limits.size)throw(0,L.createFileSystemProviderError)((0,v.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[176],J([0,1,136,71,2,24,5,15,36,35,6,23,63,9,25,10,93,62]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends L.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(o,c){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:c});const t=new L.DisposableStore;return t.add(c.onDidChangeFile(r=>this._onDidFilesChange.fire(new b.FileChangesEvent(r,!this.isPathCaseSensitive(c))))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:o}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:c}),this.provider.delete(o),(0,L.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){c.push(t)}}),!this.provider.has(o)&&await p.Promises.settled(c)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,c){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return I.Iterable.map(this.provider,([o,c])=>({scheme:o,capabilities:c.capabilities}))}async withProvider(o){if(!(0,i.isAbsolutePath)(o))throw new b.FileOperationError((0,v.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const c=this.provider.get(o.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,o.toString()),t}return c}async withReadProvider(o){const c=await this.withProvider(o);if((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasReadWriteCapability)(c)||(0,b.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const c=await this.withProvider(o);if((0,b.hasOpenReadWriteCloseCapability)(c)||(0,b.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,c){try{return await this.doResolveFile(o,c)}catch(t){throw(0,b.toFileSystemProviderErrorCode)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,v.localize)(2,null,this.resourceForError(o)),1):(0,b.ensureFileSystemProviderError)(t)}}async doResolveFile(o,c){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),s=c==null?void 0:c.resolveTo,u=c==null?void 0:c.resolveSingleChildDescendants,h=c==null?void 0:c.resolveMetadata,f=await t.stat(o);let m;return this.toFileStat(t,o,f,void 0,!!h,(D,_)=>(m||(m=S.TernarySearchTree.forUris(()=>!r),m.set(o,!0),(0,y.isNonEmptyArray)(s)&&s.forEach(U=>m.set(U,!0))),Boolean(m.findSuperstr(D.resource)||m.get(D.resource))?!0:D.isDirectory&&u?_===1:!1))}async toFileStat(o,c,t,r,s,u){const{providerExtUri:h}=this.getExtUri(o),f={resource:c,name:h.basename(c),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,b.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&u(f,r)){try{const m=await o.readdir(c),D=await p.Promises.settled(m.map(async([_,U])=>{try{const q=h.joinPath(c,_),Q=s?await o.stat(q):{type:U};return await this.toFileStat(o,q,Q,m.length,s,u)}catch(q){return this.logService.trace(q),null}}));f.children=(0,y.coalesce)(D)}catch(m){this.logService.trace(m),f.children=[]}return f}return f}async resolveAll(o){return p.Promises.settled(o.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const c=await this.withProvider(o);try{return!!await c.stat(o)}catch(t){return!1}}async canCreateFile(o,c){try{await this.doValidateCreateFile(o,c)}catch(t){return t}return!0}async doValidateCreateFile(o,c){if(!(c==null?void 0:c.overwrite)&&await this.exists(o))throw new b.FileOperationError((0,v.localize)(3,null,this.resourceForError(o)),3,c)}async createFile(o,c=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,c);return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,r)),r}async writeFile(o,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,s.dirname(o));let h;if((0,b.hasReadWriteCapability)(r)&&!(c instanceof g.VSBuffer))if((0,E.isReadableStream)(c)){const f=await(0,E.peekStream)(c,3);f.ended?h=g.VSBuffer.concat(f.buffer):h=f}else h=(0,E.peekReadable)(c,f=>g.VSBuffer.concat(f),3);else h=c;!(0,b.hasOpenReadWriteCloseCapability)(r)||(0,b.hasReadWriteCapability)(r)&&h instanceof g.VSBuffer?await this.doWriteUnbuffered(r,o,t,h):await this.doWriteBuffered(r,o,t,h instanceof g.VSBuffer?(0,g.bufferToReadable)(h):h)}catch(u){throw new b.FileOperationError((0,v.localize)(4,null,this.resourceForError(o),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,c,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(c)));let s;try{s=await o.stat(c)}catch(u){return}if((s.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,v.localize)(6,null,this.resourceForError(c)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,b.etag)({mtime:t.mtime,size:s.size}))throw new b.FileOperationError((0,v.localize)(7,null),3,t);return s}async readFile(o,c){const t=await this.withReadProvider(o);return(c==null?void 0:c.atomic)?this.doReadFileAtomic(t,o,c):this.doReadFile(t,o,c)}async doReadFileAtomic(o,c,t){return new Promise((r,s)=>{this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(o,c,t);r(u)}catch(u){s(u)}})})}async doReadFile(o,c,t){const r=await this.doReadFileStream(o,c,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,g.streamToBuffer)(r.value)})}async readFileStream(o,c){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,c)}async doReadFileStream(o,c,t){const r=new d.CancellationTokenSource,s=this.validateReadFile(c,t).then(h=>h,h=>{throw r.cancel(),h});let u;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await s,!((0,b.hasOpenReadWriteCloseCapability)(o)||(0,b.hasFileReadStreamCapability)(o))||(0,b.hasReadWriteCapability)(o)&&(t==null?void 0:t.preferUnbuffered)?u=this.readFileUnbuffered(o,c,t):(0,b.hasFileReadStreamCapability)(o)?u=this.readFileStreamed(o,c,r.token,t):u=this.readFileBuffered(o,c,r.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:u})}catch(h){throw u&&await(0,E.consumeStream)(u),new b.FileOperationError((0,v.localize)(8,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(h).toString()),(0,b.toFileOperationResult)(h),t)}}readFileStreamed(o,c,t,r=Object.create(null)){const s=o.readFileStream(c,r,t);return(0,E.transform)(s,{data:u=>u instanceof g.VSBuffer?u:g.VSBuffer.wrap(u),error:u=>new b.FileOperationError((0,v.localize)(9,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),r)},u=>g.VSBuffer.concat(u))}readFileBuffered(o,c,t,r=Object.create(null)){const s=(0,g.newWriteableBufferStream)();return(0,P.readFileIntoStream)(o,c,s,u=>u,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:u=>new b.FileOperationError((0,v.localize)(10,null,this.resourceForError(c),(0,b.ensureFileSystemProviderError)(u).toString()),(0,b.toFileOperationResult)(u),r)}),t),s}readFileUnbuffered(o,c,t){const r=(0,E.newWriteableStream)(s=>g.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(c);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(c,s.byteLength,t),r.end(g.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(o,c){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError((0,v.localize)(11,null,this.resourceForError(o)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==b.ETAG_DISABLED&&c.etag===t.etag)throw new b.FileOperationError((0,v.localize)(12,null),2,c);return this.validateReadFileLimits(o,t.size,c),t}validateReadFileLimits(o,c,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&c>t.limits.size&&(r=7),typeof r=="number")throw new b.FileOperationError((0,v.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,c,t){return this.doCanMoveCopy(o,c,"move",t)}async canCopy(o,c,t){return this.doCanMoveCopy(o,c,"copy",t)}async doCanMoveCopy(o,c,t,r){if(o.toString()!==c.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(s,o,u,c,t,r)}catch(s){return s}return!0}async move(o,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),u=await this.doMoveCopy(r,o,s,c,"move",!!t),h=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,u==="move"?2:3,h)),h}async copy(o,c,t){const r=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),u=await this.doMoveCopy(r,o,s,c,"copy",!!t),h=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,u==="copy"?3:2,h)),h}async doMoveCopy(o,c,t,r,s,u){if(c.toString()===r.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,c,t,r,s,u);if(h&&!f&&u&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(o===t&&(0,b.hasFileFolderCopyCapability)(o))await o.copy(c,r,{overwrite:u});else{const m=await this.resolve(c);m.isDirectory?await this.doCopyFolder(o,m,t,r):await this.doCopyFile(o,c,t,r)}return s}else return o===t?(await o.rename(c,r,{overwrite:u}),s):(await this.doMoveCopy(o,c,t,r,"copy",u),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(o,c,t,r){if((0,b.hasOpenReadWriteCloseCapability)(o)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,c,t,r);if((0,b.hasOpenReadWriteCloseCapability)(o)&&(0,b.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,c,t,r);if((0,b.hasReadWriteCapability)(o)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,c,t,r);if((0,b.hasReadWriteCapability)(o)&&(0,b.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,c,t,r)}async doCopyFolder(o,c,t,r){await t.mkdir(r),Array.isArray(c.children)&&await p.Promises.settled(c.children.map(async s=>{const u=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),t,u):this.doCopyFile(o,s.resource,t,u)}))}async doValidateMoveCopy(o,c,t,r,s,u){let h=!1;if(o===t){const{providerExtUri:m,isPathCaseSensitive:D}=this.getExtUri(o);if(D||(h=m.isEqual(c,r)),h&&s==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(c),this.resourceForError(r)));if(!h&&m.isEqualOrParent(r,c))throw new Error((0,v.localize)(15,null,this.resourceForError(c),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!h){if(!u)throw new b.FileOperationError((0,v.localize)(16,null,this.resourceForError(c),this.resourceForError(r)),4);if(o===t){const{providerExtUri:m}=this.getExtUri(o);if(m.isEqualOrParent(c,r))throw new Error((0,v.localize)(17,null,this.resourceForError(c),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(o){const c=this.isPathCaseSensitive(o);return{providerExtUri:c?i.extUri:i.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(c,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,t)),t}async mkdirp(o,c){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(c,r.dirname(c));)try{if(((await o.stat(c)).type&b.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(c)));break}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(c)),c=r.dirname(c)}for(let s=t.length-1;s>=0;s--){c=r.joinPath(c,t[s]);try{await o.mkdir(c)}catch(u){if((0,b.toFileSystemProviderErrorCode)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(o,c){try{await this.doValidateDelete(o,c)}catch(t){return t}return!0}async doValidateDelete(o,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(c==null?void 0:c.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(o)));const s=await this.exists(o);if(!s)throw new b.FileOperationError((0,v.localize)(20,null,this.resourceForError(o)),1);if(!!!(c==null?void 0:c.recursive)&&s){const h=await this.resolve(o);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(o)))}return t}async del(o,c){const t=await this.doValidateDelete(o,c),r=!!(c==null?void 0:c.useTrash),s=!!(c==null?void 0:c.recursive);await t.delete(o,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new b.FileOperationEvent(o,1))}watch(o,c={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(o,c).then(s=>{t?(0,L.dispose)(s):r=()=>(0,L.dispose)(s)},s=>this.logService.error(s)),(0,L.toDisposable)(()=>r())}async doWatch(o,c){const t=await this.withProvider(o),r=this.toWatchKey(t,o,c),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,c)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,(0,L.toDisposable)(()=>{s.count--,s.count===0&&((0,L.dispose)(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,c,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,L.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(async()=>{var s;const u=await o.open(c,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,u,r):await this.doWriteReadableBufferedQueued(o,u,r)}catch(h){throw(0,b.ensureFileSystemProviderError)(h)}finally{await o.close(u)}})}async doWriteStreamBufferedQueued(o,c,t){let r=0,s;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,c,u,u.byteLength,r,0),r+=u.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(u,h)=>{(0,E.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,c,f,f.byteLength,r,0)}catch(m){return h(m)}r+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>h(f),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(o,c,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(o,c,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(o,c,t,r,s,u){let h=0;for(;h<r;)h+=await o.write(c,s+h,t.buffer,u+h,r-h)}async doWriteUnbuffered(o,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,c,t,r))}async doWriteUnbufferedQueued(o,c,t,r){var s;let u;r instanceof g.VSBuffer?u=r:(0,E.isReadableStream)(r)?u=await(0,g.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?u=await(0,g.bufferedStreamToBuffer)(r):u=(0,g.readableToBuffer)(r),await o.writeFile(c,u.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(o,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,c,t,r))}async doPipeBufferedQueued(o,c,t,r){let s,u;try{s=await o.open(c,{create:!1}),u=await t.open(r,{create:!0,unlock:!1});const h=g.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,m=0,D=0;do D=await o.read(s,f,h.buffer,m,h.byteLength-m),await this.doWriteBuffer(t,u,h,D,f,m),f+=D,m+=D,m===h.byteLength&&(m=0);while(D>0)}catch(h){throw(0,b.ensureFileSystemProviderError)(h)}finally{await p.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(o,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,c,t,r))}async doPipeUnbufferedQueued(o,c,t,r){return t.writeFile(r,await o.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,c,t,r))}async doPipeUnbufferedToBufferedQueued(o,c,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const u=await o.readFile(c);await this.doWriteBuffer(t,s,g.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,b.ensureFileSystemProviderError)(u)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(o,c,t,r){const s=await(0,g.streamToBuffer)(this.readFileBuffered(o,c,d.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(o,c){if(o.capabilities&2048)throw new b.FileOperationError((0,v.localize)(22,null,this.resourceForError(c)),6);return o}resourceForError(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};a=ce([ee(0,n.ILogService)],a),e.FileService=a}),define(X[177],J([0,1,18,112,2,24,5,3,19,8,15,30,9,6,139,90,159,161,158,167,63,93,35,23]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends L.Disposable{constructor(h,f){var m;super();this.logService=h,this.options=f,this.BUFFER_SIZE=((m=this.options)===null||m===void 0?void 0:m.bufferSize)||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,i.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:f,symbolicLink:m}=await S.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(f,m),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(h){try{const f=await(0,S.readdir)(this.toFilePath(h),{withFileTypes:!0}),m=[];return await Promise.all(f.map(async D=>{try{let _;D.isSymbolicLink()?_=(await this.stat((0,n.joinPath)(h,D.name))).type:_=this.toType(D),m.push([D.name,_])}catch(_){this.logService.trace(_)}})),m}catch(f){throw this.toFileSystemProviderError(f)}}toType(h,f){let m;return(f==null?void 0:f.dangling)?m=b.FileType.Unknown:h.isFile()?m=b.FileType.File:h.isDirectory()?m=b.FileType.Directory:m=b.FileType.Unknown,f&&(m|=b.FileType.SymbolicLink),m}async readFile(h){try{const f=this.toFilePath(h);return await v.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(h,f,m){const D=(0,o.newWriteableStream)(_=>r.VSBuffer.concat(_.map(U=>r.VSBuffer.wrap(U))).buffer);return(0,c.readFileIntoStream)(this,h,D,_=>_.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),m),D}async writeFile(h,f,m){let D;try{const _=this.toFilePath(h);if(!m.create||!m.overwrite){if(await(0,S.exists)(_)){if(!m.overwrite)throw(0,b.createFileSystemProviderError)((0,d.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,b.createFileSystemProviderError)((0,d.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(h,{create:!0,unlock:m.unlock}),await this.write(D,0,f,0,f.byteLength)}catch(_){throw await this.toFileSystemProviderWriteError(h,_)}finally{typeof D=="number"&&await this.close(D)}}async open(h,f){try{const m=this.toFilePath(h);if((0,b.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:U}=await S.SymlinkSupport.stat(m);U.mode&128||await v.promises.chmod(m,U.mode|128)}catch(U){this.logService.trace(U)}let D;if((0,b.isFileOpenForWriteOptions)(f)){if(i.isWindows)try{await v.promises.truncate(m,0),D="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}D||(D="w")}else D="r";const _=await(0,A.promisify)(v.open)(m,D);return this.mapHandleToPos.set(_,0),(0,b.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(_,h),_}catch(m){throw(0,b.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(h,m):this.toFileSystemProviderError(m)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,A.promisify)(v.fdatasync)(h)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,A.promisify)(v.close)(h)}catch(f){throw this.toFileSystemProviderError(f)}}async read(h,f,m,D,_){const U=this.normalizePos(h,f);let q=null;try{const Q=await(0,A.promisify)(v.read)(h,m,D,_,U);return typeof Q=="number"?q=Q:q=Q.bytesRead,q}catch(Q){throw this.toFileSystemProviderError(Q)}finally{this.updatePos(h,U,q)}}normalizePos(h,f){return f===this.mapHandleToPos.get(h)?null:f}updatePos(h,f,m){const D=this.mapHandleToPos.get(h);typeof D=="number"&&(typeof f=="number"||(typeof m=="number"?this.mapHandleToPos.set(h,D+m):this.mapHandleToPos.delete(h)))}async write(h,f,m,D,_){return(0,E.retry)(()=>this.doWrite(h,f,m,D,_),100,3)}async doWrite(h,f,m,D,_){const U=this.normalizePos(h,f);let q=null;try{const Q=await(0,A.promisify)(v.write)(h,m,D,_,U);return typeof Q=="number"?q=Q:q=Q.bytesWritten,q}catch(Q){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),Q)}finally{this.updatePos(h,U,q)}}async mkdir(h){try{await v.promises.mkdir(this.toFilePath(h))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(h,f){try{const m=this.toFilePath(h);await this.doDelete(m,f)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(h,f){f.recursive?await(0,S.rimraf)(h,S.RimRafMode.MOVE):await v.promises.unlink(h)}async rename(h,f,m){const D=this.toFilePath(h),_=this.toFilePath(f);if(D!==_)try{await this.validateTargetDeleted(h,f,"move",m.overwrite),await(0,S.move)(D,_)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(2,null,(0,y.basename)(D),(0,y.basename)((0,y.dirname)(_)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(h,f,m){const D=this.toFilePath(h),_=this.toFilePath(f);if(D!==_)try{await this.validateTargetDeleted(h,f,"copy",m.overwrite),await(0,S.copy)(D,_,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(3,null,(0,y.basename)(D),(0,y.basename)((0,y.dirname)(_)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(h,f,m,D){const _=this.toFilePath(h),U=this.toFilePath(f);let q=!1;if(!!(this.capabilities&1024)||(q=(0,g.isEqual)(_,U,!0)),q&&m==="copy")throw(0,b.createFileSystemProviderError)((0,d.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!q&&await(0,S.exists)(U)){if(!D)throw(0,b.createFileSystemProviderError)((0,d.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(h,f){return f.recursive?this.watchRecursive(h,f.excludes):this.watchNonRecursive(h)}watchRecursive(h,f){const m={path:this.toFilePath(h),excludes:f},D=(0,t.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{D(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,f,m;if(this.recursiveWatcher instanceof a.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let D,_;((f=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||f===void 0?void 0:f.usePolling)?(D=P.FileWatcher,_=(m=this.options)===null||m===void 0?void 0:m.watcher):this.recursiveFoldersToWatch.length===1?i.isWindows?D=I.FileWatcher:D=P.FileWatcher:D=a.FileWatcher,this.recursiveWatcher=new D(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,w.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===p.LogLevel.Trace,_),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)}))}}watchNonRecursive(h){const f=new l.FileWatcher(this.toFilePath(h),D=>this._onDidChangeFile.fire((0,w.toFileChanges)(D)),D=>{D.type==="error"&&this._onDidWatchErrorOccur.fire(D.message),this.logService[D.type](D.message)},this.logService.getLevel()===p.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===p.LogLevel.Trace)});return(0,L.combinedDisposable)(f,m)}toFilePath(h){return(0,y.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof b.FileSystemProviderError)return h;let f;switch(h.code){case"ENOENT":f=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=b.FileSystemProviderErrorCode.NoPermissions;break;default:f=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(h,f)}async toFileSystemProviderWriteError(h,f){let m=this.toFileSystemProviderError(f);if(h&&m.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:D}=await S.SymlinkSupport.stat(this.toFilePath(h));D.mode&128||(m=(0,b.createFileSystemProviderError)(f,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(D){this.logService.trace(D)}return m}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(X[20],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(X[178],J([0,1,58,6,20]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(i,S){this.productService=i,this.logService=S,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(i,S){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(S);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",S),!1;const[,n,g]=y;let E=this.trustedExtensionUrlPublicKeys.get(i);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[i],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",i),!1;this.trustedExtensionUrlPublicKeys.set(i,[...E])}const p=Buffer.from(decodeURIComponent(g),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",S),!1;const d=p.slice(0,6),w=p.readUIntBE(0,6),P=Date.now()-w;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",S),!1;const I=p.slice(6),a=v.createVerify("SHA256");a.write(d),a.write(Buffer.from(n)),a.end();for(let l=0;l<E.length;l++){let o=E[l];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),E[l]=o}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${l+1} for ${i}:`,c),E[l]=null;continue}if(a.verify(o,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",S),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",S),!1}};b=ce([ee(0,L.IProductService),ee(1,A.ILogService)],b),e.ExtensionUrlTrustService=b}),define(X[55],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(X[179],J([0,1,2,10,7,46,13,6,36,3,15,28]),function(H,e,v,A,L,b,M,i,S,y,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends v.Disposable{constructor(d,w){super();this.logService=w,this.validRoots=S.TernarySearchTree.forUris(()=>!y.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(L.URI.file(d.appRoot)),this.addValidFileRoot(L.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=M.session;d.protocol.registerFileProtocol(A.Schemas.vscodeFileResource,(w,P)=>this.handleResourceRequest(w,P)),d.protocol.interceptFileProtocol(A.Schemas.file,(w,P)=>this.handleFileRequest(w,P)),this._register((0,v.toDisposable)(()=>{d.protocol.unregisterProtocol(A.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(A.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?v.Disposable.None:(this.validRoots.set(d,!0),(0,v.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,w){const P=L.URI.parse(d.url);return y.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${P.fsPath} from ${A.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3})):this.validRoots.findSubstr(P)?w({path:P.fsPath}):this.validExtensions.has((0,n.extname)(P))?w({path:P.fsPath}):(this.logService.error(`${A.Schemas.file}: Refused to load resource ${P.fsPath} from ${A.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3}))}handleResourceRequest(d,w){const P=L.URI.parse(d.url),I=A.FileAccess.asFileUri(P);return this.validRoots.findSubstr(I)?w({path:I.fsPath}):this.validExtensions.has((0,n.extname)(I))?w({path:I.fsPath}):(this.logService.error(`${A.Schemas.vscodeFileResource}: Refused to load resource ${I.fsPath} from ${A.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),w({error:-3}))}createIPCObjectUrl(d){const w=L.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),P=w.toString(),I=async()=>d;return M.ipcMain.handle(P,I),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:w,update:a=>d=a,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),M.ipcMain.removeHandler(P)}}}};E=ce([ee(0,b.INativeEnvironmentService),ee(1,i.ILogService)],E),e.ProtocolMainService=E}),define(X[37],J([0,1,12,100]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(M,i){A.ok(v.isString(M)),A.ok(v.isObject(i)),A.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,i)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new L}),define(X[180],J([0,1,37,5]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(i){return i.length>0&&i.charAt(i.length-1)==="#"?i.substring(0,i.length-1):i}class b{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,y){this.schemasById[L(S)]=y,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new b;v.Registry.add(e.Extensions.JSONContribution,M)}),define(X[48],J([0,1,130,5,37,12,180]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var i;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(i=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=L.Registry.as(M.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,a=!0){this.registerConfigurations([I],a)}registerConfigurations(I,a=!0){const l=[];I.forEach(o=>{l.push(...this.validateAndRegisterProperties(o,a,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(I){const a=[],l=o=>{if(o.properties)for(const c in o.properties)a.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,o.properties[c]);o.allOf&&o.allOf.forEach(c=>l(c))};for(const o of I){l(o);const c=this.configurationContributors.indexOf(o);c!==-1&&this.configurationContributors.splice(c,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(I){const a=[],l=[];for(const o of I)for(const c in o)if(a.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),o[c]);const t={type:"object",default:this.defaultValues[c],description:v.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};l.push(g(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=o[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(I){const a=[];for(const l of I)for(const o in l)if(a.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const a of I)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,a=!0,l,o=3){var c;o=b.isUndefinedOrNull(I.scope)?o:I.scope;let t=[],r=I.properties;if(r)for(let u in r){if(a&&d(u)){delete r[u];continue}const h=r[u];if(this.updatePropertyDefaultValue(u,h),e.OVERRIDE_PROPERTY_PATTERN.test(u)?h.scope=void 0:(h.scope=b.isUndefinedOrNull(h.scope)?o:h.scope,h.requireTrust=b.isUndefinedOrNull(h.requireTrust)?!!((c=l==null?void 0:l.requireTrustForConfigurations)===null||c===void 0?void 0:c.includes(u)):h.requireTrust),r[u].hasOwnProperty("included")&&!r[u].included){this.excludedConfigurationProperties[u]=r[u],delete r[u];continue}else this.configurationProperties[u]=r[u];!r[u].deprecationMessage&&r[u].markdownDeprecationMessage&&(r[u].deprecationMessage=r[u].markdownDeprecationMessage),t.push(u)}let s=I.allOf;if(s)for(let u of s)t.push(...this.validateAndRegisterProperties(u,a,l,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const a=l=>{let o=l.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let c=l.allOf;c&&c.forEach(a)};a(I)}updateSchema(I,a){switch(e.allSettings.properties[I]=a,a.scope){case 1:e.applicationSettings.properties[I]=a;break;case 2:e.machineSettings.properties[I]=a;break;case 6:e.machineOverridableSettings.properties[I]=a;break;case 3:e.windowSettings.properties[I]=a;break;case 4:e.resourceSettings.properties[I]=a;break;case 5:e.resourceSettings.properties[I]=a,this.resourceLanguageSettingsSchema.properties[I]=a;break}}removeFromSchema(I,a){switch(delete e.allSettings.properties[I],a.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const a=`[${I}]`,l={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,l),e.allSettings.properties[a]=l,e.applicationSettings.properties[a]=l,e.machineSettings.properties[a]=l,e.machineOverridableSettings.properties[a]=l,e.windowSettings.properties[a]=l,e.resourceSettings.properties[a]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,a){let l=this.defaultValues[I];b.isUndefined(l)&&(l=a.default),b.isUndefined(l)&&(l=E(a.type)),a.default=l}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function g(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=g;function E(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const p=new y;L.Registry.add(e.Extensions.Configuration,p);function d(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?v.localize(5,null,P):p.getConfigurationProperties()[P]!==void 0?v.localize(6,null,P):null:v.localize(4,null)}e.validateProperty=d;function w(){const P=[],I=p.getConfigurationProperties();for(const a of Object.keys(I))P.push([a,I[a].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=w}),define(X[21],J([0,1,44,12,7,37,4,48]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,M.createDecorator)("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=S;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function g(r,s){const u=s?r?s.keys.filter(q=>r.keys.indexOf(q)===-1):[...s.keys]:[],h=r?s?r.keys.filter(q=>s.keys.indexOf(q)===-1):[...r.keys]:[],f=[];if(s&&r){for(const q of r.keys)if(s.keys.indexOf(q)!==-1){const Q=I(r.contents,q),ie=I(s.contents,q);v.equals(Q,ie)||f.push(q)}}const m=[],D=q=>{const Q={};for(const ie of q)for(const ae of ie.identifiers)Q[c(ae)]=ie;return Q},_=s?D(s.overrides):{},U=r?D(r.overrides):{};if(Object.keys(_).length)for(const q of u){const Q=_[q];Q&&m.push([(0,i.overrideIdentifierFromKey)(q),Q.keys])}if(Object.keys(U).length)for(const q of h){const Q=U[q];Q&&m.push([(0,i.overrideIdentifierFromKey)(q),Q.keys])}if(Object.keys(_).length&&Object.keys(U).length)for(const q of f){const Q=U[q],ie=_[q];if(Q&&ie){const ae=g({contents:Q.contents,keys:Q.keys,overrides:[]},{contents:ie.contents,keys:ie.keys,overrides:[]});m.push([(0,i.overrideIdentifierFromKey)(q),[...ae.added,...ae.removed,...ae.updated]])}}return{added:u,removed:h,updated:f,overrides:m}}e.compare=g;function E(r,s){const u=[];for(const h of Object.keys(r))if(i.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const m in r[h])f[m]=r[h][m];u.push({identifiers:[(0,i.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(f),contents:p(f,s)})}return u}e.toOverrides=E;function p(r,s){const u=Object.create(null);for(let h in r)d(u,h,r[h],s);return u}e.toValuesTree=p;function d(r,s,u,h){const f=s.split("."),m=f.pop();let D=r;for(let _=0;_<f.length;_++){let U=f[_],q=D[U];switch(typeof q){case"undefined":q=D[U]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${f.slice(0,_+1).join(".")} is ${JSON.stringify(q)}`);return}D=q}if(typeof D=="object"&&D!==null)try{D[m]=u}catch(_){h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}else h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function w(r,s){const u=s.split(".");P(r,u)}e.removeFromValueTree=w;function P(r,s){const u=s.shift();if(s.length===0){delete r[u];return}if(Object.keys(r).indexOf(u)!==-1){const h=r[u];typeof h=="object"&&!Array.isArray(h)&&(P(h,s),Object.keys(h).length===0&&delete r[u])}}function I(r,s,u){function h(D,_){let U=D;for(const q of _){if(typeof U!="object"||U===null)return;U=U[q]}return U}const f=s.split("."),m=h(r,f);return typeof m=="undefined"?u:m}e.getConfigurationValue=I;function a(r,s,u){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in r?A.isObject(r[h])&&A.isObject(s[h])?a(r[h],s[h],u):u&&(r[h]=s[h]):r[h]=s[h])})}e.merge=a;function l(){const r=b.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=l;function o(){const r=Object.create(null),s=b.Registry.as(i.Extensions.Configuration).getConfigurationProperties();for(let u in s){let h=s[u].default;d(r,u,h,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=o;function c(r){return`[${r}]`}e.keyFromOverrideIdentifier=c;function t(r,s,u){const h=r.inspect(s),f=r.inspect(u);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(X[181],J([0,1,43,36,35,12,44,7,48,21,37,2,5]),function(H,e,v,A,L,b,M,i,S,y,n,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,y.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?(0,y.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const u of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[u],f=r[u];f&&(typeof h=="object"&&typeof f=="object"?(h=M.deepClone(h),this.mergeContents(h,f)):h=f),s[u]=h}return new p(s,this.keys,this.overrides)}merge(...t){const r=M.deepClone(this.contents),s=M.deepClone(this.overrides),u=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const f of h.overrides){const[m]=s.filter(D=>L.equals(D.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):s.push(M.deepClone(f))}for(const f of h.keys)u.indexOf(f)===-1&&u.push(f)}return new p(r,u,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&b.isObject(t[s])&&b.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=M.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?M.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,y.addToValueTree)(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,y.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class d extends p{constructor(){const t=(0,y.getDefaultValues)(),r=(0,y.getConfigurationKeys)(),s=[];for(const u of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(u)&&s.push({identifiers:[(0,S.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(t[u]),contents:(0,y.toValuesTree)(t[u],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,s)}}e.DefaultConfigurationModel=d;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!b.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:u,overrides:h,untrusted:f}=this.doParseRaw(t,r);this._configurationModel=new p(s,u,h),this._untrustedConfigurations=f||[]}doParseContent(t){let r={},s=null,u=[],h=[],f=[];function m(_){Array.isArray(u)?u.push(_):s&&(u[s]=_)}let D={onObjectBegin:()=>{let _={};m(_),h.push(u),u=_,s=null},onObjectProperty:_=>{s=_},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{let _=[];m(_),h.push(u),u=_,s=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:m,onError:(_,U,q)=>{f.push({error:_,offset:U,length:q})}};if(t)try{v.visit(t,D),r=u[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return r}doParseRaw(t,r){const s=n.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),u=this.filter(t,s,!0,r);t=u.raw;const h=(0,y.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(t),m=(0,y.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:h,keys:f,overrides:m,untrusted:u.untrusted}}filter(t,r,s,u){if(!(u==null?void 0:u.scopes)&&!(u==null?void 0:u.isUntrusted))return{raw:t,untrusted:[]};const h={},f=[];for(let m in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const D=this.filter(t[m],r,!1,u);h[m]=D.raw,f.push(...D.untrusted)}else{const D=r[m],_=D?typeof D.scope!="undefined"?D.scope:3:void 0;(_===void 0||u.scopes===void 0||u.scopes.includes(_))&&(u.isUntrusted&&(D==null?void 0:D.requireTrust)?f.push(m):h[m]=t[m])}return{raw:h,untrusted:f}}}e.ConfigurationModelParser=w;class P extends g.Disposable{constructor(t,r,s,u){super();this.userSettingsResource=t,this.scopes=r,this.fileService=u,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=P;class I{constructor(t,r,s=new p,u=new p,h=new A.ResourceMap,f=new p,m=new A.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=u,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let u;s.resource?(u=this._memoryConfigurationByResource.get(s.resource),u||(u=new p,this._memoryConfigurationByResource.set(s.resource,u))):u=this._memoryConfiguration,r===void 0?u.removeValue(t):u.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const u=this.getConsolidateConfigurationModel(r,s),h=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,m=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),_=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),q=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Q=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,ie=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),ae=u.getValue(t),O=L.distinct(L.flatten(u.overrides.map($=>$.identifiers))).filter($=>u.getOverrideValue(t,$)!==void 0);return{defaultValue:m,userValue:D,userLocalValue:_,userRemoteValue:U,workspaceValue:q,workspaceFolderValue:Q,memoryValue:ie,value:ae,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:Q!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(u=>S.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const h=(0,S.overrideIdentifierFromKey)(u),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),m=t.getKeysForOverrideIdentifier(h),D=[...m.filter(_=>f.indexOf(_)===-1),...f.filter(_=>m.indexOf(_)===-1),...f.filter(_=>!M.equals(this._defaultConfiguration.override(h).getValue(_),t.override(h).getValue(_)))];return[h,D]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:u,overrides:h}=(0,y.compare)(this.localUserConfiguration,t),f=[...r,...s,...u];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:u,overrides:h}=(0,y.compare)(this.remoteUserConfiguration,t);let f=[...r,...s,...u];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:u,overrides:h}=(0,y.compare)(this.workspaceConfiguration,t);let f=[...r,...s,...u];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:u,updated:h,removed:f,overrides:m}=(0,y.compare)(s,r);let D=[...u,...h,...f];return(D.length||!s)&&this.updateFolderConfiguration(t,r),{keys:D,overrides:m}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:u,removed:h,overrides:f}=(0,y.compare)(r,void 0);return{keys:[...s,...u,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const u=r.getFolder(t);u&&(s=this.getFolderConsolidatedConfiguration(u.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(r=s.merge(u),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:u,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:u,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,m)=>(f.set(i.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new A.ResourceMap);return new I(r,s,new p,u,h,new p,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function a(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,r=new Map;for(const u of c)u.keys.forEach(h=>t.add(h)),u.overrides.forEach(([h,f])=>{const m=(0,A.getOrSet)(r,h,new Set);f.forEach(D=>m.add(D))});const s=[];return r.forEach((u,h)=>s.push([h,[...u.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=a;class l{constructor(t,r,s,u){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=u,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(m=>h.add(m)),t.overrides.forEach(([,m])=>m.forEach(D=>h.add(D))),this.affectedKeys=[...h.values()];const f=new p;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!M.equals(u,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=(0,y.toValuesTree)({[r]:!0},()=>{}),u;for(;typeof s=="object"&&(u=Object.keys(s)[0]);){if(t=t[u],!t)return!1;s=s[u]}return!0}}e.ConfigurationChangeEvent=l;class o extends l{constructor(t,r,s,u){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=o}),define(X[182],J([0,1,37,48,2,21,181,5,9,15]),function(H,e,v,A,L,b,M,i,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(E,p){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new M.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,p)),this.configuration=new M.Configuration(new M.DefaultConfigurationModel,new M.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new M.Configuration(new M.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,p){const d=typeof E=="string"?E:void 0,w=(0,b.isConfigurationOverrides)(E)?E:(0,b.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(d,w,void 0)}updateValue(E,p,d,w){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,p,1)}onDidDefaultConfigurationChange(E){const p=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new M.DefaultConfigurationModel,E);this.trigger(d,p,6)}trigger(E,p,d){const w=new M.ConfigurationChangeEvent(E,{data:p},this.configuration);w.source=d,w.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(X[183],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var A;(function(M){M[M.Unknown=0]="Unknown",M[M.DisableTrust=1]="DisableTrust",M[M.MachineTrusted=2]="MachineTrusted"})(A=e.RemoteTrustOption||(e.RemoteTrustOption={}));var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(i,S=L.Unknown,y){super(i);this._message=i,this._code=S,this._detail=y,this.isHandled=S===L.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(i){return i instanceof b&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof b&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof b&&i.isHandled}}e.RemoteAuthorityResolverError=b}),define(X[184],J([0,1,83,28,2,23,5,183,17,9,25]),function(H,e,v,A,L,b,M,i,S,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var E;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function p(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(k){const F=new n.CancellationTokenSource;return setTimeout(()=>F.cancel(),k),F.token}function w(k,F){if(k.isCancellationRequested||F.isCancellationRequested)return n.CancellationToken.Cancelled;const B=new n.CancellationTokenSource;return k.onCancellationRequested(()=>B.cancel()),F.onCancellationRequested(()=>B.cancel()),B.token}class P{constructor(F){this._state="pending",this._disposables=new L.DisposableStore,this.promise=new Promise((B,V)=>{this._resolvePromise=B,this._rejectPromise=V}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function I(k,F){const B=new P(F);return B.registerDisposable(k.onControlMessage(V=>{const G=JSON.parse(V.toString()),Y=j(G);Y?B.reject(Y):B.resolve(G)})),B.promise}function a(k,F,B,V,G,Y){const Z=new P(Y);return F.connect(B,V,G,(re,se)=>{Z.didTimeout?(re&&k.error(re),se==null||se.dispose()):re||!se?Z.reject(re):Z.resolve(se)}),Z.promise}function l(k,F){const B=new P(F);return k.then(V=>{B.didTimeout||B.resolve(V)},V=>{B.didTimeout||B.reject(V)}),B.promise}async function o(k,F,B,V){const G=R(k,F);k.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,V)}catch(x){throw k.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),k.logService.error(x),x}k.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,re;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=k.reconnectionProtocol,re=!1):(Z=new v.PersistentProtocol(Y,null),re=!0),k.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:k.connectionToken||"00000000000000000000"};Z.sendControl(b.VSBuffer.fromString(JSON.stringify(se)));try{const x=await I(Z,w(V,d(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}k.logService.trace(`${G} 4/6. received SignRequest control message.`);const ne=await l(k.signService.sign(x.data),V),ue={type:"connectionType",commit:k.commit,signedData:ne,desiredConnectionType:F};return B&&(ue.args=B),k.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(b.VSBuffer.fromString(JSON.stringify(ue))),{protocol:Z,ownsProtocol:re}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(k.logService.error(`${G} the handshake timed out. Error:`),k.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${G} received error control message when negotiating connection. Error:`),k.logService.error(x)),re&&C(Z),x}}async function c(k,F,B,V){const G=Date.now(),Y=R(k,F),{protocol:Z,ownsProtocol:re}=await o(k,F,B,V),se=new P(V);return se.registerDisposable(Z.onControlMessage(x=>{const ne=JSON.parse(x.toString()),ue=j(ne);ue?(k.logService.error(`${Y} received error control message when negotiating connection. Error:`),k.logService.error(ue),re&&C(Z),se.reject(ue)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(G)}!`),se.resolve({protocol:Z,firstMessage:ne}))})),se.promise}async function t(k,F){const{protocol:B}=await c(k,1,void 0,F);return{protocol:B}}async function r(k,F,B){const{protocol:V,firstMessage:G}=await c(k,2,F,B),Y=G&&G.debugPort;return{protocol:V,debugPort:Y}}async function s(k,F,B){const V=Date.now(),G=R(k,3),{protocol:Y}=await o(k,3,F,B);return k.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${W(V)}!`),Y}async function u(k,F,B){const{host:V,port:G,connectionToken:Y}=await k.addressProvider.getAddress();return{commit:k.commit,host:V,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:B,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function h(k,F,B){try{const V=(0,A.generateUuid)(),G=await u(k,V,null),{protocol:Y}=await t(G,n.CancellationToken.None);return new $(k,F,B,V,Y)}catch(V){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(V),O.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=h;async function f(k,F){try{const B=(0,A.generateUuid)(),V=await u(k,B,null),{protocol:G,debugPort:Y}=await r(V,F,n.CancellationToken.None);return new z(k,F,B,G,Y)}catch(B){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(B),O.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=f;async function m(k,F){const B=await u(k,(0,A.generateUuid)(),null);return await s(B,{port:F},n.CancellationToken.None)}e.connectRemoteAgentTunnel=m;function D(k){return(0,y.createCancelablePromise)(F=>new Promise((B,V)=>{const G=setTimeout(B,k*1e3);F.onCancellationRequested(()=>{clearTimeout(G),B()})}))}var _;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(_=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(F,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=U;class q{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.durationSeconds=V,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=q;class Q{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=Q;class ie{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=4}}e.ConnectionGainEvent=ie;class ae{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class O extends L.Disposable{constructor(F,B,V,G){super();this._connectionType=F,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=V,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new ie(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),O._instances.push(this),O._permanentFailure&&this._gotoPermanentFailure(O._permanentFailureMillisSinceLastIncomingData,O._permanentFailureAttempt,O._permanentFailureHandled)}static triggerPermanentFailure(F,B,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=B,this._permanentFailureHandled=V,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!O._permanentFailure){const F=T(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30],V=Date.now();let G=-1;do{G++;const Y=G<B.length?B[G]:B[B.length-1];try{if(Y>0){const re=D(Y);this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,re)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await re}catch(se){}}if(O._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const Z=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,d(g)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-V>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,S.isPromiseCanceledError)(Z)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,i.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!O._permanentFailure)}}_gotoPermanentFailure(F,B,V){this._onDidStateChange.fire(new ae(this.reconnectionToken,F,B,V)),C(this.protocol)}}O._permanentFailure=!1,O._permanentFailureMillisSinceLastIncomingData=0,O._permanentFailureAttempt=0,O._permanentFailureHandled=!1,O._instances=[];class $ extends O{constructor(F,B,V,G,Y){super(1,F,G,Y);this.client=this._register(new v.Client(Y,{remoteAuthority:B,clientId:V},F.ipcLogger))}async _reconnect(F,B){await t(F,B)}}e.ManagementPersistentConnection=$;class z extends O{constructor(F,B,V,G,Y){super(2,F,V,G);this._startArguments=B,this.debugPort=Y}async _reconnect(F,B){await r(F,this._startArguments,B)}}e.ExtensionHostPersistentConnection=z;function C(k){try{k.acceptDisconnect();const F=k.getSocket();k.dispose(),F.dispose()}catch(F){(0,S.onUnexpectedError)(F)}}function j(k){if(k&&k.type==="error"){const F=new Error(`Connection error: ${k.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function N(k,F){for(;k.length<F;)k+=" ";return k}function T(k,F,B){return`[remote-connection][${N(p(k),13)}][${F.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function R(k,F){return`${T(F,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function W(k){return`${Date.now()-k} ms`}}),define(X[72],J([0,1,10]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function A(S){return S.scheme===v.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=A;function L(S){if(!!S){const y=S.indexOf("+");return y<0?S:S.substr(0,y)}}e.getRemoteName=L;function b(S){return S.scheme!==v.Schemas.file&&S.scheme!==v.Schemas.vscodeRemote}function M(S){if(S.folders.length)return S.folders.every(y=>b(y.uri))?S.folders[0].uri:void 0;if(S.configuration&&b(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=M;function i(S){var y;return(y=M(S))===null||y===void 0?void 0:y.scheme}e.getVirtualWorkspaceScheme=i}),define(X[73],J([0,1,5,3,4,6]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService");var M;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(M=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function i(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!p)return{address:p[1],port:+p[2]}}}e.extractLocalHostUriMetaDataForPortMapping=i,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=y;function n(E,p){return p?p!==1&&E<1024:!A.isWindows&&E<1024}e.isPortPrivileged=n;let g=class{constructor(p){this.logService=p,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(p,d){return this._tunnelProvider=p,p?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async p=>{const d=[],w=Array.from(this._tunnels.values());for(let P of w){const I=Array.from(P.values());for(let a of I){const l=await a.value;l&&d.push(l)}}p(d)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:d}of p.values())await d.then(w=>w==null?void 0:w.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,d,w,P,I=!1,a=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${w} on local port ${P}.`),!!p){d||(d="localhost");const l=this.retainOrCreateTunnel(p,d,w,P,I,a);return l?l.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(o);return(o.tunnelRemoteHost!==d||o.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,public:p.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemotePort} `);const d=this._tunnels.get(p.tunnelRemoteHost);if(d){const w=d.get(p.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,w))}}}}async tryDisposeTunnel(p,d,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${d}.`);const P=w.value.then(async I=>{I&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(d),P}}async closeTunnel(p,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d} `);const w=this._tunnels.get(p);if(w&&w.has(d)){const P=w.get(d);P.refcount=0,await this.tryDisposeTunnel(p,d,P)}}addTunnelToMap(p,d,w){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(d,{refcount:1,value:w})}async removeEmptyTunnelFromMap(p,d){const w=this._tunnels.get(p);w&&(await w.get(d)||w.delete(d),w.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,d){let w=[p];S(p)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):y(p)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const P=w.map(I=>this._tunnels.get(I));for(const I of P){const a=I==null?void 0:I.get(d);if(a)return a}}canTunnel(p){return!!i(p)}createWithProvider(p,d,w,P,I,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${w} on local port ${P}.`);const o={elevationRequired:I?n(P===void 0?w:P):!1},c={remoteAddress:{host:d,port:w},localAddressPort:P,public:a},t=p.forwardPort(c,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,w,t),t}};g=ce([ee(0,b.ILogService)],g),e.AbstractTunnelService=g}),define(X[49],J([0,1,142,4,48,37,23]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function i(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=i;function S(d){return d.res.statusCode===204}async function y(d){if(!i(d))throw new Error("Server returned "+d.res.statusCode);return S(d)?null:(await(0,M.streamToBuffer)(d.stream)).toString()}e.asText=y;async function n(d){if(!i(d))throw new Error("Server returned "+d.res.statusCode);if(S(d))return null;const P=(await(0,M.streamToBuffer)(d.stream)).toString();try{return JSON.parse(P)}catch(I){throw I.message+=`:
`+P,I}}e.asJson=n;function g(d){p(d)}e.updateProxyConfigurationsScope=g;let E;function p(d){const w=b.Registry.as(L.Extensions.Configuration);E&&w.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,v.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null),requireTrust:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null),requireTrust:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null),requireTrust:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null),(0,v.localize)(7,null)],default:"override",description:(0,v.localize)(8,null),requireTrust:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(9,null),requireTrust:!0}}},w.registerConfiguration(E)}p(2)}),define(X[185],J([0,1,186,12]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(M,i){return M.protocol==="http:"?i.HTTP_PROXY||i.http_proxy||null:M.protocol==="https:"&&(i.HTTPS_PROXY||i.https_proxy||i.HTTP_PROXY||i.http_proxy)||null}async function b(M,i,S={}){const y=(0,v.parse)(M),n=S.proxyUrl||L(y,i);if(!n)return null;const g=(0,v.parse)(n);if(!/^https?:$/.test(g.protocol||""))return null;const E={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,A.isBoolean)(S.strictSSL)?S.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((p,d)=>{H(["http-proxy-agent"],p,d)}))(E):new(await new Promise((p,d)=>{H(["https-proxy-agent"],p,d)}))(E)}e.getProxyAgent=b}),define(X[187],J([0,1,28,23]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(b,M,i){let S=i&&i.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await M.readFile(b.serviceMachineIdResource)).value.toString();S=(0,v.isUUID)(n)?n:null}catch(y){S=null}if(!S){S=(0,v.generateUuid)();try{await M.writeFile(b.serviceMachineIdResource,A.VSBuffer.fromString(S))}catch(y){}}return i&&i.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=L}),define(X[74],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[188],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((L,b)=>H(["vsda"],L,b))}async sign(L){try{const b=await this.vsda(),M=new b.signer;if(M)return M.sign(L)}catch(b){}return L}}e.SignService=v}),define(X[38],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(X[16],J([0,1,13,6,38,5,4,171,3,2,9,12,32]),function(H,e,v,A,L,b,M,i,S,y,n,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,M.createDecorator)("lifecycleMainService");var p;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var d;(function(P){P[P.Starting=1]="Starting",P[P.Ready=2]="Ready",P[P.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class it extends y.Disposable{constructor(I,a){super();this.logService=I,this.stateService=a,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(it.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(it.QUIT_FROM_RESTART_MARKER)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),S.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",I);const a=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!S.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",a),v.app.once("will-quit",l=>{this.logService.trace("Lifecycle#app.on(will-quit)"),l.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",I),v.app.removeListener("window-all-closed",a),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(a){I.push(a)}}),this.pendingWillShutdownPromise=n.Promises.settled(I).then(()=>{},a=>this.logService.error(a)),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==I){this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const a=this.phaseWhen.get(this._phase);a&&(a.open(),this.phaseWhen.delete(this._phase))}}async when(I){if(!(I<=this._phase)){let a=this.phaseWhen.get(I);a||(a=new n.Barrier,this.phaseWhen.set(I,a)),await a.wait()}}registerWindow(I){const a=new y.DisposableStore;this.windowCounter++,a.add(I.onWillLoad(o=>this._onWillLoadWindow.fire({window:I,workspace:o.workspace})));const l=(0,g.assertIsDefined)(I.win);l.on("close",o=>{const c=I.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),o.preventDefault(),this.unload(I,1).then(t=>{if(t){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(I),I.close()})}),l.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,a.dispose(),this.windowCounter===0&&(!S.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,a){await this.unload(I,3)||I.reload(a)}async unload(I,a){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const l=this._quitRequested?2:a;let o=await this.onBeforeUnloadWindowInRenderer(I,l);return o?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(o)):(o=await this.onBeforeUnloadWindowInMain(I,l),o?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(o)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,l),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(I,a){return new Promise(l=>{const o=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${o}`,t=`vscode:cancel${o}`;v.ipcMain.once(c,()=>{l(!1)}),v.ipcMain.once(t,()=>{l(!0)}),I.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:t,reason:a})})}onBeforeUnloadWindowInMain(I,a){const l=[];return this._onBeforeUnloadWindow.fire({reason:a,window:I,veto(o){l.push(o)}}),(0,i.handleVetos)(l,o=>this.logService.error(o))}onWillUnloadWindowInRenderer(I,a){return new Promise(l=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(c,()=>l()),I.send("vscode:onWillUnload",{replyChannel:c,reason:a})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${I}`),I&&this.stateService.setItem(it.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(a=>{this.pendingQuitPromiseResolve=a,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}relaunch(I){this.logService.trace("Lifecycle#relaunch()");const a=process.argv.slice(1);if((I==null?void 0:I.addArgs)&&a.push(...I.addArgs),I==null?void 0:I.removeArgs)for(const o of I.removeArgs){const c=a.indexOf(o);c>=0&&a.splice(c,1)}let l=!1;v.app.once("quit",()=>{if(!l){this.stateService.setItem(it.QUIT_FROM_RESTART_MARKER,!0);try{if(S.isWindows){const o=(0,E.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:a})}}),this.quit().then(o=>l=o)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const a of v.BrowserWindow.getAllWindows())if(a&&!a.isDestroyed()){let l;a.webContents&&!a.webContents.isDestroyed()?l=new Promise(o=>a.once("closed",o)):l=Promise.resolve(),a.destroy(),await l}})()]),v.app.exit(I)}};w.QUIT_FROM_RESTART_MARKER="quit.from.restart",w=ce([ee(0,A.ILogService),ee(1,L.IStateService)],w),e.LifecycleMainService=w}),define(X[189],J([0,1,4,5,2,16]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,v.createDecorator)("keyboardLayoutMainService");let M=class extends L.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((n,g)=>{H(["native-keymap"],n,g)});this._keyboardLayoutData=i(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=i(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ce([ee(0,b.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function i(S){const y=S.getKeyMap(),n=S.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:n}}}),define(X[190],J([0,1,8,18,46,19,12,6]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class S{constructor(g,E){this.dbPath=g,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=A.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await A.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,E){const p=this.database[g];return(0,M.isUndefinedOrNull)(p)?E:p}setItem(g,E){if((0,M.isUndefinedOrNull)(E))return this.removeItem(g);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[g]===E||(this.database[g]=E,this.saveSync())}removeItem(g){(0,M.isUndefined)(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{(0,b.writeFileSync)(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(E){this.onError(E)}}}e.FileStorage=S;let y=class wt{constructor(g,E){this.fileStorage=new S(v.join(g.userDataPath,wt.STATE_FILE),p=>E.error(p))}init(){return this.fileStorage.init()}getItem(g,E){return this.fileStorage.getItem(g,E)}setItem(g,E){this.fileStorage.setItem(g,E)}removeItem(g){this.fileStorage.removeItem(g)}};y.STATE_FILE="storage.json",y=ce([ee(0,L.INativeEnvironmentService),ee(1,i.ILogService)],y),e.StateService=y}),define(X[94],J([0,1,4,5,2,12,85,9]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var y;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var g;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class E extends L.Disposable{constructor(P={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new i.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,i.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,I){I===S?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:I,target:this.getKeyTargets(P)[I]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,I,a){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.get(P,a)}getBoolean(P,I,a){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.getBoolean(P,a)}getNumber(P,I,a){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.getNumber(P,a)}store(P,I,a,l){if((0,b.isUndefinedOrNull)(I)){this.remove(P,a);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(P,a,l),(o=this.getStorage(a))===null||o===void 0||o.set(P,I)})}remove(P,I){this.withPausedEmitters(()=>{var a;this.updateKeyTarget(P,I,void 0),(a=this.getStorage(I))===null||a===void 0||a.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,I){const a=[],l=this.getKeyTargets(P);for(const o of Object.keys(l))l[o]===I&&a.push(o);return a}updateKeyTarget(P,I,a){var l,o;const c=this.getKeyTargets(I);typeof a=="number"?c[P]!==a&&(c[P]=a,(l=this.getStorage(I))===null||l===void 0||l.set(S,JSON.stringify(c))):typeof c[P]=="number"&&(delete c[P],(o=this.getStorage(I))===null||o===void 0||o.set(S,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const I=this.get(S,P);if(I)try{return JSON.parse(I)}catch(a){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){var P,I,a,l;this._onWillSaveState.fire({reason:y.NONE}),await i.Promises.settled([(I=(P=this.getStorage(0))===null||P===void 0?void 0:P.whenFlushed())!==null&&I!==void 0?I:Promise.resolve(),(l=(a=this.getStorage(1))===null||a===void 0?void 0:a.whenFlushed())!==null&&l!==void 0?l:Promise.resolve()])}async logStorage(){var P,I,a,l,o,c;const t=(I=(P=this.getStorage(0))===null||P===void 0?void 0:P.items)!==null&&I!==void 0?I:new Map,r=(l=(a=this.getStorage(1))===null||a===void 0?void 0:a.items)!==null&&l!==void 0?l:new Map;return d(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(c=this.getLogDetails(1))!==null&&c!==void 0?c:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends E{constructor(){super();this.globalStorage=new M.Storage(new M.InMemoryStorageDatabase),this.workspaceStorage=new M.Storage(new M.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=p;async function d(w,P,I,a){const l=h=>{try{return JSON.parse(h)}catch(f){return h}},o=new Map,c=new Map;w.forEach((h,f)=>{o.set(f,h),c.set(f,l(h))});const t=new Map,r=new Map;P.forEach((h,f)=>{t.set(f,h),r.set(f,l(h))}),console.group(`Storage: Global (path: ${I})`);let s=[];o.forEach((h,f)=>{s.push({key:f,value:h})}),console.table(s),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${a})`);let u=[];t.forEach((h,f)=>{u.push({key:f,value:h})}),console.table(u),console.groupEnd(),console.log(r)}e.logStorage=d}),define(X[191],J([0,1,3,32,28,7]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function M(y){if(v.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function i(y,n,g,E,p,d,w,P,I,a){const l=Object.create(null);l["common.machineId"]=w,l.sessionID=(0,L.generateUuid)()+Date.now(),l.commitHash=p,l.version=d,l["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.PlatformToString)(v.platform),l["common.nodePlatform"]=A.platform,l["common.nodeArch"]=E,l["common.product"]=a||"desktop";const o=S(P||[]);o&&(l["common.msftInternal"]=o);let c=0;const t=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(l["common.snap"]="true");const r=M(g);r&&(l["common.platformDetail"]=r);try{const s=await y.readFile(b.URI.file(I));l["common.source"]=s.value.toString().slice(0,30)}catch(s){}return l}e.resolveCommonProperties=i;function S(y){const n=A.env.USERDNSDOMAIN;if(!n)return!1;const g=n.toLowerCase();return y.some(E=>g===E)}}),define(X[31],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[192],J([0,1,27,65,68,18,8,43,82,20,3,7,31,62,10,24,19]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(t,r){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],u=new Map,h=new Map,f=2e4;function m(U,q,Q,ie){const ae=q.substring(U.length+1);return new Promise(async O=>{var $,z,C;let j;try{j=await(0,P.readdir)(q,{withFileTypes:!0})}catch(R){O();return}if(ie.count>=f){ie.count+=j.length,ie.maxReached=!0,O();return}let N=j.length;if(N===0){O();return}let T=j;ie.count+j.length>f&&(ie.maxReached=!0,N=f-ie.count,T=j.slice(0,N)),ie.count+=j.length;for(const R of T)if(R.isDirectory()){if(Q.includes(R.name)||await m(U,(0,M.join)(q,R.name),Q,ie),--N==0){O();return}}else{const W=R.name.lastIndexOf(".");if(W>=0){const k=R.name.substring(W+1);k&&u.set(k,(($=u.get(k))!==null&&$!==void 0?$:0)+1)}for(const k of s)((z=k.relativePathPattern)===null||z===void 0?void 0:z.test(ae))!==!1&&k.filePattern.test(R.name)&&h.set(k.tag,((C=h.get(k.tag))!==null&&C!==void 0?C:0)+1);if(--N==0){O();return}}})}const D={count:0,maxReached:!1};await m(t,t,r,D);const _=await o(t);return{configFiles:a(h),fileTypes:a(u),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=I;function a(t){return[...p.Iterable.map(t.entries(),([r,s])=>({name:r,count:s}))].sort((r,s)=>s.count-r.count)}function l(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},r=v.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=l;function o(t){let r=new Map,s=(0,M.join)(t,".vscode","launch.json");return new Promise((u,h)=>{(0,b.exists)(s,f=>{if(f)(0,b.readFile)(s,(m,D)=>{if(m)return u([]);const _=[],U=(0,i.parse)(D.toString(),_);if(_.length)return console.log(`Unable to parse ${s}`),u([]);if((0,i.getNodeType)(U)==="object"&&U.configurations)for(const q of U.configurations){const Q=q.type;Q&&(r.has(Q)?r.set(Q,r.get(Q)+1):r.set(Q,1))}return u(a(r))});else return u([])})})}e.collectLaunchConfigs=o;let c=class{constructor(r,s){this.telemetryService=r,this.productService=s}formatMachineInfo(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}formatEnvironment(r){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const u=v.cpus();return u&&u.length>0&&s.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${v.loadavg().map(h=>Math.round(h)).join(", ")}`),s.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,S.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async u=>{let[h,f]=u,m=this.formatProcessList(r,h);return s.forEach(D=>{if((0,L.isRemoteDiagnosticError)(D))m+=`
${D.errorMessage}`,f+=`
${D.errorMessage}`;else if(m+=`

Remote: ${D.hostName}`,D.processes&&(m+=`
${this.formatProcessList(r,D.processes)}`),D.workspaceMetadata){f+=`
|  Remote: ${D.hostName}`;for(const _ of Object.keys(D.workspaceMetadata)){const U=D.workspaceMetadata[_];let q=`${U.fileCount} files`;U.maxFilesReached&&(q=`more than ${q}`),f+=`|    Folder (${_}): ${q}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:m,workspaceInfo:f}})}async getSystemInfo(r,s){const{memory:u,vmHint:h,os:f,cpus:m}=l(),D={os:f,memory:u,cpus:m,vmHint:h,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(D.load=`${v.loadavg().map(_=>Math.round(_)).join(", ")}`),n.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(r,s){const u=[];return(0,S.listProcesses)(r.mainPID).then(async h=>(u.push(""),u.push(this.formatEnvironment(r)),u.push(""),u.push(this.formatProcessList(r,h)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.formatWorkspaceMetadata(r))),s.forEach(f=>{if((0,L.isRemoteDiagnosticError)(f))u.push(`
${f.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${f.hostName}`),u.push(this.formatMachineInfo(f.machineInfo)),f.processes&&u.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const m of Object.keys(f.workspaceMetadata)){const D=f.workspaceMetadata[m];let _=`${D.fileCount} files`;D.maxFilesReached&&(_=`more than ${_}`),u.push(`Folder (${m}): ${_}`),u.push(this.formatWorkspaceStats(D))}}),u.push(""),u.push(""),u.join(`
`)))}formatWorkspaceStats(r){const s=[],u=60;let h=0;const f=(U,q)=>{const Q=` ${U}(${q})`;h+Q.length>u?(s.push(m),m="|                 ",h=m.length):h+=Q.length,m+=Q};let m="|      File types:";const D=10;let _=r.fileTypes.length>D?D:r.fileTypes.length;for(let U=0;U<_;U++){const q=r.fileTypes[U];f(q.name,q.count)}if(s.push(m),r.configFiles.length>=0&&(m="|      Conf files:",h=0,r.configFiles.forEach(U=>{f(U.name,U.count)}),s.push(m)),r.launchConfigFiles.length>0){let U="|      Launch Configs:";r.launchConfigFiles.forEach(q=>{U+=q.count>1?` ${q.name}(${q.count})`:` ${q.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(r){const s=Math.max(...Object.keys(r).map(u=>u.length));return Object.keys(r).map(u=>`${u}:  ${" ".repeat(s-u.length)}  ${r[u]}`).join(`
                  `)}formatWorkspaceMetadata(r){const s=[],u=[];return r.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(s.push(`|  Window (${h.title})`),h.folderURIs.forEach(f=>{const m=g.URI.revive(f);if(m.scheme===d.Schemas.file){const D=m.fsPath;u.push(I(D,["node_modules",".git"]).then(_=>{let U=`${_.fileCount} files`;_.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${(0,M.basename)(D)}): ${U}`),s.push(this.formatWorkspaceStats(_))}).catch(_=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${_.toString()})`)}))}else s.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(h=>s.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(r,s){const u=new Map;r.windows.forEach(f=>u.set(f.pid,f.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(r.mainPID,u,h,s,0),h.join(`
`)}formatProcessItem(r,s,u,h,f){const m=f===0;let D;m?D=h.pid===r?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(f)} ${h.name}`,h.name==="window"&&(D=`${D} (${s.get(h.pid)})`));const _=process.platform==="win32"?h.mem:v.totalmem()*(h.mem/100);u.push(`${h.load.toFixed(0).padStart(5," ")}	${(_/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(h.children)&&h.children.forEach(U=>this.formatProcessItem(r,s,u,U,f+1))}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const u=g.URI.revive(s);if(u.scheme===d.Schemas.file){const h=u.fsPath;try{const f=await I(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:m.name,count:m.count})}),f.launchConfigFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:m.name,count:m.count})}),f.configFiles.forEach(m=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:m.name,count:m.count})})}catch(f){}}}}};c=ce([ee(0,E.ITelemetryService),ee(1,y.IProductService)],c),e.DiagnosticsService=c}),define(X[193],J([0,1,17,163,166,44,31,49,157,46,25,6,24,7,20,94,187,4,15]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var l;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(l||(l={}));function o(...T){return String(T.reduce((R,W)=>R|W,0))}var c;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class h{constructor(R=u){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,W=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:W}))}withFilter(R,...W){const k=[...this.state.criteria,...W.length?W.map(F=>({filterType:R,value:F})):[{filterType:R}]];return new h(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(R){return new h(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new h(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new h(Object.assign(Object.assign({},this.state),{flags:R.reduce((W,k)=>W|k,0)}))}withAssetTypes(...R){return new h(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:W,pageSize:k,sortBy:F,sortOrder:B,flags:V,assetTypes:G}=this.state;return{filters:[{criteria:R,pageNumber:W,pageSize:k,sortBy:F,sortOrder:B}],assetTypes:G,flags:V}}get searchText(){const R=this.state.criteria.filter(W=>W.filterType===c.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(T,R){const W=(T||[]).filter(k=>k.statisticName===R)[0];return W?W.value:0}function m(T){const R="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(k=>k.assetType.indexOf(R)===0).reduce((k,F)=>{const B=q(T,F.assetType);return B&&k.push([F.assetType.substring(R.length),B]),k},[])}function D(T){if(T.properties){const R=T.properties.filter(F=>F.key===t.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),k=R.filter(F=>W.test(F.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return q(T,t.Repository)}function _(T){return{uri:`${T.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${T.fallbackAssetUri}/${t.VSIX}`}}function U(T){const R=q(T,t.Icon);if(R)return R;const W=A.DefaultIconPath;return{uri:W,fallbackUri:W}}function q(T,R){return T.files.filter(k=>k.assetType===R)[0]?{uri:`${T.assetUri}/${R}`,fallbackUri:`${T.fallbackAssetUri}/${R}`}:null}function Q(T,R){const W=T.properties?T.properties.filter(F=>F.key===R):[],k=W.length>0&&W[0].value;return k?k.split(",").map(F=>(0,L.adoptToGalleryExtensionId)(F)):[]}function ie(T){const R=T.properties?T.properties.filter(W=>W.key===r.Engine):[];return R.length>0&&R[0].value||""}function ae(T){const R=T.properties?T.properties.filter(k=>k.key===r.LocalizedLanguages):[],W=R.length>0&&R[0].value||"";return W?W.split(","):[]}function O(T){return T.indexOf("preview")!==-1}function $(T){const R=T.properties?T.properties.find(W=>W.key===r.WebExtension):void 0;return!!R&&R.value==="true"}function z(T){return T.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,a.joinPath)(p.URI.parse(T.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function C(T,R,W,k,F){const B={manifest:q(R,t.Manifest),readme:q(R,t.Details),changelog:q(R,t.Changelog),license:q(R,t.License),repository:D(R),download:_(R),icon:U(R),coreTranslations:m(R)};return{identifier:{id:(0,L.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:R.version,date:R.lastUpdated,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:f(T.statistics,"install"),rating:f(T.statistics,"averagerating"),ratingCount:f(T.statistics,"ratingcount"),assetUri:p.URI.parse(R.assetUri),webResource:z(R),assetTypes:R.files.map(({assetType:V})=>V),assets:B,properties:{dependencies:Q(R,r.Dependency),extensionPack:Q(R,r.ExtensionPack),engine:ie(R),localizedLanguages:ae(R),webExtension:$(R)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+W,searchText:k.searchText,querySource:F},preview:O(T.flags)}}let j=class{constructor(R,W,k,F,B,V,G){this.requestService=R,this.logService=W,this.environmentService=k,this.telemetryService=F,this.fileService=B,this.productService=V;const Y=V.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=N(V.version,this.environmentService,this.fileService,G)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,W){const k=[];let{total:F,firstPage:B,getPage:V}=await this.query({names:R,pageSize:R.length},W);k.push(...B);for(let G=1;k.length<F&&(B=await V(G,W),B.length);G++)k.push(...B);return k}async getCompatibleExtension(R,W){const k=await this.getCompatibleExtensionByEngine(R,W);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(R,W){const k=(0,A.isIExtensionIdentifier)(R)?null:R;if(k&&k.properties.engine&&(0,S.isEngineValid)(k.properties.engine,this.productService.version))return k;const{id:F,uuid:B}=k?k.identifier:R;let V=new h().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");B?V=V.withFilter(c.ExtensionId,B):V=V.withFilter(c.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(V,n.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(W){const re=Y.versions.filter(se=>se.version===W)[0];if(re){const se=C(Y,re,0,V);if(se.properties.engine&&(0,S.isEngineValid)(se.properties.engine,this.productService.version))return se}return null}const Z=await this.getLastValidExtensionVersion(Y,Y.versions);return Z?C(Y,Z,0,V):null}async query(R,W){const k=n.CancellationToken.isCancellationToken(R)?{}:R,F=n.CancellationToken.isCancellationToken(R)?R:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=k.text||"";const V=(0,b.getOrDefault)(k,x=>x.pageSize,50);let G=new h().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,V).withFilter(c.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(c.Category,ue||ne),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(c.Tag,ue||ne),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(c.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),G=G.withFilter(c.SearchText,B)),G=G.withSortBy(0)):k.ids?G=G.withFilter(c.ExtensionId,...k.ids):k.names?G=G.withFilter(c.ExtensionName,...k.names):G=G.withSortBy(4),typeof k.sortBy=="number"&&(G=G.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(G=G.withSortOrder(k.sortOrder));const{galleryExtensions:Y,total:Z}=await this.queryGallery(G,F),re=Y.map((x,ne)=>C(x,x.versions[0],ne,G,k.source)),se=async(x,ne)=>{if(ne.isCancellationRequested)throw(0,v.canceled)();const ue=G.withPage(x+1),{galleryExtensions:ye}=await this.queryGallery(ue,ne);return ye.map((ge,Ee)=>C(ge,ge.versions[0],Ee,ue,k.source))};return{firstPage:re,total:Z,pageSize:G.pageSize,getPage:se}}async queryGallery(R,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,l.ExcludeNonValidated).withFilter(c.ExcludeWithFlags,o(l.Unpublished));const k=await this.commonHeadersPromise,F=JSON.stringify(R.raw),B=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),V=new Date().getTime();let G,Y,Z=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:B},W),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:Z};const re=await(0,i.asJson)(G);if(re){const se=re.results[0],x=se.extensions,ne=se.resultMetadata&&se.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return Z=ne&&ne.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:Z}}return{galleryExtensions:[],total:Z}}catch(re){throw Y=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-V,success:!!G&&(0,i.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,v.isPromiseCanceledError)(Y)?"canceled":(0,v.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(R,W,k,F){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,V=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${W}/${k}/stats?statType=${F}`),headers:V},n.CancellationToken.None)}catch(G){}}}async download(R,W,k){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const F=(0,L.getGalleryExtensionTelemetryData)(R),B=new Date().getTime(),V=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:re})),G=k===1?"install":k===2?"update":"",Y=G?{uri:`${R.assets.download.uri}&${G}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${G}=true`}:R.assets.download,Z=await this.getAsset(Y);await this.fileService.writeFile(W,Z.stream),V(new Date().getTime()-B)}async getReadme(R,W){if(R.assets.readme){const k=await this.getAsset(R.assets.readme,{},W);return await(0,i.asText)(k)||""}return""}async getManifest(R,W){if(R.assets.manifest){const k=await this.getAsset(R.assets.manifest,{},W),F=await(0,i.asText)(k);return F?JSON.parse(F):null}return null}async getCoreTranslation(R,W){const k=R.assets.coreTranslations.filter(F=>F[0]===W.toUpperCase())[0];if(k){const F=await this.getAsset(k[1]),B=await(0,i.asText)(F);return B?JSON.parse(B):null}return null}async getChangelog(R,W){if(R.assets.changelog){const k=await this.getAsset(R.assets.changelog,{},W);return await(0,i.asText)(k)||""}return""}async getAllVersions(R,W){let k=new h().withFlags(l.IncludeVersions,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?k=k.withFilter(c.ExtensionId,R.identifier.uuid):k=k.withFilter(c.ExtensionName,R.identifier.id);const F=[],{galleryExtensions:B}=await this.queryGallery(k,n.CancellationToken.None);return B.length&&(W?await Promise.all(B[0].versions.map(async V=>{let G;try{G=await this.getEngine(V)}catch(Y){}G&&(0,S.isEngineValid)(G,this.productService.version)&&F.push({version:V.version,date:V.lastUpdated})})):F.push(...B[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),F}async getAsset(R,W={},k=n.CancellationToken.None){const F=await this.commonHeadersPromise,B={type:"GET"},V=Object.assign(Object.assign({},F),W.headers||{});W=Object.assign(Object.assign(Object.assign({},W),B),{headers:V});const G=R.uri,Y=R.fallbackUri,Z=Object.assign(Object.assign({},W),{url:G});try{const re=await this.requestService.request(Z,k);if(re.res.statusCode===200)return re;const se=await(0,i.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${se}`)}catch(re){if((0,v.isPromiseCanceledError)(re))throw re;const se=(0,v.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:se});const x=Object.assign(Object.assign({},W),{url:Y});return this.requestService.request(x,k)}}async getLastValidExtensionVersion(R,W){const k=this.getLastValidExtensionVersionFromProperties(R,W);return k||this.getLastValidExtensionVersionRecursively(R,W)}getLastValidExtensionVersionFromProperties(R,W){for(const k of W){const F=ie(k);if(!F)return null;if((0,S.isEngineValid)(F,this.productService.version))return k}return null}async getEngine(R){const W=ie(R);if(W)return W;const k=q(R,t.Manifest);if(!k)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},B=await this.getAsset(k,{headers:F}),V=await(0,i.asJson)(B);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,W){if(!W.length)return null;const k=W[0],F=await this.getEngine(k);return(0,S.isEngineValid)(F,this.productService.version)?(k.properties=k.properties||[],k.properties.push({key:r.Engine,value:F}),k):this.getLastValidExtensionVersionRecursively(R,W.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,i.asJson)(R),k=new Map;if(W)for(const F of W.malicious){const B=k.get(F)||{id:{id:F},malicious:!0,slow:!1};B.malicious=!0,k.set(F,B)}return[...k.values()]}};j=ce([ee(0,i.IRequestService),ee(1,g.ILogService),ee(2,y.IEnvironmentService),ee(3,M.ITelemetryService),ee(4,E.IFileService),ee(5,d.IProductService),ee(6,(0,I.optional)(w.IStorageService))],j),e.ExtensionGalleryService=j;async function N(T,R,W,k){const F={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},B=await(0,P.getServiceMachineId)(R,W,k);return F["X-Market-User-Id"]=B,F}e.resolveMarketplaceHeaders=N}),define(X[194],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(b){this.appender=b}listen(b,M){throw new Error(`Event not found: ${M}`)}call(b,M,{eventName:i,data:S}){return this.appender.log(i,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class A{constructor(b){this.channel=b}log(b,M){return this.channel.call("log",{eventName:b,data:M}).then(void 0,i=>`Failed to log telemetry: ${console.warn(i)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(X[195],J([0,1,47,143,22,4,21,48,2,44,37]),function(H,e,v,A,L,b,M,i,S,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(d,w){this._configurationService=w,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const I=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(d,w){this._experimentProperties[d]=w}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const w=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(E);this._userOptIn=w?w.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let w=d.sessionID,P=d["common.instanceId"],I=d["common.machineId"],a=d["common.firstSessionDate"],l=d["common.msftInternal"];return{sessionId:w,instanceId:P,machineId:I,firstSessionDate:a,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(d,w,P){return this.isOptedIn?this._commonProperties.then(I=>{w=(0,y.mixin)(w,I),w=(0,y.mixin)(w,this._experimentProperties),w=(0,y.cloneAndChange)(w,a=>{if(typeof a=="string")return this._cleanupInfo(a,P)}),this._appender.log(d,w)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(d,w,P){return this.publicLog(d,w,P)}publicLogError(d,w){return this.sendErrorTelemetry?this.publicLog(d,w,!0):Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}_cleanupInfo(d,w){let P=d;if(w){const I=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(d);if(!t)break;I.push([t.index,c.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(P="";;){const c=l.exec(d);if(!c)break;!a.test(c[0])&&I.every(([t,r])=>c.index<t||c.index>=r)&&(P+=d.substring(o,c.index)+"<REDACTED: user-file-path>",o=l.lastIndex)}o<d.length&&(P+=d.substr(o))}for(let I of this._cleanupPatterns)P=P.replace(I,"");return P}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ce([ee(1,(0,b.optional)(M.IConfigurationService))],g),e.TelemetryService=g;const E="telemetry";n.Registry.as(i.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,A.localize)(2,null,v.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,requireTrust:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(X[95],J([0,1,21,44,12,9]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,w){return Promise.resolve(void 0)}publicLog2(d,w){return this.publicLog(d,w)}publicLogError(d,w){return Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class M{async publicLog(w,P,I){}async publicLogError(w,P,I){}}e.NullEndpointTelemetryService=M;function i(...d){return{log:(w,P)=>d.forEach(I=>I.log(w,P)),flush:()=>b.Promises.settled(d.map(w=>w.flush()))}}e.combinedAppender=i,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(d,w){return w.onDidChangeConfiguration(P=>{P.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(P.source),configurationKeys:E(P.sourceConfig)})})}e.configurationTelemetry=S;function y(d){const w=Object.create(null),P=Object.create(null),I=Object.create(null);g(d,I);for(let a in I){a=a.length>150?a.substr(a.length-149):a;const l=I[a];typeof l=="number"?P[a]=l:typeof l=="boolean"?P[a]=l?1:0:typeof l=="string"?w[a]=l.substring(0,1023):typeof l!="undefined"&&l!==null&&(w[a]=l)}return{properties:w,measurements:P}}e.validateTelemetryData=y;function n(d){if(!d)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{d.indexOf(`${I}+`)===0&&(w=I)}),w}e.cleanRemoteAuthority=n;function g(d,w,P=0,I){if(!!d)for(let a of Object.getOwnPropertyNames(d)){const l=d[a],o=I?I+a:a;Array.isArray(l)?w[o]=(0,A.safeStringify)(l):l instanceof Date?w[o]=l.toISOString():(0,L.isObject)(l)?P<2?g(l,w,P+1,o+"."):w[o]=(0,A.safeStringify)(l):w[o]=l}}function E(d){if(!d)return[];const w=[];return p(w,"",d),w}function p(d,w,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(I=>p(d,w?`${w}.${I}`:I,P[I])):d.push(w)}}),define(X[196],J([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(X[197],J([0,1,4,2,37,5,196,105]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var S;(function(P){function I(a){return a&&typeof a=="object"&&typeof a.id=="string"}P.isThemeColor=I})(S=e.ThemeColor||(e.ThemeColor={}));function y(P){return{id:P}}e.themeColorFromId=y;var n;(function(P){function I(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}P.isThemeIcon=I;const a=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function l(t){const r=a.exec(t);if(!!r){let[,s]=r;return{id:s}}}P.fromString=l;function o(t,r){let s=t.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}P.modify=o;function c(t,r){var s,u;return t.id===r.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((u=r.color)===null||u===void 0?void 0:u.id)}P.isEqual=c,P.asClassNameArray=i.CSSIcon.asClassNameArray,P.asClassName=i.CSSIcon.asClassName,P.asCSSSelector=i.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function g(P){switch(P){case M.ColorScheme.DARK:return"vs-dark";case M.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,A.toDisposable)(()=>{const a=this.themingParticipants.indexOf(I);this.themingParticipants.splice(a,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new E;L.Registry.add(e.Extensions.ThemingContribution,p);function d(P){return p.onColorThemeChange(P)}e.registerThemingParticipant=d;class w extends A.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(a=>this.onThemeChange(a)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,a){let l=this.theme.getColor(I);return l&&a&&(l=a(l,this.theme)),l?l.toString():null}}e.Themable=w}),define(X[75],J([0,1,3,13,38,4]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",i="#1E1E1E",S="#000000",y="theme",n="themeBackground";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let g=class{constructor(p){this.stateService=p,A.ipcMain.on("vscode:changeColorTheme",(d,w,P)=>{typeof P=="string"&&this.storeBackgroundColor(JSON.parse(P))})}storeBackgroundColor(p){this.stateService.setItem(y,p.baseTheme),this.stateService.setItem(n,p.background)}getBackgroundColor(){if((v.isWindows||v.isMacintosh)&&A.nativeTheme.shouldUseInvertedColorScheme)return S;let p=this.stateService.getItem(n,null);if(!p){let d;(v.isWindows||v.isMacintosh)&&A.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateService.getItem(y,"vs-dark").split(" ")[0],p=d==="hc-black"?S:d==="vs"?M:i}return v.isMacintosh&&p.toUpperCase()===i&&(p="#171717"),p}};g=ce([ee(0,L.IStateService)],g),e.ThemeMainService=g}),define(X[40],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(A=e.StateType||(e.StateType={}));var L;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,M)=>({type:"idle",updateType:b,error:M}),CheckingForUpdates:b=>({type:"checking for updates",explicit:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(X[198],J([0,1,37,48,144,3]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.Registry.as(A.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[199],J([0,1,5,40]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(i){this.service=i}listen(i,S){switch(S){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${S}`)}call(i,S,y){switch(S){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${S}`)}}e.UpdateChannel=L;class b{constructor(i){this.channel=i,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(S=>this.state=S),this.channel.call("_getInitialState").then(S=>this.state=S)}get state(){return this._state}set state(i){this._state=i,this._onStateChange.fire(i)}checkForUpdates(i){return this.channel.call("checkForUpdates",i)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(X[96],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(X[200],J([0,1,7]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(i){this.handler=i}listen(i,S){throw new Error(`Event not found: ${S}`)}call(i,S,y){switch(S){case"handleURL":return this.handler.handleURL(v.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${S}`)}}e.URLHandlerChannel=A;class L{constructor(i){this.channel=i}handleURL(i,S){return this.channel.call("handleURL",[i.toJSON(),S])}}e.URLHandlerChannelClient=L;class b{constructor(i){this.next=i}async routeCall(i,S,y,n){if(S!=="handleURL")throw new Error(`Call not found: ${S}`);if(y){const g=v.URI.revive(y);if(g&&g.query){const E=/\bwindowId=(\d+)/.exec(g.query);if(E){const p=E[1],d=new RegExp(`window:${p}`),w=i.connections.find(P=>d.test(P.ctx));if(w)return w}}}return this.next.routeCall(i,S,y,n)}routeEvent(i,S){throw new Error(`Event not found: ${S}`)}}e.URLHandlerRouter=b}),define(X[201],J([0,1,7,9,2,20]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,n){const g=[...this.handlers.values()];return(0,A.first)(g.map(E=>()=>E.handleURL(y,n)),void 0,!1).then(E=>E||!1)}registerHandler(y){return this.handlers.add(y),(0,L.toDisposable)(()=>this.handlers.delete(y))}}e.AbstractURLService=M;let i=class extends M{constructor(y){super();this.productService=y}create(y){let{authority:n,path:g,query:E,fragment:p}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return n&&g&&g.indexOf("/")!==0&&(g=`/${g}`),v.URI.from({scheme:this.productService.urlProtocol,authority:n,path:g,query:E,fragment:p})}};i=ce([ee(0,b.IProductService)],i),e.NativeURLService=i}),define(X[202],J([0,1,5,13,7,2,3,9]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function S(n){try{return L.URI.parse(n)}catch(g){return null}}class y{constructor(g,E,p,d,w){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=b.Disposable.None,this.disposables=new b.DisposableStore,this.uris=g,M.isWindows){const a=d.isBuilt?[]:[`"${d.appRoot}"`];a.push("--open-url","--"),A.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,a)}const P=v.Event.map(v.Event.fromNodeEventEmitter(A.app,"open-url",(a,l)=>({event:a,url:l})),({event:a,url:l})=>(a.preventDefault(),l));this.disposables.add(P(a=>{const l=S(a);!l||this.urlService.open(l,{originalUrl:a})})),p.getWindows().filter(a=>a.isReady).length>0?this.flush():v.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const g=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||g.push(E);g.length!==0&&(this.uris=g,this.flushDisposable=(0,i.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(X[76],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(X[203],J([0,1,13,2,10,7,76]),function(H,e,v,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class i extends A.Disposable{constructor(){super();const y=v.session.fromPartition(M.webviewPartitionId),n=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n),y.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n)}async handleWebviewRequest(y,n){try{const g=b.URI.parse(y.url),E=i.validWebviewFilePaths.get(g.path);if(typeof E=="string"){const p=g.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${E}`:`vs/workbench/contrib/webview/browser/pre/${E}`,d=L.FileAccess.asFileUri(p,H);return n(decodeURIComponent(d.fsPath))}}catch(g){}n({error:-10})}}e.WebviewProtocolProvider=i,i.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(X[60],J([0,1,3]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(y){return!!y.workspaceUri}e.isWorkspaceToOpen=A;function L(y){return!!y.folderUri}e.isFolderToOpen=L;function b(y){return!!y.fileUri}e.isFileToOpen=b;function M(y){const n=i(y),g=y.getValue("window.menuBarVisibility");return g==="default"||n==="native"&&g==="compact"||v.isMacintosh&&v.isNative?"classic":g}e.getMenuBarVisibility=M;function i(y){if(v.isWeb)return"custom";const n=y.getValue("window");if(n){if(v.isMacintosh&&n.nativeTabs===!0||v.isMacintosh&&n.nativeFullScreen===!1)return"native";const p=n.titleBarStyle;if(p==="native"||p==="custom")return p}return v.isLinux?"native":"custom"}e.getTitleBarStyle=i;function S(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=S}),define(X[34],J([0,1,4]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var A;(function(i){i[i.CLI=0]="CLI",i[i.DOCK=1]="DOCK",i[i.MENU=2]="MENU",i[i.DIALOG=3]="DIALOG",i[i.DESKTOP=4]="DESKTOP",i[i.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}));const L=function(i=1){return{width:1024,height:768,mode:i}};e.defaultWindowState=L;var b;(function(i){i[i.Maximized=0]="Maximized",i[i.Normal=1]="Normal",i[i.Minimized=2]="Minimized",i[i.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var M;(function(i){i[i.UNRESPONSIVE=1]="UNRESPONSIVE",i[i.CRASHED=2]="CRASHED",i[i.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(X[204],J([0,1,13,2,73,76,203,34]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let S=class extends A.Disposable{constructor(n,g){super();this.windowsMainService=g,this._register(new M.WebviewProtocolProvider);const E=v.session.fromPartition(b.webviewPartitionId);E.setPermissionRequestHandler((p,d,w)=>w(d==="clipboard-read")),E.setPermissionCheckHandler((p,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(n,g){let E;if(typeof n.windowId=="number"){const{windowId:p}=n,d=this.windowsMainService.getWindowById(p);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${p}`);E=d.win.webContents}else{const{webContentsId:p}=n;if(E=v.webContents.fromId(p),!E)throw new Error(`Invalid webContentsId: ${p}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(g)}};S=ce([ee(0,L.ITunnelService),ee(1,i.IWindowsMainService)],S),e.WebviewMainService=S}),define(X[205],J([0,1,5,2,9]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends A.Disposable{constructor({onDidOpenWindow:i,onDidFocusWindow:S,getActiveWindowId:y}){super();this.disposables=this._register(new A.DisposableStore),v.Event.latch(v.Event.any(i,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>y()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(i){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=i}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(X[206],J([0,1,7,15,4,36]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");var M;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function i(E){const p=E;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=i;function S(E){const p=E;return!!(p&&typeof p=="object"&&v.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=S;class y{constructor(p,d,w,P){this._id=p,this._configuration=w,this._ignorePathCasing=P,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class n{constructor(p,d){this.raw=d,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,A.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function g(E){return new n({uri:E,index:0,name:(0,A.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=g}),define(X[29],J([0,1,4,147,206,7,3,8,15,102,43,10,39,30,72]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(z){return(typeof z=="string"?(0,i.extname)(z):(0,S.extname)(z))===w}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function I(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function a(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=a;function l(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=l;function o(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&b.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(z){const C=z;return typeof(C==null?void 0:C.id)=="string"&&b.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=t;function r(z){const C=z;if(C==null?void 0:C.uri)return{id:C.id,uri:b.URI.revive(C.uri)};const j=z;if(j==null?void 0:j.configPath)return{id:j.id,configPath:b.URI.revive(j.configPath)};if(z==null?void 0:z.id)return{id:z.id}}e.reviveIdentifier=r;function s(z,C){return S.extUriBiasedIgnorePathCase.isEqualOrParent(z,C.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function u(z){return h(z)||f(z)}e.isStoredWorkspaceFolder=u;function h(z){const C=z;return typeof(C==null?void 0:C.path)=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=h;function f(z){const C=z;return typeof(C==null?void 0:C.uri)=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=f;function m(z,C,j,N,T=!M.isWindows,R){if(z.scheme!==N.scheme)return{name:j,uri:z.toString(!0)};let W=C?void 0:R.relativePath(N,z);if(W!==void 0)W.length===0?W=".":M.isWindows&&z.scheme===g.Schemas.file&&!T&&(W=W.replace(/\//g,"\\"));else if(z.scheme===g.Schemas.file)W=z.fsPath,M.isWindows&&(W=(0,E.normalizeDriveLetter)(W),T&&(W=(0,p.toSlashes)(W)));else{if(!R.isEqualAuthority(z.authority,N.authority))return{name:j,uri:z.toString(!0)};W=z.path}return{name:j,path:W}}e.getStoredWorkspaceFolder=m;function D(z,C,j){let N=[],T=new Set;const R=j.dirname(C);for(let W of z){let k=null;if(h(W))W.path&&(k=j.resolvePath(R,W.path));else if(f(W))try{k=b.URI.parse(W.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(F){console.warn(F)}if(k){let F=j.getComparisonKey(k);if(!T.has(F)){T.add(F);const B=W.name||j.basenameOrAuthority(k);N.push(new L.WorkspaceFolder({uri:k,name:B,index:N.length},W))}}}return N}e.toWorkspaceFolders=D;function _(z,C,j,N,T){let R=U(C,z);const W=T.dirname(C),k=T.dirname(N),F=[],B=q(R.folders);for(const Z of R.folders){const re=h(Z)?T.resolvePath(W,Z.path):b.URI.parse(Z.uri);let se;j?se=!1:se=!h(Z)||(0,i.isAbsolute)(Z.path),F.push(m(re,se,Z.name,k,B,T))}const V={insertSpaces:!1,tabSize:4,eol:M.isLinux||M.isMacintosh?`
`:`\r
`},G=y.setProperty(z,["folders"],F,V);let Y=y.applyEdits(z,G);return R.remoteAuthority===(0,d.getRemoteAuthority)(N)&&(Y=y.applyEdits(Y,y.removeProperty(Y,["remoteAuthority"],V))),Y}e.rewriteWorkspaceFileForNewLocation=_;function U(z,C){let j=n.parse(C);if(j&&Array.isArray(j.folders))j.folders=j.folders.filter(N=>u(N));else throw new Error(`${z} looks like an invalid workspace file.`);return j}function q(z){return M.isWindows?z.some(C=>h(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=q;function Q(z){return z.workspace&&typeof z.workspace=="object"&&typeof z.workspace.id=="string"&&typeof z.workspace.configPath=="string"}function ie(z){return typeof z.folderUri=="string"}function ae(z){return typeof z.fileUri=="string"}function O(z,C){const j={workspaces:[],files:[]};if(z){const N=function(R,W){for(let k=0;k<R.length;k++)try{W(R[k],k)}catch(F){C.warn(`Error restoring recent entry ${JSON.stringify(R[k])}: ${F.toString()}. Skip entry.`)}},T=z;if(Array.isArray(T.entries))N(T.entries,R=>{const W=R.label,k=R.remoteAuthority;Q(R)?j.workspaces.push({label:W,remoteAuthority:k,workspace:{id:R.workspace.id,configPath:b.URI.parse(R.workspace.configPath)}}):ie(R)?j.workspaces.push({label:W,remoteAuthority:k,folderUri:b.URI.parse(R.folderUri)}):ae(R)&&j.files.push({label:W,remoteAuthority:k,fileUri:b.URI.parse(R.fileUri)})});else{const R=z;Array.isArray(R.workspaces3)&&N(R.workspaces3,(W,k)=>{const F=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[k]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?j.workspaces.push({label:F,workspace:{id:W.id,configPath:b.URI.parse(W.configURIPath)}}):typeof W=="string"&&j.workspaces.push({label:F,folderUri:b.URI.parse(W)})}),Array.isArray(R.files2)&&N(R.files2,(W,k)=>{const F=Array.isArray(R.fileLabels)&&R.fileLabels[k]||void 0;typeof W=="string"&&j.files.push({label:F,fileUri:b.URI.parse(W)})})}}return j}e.restoreRecentlyOpened=O;function $(z){const C={entries:[]};for(const j of z.workspaces)a(j)?C.entries.push({folderUri:j.folderUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority}):C.entries.push({workspace:{id:j.workspace.id,configPath:j.workspace.configPath.toString()},label:j.label,remoteAuthority:j.remoteAuthority});for(const j of z.files)C.entries.push({fileUri:j.fileUri.toString(),label:j.label,remoteAuthority:j.remoteAuthority});return C}e.toStoreData=$}),define(X[50],J([0,1,4,29]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function L(b){const M=b;return M&&(0,A.isWorkspaceIdentifier)(M.workspace)}e.isWorkspaceBackupInfo=L}),define(X[51],J([0,1,4,13,9,38,3,8,64,19,12,131,29,39,2,80]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let P=class ut{constructor(a){this.stateService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(a,l){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)}),l)}pickFolder(a,l){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,title:(0,g.localize)(1,null)}),l)}pickFile(a,l){return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:(0,g.localize)(2,null)}),l)}pickWorkspace(a,l){const o=(0,g.localize)(3,null),c=(0,p.mnemonicButtonLabel)((0,g.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:o,filters:t,buttonLabel:c}),l)}async doPick(a,l){const o={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters};o.defaultPath=a.defaultPath||this.stateService.getItem(ut.workingDirPickerStorageKey),(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(o.properties=void 0,a.pickFiles&&a.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),M.isMacintosh&&o.properties.push("treatPackageAsDirectory");const c=l||A.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,(0,n.withNullAsUndefined)(c));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ut.workingDirPickerStorageKey,(0,i.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(a){if(a){let l=this.windowDialogQueues.get(a.id);return l||(l=new L.Queue,this.windowDialogQueues.set(a.id,l)),l}else return this.noWindowDialogueQueue}showMessageBox(a,l){return this.getWindowDialogQueue(l).queue(async()=>l?A.dialog.showMessageBox(l,a):A.dialog.showMessageBox(a))}async showSaveDialog(a,l){const o=this.acquireFileDialogLock(a,l);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(l).queue(async()=>{let c;return l?c=await A.dialog.showSaveDialog(l,a):c=await A.dialog.showSaveDialog(a),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,d.dispose)(o)}}normalizePath(a){return a&&M.isMacintosh&&(a=(0,S.normalizeNFC)(a)),a}normalizePaths(a){return a.map(l=>this.normalizePath(l))}async showOpenDialog(a,l){a.defaultPath&&(await(0,y.exists)(a.defaultPath)||(a.defaultPath=void 0));const o=this.acquireFileDialogLock(a,l);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(l).queue(async()=>{let c;return l?c=await A.dialog.showOpenDialog(l,a):c=await A.dialog.showOpenDialog(a),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,d.dispose)(o)}}acquireFileDialogLock(a,l){if(!l)return d.Disposable.None;let o=this.windowFileDialogLocks.get(l.id);o||(o=new Set,this.windowFileDialogLocks.set(l.id,o));const c=(0,w.hash)(a);if(!o.has(c))return o.add(c),(0,d.toDisposable)(()=>{o==null||o.delete(c),(o==null?void 0:o.size)===0&&this.windowFileDialogLocks.delete(l.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=ce([ee(0,b.IStateService)],P),e.DialogMainService=P}),define(X[207],J([0,1,5,2,29]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends A.Disposable{constructor(i,S){super();this.logService=i,this.storageMainService=S,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(i,S)=>(i?i.push(S):i=[S],i),b.STORAGE_CHANGE_DEBOUNCE_TIME)(i=>{i.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(i))}))}serializeGlobalStorageEvents(i){const S=new Map,y=new Set;return i.forEach(n=>{const g=this.storageMainService.globalStorage.get(n.key);typeof g=="string"?S.set(n.key,g):y.add(n.key)}),{changed:Array.from(S.entries()),deleted:Array.from(y.values())}}listen(i,S){switch(S){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${S}`)}async call(i,S,y){const n=(0,L.reviveIdentifier)(y.workspace),g=await this.withStorageInitialized(n);switch(S){case"getItems":return Array.from(g.items.entries());case"updateItems":{const E=y;if(E.insert)for(const[p,d]of E.insert)g.set(p,d);E.delete&&E.delete.forEach(p=>g.delete(p));break}case"close":{if(n)return g.close();break}default:throw new Error(`Call not found: ${S}`)}}async withStorageInitialized(i){const S=i?this.storageMainService.workspaceStorage(i):this.storageMainService.globalStorage;try{await S.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${i?"workspace":"global"} storage due to ${y}`)}return S}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[208],J([0,1,18,19,5,2,6,121,85,8,94,31,28,29]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends b.Disposable{constructor(a){super();this.logService=a,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new S.Storage(new S.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const a=await this.doCreate();this.storage.dispose(),this.storage=a,this._register(a.onDidChangeStorage(o=>this._onDidChangeStorage.fire({key:o}))),await this.doInit(a);const l=a.getBoolean(n.IS_NEW_KEY);l===void 0?a.set(n.IS_NEW_KEY,!0):l&&a.set(n.IS_NEW_KEY,!1)}catch(a){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${a}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===M.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this.storage.items}get(a,l){return this.storage.get(a,l)}set(a,l){return this.storage.set(a,l)}delete(a){return this.storage.delete(a)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class w extends d{constructor(a,l,o){super(l);this.options=a,this.environmentService=o}async doCreate(){let a;return this.options.useInMemoryStorage?a=i.SQLiteStorageDatabase.IN_MEMORY_PATH:a=(0,y.join)(this.environmentService.globalStorageHome.fsPath,w.STORAGE_NAME),new S.Storage(new i.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}))}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(g.instanceStorageKey,void 0)===void 0&&a.set(g.instanceStorageKey,(0,E.generateUuid)()),a.get(g.firstSessionDateStorageKey,void 0)===void 0&&a.set(g.firstSessionDateStorageKey,new Date().toUTCString());const c=a.get(g.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();a.set(g.lastSessionDateStorageKey,typeof c=="undefined"?null:c),a.set(g.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=w,w.STORAGE_NAME="state.vscdb";class P extends d{constructor(a,l,o,c){super(o);this.workspace=a,this.options=l,this.environmentService=c}async doCreate(){const{storageFilePath:a,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new S.Storage(new i.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}),{hint:l?S.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:i.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,y.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),l=(0,y.join)(a,P.WORKSPACE_STORAGE_NAME);return await(0,A.exists)(a)?{storageFilePath:l,wasCreated:!1}:(await v.promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let l;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?l={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const o=(0,y.join)(a,P.WORKSPACE_META_NAME);await(0,A.exists)(o)||await(0,A.writeFile)(o,JSON.stringify(l,void 0,2))}catch(o){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.WorkspaceStorageMain=P,P.WORKSPACE_STORAGE_NAME="state.vscdb",P.WORKSPACE_META_NAME="workspace.json"}),define(X[97],J([0,1,42,2,46,4,16,6,208]),function(H,e,v,A,L,b,M,i,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,b.createDecorator)("storageMainService");let y=class extends A.Disposable{constructor(g,E,p){super();this.logService=g,this.environmentService=E,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async g=>{g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{g.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)g.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const g=new S.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),g}createWorkspaceStorage(g){return new S.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(g){let E=this.mapWorkspaceToStorage.get(g.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),E=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),E}};y=ce([ee(0,i.ILogService),ee(1,L.IEnvironmentService),ee(2,M.ILifecycleMainService)],y),e.StorageMainService=y}),define(X[98],J([0,1,7,29,15]),function(H,e,v,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(S,y,n){for(const E of S){const p=E.openedWorkspace;if((0,A.isWorkspaceIdentifier)(p)){const d=n(p);if(d){if(d.folders.some(w=>L.extUriBiasedIgnorePathCase.isEqualOrParent(y,w.uri)))return E}else if(L.extUriBiasedIgnorePathCase.isEqualOrParent(y,p.configPath))return E}}const g=S.filter(E=>(0,A.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqualOrParent(y,E.openedWorkspace.uri));if(g.length)return g.sort((E,p)=>-(E.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function M(S,y){for(const n of S)if((0,A.isWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.configPath,y)||(0,A.isSingleFolderWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.uri,y))return n}e.findWindowOnWorkspaceOrFolder=M;function i(S,y){var n,g;const E=p=>y.some(d=>L.extUriBiasedIgnorePathCase.isEqual(v.URI.file(d),v.URI.file(p)));for(const p of S)if((g=(n=p.config)===null||n===void 0?void 0:n.extensionDevelopmentPath)===null||g===void 0?void 0:g.some(d=>E(d)))return p}e.findWindowOnExtensionDevelopmentPath=i}),define(X[209],J([0,1,13,2,3,15,7,21,16,6,38,34,29]),function(H,e,v,A,L,b,M,i,S,y,n,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class ht extends A.Disposable{constructor(l,o,c,t,r){super();this.windowsMainService=l,this.stateService=o,this.lifecycleMainService=c,this.logService=t,this.configurationService=r,this._state=d(this.stateService.getItem(ht.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(l.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const c=P(l);this.stateService.setItem(ht.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(l){if(!this.lifecycleMainService.quitRequested){const o=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(c=>{var t;const r=(0,E.isWorkspaceIdentifier)(l.openedWorkspace)&&((t=c.workspace)===null||t===void 0?void 0:t.id)===l.openedWorkspace.id,s=(0,E.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&c.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(c.folderUri,l.openedWorkspace.uri);(r||s)&&(c.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}}toWindowState(l){return{workspace:(0,E.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const o=this.doGetNewWindowState(l),c=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!((c==null?void 0:c.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(c==null?void 0:c.restoreFullscreen)),t&&L.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(l){const o=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=l.workspace;if((0,E.isWorkspaceIdentifier)(h)){const m=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===h.id).map(D=>D.uiState);if(m.length)return m[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(h)){const m=this.state.openedWindows.filter(D=>D.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(D.folderUri,h.uri)).map(D=>D.uiState);if(m.length)return m[0]}else if(l.backupPath){const m=this.state.openedWindows.filter(D=>D.backupPath===l.backupPath).map(D=>D.uiState);if(m.length)return m[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!o&&f)return f.uiState}let c;const t=v.screen.getAllDisplays();if(t.length===1)c=t[0];else{if(L.isMacintosh){const h=v.screen.getCursorScreenPoint();c=v.screen.getDisplayNearestPoint(h)}!c&&o&&(c=v.screen.getDisplayMatching(o.getBounds())),c||(c=v.screen.getPrimaryDisplay()||t[0])}let r=(0,g.defaultWindowState)();r.x=Math.round(c.bounds.x+c.bounds.width/2-r.width/2),r.y=Math.round(c.bounds.y+c.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let u=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,u=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,u=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const h=o.serializeWindowState();h.mode===3?r.mode=3:r=h,u=r.mode!==3&&s.newWindowDimensions==="offset"}}return u&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const o=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;o.some(c=>c.x===l.x||c.y===l.y);)l.x+=30,l.y+=30;return l}};p.windowsStateStorageKey="windowsState",p=ce([ee(0,g.IWindowsMainService),ee(1,n.IStateService),ee(2,S.ILifecycleMainService),ee(3,y.ILogService),ee(4,i.IConfigurationService)],p),e.WindowsStateHandler=p;function d(a){const l={openedWindows:[]},o=a||{openedWindows:[]};return o.lastActiveWindow&&(l.lastActiveWindow=w(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=w(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(l.openedWindows=o.openedWindows.map(c=>w(c))),l}e.restoreWindowsState=d;function w(a){const l={uiState:a.uiState};return a.backupPath&&(l.backupPath=a.backupPath),a.remoteAuthority&&(l.remoteAuthority=a.remoteAuthority),a.folder&&(l.folderUri=M.URI.parse(a.folder)),a.workspaceIdentifier&&(l.workspace={id:a.workspaceIdentifier.id,configPath:M.URI.parse(a.workspaceIdentifier.configURIPath)}),l}function P(a){return{lastActiveWindow:a.lastActiveWindow&&I(a.lastActiveWindow),lastPluginDevelopmentHostWindow:a.lastPluginDevelopmentHostWindow&&I(a.lastPluginDevelopmentHostWindow),openedWindows:a.openedWindows.map(l=>I(l))}}e.getWindowsStateStoreData=P;function I(a){return{workspaceIdentifier:a.workspace&&{id:a.workspace.id,configURIPath:a.workspace.configPath.toString()},folder:a.folderUri&&a.folderUri.toString(),backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.uiState}}}),define(X[56],J([0,1,58,59,210,5,33,8,27,28,2,23,83,17,3]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(m){this.socket=m,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,p.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const D=_=>m(g.VSBuffer.wrap(_));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(m){return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,p.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,p.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((m,D)=>{if(this.socket.bufferSize===0){m();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),m()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=w;var P;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var I;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(I||(I={}));class a extends n.Disposable{constructor(m,D,_,U){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=U,D?(this._zlibInflate=L.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",q=>{console.error(q),(0,p.onUnexpectedError)(q),this._onClose.fire()}),this._zlibInflate.on("data",q=>{this._pendingInflateData.push(q)}),_&&(this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=L.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",q=>{console.error(q),(0,p.onUnexpectedError)(q),this._onClose.fire()}),this._zlibDeflate.on("data",q=>{this._pendingDeflateData.push(q)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(g.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,D){let _=2;m.byteLength<126?_+=0:m.byteLength<2**16?_+=2:_+=8;const U=g.VSBuffer.alloc(_);if(D?U.writeUInt8(194,0):U.writeUInt8(130,0),m.byteLength<126)U.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(m.byteLength>>>8&255,++q),U.writeUInt8(m.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(m.byteLength>>>24&255,++q),U.writeUInt8(m.byteLength>>>16&255,++q),U.writeUInt8(m.byteLength>>>8&255,++q),U.writeUInt8(m.byteLength>>>0&255,++q)}this._totalOutgoingWireBytes+=U.byteLength+m.byteLength,this.socket.write(g.VSBuffer.concat([U,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),U=(D.readUInt8(0)&128)>>>7,q=D.readUInt8(1),Q=(q&128)>>>7,ie=q&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(ie===126?2:0)+(ie===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),_=D.readUInt8(1),U=(_&128)>>>7;let q=_&127,Q=1;q===126?q=D.readUInt8(++Q)*2**8+D.readUInt8(++Q):q===127&&(q=D.readUInt8(++Q)*0+D.readUInt8(++Q)*0+D.readUInt8(++Q)*0+D.readUInt8(++Q)*0+D.readUInt8(++Q)*2**24+D.readUInt8(++Q)*2**16+D.readUInt8(++Q)*2**8+D.readUInt8(++Q));let ie=0;U&&(ie=D.readUInt8(++Q)*2**24+D.readUInt8(++Q)*2**16+D.readUInt8(++Q)*2**8+D.readUInt8(++Q)),this._state.state=3,this._state.readLen=q,this._state.mask=ie}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);l(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const _=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=_.length,this._onData.fire(g.VSBuffer.wrap(_))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=a;function l(f,m){if(m!==0){let D=f.byteLength>>>2;for(let ae=0;ae<D;ae++){const O=f.readUInt32BE(ae*4);f.writeUInt32BE(O^m,ae*4)}let _=D*4,U=f.byteLength-_;const q=m>>>24&255,Q=m>>>16&255,ie=m>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(_)^q,_),U>=2&&f.writeUInt8(f.readUInt8(_+1)^Q,_+1),U>=3&&f.writeUInt8(f.readUInt8(_+2)^ie,_+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const f=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,i.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):m=(0,i.join)((0,S.tmpdir)(),`vscode-ipc-${f}.sock`),r(m),m}e.createRandomIPCHandle=c;function t(f,m,D){const _=(0,v.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${D}-${m}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,i.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${D}-${m}.sock`):U=(0,i.join)(f,`${D}-${m}.sock`),r(U),U}e.createStaticIPCHandle=t;function r(f){const m=o[d.platform];typeof m=="number"&&f.length>=m&&console.warn(`WARNING: IPC handle "${f}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends M.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const D=b.Event.fromNodeEventEmitter(m,"connection");return b.Event.map(D,_=>({protocol:new E.Protocol(new w(_)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function u(f){return new Promise((m,D)=>{const _=(0,A.createServer)();_.on("error",D),_.listen(f,()=>{_.removeListener("error",D),m(new s(_))})})}e.serve=u;function h(f,m){return new Promise((D,_)=>{const U=(0,A.createConnection)(f,()=>{U.removeListener("error",_),D(E.Client.fromSocket(new w(U),m))});U.once("error",_)})}e.connect=h}),define(X[211],J([0,1,56]),function(H,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class A{constructor(g){this.driver=g}listen(g,E){throw new Error("No event found")}call(g,E,p){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(p);case"reloadWindow":return this.driver.reloadWindow(p);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(p[0],p[1]);case"click":return this.driver.click(p[0],p[1],p[2],p[3]);case"doubleClick":return this.driver.doubleClick(p[0],p[1]);case"setValue":return this.driver.setValue(p[0],p[1],p[2]);case"getTitle":return this.driver.getTitle(p[0]);case"isActiveElement":return this.driver.isActiveElement(p[0],p[1]);case"getElements":return this.driver.getElements(p[0],p[1],p[2]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1],p[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p[0],p[1]);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1],p[2])}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=A;class L{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,E){return this.channel.call("dispatchKeybinding",[g,E])}click(g,E,p,d){return this.channel.call("click",[g,E,p,d])}doubleClick(g,E){return this.channel.call("doubleClick",[g,E])}setValue(g,E,p){return this.channel.call("setValue",[g,E,p])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,E){return this.channel.call("isActiveElement",[g,E])}getElements(g,E,p){return this.channel.call("getElements",[g,E,p])}getElementXY(g,E,p,d){return this.channel.call("getElementXY",[g,E,p,d])}typeInEditor(g,E,p){return this.channel.call("typeInEditor",[g,E,p])}getTerminalBuffer(g,E){return this.channel.call("getTerminalBuffer",[g,E])}writeInTerminal(g,E,p){return this.channel.call("writeInTerminal",[g,E,p])}}e.DriverChannelClient=L;class b{constructor(g){this.registry=g}listen(g,E){throw new Error(`Event not found: ${E}`)}call(g,E,p){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(p);case"reloadWindowDriver":return this.registry.reloadWindowDriver(p)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=b;class M{constructor(g){this.channel=g}registerWindowDriver(g){return this.channel.call("registerWindowDriver",g)}reloadWindowDriver(g){return this.channel.call("reloadWindowDriver",g)}}e.WindowDriverRegistryChannelClient=M;class i{constructor(g){this.driver=g}listen(g,E){throw new Error(`No event found: ${E}`)}call(g,E,p){switch(E){case"click":return this.driver.click(p[0],p[1],p[2]);case"doubleClick":return this.driver.doubleClick(p);case"setValue":return this.driver.setValue(p[0],p[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(p);case"getElements":return this.driver.getElements(p[0],p[1]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1])}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=i;class S{constructor(g){this.channel=g}click(g,E,p){return this.channel.call("click",[g,E,p])}doubleClick(g){return this.channel.call("doubleClick",g)}setValue(g,E){return this.channel.call("setValue",[g,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(g){return this.channel.call("isActiveElement",g)}getElements(g,E){return this.channel.call("getElements",[g,E])}getElementXY(g,E,p){return this.channel.call("getElementXY",[g,E,p])}typeInEditor(g,E){return this.channel.call("typeInEditor",[g,E])}getTerminalBuffer(g){return this.channel.call("getTerminalBuffer",g)}writeInTerminal(g,E){return this.channel.call("writeInTerminal",[g,E])}}e.WindowDriverChannelClient=S;async function y(n){const g=await(0,v.connect)(n,"driverClient"),E=g.getChannel("driver"),p=new L(E);return{client:g,driver:p}}e.connect=y}),define(X[26],J([0,1,8,53,4,46,155,56]),function(H,e,v,A,L,b,M,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,L.refineServiceDecorator)(b.IEnvironmentService);class S extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,v.join)(this.userDataPath,"clp")}get backupHome(){return(0,v.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,v.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,i.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,v.join)(this.userDataPath,"Code Cache")}}ce([A.memoize],S.prototype,"cachedLanguagesPath",null),ce([A.memoize],S.prototype,"backupHome",null),ce([A.memoize],S.prototype,"backupWorkspacesPath",null),ce([A.memoize],S.prototype,"mainIPCHandle",null),ce([A.memoize],S.prototype,"sandbox",null),ce([A.memoize],S.prototype,"driverVerbose",null),ce([A.memoize],S.prototype,"disableUpdates",null),ce([A.memoize],S.prototype,"disableKeytar",null),ce([A.memoize],S.prototype,"nodeCachedDataDir",null),ce([A.memoize],S.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=S}),define(X[212],J([0,1,18,58,8,3,19,50,26,21,24,6,29,7,30,10,15]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(l,o,c){this.configurationService=o,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>(0,d.isEqual)(t,r,!b.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await v.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){l=Object.create(null)}l.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos));let o=[];try{Array.isArray(l.rootURIWorkspaces)&&(o=l.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let c=[];try{Array.isArray(l.folderURIWorkspaces)&&(c=l.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==n.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===n.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var l;const o=this.configurationService.getValue();return((l=o==null?void 0:o.files)===null||l===void 0?void 0:l.hotExit)||n.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,o){this.workspaces.some(t=>l.workspace.id===t.workspace.id)||(this.workspaces.push(l),this.saveSync());const c=this.getBackupPath(l.workspace.id);return o&&this.moveBackupFolderSync(c,o),c}moveBackupFolderSync(l,o){if(v.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),v.existsSync(o))try{v.renameSync(o,l)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(l){const o=l.id,c=this.workspaces.findIndex(t=>t.workspace.id===o);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(o=>this.backupUriComparer.isEqual(l,o))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const o=this.folders.findIndex(c=>this.backupUriComparer.isEqual(l,c));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(l,o){const c=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:o}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(l){const o=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,l));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(l){return(0,L.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const o=new Set,c=[];for(let t of l){const r=t.workspace;if(!(0,E.isWorkspaceIdentifier)(r))return[];if(!o.has(r.id)){o.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==w.Schemas.file||await(0,M.exists)(r.configPath.fsPath)?c.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(l){if(!Array.isArray(l))return[];const o=[],c=new Set;for(let t of l){const r=this.backupUriComparer.getComparisonKey(t);if(!c.has(r)){c.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==w.Schemas.file||await(0,M.exists)(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const o=[],c=new Set;for(let t of l){const r=t.backupFolder;if(typeof r!="string")return[];if(!c.has(r)){c.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?o.push(t):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(l){try{await(0,M.exists)(l)&&await(0,M.rimraf)(l,M.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(l){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{await v.promises.rename(l,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(l){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const c=this.getBackupPath(o);try{v.renameSync(l,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const l=[];for(const o of this.workspaces)await this.hasBackups(o)&&l.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&l.push(o);return l}hasBackups(l){let o;return p.URI.isUri(l)?o=this.getBackupPath(this.getFolderHash(l)):(0,i.isWorkspaceBackupInfo)(l)?o=this.getBackupPath(l.workspace.id):o=l.backupFolder,this.doHasBackups(o)}async doHasBackups(l){try{const o=await(0,M.readdir)(l);for(const c of o)try{if((await(0,M.readdir)((0,L.join)(l,c))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{(0,M.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await(0,M.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderURIWorkspaces:this.folders.map(l=>l.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){let o;return l.scheme===w.Schemas.file?o=b.isLinux?l.fsPath:l.fsPath.toLowerCase():o=l.toString().toLowerCase(),(0,A.createHash)("md5").update(o).digest("hex")}};I=ce([ee(0,S.IEnvironmentMainService),ee(1,y.IConfigurationService),ee(2,g.ILogService)],I),e.BackupMainService=I}),define(X[41],J([0,1,5,34,13,16,3,26,51,19,7,31,4,27,65,6,8,20,53,2]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let o=class st extends l.Disposable{constructor(t,r,s,u,h,f,m,D){super();this.sharedProcess=t,this.windowsMainService=r,this.dialogMainService=s,this.lifecycleMainService=u,this.environmentMainService=h,this.telemetryService=f,this.logService=m,this.productService=D,this.onDidOpenWindow=v.Event.map(this.windowsMainService.onDidOpenWindow,_=>_.id),this.onDidMaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidUnmaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidBlurWindow=v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_)),this.onDidFocusWindow=v.Event.any(v.Event.map(v.Event.filter(v.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),_=>!!_),_=>_.id),v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(_,U)=>U.id),_=>!!this.windowsMainService.getWindowById(_))),this.onDidResumeOS=v.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new v.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new v.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=v.Event.debounce(v.Event.any(v.Event.filter(v.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(_,U,q)=>q),_=>!(Array.isArray(_)&&_.length===1&&_[0]==="workArea")),v.Event.fromNodeEventEmitter(L.screen,"display-added"),v.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(r=>{var s,u;return{id:r.id,workspace:r.openedWorkspace,title:(u=(s=r.win)===null||s===void 0?void 0:s.getTitle())!==null&&u!==void 0?u:"",filename:r.getRepresentedFilename(),dirty:r.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const r=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(r)return r.id}openWindow(t,r,s){return Array.isArray(r)?this.doOpenWindow(t,r,s):this.doOpenEmptyWindow(t,r)}async doOpenWindow(t,r,s=Object.create(null)){r.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:r,cli:this.environmentMainService.args,forceNewWindow:s.forceNewWindow,forceReuseWindow:s.forceReuseWindow,preferNewWindow:s.preferNewWindow,diffMode:s.diffMode,addMode:s.addMode,gotoLineMode:s.gotoLineMode,noRecentEntry:s.noRecentEntry,waitMarkerFileURI:s.waitMarkerFileURI,remoteAuthority:s.remoteAuthority||void 0})}async doOpenEmptyWindow(t,r){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},r)}async toggleFullScreen(t){const r=this.windowById(t);r&&r.toggleFullScreen()}async handleTitleDoubleClick(t){const r=this.windowById(t);r&&r.handleTitleDoubleClick()}async isMaximized(t){const r=this.windowById(t);return(r==null?void 0:r.win)?r.win.isMaximized():!1}async maximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.maximize()}async unmaximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.unmaximize()}async minimizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.minimize()}async focusWindow(t,r){var s;r&&typeof r.windowId=="number"&&(t=r.windowId);const u=this.windowById(t);u&&u.focus({force:(s=r==null?void 0:r.force)!==null&&s!==void 0?s:!1})}async setMinimumSize(t,r,s){const u=this.windowById(t);if(u==null?void 0:u.win){const[h,f]=u.win.getSize(),[m,D]=u.win.getMinimumSize(),[_,U]=[r!=null?r:m,s!=null?s:D],[q,Q]=[Math.max(h,_),Math.max(f,U)];(m!==_||D!==U)&&u.win.setMinimumSize(_,U),(h!==q||f!==Q)&&u.win.setSize(q,Q)}}async showMessageBox(t,r){return this.dialogMainService.showMessageBox(r,this.toBrowserWindow(t))}async showSaveDialog(t,r){return this.dialogMainService.showSaveDialog(r,this.toBrowserWindow(t))}async showOpenDialog(t,r){return this.dialogMainService.showOpenDialog(r,this.toBrowserWindow(t))}toBrowserWindow(t){const r=this.windowById(t);if(r==null?void 0:r.win)return r.win}async pickFileFolderAndOpen(t,r){const s=await this.dialogMainService.pickFileFolder(r);s&&(this.sendPickerTelemetry(s,r.telemetryEventName||"openFileFolder",r.telemetryExtraData),this.doOpenPicked(await Promise.all(s.map(async u=>await y.SymlinkSupport.existsDirectory(u)?{folderUri:n.URI.file(u)}:{fileUri:n.URI.file(u)})),r,t))}async pickFolderAndOpen(t,r){const s=await this.dialogMainService.pickFolder(r);s&&(this.sendPickerTelemetry(s,r.telemetryEventName||"openFolder",r.telemetryExtraData),this.doOpenPicked(s.map(u=>({folderUri:n.URI.file(u)})),r,t))}async pickFileAndOpen(t,r){const s=await this.dialogMainService.pickFile(r);s&&(this.sendPickerTelemetry(s,r.telemetryEventName||"openFile",r.telemetryExtraData),this.doOpenPicked(s.map(u=>({fileUri:n.URI.file(u)})),r,t))}async pickWorkspaceAndOpen(t,r){const s=await this.dialogMainService.pickWorkspace(r);s&&(this.sendPickerTelemetry(s,r.telemetryEventName||"openWorkspace",r.telemetryExtraData),this.doOpenPicked(s.map(u=>({workspaceUri:n.URI.file(u)})),r,t))}doOpenPicked(t,r,s){this.windowsMainService.open({context:3,contextWindowId:s,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:r.forceNewWindow})}sendPickerTelemetry(t,r,s){const u=t?t.length:0;this.telemetryService.publicLog(r,Object.assign(Object.assign({},s),{outcome:u?"success":"canceled",numberOfPaths:u}))}async showItemInFolder(t,r){L.shell.showItemInFolder(r)}async setRepresentedFilename(t,r){const s=this.windowById(t);s&&s.setRepresentedFilename(r)}async setDocumentEdited(t,r){const s=this.windowById(t);s&&s.setDocumentEdited(r)}async openExternal(t,r){return M.isLinuxSnap?this.safeSnapOpenExternal(r):L.shell.openExternal(r),!0}safeSnapOpenExternal(t){const r=process.env.GDK_PIXBUF_MODULE_FILE,s=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=r,process.env.GDK_PIXBUF_MODULEDIR=s}async moveItemToTrash(t,r){return L.shell.moveItemToTrash(r)}async isAdmin(){let t;return M.isWindows?t=(await new Promise((r,s)=>{H(["native-is-elevated"],r,s)}))():t=process.getuid()===0,t}async writeElevated(t,r,s,u){const h=await new Promise((f,m)=>{H(["sudo-prompt"],f,m)});return new Promise((f,m)=>{const D=[`"${this.cliPath}"`];(u==null?void 0:u.unlock)&&D.push("--file-chmod"),D.push("--file-write",`"${r.fsPath}"`,`"${s.fsPath}"`);const _={name:this.productService.nameLong.replace("-",""),icns:M.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};h.exec(D.join(" "),_,(U,q,Q)=>{q&&this.logService.trace(`[sudo-prompt] received stdout: ${q}`),Q&&this.logService.trace(`[sudo-prompt] received stderr: ${Q}`),U?m(U):f(void 0)})})}get cliPath(){return M.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):M.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,p.totalmem)(),freemem:(0,p.freemem)(),loadavg:(0,p.loadavg)()}}async getOSProperties(){return{arch:(0,p.arch)(),platform:(0,p.platform)(),release:(0,p.release)(),type:(0,p.type)(),cpus:(0,p.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(t,r,s){process.kill(r,s)}async readClipboardText(t,r){return L.clipboard.readText(r)}async writeClipboardText(t,r,s){return L.clipboard.writeText(r,s)}async readClipboardFindText(t){return L.clipboard.readFindText()}async writeClipboardFindText(t,r){return L.clipboard.writeFindText(r)}async writeClipboardBuffer(t,r,s,u){return L.clipboard.writeBuffer(r,Buffer.from(s),u)}async readClipboardBuffer(t,r){return L.clipboard.readBuffer(r)}async hasClipboard(t,r,s){return L.clipboard.has(r,s)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,r){const s=this.windowById(t);s&&s.updateTouchBar(r)}async notifyReady(t){const r=this.windowById(t);r&&r.setReady()}async relaunch(t,r){return this.lifecycleMainService.relaunch(r)}async reload(t,r){const s=this.windowById(t);if(s)return this.lifecycleMainService.reload(s,(r==null?void 0:r.disableExtensions)!==void 0?{_:[],"disable-extensions":r==null?void 0:r.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,r){const s=this.windowById(r);if(s==null?void 0:s.win)return s.win.close()}async quit(t){const r=this.windowsMainService.getLastActiveWindow();(r==null?void 0:r.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&r.win?r.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,r){await this.lifecycleMainService.kill(r)}async resolveProxy(t,r){var s,u;const h=this.windowById(t),f=(u=(s=h==null?void 0:h.win)===null||s===void 0?void 0:s.webContents)===null||u===void 0?void 0:u.session;if(f)return f.resolveProxy(r)}async openDevTools(t,r){const s=this.windowById(t);(s==null?void 0:s.win)&&s.win.webContents.openDevTools(r)}async toggleDevTools(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.webContents.toggleDevTools()}async sendInputEvent(t,r){const s=this.windowById(t);(s==null?void 0:s.win)&&(r.type==="mouseDown"||r.type==="mouseUp")&&s.win.webContents.sendInputEvent(r)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,r,s,u){if(!!M.isWindows){const h=await new Promise((f,m)=>{H(["vscode-windows-registry"],f,m)});try{return h.GetStringRegKey(r,s,u)}catch(f){return}}}async getPassword(t,r,s){const u=await this.withKeytar(),h=await u.getPassword(r,s);if(h)try{let{content:f,hasNextChunk:m}=JSON.parse(h);if(!f||!m)return h;let D=1;for(;m;){const _=await u.getPassword(r,`${s}-${D}`),U=JSON.parse(_);f+=U.content,m=U.hasNextChunk}return f}catch(f){return h}return h}async setPassword(t,r,s,u){const h=await this.withKeytar();if(M.isWindows&&u.length>st.MAX_PASSWORD_LENGTH){let f=0,m=0,D=!0;for(;D;){const _=u.substring(f,f+st.PASSWORD_CHUNK_SIZE);f+=st.PASSWORD_CHUNK_SIZE,D=u.length-f>0;const U={content:_,hasNextChunk:D};await h.setPassword(r,m?`${s}-${m}`:s,JSON.stringify(U)),m++}}else await h.setPassword(r,s,u);this._onDidChangePassword.fire({service:r,account:s})}async deletePassword(t,r,s){const h=await(await this.withKeytar()).deletePassword(r,s);return h&&this._onDidChangePassword.fire({service:r,account:s}),h}async findPassword(t,r){return(await this.withKeytar()).findPassword(r)}async findCredentials(t,r){return(await this.withKeytar()).findCredentials(r)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,r)=>{H(["keytar"],t,r)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};o.MAX_PASSWORD_LENGTH=2500,o.PASSWORD_CHUNK_SIZE=o.MAX_PASSWORD_LENGTH-100,ce([a.memoize],o.prototype,"cliPath",null),o=ce([ee(1,A.IWindowsMainService),ee(2,S.IDialogMainService),ee(3,b.ILifecycleMainService),ee(4,i.IEnvironmentMainService),ee(5,g.ITelemetryService),ee(6,w.ILogService),ee(7,I.IProductService)],o),e.NativeHostMainService=o}),define(X[213],J([0,1,2,5,80,13,6,34,41,89,28,20,25]),function(H,e,v,A,L,b,M,i,S,y,n,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let d=class extends v.Disposable{constructor(P,I,a,l,o){super();this.logService=P,this.windowsMainService=I,this.nativeHostMainService=a,this.encryptionMainService=l,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=A.Event.fromNodeEventEmitter(b.app,"login",(I,a,l,o,c)=>({event:I,webContents:a,req:l,authInfo:o,callback:c}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:I,req:a,callback:l}){if(!!I.isProxy){if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}l(o==null?void 0:o.username,o==null?void 0:o.password)}}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(P);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){var I,a,l,o;this.logService.trace("auth#doResolveProxyCredentials - enter",P);const c=String((0,L.hash)({scheme:P.scheme,host:P.host,port:P.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c);if(f){const m=JSON.parse(await this.encryptionMainService.decrypt(f));t=m.username,r=m.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const u={authInfo:P,username:(a=(I=this.sessionCredentials)===null||I===void 0?void 0:I.username)!==null&&a!==void 0?a:t,password:(o=(l=this.sessionCredentials)===null||l===void 0?void 0:l.password)!==null&&o!==void 0?o:r,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,u),this.state=p.LoginDialogShown;const h=await new Promise(f=>{var m;const D=async(_,U,q)=>{var Q;if(U===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(Q=s.win)===null||Q===void 0||Q.webContents.off("ipc-message",D),q){const ie={username:q.username,password:q.password};try{if(q.remember){const ae=await this.encryptionMainService.encrypt(JSON.stringify(ie));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c,ae)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c)}catch(ae){this.logService.error(ae)}f({username:ie.username,password:ie.password})}else f(void 0)};(m=s.win)===null||m===void 0||m.webContents.on("ipc-message",D)});return this.sessionCredentials=h,h}};d=ce([ee(0,M.ILogService),ee(1,i.IWindowsMainService),ee(2,S.INativeHostMainService),ee(3,y.IEncryptionMainService),ee(4,g.IProductService)],d),e.ProxyAuthHandler=d}),define(X[214],J([0,1,211,34,56,2,33,57,170,3,5,79,103,9,16,41]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(l){return l<21}let I=class{constructor(o,c,t,r,s){this.windowServer=o,this.options=c,this.windowsMainService=t,this.lifecycleMainService=r,this.nativeHostMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!(c==null?void 0:c.win))throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const c=this.windowsMainService.getWindowById(o);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(c)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(o,c){await this.whenUnfrozen(o);const t=E.KeybindingParser.parseUserBinding(c);for(let r of t)await this._dispatchKeybinding(o,r)}async _dispatchKeybinding(o,c){if(c instanceof g.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(o);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const r=t.win.webContents,s=new i.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),h=new S.USLayoutResolvedKeybinding(s.toChord(),y.OS).getElectronAccelerator(),f=[];c.ctrlKey&&f.push("ctrl"),c.metaKey&&f.push("meta"),c.shiftKey&&f.push("shift"),c.altKey&&f.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:h,modifiers:f}),P(c.keyCode)||r.sendInputEvent({type:"char",keyCode:h,modifiers:f}),r.sendInputEvent({type:"keyUp",keyCode:h,modifiers:f}),await(0,p.timeout)(100)}async click(o,c,t,r){await(await this.getWindowDriver(o)).click(c,t,r)}async doubleClick(o,c){await(await this.getWindowDriver(o)).doubleClick(c)}async setValue(o,c,t){await(await this.getWindowDriver(o)).setValue(c,t)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,c){return await(await this.getWindowDriver(o)).isActiveElement(c)}async getElements(o,c,t){return await(await this.getWindowDriver(o)).getElements(c,t)}async getElementXY(o,c,t,r){return await(await this.getWindowDriver(o)).getElementXY(c,t,r)}async typeInEditor(o,c,t){await(await this.getWindowDriver(o)).typeInEditor(c,t)}async getTerminalBuffer(o,c){return await(await this.getWindowDriver(o)).getTerminalBuffer(c)}async writeInTerminal(o,c,t){await(await this.getWindowDriver(o)).writeInTerminal(c,t)}async getWindowDriver(o){await this.whenUnfrozen(o);const c=`window:${o}`,t=new M.StaticRouter(s=>s===c),r=this.windowServer.getChannel("windowDriver",t);return new v.WindowDriverChannelClient(r)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await n.Event.toPromise(this.onDidReloadingChange.event)}};I=ce([ee(2,A.IWindowsMainService),ee(3,d.ILifecycleMainService),ee(4,w.INativeHostMainService)],I),e.Driver=I;async function a(l,o,c,t){const r=c.driverVerbose,s=t.createInstance(I,l,{verbose:r}),u=new v.WindowDriverRegistryChannel(s);l.registerChannel("windowDriverRegistry",u);const h=await(0,L.serve)(o),f=new v.DriverChannel(s);return h.registerChannel("driver",f),(0,b.combinedDisposable)(h,l)}e.serve=a}),define(X[215],J([0,1,59,56]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,b,M,i){const S=n=>i(n,void 0),y=v.createConnection({host:L,port:b},()=>{y.removeListener("error",S);const n=Buffer.alloc(16);for(let d=0;d<16;d++)n[d]=Math.round(Math.random()*256);const g=n.toString("base64");let E=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${b}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];y.write(E.join(`\r
`)+`\r
\r
`);const p=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",p),i(void 0,new A.NodeSocket(y)))};y.on("data",p)});y.once("error",S)}}}),define(X[216],J([0,1,59,9,2,113,6,20,184,73,215,74]),function(H,e,v,A,L,b,M,i,S,y,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(P,I,a,l){return new p(P,I,a,l).waitForReady()}class p extends L.Disposable{constructor(I,a,l,o){super();this.suggestedLocalPort=o,this.public=!1,this._socketsDispose=new Map,this._options=I,this._server=v.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=c=>this._onConnection(c),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){var I;let a=await(0,b.findFreePortFaster)((I=this.suggestedLocalPort)!==null&&I!==void 0?I:this.tunnelRemotePort,2,1e3),l=null;return l=this._server.listen(a).address(),l||(a=0,l=this._server.listen(a).address()),this.tunnelLocalPort=l.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(I){I.pause();const a=await(0,S.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),l=a.getSocket().socket,o=a.readEntireBuffer();a.dispose(),o.byteLength>0&&I.write(o.buffer),I.on("end",()=>{this._socketsDispose.delete(I.localAddress),l.end()}),I.on("close",()=>l.end()),I.on("error",()=>{this._socketsDispose.delete(I.localAddress),l.destroy()}),l.on("end",()=>I.end()),l.on("close",()=>I.end()),l.on("error",()=>{I.destroy()}),I.pipe(l),l.pipe(I),this._socketsDispose.set(I.localAddress,()=>{I.end(),l.end()})}}let d=class extends y.AbstractTunnelService{constructor(I,a,l,o){super(a);this.socketFactory=I,this.signService=l,this.productService=o}retainOrCreateTunnel(I,a,l,o,c,t){const r=this.getTunnelFromMap(a,l);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,o,c,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${o}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:I,signService:this.signService,logService:this.logService,ipcLogger:null},u=E(s,a,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,u),u}}};d=ce([ee(1,M.ILogService),ee(2,g.ISignService),ee(3,i.IProductService)],d),e.BaseTunnelService=d;let w=class extends d{constructor(I,a,l){super(n.nodeSocketFactory,I,a,l)}};w=ce([ee(0,M.ILogService),ee(1,g.ISignService),ee(2,i.IProductService)],w),e.TunnelService=w}),define(X[217],J([0,1,210,186,2,12,17,185,21,6,23,46,69]),function(H,e,v,A,L,b,M,i,S,y,n,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends L.Disposable{constructor(w,P,I){super();this.environmentService=P,this.logService=I,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,P){this.logService.trace("RequestService#request",w.url);const{proxyUrl:I,strictSSL:a}=this,l=Object.assign(Object.assign({},process.env),await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),o=w.agent?w.agent:await(0,i.getProxyAgent)(w.url||"",l,{proxyUrl:I,strictSSL:a});return w.agent=o,w.strictSSL=a,this.authorization&&(w.headers=Object.assign(Object.assign({},w.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(w,P)}async getNodeRequest(w){return((0,A.parse)(w.url).protocol==="https:"?await new Promise((a,l)=>{H(["https"],a,l)}):await new Promise((a,l)=>{H(["http"],a,l)})).request}_request(w,P){return new Promise(async(I,a)=>{let l;const o=(0,A.parse)(w.url),c=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,b.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(t.auth=w.user+":"+w.password),l=c(t,r=>{const s=(0,b.isNumber)(w.followRedirects)?w.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},w),{url:r.headers.location,followRedirects:s-1}),P).then(I,a);else{let u=r;r.headers["content-encoding"]==="gzip"&&(u=r.pipe((0,v.createGunzip)())),I({res:r,stream:(0,n.streamToBufferReadableStream)(u)})}}),l.on("error",a),w.timeout&&l.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&l.write(w.data),l.end(),P.onCancellationRequested(()=>{l.abort(),a((0,M.canceled)())})})}async resolveProxy(w){}};p=ce([ee(0,S.IConfigurationService),ee(1,g.INativeEnvironmentService),ee(2,y.ILogService)],p),e.RequestService=p}),define(X[218],J([0,1,217,13]),function(H,e,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(M){return A.net.request}class b extends v.RequestService{request(i,S){return super.request(Object.assign(Object.assign({},i||{}),{getRawRequest:L}),S)}}e.RequestMainService=b}),define(X[219],J([0,1,47,13,26,9,6,16,75,10,3,2,84,12,5,69,55]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let I=class extends g.Disposable{constructor(l,o,c,t,r,s,u){super();this.machineId=l,this.userEnv=o,this.environmentMainService=c,this.lifecycleMainService=t,this.logService=r,this.themeMainService=s,this.protocolMainService=u,this.firstWindowConnectionBarrier=new b.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),A.ipcMain.on("vscode:createSharedProcessMessageChannel",async(l,o)=>this.onWindowConnection(l,o))}async onWindowConnection(l,o){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(l.sender.isDestroyed())return c.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",o,[c])}onWillShutdown(){const l=this.window;!l||(!l.isDestroyed()&&!l.webContents.isDestroyed()&&l.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch(o){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>A.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>A.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new A.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`],v8CacheOptions:n.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",H).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{var o;this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),((o=this.window)===null||o===void 0?void 0:o.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,o)=>this._onDidError.fire({type:2,details:o})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(l,o,c)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${c}`})))}async connect(){await this.whenIpcReady;const l=(0,p.assertIsDefined)(this.window);return(0,E.connect)(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var l,o;return(o=(l=this.window)===null||l===void 0?void 0:l.isVisible())!==null&&o!==void 0?o:!1}};I=ce([ee(2,L.IEnvironmentMainService),ee(3,i.ILifecycleMainService),ee(4,M.ILogService),ee(5,S.IThemeMainService),ee(6,P.IProtocolMainService)],I),e.SharedProcess=I}),define(X[77],J([0,1,5,9,21,16,20,40,26,6,49,25]),function(H,e,v,A,L,b,M,i,S,y,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,w,P){return`${P.updateUrl}/api/update/${d}/${w}/${P.commit}`}e.createUpdateURL=E;let p=class{constructor(w,P,I,a,l,o){this.lifecycleMainService=w,this.configurationService=P,this.environmentMainService=I,this.requestService=a,this.logService=l,this.productService=o,this._state=i.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(w);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(i.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,A.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},g.CancellationToken.None).then(w=>w.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=ce([ee(0,b.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,S.IEnvironmentMainService),ee(3,n.IRequestService),ee(4,y.ILogService),ee(5,M.IProductService)],p),e.AbstractUpdateService=p}),define(X[220],J([0,1,13,2,5,53,21,16,40,31,26,6,77,49,20]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends E.AbstractUpdateService{constructor(I,a,l,o,c,t,r){super(I,a,o,c,t,r);this.telemetryService=l,this.disposables=new A.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"error",(I,a)=>a)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(I,a,l)=>({url:a,version:l,productVersion:l}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(I,a,l,o)=>({releaseNotes:a,version:l,productVersion:l,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const l=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(S.State.Idle(1,l))}buildUpdateFeedUrl(I){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,E.createUpdateURL)(a,I,this.productService);try{v.autoUpdater.setFeedURL({url:l})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return l}doCheckForUpdates(I){this.setState(S.State.CheckingForUpdates(I)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(S.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([b.memoize],w.prototype,"onRawError",null),ce([b.memoize],w.prototype,"onRawUpdateNotAvailable",null),ce([b.memoize],w.prototype,"onRawUpdateAvailable",null),ce([b.memoize],w.prototype,"onRawUpdateDownloaded",null),w=ce([ee(0,i.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,y.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,p.IRequestService),ee(5,g.ILogService),ee(6,d.IProductService)],w),e.DarwinUpdateService=w}),define(X[221],J([0,1,20,21,16,40,31,26,6,77,49,25,41]),function(H,e,v,A,L,b,M,i,S,y,n,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends y.AbstractUpdateService{constructor(w,P,I,a,l,o,c,t){super(w,P,a,l,o,t);this.telemetryService=I,this.nativeHostMainService=c}buildUpdateFeedUrl(w){return(0,y.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(b.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},g.CancellationToken.None).then(n.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const I=w?P.message||P:void 0;this.setState(b.State.Idle(1,I))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(b.State.Idle(1))}};p=ce([ee(0,L.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,M.ITelemetryService),ee(3,i.IEnvironmentMainService),ee(4,n.IRequestService),ee(5,S.ILogService),ee(6,E.INativeHostMainService),ee(7,v.IProductService)],p),e.LinuxUpdateService=p}),define(X[222],J([0,1,5,9,16,40,26,6,8,18,45,31]),function(H,e,v,A,L,b,M,i,S,y,n,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(w,P,I){if(this.lifecycleMainService=w,this.logService=I,this._state=b.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,A.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ce([ee(0,L.ILifecycleMainService),ee(1,M.IEnvironmentMainService),ee(2,i.ILogService)],E);let p=class extends E{constructor(w,P,I,a,l,o){super(I,a,l);this.snap=w,this.snapRevision=P,this.telemetryService=o;const c=(0,y.watch)(S.dirname(this.snap)),t=v.Event.fromNodeEventEmitter(c,"change",(h,f)=>f),r=v.Event.filter(t,h=>h==="current"),u=v.Event.debounce(r,(h,f)=>f,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{u.dispose(),c.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(w=>{w?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,w.message||w))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+S.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((I,a)=>(0,y.realpath)(`${S.dirname(this.snap)}/current`,(l,o)=>l?a(l):I(o))),P=S.basename(w);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ce([ee(2,L.ILifecycleMainService),ee(3,M.IEnvironmentMainService),ee(4,i.ILogService),ee(5,g.ITelemetryService)],p),e.SnapUpdateService=p}),define(X[223],J([0,1,18,8,19,53,21,16,20,40,31,26,6,77,49,109,27,45,25,9,24,7,41]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,m=1e3){for(;!f();)await(0,l.timeout)(m)}let s;function u(){return typeof s=="undefined"&&(s=v.existsSync(A.join(A.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends p.AbstractUpdateService{constructor(m,D,_,U,q,Q,ie,ae,O){super(m,D,U,q,Q,O);this.telemetryService=_,this.fileService=ie,this.nativeHostMainService=ae}get cachePath(){const m=A.join((0,P.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return v.promises.mkdir(m,{recursive:!0}).then(()=>m)}initialize(){super.initialize(),u()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(m){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),u()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,p.createUpdateURL)(D,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(y.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},a.CancellationToken.None).then(d.asJson).then(D=>{const _=u();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(y.State.Idle(_)),Promise.resolve(null)):_===1?(this.setState(y.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(y.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(U=>L.exists(U).then(q=>{if(q)return Promise.resolve(U);const Q=D.url,ie=D.hash,ae=`${U}.tmp`;return this.requestService.request({url:Q},a.CancellationToken.None).then(O=>this.fileService.writeFile(c.URI.file(ae),O.stream)).then(ie?()=>(0,w.checksum)(ae,D.hash):()=>{}).then(()=>v.promises.rename(ae,U)).then(()=>U)})).then(U=>{const q=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},q&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(y.State.Downloaded(D)):this.setState(y.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const _=m?D.message||D:void 0;this.setState(y.State.Idle(u(),_))}))}async doDownloadUpdate(m){m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(y.State.Idle(u()))}async getUpdatePackagePath(m){const D=await this.cachePath;return A.join(D,`CodeSetup-${this.productService.quality}-${m}.exe`)}async cleanup(m=null){const D=m?Q=>!new RegExp(`${this.productService.quality}-${m}\\.exe$`).test(Q):()=>!0,_=await this.cachePath,q=(await L.readdir(_)).filter(D).map(async Q=>{try{await v.promises.unlink(A.join(_,Q))}catch(ie){}});await Promise.all(q)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const m=this.state.update;this.setState(y.State.Updating(m));const D=await this.cachePath;this.availableUpdate.updateFilePath=A.join(D,`CodeSetup-${this.productService.quality}-${m.version}.flag`),await L.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(y.State.Idle(u()))});const U=`${this.productService.win32MutexName}-ready`,q=await new Promise((Q,ie)=>{H(["windows-mutex"],Q,ie)});r(()=>q.isActive(U)).then(()=>this.setState(y.State.Ready(m)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?v.unlinkSync(this.availableUpdate.updateFilePath):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return u()}};ce([b.memoize],h.prototype,"cachePath",null),h=ce([ee(0,i.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,n.ITelemetryService),ee(3,g.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,E.ILogService),ee(6,o.IFileService),ee(7,t.INativeHostMainService),ee(8,S.IProductService)],h),e.Win32UpdateService=h}),define(X[52],J([0,1,29,26,8,19,18,3,5,6,58,43,10,2,15,4,149,20,13,12,50,51,98]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let r=class extends p.Disposable{constructor(f,m,D,_,U){super();this.environmentMainService=f,this.logService=m,this.backupMainService=D,this.dialogMainService=_,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new S.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new S.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==E.Schemas.file)return null;let m;try{m=(0,M.readFileSync)(f.fsPath,"utf8")}catch(D){return null}return this.doResolveWorkspace(f,m)}isWorkspacePath(f){return(0,v.isUntitledWorkspace)(f,this.environmentMainService)||(0,v.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,m){try{const D=this.doParseStoredWorkspace(f,m),_=s(f);return{id:_.id,configPath:_.configPath,folders:(0,v.toWorkspaceFolders)(D.folders,_.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:D.remoteAuthority}}catch(D){this.logService.warn(D.toString())}return null}doParseStoredWorkspace(f,m){const D=(0,g.parse)(m);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(_=>(0,v.isStoredWorkspaceFolder)(_));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return D}async createUntitledWorkspace(f,m){const{workspace:D,storedWorkspace:_}=this.newUntitledWorkspace(f,m),U=D.configPath.fsPath;return await M.promises.mkdir((0,L.dirname)(U),{recursive:!0}),await(0,b.writeFile)(U,JSON.stringify(_,null,"	")),D}createUntitledWorkspaceSync(f,m){const{workspace:D,storedWorkspace:_}=this.newUntitledWorkspace(f,m),U=D.configPath.fsPath;return(0,M.mkdirSync)((0,L.dirname)(U),{recursive:!0}),(0,b.writeFileSync)(U,JSON.stringify(_,null,"	")),D}newUntitledWorkspace(f=[],m){const D=(Date.now()+Math.round(Math.random()*1e3)).toString(),_=(0,d.joinPath)(this.untitledWorkspacesHome,D),U=(0,d.joinPath)(_,v.UNTITLED_WORKSPACE_NAME),q=[];for(const Q of f)q.push((0,v.getStoredWorkspaceFolder)(Q.uri,!0,Q.name,_,!i.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:s(U),storedWorkspace:{folders:q,remoteAuthority:m}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return(0,v.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const m=(0,d.originalFSPath)(f.configPath);try{(0,b.rimrafSync)((0,L.dirname)(m));const D=(0,L.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,M.existsSync)(D)&&(0,b.writeFileSync)((0,L.join)(D,"obsolete"),"")}catch(D){this.logService.warn(`Unable to delete untitled workspace ${m} (${D}).`)}}getUntitledWorkspacesSync(){const f=[];try{const m=(0,b.readdirSync)(this.untitledWorkspacesHome.fsPath).map(D=>(0,d.joinPath)(this.untitledWorkspacesHome,D,v.UNTITLED_WORKSPACE_NAME));for(const D of m){const _=s(D),U=this.resolveLocalWorkspaceSync(D);U?f.push({workspace:_,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(_)}}catch(m){m.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${m}).`)}return f}async enterWorkspace(f,m,D){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,m,D))return null;const U=this.doEnterWorkspace(f,s(D));return U?(this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U):null}async isValidTargetWorkspacePath(f,m,D){if(!D)return!0;if((0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,D))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(m,D)){const _={title:this.productService.nameLong,type:"info",buttons:[(0,P.localize)(0,null)],message:(0,P.localize)(1,null,(0,d.basename)(D)),detail:(0,P.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(_,(0,l.withNullAsUndefined)(a.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,m){if(!f.config)return null;f.focus();let D;return f.config.extensionDevelopmentPath||(D=this.backupMainService.registerWorkspaceBackupSync({workspace:m,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=m,f.config.backupPath=D,{workspace:m,backupPath:D}}};r=ce([ee(0,A.IEnvironmentMainService),ee(1,y.ILogService),ee(2,o.IBackupMainService),ee(3,c.IDialogMainService),ee(4,I.IProductService)],r),e.WorkspacesManagementMainService=r;function s(h){function f(){let m=h.scheme===E.Schemas.file?(0,d.originalFSPath)(h):h.toString();return i.isLinux||(m=m.toLowerCase()),(0,n.createHash)("md5").update(m).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=s;function u(h,f){function m(){if(h.scheme!==E.Schemas.file)return(0,n.createHash)("md5").update(h.toString()).digest("hex");if(!f)try{f=(0,M.statSync)(h.fsPath)}catch(U){return}let _;return i.isLinux?_=f.ino:i.isMacintosh?_=f.birthtime.getTime():i.isWindows&&(typeof f.birthtimeMs=="number"?_=Math.floor(f.birthtimeMs):_=f.birthtime.getTime()),(0,n.createHash)("md5").update(h.fsPath).update(_?String(_):"").digest("hex")}const D=m();if(typeof D=="string")return{id:D,uri:h}}e.getSingleFolderWorkspaceIdentifier=u}),define(X[99],J([0,1,6,96,3,4,34,19,52,21,7,13,35,54,25,29,12]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let I=class{constructor(l,o,c,t,r){this.logService=l,this.windowsMainService=o,this.urlService=c,this.workspacesManagementMainService=t,this.configurationService=r}async start(l,o){this.logService.trace("Received data from other instance: ",l,o),L.isMacintosh&&g.app.focus({steal:!0});const c=this.parseOpenUrl(l);if(c.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of c)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(l,o)}parseOpenUrl(l){return l["open-url"]&&l._urls&&l._urls.length>0?(0,E.coalesce)(l._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(c){return null}})):[]}async startOpenWindow(l,o){const c=(0,p.isLaunchedFromCli)(o)?0:4;let t=[];const r=l.wait&&l.waitMarkerFilePath?n.URI.file(l.waitMarkerFilePath):void 0,s=l.remote||void 0;if(l.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(l.extensionDevelopmentPath,{context:c,cli:l,userEnv:o,waitMarkerFileURI:r,remoteAuthority:s});else if(!l._.length&&!l["folder-uri"]&&!l["file-uri"]){let u=!1;if(l["new-window"]||l["unity-launch"])u=!0;else if(l["reuse-window"])u=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!L.isMacintosh}}if(u)t=this.windowsMainService.open({context:c,cli:l,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:c,cli:l,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:c,cli:l,userEnv:o,forceNewWindow:l["new-window"],preferNewWindow:!l["reuse-window"]&&!l.wait,forceReuseWindow:l["reuse-window"],diffMode:l.diff,addMode:l.add,noRecentEntry:!!l["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:l.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,i.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const l=[];return g.BrowserWindow.getAllWindows().forEach(o=>{const c=this.windowsMainService.getWindowById(o.id);c?l.push(this.codeWindowToInfo(c)):l.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,screenReader:!!g.app.accessibilitySupportEnabled,gpuFeatureStatus:g.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(l){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const u=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:u,args:h}),g.ipcMain.once(u,(f,m)=>{m||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(m)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(l){const o=[],c=l.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(c))o.push(c.uri);else if((0,w.isWorkspaceIdentifier)(c)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);t&&t.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(l){const o=this.getFolderURIs(l),c=(0,P.assertIsDefined)(l.win);return this.browserWindowToInfo(c,o,l.remoteAuthority)}browserWindowToInfo(l,o=[],c){return{pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:o,remoteAuthority:c}}};I=ce([ee(0,v.ILogService),ee(1,M.IWindowsMainService),ee(2,A.IURLService),ee(3,S.IWorkspacesManagementMainService),ee(4,y.IConfigurationService)],I),e.LaunchMainService=I}),define(X[224],J([0,1,140,27,47,13,99,68,26,3,6,82,51,4,60,10,41,55,2]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let l=class pt{constructor(c,t,r,s,u,h,f,m){this.userEnv=c,this.environmentMainService=t,this.launchMainService=r,this.logService=s,this.diagnosticsService=u,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=m,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){b.ipcMain.on("vscode:issueSystemInfoRequest",async c=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(c,"vscode:issueSystemInfoResponse",s)}),b.ipcMain.on("vscode:listProcesses",async c=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:(0,v.localize)(0,null),rootProcess:await(0,g.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,i.isRemoteDiagnosticError)(u)?t.push({name:u.hostName,rootProcess:u}):u.processes&&t.push({name:u.hostName,rootProcess:u.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(c,"vscode:listProcessesResponse",t)}),b.ipcMain.on("vscode:issueReporterClipboard",async c=>{const t={message:(0,v.localize)(1,null),type:"warning",buttons:[(0,v.localize)(2,null),(0,v.localize)(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(c,"vscode:issueReporterClipboardResponse",r.response===0)}}),b.ipcMain.on("vscode:issuePerformanceInfoRequest",async c=>{const t=await this.getPerformanceInfo();this.safeSend(c,"vscode:issuePerformanceInfoResponse",t)}),b.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const c={message:(0,v.localize)(4,null),type:"warning",buttons:[(0,v.localize)(5,null),(0,v.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(c,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),b.ipcMain.on("vscode:workbenchCommand",(c,t)=>{const{id:r,from:s,args:u}=t;let h;switch(s){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}h&&h.webContents.send("vscode:runAction",{id:r,from:s,args:u})}),b.ipcMain.on("vscode:openExternal",(c,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),b.ipcMain.on("vscode:closeIssueReporter",c=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),b.ipcMain.on("vscode:closeProcessExplorer",c=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),b.ipcMain.on("vscode:windowsInfoRequest",async c=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(c,"vscode:windowsInfoResponse",t.windows)})}safeSend(c,t,...r){c.sender.isDestroyed()||c.sender.send(t,...r)}async openReporter(c){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=b.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new a.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,s,c.styles.backgroundColor,(0,v.localize)(7,null),c.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:c,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:L.default}),this.issueReporterWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",H,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(c){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=b.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new a.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,s,c.styles.backgroundColor,(0,v.localize)(8,null),c.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:c,product:L.default}),this.processExplorerWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",H,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(c,t,r,s,u){const h=new b.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:c.width,height:c.height,minWidth:300,minHeight:200,x:c.x,y:c.y,title:s,backgroundColor:r||pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(u),sandbox:!0,contextIsolation:!0}});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(c,t)}getWindowPosition(c,t,r){let s;const u=b.screen.getAllDisplays();if(u.length===1)s=u[0];else{if(y.isMacintosh){const m=b.screen.getCursorScreenPoint();s=b.screen.getDisplayNearestPoint(m)}!s&&c&&(s=b.screen.getDisplayMatching(c.getBounds())),s||(s=b.screen.getPrimaryDisplay()||u[0])}const h={width:t,height:r},f=s.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(c,t)}catch(c){throw this.logService.warn("issueService#getPerformanceInfo ",c.message),c}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=ce([ee(1,S.IEnvironmentMainService),ee(2,M.ILaunchMainService),ee(3,n.ILogService),ee(4,i.IDiagnosticsService),ee(5,E.IDialogMainService),ee(6,P.INativeHostMainService),ee(7,I.IProtocolMainService)],l),e.IssueMainService=l}),define(X[225],J([0,1,8,145,71,5,7,13,26,6,21,20,60,2,3,34,29,52,50,193,75,31,51,39,197,16,97,24,10,54,25,41,55]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c,t,r,s,u,h,f,m,D,_,U,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(ae){ae[ae.NONE=0]="NONE",ae[ae.LOADING=1]="LOADING",ae[ae.NAVIGATING=2]="NAVIGATING",ae[ae.READY=3]="READY"})(Q||(Q={}));let ie=class extends p.Disposable{constructor(O,$,z,C,j,N,T,R,W,k,F,B,V,G,Y){super();this.logService=$,this.environmentMainService=z,this.fileService=C,this.configurationService=N,this.themeMainService=T,this.workspacesManagementMainService=R,this.backupMainService=W,this.telemetryService=k,this.dialogMainService=F,this.lifecycleMainService=B,this.nativeHostMainService=V,this.productService=G,this.protocolMainService=Y,this._onWillLoad=this._register(new b.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new b.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new b.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new b.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Z,re]=this.restoreWindowState(O.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const se=this.windowState.mode===0||this.windowState.mode===3,x=this.configurationService.getValue("window"),ne={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:E.WindowMinimumSize.WIDTH,minHeight:E.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:Object.assign({preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",H).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,E.zoomLevelToZoomFactor)(x==null?void 0:x.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),d.isLinux?ne.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(ne.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(ne.fullscreenable=!1),d.isMacintosh&&(ne.acceptFirstMouse=!0,(x==null?void 0:x.clickThroughInactive)===!1&&(ne.acceptFirstMouse=!1));const ue=d.isMacintosh&&(x==null?void 0:x.nativeTabs)===!0;ue&&(ne.tabbingIdentifier=this.productService.nameShort);const ye=(0,E.getTitleBarStyle)(this.configurationService)==="custom";if(ye&&(ne.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(ne.frame=!1)),(0,L.mark)("code/willCreateCodeBrowserWindow"),this._win=new i.BrowserWindow(ne),(0,L.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&ye&&this._win.setSheetOffset(22),d.isMacintosh&&re&&(!ue||i.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ge=>typeof ge=="number")){const ge=this.windowState;this._win.setBounds({width:ge.width,height:ge.height,x:ge.x,y:ge.y})}se&&((0,L.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,L.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,l.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:Z=>j.globalStorage.get(Z),store:(Z,re)=>j.globalStorage.set(Z,re)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.backupPath}get openedWorkspace(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.workspace}get remoteAuthority(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionDevelopmentPath)}get isExtensionTestHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var O;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((O=this.currentConfig)===null||O===void 0?void 0:O.debugId)}setRepresentedFilename(O){d.isMacintosh?this._win.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){d.isMacintosh&&this._win.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(O){d.isMacintosh&&(O==null?void 0:O.force)&&i.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(O=>{function $(){z.dispose(),C.dispose(),O()}const z=this.onDidClose(()=>$()),C=this.onWillLoad(()=>$())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(C,j)=>this.onWindowError(2,j)),this._win.webContents.on("did-fail-load",(C,j,N)=>this.onWindowError(3,N)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const O=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,"devtools"]),$=C=>{for(let j=C;j;j=j.parent)if(j.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1};this._win.webContents.session.webRequest.onBeforeRequest((C,j)=>{const N=M.URI.parse(C.url);if(N.path.endsWith(".svg")&&!(O.has(N.scheme)||N.path.includes(m.Schemas.vscodeRemoteResource))){const R=$(C.frame);return j({cancel:!R})}return j({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((C,j)=>{const N=C.responseHeaders,T=N["content-type"]||N["Content-Type"];if(T&&Array.isArray(T)){const R=M.URI.parse(C.url);if(R.path.endsWith(".svg")&&O.has(R.scheme))return N["Content-Type"]=["image/svg+xml"],j({cancel:!1,responseHeaders:N});if(!R.path.includes(m.Schemas.vscodeRemoteResource)&&T.some(W=>W.toLowerCase().includes("image/svg"))){const W=$(C.frame);return j({cancel:!W})}}return j({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),d.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!0),i.app.emit("browser-window-maximize",C,this._win)}),this._win.on("unmaximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!1),i.app.emit("browser-window-unmaximize",C,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",_.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",_.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(C=>this.onDidDeleteUntitledWorkspace(C)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(C,j)=>{const N=await this.marketplaceHeadersPromise;j({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,N)})})}async onWindowError(O,$){switch(O){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof $=="string"?$:$==null?void 0:$.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof $=="string"?$:$==null?void 0:$.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:O,reason:typeof $!="string"?$==null?void 0:$.reason:void 0}),O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,A.localize)(0,null)),(0,r.mnemonicButtonLabel)((0,A.localize)(1,null)),(0,r.mnemonicButtonLabel)((0,A.localize)(2,null))],message:(0,A.localize)(3,null),detail:(0,A.localize)(4,null),noLink:!0},this._win);if(!this._win)return;z.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):z.response===2&&this.destroyWindow()}else if(O===2){let z;typeof $=="string"||!$?z=(0,A.localize)(5,null):z=(0,A.localize)(6,null,$.reason);const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,A.localize)(7,null)),(0,r.mnemonicButtonLabel)((0,A.localize)(8,null))],message:z,detail:(0,A.localize)(9,null),noLink:!0},this._win);if(!this._win)return;C.response===0?this.reload():C.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(O){var $;(($=this.openedWorkspace)===null||$===void 0?void 0:$.id)===O.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const O=this.getMenuBarVisibility();O!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=O,this.setMenuBarVisibility(O));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;($==null?void 0:$.endsWith("/"))&&($=$.substr(0,$.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=z;const C=$||"",j=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(O){d.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,$=Object.create(null)){this.isDocumentEdited()&&(!$.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),$.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,$),this.readyState===0?this.currentConfig=O:(this.pendingLoadConfig=O,this.readyState=2),this._win.loadURL(m.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",H).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:O.workspace})}updateConfiguration(O,$){var z,C;const j=(C=(z=this.currentConfig)!==null&&z!==void 0?z:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;j&&(0,D.isLaunchedFromCli)(j)&&!(0,D.isLaunchedFromCli)(O.userEnv)&&(O.userEnv=Object.assign(Object.assign({},j),O.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),$.disableExtensions!==void 0&&(O["disable-extensions"]=$.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),(0,L.mark)("code/willOpenNewWindow"),O.perfMarks=(0,L.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const $=Object.assign({},this.currentConfig);$.workspace=await this.validateWorkspace($),delete $.filesToOpenOrCreate,delete $.filesToDiff,delete $.filesToWait,this.isExtensionDevelopmentHost&&O&&($.verbose=O.verbose,$.debugId=O.debugId,$["inspect-extensions"]=O["inspect-extensions"],$["inspect-brk-extensions"]=O["inspect-brk-extensions"],$["extensions-dir"]=O["extensions-dir"]),$.isInitialStartup=!1,this.load($,{isReload:!0,disableExtensions:O==null?void 0:O["disable-extensions"]})}async validateWorkspace(O){if((0,P.isWorkspaceIdentifier)(O.workspace)){const $=O.workspace.configPath;if($.scheme===m.Schemas.file&&!await this.fileService.exists($))return}else if((0,P.isSingleFolderWorkspaceIdentifier)(O.workspace)){const $=O.workspace.uri;if($.scheme===m.Schemas.file&&!await this.fileService.exists($))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,w.defaultWindowState)();if(this.isFullScreen){let z;try{z=i.screen.getDisplayMatching(this.getBounds())}catch(N){}const C=(0,w.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const O=Object.create(null);let $;if(!d.isMacintosh&&this._win.isMaximized()?$=0:$=1,$===0?O.mode=0:O.mode=1,$===1||$===0){let z;$===1?z=this.getBounds():z=this._win.getNormalBounds(),O.x=z.x,O.y=z.y,O.width=z.width,O.height=z.height}return O}restoreWindowState(O){(0,L.mark)("code/willRestoreCodeWindowState");let $=!1;if(O)try{const z=i.screen.getAllDisplays();$=z.length>1,O=this.validateWindowState(O,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,L.mark)("code/didRestoreCodeWindowState"),[O||(0,w.defaultWindowState)(),$]}validateWindowState(O,$){var z,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${$.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if($.length===1){const R=this.getWorkingArea($[0]);if(R){this.logService.trace("window#validateWindowState: 1 monitor working area",R);function j(){!O||typeof O.x!="number"||typeof O.y!="number"||!R||(O.x<R.x&&(O.x=R.x),O.y<R.y&&(O.y=R.y))}j(),O.width>R.width&&(O.width=R.width),O.height>R.height&&(O.height=R.height),O.x>R.x+R.width-128&&(O.x=R.x+R.width-O.width),O.y>R.y+R.height-128&&(O.y=R.y+R.height-O.height),j()}return O}if(O.display&&O.mode===3){const R=$.find(W=>W.id===O.display);if(R&&typeof((z=R.bounds)===null||z===void 0?void 0:z.x)=="number"&&typeof((C=R.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=(0,w.defaultWindowState)(3);return W.x=R.bounds.x,W.y=R.bounds.y,W}}let N,T;try{N=i.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),T=this.getWorkingArea(N)}catch(R){}if(N&&T&&O.x+O.width>T.x&&O.y+O.height>T.y&&O.x<T.x+T.width&&O.y<T.y+T.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",T),O}getWorkingArea(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,$]=this._win.getPosition(),[z,C]=this._win.getSize();return{x:O,y:$,width:z,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(O){this.useNativeFullScreen()?this.setNativeFullScreen(O):this.setSimpleFullScreen(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",_.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(O){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(O)}setSimpleFullScreen(O){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(O),this._win.webContents.focus()}useNativeFullScreen(){const O=this.configurationService.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let O=(0,E.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,$=!0){d.isMacintosh||(O==="toggle"&&$&&this.send("vscode:showInfoMessage",(0,A.localize)(10,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const $=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!$),this._win.autoHideMenuBar=$;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(i.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(O,$,...z){this.isReady?this.send(O,...z):this.ready().then(()=>{$.isCancellationRequested||this.send(O,...z)})}send(O,...$){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${O} for window that is destroyed`);return}this._win.webContents.send(O,...$)}}updateTouchBar(O){!d.isMacintosh||this.touchBarGroups.forEach(($,z)=>{const C=O[z];$.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!d.isMacintosh){for(let O=0;O<10;O++){const $=this.createTouchBarGroup();this.touchBarGroups.push($)}this._win.setTouchBar(new i.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const $=this.createTouchBarGroupSegments(O),z=new i.TouchBar.TouchBarSegmentedControl({segments:$,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",_.CancellationToken.None,{id:z.segments[C].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(O=[]){return O.map(z=>{var C,j;let N;z.icon&&!s.ThemeIcon.isThemeIcon(z.icon)&&((j=(C=z.icon)===null||C===void 0?void 0:C.dark)===null||j===void 0?void 0:j.scheme)===m.Schemas.file&&(N=i.nativeImage.createFromPath(M.URI.revive(z.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let T;return typeof z.title=="string"?T=z.title:T=z.title.value,{id:z.id,label:N?void 0:T,icon:N}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};ie=ce([ee(1,y.ILogService),ee(2,S.IEnvironmentMainService),ee(3,f.IFileService),ee(4,h.IStorageMainService),ee(5,n.IConfigurationService),ee(6,o.IThemeMainService),ee(7,I.IWorkspacesManagementMainService),ee(8,a.IBackupMainService),ee(9,c.ITelemetryService),ee(10,t.IDialogMainService),ee(11,u.ILifecycleMainService),ee(12,U.INativeHostMainService),ee(13,g.IProductService),ee(14,q.IProtocolMainService)],ie),e.CodeWindow=ie}),define(X[61],J([0,1,148,35,38,13,6,39,5,3,29,52,9,15,7,10,19,16,4,2]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,a.createDecorator)("workspacesHistoryMainService");let o=class Ve extends l.Disposable{constructor(f,m,D,_){super();this.stateService=f,this.logService=m,this.workspacesManagementMainService=D,this.lifecycleMainService=_,this._onDidChangeRecentlyOpened=this._register(new S.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!y.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const m=[],D=[];for(let _ of f)if((0,n.isRecentWorkspace)(_))!this.workspacesManagementMainService.isUntitledWorkspace(_.workspace)&&r(m,_.workspace)===-1&&m.push(_);else if((0,n.isRecentFolder)(_))s(m,_.folderUri)===-1&&m.push(_);else{const U=u(D,_.fileUri)>=0,q=_.fileUri.scheme===w.Schemas.file&&Ve.COMMON_FILES_FILTER.indexOf((0,p.basename)(_.fileUri))>=0;!U&&!q&&(D.push(_),y.isWindows&&_.fileUri.scheme===w.Schemas.file&&b.app.addRecentDocument(_.fileUri.fsPath))}this.addEntriesFromStorage(m,D),m.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(m.length=Ve.MAX_TOTAL_RECENT_ENTRIES),D.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(D.length=Ve.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:m,files:D}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const m=q=>{const Q=t(q);for(const ie of f)if(p.extUriBiasedIgnorePathCase.isEqual(ie,Q))return!1;return!0},D=this.getRecentlyOpened(),_=D.workspaces.filter(m),U=D.files.filter(m);(_.length!==D.workspaces.length||U.length!==D.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:_}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!y.isMacintosh){b.app.clearRecentDocuments();const f=this.getRecentlyOpened(),m=[];let D=0;for(let U=0;U<f.workspaces.length&&D<Ve.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const q=t(f.workspaces[U]);if(q.scheme===w.Schemas.file){const Q=(0,p.originalFSPath)(q);await(0,P.exists)(Q)&&(m.push(Q),D++)}}const _=[];for(let U=0;U<f.files.length&&D<Ve.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const q=t(f.files[U]);if(q.scheme===w.Schemas.file){const Q=(0,p.originalFSPath)(q);if(Ve.COMMON_FILES_FILTER.includes((0,p.basename)(q))||m.includes(Q))continue;await(0,P.exists)(Q)&&(_.push(Q),D++)}}_.reverse().forEach(U=>b.app.addRecentDocument(U)),m.reverse().forEach(U=>b.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var m,D;const _=[],U=[],q=(m=f==null?void 0:f.config)===null||m===void 0?void 0:m.workspace;(0,n.isWorkspaceIdentifier)(q)&&!this.workspacesManagementMainService.isUntitledWorkspace(q)?_.push({workspace:q}):(0,n.isSingleFolderWorkspaceIdentifier)(q)&&_.push({folderUri:q.uri});const Q=(D=f==null?void 0:f.config)===null||D===void 0?void 0:D.filesToOpenOrCreate;if(Q)for(let ie of Q){const ae=ie.fileUri;ae&&u(U,ae)===-1&&U.push({fileUri:ae})}return this.addEntriesFromStorage(_,U),{workspaces:_,files:U}}addEntriesFromStorage(f,m){let D=this.getRecentlyOpenedFromStorage();for(let _ of D.workspaces){let U=(0,n.isRecentFolder)(_)?s(f,_.folderUri):r(f,_.workspace);U>=0?f[U].label=f[U].label||_.label:f.push(_)}for(let _ of D.files){let U=u(m,_.fileUri);U>=0?m[U].label=m[U].label||_.label:m.push(_)}}getRecentlyOpenedFromStorage(){const f=this.stateService.getItem(Ve.recentlyOpenedStorageKey);return(0,n.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const m=(0,n.toStoreData)(f);this.stateService.setItem(Ve.recentlyOpenedStorageKey,m)}updateWindowsJumpList(){if(!!y.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let m=[];for(let U of b.app.getJumpListSettings().removedItems){const q=U.args;if(q){const Q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(q);Q&&m.push(d.URI.parse(Q[2]))}}this.removeRecentlyOpened(m);let D=!1;const _=(0,A.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const q=(0,n.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:Q,description:ie}=this.getWindowsJumpListLabel(q,U.label);let ae;return d.URI.isUri(q)?ae=`--folder-uri "${q.toString()}"`:(D=!0,ae=`--file-uri "${q.configPath.toString()}"`),{type:"task",title:Q.substr(0,255),description:ie.substr(0,255),program:process.execPath,args:ae,iconPath:"explorer.exe",iconIndex:0}}));_.length>0&&f.push({type:"custom",name:D?(0,v.localize)(2,null):(0,v.localize)(3,null),items:_})}f.push({type:"recent"});try{b.app.setJumpList(f)}catch(m){this.logService.warn("updateWindowsJumpList#setJumpList",m)}}}getWindowsJumpListLabel(f,m){if(m)return{title:(0,i.splitName)(m).name,description:m};if(d.URI.isUri(f))return{title:(0,p.basename)(f),description:c(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,v.localize)(4,null),description:""};let D=(0,p.basename)(f.configPath);return D.endsWith(n.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-n.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,D),description:c(f.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=ce([ee(0,L.IStateService),ee(1,M.ILogService),ee(2,g.IWorkspacesManagementMainService),ee(3,I.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function c(h){return h.scheme==="file"?(0,i.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,n.isRecentFolder)(h)?h.folderUri:(0,n.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function r(h,f){return h.findIndex(m=>(0,n.isRecentWorkspace)(m)&&m.workspace.id===f.id)}function s(h,f){return h.findIndex(m=>(0,n.isRecentFolder)(m)&&p.extUriBiasedIgnorePathCase.isEqual(m.folderUri,f))}function u(h,f){return h.findIndex(m=>p.extUriBiasedIgnorePathCase.isEqual(m.fileUri,f))}}),define(X[226],J([0,1,141,3,26,13,60,21,31,40,20,9,6,39,34,61,175,7,38,16,41,25]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class dt{constructor(h,f,m,D,_,U,q,Q,ie,ae,O){this.updateService=h,this.configurationService=f,this.windowsMainService=m,this.environmentMainService=D,this.telemetryService=_,this.workspacesHistoryMainService=U,this.stateService=q,this.lifecycleMainService=Q,this.logService=ie,this.nativeHostMainService=ae,this.productService=O,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new g.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new g.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||(0,M.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateService.getItem(dt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,q,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,q,Q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,q,Q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,q,Q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const m=this.productService.reportIssueUrl;m&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(m,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const U=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${U}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const _=this.productService.privacyStatementUrl;_&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(A.language){const U=D.indexOf("?")>0?"&":"?";this.openUrl(`${_}${U}lang=${A.language}`,"openPrivacyStatement")}else this.openUrl(_,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateService.setItem(dt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!A.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!A.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=b.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(A.isMacintosh?new b.Menu:null);return}const f=new b.Menu;let m;if(A.isMacintosh){const F=new b.Menu;m=new b.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),f.append(m)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new b.Menu;F.append(new b.MenuItem({label:this.mnemonicLabel(v.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(F)}const D=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(v.localize(1,null)),submenu:D});this.setMenuById(D,"File"),f.append(_);const U=new b.Menu,q=new b.MenuItem({label:this.mnemonicLabel(v.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(q);const Q=new b.Menu,ie=new b.MenuItem({label:this.mnemonicLabel(v.localize(3,null)),submenu:Q});this.setMenuById(Q,"Selection"),f.append(ie);const ae=new b.Menu,O=new b.MenuItem({label:this.mnemonicLabel(v.localize(4,null)),submenu:ae});this.setMenuById(ae,"View"),f.append(O);const $=new b.Menu,z=new b.MenuItem({label:this.mnemonicLabel(v.localize(5,null)),submenu:$});this.setMenuById($,"Go"),f.append(z);const C=new b.Menu,j=new b.MenuItem({label:this.mnemonicLabel(v.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),f.append(j);const N=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(v.localize(7,null)),submenu:N});this.setMenuById(N,"Terminal"),f.append(T);let R;if(this.shouldDrawMenu("Window")){const F=new b.Menu;R=new b.MenuItem({label:this.mnemonicLabel(v.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}R&&f.append(R);const W=new b.Menu,k=new b.MenuItem({label:this.mnemonicLabel(v.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),f.append(k),f.items&&f.items.length>0?b.Menu.setApplicationMenu(f):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(v.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),m=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const $=new b.Menu;this.setMenuById($,"Preferences"),D=new b.MenuItem({label:this.mnemonicLabel(v.localize(11,null)),submenu:$})}const _=new b.Menu,U=new b.MenuItem({label:v.localize(12,null),role:"services",submenu:_}),q=new b.MenuItem({label:v.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Q=new b.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ie=new b.MenuItem({label:v.localize(15,null),role:"unhide"}),ae=new b.MenuItem(this.likeAction("workbench.action.quit",{label:v.localize(16,null,this.productService.nameLong),click:()=>{const $=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||($==null?void 0:$.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),O=[f];O.push(...m),D&&O.push(s(),D),O.push(s(),U,s(),q,Q,ie,s(),ae),O.forEach($=>h.append($))}shouldDrawMenu(h){if(!A.isMacintosh&&(0,M.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(m=>{if((0,P.isMenubarMenuItemSeparator)(m))h.append(s());else if((0,P.isMenubarMenuItemSubmenu)(m)){const D=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.label),submenu:D});this.setMenu(D,m.submenu.items),h.append(_)}else(0,P.isMenubarMenuItemRecentAction)(m)?h.append(this.createOpenRecentMenuItem(m)):(0,P.isMenubarMenuItemAction)(m)&&(m.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[m.id]?h.append(new b.MenuItem(this.likeAction(m.id,{label:this.mnemonicLabel(m.label),click:this.fallbackMenuHandlers[m.id]}))):h.append(this.createMenuItem(m.label,m.id,!1,m.checked)):h.append(this.createMenuItem(m.label,m.id,m.enabled!==!1,!!m.checked)):h.append(this.createMenuItem(m.label,m.id,m.enabled!==!1,!!m.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(m=>h.append(m)),h.append(s()))}createOpenRecentMenuItem(h){const f=I.URI.revive(h.uri),m=h.id,D=m==="openRecentFile"?{fileUri:f}:m==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new b.MenuItem(this.likeAction(m,{label:h.label,click:(_,U,q)=>{const Q=this.isOptionClick(q);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:Q,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!A.isMacintosh&&(h.ctrlKey||h.shiftKey)||A.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,m){const D={label:this.mnemonicLabel(h),role:m,enabled:!0};return new b.MenuItem(this.withKeybinding(f,D))}setMacWindowMenu(h){const f=new b.MenuItem({label:v.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),m=new b.MenuItem({label:v.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new b.MenuItem({label:v.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),_=this.createMenuItem(v.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(v.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(v.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(v.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(v.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(v.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,m,s(),_,...U,s(),D].forEach(q=>h.append(q))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(v.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new b.MenuItem({label:v.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(v.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:v.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(v.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:v.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(v.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,m,D){const _=this.mnemonicLabel(h),U=typeof f=="function"?f:(O,$,z)=>{const C=O?O.userSettingsLabel:null;let j=f;Array.isArray(f)&&(j=this.isOptionClick(z)?f[1]:f[0]),C&&z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:j})},q=typeof m=="boolean"?m:this.windowsMainService.getWindowCount()>0,Q=typeof D=="boolean"?D:!1,ie={label:_,click:U,enabled:q};Q&&(ie.type="checkbox",ie.checked=Q);let ae;return typeof f=="string"?ae=f:Array.isArray(f)&&(ae=f[0]),A.isMacintosh&&(ae==="editor.action.clipboardCutAction"?ie.role="cut":ae==="editor.action.clipboardCopyAction"?ie.role="copy":ae==="editor.action.clipboardPasteAction"&&(ie.role="paste"),ae==="undo"?ie.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):ae==="redo"?ie.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):ae==="editor.action.selectAll"&&(ie.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(ae,ie))}makeContextAwareClickHandler(h,f){return(m,D,_)=>{const U=b.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);h(m,D||U,_)}}runActionInRenderer(h){let f=b.BrowserWindow.getFocusedWindow();if(!f){const D=this.windowsMainService.getLastActiveWindow();(D==null?void 0:D.isMinimized())&&(f=D.win)}const m=f?this.windowsMainService.getWindowById(f.id):void 0;if(m){if(this.logService.trace("menubar#runActionInRenderer",h),A.isMacintosh&&!this.environmentMainService.isBuilt&&!m.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const D={id:h.commandId,from:"menu"};m.sendWhenReady("vscode:runAction",c.CancellationToken.None,D)}else{const D={userSettingsLabel:h.userSettingsLabel};m.sendWhenReady("vscode:runKeybinding",c.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const m=typeof h=="string"?this.keybindings[h]:void 0;if(m==null?void 0:m.label){if(m.isNative!==!1)f.accelerator=m.label,f.userSettingsLabel=m.userSettingsLabel;else if(typeof f.label=="string"){const D=f.label.indexOf("[");D>=0?f.label=`${f.label.substr(0,D)} [${m.label}]`:f.label=`${f.label} [${m.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,m=!f.accelerator){m&&(f=this.withKeybinding(h,f));const D=f.click;return f.click=(_,U,q)=>{this.reportMenuActionTelemetry(h),D&&D(_,U,q)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,p.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ce([ee(0,y.IUpdateService),ee(1,i.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,L.IEnvironmentMainService),ee(4,S.ITelemetryService),ee(5,w.IWorkspacesHistoryMainService),ee(6,a.IStateService),ee(7,l.ILifecycleMainService),ee(8,E.ILogService),ee(9,o.INativeHostMainService),ee(10,n.IProductService)],r),e.Menubar=r;function s(){return new b.MenuItem({type:"separator"})}}),define(X[227],J([0,1,226,6,4,16]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,L.createDecorator)("menubarMainService");let M=class{constructor(S,y,n){this.instantiationService=S,this.lifecycleMainService=y,this.logService=n,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(v.Menubar)}async updateMenubar(S,y){this.logService.trace("menubarService#updateMenubar",S),(await this.menubar).updateMenu(y,S)}};M=ce([ee(0,L.IInstantiationService),ee(1,b.ILifecycleMainService),ee(2,A.ILogService)],M),e.MenubarMainService=M}),define(X[228],J([0,1,18,27,47,71,8,146,35,50,26,38,225,13,16,21,6,60,98,5,20,61,3,29,4,10,7,15,72,209,52,42,2,51,12,30,39,25,24,32,55]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c,t,r,s,u,h,f,m,D,_,U,q,Q,ie,ae,O,$,z,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(W){return(0,r.isWorkspaceIdentifier)(W==null?void 0:W.workspace)}function T(W){return(0,r.isSingleFolderWorkspaceIdentifier)(W==null?void 0:W.workspace)}let R=class et extends q.Disposable{constructor(k,F,B,V,G,Y,Z,re,se,x,ne,ue,ye,ge,Ee){super();this.machineId=k,this.initialUserEnv=F,this.logService=B,this.stateService=V,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=Z,this.configurationService=re,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=x,this.instantiationService=ne,this.dialogMainService=ue,this.fileService=ye,this.productService=ge,this.protocolMainService=Ee,this._onDidOpenWindow=this._register(new l.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new l.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new l.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new l.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new D.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var F,B;if(((F=k.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((B=k.config)===null||B===void 0?void 0:B.extensionTestsPath)){const V=new q.DisposableStore;if(V.add(l.Event.any(k.onDidClose,k.onDidDestroy)(()=>V.dispose())),k.config.extensionDevelopmentPath)for(const G of k.config.extensionDevelopmentPath)V.add(this.protocolMainService.addValidFileRoot(h.URI.file(G)));k.config.extensionTestsPath&&V.add(this.protocolMainService.addValidFileRoot(h.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,F){let B=this.environmentMainService.args;const V=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,Z=!Y;return this.open(Object.assign(Object.assign({},k),{cli:B,forceEmpty:G,forceNewWindow:Z,forceReuseWindow:Y,remoteAuthority:V}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const F=[],B=[],V=[],G=[],Y=[];let Z,re=0;const se=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",se);for(const ge of se)T(ge)?k.addMode?F.push(ge):B.push(ge):N(ge)?V.push(ge):ge.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ge.remoteAuthority}),Z.filesToOpenOrCreate.push(ge)):ge.backupPath?Y.push({backupFolder:(0,M.basename)(ge.backupPath),remoteAuthority:ge.remoteAuthority}):re++;k.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&k.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:x,filesOpenedInWindow:ne}=this.doOpen(k,V,B,Y,re,Z,F);if(this.logService.trace(`windowsManager#open used window count ${x.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${re})`),x.length>1)if(ne)ne.focus();else{const ge=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let Ee=!0,Ae=!0;if(ge){const ve=x.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ve.length&&(ve[0].focus(),Ee=!1,Ae=!1)}if(Ee)for(let ve=x.length-1;ve>=0;ve--){const me=x[ve];if(!(me.openedWorkspace&&G.some(be=>me.openedWorkspace&&be.workspace.id===me.openedWorkspace.id)||me.backupPath&&Y.some(be=>me.backupPath&&be.backupFolder===(0,M.basename)(me.backupPath)))){me.focus(),Ae=!1;break}}Ae&&x[x.length-1].focus()}const ue=Z&&Z.filesToDiff.length>0;if(!x.some(ge=>ge.isExtensionDevelopmentHost)&&!ue&&!k.noRecentEntry){const ge=[];for(const Ee of se)N(Ee)?ge.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):T(Ee)?ge.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&ge.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ge)}const ye=k.waitMarkerFileURI;return k.context===0&&ye&&x.length===1&&x[0]&&(async()=>{await x[0].whenClosedOrLoaded;try{await this.fileService.del(ye)}catch(ge){}})(),x}doOpen(k,F,B,V,G,Y,Z){const re=[];let se;function x(ve,me){re.push(ve),me&&(se=ve,Y=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&Z.length>0){const ve=Z[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(ve);me&&x(this.doAddFoldersToExistingWindow(me,Z.map(be=>be.workspace.uri)))}const ye=B.length+F.length+V.length;if(Y&&ye===0){const ve=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],me=this.getWindows().filter(Te=>Y&&Te.remoteAuthority===Y.remoteAuthority);let be;(ve==null?void 0:ve.fileUri)&&!ue&&((k.context===4||k.context===0||k.context===1)&&(be=(0,a.findWindowOnFile)(me,ve.fileUri,Te=>Te.configPath.scheme===u.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Te.configPath):null)),be||(be=this.doGetLastActiveWindow(me))),be?(0,r.isWorkspaceIdentifier)(be.openedWorkspace)?F.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,r.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?B.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):x(this.doOpenFilesInExistingWindow(k,be,Y),!0):x(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const ge=(0,S.distinct)(F,ve=>ve.workspace.id);if(ge.length>0){const ve=(0,S.coalesce)(ge.map(me=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(k,me,be),!!be),ne=!0}ge.forEach(me=>{if(!ve.some(_e=>_e.openedWorkspace&&_e.openedWorkspace.id===me.workspace.id)){const be=me.remoteAuthority,Te=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(k,me,ne,Te),!!Te),ne=!0}})}const Ee=(0,S.distinct)(B,ve=>f.extUriBiasedIgnorePathCase.getComparisonKey(ve.workspace.uri));if(Ee.length>0){const ve=(0,S.coalesce)(Ee.map(me=>(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(ve.length>0){const me=ve[0],be=(Y==null?void 0:Y.remoteAuthority)===me.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(k,me,be),!!be),ne=!0}Ee.forEach(me=>{if(!ve.some(_e=>(0,r.isSingleFolderWorkspaceIdentifier)(_e.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(_e.openedWorkspace.uri,me.workspace.uri))){const be=me.remoteAuthority,Te=(Y==null?void 0:Y.remoteAuthority)===be?Y:void 0;x(this.doOpenFolderOrWorkspace(k,me,ne,Te),!!Te),ne=!0}})}const Ae=(0,S.distinct)(V,ve=>ve.backupFolder);if(Ae.length>0&&Ae.forEach(ve=>{const me=ve.remoteAuthority,be=(Y==null?void 0:Y.remoteAuthority)===me?Y:void 0;x(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:be,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:ve}),!!be),ne=!0}),re.length===0||Y){Y&&!G&&G++;const ve=Y?Y.remoteAuthority:k.remoteAuthority;for(let me=0;me<G;me++)x(this.doOpenEmpty(k,ne,ve,Y),!!Y),ne=!0}return{windows:(0,S.distinct)(re),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(k,F,B){var V;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:B==null?void 0:B.filesToOpenOrCreate,filesToDiff:B==null?void 0:B.filesToDiff,filesToWait:B==null?void 0:B.filesToWait,termProgram:(V=k==null?void 0:k.userEnv)===null||V===void 0?void 0:V.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",$.CancellationToken.None,G),F}doAddFoldersToExistingWindow(k,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const B={foldersToAdd:F};return k.sendWhenReady("vscode:addFolders",$.CancellationToken.None,B),k}doOpenEmpty(k,F,B,V,G){return!F&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}doOpenFolderOrWorkspace(k,F,B,V,G){return!B&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}getPathsToOpen(k){var F;let B,V=!1,G=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(B=this.doExtractPathsFromAPI(k),V=!0):k.forceEmpty?B=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(B=this.doExtractPathsFromCLI(k.cli),B.length===0&&B.push(Object.create(null)),V=!0):(B=this.doGetPathsFromLastSession(),B.length===0&&B.push(Object.create(null)),G=!0),!k.addMode&&V){const Y=B.filter(Z=>T(Z));if(Y.length>1){const Z=Y[0].remoteAuthority;if(Y.every(re=>re.remoteAuthority===Z)){const re=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(se=>({uri:se.workspace.uri})));B.push({workspace:re,remoteAuthority:Z}),B=B.filter(se=>!T(se))}}}return k.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&B.unshift(...this.doGetPathsFromLastSession().filter(Y=>N(Y)||T(Y)||Y.backupPath)),B}doExtractPathsFromAPI(k){const F=[],B={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const V of(0,S.coalesce)(k.urisToOpen||[])){const G=this.resolveOpenable(V,B);if(G)G.label=V.label,F.push(G);else{const Y=this.resourceFromOpenable(V),Z={title:this.productService.nameLong,type:"info",buttons:[(0,i.localize)(0,null)],message:Y.scheme===u.Schemas.file?(0,i.localize)(1,null):(0,i.localize)(2,null),detail:Y.scheme===u.Schemas.file?(0,i.localize)(3,null,(0,O.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,i.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,ie.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(k){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},V=k["folder-uri"];if(V)for(const Z of V){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable({folderUri:re},B);se&&F.push(se)}}const G=k["file-uri"];if(G)for(const Z of G){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable((0,r.hasWorkspaceFileExtension)(Z)?{workspaceUri:re}:{fileUri:re},B);se&&F.push(se)}}const Y=k._;for(const Z of Y){const re=B.remoteAuthority?this.doResolvePathRemote(Z,B):this.doResolveFilePath(Z,B);re&&F.push(re)}return F}cliArgToUri(k){try{const F=h.URI.parse(k);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${k}, ${F.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];k!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of F)if(V.workspace){const G=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority});N(G)&&B.push(G)}else if(V.folderUri){const G=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});T(G)&&B.push(G)}else k!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const F=this.configurationService.getValue("window");k=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,F={}){let B=this.resourceFromOpenable(k);return B.scheme===u.Schemas.file?((0,I.isFileToOpen)(k)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(k,F)}doResolveRemoteOpenable(k,F){let B=this.resourceFromOpenable(k);const V=(0,m.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(B)),(0,I.isFileToOpen)(k)){if(F.gotoLineMode){const{path:G,line:Y,column:Z}=(0,ae.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:G}),lineNumber:Y,columnNumber:Z,remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,I.isWorkspaceToOpen)(k))return{workspace:(0,_.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(k){return(0,I.isWorkspaceToOpen)(k)?k.workspaceUri:(0,I.isFolderToOpen)(k)?k.folderUri:k.fileUri}doResolveFilePath(k,F){let B,V;F.gotoLineMode&&({path:k,line:B,column:V}=(0,ae.parseLineAndColumnAware)(k)),k=(0,ae.sanitizeFilePath)((0,M.normalize)(k),(0,C.cwd)());try{const G=(0,v.statSync)(k);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(k));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(k),lineNumber:B,columnNumber:V,exists:!0}}else if(G.isDirectory())return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(h.URI.file(k),G),exists:!0}}catch(G){const Y=h.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(k,F){const B=k.charCodeAt(0),V=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:k,line:G,column:Y}=(0,ae.parseLineAndColumnAware)(k)),B!==47&&((0,ae.isWindowsDriveLetter)(B)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=(0,ae.toSlashes)(k)),k=`/${k}`);const Z=h.URI.from({scheme:u.Schemas.vscodeRemote,authority:V,path:k});if(k.charCodeAt(k.length-1)!==47){if((0,r.hasWorkspaceFileExtension)(k))return F.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,_.getWorkspaceIdentifier)(Z),remoteAuthority:V};if(F.gotoLineMode||M.posix.basename(k).indexOf(".")!==-1)return{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:V}}return{workspace:(0,_.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:V}}shouldOpenNewWindow(k){const F=this.configurationService.getValue("window"),B=(F==null?void 0:F.openFoldersInNewWindow)||"default",V=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(B==="on"||B==="off")&&(G=B==="on");let Y=!1;return k.forceNewWindow||k.forceReuseWindow?Y=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(Y=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!k.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(Y=V==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(k,F){const B=(0,a.findWindowOnExtensionDevelopmentPath)(this.getWindows(),k);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let V=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!V.length&&!G.length&&!F.cli.extensionTestsPath){const x=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=x&&(x.workspace||x.folderUri);ne&&(h.URI.isUri(ne)?ne.scheme===u.Schemas.file?Y=[ne.fsPath]:V=[ne.toString()]:ne.configPath.scheme===u.Schemas.file?Y=[(0,f.originalFSPath)(ne.configPath)]:G=[ne.configPath.toString()])}let Z=F.remoteAuthority;for(const x of k)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=h.URI.parse(x),ue=(0,m.getRemoteAuthority)(ne);ue&&(Z?ue!==Z&&this.logService.error("more than one extension development path authority"):Z=ue)}Y=Y.filter(x=>{const ne=h.URI.file(x);return(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,m.getRemoteAuthority)(ne)===Z}),V=V.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,m.getRemoteAuthority)(ne)===Z:!1}),G=G.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,a.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,m.getRemoteAuthority)(ne)===Z:!1}),F.cli._=Y,F.cli["folder-uri"]=V,F.cli["file-uri"]=G;const re=!Y.length&&!V.length&&!G.length,se={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:re,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Z};return this.open(se)}openInBrowserWindow(k){var F,B,V,G,Y;const Z=this.configurationService.getValue("window"),re=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,partsSplashPath:(0,M.join)(this.environmentMainService.userDataPath,"rapid_render.json"),backupPath:k.emptyWindowBackupInfo?(0,M.join)(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(F=k.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(B=k.filesToOpen)===null||B===void 0?void 0:B.filesToDiff,filesToWait:(V=k.filesToOpen)===null||V===void 0?void 0:V.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:L.default,isInitialStartup:k.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(G=Z==null?void 0:Z.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}});let se;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(se=k.windowToUse||this.getLastActiveWindow(),se&&se.focus()),se){const x=se.config;!re.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(re.extensionDevelopmentPath=x.extensionDevelopmentPath,re.verbose=x.verbose,re["inspect-brk-extensions"]=x["inspect-brk-extensions"],re.debugId=x.debugId,re["inspect-extensions"]=x["inspect-extensions"],re["extensions-dir"]=x["extensions-dir"])}else{const x=this.windowsStateHandler.getNewWindowState(re);(0,b.mark)("code/willCreateCodeWindow");const ne=se=this.instantiationService.createInstance(E.CodeWindow,{state:x,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});if((0,b.mark)("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const ye=this.getLastActiveWindow();ye&&ye.addTabbedWindow(ne)}et.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,U.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,U.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,U.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne));const ue=(0,ie.assertIsDefined)((Y=ne.win)===null||Y===void 0?void 0:Y.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return re.windowId=se.id,se.isReady?this.lifecycleMainService.unload(se,4).then(x=>{x||this.doOpenInBrowserWindow(se,re,k)}):this.doOpenInBrowserWindow(se,re,k),se}doOpenInBrowserWindow(k,F,B){if(!F.extensionDevelopmentPath)if((0,r.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,r.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,F.remoteAuthority)}k.load(F)}onWindowClosed(k){const F=et.WINDOWS.indexOf(k);et.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=p.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===k))}doGetLastActiveWindow(k){const F=Math.max.apply(Math,k.map(B=>B.lastFocusTime));return k.find(B=>B.lastFocusTime===F)}sendToFocused(k,...F){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(k,$.CancellationToken.None,...F)}sendToAll(k,F,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(k,$.CancellationToken.None,F)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(k){const F=this.getWindows().filter(B=>B.id===k);return(0,S.firstOrDefault)(F)}getWindowByWebContents(k){const F=p.BrowserWindow.fromWebContents(k);if(!!F)return this.getWindowById(F.id)}};R.WINDOWS=[],R=ce([ee(2,P.ILogService),ee(3,g.IStateService),ee(4,n.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,y.IBackupMainService),ee(7,w.IConfigurationService),ee(8,c.IWorkspacesHistoryMainService),ee(9,_.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,Q.IDialogMainService),ee(12,z.IFileService),ee(13,o.IProductService),ee(14,j.IProtocolMainService)],R),e.WindowsMainService=R}),define(X[229],J([0,1,52,34,61,50]),function(H,e,v,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(S,y,n,g){this.workspacesManagementMainService=S,this.windowsMainService=y,this.workspacesHistoryMainService=n,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(S,y){const n=this.windowsMainService.getWindowById(S);return n?this.workspacesManagementMainService.enterWorkspace(n,this.windowsMainService.getWindows(),y):null}createUntitledWorkspace(S,y,n){return this.workspacesManagementMainService.createUntitledWorkspace(y,n)}deleteUntitledWorkspace(S,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(S,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}async getRecentlyOpened(S){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(S))}async addRecentlyOpened(S,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}async removeRecentlyOpened(S,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}async clearRecentlyOpened(S){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ce([ee(0,v.IWorkspacesManagementMainService),ee(1,A.IWindowsMainService),ee(2,L.IWorkspacesHistoryMainService),ee(3,b.IBackupMainService)],M),e.WorkspacesMainService=M}),define(X[230],J([0,1,27,18,13,3,228,16,69,40,199,33,120,84,219,99,4,70,67,6,38,26,21,96,200,31,95,194,195,191,20,213,2,34,7,29,229,65,223,221,220,224,173,17,202,214,227,117,8,15,129,10,222,97,207,212,50,61,201,52,68,152,41,51,12,39,204,76,24,43,28,23,89,205,189,54,30,25,164,178,42,72,74]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c,t,r,s,u,h,f,m,D,_,U,q,Q,ie,ae,O,$,z,C,j,N,T,R,W,k,F,B,V,G,Y,Z,re,se,x,ne,ue,ye,ge,Ee,Ae,ve,me,be,Te,_e,Ye,xe,Ke,ot,ze,nt,K,te,oe,le,de,pe,Ie,Oe,Ce,Ne,He){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let at=class extends q.Disposable{constructor(fe,we,Le,he,Me,Se,Pe,De,ke,We){super();this.mainProcessNodeIpcServer=fe,this.userEnv=we,this.mainInstantiationService=Le,this.logService=he,this.environmentMainService=Me,this.lifecycleMainService=Se,this.configurationService=Pe,this.stateService=De,this.fileService=ke,this.productService=We,this.registerListeners()}registerListeners(){(0,R.setUnexpectedErrorHandler)(he=>this.onUnexpectedError(he)),process.on("uncaughtException",he=>this.onUnexpectedError(he)),process.on("unhandledRejection",he=>(0,R.onUnexpectedError)(he)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,B.registerContextMenuListener)(),L.app.on("accessibility-support-changed",(he,Me)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",Me)}),L.app.on("activate",(he,Me)=>{var Se;this.logService.trace("app#activate"),Me||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),L.app.on("remote-require",(he,Me,Se)=>{this.logService.trace("app#on(remote-require): prevented"),he.preventDefault()}),L.app.on("remote-get-global",(he,Me,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),he.preventDefault()}),L.app.on("remote-get-builtin",(he,Me,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&he.preventDefault()}),L.app.on("remote-get-current-window",he=>{this.logService.trace("app#on(remote-get-current-window): prevented"),he.preventDefault()}),L.app.on("remote-get-current-web-contents",he=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),he.preventDefault())}),L.app.on("web-contents-created",(he,Me)=>{Me.on("will-attach-webview",(Pe,De,ke)=>{const We=$e=>{if(!$e)return!1;const Ue=ie.URI.parse($e);if(Ue.scheme===Z.Schemas.vscodeWebview)return Ue.path==="/index.html"||Ue.path==="/electron-browser-index.html";const Je=Ue.fsPath.toLowerCase(),Re=ie.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Je.startsWith(Re+V.sep)};delete De.preload,De.nodeIntegration=!1,!(We(ke.src)&&We(De.preloadURL))&&(delete De.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Pe.preventDefault())}),Me.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),Me.on("new-window",(Pe,De)=>{var ke;Pe.preventDefault(),(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,De)});const Se=Pe=>Pe.startsWith(`${Z.Schemas.vscodeWebview}://`);L.session.defaultSession.setPermissionRequestHandler((Pe,De,ke,We)=>Se(We.requestingUrl)?ke(De==="clipboard-read"):ke(!1)),L.session.defaultSession.setPermissionCheckHandler((Pe,De,ke,We)=>Se(We.requestingUrl)?De==="clipboard-read":!1)});let fe=[],we=null;L.app.on("open-file",(he,Me)=>{this.logService.trace("app#open-file: ",Me),he.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(Me)),we!==null&&(clearTimeout(we),we=null),we=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],we=null},100)}),L.app.on("new-window-for-tab",()=>{var he;(he=this.windowsMainService)===null||he===void 0||he.openEmptyWindow({context:4})});let Le=!1;L.ipcMain.handle("vscode:fetchShellEnv",he=>new Promise(async Me=>{var Se;const Pe=he.sender;let De=!1;function ke(je){clearTimeout($e),clearTimeout(Je),De||(De=!0,Pe.isDestroyed()||Me(je))}const We=new pe.CancellationTokenSource,$e=setTimeout(()=>{var je;Le||((je=this.windowsMainService)===null||je===void 0||je.sendToFocused("vscode:showShellEnvSlowWarning",We.token),Le=!0)},3e3),Ue=(Se=this.windowsMainService)===null||Se===void 0?void 0:Se.getWindowByWebContents(he.sender),Je=setTimeout(()=>{We.dispose(!0),Ue==null||Ue.sendWhenReady("vscode:showShellEnvTimeoutError",pe.CancellationToken.None),ke({})},1e4);let Re,Qe;(Ue==null?void 0:Ue.config)?(Re=Ue.config,Qe=Object.assign(Object.assign({},process.env),Ue.config.userEnv)):(Re=this.environmentMainService.args,Qe=process.env);const Xe=await(0,S.resolveShellEnv)(this.logService,Re,Qe);ke(Xe)})),L.ipcMain.handle("vscode:writeNlsFile",(he,Me,Se)=>{const Pe=this.validateNlsPath([Me]);if(!Pe||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Pe,nt.VSBuffer.fromString(Se))}),L.ipcMain.handle("vscode:readNlsFile",async(he,...Me)=>{const Se=this.validateNlsPath(Me);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),L.ipcMain.on("vscode:toggleDevTools",he=>he.sender.toggleDevTools()),L.ipcMain.on("vscode:openDevTools",he=>he.sender.openDevTools()),L.ipcMain.on("vscode:reloadWindow",he=>he.sender.reload())}validateNlsPath(fe){let we;for(const Le of fe)typeof Le=="string"&&(typeof we!="string"?we=Le:we=(0,V.join)(we,Le));if(!(typeof we!="string"||!(0,V.isAbsolute)(we)||!(0,de.isEqualOrParent)(we,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return ie.URI.file(we)}onUnexpectedError(fe){var we;if(fe){const Le={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};(we=this.windowsMainService)===null||we===void 0||we.sendToFocused("vscode:reportError",JSON.stringify(Le))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const ke=ie.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${ke.fsPath}`),await this.fileService.del(ke,{recursive:!0})}catch(ke){ke.fileOperationResult!==1&&this.logService.error(ke)}const fe=this.productService.win32AppUserModelId;b.isWindows&&fe&&L.app.setAppUserModelId(fe);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!L.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&L.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const we=new E.Server;this.logService.trace("Resolving machine identifier...");const Le=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Le}`);const{sharedProcess:he,sharedProcessReady:Me,sharedProcessClient:Se}=this.setupSharedProcess(Le),Pe=await this.initServices(Le,he,Me);if(this.environmentMainService.driverHandle){const ke=await(0,k.serve)(we,this.environmentMainService.driverHandle,this.environmentMainService,Pe);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(Pe.createInstance(U.ProxyAuthHandler)),Pe.invokeFunction(ke=>this.initChannels(ke,we,Se));const De=Pe.invokeFunction(ke=>this.openFirstWindow(ke,we));Pe.invokeFunction(ke=>this.afterWindowOpen(ke,he)),this.environmentMainService.args.trace&&Pe.invokeFunction(ke=>this.stopTracingEventually(ke,De))}async resolveMachineId(){let fe=this.stateService.getItem(u.machineIdKey);return(!fe||b.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,$.getMachineId)(),this.stateService.setItem(u.machineIdKey,fe)),fe}setupSharedProcess(fe){const we=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,fe,this.userEnv)),Le=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Me=await we.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(Me,"main")})(),he=(async()=>(await we.whenReady(),Le))();return{sharedProcess:we,sharedProcessReady:he,sharedProcessClient:Le}}async initServices(fe,we,Le){const he=new I.ServiceCollection;switch(process.platform){case"win32":he.set(y.IUpdateService,new a.SyncDescriptor(z.Win32UpdateService));break;case"linux":b.isLinuxSnap?he.set(y.IUpdateService,new a.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):he.set(y.IUpdateService,new a.SyncDescriptor(C.LinuxUpdateService));break;case"darwin":he.set(y.IUpdateService,new a.SyncDescriptor(j.DarwinUpdateService));break}he.set(Q.IWindowsMainService,new a.SyncDescriptor(M.WindowsMainService,[fe,this.userEnv])),he.set(be.IDialogMainService,new a.SyncDescriptor(be.DialogMainService)),he.set(w.ILaunchMainService,new a.SyncDescriptor(w.LaunchMainService)),he.set(Ae.IDiagnosticsService,g.ProxyChannel.toService((0,g.getDelayedChannel)(Le.then(Se=>Se.getChannel("diagnostics"))))),he.set(N.IIssueMainService,new a.SyncDescriptor(N.IssueMainService,[this.userEnv])),he.set(K.IEncryptionMainService,new a.SyncDescriptor(K.EncryptionMainService,[fe])),he.set(oe.IKeyboardLayoutMainService,new a.SyncDescriptor(oe.KeyboardLayoutMainService)),he.set(me.INativeHostMainService,new a.SyncDescriptor(me.NativeHostMainService,[we])),he.set(xe.IWebviewManagerService,new a.SyncDescriptor(Ye.WebviewMainService)),he.set(ae.IWorkspacesService,new a.SyncDescriptor(O.WorkspacesMainService)),he.set(Ee.IWorkspacesManagementMainService,new a.SyncDescriptor(Ee.WorkspacesManagementMainService)),he.set(ye.IWorkspacesHistoryMainService,new a.SyncDescriptor(ye.WorkspacesHistoryMainService)),he.set(F.IMenubarMainService,new a.SyncDescriptor(F.MenubarMainService)),he.set(Ie.IExtensionUrlTrustService,new a.SyncDescriptor(Oe.ExtensionUrlTrustService)),he.set(se.IStorageMainService,new a.SyncDescriptor(se.StorageMainService));const Me=new ne.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(he.set(ue.IBackupMainService,Me),he.set(r.IURLService,new a.SyncDescriptor(ge.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Se=(0,g.getDelayedChannel)(Le.then($e=>$e.getChannel("telemetryAppender"))),Pe=new f.TelemetryAppenderClient(Se),De=(0,D.resolveCommonProperties)(this.fileService,(0,v.release)(),(0,v.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appender:Pe,commonProperties:De,piiPaths:ke,sendErrorTelemetry:!0};he.set(u.ITelemetryService,new a.SyncDescriptor(m.TelemetryService,[We]))}else he.set(u.ITelemetryService,h.NullTelemetryService);return await Me.initialize(),this.mainInstantiationService.createChild(he)}initChannels(fe,we,Le){const he=g.ProxyChannel.fromService(fe.get(w.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",he);const Me=new n.UpdateChannel(fe.get(y.IUpdateService));we.registerChannel("update",Me);const Se=g.ProxyChannel.fromService(fe.get(N.IIssueMainService));we.registerChannel("issue",Se);const Pe=g.ProxyChannel.fromService(fe.get(K.IEncryptionMainService));we.registerChannel("encryption",Pe);const De=g.ProxyChannel.fromService(fe.get(He.ISignService));we.registerChannel("sign",De);const ke=g.ProxyChannel.fromService(fe.get(oe.IKeyboardLayoutMainService));we.registerChannel("keyboardLayout",ke),this.nativeHostMainService=fe.get(me.INativeHostMainService);const We=g.ProxyChannel.fromService(this.nativeHostMainService);we.registerChannel("nativeHost",We),Le.then(qe=>qe.registerChannel("nativeHost",We));const $e=g.ProxyChannel.fromService(fe.get(ae.IWorkspacesService));we.registerChannel("workspaces",$e);const Ue=g.ProxyChannel.fromService(fe.get(F.IMenubarMainService));we.registerChannel("menubar",Ue);const Je=g.ProxyChannel.fromService(fe.get(r.IURLService));we.registerChannel("url",Je);const Re=g.ProxyChannel.fromService(fe.get(Ie.IExtensionUrlTrustService));we.registerChannel("extensionUrlTrust",Re);const Qe=g.ProxyChannel.fromService(fe.get(xe.IWebviewManagerService));we.registerChannel("webview",Qe);const Xe=this._register(new x.StorageDatabaseChannel(this.logService,fe.get(se.IStorageMainService)));we.registerChannel("storage",Xe),Le.then(qe=>qe.registerChannel("storage",Xe));const je=new T.LogLevelChannel(fe.get(l.ILogService));we.registerChannel("logLevel",je),Le.then(qe=>qe.registerChannel("logLevel",je));const tt=new T.LoggerChannel(fe.get(l.ILoggerService));we.registerChannel("logger",tt),Le.then(qe=>qe.registerChannel("logger",tt));const rt=new ve.ElectronExtensionHostDebugBroadcastChannel(fe.get(Q.IWindowsMainService));we.registerChannel("extensionhostdebugservice",rt)}openFirstWindow(fe,we){const Le=this.windowsMainService=fe.get(Q.IWindowsMainService),he=fe.get(r.IURLService),Me=fe.get(me.INativeHostMainService);this.lifecycleMainService.phase=2;const Se=[],Pe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Be=>{try{return{uri:ie.URI.parse(Be),url:Be}}catch(Ze){return null}}).filter(Be=>{if(!Be||this.shouldBlockURI(Be.uri))return!1;const Ze=this.getWindowOpenableFromProtocolLink(Be.uri);return Ze?(Se.push(Ze),!1):!0}),De=this,ke=this.environmentMainService;he.registerHandler({async handleURL(Be,Ze){if(De.shouldBlockURI(Be))return!0;const vt=De.getWindowOpenableFromProtocolLink(Be);if(vt){const[ct]=Le.open({context:5,cli:Object.assign({},ke.args),urisToOpen:[vt],gotoLineMode:!0});return ct.focus(),!0}if(b.isMacintosh&&Le.getWindowCount()===0){const[ct]=Le.open({context:5,cli:Object.assign({},ke.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ne.getRemoteAuthority)(Be)});return await ct.ready(),he.open(Be,Ze)}return!1}});const We=this._register(new te.ActiveWindowManager({onDidOpenWindow:Me.onDidOpenWindow,onDidFocusWindow:Me.onDidFocusWindow,getActiveWindowId:()=>Me.getActiveWindowId(-1)})),$e=new g.StaticRouter(Be=>We.getActiveClientId().then(Ze=>Be===Ze)),Ue=new s.URLHandlerRouter($e),Je=we.getChannel("urlHandler",Ue);he.registerHandler(new s.URLHandlerChannelClient(Je)),this._register(new W.ElectronURLListener(Pe,he,Le,this.environmentMainService,this.productService));const Re=this.environmentMainService.args,Qe=global.macOpenFiles,Xe=(0,le.isLaunchedFromCli)(process.env)?0:4,je=Re._.length,tt=!!Re["folder-uri"],rt=!!Re["file-uri"],qe=Re["skip-add-to-recently-opened"]===!0,lt=Re.wait&&Re.waitMarkerFilePath?ie.URI.file(Re.waitMarkerFilePath):void 0,mt=Re.remote||void 0;return Se.length>0?Le.open({context:Xe,cli:Re,urisToOpen:Se,gotoLineMode:!0,initialStartup:!0}):Re["new-window"]&&!je&&!tt&&!rt?Le.open({context:Xe,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:qe,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:mt}):Qe.length&&!je&&!tt&&!rt?Le.open({context:1,cli:Re,urisToOpen:Qe.map(Be=>this.getWindowOpenableFromPathSync(Be)),noRecentEntry:qe,waitMarkerFileURI:lt,initialStartup:!0}):Le.open({context:Xe,cli:Re,forceNewWindow:Re["new-window"]||!je&&Re["unity-launch"],diffMode:Re.diff,noRecentEntry:qe,waitMarkerFileURI:lt,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:mt})}shouldBlockURI(fe){return!!(fe.authority===Z.Schemas.file&&b.isWindows&&L.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,_e.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,_e.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,_e.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===Z.Schemas.file)return{fileUri:ie.URI.file(fe.fsPath)};if(fe.authority===Z.Schemas.vscodeRemote){const we=fe.path.indexOf(V.posix.sep,1);if(we!==-1){const Le=fe.path.substring(1,we),he=fe.path.substring(we),Me=ie.URI.from({scheme:Z.Schemas.vscodeRemote,authority:Le,path:he,query:fe.query,fragment:fe.fragment});return(0,ae.hasWorkspaceFileExtension)(he)?{workspaceUri:Me}:/:[\d]+$/.test(he)?{fileUri:Me}:{folderUri:Me}}}}}getWindowOpenableFromPathSync(fe){try{if((0,A.statSync)(fe).isDirectory())return{folderUri:ie.URI.file(fe)};if((0,ae.hasWorkspaceFileExtension)(fe))return{workspaceUri:ie.URI.file(fe)}}catch(we){}return{fileUri:ie.URI.file(fe)}}async afterWindowOpen(fe,we){var Le;this.lifecycleMainService.phase=3;const he=fe.get(u.ITelemetryService);this._register(we.onDidError(({type:Pe,details:De})=>{let ke;typeof De=="string"?ke=De:ke=`SharedProcess: crashed (detail: ${De.reason})`,(0,R.onUnexpectedError)(new Error(ke)),he.publicLog2("sharedprocesserror",{type:Pe,reason:typeof De!="string"?De==null?void 0:De.reason:void 0,visible:we.isVisible()})}));const Me=this.productService.win32MutexName;if(b.isWindows&&Me)try{const Pe=H.__$__nodeRequire("windows-mutex").Mutex,De=new Pe(Me);(0,Ce.once)(this.lifecycleMainService.onWillShutdown)(()=>De.release())}catch(Pe){this.logService.error(Pe)}L.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(Pe,De)=>{De({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})});const Se=fe.get(y.IUpdateService);(Se instanceof z.Win32UpdateService||Se instanceof C.LinuxUpdateService||Se instanceof j.DarwinUpdateService)&&Se.initialize(),(0,S.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const De=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,ot.stripComments)(De))["enable-crash-reporter"]===void 0){const We=(Le=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Le!==void 0?Le:!0,$e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${We},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,ze.generateUuid)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,$e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,nt.VSBuffer.fromString(Ue))}}catch(Pe){this.logService.error(Pe)}}stopTracingEventually(fe,we){this.logService.info("Tracing: waiting for windows to get ready...");const Le=fe.get(be.IDialogMainService);let he=!1;const Me=async Pe=>{if(!he){he=!0;const De=await L.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Pe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):Le.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,De),buttons:[(0,Y.localize)(6,null)]},(0,Te.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}},Se=setTimeout(()=>Me(!0),3e4);Promise.all(we.map(Pe=>Pe.ready())).then(()=>{clearTimeout(Se),Me(!1)})}};at=ce([ee(2,P.IInstantiationService),ee(3,l.ILogService),ee(4,c.IEnvironmentMainService),ee(5,i.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,o.IStateService),ee(8,Ke.IFileService),ee(9,_.IProductService)],at),e.CodeApplication=at}),define(X[234],J([0,1,13,18,11,3,71,47,54,156,16,33,56,168,70,67,6,190,38,21,182,49,218,230,39,92,91,17,75,42,74,188,192,176,177,10,24,73,216,20,30,22,8,35,26,66,95,174,32,55,179,198]),function(H,e,v,A,L,b,M,i,S,y,n,g,E,p,d,w,P,I,a,l,o,c,t,r,s,u,h,f,m,D,_,U,q,Q,ie,ae,O,$,z,C,j,N,T,R,W,k,F,B,V,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Z{main(){try{this.startup()}catch(x){console.error(x.message),v.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(ve=>console.error(ve));const[x,ne,ue,ye,ge,Ee,Ae]=this.createServices();try{try{await this.initServices(ue,ye,ge)}catch(ve){throw this.handleStartupDataDirError(ue,Ae.nameLong,ve),ve}await x.invokeFunction(async ve=>{const me=ve.get(P.ILogService),be=ve.get(n.ILifecycleMainService),Te=ve.get(O.IFileService),_e=await this.claimInstance(me,ue,be,x,Ae,!0);return Ee.logger=new u.SpdLogLogger("main",(0,T.join)(ue.logsPath,"main.log"),!0,Ee.getLevel()),(0,D.once)(be.onWillShutdown)(()=>{Te.dispose(),ye.dispose()}),x.createInstance(r.CodeApplication,_e,ne).startup()})}catch(ve){x.invokeFunction(this.quit,ve)}}createServices(){const x=new d.ServiceCollection,ne=Object.assign({_serviceBrand:void 0},i.default);x.set(C.IProductService,ne);const ue=new W.EnvironmentMainService(this.resolveArgs(),ne),ye=this.patchEnvironment(ue);x.set(W.IEnvironmentMainService,ue);const ge=new h.BufferLogService,Ee=new P.MultiplexLogService([new P.ConsoleMainLogger((0,P.getLogLevel)(ue)),ge]);process.once("exit",()=>Ee.dispose()),x.set(P.ILogService,Ee);const Ae=new Q.FileService(Ee);x.set(O.IFileService,Ae);const ve=new ie.DiskFileSystemProvider(Ee);Ae.registerProvider(ae.Schemas.file,ve),x.set(P.ILoggerService,new B.LoggerService(Ee,Ae));const me=new o.ConfigurationService(ue.settingsResource,Ae);x.set(l.IConfigurationService,me),x.set(n.ILifecycleMainService,new w.SyncDescriptor(n.LifecycleMainService));const be=new I.StateService(ue,Ee);return x.set(a.IStateService,be),x.set(c.IRequestService,new w.SyncDescriptor(t.RequestMainService)),x.set(m.IThemeMainService,new w.SyncDescriptor(m.ThemeMainService)),x.set(_.ISignService,new w.SyncDescriptor(U.SignService)),x.set($.ITunnelService,new w.SyncDescriptor(z.TunnelService)),x.set(G.IProtocolMainService,new w.SyncDescriptor(Y.ProtocolMainService)),[new p.InstantiationService(x,!0),ye,ue,me,be,ge,ne]}patchEnvironment(x){const ne={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const ye=process.env[ue];typeof ye=="string"&&(ne[ue]=ye)}),Object.assign(process.env,ne),ne}initServices(x,ne,ue){const ye=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(Ae=>Ae?A.promises.mkdir(Ae,{recursive:!0}):void 0)),ge=ne.initialize(),Ee=ue.init();return Promise.all([ye,ge,Ee])}async claimInstance(x,ne,ue,ye,ge,Ee){let Ae;try{(0,M.mark)("code/willStartMainServer"),Ae=await(0,E.serve)(ne.mainIPCHandle),(0,M.mark)("code/didStartMainServer"),(0,D.once)(ue.onWillShutdown)(()=>Ae.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ne,ge.nameLong,ve),ve;let me;try{me=await(0,E.connect)(ne.mainIPCHandle,"main")}catch(_e){if(!Ee||b.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,L.localize)(0,null,ge.nameShort),(0,L.localize)(1,null),ge.nameLong),_e;try{(0,A.unlinkSync)(ne.mainIPCHandle)}catch(Ye){throw x.warn("Could not delete obsolete instance handle",Ye),Ye}return this.claimInstance(x,ne,ue,ye,ge,!1)}if(ne.extensionTestsLocationURI&&!ne.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(_e),me.dispose(),new Error(_e)}let be;!ne.args.wait&&!ne.args.status&&(be=setTimeout(()=>{this.showStartupWarningDialog((0,L.localize)(2,null,ge.nameShort),(0,L.localize)(3,null),ge.nameLong)},1e4));const Te=g.ProxyChannel.toService(me.getChannel("launch"),{disableMarshalling:!0});if(ne.args.status)return ye.invokeFunction(async()=>{const _e=new q.DiagnosticsService(F.NullTelemetryService,ge),Ye=await Te.getMainProcessInfo(),xe=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ke=await _e.getDiagnostics(Ye,xe);throw console.log(Ke),new f.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Te,x),x.trace("Sending env to running instance..."),await Te.start(ne.args,process.env),me.dispose(),be&&clearTimeout(be),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ne.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}handleStartupDataDirError(x,ne,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const ye=(0,R.coalesce)([x.userDataPath,x.extensionsPath,E.XDG_RUNTIME_DIR]).map(ge=>(0,s.getPathLabel)(ge,x));this.showStartupWarningDialog((0,L.localize)(4,null),(0,L.localize)(5,null,(0,k.toErrorMessage)(ue),ye.join(`
`)),ne)}}showStartupWarningDialog(x,ne,ue){v.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,L.localize)(6,null))],message:x,detail:ne,noLink:!0})}async windowsAllowSetForegroundWindow(x,ne){if(b.isWindows){const ue=await x.getMainProcessId();ne.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((ye,ge)=>{H(["windows-foreground-love"],ye,ge)})).allowSetForegroundWindow(ue)}catch(ye){ne.error(ye)}}}quit(x,ne){const ue=x.get(P.ILogService),ye=x.get(n.ILifecycleMainService);let ge=0;ne&&(ne.isExpected?ne.message&&ue.trace(ne.message):(ge=1,ne.stack?ue.error(ne.stack):ue.error(`Startup error: ${ne.toString()}`))),ye.kill(ge)}resolveArgs(){const x=this.validatePaths((0,S.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ne=(0,y.createWaitMarkerFile)(x.verbose);ne&&((0,S.addArg)(process.argv,"--waitMarkerFilePath",ne),x.waitMarkerFilePath=ne)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ne=this.doValidatePaths(x._,x.goto);x._=ne}return x}doValidatePaths(x,ne){const ue=(0,V.cwd)(),ye=x.map(Ae=>{let ve=String(Ae),me;ne&&(me=(0,j.parseLineAndColumnAware)(ve),ve=me.path),ve&&(ve=this.preparePath(ue,ve));const be=(0,j.sanitizeFilePath)(ve,ue),Te=(0,T.basename)(be);return Te&&!(0,j.isValidBasename)(Te)?null:ne&&me?(me.path=be,this.toPath(me)):be}),ge=b.isWindows||b.isMacintosh,Ee=(0,R.distinct)(ye,Ae=>Ae&&ge?Ae.toLowerCase():Ae||"");return(0,R.coalesce)(Ee)}preparePath(x,ne){return b.isWindows&&(ne=(0,N.rtrim)(ne,'"')),ne=(0,N.trim)((0,N.trim)(ne," "),"	"),b.isWindows&&(ne=(0,T.resolve)(x,ne),ne=(0,N.rtrim)(ne,".")),ne}toPath(x){const ne=[x.path];return typeof x.line=="number"&&ne.push(String(x.line)),typeof x.column=="number"&&ne.push(String(x.column)),ne.join(":")}}new Z().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/633562da380f9161ea2fd783e561eed508cfbbea/core/vs/code/electron-main/main.js.map
