/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Q){for(var e=[],b=0,I=Q.length;b<I;b++)e[b]=be[Q[b]];return e};define(be[42],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(I,A){if(!I)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=b}),define(be[51],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function I(n){const P=[];for(let d in n)b.call(n,d)&&P.push(n[d]);return P}e.values=I;function A(n,P){for(let d in n)if(b.call(n,d)&&P({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=A;function T(n,P){const d=Object.create(null);for(const h of n){const r=P(h);let l=d[r];l||(l=d[r]=[]),l.push(h)}return d}e.groupBy=T;function y(n){const P=Object.create(null);return n&&n.forEach((d,h)=>{P[h]=d}),P}e.fromMap=y;function C(n,P){const d=[],h=[];for(let r of n)P.has(r)||d.push(r);for(let r of P)n.has(r)||h.push(r);return{removed:d,added:h}}e.diffSets=C;function D(n,P){const d=[],h=[];for(let[r,l]of n)P.has(r)||d.push(l);for(let[r,l]of P)n.has(r)||h.push(l);return{removed:d,added:h}}e.diffMaps=D;class k{constructor(){this.map=new Map}add(P,d){let h=this.map.get(P);h||(h=new Set,this.map.set(P,h)),h.add(d)}delete(P,d){const h=this.map.get(P);!h||(h.delete(d),h.size===0&&this.map.delete(P))}forEach(P,d){const h=this.map.get(P);!h||h.forEach(d)}}e.SetMap=k}),define(be[52],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function b(D){return(k,n,P)=>{let d=null,h=null;if(typeof P.value=="function"?(d="value",h=P.value):typeof P.get=="function"&&(d="get",h=P.get),!h)throw new Error("not supported");P[d]=D(h,n)}}e.createDecorator=b;let I=0;function A(){const D=`$memoize${I++}`;let k;const n=function(d,h,r){let l=null,g=null;if(typeof r.value=="function"?(l="value",g=r.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(l="get",g=r.get),!g)throw new Error("not supported");const m=`${D}:${h}`;r[l]=function(...S){return k=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:g.apply(this,S)}),this[m]}};return n.clear=()=>{typeof k!="undefined"&&Object.getOwnPropertyNames(k).forEach(P=>{P.indexOf(D)===0&&delete k[P]})},n}e.createMemoizer=A;function T(D,k,n){return A()(D,k,n)}e.memoize=T;function y(D,k,n){return b((P,d)=>{const h=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...l){this[r]||(this[r]=n?n():void 0),clearTimeout(this[h]),k&&(this[r]=k(this[r],...l),l=[this[r]]),this[h]=setTimeout(()=>{P.apply(this,l),this[r]=n?n():void 0},D)}})}e.debounce=y;function C(D,k,n){return b((P,d)=>{const h=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,l=`$throttle$lastRun$${d}`,g=`$throttle$pending$${d}`;return function(...m){if(this[r]||(this[r]=n?n():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),k&&(this[r]=k(this[r],...m)),!this[g]){const S=this[l]+D;S<=Date.now()?(this[l]=Date.now(),P.apply(this,[this[r]]),this[r]=n?n():void 0):(this[g]=!0,this[h]=setTimeout(()=>{this[g]=!1,this[l]=Date.now(),P.apply(this,[this[r]]),this[r]=n?n():void 0},S-Date.now()))}}})}e.throttle=C}),define(be[12],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function I(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=I;function A(p){D(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=A;function T(p){D(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=T;function y(p){if(p instanceof Error){let{name:t,message:i}=p;const o=p.stacktrace||p.stack;return{$isError:!0,name:t,message:i,stack:o}}return p}e.transformErrorForSerialization=y;const C="Canceled";function D(p){return p instanceof Error&&p.name===C&&p.message===C}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function n(){const p=new Error(C);return p.name=p.message,p}e.canceled=n;function P(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=P;function d(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=d;function h(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function r(p){const t=new Error(`${p} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function l(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=l;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function f(p){const t=p;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function c(p,t=Object.create(null)){const i=new Error(p);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(be[15],_e([0,1,12]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I($,R=0){return $[$.length-(1+R)]}e.tail=I;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function T($,R,L=(M,U)=>M===U){if($===R)return!0;if(!$||!R||$.length!==R.length)return!1;for(let M=0,U=$.length;M<U;M++)if(!L($[M],R[M]))return!1;return!0}e.equals=T;function y($,R,L){let M=0,U=$.length-1;for(;M<=U;){const G=(M+U)/2|0,X=L($[G],R);if(X<0)M=G+1;else if(X>0)U=G-1;else return G}return-(M+1)}e.binarySearch=y;function C($,R){let L=0,M=$.length;if(M===0)return 0;for(;L<M;){const U=Math.floor((L+M)/2);R($[U])?M=U:L=U+1}return L}e.findFirstInSorted=C;function D($,R,L){if($=$|0,$>=R.length)throw new TypeError("invalid index");let M=R[Math.floor(R.length*Math.random())],U=[],G=[],X=[];for(let se of R){const pe=L(se,M);pe<0?U.push(se):pe>0?G.push(se):X.push(se)}return $<U.length?D($,U,L):$<U.length+X.length?X[0]:D($-(U.length+X.length),G,L)}e.quickSelect=D;function k($,R){const L=[];let M;for(const U of $.slice(0).sort(R))!M||R(M[0],U)!==0?(M=[U],L.push(M)):M.push(U);return L}e.groupBy=k;function n($,R,L){const M=[];function U(se,pe,Te){if(!(pe===0&&Te.length===0)){const xe=M[M.length-1];xe&&xe.start+xe.deleteCount===se?(xe.deleteCount+=pe,xe.toInsert.push(...Te)):M.push({start:se,deleteCount:pe,toInsert:Te})}}let G=0,X=0;for(;;){if(G===$.length){U(G,0,R.slice(X));break}if(X===R.length){U(G,$.length-G,[]);break}const se=$[G],pe=R[X],Te=L(se,pe);Te===0?(G+=1,X+=1):Te<0?(U(G,1,[]),G+=1):Te>0&&(U(G,0,[pe]),X+=1)}return M}e.sortedDiff=n;function P($,R,L){const M=n($,R,L),U=[],G=[];for(const X of M)U.push(...$.slice(X.start,X.start+X.deleteCount)),G.push(...X.toInsert);return{removed:U,added:G}}e.delta=P;function d($,R,L){if(L===0)return[];const M=$.slice(0,L).sort(R);return r($,R,M,L,$.length),M}e.top=d;function h($,R,L,M,U){return L===0?Promise.resolve([]):new Promise((G,X)=>{(async()=>{const se=$.length,pe=$.slice(0,L).sort(R);for(let Te=L,xe=Math.min(L+M,se);Te<se;Te=xe,xe=Math.min(xe+M,se)){if(Te>L&&await new Promise(Ae=>setTimeout(Ae)),U&&U.isCancellationRequested)throw(0,b.canceled)();r($,R,pe,Te,xe)}return pe})().then(G,X)})}e.topAsync=h;function r($,R,L,M,U){for(const G=L.length;M<U;M++){const X=$[M];if(R(X,L[G-1])<0){L.pop();const se=C(L,pe=>R(X,pe)<0);L.splice(se,0,X)}}}function l($){return $.filter(R=>!!R)}e.coalesce=l;function g($){let R=0;for(let L=0;L<$.length;L++)$[L]&&($[R]=$[L],R+=1);$.length=R}e.coalesceInPlace=g;function m($,R,L){$.splice(L,0,$.splice(R,1)[0])}e.move=m;function S($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=S;function f($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=f;function c($,R){if(!R)return $.filter((M,U)=>$.indexOf(M)===U);const L=Object.create(null);return $.filter(M=>{const U=R(M);return L[U]?!1:(L[U]=!0,!0)})}e.distinct=c;function p($){const R=new Set;return $.filter(L=>R.has(L)?!1:(R.add(L),!0))}e.distinctES6=p;function t($){const R=Object.create(null);return L=>{const M=$(L);return R[M]?!1:(R[M]=!0,!0)}}e.uniqueFilter=t;function i($,R){for(let L=$.length-1;L>=0;L--){const M=$[L];if(R(M))return L}return-1}e.lastIndex=i;function o($,R){return $.length>0?$[0]:R}e.firstOrDefault=o;function a($,R,L=(M,U)=>M===U){let M=0;for(let U=0,G=Math.min($.length,R.length);U<G&&L($[U],R[U]);U++)M++;return M}e.commonPrefixLength=a;function s($){return[].concat(...$)}e.flatten=s;function u($,R){let L=typeof R=="number"?$:0;typeof R=="number"?L=$:(L=0,R=$);const M=[];if(L<=R)for(let U=L;U<R;U++)M.push(U);else for(let U=L;U>R;U--)M.push(U);return M}e.range=u;function w($,R,L){return $.reduce((M,U)=>(M[R(U)]=L?L(U):U,M),Object.create(null))}e.index=w;function _($,R){return $.push(R),()=>v($,R)}e.insert=_;function v($,R){const L=$.indexOf(R);if(L>-1)return $.splice(L,1),R}e.remove=v;function E($,R,L){const M=$.slice(0,R),U=$.slice(R);return M.concat(L,U)}e.arrayInsert=E;function F($,R){let L;if(typeof R=="number"){let M=R;L=()=>{const U=Math.sin(M++)*179426549;return U-Math.floor(U)}}else L=Math.random;for(let M=$.length-1;M>0;M-=1){const U=Math.floor(L()*(M+1)),G=$[M];$[M]=$[U],$[U]=G}}e.shuffle=F;function B($,R){const L=$.indexOf(R);L>-1&&($.splice(L,1),$.unshift(R))}e.pushToStart=B;function Y($,R){const L=$.indexOf(R);L>-1&&($.splice(L,1),$.push(R))}e.pushToEnd=Y;function fe($,R){return Array.isArray($)?$.map(R):R($)}e.mapArrayOrNot=fe;function V($){return Array.isArray($)?$:[$]}e.asArray=V;function z($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=z;function ee($,R){for(const L of $){const M=R(L);if(M!==void 0)return M}}e.mapFind=ee}),define(be[53],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(I){const A=this;let T=!1,y;return function(){return T||(T=!0,y=I.apply(A,arguments)),y}}e.once=b}),define(be[54],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(be[43],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(I){function A(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}I.is=A;const T=Object.freeze([]);function y(){return T}I.empty=y;function*C(p){yield p}I.single=C;function D(p){return p||T}I.from=D;function k(p){return!p||p[Symbol.iterator]().next().done===!0}I.isEmpty=k;function n(p){return p[Symbol.iterator]().next().value}I.first=n;function P(p,t){for(const i of p)if(t(i))return!0;return!1}I.some=P;function d(p,t){for(const i of p)if(t(i))return i}I.find=d;function*h(p,t){for(const i of p)t(i)&&(yield i)}I.filter=h;function*r(p,t){for(const i of p)yield t(i)}I.map=r;function*l(...p){for(const t of p)for(const i of t)yield i}I.concat=l;function*g(p){for(const t of p)for(const i of t)yield i}I.concatNested=g;function m(p,t,i){let o=i;for(const a of p)o=t(o,a);return o}I.reduce=m;function*S(p,t,i=p.length){for(t<0&&(t+=p.length),i<0?i+=p.length:i>p.length&&(i=p.length);t<i;t++)yield p[t]}I.slice=S;function f(p,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,p];const o=p[Symbol.iterator]();for(let a=0;a<t;a++){const s=o.next();if(s.done)return[i,I.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return o}}]}I.consume=f;function c(p,t,i=(o,a)=>o===a){const o=p[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const s=o.next(),u=a.next();if(s.done!==u.done)return!1;if(s.done)return!0;if(!i(s.value,u.value))return!1}}I.equals=c})(b=e.Iterable||(e.Iterable={}))}),define(be[44],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,i=!1){let o=0,a=t.length,s="",u=0,w=16,_=0;function v(z){let ee=0,$=0;for(;ee<z;){const R=t.charCodeAt(o);if(R>=48&&R<=57)$=$*16+R-48;else if(R>=65&&R<=70)$=$*16+R-65+10;else if(R>=97&&R<=102)$=$*16+R-97+10;else break;o++,ee++}return ee<z&&($=-1),$}function E(z){o=z,s="",u=0,w=16,_=0}function F(){const z=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&k(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&k(t.charCodeAt(o)))for(o++;o<t.length&&k(t.charCodeAt(o));)o++;else return _=3,t.substring(z,o);let ee=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&k(t.charCodeAt(o))){for(o++;o<t.length&&k(t.charCodeAt(o));)o++;ee=o}else _=3;return t.substring(z,ee)}function B(){let z="",ee=o;for(;;){if(o>=a){z+=t.substring(ee,o),_=2;break}const $=t.charCodeAt(o);if($===34){z+=t.substring(ee,o),o++;break}if($===92){if(z+=t.substring(ee,o),o++,o>=a){_=2;break}switch(t.charCodeAt(o++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const L=v(4);L>=0?z+=String.fromCharCode(L):_=4;break;default:_=5}ee=o;continue}if($>=0&&$<=31)if(D($)){z+=t.substring(ee,o),_=2;break}else _=6;o++}return z}function Y(){if(s="",_=0,u=o,o>=a)return u=a,w=17;let z=t.charCodeAt(o);if(C(z)){do o++,s+=String.fromCharCode(z),z=t.charCodeAt(o);while(C(z));return w=15}if(D(z))return o++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(o)===10&&(o++,s+=`
`),w=14;switch(z){case 123:return o++,w=1;case 125:return o++,w=2;case 91:return o++,w=3;case 93:return o++,w=4;case 58:return o++,w=6;case 44:return o++,w=5;case 34:return o++,s=B(),w=10;case 47:const ee=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<a&&!D(t.charCodeAt(o));)o++;return s=t.substring(ee,o),w=12}if(t.charCodeAt(o+1)===42){o+=2;const $=a-1;let R=!1;for(;o<$;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,R=!0;break}o++}return R||(o++,_=1),s=t.substring(ee,o),w=13}return s+=String.fromCharCode(z),o++,w=16;case 45:if(s+=String.fromCharCode(z),o++,o===a||!k(t.charCodeAt(o)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),w=11;default:for(;o<a&&fe(z);)o++,z=t.charCodeAt(o);if(u!==o){switch(s=t.substring(u,o),s){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return s+=String.fromCharCode(z),o++,w=16}}function fe(z){if(C(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let z;do z=Y();while(z>=12&&z<=15);return z}return{setPosition:E,getPosition:()=>o,scan:i?V:Y,getToken:()=>w,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>o-u,getTokenError:()=>_}}e.createScanner=y;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function P(t,i){const o=[],a=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function _(v,E,F,B){u.value=v,u.offset=E,u.length=F,u.type=B,u.colonOffset=void 0,s=u}try{f(t,{onObjectBegin:(v,E)=>{if(i<=v)throw a;s=void 0,w=i>v,o.push("")},onObjectProperty:(v,E,F)=>{if(i<E||(_(v,E,F,"property"),o[o.length-1]=v,i<=E+F))throw a},onObjectEnd:(v,E)=>{if(i<=v)throw a;s=void 0,o.pop()},onArrayBegin:(v,E)=>{if(i<=v)throw a;s=void 0,o.push(0)},onArrayEnd:(v,E)=>{if(i<=v)throw a;s=void 0,o.pop()},onLiteralValue:(v,E,F)=>{if(i<E||(_(v,E,F,p(v)),i<=E+F))throw a},onSeparator:(v,E,F)=>{if(i<=E)throw a;if(v===":"&&s&&s.type==="property")s.colonOffset=E,w=!1,s=void 0;else if(v===","){const B=o[o.length-1];typeof B=="number"?o[o.length-1]=B+1:(w=!0,o[o.length-1]=""),s=void 0}}})}catch(v){if(v!==a)throw v}return{path:o,previousNode:s,isAtPropertyKey:w,matches:v=>{let E=0;for(let F=0;E<v.length&&F<o.length;F++)if(v[E]===o[F]||v[E]==="*")E++;else if(v[E]!=="**")return!1;return E===v.length}}}e.getLocation=P;function d(t,i=[],o=T.DEFAULT){let a=null,s=[];const u=[];function w(v){Array.isArray(s)?s.push(v):a!==null&&(s[a]=v)}return f(t,{onObjectBegin:()=>{const v={};w(v),u.push(s),s=v,a=null},onObjectProperty:v=>{a=v},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const v=[];w(v),u.push(s),s=v,a=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:w,onError:(v,E,F)=>{i.push({error:v,offset:E,length:F})}},o),s[0]}e.parse=d;function h(t,i=[],o=T.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){a.type==="property"&&(a.length=v-a.offset,a=a.parent)}function u(v){return a.children.push(v),v}f(t,{onObjectBegin:v=>{a=u({type:"object",offset:v,length:-1,parent:a,children:[]})},onObjectProperty:(v,E,F)=>{a=u({type:"property",offset:E,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:v,offset:E,length:F,parent:a})},onObjectEnd:(v,E)=>{a.length=v+E-a.offset,a=a.parent,s(v+E)},onArrayBegin:(v,E)=>{a=u({type:"array",offset:v,length:-1,parent:a,children:[]})},onArrayEnd:(v,E)=>{a.length=v+E-a.offset,a=a.parent,s(v+E)},onLiteralValue:(v,E,F)=>{u({type:p(v),offset:E,length:F,parent:a,value:v}),s(E+F)},onSeparator:(v,E,F)=>{a.type==="property"&&(v===":"?a.colonOffset=E:v===","&&s(E))},onError:(v,E,F)=>{i.push({error:v,offset:E,length:F})}},o);const _=a.children[0];return _&&delete _.parent,_}e.parseTree=h;function r(t,i){if(!!t){let o=t;for(let a of i)if(typeof a=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const u of o.children)if(Array.isArray(u.children)&&u.children[0].value===a){o=u.children[1],s=!0;break}if(!s)return}else{const s=a;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}}e.findNodeAtLocation=r;function l(t){if(!t.parent||!t.parent.children)return[];const i=l(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;i.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&i.push(o)}return i}e.getNodePath=l;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const i=Object.create(null);for(let o of t.children){const a=o.children[1];a&&(i[o.children[0].value]=g(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function m(t,i,o=!1){return i>=t.offset&&i<t.offset+t.length||o&&i===t.offset+t.length}e.contains=m;function S(t,i,o=!1){if(m(t,i,o)){const a=t.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=i;s++){const u=S(a[s],i,o);if(u)return u}return t}}e.findNodeAtOffset=S;function f(t,i,o=T.DEFAULT){const a=y(t,!1);function s(pe){return pe?()=>pe(a.getTokenOffset(),a.getTokenLength()):()=>!0}function u(pe){return pe?Te=>pe(Te,a.getTokenOffset(),a.getTokenLength()):()=>!0}const w=s(i.onObjectBegin),_=u(i.onObjectProperty),v=s(i.onObjectEnd),E=s(i.onArrayBegin),F=s(i.onArrayEnd),B=u(i.onLiteralValue),Y=u(i.onSeparator),fe=s(i.onComment),V=u(i.onError),z=o&&o.disallowComments,ee=o&&o.allowTrailingComma;function $(){for(;;){const pe=a.scan();switch(a.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:z||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(pe){case 12:case 13:z?R(10):fe();break;case 16:R(1);break;case 15:case 14:break;default:return pe}}}function R(pe,Te=[],xe=[]){if(V(pe),Te.length+xe.length>0){let Ae=a.getToken();for(;Ae!==17;){if(Te.indexOf(Ae)!==-1){$();break}else if(xe.indexOf(Ae)!==-1)break;Ae=$()}}}function L(pe){const Te=a.getTokenValue();return pe?B(Te):_(Te),$(),!0}function M(){switch(a.getToken()){case 11:let pe=0;try{pe=JSON.parse(a.getTokenValue()),typeof pe!="number"&&(R(2),pe=0)}catch(Te){R(2)}B(pe);break;case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return $(),!0}function U(){return a.getToken()!==10?(R(3,[],[2,5]),!1):(L(!1),a.getToken()===6?(Y(":"),$(),se()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function G(){w(),$();let pe=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(pe||R(4,[],[]),Y(","),$(),a.getToken()===2&&ee)break}else pe&&R(6,[],[]);U()||R(4,[],[2,5]),pe=!0}return v(),a.getToken()!==2?R(7,[2],[]):$(),!0}function X(){E(),$();let pe=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(pe||R(4,[],[]),Y(","),$(),a.getToken()===4&&ee)break}else pe&&R(6,[],[]);se()||R(4,[],[4,5]),pe=!0}return F(),a.getToken()!==4?R(8,[4],[]):$(),!0}function se(){switch(a.getToken()){case 3:return X();case 1:return G();case 10:return L(!0);default:return M()}}return $(),a.getToken()===17?o.allowEmptyContent?!0:(R(4,[],[]),!1):se()?(a.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=f;function c(t,i){let o=y(t),a=[],s,u=0,w;do switch(w=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:u!==w&&a.push(t.substring(u,w)),i!==void 0&&a.push(o.getTokenValue().replace(/[^\r\n]/g,i)),u=o.getPosition();break}while(s!==17);return a.join("")}e.stripComments=c;function p(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(be[106],_e([0,1,44]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,k,n){let P,d,h,r,l;if(k){for(r=k.offset,l=r+k.length,h=r;h>0&&!C(D,h-1);)h--;let u=l;for(;u<D.length&&!C(D,u);)u++;d=D.substring(h,u),P=T(d,n)}else d=D,P=0,h=0,r=0,l=D.length;const g=y(n,D);let m=!1,S=0,f;n.insertSpaces?f=A(" ",n.tabSize||4):f="	";const c=(0,b.createScanner)(d,!1);let p=!1;function t(){return g+A(f,P+S)}function i(){let u=c.scan();for(m=!1;u===15||u===14;)m=m||u===14,u=c.scan();return p=u===16||c.getTokenError()!==0,u}const o=[];function a(u,w,_){!p&&w<l&&_>r&&D.substring(w,_)!==u&&o.push({offset:w,length:_-w,content:u})}let s=i();if(s!==17){const u=c.getTokenOffset()+h,w=A(f,P);a(w,h,u)}for(;s!==17;){let u=c.getTokenOffset()+c.getTokenLength()+h,w=i(),_="";for(;!m&&(w===12||w===13);){const E=c.getTokenOffset()+h;a(" ",u,E),u=c.getTokenOffset()+c.getTokenLength()+h,_=w===12?t():"",w=i()}if(w===2)s!==1&&(S--,_=t());else if(w===4)s!==3&&(S--,_=t());else{switch(s){case 3:case 1:S++,_=t();break;case 5:case 12:_=t();break;case 13:m?_=t():_=" ";break;case 6:_=" ";break;case 10:if(w===6){_="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?_=" ":w!==5&&w!==17&&(p=!0);break;case 16:p=!0;break}m&&(w===12||w===13)&&(_=t())}const v=c.getTokenOffset()+h;a(_,u,v),s=w}return o}e.format=I;function A(D,k){let n="";for(let P=0;P<k;P++)n+=D;return n}function T(D,k){let n=0,P=0;const d=k.tabSize||4;for(;n<D.length;){const h=D.charAt(n);if(h===" ")P++;else if(h==="	")P+=d;else break;n++}return Math.floor(P/d)}function y(D,k){for(let n=0;n<k.length;n++){const P=k.charAt(n);if(P==="\r")return n+1<k.length&&k.charAt(n+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function C(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=C}),define(be[107],_e([0,1,44,106]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(k,n,P){return T(k,n,void 0,P)}e.removeProperty=A;function T(k,n,P,d,h){const r=n.slice(),l=[],g=(0,b.parseTree)(k,l);let m,S;for(;r.length>0&&(S=r.pop(),m=(0,b.findNodeAtLocation)(g,r),m===void 0&&P!==void 0);)typeof S=="string"?P={[S]:P}:P=[P];if(m)if(m.type==="object"&&typeof S=="string"&&Array.isArray(m.children)){const f=(0,b.findNodeAtLocation)(m,[S]);if(f!==void 0)if(P===void 0){if(!f.parent)throw new Error("Malformed AST");const c=m.children.indexOf(f.parent);let p,t=f.parent.offset+f.parent.length;if(c>0){const i=m.children[c-1];p=i.offset+i.length}else p=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return y(k,{offset:p,length:t-p,content:""},d)}else return y(k,{offset:f.offset,length:f.length,content:JSON.stringify(P)},d);else{if(P===void 0)return[];const c=`${JSON.stringify(S)}: ${JSON.stringify(P)}`,p=h?h(m.children.map(i=>i.children[0].value)):m.children.length;let t;if(p>0){const i=m.children[p-1];t={offset:i.offset+i.length,length:0,content:","+c}}else m.children.length===0?t={offset:m.offset+1,length:0,content:c}:t={offset:m.offset+1,length:0,content:c+","};return y(k,t,d)}}else if(m.type==="array"&&typeof S=="number"&&Array.isArray(m.children))if(P!==void 0){const f=`${JSON.stringify(P)}`;let c;if(m.children.length===0||S===0)c={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const p=S===-1||S>m.children.length?m.children.length:S,t=m.children[p-1];c={offset:t.offset+t.length,length:0,content:","+f}}return y(k,c,d)}else{const f=S,c=m.children[f];let p;if(m.children.length===1)p={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const t=m.children[f-1],i=t.offset+t.length,o=m.offset+m.length;p={offset:i,length:o-2-i,content:""}}else p={offset:c.offset,length:m.children[f+1].offset-c.offset,content:""};return y(k,p,d)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${m.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return y(k,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(P)},d)}}e.setProperty=T;function y(k,n,P){let d=C(k,n),h=n.offset,r=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;h>0&&!(0,I.isEOL)(d,h-1);)h--;for(;r<d.length&&!(0,I.isEOL)(d,r);)r++}const l=(0,I.format)(d,{offset:h,length:r-h},P);for(let m=l.length-1;m>=0;m--){const S=l[m];d=C(d,S),h=Math.min(h,S.offset),r=Math.max(r,S.offset+S.length),r+=S.content.length-S.length}const g=k.length-(d.length-r)-h;return[{offset:h,length:g,content:d.substring(h,r)}]}e.withFormatting=y;function C(k,n){return k.substring(0,n.offset)+n.content+k.substring(n.offset+n.length)}e.applyEdit=C;function D(k,n){let P=n.slice(0).sort((h,r)=>{const l=h.offset-r.offset;return l===0?h.length-r.length:l}),d=k.length;for(let h=P.length-1;h>=0;h--){let r=P[h];if(r.offset+r.length<=d)k=C(k,r);else throw new Error("Overlapping edit");d=r.offset}return k}e.applyEdits=D}),define(be[108],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new b(()=>A(this.getValue()))}}e.Lazy=b}),define(be[6],_e([0,1,53,43]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function y(f){T=f}if(e.setDisposableTracker=y,A){const f="__is_disposable_tracked__";T=new class{trackDisposable(c){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[f]||console.log(p)},3e3)}markTracked(c){if(c&&c!==l.None)try{c[f]=!0}catch(p){}}}}function C(f){!T||T.markTracked(f)}function D(f){return T&&T.trackDisposable(f),f}e.trackDisposable=D;class k extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=k;function n(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=n;function P(f){if(I.Iterable.is(f)){let c=[];for(const p of f)if(p){C(p);try{p.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new k(c);return Array.isArray(f)?[]:f}else if(f)return C(f),f.dispose(),f}e.dispose=P;function d(...f){return f.forEach(C),h(()=>P(f))}e.combinedDisposable=d;function h(f){const c=D({dispose:()=>{C(c),f()}});return c}e.toDisposable=h;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return C(c),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this._store=new r,D(this)}dispose(){C(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=l,l.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var p;this._isDisposed||c===this._value||((p=this._value)===null||p===void 0||p.dispose(),c&&C(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,C(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=g;class m{constructor(){this.references=new Map}acquire(c,...p){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...p)},this.references.set(c,t));const{object:i}=t,o=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:o}}}e.ReferenceCollection=m;class S{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=S}),define(be[45],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(T){this.element=T,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class I{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const C=new b(T);if(this._first===b.Undefined)this._first=C,this._last=C;else if(y){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==b.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==b.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==b.Undefined&&T.next!==b.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===b.Undefined&&T.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):T.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):T.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==b.Undefined;)yield T.element,T=T.next}}e.LinkedList=I}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(W,ie){for(var ce=0;ce<ie.length;ce++){var j=ie[ce];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(W,j.key,j)}}function e(W,ie,ce){return ie&&Q(W.prototype,ie),ce&&Q(W,ce),W}function b(W,ie){if(!!W){if(typeof W=="string")return I(W,ie);var ce=Object.prototype.toString.call(W).slice(8,-1);if(ce==="Object"&&W.constructor&&(ce=W.constructor.name),ce==="Map"||ce==="Set")return Array.from(W);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return I(W,ie)}}function I(W,ie){(ie==null||ie>W.length)&&(ie=W.length);for(var ce=0,j=new Array(ie);ce<ie;ce++)j[ce]=W[ce];return j}function A(W,ie){var ce;if(typeof Symbol=="undefined"||W[Symbol.iterator]==null){if(Array.isArray(W)||(ce=b(W))||ie&&W&&typeof W.length=="number"){ce&&(W=ce);var j=0;return function(){return j>=W.length?{done:!0}:{done:!1,value:W[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=W[Symbol.iterator](),ce.next.bind(ce)}function T(W){var ie={exports:{}};return W(ie,ie.exports),ie.exports}var y=T(function(W){function ie(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(j){W.exports.defaults=j}W.exports={defaults:ie(),getDefaults:ie,changeDefaults:ce}}),C=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ie){return P[ie]};function h(W,ie){if(ie){if(C.test(W))return W.replace(D,d)}else if(k.test(W))return W.replace(n,d);return W}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(W){return W.replace(r,function(ie,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var g=/(^|[^\[])\^/g;function m(W,ie){W=W.source||W,ie=ie||"";var ce={replace:function(Z,ae){return ae=ae.source||ae,ae=ae.replace(g,"$1"),W=W.replace(Z,ae),ce},getRegex:function(){return new RegExp(W,ie)}};return ce}var S=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(W,ie,ce){if(W){var j;try{j=decodeURIComponent(l(ce)).replace(S,"").toLowerCase()}catch(Z){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ie&&!f.test(ce)&&(ce=a(ie,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(Z){return null}return ce}var p={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(W,ie){p[" "+W]||(t.test(W)?p[" "+W]=W+"/":p[" "+W]=_(W,"/",!0)),W=p[" "+W];var ce=W.indexOf(":")===-1;return ie.substring(0,2)==="//"?ce?ie:W.replace(i,"$1")+ie:ie.charAt(0)==="/"?ce?ie:W.replace(o,"$1")+ie:W+ie}var s={exec:function(){}};function u(W){for(var ie=1,ce,j;ie<arguments.length;ie++){ce=arguments[ie];for(j in ce)Object.prototype.hasOwnProperty.call(ce,j)&&(W[j]=ce[j])}return W}function w(W,ie){var ce=W.replace(/\|/g,function(ae,he,ye){for(var ze=!1,Be=he;--Be>=0&&ye[Be]==="\\";)ze=!ze;return ze?"|":" |"}),j=ce.split(/ \|/),Z=0;if(j.length>ie)j.splice(ie);else for(;j.length<ie;)j.push("");for(;Z<j.length;Z++)j[Z]=j[Z].trim().replace(/\\\|/g,"|");return j}function _(W,ie,ce){var j=W.length;if(j===0)return"";for(var Z=0;Z<j;){var ae=W.charAt(j-Z-1);if(ae===ie&&!ce)Z++;else if(ae!==ie&&ce)Z++;else break}return W.substr(0,j-Z)}function v(W,ie){if(W.indexOf(ie[1])===-1)return-1;for(var ce=W.length,j=0,Z=0;Z<ce;Z++)if(W[Z]==="\\")Z++;else if(W[Z]===ie[0])j++;else if(W[Z]===ie[1]&&(j--,j<0))return Z;return-1}function E(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(W,ie){if(ie<1)return"";for(var ce="";ie>1;)ie&1&&(ce+=W),ie>>=1,W+=W;return ce+W}var B={escape:h,unescape:l,edit:m,cleanUrl:c,resolveUrl:a,noopTest:s,merge:u,splitCells:w,rtrim:_,findClosingBracket:v,checkSanitizeDeprecation:E,repeatString:F},Y=y.defaults,fe=B.rtrim,V=B.splitCells,z=B.escape,ee=B.findClosingBracket;function $(W,ie,ce){var j=ie.href,Z=ie.title?z(ie.title):null,ae=W[1].replace(/\\([\[\]])/g,"$1");return W[0].charAt(0)!=="!"?{type:"link",raw:ce,href:j,title:Z,text:ae}:{type:"image",raw:ce,href:j,title:Z,text:z(ae)}}function R(W,ie){var ce=W.match(/^(\s+)(?:```)/);if(ce===null)return ie;var j=ce[1];return ie.split(`
`).map(function(Z){var ae=Z.match(/^\s+/);if(ae===null)return Z;var he=ae[0];return he.length>=j.length?Z.slice(j.length):Z}).join(`
`)}var L=function(){function W(ce){this.options=ce||Y}var ie=W.prototype;return ie.space=function(j){var Z=this.rules.block.newline.exec(j);if(Z)return Z[0].length>1?{type:"space",raw:Z[0]}:{raw:`
`}},ie.code=function(j){var Z=this.rules.block.code.exec(j);if(Z){var ae=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:fe(ae,`
`)}}},ie.fences=function(j){var Z=this.rules.block.fences.exec(j);if(Z){var ae=Z[0],he=R(ae,Z[3]||"");return{type:"code",raw:ae,lang:Z[2]?Z[2].trim():Z[2],text:he}}},ie.heading=function(j){var Z=this.rules.block.heading.exec(j);if(Z){var ae=Z[2].trim();if(/#$/.test(ae)){var he=fe(ae,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ae=he.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:ae}}},ie.nptable=function(j){var Z=this.rules.block.nptable.exec(j);if(Z){var ae={type:"table",header:V(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[],raw:Z[0]};if(ae.header.length===ae.align.length){var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=V(ae.cells[ye],ae.header.length);return ae}}},ie.hr=function(j){var Z=this.rules.block.hr.exec(j);if(Z)return{type:"hr",raw:Z[0]}},ie.blockquote=function(j){var Z=this.rules.block.blockquote.exec(j);if(Z){var ae=Z[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Z[0],text:ae}}},ie.list=function(j){var Z=this.rules.block.list.exec(j);if(Z){var ae=Z[0],he=Z[2],ye=he.length>1,ze={type:"list",raw:ae,ordered:ye,start:ye?+he.slice(0,-1):"",loose:!1,items:[]},Be=Z[0].match(this.rules.block.item),Ne=!1,Ge,nt,dt,it,Je,mt,wt,we,de=Be.length;dt=this.rules.block.listItemStart.exec(Be[0]);for(var oe=0;oe<de;oe++){if(Ge=Be[oe],ae=Ge,oe!==de-1){if(it=this.rules.block.listItemStart.exec(Be[oe+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){Be.splice(oe,2,Be[oe]+`
`+Be[oe+1]),oe--,de--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==he[he.length-1]:ye===(it[2].length===1))&&(Je=Be.slice(oe+1).join(`
`),ze.raw=ze.raw.substring(0,ze.raw.length-Je.length),oe=de-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=Ne||/\n\n(?!\s*$)/.test(Ge),oe!==de-1&&(Ne=Ge.charAt(Ge.length-1)===`
`,mt||(mt=Ne)),mt&&(ze.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test(Ge),we=void 0,wt&&(we=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:ae,task:wt,checked:we,loose:mt,text:Ge})}return ze}},ie.html=function(j){var Z=this.rules.block.html.exec(j);if(Z)return{type:this.options.sanitize?"paragraph":"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):z(Z[0]):Z[0]}},ie.def=function(j){var Z=this.rules.block.def.exec(j);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var ae=Z[1].toLowerCase().replace(/\s+/g," ");return{tag:ae,raw:Z[0],href:Z[2],title:Z[3]}}},ie.table=function(j){var Z=this.rules.block.table.exec(j);if(Z){var ae={type:"table",header:V(Z[1].replace(/^ *| *\| *$/g,"")),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Z[3]?Z[3].replace(/\n$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=Z[0];var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=V(ae.cells[ye].replace(/^ *\| *| *\| *$/g,""),ae.header.length);return ae}}},ie.lheading=function(j){var Z=this.rules.block.lheading.exec(j);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1]}},ie.paragraph=function(j){var Z=this.rules.block.paragraph.exec(j);if(Z)return{type:"paragraph",raw:Z[0],text:Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1]}},ie.text=function(j){var Z=this.rules.block.text.exec(j);if(Z)return{type:"text",raw:Z[0],text:Z[0]}},ie.escape=function(j){var Z=this.rules.inline.escape.exec(j);if(Z)return{type:"escape",raw:Z[0],text:z(Z[1])}},ie.tag=function(j,Z,ae){var he=this.rules.inline.tag.exec(j);if(he)return!Z&&/^<a /i.test(he[0])?Z=!0:Z&&/^<\/a>/i.test(he[0])&&(Z=!1),!ae&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?ae=!0:ae&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(ae=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:Z,inRawBlock:ae,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]}},ie.link=function(j){var Z=this.rules.inline.link.exec(j);if(Z){var ae=Z[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var he=fe(ae.slice(0,-1),"\\");if((ae.length-he.length)%2==0)return}else{var ye=ee(Z[2],"()");if(ye>-1){var ze=Z[0].indexOf("!")===0?5:4,Be=ze+Z[1].length+ye;Z[2]=Z[2].substring(0,ye),Z[0]=Z[0].substring(0,Be).trim(),Z[3]=""}}var Ne=Z[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);nt&&(Ne=nt[1],Ge=nt[3])}else Ge=Z[3]?Z[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(ae)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),$(Z,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},Z[0])}},ie.reflink=function(j,Z){var ae;if((ae=this.rules.inline.reflink.exec(j))||(ae=this.rules.inline.nolink.exec(j))){var he=(ae[2]||ae[1]).replace(/\s+/g," ");if(he=Z[he.toLowerCase()],!he||!he.href){var ye=ae[0].charAt(0);return{type:"text",raw:ye,text:ye}}return $(ae,he,ae[0])}},ie.emStrong=function(j,Z,ae){ae===void 0&&(ae="");var he=this.rules.inline.emStrong.lDelim.exec(j);if(!!he&&!(he[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=he[1]||he[2]||"";if(!ye||ye&&(ae===""||this.rules.inline.punctuation.exec(ae))){var ze=he[0].length-1,Be,Ne,Ge=ze,nt=0,dt=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,Z=Z.slice(-1*j.length+ze);(he=dt.exec(Z))!=null;)if(Be=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Be){if(Ne=Be.length,he[3]||he[4]){Ge+=Ne;continue}else if((he[5]||he[6])&&ze%3&&!((ze+Ne)%3)){nt+=Ne;continue}if(Ge-=Ne,!(Ge>0)){if(Ge+nt-Ne<=0&&!Z.slice(dt.lastIndex).match(dt)&&(Ne=Math.min(Ne,Ne+Ge+nt)),Math.min(ze,Ne)%2)return{type:"em",raw:j.slice(0,ze+he.index+Ne+1),text:j.slice(1,ze+he.index+Ne)};if(Math.min(ze,Ne)%2==0)return{type:"strong",raw:j.slice(0,ze+he.index+Ne+1),text:j.slice(2,ze+he.index+Ne-1)}}}}}},ie.codespan=function(j){var Z=this.rules.inline.code.exec(j);if(Z){var ae=Z[2].replace(/\n/g," "),he=/[^ ]/.test(ae),ye=/^ /.test(ae)&&/ $/.test(ae);return he&&ye&&(ae=ae.substring(1,ae.length-1)),ae=z(ae,!0),{type:"codespan",raw:Z[0],text:ae}}},ie.br=function(j){var Z=this.rules.inline.br.exec(j);if(Z)return{type:"br",raw:Z[0]}},ie.del=function(j){var Z=this.rules.inline.del.exec(j);if(Z)return{type:"del",raw:Z[0],text:Z[2]}},ie.autolink=function(j,Z){var ae=this.rules.inline.autolink.exec(j);if(ae){var he,ye;return ae[2]==="@"?(he=z(this.options.mangle?Z(ae[1]):ae[1]),ye="mailto:"+he):(he=z(ae[1]),ye=he),{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.url=function(j,Z){var ae;if(ae=this.rules.inline.url.exec(j)){var he,ye;if(ae[2]==="@")he=z(this.options.mangle?Z(ae[0]):ae[0]),ye="mailto:"+he;else{var ze;do ze=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(ze!==ae[0]);he=z(ae[0]),ae[1]==="www."?ye="http://"+he:ye=he}return{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.inlineText=function(j,Z,ae){var he=this.rules.inline.text.exec(j);if(he){var ye;return Z?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]:ye=z(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:ye}}},W}(),M=B.noopTest,U=B.edit,G=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=U(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,X.item=U(X.item,"gm").replace(/bull/g,X.bullet).getRegex(),X.listItemStart=U(/^( *)(bull)/).replace("bull",X.bullet).getRegex(),X.list=U(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=U(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=U(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.blockquote=U(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=G({},X),X.gfm=G({},X.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.nptable=U(X.gfm.nptable).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.gfm.table=U(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.pedantic=G({},X.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:U(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var se={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};se._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",se.punctuation=U(se.punctuation).replace(/punctuation/g,se._punctuation).getRegex(),se.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,se.escapedEmSt=/\\\*|\\_/g,se._comment=U(X._comment).replace("(?:-->|$)","-->").getRegex(),se.emStrong.lDelim=U(se.emStrong.lDelim).replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimAst=U(se.emStrong.rDelimAst,"g").replace(/punct/g,se._punctuation).getRegex(),se.emStrong.rDelimUnd=U(se.emStrong.rDelimUnd,"g").replace(/punct/g,se._punctuation).getRegex(),se._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,se._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,se._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,se.autolink=U(se.autolink).replace("scheme",se._scheme).replace("email",se._email).getRegex(),se._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,se.tag=U(se.tag).replace("comment",se._comment).replace("attribute",se._attribute).getRegex(),se._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,se._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,se._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,se.link=U(se.link).replace("label",se._label).replace("href",se._href).replace("title",se._title).getRegex(),se.reflink=U(se.reflink).replace("label",se._label).getRegex(),se.reflinkSearch=U(se.reflinkSearch,"g").replace("reflink",se.reflink).replace("nolink",se.nolink).getRegex(),se.normal=G({},se),se.pedantic=G({},se.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",se._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",se._label).getRegex()}),se.gfm=G({},se.normal,{escape:U(se.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),se.gfm.url=U(se.gfm.url,"i").replace("email",se.gfm._extended_email).getRegex(),se.breaks=G({},se.gfm,{br:U(se.br).replace("{2,}","*").getRegex(),text:U(se.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:X,inline:se},Te=y.defaults,xe=pe.block,Ae=pe.inline,We=B.repeatString;function x(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(W){var ie="",ce,j,Z=W.length;for(ce=0;ce<Z;ce++)j=W.charCodeAt(ce),Math.random()>.5&&(j="x"+j.toString(16)),ie+="&#"+j+";";return ie}var ne=function(){function W(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Te,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:xe.normal,inline:Ae.normal};this.options.pedantic?(j.block=xe.pedantic,j.inline=Ae.pedantic):this.options.gfm&&(j.block=xe.gfm,this.options.breaks?j.inline=Ae.breaks:j.inline=Ae.gfm),this.tokenizer.rules=j}W.lex=function(j,Z){var ae=new W(Z);return ae.lex(j)},W.lexInline=function(j,Z){var ae=new W(Z);return ae.inlineTokens(j)};var ie=W.prototype;return ie.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ie.blockTokens=function(j,Z,ae){Z===void 0&&(Z=[]),ae===void 0&&(ae=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var he,ye,ze,Be;j;){if(he=this.tokenizer.space(j)){j=j.substring(he.raw.length),he.type&&Z.push(he);continue}if(he=this.tokenizer.code(j)){j=j.substring(he.raw.length),Be=Z[Z.length-1],Be&&Be.type==="paragraph"?(Be.raw+=`
`+he.raw,Be.text+=`
`+he.text):Z.push(he);continue}if(he=this.tokenizer.fences(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.heading(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.nptable(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.hr(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.blockquote(j)){j=j.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],ae),Z.push(he);continue}if(he=this.tokenizer.list(j)){for(j=j.substring(he.raw.length),ze=he.items.length,ye=0;ye<ze;ye++)he.items[ye].tokens=this.blockTokens(he.items[ye].text,[],!1);Z.push(he);continue}if(he=this.tokenizer.html(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(ae&&(he=this.tokenizer.def(j))){j=j.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.lheading(j)){j=j.substring(he.raw.length),Z.push(he);continue}if(ae&&(he=this.tokenizer.paragraph(j))){j=j.substring(he.raw.length),Z.push(he);continue}if(he=this.tokenizer.text(j)){j=j.substring(he.raw.length),Be=Z[Z.length-1],Be&&Be.type==="text"?(Be.raw+=`
`+he.raw,Be.text+=`
`+he.text):Z.push(he);continue}if(j){var Ne="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return Z},ie.inline=function(j){var Z,ae,he,ye,ze,Be,Ne=j.length;for(Z=0;Z<Ne;Z++)switch(Be=j[Z],Be.type){case"paragraph":case"text":case"heading":{Be.tokens=[],this.inlineTokens(Be.text,Be.tokens);break}case"table":{for(Be.tokens={header:[],cells:[]},ye=Be.header.length,ae=0;ae<ye;ae++)Be.tokens.header[ae]=[],this.inlineTokens(Be.header[ae],Be.tokens.header[ae]);for(ye=Be.cells.length,ae=0;ae<ye;ae++)for(ze=Be.cells[ae],Be.tokens.cells[ae]=[],he=0;he<ze.length;he++)Be.tokens.cells[ae][he]=[],this.inlineTokens(ze[he],Be.tokens.cells[ae][he]);break}case"blockquote":{this.inline(Be.tokens);break}case"list":{for(ye=Be.items.length,ae=0;ae<ye;ae++)this.inline(Be.items[ae].tokens);break}}return j},ie.inlineTokens=function(j,Z,ae,he){Z===void 0&&(Z=[]),ae===void 0&&(ae=!1),he===void 0&&(he=!1);var ye,ze,Be=j,Ne,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Be))!=null;)dt.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Be=Be.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Be))!=null;)Be=Be.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Be))!=null;)Be=Be.slice(0,Ne.index)+"++"+Be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(j)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.tag(j,ae,he)){j=j.substring(ye.raw.length),ae=ye.inLink,he=ye.inRawBlock;var it=Z[Z.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):Z.push(ye);continue}if(ye=this.tokenizer.link(j)){j=j.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,he)),Z.push(ye);continue}if(ye=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(ye.raw.length);var Je=Z[Z.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,he),Z.push(ye)):Je&&ye.type==="text"&&Je.type==="text"?(Je.raw+=ye.raw,Je.text+=ye.text):Z.push(ye);continue}if(ye=this.tokenizer.emStrong(j,Be,nt)){j=j.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),Z.push(ye);continue}if(ye=this.tokenizer.codespan(j)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.br(j)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.del(j)){j=j.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),Z.push(ye);continue}if(ye=this.tokenizer.autolink(j,q)){j=j.substring(ye.raw.length),Z.push(ye);continue}if(!ae&&(ye=this.tokenizer.url(j,q))){j=j.substring(ye.raw.length),Z.push(ye);continue}if(ye=this.tokenizer.inlineText(j,he,x)){j=j.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,ze=Z[Z.length-1],ze&&ze.type==="text"?(ze.raw+=ye.raw,ze.text+=ye.text):Z.push(ye);continue}if(j){var mt="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return Z},e(W,null,[{key:"rules",get:function(){return{block:xe,inline:Ae}}}]),W}(),le=y.defaults,me=B.cleanUrl,Se=B.escape,Oe=function(){function W(ce){this.options=ce||le}var ie=W.prototype;return ie.code=function(j,Z,ae){var he=(Z||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(j,he);ye!=null&&ye!==j&&(ae=!0,j=ye)}return j=j.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+Se(he,!0)+'">'+(ae?j:Se(j,!0))+`</code></pre>
`:"<pre><code>"+(ae?j:Se(j,!0))+`</code></pre>
`},ie.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ie.html=function(j){return j},ie.heading=function(j,Z,ae,he){return this.options.headerIds?"<h"+Z+' id="'+this.options.headerPrefix+he.slug(ae)+'">'+j+"</h"+Z+`>
`:"<h"+Z+">"+j+"</h"+Z+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(j,Z,ae){var he=Z?"ol":"ul",ye=Z&&ae!==1?' start="'+ae+'"':"";return"<"+he+ye+`>
`+j+"</"+he+`>
`},ie.listitem=function(j){return"<li>"+j+`</li>
`},ie.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(j){return"<p>"+j+`</p>
`},ie.table=function(j,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+Z+`</table>
`},ie.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ie.tablecell=function(j,Z){var ae=Z.header?"th":"td",he=Z.align?"<"+ae+' align="'+Z.align+'">':"<"+ae+">";return he+j+"</"+ae+`>
`},ie.strong=function(j){return"<strong>"+j+"</strong>"},ie.em=function(j){return"<em>"+j+"</em>"},ie.codespan=function(j){return"<code>"+j+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(j){return"<del>"+j+"</del>"},ie.link=function(j,Z,ae){if(j=me(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<a href="'+Se(j)+'"';return Z&&(he+=' title="'+Z+'"'),he+=">"+ae+"</a>",he},ie.image=function(j,Z,ae){if(j=me(this.options.sanitize,this.options.baseUrl,j),j===null)return ae;var he='<img src="'+j+'" alt="'+ae+'"';return Z&&(he+=' title="'+Z+'"'),he+=this.options.xhtml?"/>":">",he},ie.text=function(j){return j},W}(),ge=function(){function W(){}var ie=W.prototype;return ie.strong=function(j){return j},ie.em=function(j){return j},ie.codespan=function(j){return j},ie.del=function(j){return j},ie.html=function(j){return j},ie.text=function(j){return j},ie.link=function(j,Z,ae){return""+ae},ie.image=function(j,Z,ae){return""+ae},ie.br=function(){return""},W}(),Ce=function(){function W(){this.seen={}}var ie=W.prototype;return ie.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(j,Z){var ae=j,he=0;if(this.seen.hasOwnProperty(ae)){he=this.seen[j];do he++,ae=j+"-"+he;while(this.seen.hasOwnProperty(ae))}return Z||(this.seen[j]=he,this.seen[ae]=0),ae},ie.slug=function(j,Z){Z===void 0&&(Z={});var ae=this.serialize(j);return this.getNextSafeSlug(ae,Z.dryrun)},W}(),Pe=y.defaults,$e=B.unescape,Ee=function(){function W(ce){this.options=ce||Pe,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}W.parse=function(j,Z){var ae=new W(Z);return ae.parse(j)},W.parseInline=function(j,Z){var ae=new W(Z);return ae.parseInline(j)};var ie=W.prototype;return ie.parse=function(j,Z){Z===void 0&&(Z=!0);var ae="",he,ye,ze,Be,Ne,Ge,nt,dt,it,Je,mt,wt,we,de,oe,K,Re,Ie,Qe=j.length;for(he=0;he<Qe;he++)switch(Je=j[he],Je.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,$e(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(dt="",nt="",Be=Je.header.length,ye=0;ye<Be;ye++)nt+=this.renderer.tablecell(this.parseInline(Je.tokens.header[ye]),{header:!0,align:Je.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",Be=Je.cells.length,ye=0;ye<Be;ye++){for(Ge=Je.tokens.cells[ye],nt="",Ne=Ge.length,ze=0;ze<Ne;ze++)nt+=this.renderer.tablecell(this.parseInline(Ge[ze]),{header:!1,align:Je.align[ze]});it+=this.renderer.tablerow(nt)}ae+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Je.tokens),ae+=this.renderer.blockquote(it);continue}case"list":{for(mt=Je.ordered,wt=Je.start,we=Je.loose,Be=Je.items.length,it="",ye=0;ye<Be;ye++)oe=Je.items[ye],K=oe.checked,Re=oe.task,de="",oe.task&&(Ie=this.renderer.checkbox(K),we?oe.tokens.length>0&&oe.tokens[0].type==="text"?(oe.tokens[0].text=Ie+" "+oe.tokens[0].text,oe.tokens[0].tokens&&oe.tokens[0].tokens.length>0&&oe.tokens[0].tokens[0].type==="text"&&(oe.tokens[0].tokens[0].text=Ie+" "+oe.tokens[0].tokens[0].text)):oe.tokens.unshift({type:"text",text:Ie}):de+=Ie),de+=this.parse(oe.tokens,we),it+=this.renderer.listitem(de,Re,K);ae+=this.renderer.list(it,mt,wt);continue}case"html":{ae+=this.renderer.html(Je.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(it=Je.tokens?this.parseInline(Je.tokens):Je.text;he+1<Qe&&j[he+1].type==="text";)Je=j[++he],it+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);ae+=Z?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ae},ie.parseInline=function(j,Z){Z=Z||this.renderer;var ae="",he,ye,ze=j.length;for(he=0;he<ze;he++)switch(ye=j[he],ye.type){case"escape":{ae+=Z.text(ye.text);break}case"html":{ae+=Z.html(ye.text);break}case"link":{ae+=Z.link(ye.href,ye.title,this.parseInline(ye.tokens,Z));break}case"image":{ae+=Z.image(ye.href,ye.title,ye.text);break}case"strong":{ae+=Z.strong(this.parseInline(ye.tokens,Z));break}case"em":{ae+=Z.em(this.parseInline(ye.tokens,Z));break}case"codespan":{ae+=Z.codespan(ye.text);break}case"br":{ae+=Z.br();break}case"del":{ae+=Z.del(this.parseInline(ye.tokens,Z));break}case"text":{ae+=Z.text(ye.text);break}default:{var Be='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}return ae},W}(),je=B.merge,H=B.checkSanitizeDeprecation,te=B.escape,ve=y.getDefaults,Le=y.changeDefaults,He=y.defaults;function Ue(W,ie,ce){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof ie=="function"&&(ce=ie,ie=null),ie=je({},Ue.defaults,ie||{}),H(ie),ce){var j=ie.highlight,Z;try{Z=ne.lex(W,ie)}catch(ze){return ce(ze)}var ae=function(Be){var Ne;if(!Be)try{Ne=Ee.parse(Z,ie)}catch(Ge){Be=Ge}return ie.highlight=j,Be?ce(Be):ce(null,Ne)};if(!j||j.length<3||(delete ie.highlight,!Z.length))return ae();var he=0;Ue.walkTokens(Z,function(ze){ze.type==="code"&&(he++,setTimeout(function(){j(ze.text,ze.lang,function(Be,Ne){if(Be)return ae(Be);Ne!=null&&Ne!==ze.text&&(ze.text=Ne,ze.escaped=!0),he--,he===0&&ae()})},0))}),he===0&&ae();return}try{var ye=ne.lex(W,ie);return ie.walkTokens&&Ue.walkTokens(ye,ie.walkTokens),Ee.parse(ye,ie)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+te(ze.message+"",!0)+"</pre>";throw ze}}Ue.options=Ue.setOptions=function(W){return je(Ue.defaults,W),Le(Ue.defaults),Ue},Ue.getDefaults=ve,Ue.defaults=He,Ue.use=function(W){var ie=je({},W);if(W.renderer&&function(){var j=Ue.defaults.renderer||new Oe,Z=function(ye){var ze=j[ye];j[ye]=function(){for(var Be=arguments.length,Ne=new Array(Be),Ge=0;Ge<Be;Ge++)Ne[Ge]=arguments[Ge];var nt=W.renderer[ye].apply(j,Ne);return nt===!1&&(nt=ze.apply(j,Ne)),nt}};for(var ae in W.renderer)Z(ae);ie.renderer=j}(),W.tokenizer&&function(){var j=Ue.defaults.tokenizer||new L,Z=function(ye){var ze=j[ye];j[ye]=function(){for(var Be=arguments.length,Ne=new Array(Be),Ge=0;Ge<Be;Ge++)Ne[Ge]=arguments[Ge];var nt=W.tokenizer[ye].apply(j,Ne);return nt===!1&&(nt=ze.apply(j,Ne)),nt}};for(var ae in W.tokenizer)Z(ae);ie.tokenizer=j}(),W.walkTokens){var ce=Ue.defaults.walkTokens;ie.walkTokens=function(j){W.walkTokens(j),ce&&ce(j)}}Ue.setOptions(ie)},Ue.walkTokens=function(W,ie){for(var ce=A(W),j;!(j=ce()).done;){var Z=j.value;switch(ie(Z),Z.type){case"table":{for(var ae=A(Z.tokens.header),he;!(he=ae()).done;){var ye=he.value;Ue.walkTokens(ye,ie)}for(var ze=A(Z.tokens.cells),Be;!(Be=ze()).done;)for(var Ne=Be.value,Ge=A(Ne),nt;!(nt=Ge()).done;){var dt=nt.value;Ue.walkTokens(dt,ie)}break}case"list":{Ue.walkTokens(Z.items,ie);break}default:Z.tokens&&Ue.walkTokens(Z.tokens,ie)}}},Ue.parseInline=function(W,ie){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");ie=je({},Ue.defaults,ie||{}),H(ie);try{var ce=ne.lexInline(W,ie);return ie.walkTokens&&Ue.walkTokens(ce,ie.walkTokens),Ee.parseInline(ce,ie)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+te(j.message+"",!0)+"</pre>";throw j}},Ue.Parser=Ee,Ue.parser=Ee.parse,Ue.Renderer=Oe,Ue.TextRenderer=ge,Ue.Lexer=ne,Ue.lexer=ne.lex,Ue.Tokenizer=L,Ue.Slugger=Ce,Ue.parse=Ue;var Xe=Ue;return Xe}),define(be[81],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,C,D){return Math.min(Math.max(y,C),D)}e.clamp=b;function I(y,C){return(C+y%C)%C}e.rot=I;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function Q(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function y(D){T.push(D,Date.now())}function C(){const D=[];for(let k=0;k<T.length;k+=2)D.push({name:T[k],startTime:T[k+1]});return D}return{mark:y,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(A+y.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function b(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=b(I))})(),define(be[21],_e([0,1]),function(Q,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let A=!1,T=!1,y=!1,C=!1,D=!1,k=!1,n=!1,P,d=I,h,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const g=typeof((b=l==null?void 0:l.versions)===null||b===void 0?void 0:b.electron)=="string"&&l.type==="renderer";if(e.isElectronSandboxed=g&&(l==null?void 0:l.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=l==null?void 0:l.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)r=navigator.userAgent,A=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,n=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=r.indexOf("Linux")>=0,k=!0,P=navigator.language,d=P;else if(typeof l=="object"){A=l.platform==="win32",T=l.platform==="darwin",y=l.platform==="linux",C=y&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,P=I,d=I;const a=l.env.VSCODE_NLS_CONFIG;if(a)try{const s=JSON.parse(a),u=s.availableLanguages["*"];P=s.locale,d=u||I,h=s._translationsConfigFile}catch(s){}D=!0}else console.error("Unable to resolve platform.");var m;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function S(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let f=0;T?f=1:A?f=3:y&&(f=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=C,e.isNative=D,e.isWeb=k,e.isIOS=n,e.platform=f,e.userAgent=r,e.language=d;var c;(function(a){function s(){return e.language}a.value=s;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=u;function w(){return e.language==="en"}a.isDefault=w})(c=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeSetImmediateId)for(let v=0,E=u.length;v<E;v++){const F=u[v];if(F.id===_.data.vscodeSetImmediateId){u.splice(v,1),F.callback();return}}});let w=0;return _=>{const v=++w;u.push({id:v,callback:_}),e.globals.postMessage({vscodeSetImmediateId:v},"*")}}if(typeof(l==null?void 0:l.nextTick)=="function")return l.nextTick.bind(l);const s=Promise.resolve();return u=>s.then(u)}();var p;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(p=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||n?2:A?1:3;let t=!0,i=!1;function o(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(be[46],_e([0,1,21]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof b.globals.vscode!="undefined"){const A=b.globals.vscode.process;I={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,b.setImmediate)(T)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:I={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(A){return(0,b.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(be[13],_e([0,1,46]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,A=97,T=90,y=122,C=46,D=47,k=92,n=58,P=63;class d extends Error{constructor(c,p,t){let i;typeof p=="string"&&p.indexOf("not ")===0?(i="must not be",p=p.replace(/^not /,"")):i="must be";const o=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${o} ${i} of type ${p}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(f,c){if(typeof f!="string")throw new d(c,"string",f)}function r(f){return f===D||f===k}function l(f){return f===D}function g(f){return f>=I&&f<=T||f>=A&&f<=y}function m(f,c,p,t){let i="",o=0,a=-1,s=0,u=0;for(let w=0;w<=f.length;++w){if(w<f.length)u=f.charCodeAt(w);else{if(t(u))break;u=D}if(t(u)){if(!(a===w-1||s===1))if(s===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==C||i.charCodeAt(i.length-2)!==C){if(i.length>2){const _=i.lastIndexOf(p);_===-1?(i="",o=0):(i=i.slice(0,_),o=i.length-1-i.lastIndexOf(p)),a=w,s=0;continue}else if(i.length!==0){i="",o=0,a=w,s=0;continue}}c&&(i+=i.length>0?`${p}..`:"..",o=2)}else i.length>0?i+=`${p}${f.slice(a+1,w)}`:i=f.slice(a+1,w),o=w-a-1;a=w,s=0}else u===C&&s!==-1?++s:s=-1}return i}function S(f,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const p=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return p?p===c.root?`${p}${t}`:`${p}${f}${t}`:t}e.win32={resolve(...f){let c="",p="",t=!1;for(let i=f.length-1;i>=-1;i--){let o;if(i>=0){if(o=f[i],h(o,"path"),o.length===0)continue}else c.length===0?o=b.cwd():(o=b.env[`=${c}`]||b.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==c.toLowerCase()&&o.charCodeAt(2)===k)&&(o=`${c}\\`));const a=o.length;let s=0,u="",w=!1;const _=o.charCodeAt(0);if(a===1)r(_)&&(s=1,w=!0);else if(r(_))if(w=!0,r(o.charCodeAt(1))){let v=2,E=v;for(;v<a&&!r(o.charCodeAt(v));)v++;if(v<a&&v!==E){const F=o.slice(E,v);for(E=v;v<a&&r(o.charCodeAt(v));)v++;if(v<a&&v!==E){for(E=v;v<a&&!r(o.charCodeAt(v));)v++;(v===a||v!==E)&&(u=`\\\\${F}\\${o.slice(E,v)}`,s=v)}}}else s=1;else g(_)&&o.charCodeAt(1)===n&&(u=o.slice(0,2),s=2,a>2&&r(o.charCodeAt(2))&&(w=!0,s=3));if(u.length>0)if(c.length>0){if(u.toLowerCase()!==c.toLowerCase())continue}else c=u;if(t){if(c.length>0)break}else if(p=`${o.slice(s)}\\${p}`,t=w,w&&c.length>0)break}return p=m(p,!t,"\\",r),t?`${c}\\${p}`:`${c}${p}`||"."},normalize(f){h(f,"path");const c=f.length;if(c===0)return".";let p=0,t,i=!1;const o=f.charCodeAt(0);if(c===1)return l(o)?"\\":f;if(r(o))if(i=!0,r(f.charCodeAt(1))){let s=2,u=s;for(;s<c&&!r(f.charCodeAt(s));)s++;if(s<c&&s!==u){const w=f.slice(u,s);for(u=s;s<c&&r(f.charCodeAt(s));)s++;if(s<c&&s!==u){for(u=s;s<c&&!r(f.charCodeAt(s));)s++;if(s===c)return`\\\\${w}\\${f.slice(u)}\\`;s!==u&&(t=`\\\\${w}\\${f.slice(u,s)}`,p=s)}}}else p=1;else g(o)&&f.charCodeAt(1)===n&&(t=f.slice(0,2),p=2,c>2&&r(f.charCodeAt(2))&&(i=!0,p=3));let a=p<c?m(f.slice(p),!i,"\\",r):"";return a.length===0&&!i&&(a="."),a.length>0&&r(f.charCodeAt(c-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(f){h(f,"path");const c=f.length;if(c===0)return!1;const p=f.charCodeAt(0);return r(p)||c>2&&g(p)&&f.charCodeAt(1)===n&&r(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,p;for(let o=0;o<f.length;++o){const a=f[o];h(a,"path"),a.length>0&&(c===void 0?c=p=a:c+=`\\${a}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof p=="string"&&r(p.charCodeAt(0))){++i;const o=p.length;o>1&&r(p.charCodeAt(1))&&(++i,o>2&&(r(p.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&r(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(f,c){if(h(f,"from"),h(c,"to"),f===c)return"";const p=e.win32.resolve(f),t=e.win32.resolve(c);if(p===t||(f=p.toLowerCase(),c=t.toLowerCase(),f===c))return"";let i=0;for(;i<f.length&&f.charCodeAt(i)===k;)i++;let o=f.length;for(;o-1>i&&f.charCodeAt(o-1)===k;)o--;const a=o-i;let s=0;for(;s<c.length&&c.charCodeAt(s)===k;)s++;let u=c.length;for(;u-1>s&&c.charCodeAt(u-1)===k;)u--;const w=u-s,_=a<w?a:w;let v=-1,E=0;for(;E<_;E++){const B=f.charCodeAt(i+E);if(B!==c.charCodeAt(s+E))break;B===k&&(v=E)}if(E!==_){if(v===-1)return t}else{if(w>_){if(c.charCodeAt(s+E)===k)return t.slice(s+E+1);if(E===2)return t.slice(s+E)}a>_&&(f.charCodeAt(i+E)===k?v=E:E===2&&(v=3)),v===-1&&(v=0)}let F="";for(E=i+v+1;E<=o;++E)(E===o||f.charCodeAt(E)===k)&&(F+=F.length===0?"..":"\\..");return s+=v,F.length>0?`${F}${t.slice(s,u)}`:(t.charCodeAt(s)===k&&++s,t.slice(s,u))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===k){if(c.charCodeAt(1)===k){const p=c.charCodeAt(2);if(p!==P&&p!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(g(c.charCodeAt(0))&&c.charCodeAt(1)===n&&c.charCodeAt(2)===k)return`\\\\?\\${c}`;return f},dirname(f){h(f,"path");const c=f.length;if(c===0)return".";let p=-1,t=0;const i=f.charCodeAt(0);if(c===1)return r(i)?f:".";if(r(i)){if(p=t=1,r(f.charCodeAt(1))){let s=2,u=s;for(;s<c&&!r(f.charCodeAt(s));)s++;if(s<c&&s!==u){for(u=s;s<c&&r(f.charCodeAt(s));)s++;if(s<c&&s!==u){for(u=s;s<c&&!r(f.charCodeAt(s));)s++;if(s===c)return f;s!==u&&(p=t=s+1)}}}}else g(i)&&f.charCodeAt(1)===n&&(p=c>2&&r(f.charCodeAt(2))?3:2,t=p);let o=-1,a=!0;for(let s=c-1;s>=t;--s)if(r(f.charCodeAt(s))){if(!a){o=s;break}}else a=!1;if(o===-1){if(p===-1)return".";o=p}return f.slice(0,o)},basename(f,c){c!==void 0&&h(c,"ext"),h(f,"path");let p=0,t=-1,i=!0,o;if(f.length>=2&&g(f.charCodeAt(0))&&f.charCodeAt(1)===n&&(p=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let a=c.length-1,s=-1;for(o=f.length-1;o>=p;--o){const u=f.charCodeAt(o);if(r(u)){if(!i){p=o+1;break}}else s===-1&&(i=!1,s=o+1),a>=0&&(u===c.charCodeAt(a)?--a==-1&&(t=o):(a=-1,t=s))}return p===t?t=s:t===-1&&(t=f.length),f.slice(p,t)}for(o=f.length-1;o>=p;--o)if(r(f.charCodeAt(o))){if(!i){p=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":f.slice(p,t)},extname(f){h(f,"path");let c=0,p=-1,t=0,i=-1,o=!0,a=0;f.length>=2&&f.charCodeAt(1)===n&&g(f.charCodeAt(0))&&(c=t=2);for(let s=f.length-1;s>=c;--s){const u=f.charCodeAt(s);if(r(u)){if(!o){t=s+1;break}continue}i===-1&&(o=!1,i=s+1),u===C?p===-1?p=s:a!==1&&(a=1):p!==-1&&(a=-1)}return p===-1||i===-1||a===0||a===1&&p===i-1&&p===t+1?"":f.slice(p,i)},format:S.bind(null,"\\"),parse(f){h(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const p=f.length;let t=0,i=f.charCodeAt(0);if(p===1)return r(i)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(r(i)){if(t=1,r(f.charCodeAt(1))){let v=2,E=v;for(;v<p&&!r(f.charCodeAt(v));)v++;if(v<p&&v!==E){for(E=v;v<p&&r(f.charCodeAt(v));)v++;if(v<p&&v!==E){for(E=v;v<p&&!r(f.charCodeAt(v));)v++;v===p?t=v:v!==E&&(t=v+1)}}}}else if(g(i)&&f.charCodeAt(1)===n){if(p<=2)return c.root=c.dir=f,c;if(t=2,r(f.charCodeAt(2))){if(p===3)return c.root=c.dir=f,c;t=3}}t>0&&(c.root=f.slice(0,t));let o=-1,a=t,s=-1,u=!0,w=f.length-1,_=0;for(;w>=t;--w){if(i=f.charCodeAt(w),r(i)){if(!u){a=w+1;break}continue}s===-1&&(u=!1,s=w+1),i===C?o===-1?o=w:_!==1&&(_=1):o!==-1&&(_=-1)}return s!==-1&&(o===-1||_===0||_===1&&o===s-1&&o===a+1?c.base=c.name=f.slice(a,s):(c.name=f.slice(a,o),c.base=f.slice(a,s),c.ext=f.slice(o,s))),a>0&&a!==t?c.dir=f.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",p=!1;for(let t=f.length-1;t>=-1&&!p;t--){const i=t>=0?f[t]:b.cwd();h(i,"path"),i.length!==0&&(c=`${i}/${c}`,p=i.charCodeAt(0)===D)}return c=m(c,!p,"/",l),p?`/${c}`:c.length>0?c:"."},normalize(f){if(h(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===D,p=f.charCodeAt(f.length-1)===D;return f=m(f,!c,"/",l),f.length===0?c?"/":p?"./":".":(p&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return h(f,"path"),f.length>0&&f.charCodeAt(0)===D},join(...f){if(f.length===0)return".";let c;for(let p=0;p<f.length;++p){const t=f[p];h(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(h(f,"from"),h(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const p=1,t=f.length,i=t-p,o=1,a=c.length-o,s=i<a?i:a;let u=-1,w=0;for(;w<s;w++){const v=f.charCodeAt(p+w);if(v!==c.charCodeAt(o+w))break;v===D&&(u=w)}if(w===s)if(a>s){if(c.charCodeAt(o+w)===D)return c.slice(o+w+1);if(w===0)return c.slice(o+w)}else i>s&&(f.charCodeAt(p+w)===D?u=w:w===0&&(u=0));let _="";for(w=p+u+1;w<=t;++w)(w===t||f.charCodeAt(w)===D)&&(_+=_.length===0?"..":"/..");return`${_}${c.slice(o+u)}`},toNamespacedPath(f){return f},dirname(f){if(h(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===D;let p=-1,t=!0;for(let i=f.length-1;i>=1;--i)if(f.charCodeAt(i)===D){if(!t){p=i;break}}else t=!1;return p===-1?c?"/":".":c&&p===1?"//":f.slice(0,p)},basename(f,c){c!==void 0&&h(c,"ext"),h(f,"path");let p=0,t=-1,i=!0,o;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let a=c.length-1,s=-1;for(o=f.length-1;o>=0;--o){const u=f.charCodeAt(o);if(u===D){if(!i){p=o+1;break}}else s===-1&&(i=!1,s=o+1),a>=0&&(u===c.charCodeAt(a)?--a==-1&&(t=o):(a=-1,t=s))}return p===t?t=s:t===-1&&(t=f.length),f.slice(p,t)}for(o=f.length-1;o>=0;--o)if(f.charCodeAt(o)===D){if(!i){p=o+1;break}}else t===-1&&(i=!1,t=o+1);return t===-1?"":f.slice(p,t)},extname(f){h(f,"path");let c=-1,p=0,t=-1,i=!0,o=0;for(let a=f.length-1;a>=0;--a){const s=f.charCodeAt(a);if(s===D){if(!i){p=a+1;break}continue}t===-1&&(i=!1,t=a+1),s===C?c===-1?c=a:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||t===-1||o===0||o===1&&c===t-1&&c===p+1?"":f.slice(c,t)},format:S.bind(null,"/"),parse(f){h(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const p=f.charCodeAt(0)===D;let t;p?(c.root="/",t=1):t=0;let i=-1,o=0,a=-1,s=!0,u=f.length-1,w=0;for(;u>=t;--u){const _=f.charCodeAt(u);if(_===D){if(!s){o=u+1;break}continue}a===-1&&(s=!1,a=u+1),_===C?i===-1?i=u:w!==1&&(w=1):i!==-1&&(w=-1)}if(a!==-1){const _=o===0&&p?1:o;i===-1||w===0||w===1&&i===a-1&&i===o+1?c.base=c.name=f.slice(_,a):(c.name=f.slice(_,i),c.base=f.slice(_,a),c.ext=f.slice(i,a))}return o>0?c.dir=f.slice(0,o-1):p&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[55],_e([0,1,21]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=b.globals.performance&&typeof b.globals.performance.now=="function";class A{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=A}),define(be[3],_e([0,1,12,53,6,45,55]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(m){m.None=()=>A.Disposable.None;function S(V){return(z,ee=null,$)=>{let R=!1,L;return L=V(M=>{if(!R)return L?L.dispose():R=!0,z.call(ee,M)},null,$),R&&L.dispose(),L}}m.once=S;function f(V,z){return a((ee,$=null,R)=>V(L=>ee.call($,z(L)),null,R))}m.map=f;function c(V,z){return a((ee,$=null,R)=>V(L=>{z(L),ee.call($,L)},null,R))}m.forEach=c;function p(V,z){return a((ee,$=null,R)=>V(L=>z(L)&&ee.call($,L),null,R))}m.filter=p;function t(V){return V}m.signal=t;function i(...V){return(z,ee=null,$)=>(0,A.combinedDisposable)(...V.map(R=>R(L=>z.call(ee,L),null,$)))}m.any=i;function o(V,z,ee){let $=ee;return f(V,R=>($=z($,R),$))}m.reduce=o;function a(V){let z;const ee=new d({onFirstListenerAdd(){z=V(ee.fire,ee)},onLastListenerRemove(){z.dispose()}});return ee.event}m.snapshot=a;function s(V,z,ee=100,$=!1,R){let L,M,U,G=0;const X=new d({leakWarningThreshold:R,onFirstListenerAdd(){L=V(se=>{G++,M=z(M,se),$&&!U&&(X.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const pe=M;M=void 0,U=void 0,(!$||G>1)&&X.fire(pe),G=0},ee)})},onLastListenerRemove(){L.dispose()}});return X.event}m.debounce=s;function u(V){const z=new Date().getTime();return f(S(V),ee=>new Date().getTime()-z)}m.stopwatch=u;function w(V){let z=!0,ee;return p(V,$=>{const R=z||$!==ee;return z=!1,ee=$,R})}m.latch=w;function _(V,z=!1,ee=[]){let $=ee.slice(),R=V(U=>{$?$.push(U):M.fire(U)});const L=()=>{$&&$.forEach(U=>M.fire(U)),$=null},M=new d({onFirstListenerAdd(){R||(R=V(U=>M.fire(U)))},onFirstListenerDidAdd(){$&&(z?setTimeout(L):L())},onLastListenerRemove(){R&&R.dispose(),R=null}});return M.event}m.buffer=_;class v{constructor(z){this.event=z}map(z){return new v(f(this.event,z))}forEach(z){return new v(c(this.event,z))}filter(z){return new v(p(this.event,z))}reduce(z,ee){return new v(o(this.event,z,ee))}latch(){return new v(w(this.event))}debounce(z,ee=100,$=!1,R){return new v(s(this.event,z,ee,$,R))}on(z,ee,$){return this.event(z,ee,$)}once(z,ee,$){return S(this.event)(z,ee,$)}}function E(V){return new v(V)}m.chain=E;function F(V,z,ee=$=>$){const $=(...U)=>M.fire(ee(...U)),R=()=>V.on(z,$),L=()=>V.removeListener(z,$),M=new d({onFirstListenerAdd:R,onLastListenerRemove:L});return M.event}m.fromNodeEventEmitter=F;function B(V,z,ee=$=>$){const $=(...U)=>M.fire(ee(...U)),R=()=>V.addEventListener(z,$),L=()=>V.removeEventListener(z,$),M=new d({onFirstListenerAdd:R,onLastListenerRemove:L});return M.event}m.fromDOMEventEmitter=B;function Y(V){const z=new d;let ee=!1;return V.then(void 0,()=>null).then(()=>{ee?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),ee=!0,z.event}m.fromPromise=Y;function fe(V){return new Promise(z=>S(V)(z))}m.toPromise=fe})(C=e.Event||(e.Event={}));class D{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${D._idPool++}`}start(S){this._stopWatch=new y.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function n(m){const S=k;return k=m,{dispose(){k=S}}}e.setGlobalLeakWarningThreshold=n;class P{constructor(S,f=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let f=k;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||S<f)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),p=this._stacks.get(c)||0;if(this._stacks.set(c,p+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,i=0;for(const[o,a]of this._stacks)(!t||i<a)&&(t=o,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class d{constructor(S){var f;this._disposed=!1,this._options=S,this._leakageMon=k>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(S,f,c)=>{var p;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(f?[S,f]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,f);const o=(p=this._leakageMon)===null||p===void 0?void 0:p.check(this._listeners.size);let a;return a={dispose:()=>{o&&o(),a.dispose=d._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof A.DisposableStore?c.add(a):Array.isArray(c)&&c.push(a),a}),this._event}fire(S){var f,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let p of this._listeners)this._deliveryQueue.push([p,S]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[p,t]=this._deliveryQueue.shift();try{typeof p=="function"?p.call(void 0,t):p[0].call(p[1],t)}catch(i){(0,b.onUnexpectedError)(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var S,f,c;(S=this._listeners)===null||S===void 0||S.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=d,d._noop=function(){};class h extends d{constructor(S){super(S);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=h;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const f={event:S,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const c=()=>{this.hasListeners&&this.unhook(f);const p=this.events.indexOf(f);this.events.splice(p,1)};return(0,A.toDisposable)((0,I.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(f=>this.emitter.fire(f))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class l{constructor(){this.buffers=[]}wrapEvent(S){return(f,c,p)=>S(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>f.call(c,t)):f.call(c,t)},void 0,p)}bufferEvents(S){const f=[];this.buffers.push(f);const c=S();return this.buffers.pop(),f.forEach(p=>p()),c}}e.EventBufferer=l;class g{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=A.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(be[20],_e([0,1,3]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(C,D){const k=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(k)}}});var A;(function(C){function D(k){return k===C.None||k===C.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(be[36],_e([0,1,3]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(P){const d=this._icons.get(P.id);d?P.description?d.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new I;e.iconRegistry=A;function T(n,P){return new C(n,P)}e.registerCodicon=T;function y(n){return n?n.replace(/\$\((.*?)\)/g,(P,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=y;class C{constructor(P,d,h){this.id=P,this.definition=d,this.description=h,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(n,P){const d=["codicon","codicon-"+n];return P&&d.push("codicon-modifier-"+P),d}e.getClassNamesArray=D;var k;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(l){if(l instanceof C)return["codicon","codicon-"+l.id];const g=P.exec(l.id);if(!g)return d(C.error);let[,m,S]=g;const f=["codicon","codicon-"+m];return S&&f.push("codicon-modifier-"+S.substr(1)),f}n.asClassNameArray=d;function h(l){return d(l).join(" ")}n.asClassName=h;function r(l){return"."+d(l).join(".")}n.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(be[109],_e([0,1,12,6]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=A;function T(f){const c=f;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(f,c){return new C(f,c)}e.newWriteableStream=y;class C{constructor(c,p){this.reducer=c,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){var p;if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof((p=this.options)===null||p===void 0?void 0:p.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(p=>p(c))}emitError(c){this.listeners.error.length===0?(0,b.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(p=>p(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,p){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(c,p){if(!this.state.destroyed){let t;switch(c){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(p);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(f,c){const p=[];let t;for(;(t=f.read())!==null;)p.push(t);return c(p)}e.consumeReadable=D;function k(f,c,p){const t=[];let i;for(;(i=f.read())!==null&&t.length<p;)t.push(i);return i===null&&t.length>0?c(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const o=i;return i=void 0,o}return f.read()}}}e.peekReadable=k;function n(f,c){return new Promise((p,t)=>{const i=[];P(f,{onData:o=>{c&&i.push(o)},onError:o=>{c?t(o):p(void 0)},onEnd:()=>{p(c?c(i):void 0)}})})}e.consumeStream=n;function P(f,c){f.on("error",p=>c.onError(p)),f.on("end",()=>c.onEnd()),f.on("data",p=>c.onData(p))}e.listenStream=P;function d(f,c){return new Promise((p,t)=>{const i=new I.DisposableStore,o=[],a=w=>{if(o.push(w),o.length>c)return i.dispose(),f.pause(),p({stream:f,buffer:o,ended:!1})},s=w=>t(w),u=()=>p({stream:f,buffer:o,ended:!0});i.add((0,I.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),i.add((0,I.toDisposable)(()=>f.removeListener("end",u))),f.on("end",u),i.add((0,I.toDisposable)(()=>f.removeListener("data",a))),f.on("data",a)})}e.peekStream=d;function h(f,c){const p=y(c);return p.end(f),p}e.toStream=h;function r(){const f=y(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=r;function l(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=l;function g(f,c,p){const t=y(p);return P(f,{onData:i=>t.write(c.data(i)),onError:i=>t.error(c.error?c.error(i):i),onEnd:()=>t.end()}),t}e.transform=g;function m(f,c,p){let t=!1;return{read:()=>{const i=c.read();return t?i:(t=!0,i!==null?p([f,i]):f)}}}e.prefixedReadable=m;function S(f,c,p){let t=!1;const i=y(p);return P(c,{onData:o=>t?i.write(o):(t=!0,i.write(p([f,o]))),onError:o=>i.error(o),onEnd:()=>{t||(t=!0,i.write(f)),i.end()}}),i}e.prefixedStream=S}),define(be[8],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=b;const I=/{(\d+)}/g;function A(W,...ie){return ie.length===0?W:W.replace(I,function(ce,j){const Z=parseInt(j,10);return isNaN(Z)||Z<0||Z>=ie.length?ce:ie[Z]})}e.format=A;function T(W){return W.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=T;function y(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(W,ie){let ce=0;const j=ie.charCodeAt(0);for(let Z=W.length-1;Z>=0;Z--)W.charCodeAt(Z)===j&&ce++;return ce}e.count=C;function D(W,ie,ce="\u2026"){return W.length<=ie?W:`${W.substr(0,ie)}${ce}`}e.truncate=D;function k(W,ie=" "){const ce=n(W,ie);return P(ce,ie)}e.trim=k;function n(W,ie){if(!W||!ie)return W;const ce=ie.length;if(ce===0||W.length===0)return W;let j=0;for(;W.indexOf(ie,j)===j;)j=j+ce;return W.substring(j)}e.ltrim=n;function P(W,ie){if(!W||!ie)return W;const ce=ie.length,j=W.length;if(ce===0||j===0)return W;let Z=j,ae=-1;for(;ae=W.lastIndexOf(ie,Z-1),!(ae===-1||ae+ce!==Z);){if(ae===0)return"";Z=ae}return W.substring(0,Z)}e.rtrim=P;function d(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(W){return W.replace(/\*/g,"")}e.stripWildcards=h;function r(W,ie,ce={}){if(!W)throw new Error("Cannot create regex from empty string");ie||(W=y(W)),ce.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let j="";return ce.global&&(j+="g"),ce.matchCase||(j+="i"),ce.multiline&&(j+="m"),ce.unicode&&(j+="u"),new RegExp(W,j)}e.createRegExp=r;function l(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function g(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function m(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=m;function S(W){return W.split(/\r\n|\r|\n/)}e.splitLines=S;function f(W){for(let ie=0,ce=W.length;ie<ce;ie++){const j=W.charCodeAt(ie);if(j!==32&&j!==9)return ie}return-1}e.firstNonWhitespaceIndex=f;function c(W,ie=0,ce=W.length){for(let j=ie;j<ce;j++){const Z=W.charCodeAt(j);if(Z!==32&&Z!==9)return W.substring(ie,j)}return W.substring(ie,ce)}e.getLeadingWhitespace=c;function p(W,ie=W.length-1){for(let ce=ie;ce>=0;ce--){const j=W.charCodeAt(ce);if(j!==32&&j!==9)return ce}return-1}e.lastNonWhitespaceIndex=p;function t(W,ie){return W<ie?-1:W>ie?1:0}e.compare=t;function i(W,ie,ce=0,j=W.length,Z=0,ae=ie.length){for(;ce<j&&Z<ae;ce++,Z++){let ze=W.charCodeAt(ce),Be=ie.charCodeAt(Z);if(ze<Be)return-1;if(ze>Be)return 1}const he=j-ce,ye=ae-Z;return he<ye?-1:he>ye?1:0}e.compareSubstring=i;function o(W,ie){return a(W,ie,0,W.length,0,ie.length)}e.compareIgnoreCase=o;function a(W,ie,ce=0,j=W.length,Z=0,ae=ie.length){for(;ce<j&&Z<ae;ce++,Z++){let ze=W.charCodeAt(ce),Be=ie.charCodeAt(Z);if(ze!==Be){const Ne=ze-Be;if(!(Ne===32&&u(Be))&&!(Ne===-32&&u(ze)))return s(ze)&&s(Be)?Ne:i(W.toLowerCase(),ie.toLowerCase(),ce,j,Z,ae)}}const he=j-ce,ye=ae-Z;return he<ye?-1:he>ye?1:0}e.compareSubstringIgnoreCase=a;function s(W){return W>=97&&W<=122}e.isLowerAsciiLetter=s;function u(W){return W>=65&&W<=90}e.isUpperAsciiLetter=u;function w(W){return s(W)||u(W)}function _(W,ie){return W.length===ie.length&&v(W,ie)}e.equalsIgnoreCase=_;function v(W,ie,ce=W.length){for(let j=0;j<ce;j++){const Z=W.charCodeAt(j),ae=ie.charCodeAt(j);if(Z!==ae){if(w(Z)&&w(ae)){const he=Math.abs(Z-ae);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(Z).toLowerCase()!==String.fromCharCode(ae).toLowerCase())return!1}}return!0}function E(W,ie){const ce=ie.length;return ie.length>W.length?!1:v(W,ie,ce)}e.startsWithIgnoreCase=E;function F(W,ie){let ce,j=Math.min(W.length,ie.length);for(ce=0;ce<j;ce++)if(W.charCodeAt(ce)!==ie.charCodeAt(ce))return ce;return j}e.commonPrefixLength=F;function B(W,ie){let ce,j=Math.min(W.length,ie.length);const Z=W.length-1,ae=ie.length-1;for(ce=0;ce<j;ce++)if(W.charCodeAt(Z-ce)!==ie.charCodeAt(ae-ce))return ce;return j}e.commonSuffixLength=B;function Y(W){return 55296<=W&&W<=56319}e.isHighSurrogate=Y;function fe(W){return 56320<=W&&W<=57343}e.isLowSurrogate=fe;function V(W,ie){return(W-55296<<10)+(ie-56320)+65536}e.computeCodePoint=V;function z(W,ie,ce){const j=W.charCodeAt(ce);if(Y(j)&&ce+1<ie){const Z=W.charCodeAt(ce+1);if(fe(Z))return V(j,Z)}return j}e.getNextCodePoint=z;function ee(W,ie){const ce=W.charCodeAt(ie-1);if(fe(ce)&&ie>1){const j=W.charCodeAt(ie-2);if(Y(j))return V(j,ce)}return ce}function $(W,ie){const ce=Ue.getInstance(),j=ie,Z=W.length,ae=z(W,Z,ie);ie+=ae>=65536?2:1;let he=ce.getGraphemeBreakType(ae);for(;ie<Z;){const ye=z(W,Z,ie),ze=ce.getGraphemeBreakType(ye);if(Le(he,ze))break;ie+=ye>=65536?2:1,he=ze}return ie-j}e.nextCharLength=$;function R(W,ie){const ce=Ue.getInstance(),j=ie,Z=ee(W,ie);ie-=Z>=65536?2:1;let ae=ce.getGraphemeBreakType(Z);for(;ie>0;){const he=ee(W,ie),ye=ce.getGraphemeBreakType(he);if(Le(ye,ae))break;ie-=he>=65536?2:1,ae=ye}return j-ie}e.prevCharLength=R;function L(W,ie){const ce=Ue.getInstance(),j=W.length,Z=ie,ae=z(W,j,ie),he=ce.getGraphemeBreakType(ae);ie+=ae>=65536?2:1;let ye=he;for(;ie<j;){const Be=z(W,j,ie),Ne=ce.getGraphemeBreakType(Be);if(Le(ye,Ne))break;ie+=Be>=65536?2:1,ye=Ne}const ze=ie;for(ie=Z,ye=he;ie>0;){const Be=ee(W,ie),Ne=ce.getGraphemeBreakType(Be);if(Le(Ne,ye))break;ie-=Be>=65536?2:1,ye=Ne}return[ie,ze]}function M(W,ie){return ie>0&&fe(W.charCodeAt(ie))?L(W,ie-1):L(W,ie)}e.getCharContainingOffset=M;function U(W){const ie=W.length;let ce=0,j=0;for(;j<ie;){const he=z(W,ie,j);j+=he>=65536?2:1,he<128?ce+=1:he<2048?ce+=2:he<65536?ce+=3:ce+=4}const Z=new Uint8Array(ce);j=0;let ae=0;for(;j<ie;){const he=z(W,ie,j);j+=he>=65536?2:1,he<128?Z[ae++]=he:he<2048?(Z[ae++]=192|(he&1984)>>>6,Z[ae++]=128|(he&63)>>>0):he<65536?(Z[ae++]=224|(he&61440)>>>12,Z[ae++]=128|(he&4032)>>>6,Z[ae++]=128|(he&63)>>>0):(Z[ae++]=240|(he&1835008)>>>18,Z[ae++]=128|(he&258048)>>>12,Z[ae++]=128|(he&4032)>>>6,Z[ae++]=128|(he&63)>>>0)}return Z}e.encodeUTF8=U;function G(W){const ie=W.byteLength,ce=[];let j=0;for(;j<ie;){const Z=W[j];let ae;if(Z>=240&&j+3<ie?ae=(W[j++]&7)<<18>>>0|(W[j++]&63)<<12>>>0|(W[j++]&63)<<6>>>0|(W[j++]&63)<<0>>>0:Z>=224&&j+2<ie?ae=(W[j++]&15)<<12>>>0|(W[j++]&63)<<6>>>0|(W[j++]&63)<<0>>>0:Z>=192&&j+1<ie?ae=(W[j++]&31)<<6>>>0|(W[j++]&63)<<0>>>0:ae=W[j++],ae>=0&&ae<=55295||ae>=57344&&ae<=65535)ce.push(String.fromCharCode(ae));else if(ae>=65536&&ae<=1114111){const he=ae-65536,ye=55296+((he&1047552)>>>10),ze=56320+((he&1023)>>>0);ce.push(String.fromCharCode(ye)),ce.push(String.fromCharCode(ze))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=G;const X=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function se(W){return X.test(W)}e.containsRTL=se;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(W){return pe.test(W)}e.containsEmoji=Te;const xe=/^[\t\n\r\x20-\x7E]*$/;function Ae(W){return xe.test(W)}e.isBasicASCII=Ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=We;function x(W){for(let ie=0,ce=W.length;ie<ce;ie++)if(q(W.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=x;function q(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=q;function ne(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ne;function le(W,ie){if(W.length<ie)return W;const ce=/\b/g;let j=0;for(;ce.test(W)&&!(W.length-ce.lastIndex<ie);)j=ce.lastIndex,ce.lastIndex+=1;return W.substring(j).replace(/^\s/,"")}e.lcut=le;const me=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function ge(W){return W&&(W=W.replace(me,""),W=W.replace(Se,""),W=W.replace(Oe,"")),W}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(W){return Ce(W)?W.substr(1):W}e.stripUTF8BOM=Pe;function $e(W,ie){if(!W||!ie||W.length<ie.length)return!1;const ce=ie.length,j=W.toLowerCase();let Z=0,ae=-1;for(;Z<ce;){const he=j.indexOf(ie[Z],ae+1);if(he<0)return!1;ae=he,Z++}return!0}e.fuzzyContains=$e;function Ee(W,ie=!1){return W?(ie&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ee;function je(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=je;function H(W,ie=1){if(ie===0)return"";let ce=-1;do ce=W.indexOf(`
`,ce+1),ie--;while(ie>0&&ce>=0);return ce===-1?W:(W[ce-1]==="\r"&&ce--,W.substr(0,ce))}e.getNLines=H;function te(W){const ie=90-65+1;return W=W%(2*ie),W<ie?String.fromCharCode(97+W):String.fromCharCode(65+W-ie)}e.singleLetterHash=te;function ve(W){return Ue.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ve;function Le(W,ie){return W===0?ie!==5&&ie!==7:W===2&&ie===3?!1:W===4||W===2||W===3||ie===4||ie===2||ie===3?!0:!(W===8&&(ie===8||ie===9||ie===11||ie===12)||(W===11||W===9)&&(ie===9||ie===10)||(W===12||W===10)&&ie===10||ie===5||ie===13||ie===7||W===1||W===13&&ie===14||W===6&&ie===6)}e.breakBetweenGraphemeBreakType=Le;var He;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Xe()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ce=this._data,j=ce.length/3;let Z=1;for(;Z<=j;)if(ie<ce[3*Z])Z=2*Z;else if(ie>ce[3*Z+1])Z=2*Z+1;else return ce[3*Z+2];return 0}}Ue._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(be[23],_e([0,1,8,109]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let C,D;class k{constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}static alloc(w){return A?new k(Buffer.allocUnsafe(w)):new k(new Uint8Array(w))}static wrap(w){return A&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new k(w)}static fromString(w,_){return!((_==null?void 0:_.dontUseNodeBuffer)||!1)&&A?new k(Buffer.from(w)):T?(C||(C=new TextEncoder),new k(C.encode(w))):new k(b.encodeUTF8(w))}static concat(w,_){if(typeof _=="undefined"){_=0;for(let F=0,B=w.length;F<B;F++)_+=w[F].byteLength}const v=k.alloc(_);let E=0;for(let F=0,B=w.length;F<B;F++){const Y=w[F];v.set(Y,E),E+=Y.byteLength}return v}toString(){return A?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(w,_){return new k(this.buffer.subarray(w,_))}set(w,_){w instanceof k?this.buffer.set(w.buffer,_):this.buffer.set(w,_)}readUInt32BE(w){return d(this.buffer,w)}writeUInt32BE(w,_){h(this.buffer,w,_)}readUInt32LE(w){return r(this.buffer,w)}writeUInt32LE(w,_){l(this.buffer,w,_)}readUInt8(w){return g(this.buffer,w)}writeUInt8(w,_){m(this.buffer,w,_)}}e.VSBuffer=k;function n(u,w){return u[w+0]<<0>>>0|u[w+1]<<8>>>0}e.readUInt16LE=n;function P(u,w,_){u[_+0]=w&255,w=w>>>8,u[_+1]=w&255}e.writeUInt16LE=P;function d(u,w){return u[w]*2**24+u[w+1]*2**16+u[w+2]*2**8+u[w+3]}e.readUInt32BE=d;function h(u,w,_){u[_+3]=w,w=w>>>8,u[_+2]=w,w=w>>>8,u[_+1]=w,w=w>>>8,u[_]=w}e.writeUInt32BE=h;function r(u,w){return u[w+0]<<0>>>0|u[w+1]<<8>>>0|u[w+2]<<16>>>0|u[w+3]<<24>>>0}e.readUInt32LE=r;function l(u,w,_){u[_+0]=w&255,w=w>>>8,u[_+1]=w&255,w=w>>>8,u[_+2]=w&255,w=w>>>8,u[_+3]=w&255}e.writeUInt32LE=l;function g(u,w){return u[w]}e.readUInt8=g;function m(u,w,_){u[_]=w}e.writeUInt8=m;function S(u){return I.consumeReadable(u,w=>k.concat(w))}e.readableToBuffer=S;function f(u){return I.toReadable(u)}e.bufferToReadable=f;function c(u){return I.consumeStream(u,w=>k.concat(w))}e.streamToBuffer=c;async function p(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await c(u.stream)])}e.bufferedStreamToBuffer=p;function t(u){return I.toStream(u,w=>k.concat(w))}e.bufferToStream=t;function i(u){return I.transform(u,{data:w=>typeof w=="string"?k.fromString(w):k.wrap(w)},w=>k.concat(w))}e.streamToBufferReadableStream=i;function o(u){return I.newWriteableStream(w=>k.concat(w),u)}e.newWriteableBufferStream=o;function a(u,w){return I.prefixedReadable(u,w,_=>k.concat(_))}e.prefixedBufferReadable=a;function s(u,w){return I.prefixedStream(u,w,_=>k.concat(_))}e.prefixedBufferStream=s}),define(be[56],_e([0,1,8]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(m){return A(m,0)}e.hash=I;function A(m,S){switch(typeof m){case"object":return m===null?T(349,S):Array.isArray(m)?D(m,S):k(m,S);case"string":return C(m,S);case"boolean":return y(m,S);case"number":return T(m,S);case"undefined":return T(937,S);default:return T(617,S)}}e.doHash=A;function T(m,S){return(S<<5)-S+m|0}function y(m,S){return T(m?433:863,S)}function C(m,S){S=T(149417,S);for(let f=0,c=m.length;f<c;f++)S=T(m.charCodeAt(f),S);return S}e.stringHash=C;function D(m,S){return S=T(104579,S),m.reduce((f,c)=>A(c,f),S)}function k(m,S){return S=T(181387,S),Object.keys(m).sort().reduce((f,c)=>(f=C(c,f),A(m[c],f)),S)}class n{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=A(S,this._value),this._value}}e.Hasher=n;var P;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function d(m,S,f=32){const c=f-S,p=~((1<<c)-1);return(m<<S|(p&m)>>>c)>>>0}function h(m,S=0,f=m.byteLength,c=0){for(let p=0;p<f;p++)m[S+p]=c}function r(m,S,f="0"){for(;m.length<S;)m=f+m;return m}function l(m,S=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),S/4)}e.toHexString=l;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const f=S.length;if(f!==0){const c=this._buff;let p=this._buffLen,t=this._leftoverHighSurrogate,i,o;for(t!==0?(i=t,o=-1,t=0):(i=S.charCodeAt(0),o=0);;){let a=i;if(b.isHighSurrogate(i))if(o+1<f){const s=S.charCodeAt(o+1);b.isLowSurrogate(s)?(o++,a=b.computeCodePoint(i,s)):a=65533}else{t=i;break}else b.isLowSurrogate(i)&&(a=65533);if(p=this._push(c,p,a),o++,o<f)i=S.charCodeAt(o);else break}this._buffLen=p,this._leftoverHighSurrogate=t}}_push(S,f,c){return c<128?S[f++]=c:c<2048?(S[f++]=192|(c&1984)>>>6,S[f++]=128|(c&63)>>>0):c<65536?(S[f++]=224|(c&61440)>>>12,S[f++]=128|(c&4032)>>>6,S[f++]=128|(c&63)>>>0):(S[f++]=240|(c&1835008)>>>18,S[f++]=128|(c&258048)>>>12,S[f++]=128|(c&4032)>>>6,S[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=g._bigBlock32,f=this._buffDV;for(let w=0;w<64;w+=4)S.setUint32(w,f.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)S.setUint32(w,d(S.getUint32(w-12,!1)^S.getUint32(w-32,!1)^S.getUint32(w-56,!1)^S.getUint32(w-64,!1),1),!1);let c=this._h0,p=this._h1,t=this._h2,i=this._h3,o=this._h4,a,s,u;for(let w=0;w<80;w++)w<20?(a=p&t|~p&i,s=1518500249):w<40?(a=p^t^i,s=1859775393):w<60?(a=p&t|p&i|t&i,s=2400959708):(a=p^t^i,s=3395469782),u=d(c,5)+a+o+s+S.getUint32(w*4,!1)&4294967295,o=i,i=t,t=d(p,30),p=c,c=u;this._h0=this._h0+c&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],_e([0,1,8]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(I||(I={})),function(A){const T="error",y="warning",C="warn",D="info",k="ignore";function n(d){return d?b.equalsIgnoreCase(T,d)?A.Error:b.equalsIgnoreCase(y,d)||b.equalsIgnoreCase(C,d)?A.Warning:b.equalsIgnoreCase(D,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=n;function P(d){switch(d){case A.Error:return T;case A.Warning:return y;case A.Info:return D;default:return k}}A.toString=P}(I||(I={})),e.default=I}),define(be[10],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(w){return Array.isArray(w)}e.isArray=b;function I(w){return typeof w=="string"}e.isString=I;function A(w){return Array.isArray(w)&&w.every(_=>I(_))}e.isStringArray=A;function T(w){return typeof w=="object"&&w!==null&&!Array.isArray(w)&&!(w instanceof RegExp)&&!(w instanceof Date)}e.isObject=T;function y(w){return typeof w=="number"&&!isNaN(w)}e.isNumber=y;function C(w){return!!w&&typeof w[Symbol.iterator]=="function"}e.isIterable=C;function D(w){return w===!0||w===!1}e.isBoolean=D;function k(w){return typeof w=="undefined"}e.isUndefined=k;function n(w){return!P(w)}e.isDefined=n;function P(w){return k(w)||w===null}e.isUndefinedOrNull=P;function d(w,_){if(!w)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=d;function h(w){if(P(w))throw new Error("Assertion Failed: argument is undefined or null");return w}e.assertIsDefined=h;function r(...w){const _=[];for(let v=0;v<w.length;v++){const E=w[v];if(P(E))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);_.push(E)}return _}e.assertAllDefined=r;const l=Object.prototype.hasOwnProperty;function g(w){if(!T(w))return!1;for(let _ in w)if(l.call(w,_))return!1;return!0}e.isEmptyObject=g;function m(w){return typeof w=="function"}e.isFunction=m;function S(...w){return w.length>0&&w.every(m)}e.areFunctions=S;function f(w,_){const v=Math.min(w.length,_.length);for(let E=0;E<v;E++)c(w[E],_[E])}e.validateConstraints=f;function c(w,_){if(I(_)){if(typeof w!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(m(_)){try{if(w instanceof _)return}catch(v){}if(!P(w)&&w.constructor===_||_.length===1&&_.call(void 0,w)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function p(w){let _=[],v=Object.getPrototypeOf(w);for(;Object.prototype!==v;)_=_.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return _}e.getAllPropertyNames=p;function t(w){const _=[];for(const v of p(w))typeof w[v]=="function"&&_.push(v);return _}e.getAllMethodNames=t;function i(w,_){const v=F=>function(){const B=Array.prototype.slice.call(arguments,0);return _(F,B)};let E={};for(const F of w)E[F]=v(F);return E}e.createProxyObject=i;function o(w){return w===null?void 0:w}e.withNullAsUndefined=o;function a(w){return typeof w=="undefined"?null:w}e.withUndefinedAsNull=a;function s(w){return class{constructor(){return new Proxy({},{get(_,v){if(_[v])return _[v];throw new Error(`Not Implemented: ${w}->${String(v)}`)}})}}}e.NotImplementedProxy=s;function u(w){throw new Error("Unreachable")}e.assertNever=u}),define(be[37],_e([0,1,21,8,13,10]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(i){return i===47||i===92}e.isPathSeparator=y;function C(i){return i.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=C;function D(i,o=A.posix.sep){if(!i)return"";const a=i.length,s=i.charCodeAt(0);if(y(s)){if(y(i.charCodeAt(1))&&!y(i.charCodeAt(2))){let w=3;const _=w;for(;w<a&&!y(i.charCodeAt(w));w++);if(_!==w&&!y(i.charCodeAt(w+1))){for(w+=1;w<a;w++)if(y(i.charCodeAt(w)))return i.slice(0,w+1).replace(/[\\/]/g,o)}}return o}else if(g(s)&&i.charCodeAt(1)===58)return y(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(y(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=D;function k(i){if(!b.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let a=2;const s=a;for(;a<i.length&&(o=i.charCodeAt(a),o!==92);a++);return!(s===a||(o=i.charCodeAt(a+1),isNaN(o)||o===92))}e.isUNC=k;const n=/[\\/:\*\?"<>\|]/g,P=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,o=b.isWindows){const a=o?n:P;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||o&&d.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function r(i,o,a){const s=i===o;return!a||s?s:!i||!o?!1:(0,I.equalsIgnoreCase)(i,o)}e.isEqual=r;function l(i,o,a,s=A.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(a){if(!(0,I.startsWithIgnoreCase)(i,o))return!1;if(o.length===i.length)return!0;let w=o.length;return o.charAt(o.length-1)===s&&w--,i.charAt(w)===s}return o.charAt(o.length-1)!==s&&(o+=s),i.indexOf(o)===0}e.isEqualOrParent=l;function g(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=g;function m(i,o){return b.isWindows&&i.endsWith(":")&&(i+=A.sep),(0,A.isAbsolute)(i)||(i=(0,A.join)(o,i)),i=(0,A.normalize)(i),b.isWindows?(i=(0,I.rtrim)(i,A.sep),i.endsWith(":")&&(i+=A.sep)):(i=(0,I.rtrim)(i,A.sep),i||(i=A.sep)),i}e.sanitizeFilePath=m;function S(i){const o=(0,A.normalize)(i);return b.isWindows?i.length>3?!1:f(o)&&(i.length===2||o.charCodeAt(2)===92):o===A.posix.sep}e.isRootOrDriveLetter=S;function f(i){return b.isWindows?g(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function c(i){return f(i)?i[0]:void 0}e.getDriveLetter=c;function p(i,o,a){return o.length>i.length?-1:i===o?0:(a&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=p;function t(i){const o=i.split(":");let a,s,u;if(o.forEach(w=>{const _=Number(w);(0,T.isNumber)(_)?s===void 0?s=_:u===void 0&&(u=_):a=a?[a,w].join(":"):w}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:s!==void 0?s:void 0,column:u!==void 0?u:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(be[24],_e([0,1,10]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const l=Array.isArray(r)?[]:{};return Object.keys(r).forEach(g=>{r[g]&&typeof r[g]=="object"?l[g]=I(r[g]):l[g]=r[g]}),l}e.deepClone=I;function A(r){if(!r||typeof r!="object")return r;const l=[r];for(;l.length>0;){const g=l.shift();Object.freeze(g);for(const m in g)if(T.call(g,m)){const S=g[m];typeof S=="object"&&!Object.isFrozen(S)&&l.push(S)}}return r}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function y(r,l){return C(r,l,new Set)}e.cloneAndChange=y;function C(r,l,g){if((0,b.isUndefinedOrNull)(r))return r;const m=l(r);if(typeof m!="undefined")return m;if((0,b.isArray)(r)){const S=[];for(const f of r)S.push(C(f,l,g));return S}if((0,b.isObject)(r)){if(g.has(r))throw new Error("Cannot clone recursive data-structure");g.add(r);const S={};for(let f in r)T.call(r,f)&&(S[f]=C(r[f],l,g));return g.delete(r),S}return r}function D(r,l,g=!0){return(0,b.isObject)(r)?((0,b.isObject)(l)&&Object.keys(l).forEach(m=>{m in r?g&&((0,b.isObject)(r[m])&&(0,b.isObject)(l[m])?D(r[m],l[m],g):r[m]=l[m]):r[m]=l[m]}),r):l}e.mixin=D;function k(r,l){if(r===l)return!0;if(r==null||l===null||l===void 0||typeof r!=typeof l||typeof r!="object"||Array.isArray(r)!==Array.isArray(l))return!1;let g,m;if(Array.isArray(r)){if(r.length!==l.length)return!1;for(g=0;g<r.length;g++)if(!k(r[g],l[g]))return!1}else{const S=[];for(m in r)S.push(m);S.sort();const f=[];for(m in l)f.push(m);if(f.sort(),!k(S,f))return!1;for(g=0;g<S.length;g++)if(!k(r[S[g]],l[S[g]]))return!1}return!0}e.equals=k;function n(r){const l=new Set;return JSON.stringify(r,(g,m)=>{if((0,b.isObject)(m)||Array.isArray(m)){if(l.has(m))return"[Circular]";l.add(m)}return m})}e.safeStringify=n;function P(r,l,g){const m=l(r);return typeof m=="undefined"?g:m}e.getOrDefault=P;function d(r,l){const g=Object.create(null);return!r||!l||Object.keys(l).forEach(S=>{const f=r[S],c=l[S];k(f,c)||(g[S]=c)}),g}e.distinct=d;function h(r,l){const g=l.toLowerCase(),m=Object.keys(r).find(S=>S.toLowerCase()===g);return m?r[m]:r[l]}e.getCaseInsensitive=h}),define(be[82],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function I(T){return T<0?0:T>255?255:T|0}e.toUint8=I;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(be[2],_e([0,1,21,13]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function C(o,a){if(!o.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!A.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!T.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(o,a){return!o&&!a?"file":o}function k(o,a){switch(o){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const n="",P="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(a,s,u,w,_,v=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=D(a,v),this.authority=s||n,this.path=k(this.scheme,u||n),this.query=w||n,this.fragment=_||n,C(this,v))}static isUri(a){return a instanceof h?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return f(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:u,path:w,query:_,fragment:v}=a;return s===void 0?s=this.scheme:s===null&&(s=n),u===void 0?u=this.authority:u===null&&(u=n),w===void 0?w=this.path:w===null&&(w=n),_===void 0?_=this.query:_===null&&(_=n),v===void 0?v=this.fragment:v===null&&(v=n),s===this.scheme&&u===this.authority&&w===this.path&&_===this.query&&v===this.fragment?this:new l(s,u,w,_,v)}static parse(a,s=!1){const u=d.exec(a);return u?new l(u[2]||n,i(u[4]||n),i(u[5]||n),i(u[7]||n),i(u[9]||n),s):new l(n,n,n,n,n)}static file(a){let s=n;if(b.isWindows&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const u=a.indexOf(P,2);u===-1?(s=a.substring(2),a=P):(s=a.substring(2,u),a=a.substring(u)||P)}return new l("file",s,a,n,n)}static from(a){return new l(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return b.isWindows&&a.scheme==="file"?u=h.file(I.win32.join(f(a,!0),...s)).path:u=I.posix.join(a.path,...s),a.with({path:u})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof h)return a;{const s=new l(a);return s._formatted=a.external,s._fsPath=a._sep===r?a.fsPath:null,s}}else return a}}e.URI=h;const r=b.isWindows?1:void 0;class l extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=r),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(o,a){let s,u=-1;for(let w=0;w<o.length;w++){const _=o.charCodeAt(w);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||a&&_===47)u!==-1&&(s+=encodeURIComponent(o.substring(u,w)),u=-1),s!==void 0&&(s+=o.charAt(w));else{s===void 0&&(s=o.substr(0,w));const v=g[_];v!==void 0?(u!==-1&&(s+=encodeURIComponent(o.substring(u,w)),u=-1),s+=v):u===-1&&(u=w)}}return u!==-1&&(s+=encodeURIComponent(o.substring(u))),s!==void 0?s:o}function S(o){let a;for(let s=0;s<o.length;s++){const u=o.charCodeAt(s);u===35||u===63?(a===void 0&&(a=o.substr(0,s)),a+=g[u]):a!==void 0&&(a+=o[s])}return a!==void 0?a:o}function f(o,a){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?a?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,b.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function c(o,a){const s=a?S:m;let u="",{scheme:w,authority:_,path:v,query:E,fragment:F}=o;if(w&&(u+=w,u+=":"),(_||w==="file")&&(u+=P,u+=P),_){let B=_.indexOf("@");if(B!==-1){const Y=_.substr(0,B);_=_.substr(B+1),B=Y.indexOf(":"),B===-1?u+=s(Y,!1):(u+=s(Y.substr(0,B),!1),u+=":",u+=s(Y.substr(B+1),!1)),u+="@"}_=_.toLowerCase(),B=_.indexOf(":"),B===-1?u+=s(_,!1):(u+=s(_.substr(0,B),!1),u+=_.substr(B))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const B=v.charCodeAt(1);B>=65&&B<=90&&(v=`/${String.fromCharCode(B+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const B=v.charCodeAt(0);B>=65&&B<=90&&(v=`${String.fromCharCode(B+32)}:${v.substr(2)}`)}u+=s(v,!0)}return E&&(u+="?",u+=s(E,!1)),F&&(u+="#",u+=a?F:m(F,!1)),u}function p(o){try{return decodeURIComponent(o)}catch(a){return o.length>3?o.substr(0,3)+p(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(o){return o.match(t)?o.replace(t,a=>p(a)):o}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[22],_e([0,1,2,8]),function(Q,e,b,I){"use strict";var A,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.HashSet=e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(i,o,a){let s=i.get(o);return s===void 0&&(s=a,i.set(o,s)),s}e.getOrSet=C;function D(i){const o=[];return i.forEach((a,s)=>{o.push(`${s} => ${a}`)}),`Map(${i.size}) {${o.join(", ")}}`}e.mapToString=D;function k(i){const o=[];return i.forEach(a=>{o.push(a)}),`Set(${i.size}) {${o.join(", ")}}`}e.setToString=k;class n{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const a=o.charCodeAt(0),s=this._value.charCodeAt(this._pos);return a-s}value(){return this._value[this._pos]}}e.StringIterator=n;class P{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,I.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class d{constructor(o=!0,a=!0){this._splitOnBackslash=o,this._caseSensitive=a}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,I.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var h;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(h||(h={}));class r{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,I.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(o){this._iter=o}static forUris(o=()=>!1){return new g(new r(o))}static forPaths(){return new g(new d)}static forStrings(){return new g(new n)}static forConfigKeys(){return new g(new P)}clear(){this._root=void 0}set(o,a){const s=this._iter.reset(o);let u;for(this._root||(this._root=new l,this._root.segment=s.value()),u=this._root;;){const _=s.cmp(u.segment);if(_>0)u.left||(u.left=new l,u.left.segment=s.value()),u=u.left;else if(_<0)u.right||(u.right=new l,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new l,u.mid.segment=s.value()),u=u.mid;else break}const w=u.value;return u.value=a,u.key=o,w}get(o){var a;return(a=this._getNode(o))===null||a===void 0?void 0:a.value}_getNode(o){const a=this._iter.reset(o);let s=this._root;for(;s;){const u=a.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else break}return s}has(o){const a=this._getNode(o);return!((a==null?void 0:a.value)===void 0&&(a==null?void 0:a.mid)===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,a){const s=this._iter.reset(o),u=[];let w=this._root;for(;w;){const _=s.cmp(w.segment);if(_>0)u.push([1,w]),w=w.left;else if(_<0)u.push([-1,w]),w=w.right;else if(s.hasNext())s.next(),u.push([0,w]),w=w.mid;else{for(a?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;u.length>0&&w.isEmpty();){let[v,E]=u.pop();switch(v){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}w=E}break}}}findSubstr(o){const a=this._iter.reset(o);let s=this._root,u;for(;s;){const w=a.cmp(s.segment);if(w>0)s=s.left;else if(w<0)s=s.right;else if(a.hasNext())a.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(o){const a=this._iter.reset(o);let s=this._root;for(;s;){const u=a.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(o){for(const[a,s]of this)o(s,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){o&&(yield*this._entries(o.left),o.value&&(yield[o.key,o.value]),yield*this._entries(o.mid),yield*this._entries(o.right))}}e.TernarySearchTree=g;class m{constructor(o,a){this[A]="ResourceMap",o instanceof m?(this.map=new Map(o.map),this.toKey=a!=null?a:m.defaultToKey):(this.map=new Map,this.toKey=o!=null?o:m.defaultToKey)}set(o,a){return this.map.set(this.toKey(o),a),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,a){typeof a!="undefined"&&(o=o.bind(a));for(let[s,u]of this.map)o(u,b.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield b.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[b.URI.parse(o[0]),o[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[b.URI.parse(o[0]),o[1]]}}e.ResourceMap=m,m.defaultToKey=i=>i.toString();var S;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class f{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var o;return(o=this._head)===null||o===void 0?void 0:o.value}get last(){var o;return(o=this._tail)===null||o===void 0?void 0:o.value}has(o){return this._map.has(o)}get(o,a=0){const s=this._map.get(o);if(!!s)return a!==0&&this.touch(s,a),s.value}set(o,a,s=0){let u=this._map.get(o);if(u)u.value=a,s!==0&&this.touch(u,s);else{switch(u={key:o,value:a,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(o,u),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const a=this._map.get(o);if(!!a)return this._map.delete(o),this.removeItem(a),this._size--,a.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}}forEach(o,a){const s=this._state;let u=this._head;for(;u;){if(a?o.bind(a)(u.value,u.key,this):o(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const o=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.key,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}values(){const o=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:s.value,done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}entries(){const o=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const w={value:[s.key,s.value],done:!1};return s=s.next,w}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(!(o>=this.size)){if(o===0){this.clear();return}let a=this._head,s=this.size;for(;a&&s>o;)this._map.delete(a.key),a=a.next,s--;this._head=a,this._size=s,a&&(a.previous=void 0),this._state++}}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const a=o.next,s=o.previous;if(!a||!s)throw new Error("Invalid list");a.previous=s,s.next=a}o.next=void 0,o.previous=void 0,this._state++}touch(o,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(o===this._head)return;const s=o.next,u=o.previous;o===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(a===2){if(o===this._tail)return;const s=o.next,u=o.previous;o===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((a,s)=>{o.push([s,a])}),o}fromJSON(o){this.clear();for(const[a,s]of o)this.set(a,s)}}e.LinkedMap=f;class c extends f{constructor(o,a=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,a=2){return super.get(o,a)}peek(o){return super.get(o,0)}set(o,a){return super.set(o,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c;class p{constructor(o){y.set(this,void 0),tt(this,y,o,"f")}get size(){return Me(this,y,"f").size}forEach(o,a){Me(this,y,"f").forEach(o,a)}get(o){return Me(this,y,"f").get(o)}has(o){return Me(this,y,"f").has(o)}entries(){return Me(this,y,"f").entries()}keys(){return Me(this,y,"f").keys()}values(){return Me(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Me(this,y,"f").entries()}}e.ReadonlyMapView=p;class t{constructor(o,a){this.hash=a,this.map=new Map;for(const s of o)this.add(s)}get size(){return this.map.size}add(o){this.map.set(this.hash(o),o)}delete(o){return this.map.delete(this.hash(o))}clear(){this.map.clear()}has(o){return this.map.has(this.hash(o))}get(o){return this.map.get(this.hash(o))}}e.HashSet=t}),define(be[110],_e([0,1,22,8]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...ge){return function(Ce,Pe){for(let $e=0,Ee=ge.length;$e<Ee;$e++){const je=ge[$e](Ce,Pe);if(je)return je}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let $e;return ge?$e=I.startsWithIgnoreCase(Pe,Ce):$e=Pe.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(ge,Ce){const Pe=Ce.toLowerCase().indexOf(ge.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ge.length}]}e.matchesContiguousSubString=y;function C(ge,Ce){return D(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function D(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]===Ce[$e]){let Ee=null;return(Ee=D(ge,Ce,Pe+1,$e+1))?m({start:$e,end:$e+1},Ee):null}return D(ge,Ce,Pe,$e+1)}function k(ge){return 97<=ge&&ge<=122}function n(ge){return 65<=ge&&ge<=90}e.isUpper=n;function P(ge){return 48<=ge&&ge<=57}function d(ge){return ge===32||ge===9||ge===10||ge===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>h.add(ge.charCodeAt(0)));function r(ge){return d(ge)||h.has(ge)}function l(ge,Ce){return ge===Ce||r(ge)&&r(Ce)}function g(ge){return k(ge)||n(ge)||P(ge)}function m(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function S(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++){const $e=ge.charCodeAt(Pe);if(n($e)||P($e)||Pe>0&&!g(ge.charCodeAt(Pe-1)))return Pe}return ge.length}function f(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]!==Ce[$e].toLowerCase())return null;{let Ee=null,je=$e+1;for(Ee=f(ge,Ce,Pe+1,$e+1);!Ee&&(je=S(Ce,je))<Ce.length;)Ee=f(ge,Ce,Pe+1,je),je++;return Ee===null?null:m({start:$e,end:$e+1},Ee)}}function c(ge){let Ce=0,Pe=0,$e=0,Ee=0,je=0;for(let He=0;He<ge.length;He++)je=ge.charCodeAt(He),n(je)&&Ce++,k(je)&&Pe++,g(je)&&$e++,P(je)&&Ee++;const H=Ce/ge.length,te=Pe/ge.length,ve=$e/ge.length,Le=Ee/ge.length;return{upperPercent:H,lowerPercent:te,alphaPercent:ve,numericPercent:Le}}function p(ge){const{upperPercent:Ce,lowerPercent:Pe}=ge;return Pe===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:$e,numericPercent:Ee}=ge;return Pe>.2&&Ce<.8&&$e>.6&&Ee<.2}function i(ge){let Ce=0,Pe=0,$e=0,Ee=0;for(let je=0;je<ge.length;je++)$e=ge.charCodeAt(je),n($e)&&Ce++,k($e)&&Pe++,d($e)&&Ee++;return(Ce===0||Pe===0)&&Ee===0?ge.length<=30:Ce<=5}function o(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!i(ge)||Ce.length>60)return null;const Pe=c(Ce);if(!t(Pe)){if(!p(Pe))return null;Ce=Ce.toLowerCase()}let $e=null,Ee=0;for(ge=ge.toLowerCase();Ee<Ce.length&&($e=f(ge,Ce,0,Ee))===null;)Ee=S(Ce,Ee+1);return $e}e.matchesCamelCase=o;function a(ge,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let $e=null,Ee=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();Ee<Ce.length&&($e=s(ge,Ce,0,Ee,Pe))===null;)Ee=u(Ce,Ee+1);return $e}e.matchesWords=a;function s(ge,Ce,Pe,$e,Ee){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(l(ge.charCodeAt(Pe),Ce.charCodeAt($e))){let je=null,H=$e+1;if(je=s(ge,Ce,Pe+1,$e+1,Ee),!Ee)for(;!je&&(H=u(Ce,H))<Ce.length;)je=s(ge,Ce,Pe+1,H,Ee),H++;return je===null?null:m({start:$e,end:$e+1},je)}else return null}function u(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++)if(r(ge.charCodeAt(Pe))||Pe>0&&r(ge.charCodeAt(Pe-1)))return Pe;return ge.length}const w=A(e.matchesPrefix,o,y),_=A(e.matchesPrefix,o,C),v=new b.LRUCache(1e4);function E(ge,Ce,Pe=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let $e=v.get(ge);$e||($e=new RegExp(I.convertSimple2RegExpPattern(ge),"i"),v.set(ge,$e));const Ee=$e.exec(Ce);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Pe?_(ge,Ce):w(ge,Ce)}e.matchesFuzzy=E;function F(ge,Ce){const Pe=x(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?Y(Pe):null}e.matchesFuzzy2=F;function B(ge,Ce,Pe,$e,Ee,je){const H=Math.min(13,ge.length);for(;Pe<H;Pe++){const te=x(ge,Ce,Pe,$e,Ee,je,!1);if(te)return te}return[0,je]}e.anyScore=B;function Y(ge){if(typeof ge=="undefined")return[];const Ce=[],Pe=ge[1];for(let $e=ge.length-1;$e>1;$e--){const Ee=ge[$e]+Pe,je=Ce[Ce.length-1];je&&je.end===Ee?je.end=Ee+1:Ce.push({start:Ee,end:Ee+1})}return Ce}e.createMatches=Y;const fe=128;function V(){const ge=[],Ce=[];for(let Pe=0;Pe<=fe;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=fe;Pe++)ge.push(Ce.slice(0));return ge}function z(ge){const Ce=[];for(let Pe=0;Pe<=ge;Pe++)Ce[Pe]=0;return Ce}const ee=z(2*fe),$=z(2*fe),R=V(),L=V(),M=V(),U=!1;function G(ge,Ce,Pe,$e,Ee){function je(te,ve,Le=" "){for(;te.length<ve;)te=Le+te;return te}let H=` |   |${$e.split("").map(te=>je(te,3)).join("|")}
`;for(let te=0;te<=Pe;te++)te===0?H+=" |":H+=`${Ce[te-1]}|`,H+=ge[te].slice(0,Ee+1).map(ve=>je(ve.toString(),3)).join("|")+`
`;return H}function X(ge,Ce,Pe,$e){ge=ge.substr(Ce),Pe=Pe.substr($e),console.log(G(L,ge,ge.length,Pe,Pe.length)),console.log(G(M,ge,ge.length,Pe,Pe.length)),console.log(G(R,ge,ge.length,Pe,Pe.length))}function se(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Pe=ge.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Pe)}}function pe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Te(ge,Ce,Pe){return Ce[ge]!==Pe[ge]}function xe(ge,Ce,Pe,$e,Ee,je,H=!1){for(;Ce<Pe&&Ee<je;)ge[Ce]===$e[Ee]&&(H&&(ee[Ce]=Ee),Ce+=1),Ee+=1;return Ce===Pe}e.isPatternInWord=xe;var Ae;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var We;(function(ge){ge.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ge.isDefault=Ce})(We=e.FuzzyScore||(e.FuzzyScore={}));function x(ge,Ce,Pe,$e,Ee,je,H){const te=ge.length>fe?fe:ge.length,ve=$e.length>fe?fe:$e.length;if(!(Pe>=te||je>=ve||te-Pe>ve-je)&&!!xe(Ce,Pe,te,Ee,je,ve,!0)){q(te,ve,Pe,je,Ce,Ee);let Le=1,He=1,Ue=Pe,Xe=je;const W=[!1];for(Le=1,Ue=Pe;Ue<te;Le++,Ue++){const ae=ee[Ue],he=$[Ue],ye=Ue+1<te?$[Ue+1]:ve;for(He=ae-je+1,Xe=ae;Xe<ye;He++,Xe++){let ze=Number.MIN_SAFE_INTEGER,Be=!1;Xe<=he&&(ze=ne(ge,Ce,Ue,Pe,$e,Ee,Xe,ve,je,R[Le-1][He-1]===0,W));let Ne=0;ze!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ne=ze+L[Le-1][He-1]);const Ge=Xe>ae,nt=Ge?L[Le][He-1]+(R[Le][He-1]>0?-5:0):0,dt=Xe>ae+1&&R[Le][He-1]>0,it=dt?L[Le][He-2]+(R[Le][He-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!Be||it>=Ne))L[Le][He]=it,M[Le][He]=3,R[Le][He]=0;else if(Ge&&(!Be||nt>=Ne))L[Le][He]=nt,M[Le][He]=2,R[Le][He]=0;else if(Be)L[Le][He]=Ne,M[Le][He]=1,R[Le][He]=R[Le-1][He-1]+1;else throw new Error("not possible")}}if(U&&X(ge,Pe,$e,je),!(!W[0]&&!H)){Le--,He--;const ie=[L[Le][He],je];let ce=0,j=0;for(;Le>=1;){let ae=He;do{const he=M[Le][ae];if(he===3)ae=ae-2;else if(he===2)ae=ae-1;else break}while(ae>=1);ce>1&&Ce[Pe+Le-1]===Ee[je+He-1]&&!Te(ae+je-1,$e,Ee)&&ce+1>R[Le][ae]&&(ae=He),ae===He?ce++:ce=1,j||(j=ae),Le--,He=ae-1,ie.push(He)}ve===te&&(ie[0]+=2);const Z=j-te;return ie[0]-=Z,ie}}}e.fuzzyScore=x;function q(ge,Ce,Pe,$e,Ee,je){let H=ge-1,te=Ce-1;for(;H>=Pe&&te>=$e;)Ee[H]===je[te]&&($[H]=te,H--),te--}function ne(ge,Ce,Pe,$e,Ee,je,H,te,ve,Le,He){if(Ce[Pe]!==je[H])return Number.MIN_SAFE_INTEGER;let Ue=1,Xe=!1;return H===Pe-$e?Ue=ge[Pe]===Ee[H]?7:5:Te(H,Ee,je)&&(H===0||!Te(H-1,Ee,je))?(Ue=ge[Pe]===Ee[H]?7:5,Xe=!0):se(je,H)&&(H===0||!se(je,H-1))?Ue=5:(se(je,H-1)||pe(je,H-1))&&(Ue=5,Xe=!0),Ue>1&&Pe===$e&&(He[0]=!0),Xe||(Xe=Te(H,Ee,je)||se(je,H-1)||pe(je,H-1)),Pe===$e?H>ve&&(Ue-=Xe?3:5):Le?Ue+=Xe?2:0:Ue+=Xe?0:1,H+1===te&&(Ue-=Xe?3:5),Ue}function le(ge,Ce,Pe,$e,Ee,je,H){return Se(ge,Ce,Pe,$e,Ee,je,!0,H)}e.fuzzyScoreGracefulAggressive=le;function me(ge,Ce,Pe,$e,Ee,je,H){return Se(ge,Ce,Pe,$e,Ee,je,!1,H)}e.fuzzyScoreGraceful=me;function Se(ge,Ce,Pe,$e,Ee,je,H,te){let ve=x(ge,Ce,Pe,$e,Ee,je,te);if(ve&&!H)return ve;if(ge.length>=3){const Le=Math.min(7,ge.length-1);for(let He=Pe+1;He<Le;He++){const Ue=Oe(ge,He);if(Ue){const Xe=x(Ue,Ue.toLowerCase(),Pe,$e,Ee,je,te);Xe&&(Xe[0]-=3,(!ve||Xe[0]>ve[0])&&(ve=Xe))}}}return ve}function Oe(ge,Ce){if(!(Ce+1>=ge.length)){const Pe=ge[Ce],$e=ge[Ce+1];if(Pe!==$e)return ge.slice(0,Ce)+$e+Pe+ge.slice(Ce+2)}}}),define(be[111],_e([0,1,36,110,8]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function C(l){return l.replace(y,(g,m)=>m?g:`\\${g}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${T.source}`,"g");function k(l){return l.replace(D,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=k;const n=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function P(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(n,(g,m,S,f)=>S?g:m||f||"")}e.stripIcons=P;function d(l){const g=l.indexOf(e.iconStartMarker);return g===-1?{text:l}:h(l,g)}e.parseLabelWithIcons=d;function h(l,g){const m=[];let S="";function f(u){if(u){S+=u;for(const w of u)m.push(t)}}let c=-1,p="",t=0,i,o,a=g;const s=l.length;for(f(l.substr(0,g));a<s;)i=l[a],o=l[a+1],i===e.iconStartMarker[0]&&o===e.iconStartMarker[1]?(c=a,f(p),p=e.iconStartMarker,a++):i===")"&&c!==-1?(t+=a-c+1,c=-1,p=""):c!==-1?/^[a-z0-9\-]$/i.test(i)?p+=i:(f(p),c=-1,p=""):f(i),a++;return f(p),{text:S,iconOffsets:m}}function r(l,g,m=!1){const{text:S,iconOffsets:f}=g;if(!f||f.length===0)return(0,I.matchesFuzzy)(l,S,m);const c=(0,A.ltrim)(S," "),p=S.length-c.length,t=(0,I.matchesFuzzy)(l,c,m);if(t)for(const i of t){const o=f[i.start+p]+p;i.start+=o,i.end+=o}return t}e.matchesFuzzyIconAware=r}),define(be[83],_e([0,1,15,111,12]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(l="",g=!1){var m,S;if(this.value=l,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1):(this.isTrusted=(m=g.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(S=g.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(l,g=0){return this.value+=P(this.supportThemeIcons?(0,I.escapeIcons)(l):l).replace(/([ \t]+)/g,(m,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,g){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}}e.MarkdownString=y;function C(r){return D(r)?!r.value:Array.isArray(r)?r.every(C):!0}e.isEmptyMarkdownString=C;function D(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(r,l){return!r&&!l?!0:!r||!l?!1:Array.isArray(r)&&Array.isArray(l)?(0,b.equals)(r,l,n):D(r)&&D(l)?n(r,l):!1}e.markedStringsEquals=k;function n(r,l){return r===l?!0:!r||!l?!1:r.value===l.value&&r.isTrusted===l.isTrusted&&r.supportThemeIcons===l.supportThemeIcons}function P(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function h(r){const l=[],g=r.split("|").map(S=>S.trim());r=g[0];const m=g[1];if(m){const S=/height=(\d+)/.exec(m),f=/width=(\d+)/.exec(m),c=S?S[1]:"",p=f?f[1]:"",t=isFinite(parseInt(p)),i=isFinite(parseInt(c));t&&l.push(`width="${p}"`),i&&l.push(`height="${c}"`)}return{href:r,dimensions:l}}e.parseHrefAndDimensions=h}),define(be[57],_e([0,1,23,8,2]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,C)}e.stringify=T;function y(k){let n=JSON.parse(k);return n=D(n),n}e.parse=y;function C(k,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,I.regExpFlags)(n)}:n}function D(k,n=0){if(!k||n>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return A.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof b.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=D(k[P],n+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=D(k[P],n+1))}return k}e.revive=D}),define(be[19],_e([0,1,2,21]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,n){this._hosts[D]=k,this._ports[D]=n}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let n=this._hosts[k];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const P=this._ports[k],d=this._connectionTokens[k];let h=`path=${encodeURIComponent(D.path)}`;return typeof d=="string"&&(h+=`&tkn=${encodeURIComponent(d)}`),b.URI.from({scheme:I.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${n}:${P}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,n){const P=this.toUri(D,k);return P.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(P):I.isNative&&(n||I.isPreferringBrowserCodeLoad)&&P.scheme===A.file?P.with({scheme:A.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,k){const n=this.toUri(D,k);return n.scheme===A.vscodeFileResource?n.with({scheme:A.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(D,k){return b.URI.isUri(D)?D:b.URI.parse(k.toUrl(D))}}e.FileAccess=new y}),define(be[25],_e([0,1,37,13,2,8,19,21]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,A.uriToFsPath)(h,!0)}e.originalFSPath=D;class k{constructor(r){this._ignorePathCasing=r}compare(r,l,g=!1){return r===l?0:(0,T.compare)(this.getComparisonKey(r,g),this.getComparisonKey(l,g))}isEqual(r,l,g=!1){return r===l?!0:!r||!l?!1:this.getComparisonKey(r,g)===this.getComparisonKey(l,g)}getComparisonKey(r,l=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,l,g=!1){if(r.scheme===l.scheme){if(r.scheme===y.Schemas.file)return b.isEqualOrParent(D(r),D(l),this._ignorePathCasing(r))&&r.query===l.query&&(g||r.fragment===l.fragment);if((0,e.isEqualAuthority)(r.authority,l.authority))return b.isEqualOrParent(r.path,l.path,this._ignorePathCasing(r),"/")&&r.query===l.query&&(g||r.fragment===l.fragment)}return!1}joinPath(r,...l){return A.URI.joinPath(r,...l)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return I.posix.basename(r.path)}extname(r){return I.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let l;return r.scheme===y.Schemas.file?l=A.URI.file(I.dirname(D(r))).path:(l=I.posix.dirname(r.path),r.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),l="/")),r.with({path:l})}normalizePath(r){if(!r.path.length)return r;let l;return r.scheme===y.Schemas.file?l=A.URI.file(I.normalize(D(r))).path:l=I.posix.normalize(r.path),r.with({path:l})}relativePath(r,l){if(!(r.scheme!==l.scheme||!(0,e.isEqualAuthority)(r.authority,l.authority))){if(r.scheme===y.Schemas.file){const S=I.relative(D(r),D(l));return C.isWindows?b.toSlashes(S):S}let g=r.path||"/",m=l.path||"/";if(this._ignorePathCasing(r)){let S=0;for(const f=Math.min(g.length,m.length);S<f&&!(g.charCodeAt(S)!==m.charCodeAt(S)&&g.charAt(S).toLowerCase()!==m.charAt(S).toLowerCase());S++);g=m.substr(0,S)+g.substr(S)}return I.posix.relative(g,m)}}resolvePath(r,l){if(r.scheme===y.Schemas.file){const g=A.URI.file(I.resolve(D(r),l));return r.with({authority:g.authority,path:g.path})}return l.indexOf("/")===-1&&(l=b.toSlashes(l),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l)),r.with({path:I.posix.resolve(r.path,l)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,l){return r===l||(0,T.equalsIgnoreCase)(r,l)}hasTrailingPathSeparator(r,l=I.sep){if(r.scheme===y.Schemas.file){const g=D(r);return g.length>b.getRoot(g).length&&g[g.length-1]===l}else{const g=r.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,l=I.sep){return(0,e.hasTrailingPathSeparator)(r,l)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,l=I.sep){let g=!1;if(r.scheme===y.Schemas.file){const m=D(r);g=m!==void 0&&m.length===b.getRoot(m).length&&m[m.length-1]===l}else{l="/";const m=r.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(r,l)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(h=>h.scheme===y.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,r){const l=[];for(let g=0;g<h.length;g++){const m=r(h[g]);h.some((S,f)=>f===g?!1:(0,e.isEqualOrParent)(m,r(S)))||l.push(h[g])}return l}e.distinctParents=n;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(l){const g=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,p]=f.split(":");c&&p&&g.set(c,p)});const S=l.path.substring(0,l.path.indexOf(";"));return S&&g.set(h.META_DATA_MIME,S),g}h.parseMetaData=r})(P=e.DataUri||(e.DataUri={}));function d(h,r,l){if(r){let g=h.path;return g&&g[0]!==I.posix.sep&&(g=I.posix.sep+g),h.with({scheme:l,authority:r,path:g})}return h.with({scheme:l})}e.toLocalResource=d}),define(be[11],_e([0,1,20,12,3,6,45,25]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(L){return!!L&&typeof L.then=="function"}e.isThenable=D;function k(L){const M=new b.CancellationTokenSource,U=L(M.token),G=new Promise((X,se)=>{M.token.onCancellationRequested(()=>{se((0,I.canceled)())}),Promise.resolve(U).then(pe=>{M.dispose(),X(pe)},pe=>{M.dispose(),se(pe)})});return new class{cancel(){M.cancel()}then(X,se){return G.then(X,se)}catch(X){return this.then(void 0,X)}finally(X){return G.finally(X)}}}e.createCancelablePromise=k;function n(L,M,U){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G(U)))])}e.raceCancellation=n;async function P(L){let M=-1;const U=L.map((X,se)=>X.then(pe=>(M=se,pe))),G=await Promise.race(U);return L.forEach((X,se)=>{se!==M&&X.cancel()}),G}e.raceCancellablePromises=P;function d(L,M,U){let G;const X=setTimeout(()=>{G==null||G(void 0),U==null||U()},M);return Promise.race([L.finally(()=>clearTimeout(X)),new Promise(se=>G=se)])}e.raceTimeout=d;function h(L){return new Promise((M,U)=>{const G=L();D(G)?G.then(M,U):M(G)})}e.asPromise=h;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(U,U).then(G)})}return new Promise((U,G)=>{this.queuedPromise.then(U,G)})}return this.activePromise=M(),new Promise((U,G)=>{this.activePromise.then(X=>{this.activePromise=null,U(X)},X=>{this.activePromise=null,G(X)})})}}e.Throttler=r;class l{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=l;class g{constructor(){this.promiseMap=new Map}queue(M,U){var G;const se=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(M)===se&&this.promiseMap.delete(M)});return this.promiseMap.set(M,se),se}}e.SequencerByKey=g;class m{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,U=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,X)=>{this.doResolve=G,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class S{constructor(M){this.delayer=new m(M),this.throttler=new r}trigger(M,U){return this.delayer.trigger(()=>this.throttler.queue(M),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class f{constructor(){this._isOpen=!1,this._promise=new Promise((M,U)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class c extends f{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function p(L,M){return M?new Promise((U,G)=>{const X=setTimeout(U,L);M.onCancellationRequested(()=>{clearTimeout(X),G((0,I.canceled)())})}):k(U=>p(L,U))}e.timeout=p;function t(L,M=0){const U=setTimeout(L,M);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function i(L){return L.then(void 0,M=>{})}e.ignoreErrors=i;function o(L){const M=[];let U=0;const G=L.length;function X(){return U<G?L[U++]():null}function se(pe){pe!=null&&M.push(pe);const Te=X();return Te?Te.then(se):Promise.resolve(M)}return Promise.resolve(null).then(se)}e.sequence=o;function a(L,M=G=>!!G,U=null){let G=0;const X=L.length,se=()=>{if(G>=X)return Promise.resolve(U);const pe=L[G++];return Promise.resolve(pe()).then(xe=>M(xe)?Promise.resolve(xe):se())};return se()}e.first=a;function s(L,M=G=>!!G,U=null){if(L.length===0)return Promise.resolve(U);let G=L.length;const X=()=>{var se,pe;G=-1;for(const Te of L)(pe=(se=Te).cancel)===null||pe===void 0||pe.call(se)};return new Promise((se,pe)=>{for(const Te of L)Te.then(xe=>{--G>=0&&M(xe)?(X(),se(xe)):G===0&&se(U)}).catch(xe=>{--G>=0&&(X(),pe(xe))})})}e.firstParallel=s;class u{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((U,G)=>{this.outstandingPromises.push({factory:M,c:U,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const U=M.factory();U.then(M.c,M.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class w extends u{constructor(){super(1)}}e.Queue=w;class _{constructor(){this.queues=new Map}queueFor(M,U=C.extUri){const G=U.getComparisonKey(M);let X=this.queues.get(G);return X||(X=new w,A.Event.once(X.onFinished)(()=>{X==null||X.dispose(),this.queues.delete(G)}),this.queues.set(G,X)),X}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=_;class v{constructor(M,U){this._token=-1,typeof M=="function"&&typeof U=="number"&&this.setIfNotSet(M,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},U)}setIfNotSet(M,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},U))}}e.TimeoutTimer=v;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setInterval(()=>{M()},U)}}e.IntervalTimer=E;class F{constructor(M,U){this.timeoutToken=-1,this.runner=M,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class B extends F{constructor(M,U){super(M,U);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const U=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout(U))}}}}else e.runWhenIdle=(L,M)=>{const U=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(U))}}}}();class Y{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=Y;async function fe(L,M,U){let G;for(let X=0;X<U;X++)try{return await L()}catch(se){G=se,await p(M)}throw G}e.retry=fe;class V{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,U,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:U},U.then(()=>this.donePending(M),()=>this.donePending(M)),U}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let U,G;const X=new Promise((se,pe)=>{U=se,G=pe});this._next={run:M,promise:X,promiseResolve:U,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class z{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,U)=>{this.completeCallback=M,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(U=>{this.completeCallback(M),this.resolved=!0,U()})}error(M){return new Promise(U=>{this.errorCallback(M),this.rejected=!0,U()})}cancel(){new Promise(M=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=ee;class $ extends A.Emitter{async fireAsync(M,U,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const X of this._listeners)this._asyncDeliveryQueue.push([X,M]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[X,se]=this._asyncDeliveryQueue.shift(),pe=[],Te=Object.assign(Object.assign({},se),{waitUntil:xe=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");G&&(xe=G(xe,typeof X=="function"?X:X[0])),pe.push(xe)}});try{typeof X=="function"?X.call(void 0,Te):X[0].call(X[1],Te)}catch(xe){(0,I.onUnexpectedError)(xe);continue}Object.freeze(pe),await R.settled(pe).catch(xe=>(0,I.onUnexpectedError)(xe))}}}}e.AsyncEmitter=$;var R;(function(L){async function M(se){return typeof Promise.allSettled=="function"?U(se):G(se)}L.allSettled=M;async function U(se){return Promise.allSettled(se)}async function G(se){return Promise.all(se.map(pe=>pe.then(Te=>({status:"fulfilled",value:Te}),Te=>({status:"rejected",reason:Te}))))}async function X(se){let pe;const Te=await Promise.all(se.map(xe=>xe.then(Ae=>Ae,Ae=>{pe||(pe=Ae)})));if(typeof pe!="undefined")throw pe;return Te}L.settled=X})(R=e.Promises||(e.Promises={}))}),define(be[112],_e([0,1,13,11]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new I.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),T=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(c,p,t=!1){const i=c||"",o=p||"",a=A.value.collator.compare(i,o);return A.value.collatorIsNumeric&&a===0&&i!==o?i<o?-1:1:a}e.compareFileNames=C;function D(c,p){const t=T.value.collator;return c=c||"",p=p||"",l(t,c,p)}e.compareFileNamesDefault=D;function k(c,p,t=!1){t||(c=c&&c.toLowerCase(),p=p&&p.toLowerCase());const[i,o]=h(c),[a,s]=h(p);return i!==a?i<a?-1:1:o===s?0:o<s?-1:1}e.noIntlCompareFileNames=k;function n(c,p){const[t,i]=h(c),[o,a]=h(p);let s=A.value.collator.compare(i,a);if(s===0){if(A.value.collatorIsNumeric&&i!==a)return i<a?-1:1;if(s=A.value.collator.compare(t,o),A.value.collatorIsNumeric&&s===0&&t!==o)return t<o?-1:1}return s}e.compareFileExtensions=n;function P(c,p){c=c||"",p=p||"";const t=r(c),i=r(p),o=T.value.collator,a=y.value.collator;let s;return s=l(a,t,i),s!==0?s:l(o,c,p)}e.compareFileExtensionsDefault=P;const d=/^(.*?)(\.([^.]*))?$/;function h(c,p=!1){const t=c?d.exec(c):[];let i=[t&&t[1]||"",t&&t[3]||""];return p&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function r(c){const p=c?d.exec(c):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function l(c,p,t){let i=c.compare(p,t);return i!==0?i:p.length!==t.length?p.length<t.length?-1:1:0}function g(c,p,t=!1){return t||(c=c&&c.toLowerCase(),p=p&&p.toLowerCase()),c===p?0:c<p?-1:1}function m(c,p,t=!1){const i=c.split(b.sep),o=p.split(b.sep),a=i.length-1,s=o.length-1;let u,w;for(let _=0;;_++){if(u=a===_,w=s===_,u&&w)return C(i[_],o[_],t);if(u)return-1;if(w)return 1;const v=g(i[_],o[_],t);if(v!==0)return v}}e.comparePaths=m;function S(c,p,t){const i=c.toLowerCase(),o=p.toLowerCase(),a=f(c,p,t);if(a)return a;const s=i.endsWith(t),u=o.endsWith(t);if(s!==u)return s?-1:1;const w=C(i,o);return w!==0?w:i.localeCompare(o)}e.compareAnything=S;function f(c,p,t){const i=c.toLowerCase(),o=p.toLowerCase(),a=i.startsWith(t),s=o.startsWith(t);if(a!==s)return a?-1:1;if(a&&s){if(i.length<o.length)return-1;if(i.length>o.length)return 1}return 0}e.compareByPrefix=f}),define(be[28],_e([0,1,8,37,13,22,11]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",k="/",n="[/\\\\]",P="[^/\\\\]",d=/\//g;function h(U){switch(U){case 0:return"";case 1:return`${P}*?`;default:return`(?:${n}|${P}+${n}|${n}${P}+)*?`}}function r(U,G){if(!U)return[];const X=[];let se=!1,pe=!1,Te="";for(const xe of U){switch(xe){case G:if(!se&&!pe){X.push(Te),Te="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Te+=xe}return Te&&X.push(Te),X}e.splitGlobAware=r;function l(U){if(!U)return"";let G="";const X=r(U,k);if(X.every(se=>se===D))G=".*";else{let se=!1;X.forEach((pe,Te)=>{if(pe===D){se||(G+=h(2),se=!0);return}let xe=!1,Ae="",We=!1,x="";for(const q of pe){if(q!=="}"&&xe){Ae+=q;continue}if(We&&(q!=="]"||!x)){let ne;q==="-"?ne=q:(q==="^"||q==="!")&&!x?ne="^":q===k?ne="":ne=b.escapeRegExpCharacters(q),x+=ne;continue}switch(q){case"{":xe=!0;continue;case"[":We=!0;continue;case"}":G+=`(?:${r(Ae,",").map(me=>l(me)).join("|")})`,xe=!1,Ae="";break;case"]":G+="["+x+"]",We=!1,x="";break;case"?":G+=P;continue;case"*":G+=h(1);continue;default:G+=b.escapeRegExpCharacters(q)}}Te<X.length-1&&(X[Te+1]!==D||Te+2<X.length)&&(G+=n),se=!1})}return G}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),i=function(){return!1},o=function(){return null};function a(U,G){if(!U)return o;let X;typeof U!="string"?X=U.pattern:X=U,X=X.trim();const se=`${X}_${!!G.trimForExclusions}`;let pe=t.get(se);if(pe)return s(pe,U);let Te;if(g.test(X)){const xe=X.substr(4);pe=function(Ae,We){return typeof Ae=="string"&&Ae.endsWith(xe)?X:null}}else(Te=m.exec(u(X,G)))?pe=w(Te[1],X):(G.trimForExclusions?f:S).test(X)?pe=_(X,G):(Te=c.exec(u(X,G)))?pe=v(Te[1].substr(1),X,!0):(Te=p.exec(u(X,G)))?pe=v(Te[1],X,!1):pe=E(X);return t.set(se,pe),s(pe,U)}function s(U,G){return typeof G=="string"?U:function(X,se){return I.isEqualOrParent(X,G.base)?U(A.relative(G.base,X),se):null}}function u(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function w(U,G){const X=`/${U}`,se=`\\${U}`,pe=function(xe,Ae){return typeof xe!="string"?null:Ae?Ae===U?G:null:xe===U||xe.endsWith(X)||xe.endsWith(se)?G:null},Te=[U];return pe.basenames=Te,pe.patterns=[G],pe.allBasenames=Te,pe}function _(U,G){const X=M(U.slice(1,-1).split(",").map(Ae=>a(Ae,G)).filter(Ae=>Ae!==o),U),se=X.length;if(!se)return o;if(se===1)return X[0];const pe=function(Ae,We){for(let x=0,q=X.length;x<q;x++)if(X[x](Ae,We))return U;return null},Te=X.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const xe=X.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return xe.length&&(pe.allPaths=xe),pe}function v(U,G,X){const se=A.sep===A.posix.sep,pe=se?U:U.replace(d,A.sep),Te=A.sep+pe,xe=A.posix.sep+U,Ae=X?function(We,x){return typeof We=="string"&&(We===pe||We.endsWith(Te)||!se&&(We===U||We.endsWith(xe)))?G:null}:function(We,x){return typeof We=="string"&&(We===pe||!se&&We===U)?G:null};return Ae.allPaths=[(X?"*/":"./")+U],Ae}function E(U){try{const G=new RegExp(`^${l(U)}$`);return function(X){return G.lastIndex=0,typeof X=="string"&&G.test(X)?U:null}}catch(G){return o}}function F(U,G,X){return!U||typeof G!="string"?!1:B(U)(G,void 0,X)}e.match=F;function B(U,G={}){if(!U)return i;if(typeof U=="string"||z(U)){const X=a(U,G);if(X===o)return i;const se=function(pe,Te){return!!X(pe,Te)};return X.allBasenames&&(se.allBasenames=X.allBasenames),X.allPaths&&(se.allPaths=X.allPaths),se}return R(U,G)}e.parse=B;function Y(U){if(!!U){let G;return X=>(G||(G=(U()||Promise.resolve([])).then(se=>se?V(se):{})),G.then(se=>!!se[X]))}}e.hasSiblingPromiseFn=Y;function fe(U){if(!!U){let G;return X=>{if(!G){const se=U();G=se?V(se):{}}return!!G[X]}}}e.hasSiblingFn=fe;function V(U){const G={};for(const X of U)G[X]=!0;return G}function z(U){const G=U;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function ee(U){return U.allBasenames||[]}e.getBasenameTerms=ee;function $(U){return U.allPaths||[]}e.getPathTerms=$;function R(U,G){const X=M(Object.getOwnPropertyNames(U).map(Ae=>L(Ae,U[Ae],G)).filter(Ae=>Ae!==o)),se=X.length;if(!se)return o;if(!X.some(Ae=>!!Ae.requiresSiblings)){if(se===1)return X[0];const Ae=function(q,ne){for(let le=0,me=X.length;le<me;le++){const Se=X[le](q,ne);if(Se)return Se}return null},We=X.find(q=>!!q.allBasenames);We&&(Ae.allBasenames=We.allBasenames);const x=X.reduce((q,ne)=>ne.allPaths?q.concat(ne.allPaths):q,[]);return x.length&&(Ae.allPaths=x),Ae}const pe=function(Ae,We,x){let q;for(let ne=0,le=X.length;ne<le;ne++){const me=X[ne];me.requiresSiblings&&x&&(We||(We=A.basename(Ae)),q||(q=We.substr(0,We.length-A.extname(Ae).length)));const Se=me(Ae,We,q,x);if(Se)return Se}return null},Te=X.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const xe=X.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return xe.length&&(pe.allPaths=xe),pe}function L(U,G,X){if(G===!1)return o;const se=a(U,X);if(se===o)return o;if(typeof G=="boolean")return se;if(G){const pe=G.when;if(typeof pe=="string"){const Te=(xe,Ae,We,x)=>{if(!x||!se(xe,Ae))return null;const q=pe.replace("$(basename)",We),ne=x(q);return(0,y.isThenable)(ne)?ne.then(le=>le?U:null):ne?U:null};return Te.requiresSiblings=!0,Te}}return se}function M(U,G){const X=U.filter(Ae=>!!Ae.basenames);if(X.length<2)return U;const se=X.reduce((Ae,We)=>{const x=We.basenames;return x?Ae.concat(x):Ae},[]);let pe;if(G){pe=[];for(let Ae=0,We=se.length;Ae<We;Ae++)pe.push(G)}else pe=X.reduce((Ae,We)=>{const x=We.patterns;return x?Ae.concat(x):Ae},[]);const Te=function(Ae,We){if(typeof Ae!="string")return null;if(!We){let q;for(q=Ae.length;q>0;q--){const ne=Ae.charCodeAt(q-1);if(ne===47||ne===92)break}We=Ae.substr(q)}const x=se.indexOf(We);return x!==-1?pe[x]:null};Te.basenames=se,Te.patterns=pe,Te.allBasenames=se;const xe=U.filter(Ae=>!Ae.basenames);return xe.push(Te),xe}}),define(be[58],_e([0,1,2,13,8,19,21,25,37]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(a,s,u){if(typeof a=="string"&&(a=b.URI.file(a)),u){const _=u.getWorkspaceFolder(a);if(_){const v=u.getWorkspace().folders.length>1;let E;if((0,C.isEqual)(_.uri,a)?E="":E=(0,C.relativePath)(_.uri,a),v){const F=_.name?_.name:(0,C.basename)(_.uri);E=E?F+" \u2022 "+E:F}return E}}if(a.scheme!==T.Schemas.file&&a.scheme!==T.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(a.fsPath))return(0,I.normalize)(P(a.fsPath));let w=(0,I.normalize)(a.fsPath);return!y.isWindows&&(s==null?void 0:s.userHome)&&(w=h(w,s.userHome.fsPath)),w}e.getPathLabel=k;function n(a){if(!!a){typeof a=="string"&&(a=b.URI.file(a));const s=(0,C.basename)(a)||(a.scheme===T.Schemas.file?a.fsPath:a.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(s)?P(s):s}}e.getBaseLabel=n;function P(a){return(0,D.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=P;let d=Object.create(null);function h(a,s){if(y.isWindows||!a||!s)return a;let u=d.original===s?d.normalized:void 0;return u||(u=`${(0,A.rtrim)(s,I.posix.sep)}${I.posix.sep}`,d={original:s,normalized:u}),(y.isLinux?a.startsWith(u):(0,A.startsWithIgnoreCase)(a,u))&&(a=`~/${a.substr(u.length)}`),a}e.tildify=h;function r(a,s){return a.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=r;const l="\u2026",g="\\\\",m="~";function S(a,s=I.sep){const u=new Array(a.length);let w=!1;for(let _=0;_<a.length;_++){let v=a[_];if(v===""){u[_]=`.${s}`;continue}if(!v){u[_]=v;continue}w=!0;let E="";v.indexOf(g)===0?(E=v.substr(0,v.indexOf(g)+g.length),v=v.substr(v.indexOf(g)+g.length)):v.indexOf(s)===0?(E=v.substr(0,v.indexOf(s)+s.length),v=v.substr(v.indexOf(s)+s.length)):v.indexOf(m)===0&&(E=v.substr(0,v.indexOf(m)+m.length),v=v.substr(v.indexOf(m)+m.length));const F=v.split(s);for(let B=1;w&&B<=F.length;B++)for(let Y=F.length-B;w&&Y>=0;Y--){w=!1;let fe=F.slice(Y,Y+B).join(s);for(let V=0;!w&&V<a.length;V++)if(V!==_&&a[V]&&a[V].indexOf(fe)>-1){const z=Y+B===F.length,ee=Y>0&&a[V].indexOf(s)>-1?s+fe:fe,$=a[V].endsWith(ee);w=!z||$}if(!w){let V="";(F[0].endsWith(":")||E!=="")&&(Y===1&&(Y=0,B++,fe=F[0]+s+fe),Y>0&&(V=F[0]+s),V=E+V),Y>0&&(V=V+l+s),V=V+fe,Y+B<F.length&&(V=V+s+l),u[_]=V}}w&&(u[_]=v)}return u}e.shorten=S;var f;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function c(a,s=Object.create(null)){const u=[];let w=!1,_="";for(const v of a)if(v==="$"||w&&v==="{")_&&u.push({value:_,type:f.TEXT}),_="",w=!0;else if(v==="}"&&w){const E=s[_];if(typeof E=="string")E.length&&u.push({value:E,type:f.VARIABLE});else if(E){const F=u[u.length-1];(!F||F.type!==f.SEPARATOR)&&u.push({value:E.label,type:f.SEPARATOR})}_="",w=!1}else _+=v;return _&&!w&&u.push({value:_,type:f.TEXT}),u.filter((v,E)=>{if(v.type===f.SEPARATOR){const F=u[E-1],B=u[E+1];return[F,B].every(Y=>Y&&(Y.type===f.VARIABLE||Y.type===f.TEXT)&&Y.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=c;function p(a,s){return y.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):a.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function t(a,s){return y.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,""):y.isWindows?a.replace(/&&|&/g,u=>u==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(a){const s=a.indexOf("/")!==-1?I.posix:I.win32,u=s.basename(a),w=s.dirname(a);return u.length?{name:u,parentPath:w}:{name:w,parentPath:""}}e.splitName=o}),define(be[113],_e([0,1,2]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(n){return n.toJSON()}class A{constructor(P){this._uriTransformer=P}transformIncoming(P){const d=this._uriTransformer.transformIncoming(P);return d===P?P:I(b.URI.from(d))}transformOutgoing(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:I(b.URI.from(d))}transformOutgoingURI(P){const d=this._uriTransformer.transformOutgoing(P);return d===P?P:b.URI.from(d)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,P,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof b.URI)return P.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const r=T(n[h],P,d+1);r!==null&&(n[h]=r)}}return null}function y(n,P){const d=T(n,P,0);return d===null?n:d}e.transformOutgoingURIs=y;function C(n,P,d,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?b.URI.revive(P.transformIncoming(n)):P.transformIncoming(n);for(let r in n)if(Object.hasOwnProperty.call(n,r)){const l=C(n[r],P,d,h+1);l!==null&&(n[r]=l)}}return null}function D(n,P){const d=C(n,P,!1,0);return d===null?n:d}e.transformIncomingURIs=D;function k(n,P){const d=C(n,P,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=k}),define(be[31],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return b.test(D)}e.isUUID=I;const A=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function C(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let D=0,k="";return k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k}e.generateUuid=C}),define(be[84],_e([0,1,82]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(C){let D=(0,b.toUint8)(C);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=C;return D}set(C,D){let k=(0,b.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=I;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new I(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=T}),define(be[114],_e([0,1,84]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends b.CharacterClassifier{constructor(C){super(0);for(let D=0,k=C.length;D<k;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(y){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=y(D)),C[D])}e.getMapForWordSeparators=T(y=>new A(y))}),define(be[38],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new b(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return b.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return b.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return b.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let y=A.lineNumber|0,C=T.lineNumber|0;if(y===C){let D=A.column|0,k=T.column|0;return D-k}return y-C}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new b(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=b}),define(be[32],_e([0,1,38]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(T,y,C,D){T>C||T===C&&y>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return I.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return I.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return I.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return I.plusRange(this,T)}static plusRange(T,y){let C,D,k,n;return y.startLineNumber<T.startLineNumber?(C=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(C=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(C=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(k=y.endLineNumber,n=y.endColumn):y.endLineNumber===T.endLineNumber?(k=y.endLineNumber,n=Math.max(y.endColumn,T.endColumn)):(k=T.endLineNumber,n=T.endColumn),new I(C,D,k,n)}intersectRanges(T){return I.intersectRanges(this,T)}static intersectRanges(T,y){let C=T.startLineNumber,D=T.startColumn,k=T.endLineNumber,n=T.endColumn,P=y.startLineNumber,d=y.startColumn,h=y.endLineNumber,r=y.endColumn;return C<P?(C=P,D=d):C===P&&(D=Math.max(D,d)),k>h?(k=h,n=r):k===h&&(n=Math.min(n,r)),C>k||C===k&&D>n?null:new I(C,D,k,n)}equalsRange(T){return I.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(T){return new b.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(T){return new b.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new I(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new I(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(T){return new I(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new I(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new I(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const k=T.startLineNumber|0,n=y.startLineNumber|0;if(k===n){const P=T.startColumn|0,d=y.startColumn|0;if(P===d){const h=T.endLineNumber|0,r=y.endLineNumber|0;if(h===r){const l=T.endColumn|0,g=y.endColumn|0;return l-g}return h-r}return P-d}return k-n}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=I}),define(be[115],_e([0,1,38,32]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends I.Range{constructor(C,D,k,n){super(C,D,k,n);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return T.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,C,D):new T(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new T(C,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new T(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new T(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let k=0,n=C.length;k<n;k++)if(!this.selectionsEqual(C[k],D[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,k,n,P){return P===0?new T(C,D,k,n):new T(k,n,C,D)}}e.Selection=T}),define(be[85],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(r,l){this.range=r,this.matches=l}}e.FindMatch=D;var k;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class P{constructor(r,l,g,m,S,f){this.identifier=r,this.range=l,this.text=g,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=S,this._isTracked=f}}e.ValidAnnotatedEditOperation=P;class d{constructor(r,l,g){this.reverseEdits=r,this.changes=l,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=d}),define(be[116],_e([0,1,8,114,38,32,85]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(f,c,p,t){this.searchString=f,this.isRegex=c,this.matchCase=p,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=k(this.searchString):f=this.searchString.indexOf(`
`)>=0;let c=null;try{c=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let p=!this.isRegex&&!f;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new n(c,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=D;function k(S){if(!S||S.length===0)return!1;for(let f=0,c=S.length;f<c;f++)if(S.charCodeAt(f)===92){if(f++,f>=c)break;const t=S.charCodeAt(f);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class n{constructor(f,c,p){this.regex=f,this.wordSeparators=c,this.simpleSearch=p}}e.SearchData=n;function P(S,f,c){if(!c)return new y.FindMatch(S,null);let p=[];for(let t=0,i=f.length;t<i;t++)p[t]=f[t];return new y.FindMatch(S,p)}e.createFindMatch=P;class d{constructor(f){let c=[],p=0;for(let t=0,i=f.length;t<i;t++)f.charCodeAt(t)===10&&(c[p++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(f){const c=this._lineFeedsOffsets;let p=0,t=c.length-1;if(t===-1||f<=c[0])return 0;for(;p<t;){const i=p+((t-p)/2>>0);c[i]>=f?t=i-1:c[i+1]>=f?(p=i,t=i):p=i+1}return p+1}}class h{static findMatches(f,c,p,t,i){const o=c.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(f,p,new m(o.wordSeparators,o.regex),t,i):this._doFindMatchesLineByLine(f,p,o,t,i):[]}static _getMultilineMatchRange(f,c,p,t,i,o){let a,s=0;t?(s=t.findLineFeedCountBeforeOffset(i),a=c+i+s):a=c+i;let u;if(t){let E=t.findLineFeedCountBeforeOffset(i+o.length)-s;u=a+o.length+E}else u=a+o.length;const w=f.getPositionAt(a),_=f.getPositionAt(u);return new T.Range(w.lineNumber,w.column,_.lineNumber,_.column)}static _doFindMatchesMultiline(f,c,p,t,i){const o=f.getOffsetAt(c.getStartPosition()),a=f.getValueInRange(c,1),s=f.getEOL()===`\r
`?new d(a):null,u=[];let w=0,_;for(p.reset(0);_=p.next(a);)if(u[w++]=P(this._getMultilineMatchRange(f,o,a,s,_.index,_[0]),_,t),w>=i)return u;return u}static _doFindMatchesLineByLine(f,c,p,t,i){const o=[];let a=0;if(c.startLineNumber===c.endLineNumber){const u=f.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return a=this._findMatchesInLine(p,u,c.startLineNumber,c.startColumn-1,a,o,t,i),o}const s=f.getLineContent(c.startLineNumber).substring(c.startColumn-1);a=this._findMatchesInLine(p,s,c.startLineNumber,c.startColumn-1,a,o,t,i);for(let u=c.startLineNumber+1;u<c.endLineNumber&&a<i;u++)a=this._findMatchesInLine(p,f.getLineContent(u),u,0,a,o,t,i);if(a<i){const u=f.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);a=this._findMatchesInLine(p,u,c.endLineNumber,0,a,o,t,i)}return o}static _findMatchesInLine(f,c,p,t,i,o,a,s){const u=f.wordSeparators;if(!a&&f.simpleSearch){const v=f.simpleSearch,E=v.length,F=c.length;let B=-E;for(;(B=c.indexOf(v,B+E))!==-1;)if((!u||g(u,c,F,B,E))&&(o[i++]=new y.FindMatch(new T.Range(p,B+1+t,p,B+1+E+t),null),i>=s))return i;return i}const w=new m(f.wordSeparators,f.regex);let _;w.reset(0);do if(_=w.next(c),_&&(o[i++]=P(new T.Range(p,_.index+1+t,p,_.index+1+_[0].length+t),_,a),i>=s))return i;while(_);return i}static findNextMatch(f,c,p,t){const i=c.parseSearchRequest();if(!i)return null;const o=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(f,p,o,t):this._doFindNextMatchLineByLine(f,p,o,t)}static _doFindNextMatchMultiline(f,c,p,t){const i=new A.Position(c.lineNumber,1),o=f.getOffsetAt(i),a=f.getLineCount(),s=f.getValueInRange(new T.Range(i.lineNumber,i.column,a,f.getLineMaxColumn(a)),1),u=f.getEOL()===`\r
`?new d(s):null;p.reset(c.column-1);let w=p.next(s);return w?P(this._getMultilineMatchRange(f,o,s,u,w.index,w[0]),w,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(f,new A.Position(1,1),p,t):null}static _doFindNextMatchLineByLine(f,c,p,t){const i=f.getLineCount(),o=c.lineNumber,a=f.getLineContent(o),s=this._findFirstMatchInLine(p,a,o,c.column,t);if(s)return s;for(let u=1;u<=i;u++){const w=(o+u-1)%i,_=f.getLineContent(w+1),v=this._findFirstMatchInLine(p,_,w+1,1,t);if(v)return v}return null}static _findFirstMatchInLine(f,c,p,t,i){f.reset(t-1);const o=f.next(c);return o?P(new T.Range(p,o.index+1,p,o.index+1+o[0].length),o,i):null}static findPreviousMatch(f,c,p,t){const i=c.parseSearchRequest();if(!i)return null;const o=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(f,p,o,t):this._doFindPreviousMatchLineByLine(f,p,o,t)}static _doFindPreviousMatchMultiline(f,c,p,t){const i=this._doFindMatchesMultiline(f,new T.Range(1,1,c.lineNumber,c.column),p,t,10*C);if(i.length>0)return i[i.length-1];const o=f.getLineCount();return c.lineNumber!==o||c.column!==f.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(f,new A.Position(o,f.getLineMaxColumn(o)),p,t):null}static _doFindPreviousMatchLineByLine(f,c,p,t){const i=f.getLineCount(),o=c.lineNumber,a=f.getLineContent(o).substring(0,c.column-1),s=this._findLastMatchInLine(p,a,o,t);if(s)return s;for(let u=1;u<=i;u++){const w=(i+o-u-1)%i,_=f.getLineContent(w+1),v=this._findLastMatchInLine(p,_,w+1,t);if(v)return v}return null}static _findLastMatchInLine(f,c,p,t){let i=null,o;for(f.reset(0);o=f.next(c);)i=P(new T.Range(p,o.index+1,p,o.index+1+o[0].length),o,t);return i}}e.TextModelSearch=h;function r(S,f,c,p,t){if(p===0)return!0;const i=f.charCodeAt(p-1);if(S.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=f.charCodeAt(p);if(S.get(o)!==0)return!0}return!1}function l(S,f,c,p,t){if(p+t===c)return!0;const i=f.charCodeAt(p+t);if(S.get(i)!==0||i===13||i===10)return!0;if(t>0){const o=f.charCodeAt(p+t-1);if(S.get(o)!==0)return!0}return!1}function g(S,f,c,p,t){return r(S,f,c,p,t)&&l(S,f,c,p,t)}e.isValidMatch=g;class m{constructor(f,c){this._wordSeparators=f,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(f){this._searchRegex.lastIndex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(f){const c=f.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(p=this._searchRegex.exec(f),!p))return null;const t=p.index,i=p[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){b.getNextCodePoint(f,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||g(this._wordSeparators,f,c,t,i))return p}while(p);return null}}e.Searcher=m}),define(be[86],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function I(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),D=new RegExp(C.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(C,D,k,n,P=A){if(k.length>P.maxLen){let g=C-P.maxLen/2;return g<0?g=0:n+=g,k=k.substring(g,C+P.maxLen/2),T(C,D,k,n,P)}const d=Date.now(),h=C-1-n;let r=-1,l=null;for(let g=1;!(Date.now()-d>=P.timeBudget);g++){const m=h-P.windowSize*g;D.lastIndex=Math.max(0,m);const S=y(D,k,h,r);if(!S&&l||(l=S,m<=0))break;r=m}if(l){let g={word:l[0],startColumn:n+1+l.index,endColumn:n+1+l.index+l[0].length};return D.lastIndex=0,g}return null}e.getWordAtText=T;function y(C,D,k,n){let P;for(;P=C.exec(D);){const d=P.index||0;if(d<=k&&C.lastIndex>=k)return P;if(n>0&&d>n)return null}return null}}),define(be[117],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class I{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,k=C.notIn.length;D<k;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=I;class A{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=A;function T(y,C,D){y.has(C)?y.get(C).push(D):y.set(C,[D])}}),define(be[59],_e([0,1,28,13]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,y,C,D){if(Array.isArray(T)){let k=0;for(const n of T){const P=A(n,y,C,D);if(P===10)return P;P>k&&(k=P)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===C?10:0:0;if(T){const{language:k,pattern:n,scheme:P,hasAccessToAllModels:d}=T;if(!D&&!d)return 0;let h=0;if(P)if(P===y.scheme)h=10;else if(P==="*")h=5;else return 0;if(k)if(k===C)h=10;else if(k==="*")h=Math.max(h,5);else return 0;if(n){let r;if(typeof n=="string"?r=n:r=Object.assign(Object.assign({},n),{base:(0,I.normalize)(n.base)}),r===y.fsPath||(0,b.match)(r,y.fsPath))h=10;else return 0}return h}else return 0}}e.score=A}),define(be[118],_e([0,1,84]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class A{constructor(r,l,g){const m=new Uint8Array(r*l);for(let S=0,f=r*l;S<f;S++)m[S]=g;this._data=m,this.rows=r,this.cols=l}get(r,l){return this._data[r*this.cols+l]}set(r,l,g){this._data[r*this.cols+l]=g}}e.Uint8Matrix=A;class T{constructor(r){let l=0,g=0;for(let S=0,f=r.length;S<f;S++){let[c,p,t]=r[S];p>l&&(l=p),c>g&&(g=c),t>g&&(g=t)}l++,g++;let m=new A(g,l,0);for(let S=0,f=r.length;S<f;S++){let[c,p,t]=r[S];m.set(c,p,t)}this._states=m,this._maxCharCode=l}nextState(r,l){return l<0||l>=this._maxCharCode?0:this._states.get(r,l)}}e.StateMachine=T;let y=null;function C(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function n(){if(k===null){k=new b.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<h.length;l++)k.set(h.charCodeAt(l),1);const r=".,;";for(let l=0;l<r.length;l++)k.set(r.charCodeAt(l),2)}return k}class P{static _createLink(r,l,g,m,S){let f=S-1;do{const c=l.charCodeAt(f);if(r.get(c)!==2)break;f--}while(f>m);if(m>0){const c=l.charCodeAt(m-1),p=l.charCodeAt(f);(c===40&&p===41||c===91&&p===93||c===123&&p===125)&&f--}return{range:{startLineNumber:g,startColumn:m+1,endLineNumber:g,endColumn:f+2},url:l.substring(m,f+1)}}static computeLinks(r,l=C()){const g=n();let m=[];for(let S=1,f=r.getLineCount();S<=f;S++){const c=r.getLineContent(S),p=c.length;let t=0,i=0,o=0,a=1,s=!1,u=!1,w=!1,_=!1;for(;t<p;){let v=!1;const E=c.charCodeAt(t);if(a===13){let F;switch(E){case 40:s=!0,F=0;break;case 41:F=s?0:1;break;case 91:w=!0,u=!0,F=0;break;case 93:w=!1,F=u?0:1;break;case 123:_=!0,F=0;break;case 125:F=_?0:1;break;case 39:F=o===34||o===96?0:1;break;case 34:F=o===39||o===96?0:1;break;case 96:F=o===39||o===34?0:1;break;case 42:F=o===42?1:0;break;case 124:F=o===124?1:0;break;case 32:F=w?0:1;break;default:F=g.get(E)}F===1&&(m.push(P._createLink(g,c,S,i,t)),v=!0)}else if(a===12){let F;E===91?(u=!0,F=0):F=g.get(E),F===1?v=!0:a=13}else a=l.nextState(a,E),a===0&&(v=!0);v&&(a=1,s=!1,u=!1,_=!1,i=t+1,o=E),t++}a===13&&m.push(P._createLink(g,c,S,i,p))}return m}}e.LinkComputer=P;function d(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:P.computeLinks(h)}e.computeLinks=d}),define(be[119],_e([0,1,3,6]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,C){return this._map.set(y,C),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===C&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,C){let D=null,k=!1;return this._promises.set(y,C.then(n=>{this._promises.delete(y),!(k||!n)&&(D=this.register(y,n))})),(0,I.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(y){const C=this.get(y);if(C)return Promise.resolve(C);const D=this._promises.get(y);return D?D.then(k=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(be[87],_e([0,1,23,21]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(A||(A={}));function T(P){for(let d=0,h=P.length;d<h;d+=4){const r=P[d+0],l=P[d+1],g=P[d+2],m=P[d+3];P[d+0]=m,P[d+1]=g,P[d+2]=l,P[d+3]=r}}function y(P){const d=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return I.isLittleEndian()||T(d),b.VSBuffer.wrap(d)}function C(P){const d=P.buffer;if(I.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const h=new Uint8Array(d.byteLength);return h.set(d),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(P){const d=new Uint32Array(k(P));let h=0;if(d[h++]=P.id,P.type==="full")d[h++]=1,d[h++]=P.data.length,d.set(P.data,h),h+=P.data.length;else{d[h++]=2,d[h++]=P.deltas.length;for(const r of P.deltas)d[h++]=r.start,d[h++]=r.deleteCount,r.data?(d[h++]=r.data.length,d.set(r.data,h),h+=r.data.length):d[h++]=0}return y(d)}e.encodeSemanticTokensDto=D;function k(P){let d=0;if(d+=1+1,P.type==="full")d+=1+P.data.length;else{d+=1,d+=(1+1+1)*P.deltas.length;for(const h of P.deltas)h.data&&(d+=h.data.length)}return d}function n(P){const d=C(P);let h=0;const r=d[h++];if(d[h++]===1){const S=d[h++],f=d.subarray(h,h+S);return h+=S,{id:r,type:"full",data:f}}const g=d[h++];let m=[];for(let S=0;S<g;S++){const f=d[h++],c=d[h++],p=d[h++];let t;p>0&&(t=d.subarray(h,h+p),h+=p),m[S]={start:f,deleteCount:c,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=n}),define(be[88],_e([0,1,82]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,C){this.index=y,this.remainder=C}}e.PrefixSumIndexOfResult=I;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,C){y=(0,b.toUint32)(y);const D=this.values,k=this.prefixSum,n=C.length;return n===0?!1:(this.values=new Uint32Array(D.length+n),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+n),this.values.set(C,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,C){return y=(0,b.toUint32)(y),C=(0,b.toUint32)(C),this.values[y]===C?!1:(this.values[y]=C,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,C){y=(0,b.toUint32)(y),C=(0,b.toUint32)(C);const D=this.values,k=this.prefixSum;if(y>=D.length)return!1;let n=D.length-y;return C>=n&&(C=n),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+C),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),y>=this.values.length&&(y=this.values.length-1);for(let D=C;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let C=0,D=this.values.length-1,k=0,n=0,P=0;for(;C<=D;)if(k=C+(D-C)/2|0,n=this.prefixSum[k],P=n-this.values[k],y<P)D=k-1;else if(y>=n)C=k+1;else break;return new I(k,y-P)}}e.PrefixSumComputer=A}),define(be[120],_e([0,1,8,38,88]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(C,D,k,n){this._uri=C,this._lines=D,this._eol=k,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new I.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let n=0;n<D;n++)k[n]=this._lines[n].length+C;this._lineStarts=new A.PrefixSumComputer(k)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length!==0){let k=(0,b.splitLines)(D);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let n=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this._lines.splice(C.lineNumber+P-1,0,k[P]),n[P-1]=k[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,n)}}}e.MirrorTextModel=T}),define(be[121],_e([16,17]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(be[60],_e([0,1,121,10,15]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,n){return n&&(k.stack||k.stacktrace)?b.localize(0,null,C(k),y(k.stack)||y(k.stacktrace)):C(k)}function y(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?b.localize(1,null,k.message):k.message||b.localize(2,null)}function D(k=null,n=!1){if(!k)return b.localize(3,null);if(Array.isArray(k)){const P=A.coalesce(k),d=D(P[0],n);return P.length>1?b.localize(4,null,d,P.length):d}if(I.isString(k))return k;if(k.detail){const P=k.detail;if(P.error)return T(P.error,n);if(P.exception)return T(P.exception,n)}return k.stack?T(k,n):k.message?k.message:b.localize(5,null)}e.toErrorMessage=D}),define(be[122],_e([16,17]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(be[123],_e([0,1,122,21,86]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=y;class C{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(te,ve,Le,He){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=He}compute(te,ve,Le){return Le}}class n{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class P{constructor(te,ve,Le,He){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=He}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Le){return Le}}function d(H,te){return typeof H=="undefined"?te:H==="false"?!1:Boolean(H)}e.boolean=d;class h extends P{constructor(te,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Le),super(te,ve,Le,He)}validate(te){return d(te,this.defaultValue)}}class r extends P{constructor(te,ve,Le,He,Ue,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Le,Xe.minimum=He,Xe.maximum=Ue),super(te,ve,Le,Xe),this.minimum=He,this.maximum=Ue}static clampedInt(te,ve,Le,He){if(typeof te=="undefined")return ve;let Ue=parseInt(te,10);return isNaN(Ue)?ve:(Ue=Math.max(Le,Ue),Ue=Math.min(He,Ue),Ue|0)}validate(te){return r.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class l extends P{constructor(te,ve,Le,He,Ue){typeof Ue!="undefined"&&(Ue.type="number",Ue.default=Le),super(te,ve,Le,Ue),this.validationFn=He}static clamp(te,ve,Le){return te<ve?ve:te>Le?Le:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Le=parseFloat(te);return isNaN(Le)?ve:Le}validate(te){return this.validationFn(l.float(te,this.defaultValue))}}class g extends P{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Le),super(te,ve,Le,He)}validate(te){return g.string(te,this.defaultValue)}}function m(H,te,ve){return typeof H!="string"||ve.indexOf(H)===-1?te:H}e.stringSet=m;class S extends P{constructor(te,ve,Le,He,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=He,Ue.default=Le),super(te,ve,Le,Ue),this._allowedValues=He}validate(te){return m(te,this.defaultValue,this._allowedValues)}}class f extends k{constructor(te,ve,Le,He,Ue,Xe,W=void 0){typeof W!="undefined"&&(W.type="string",W.enum=Ue,W.default=He),super(te,ve,Le,W),this._allowedValues=Ue,this._convert=Xe}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function c(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Le){return Le===0?te.accessibilitySupport:Le}}class t extends k{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:b.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:d(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(H){switch(H){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function u(H){switch(H){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class w extends n{constructor(){super(123,[62,31])}compute(te,ve,Le){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),te.extraEditorClassName&&He.push(te.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class _ extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(te,ve,Le){return Le&&te.emptySelectionClipboard}}class v extends k{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:b.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:b.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:d(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":m(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ve.loop,this.defaultValue.loop)}}}class E extends k{constructor(){super(41,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?E.OFF:te==="true"?E.ON:te:Boolean(te)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class F extends n{constructor(){super(40)}compute(te,ve,Le){return te.fontInfo}}class B extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(te){let ve=l.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(ve,6,100)}compute(te,ve,Le){return te.fontInfo.fontSize}}class Y extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.MINIMUM_VALUE,maximum:Y.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(r.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.MINIMUM_VALUE,Y.MAXIMUM_VALUE))}}Y.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Y.MINIMUM_VALUE=1,Y.MAXIMUM_VALUE=1e3;class fe extends k{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Le,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Le,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Le,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Le,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Le,description:b.localize(35,null)}})}validate(te){var ve,Le,He,Ue,Xe;if(!te||typeof te!="object")return this.defaultValue;const W=te;return{multiple:m(W.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=W.multipleDefinitions)!==null&&ve!==void 0?ve:m(W.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=W.multipleTypeDefinitions)!==null&&Le!==void 0?Le:m(W.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=W.multipleDeclarations)!==null&&He!==void 0?He:m(W.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ue=W.multipleImplementations)!==null&&Ue!==void 0?Ue:m(W.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=W.multipleReferences)!==null&&Xe!==void 0?Xe:m(W.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(W.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(W.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(W.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(W.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(W.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends k{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:b.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:d(ve.sticky,this.defaultValue.sticky)}}}var z;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class ee extends n{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(te,ve,Le){return ee.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Le=te.scrollBeyondLastLine?ve-1:0,He=(te.viewLineCount+Le)/(te.pixelRatio*te.height),Ue=Math.floor(te.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:He,minimapLineCount:Ue}}static _computeMinimapLayout(te,ve){const Le=te.outerWidth,He=te.outerHeight,Ue=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ue*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=ve.stableMinimapLayoutInput,W=Xe&&te.outerHeight===Xe.outerHeight&&te.lineHeight===Xe.lineHeight&&te.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&te.pixelRatio===Xe.pixelRatio&&te.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&te.minimap.enabled===Xe.minimap.enabled&&te.minimap.side===Xe.minimap.side&&te.minimap.size===Xe.minimap.size&&te.minimap.showSlider===Xe.minimap.showSlider&&te.minimap.renderCharacters===Xe.minimap.renderCharacters&&te.minimap.maxColumn===Xe.minimap.maxColumn&&te.minimap.scale===Xe.minimap.scale&&te.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&te.isViewportWrapping===Xe.isViewportWrapping,ie=te.lineHeight,ce=te.typicalHalfwidthCharacterWidth,j=te.scrollBeyondLastLine,Z=te.minimap.renderCharacters;let ae=Ue>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const he=te.minimap.maxColumn,ye=te.minimap.size,ze=te.minimap.side,Be=te.verticalScrollbarWidth,Ne=te.viewLineCount,Ge=te.remainingWidth,nt=te.isViewportWrapping,dt=Z?2:3;let it=Math.floor(Ue*He);const Je=it/Ue;let mt=!1,wt=!1,we=dt*ae,de=ae/Ue,oe=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Ye,desiredRatio:ot,minimapLineCount:ft}=ee.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:j,height:He,lineHeight:ie,pixelRatio:Ue});if(Ne/ft>1)mt=!0,wt=!0,ae=1,we=1,de=ae/Ue;else{let Et=!1,vt=ae+1;if(ye==="fit"){const Ct=Math.ceil((Ne+Ye)*we);nt&&W&&Ge<=ve.stableFitRemainingWidth?(Et=!0,vt=ve.stableFitMaxMinimapScale):(Et=Ct>it,nt&&Et?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=Ge):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(ye==="fill"||Et){mt=!0;const Ct=ae;we=Math.min(ie*Ue,Math.max(1,Math.floor(1/ot))),ae=Math.min(vt,Math.max(1,Math.floor(we/dt))),ae>Ct&&(oe=Math.min(2,ae/Ct)),de=ae/Ue/oe,it=Math.ceil(Math.max(ht,Ne+Ye)*we),nt&&Et&&(ve.stableFitMaxMinimapScale=ae)}}}const K=Math.floor(he*de),Re=Math.min(K,Math.max(0,Math.floor((Ge-Be-2)*de/(ce+de)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(Ue*Re);const Qe=Ie/Ue;Ie=Math.floor(Ie*oe);const Ze=Z?1:2,ut=ze==="left"?0:Le-Re-Be;return{renderMinimap:Ze,minimapLeft:ut,minimapWidth:Re,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:ae,minimapLineHeight:we,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Je}}static computeLayout(te,ve){const Le=ve.outerWidth|0,He=ve.outerHeight|0,Ue=ve.lineHeight|0,Xe=ve.lineNumbersDigitCount|0,W=ve.typicalHalfwidthCharacterWidth,ie=ve.maxDigitWidth,ce=ve.pixelRatio,j=ve.viewLineCount,Z=te.get(118),ae=Z==="inherit"?te.get(117):Z,he=ae==="inherit"?te.get(113):ae,ye=te.get(116),ze=te.get(2),Be=ve.isDominatedByLongLines,Ne=te.get(46),Ge=te.get(56).renderType!==0,nt=te.get(57),dt=te.get(91),it=te.get(61),Je=te.get(89),mt=Je.verticalScrollbarSize,wt=Je.verticalHasArrows,we=Je.arrowSize,de=Je.horizontalScrollbarSize,oe=te.get(54),K=te.get(35);let Re;if(typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)){const _t=parseFloat(oe.substr(0,oe.length-2));Re=r.clampedInt(_t*W,0,0,1e3)}else Re=r.clampedInt(oe,0,0,1e3);K&&(Re+=16);let Ie=0;if(Ge){const _t=Math.max(Xe,nt);Ie=Math.round(_t*ie)}let Qe=0;Ne&&(Qe=Ue);let Ze=0,ut=Ze+Qe,ht=ut+Ie,Ye=ht+Re;const ot=Le-Qe-Ie-Re;let ft=!1,at=!1,Et=-1;ze!==2&&(ae==="inherit"&&Be?(ft=!0,at=!0):he==="on"||he==="bounded"?at=!0:he==="wordWrapColumn"&&(Et=ye));const vt=ee._computeMinimapLayout({outerWidth:Le,outerHeight:He,lineHeight:Ue,typicalHalfwidthCharacterWidth:W,pixelRatio:ce,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:j,remainingWidth:ot,isViewportWrapping:at},ve.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ut+=vt.minimapWidth,ht+=vt.minimapWidth,Ye+=vt.minimapWidth);const Ct=ot-vt.minimapWidth,Pt=Math.max(1,Math.floor((Ct-mt-2)/W)),At=wt?we:0;return at&&(Et=Math.max(1,Pt),he==="bounded"&&(Et=Math.min(Et,ye))),{width:Le,height:He,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ut,lineNumbersWidth:Ie,decorationsLeft:ht,decorationsWidth:Re,contentLeft:Ye,contentWidth:Ct,minimap:vt,viewportColumn:Pt,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:Et,verticalScrollbarWidth:mt,horizontalScrollbarHeight:de,overviewRuler:{top:At,width:mt,height:He-2*At,right:0}}}}e.EditorLayoutInfoComputer=ee;class $ extends k{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:b.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:d(te.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlineHints",te,{"editor.inlineHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:te.fontSize,description:b.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:te.fontFamily,description:b.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(te,ve,Le){return te.fontInfo.lineHeight}}class M extends k{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:te.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:b.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),size:m(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ve.side,this.defaultValue.side,["right","left"]),showSlider:m(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(H){return H==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class X extends k{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:b.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:d(ve.enabled,this.defaultValue.enabled),cycle:d(ve.cycle,this.defaultValue.cycle)}}}class se extends n{constructor(){super(124)}compute(te,ve,Le){return te.pixelRatio}}class pe extends k{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:b.localize(58,null)},comments:{type:"boolean",default:te.comments,description:b.localize(59,null)},other:{type:"boolean",default:te.other,description:b.localize(60,null)}}}],default:te,description:b.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Le={other:d(ve.other,this.defaultValue.other),comments:d(ve.comments,this.defaultValue.comments),strings:d(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Te;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(te){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Le=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Ae(H){const te=H.get(84);return te==="editable"?H.get(77):te!=="on"}e.filterValidationDecorations=Ae;class We extends k{constructor(){const te=[],ve={type:"number",description:b.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:te,description:b.localize(69,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Le of te)if(typeof Le=="number")ve.push({column:r.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const He=Le;ve.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Le,He)=>Le.column-He.column),ve}return this.defaultValue}}function x(H,te){if(typeof H!="string")return te;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Le=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:x(ve.vertical,this.defaultValue.vertical),horizontal:x(ve.horizontal,this.defaultValue.horizontal),useShadows:d(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:d(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ne extends k{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:te.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:m(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ve.showIcons,this.defaultValue.showIcons),showStatusBar:d(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:d(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ve.showMethods,this.defaultValue.showMethods),showFunctions:d(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ve.showConstructors,this.defaultValue.showConstructors),showFields:d(ve.showFields,this.defaultValue.showFields),showVariables:d(ve.showVariables,this.defaultValue.showVariables),showClasses:d(ve.showClasses,this.defaultValue.showClasses),showStructs:d(ve.showStructs,this.defaultValue.showStructs),showInterfaces:d(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ve.showModules,this.defaultValue.showModules),showProperties:d(ve.showProperties,this.defaultValue.showProperties),showEvents:d(ve.showEvents,this.defaultValue.showEvents),showOperators:d(ve.showOperators,this.defaultValue.showOperators),showUnits:d(ve.showUnits,this.defaultValue.showUnits),showValues:d(ve.showValues,this.defaultValue.showValues),showConstants:d(ve.showConstants,this.defaultValue.showConstants),showEnums:d(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ve.showKeywords,this.defaultValue.showKeywords),showWords:d(ve.showWords,this.defaultValue.showWords),showColors:d(ve.showColors,this.defaultValue.showColors),showFiles:d(ve.showFiles,this.defaultValue.showFiles),showReferences:d(ve.showReferences,this.defaultValue.showReferences),showFolders:d(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ve.showSnippets,this.defaultValue.showSnippets),showUsers:d(ve.showUsers,this.defaultValue.showUsers),showIssues:d(ve.showIssues,this.defaultValue.showIssues)}}}class le extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class me extends n{constructor(){super(125,[77])}compute(te,ve,Le){return ve.get(77)?!0:te.tabFocusMode}}var Se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Oe(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends n{constructor(){super(127,[126])}compute(te,ve,Le){const He=ve.get(126);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Pe:I.isLinux?$e:Ce,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(H){return e.editorOptionsRegistry[H.id]=H,H}var je;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.letterSpacing=52]="letterSpacing",H[H.lightbulb=53]="lightbulb",H[H.lineDecorationsWidth=54]="lineDecorationsWidth",H[H.lineHeight=55]="lineHeight",H[H.lineNumbers=56]="lineNumbers",H[H.lineNumbersMinChars=57]="lineNumbersMinChars",H[H.linkedEditing=58]="linkedEditing",H[H.links=59]="links",H[H.matchBrackets=60]="matchBrackets",H[H.minimap=61]="minimap",H[H.mouseStyle=62]="mouseStyle",H[H.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=64]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",H[H.multiCursorModifier=66]="multiCursorModifier",H[H.multiCursorPaste=67]="multiCursorPaste",H[H.occurrencesHighlight=68]="occurrencesHighlight",H[H.overviewRulerBorder=69]="overviewRulerBorder",H[H.overviewRulerLanes=70]="overviewRulerLanes",H[H.padding=71]="padding",H[H.parameterHints=72]="parameterHints",H[H.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",H[H.quickSuggestions=75]="quickSuggestions",H[H.quickSuggestionsDelay=76]="quickSuggestionsDelay",H[H.readOnly=77]="readOnly",H[H.renameOnType=78]="renameOnType",H[H.renderControlCharacters=79]="renderControlCharacters",H[H.renderIndentGuides=80]="renderIndentGuides",H[H.renderFinalNewline=81]="renderFinalNewline",H[H.renderLineHighlight=82]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=84]="renderValidationDecorations",H[H.renderWhitespace=85]="renderWhitespace",H[H.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",H[H.roundedSelection=87]="roundedSelection",H[H.rulers=88]="rulers",H[H.scrollbar=89]="scrollbar",H[H.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=91]="scrollBeyondLastLine",H[H.scrollPredominantAxis=92]="scrollPredominantAxis",H[H.selectionClipboard=93]="selectionClipboard",H[H.selectionHighlight=94]="selectionHighlight",H[H.selectOnLineNumbers=95]="selectOnLineNumbers",H[H.showFoldingControls=96]="showFoldingControls",H[H.showUnused=97]="showUnused",H[H.snippetSuggestions=98]="snippetSuggestions",H[H.smartSelect=99]="smartSelect",H[H.smoothScrolling=100]="smoothScrolling",H[H.stickyTabStops=101]="stickyTabStops",H[H.stopRenderingLineAfter=102]="stopRenderingLineAfter",H[H.suggest=103]="suggest",H[H.suggestFontSize=104]="suggestFontSize",H[H.suggestLineHeight=105]="suggestLineHeight",H[H.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",H[H.suggestSelection=107]="suggestSelection",H[H.tabCompletion=108]="tabCompletion",H[H.tabIndex=109]="tabIndex",H[H.unusualLineTerminators=110]="unusualLineTerminators",H[H.useTabStops=111]="useTabStops",H[H.wordSeparators=112]="wordSeparators",H[H.wordWrap=113]="wordWrap",H[H.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=116]="wordWrapColumn",H[H.wordWrapOverride1=117]="wordWrapOverride1",H[H.wordWrapOverride2=118]="wordWrapOverride2",H[H.wrappingIndent=119]="wrappingIndent",H[H.wrappingStrategy=120]="wrappingStrategy",H[H.showDeprecated=121]="showDeprecated",H[H.inlineHints=122]="inlineHints",H[H.editorClassName=123]="editorClassName",H[H.pixelRatio=124]="pixelRatio",H[H.tabFocusMode=125]="tabFocusMode",H[H.layoutInfo=126]="layoutInfo",H[H.wrappingInfo=127]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:Ee(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:Ee(new p),accessibilityPageSize:Ee(new r(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:Ee(new g(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:Ee(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:Ee(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:Ee(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:Ee(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:Ee(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:Ee(new h(10,"automaticLayout",!1)),autoSurround:Ee(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:Ee(new h(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:Ee(new h(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:Ee(new g(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:Ee(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:Ee(new h(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:Ee(new h(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new h(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:Ee(new f(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new h(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:Ee(new f(22,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],u,{description:b.localize(145,null)})),cursorSurroundingLines:Ee(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:Ee(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:Ee(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new h(28,"domReadOnly",!1)),dragAndDrop:Ee(new h(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:Ee(new _),extraEditorClassName:Ee(new g(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new l(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:b.localize(152,null)})),find:Ee(new v),fixedOverflowWidgets:Ee(new h(34,"fixedOverflowWidgets",!1)),folding:Ee(new h(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:Ee(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:Ee(new h(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:Ee(new g(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:Ee(new F),fontLigatures2:Ee(new E),fontSize:Ee(new B),fontWeight:Ee(new Y),formatOnPaste:Ee(new h(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:Ee(new h(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:Ee(new h(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:Ee(new fe),hideCursorInOverviewRuler:Ee(new h(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:Ee(new h(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:Ee(new V),inDiffEditor:Ee(new h(51,"inDiffEditor",!1)),letterSpacing:Ee(new l(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>l.clamp(H,-5,20),{description:b.localize(165,null)})),lightbulb:Ee(new $),lineDecorationsWidth:Ee(new P(54,"lineDecorationsWidth",10)),lineHeight:Ee(new L),lineNumbers:Ee(new xe),lineNumbersMinChars:Ee(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new h(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:Ee(new h(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:Ee(new S(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:Ee(new M),mouseStyle:Ee(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new l(63,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:Ee(new h(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:Ee(new h(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:Ee(new f(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:Ee(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:Ee(new h(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:Ee(new h(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:Ee(new r(70,"overviewRulerLanes",3,0,3)),padding:Ee(new G),parameterHints:Ee(new X),peekWidgetDefaultFocus:Ee(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:Ee(new h(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:Ee(new pe),quickSuggestionsDelay:Ee(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:Ee(new h(77,"readOnly",!1)),renameOnType:Ee(new h(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:Ee(new h(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:Ee(new h(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:Ee(new h(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:Ee(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new h(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:Ee(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:Ee(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new h(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:Ee(new We),scrollbar:Ee(new q),scrollBeyondLastColumn:Ee(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:Ee(new h(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:Ee(new h(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:Ee(new h(93,"selectionClipboard",!0,{description:b.localize(201,null),included:I.isLinux})),selectionHighlight:Ee(new h(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:Ee(new h(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:Ee(new h(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:Ee(new h(121,"showDeprecated",!0,{description:b.localize(207,null)})),inlineHints:Ee(new R),snippetSuggestions:Ee(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:Ee(new le),smoothScrolling:Ee(new h(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:Ee(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ne),suggestFontSize:Ee(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:Ee(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:Ee(new h(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:Ee(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:Ee(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:Ee(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useTabStops:Ee(new h(111,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:Ee(new g(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:Ee(new S(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new g(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new g(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:Ee(new S(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new S(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new f(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:Ee(new S(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:Ee(new w),pixelRatio:Ee(new se),tabFocusMode:Ee(new me),layoutInfo:Ee(new ee),wrappingInfo:Ee(new ge)}}),define(be[124],_e([16,17]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[125],_e([16,17]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[126],_e([16,17]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(be[127],_e([16,17]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(be[128],_e([16,17]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(be[129],_e([16,17]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(be[130],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(be[131],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[132],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(be[133],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[134],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(be[135],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[136],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[137],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[138],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[139],_e([16,17]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(be[140],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[141],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[142],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[143],_e([16,17]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[144],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[145],_e([0,1,125]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(P){return P=P.trim(),P==="*"||I.test(P)}e.isValidVersionStr=A;function T(P){if(!A(P))return null;if(P=P.trim(),P==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=P.match(I);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=T;function y(P){if(!P)return null;let d=P.majorBase,h=P.majorMustEqual,r=P.minorBase,l=P.minorMustEqual,g=P.patchBase,m=P.patchMustEqual;return P.hasCaret&&(d===0||(l=!1),m=!1),{majorBase:d,majorMustEqual:h,minorBase:r,minorMustEqual:l,patchBase:g,patchMustEqual:m,isMinimum:P.hasGreaterEquals}}e.normalizeVersion=y;function C(P,d){let h;typeof P=="string"?h=y(T(P)):h=P;let r;if(typeof d=="string"?r=y(T(d)):r=d,!h||!r)return!1;let l=h.majorBase,g=h.minorBase,m=h.patchBase,S=r.majorBase,f=r.minorBase,c=r.patchBase,p=r.majorMustEqual,t=r.minorMustEqual,i=r.patchMustEqual;return r.isMinimum?l>S?!0:l<S?!1:g>f?!0:g<f?!1:m>=c:(l===1&&S===0&&(!p||!t||!i)&&(S=1,f=0,c=0,p=!0,t=!1,i=!1),l<S?!1:l>S?!p:g<f?!1:g>f?!t:m<c?!1:m>c?!i:!0)}e.isValidVersion=C;function D(P,d,h){return d.isBuiltin||typeof d.main=="undefined"?!0:n(P,d.engines.vscode,h)}e.isValidExtensionVersion=D;function k(P,d){return P==="*"||n(d,P)}e.isEngineValid=k;function n(P,d,h=[]){let r=y(T(d));if(!r)return h.push(b.localize(0,null,d)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return h.push(b.localize(1,null,d)),!1}else if(!r.majorMustEqual)return h.push(b.localize(2,null,d)),!1;return C(P,r)?!0:(h.push(b.localize(3,null,P,d)),!1)}e.isVersionValid=n}),define(be[89],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(T,y=[],C=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=b;const I=(A,...T)=>new b(A,T);e.createSyncDescriptor=I}),define(be[61],_e([0,1,89]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function A(y,C,D){C instanceof b.SyncDescriptor||(C=new b.SyncDescriptor(C,[],D)),I.push([y,C])}e.registerSingleton=A;function T(){return I}e.getSingletonServiceDescriptors=T}),define(be[146],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=b;class I{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const C=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);C.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),C)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let C of this._nodes.values())C.outgoing.delete(y),C.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let C=this._nodes.get(y);return C||(C=new b(T),this._nodes.set(y,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,C]of this._nodes)T.push(`${y}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const C=new Set([T]),D=this._findCycle(y,C);if(D)return D}}_findCycle(T,y){for(let[C,D]of T.outgoing){if(y.has(C))return[...y,C].join(" -> ");y.add(C);const k=this._findCycle(D,y);if(k)return k;y.delete(C)}}}e.Graph=I}),define(be[4],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function I(C,D,k,n){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:C,index:k,optional:n}):(D[b.DI_DEPENDENCIES]=[{id:C,index:k,optional:n}],D[b.DI_TARGET]=D)}function A(C){if(b.serviceIds.has(C))return b.serviceIds.get(C);const D=function(k,n,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,k,P,!1)};return D.toString=()=>C,b.serviceIds.set(C,D),D}e.createDecorator=A;function T(C){return C}e.refineServiceDecorator=T;function y(C){return function(D,k,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(C,D,n,!0)}}e.optional=y}),define(be[147],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function I(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(be[148],_e([0,1,3,56,6,22,81,59,147]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(h,r){let l={selector:h,provider:r,_score:-1,_time:this._clock++};return this._entries.push(l),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(l){let g=this._entries.indexOf(l);g>=0&&(this._entries.splice(g,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),l=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const r=[];for(let l of this._entries)l._score>0&&r.push(l.provider);return r}ordered(h){const r=[];return this._orderedForEach(h,l=>r.push(l.provider)),r}orderedGroups(h){const r=[];let l,g;return this._orderedForEach(h,m=>{l&&g===m._score?l.push(m.provider):(g=m._score,l=[m.provider],r.push(l))}),r}_orderedForEach(h,r){if(!!h){this._updateScores(h);for(const l of this._entries)l._score>0&&r(l)}}_updateScores(h){let r={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let l of this._entries)if(l._score=(0,C.score)(l.selector,h.uri,h.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(h)),k(l.selector)&&l._score>0){for(let g of this._entries)g._score=0;l._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,r){return h._score<r._score?1:h._score>r._score?-1:h._time<r._time?1:h._time>r._time?-1:0}}e.LanguageFeatureRegistry=n;class P{constructor(h,r,l=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=r,this.max=l,this._cache=new T.LRUCache(50,.7)}_key(h){return h.id+(0,I.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const r=this._key(h),l=this._cache.get(r);return this._clamp(l==null?void 0:l.value)}update(h,r){const l=this._key(h);let g=this._cache.get(l);return g||(g=new y.MovingAverage,this._cache.set(l,g)),g.update(r),this.get(h)}}e.LanguageFeatureRequestDelays=P}),define(be[62],_e([0,1,2,32,148,119,36]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(E,F){this.language=E,this.id=F}}e.LanguageIdentifier=D;var k;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var n;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var P;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let F=this.getForeground(E),B="mtk"+F,Y=this.getFontStyle(E);return Y&1&&(B+=" mtki"),Y&2&&(B+=" mtkb"),Y&4&&(B+=" mtku"),B}static getInlineStyleFromMetadata(E,F){const B=this.getForeground(E),Y=this.getFontStyle(E);let fe=`color: ${F[B]};`;return Y&1&&(fe+="font-style: italic;"),Y&2&&(fe+="font-weight: bold;"),Y&4&&(fe+="text-decoration: underline;"),fe}}e.TokenMetadata=h;var r;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let v=Object.create(null);return v[0]="symbol-method",v[1]="symbol-function",v[2]="symbol-constructor",v[3]="symbol-field",v[4]="symbol-variable",v[5]="symbol-class",v[6]="symbol-struct",v[7]="symbol-interface",v[8]="symbol-module",v[9]="symbol-property",v[10]="symbol-event",v[11]="symbol-operator",v[12]="symbol-unit",v[13]="symbol-value",v[14]="symbol-constant",v[15]="symbol-enum",v[16]="symbol-enum-member",v[17]="symbol-keyword",v[27]="symbol-snippet",v[18]="symbol-text",v[19]="symbol-color",v[20]="symbol-file",v[21]="symbol-reference",v[22]="symbol-customcolor",v[23]="symbol-folder",v[24]="symbol-type-parameter",v[25]="account",v[26]="issues",function(E){const F=v[E];let B=F&&y.iconRegistry.get(F);return B||(console.info("No codicon found for CompletionItemKind "+E),B=y.Codicon.symbolProperty),B.classNames}}(),e.completionKindFromString=function(){let v=Object.create(null);return v.method=0,v.function=1,v.constructor=2,v.field=3,v.variable=4,v.class=5,v.struct=6,v.interface=7,v.module=8,v.property=9,v.event=10,v.operator=11,v.unit=12,v.value=13,v.constant=14,v.enum=15,v["enum-member"]=16,v.enumMember=16,v.keyword=17,v.snippet=27,v.text=18,v.color=19,v.file=20,v.reference=21,v.customcolor=22,v.folder=23,v["type-parameter"]=24,v.typeParameter=24,v.account=25,v.issue=26,function(E,F){let B=v[E];return typeof B=="undefined"&&!F&&(B=9),B}}();var l;(function(v){v[v.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(S=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(v){return v&&b.URI.isUri(v.uri)&&I.Range.isIRange(v.range)&&(I.Range.isIRange(v.originSelectionRange)||I.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=p;var t;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(v){v[v.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var o;(function(v){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function B(V){return E.get(V)}v.fromString=B;function Y(V){return F.get(V)}v.toString=Y;function fe(V,z){const ee=F.get(V);let $=ee&&y.iconRegistry.get("symbol-"+ee);return $||(console.info("No codicon found for SymbolKind "+V),$=y.Codicon.symbolProperty),`${z?"inline":"block"} ${$.classNames}`}v.toCssClassName=fe})(o=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(E){this.value=E}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var s;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var w;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(w=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var _;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[149],_e([0,1,6,10,4,3,45,43]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const r=[];for(let g of D.description.args)r.push(g.constraint);const l=D.handler;D.handler=function(g,...m){return(0,I.validateConstraints)(m,r),l(g,...m)}}const{id:n}=D;let P=this._commands.get(n);P||(P=new y.LinkedList,this._commands.set(n,P));let d=P.unshift(D),h=(0,b.toDisposable)(()=>{d();const r=this._commands.get(n);(r==null?void 0:r.isEmpty())&&this._commands.delete(n)});return this._onDidRegisterCommand.fire(n),h}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(n,...P)=>n.get(e.ICommandService).executeCommand(k,...P))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const n=this.getCommand(k);n&&D.set(k,n)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(be[63],_e([0,1,8,4,21]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0),y.set("isIPad",T.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(v){v[v.False=0]="False",v[v.True=1]="True",v[v.Defined=2]="Defined",v[v.Not=3]="Not",v[v.Equals=4]="Equals",v[v.NotEquals=5]="NotEquals",v[v.And=6]="And",v[v.Regex=7]="Regex",v[v.NotRegex=8]="NotRegex",v[v.Or=9]="Or",v[v.In=10]="In",v[v.NotIn=11]="NotIn",v[v.Greater=12]="Greater",v[v.GreaterEquals=13]="GreaterEquals",v[v.Smaller=14]="Smaller",v[v.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return P.INSTANCE}static true(){return d.INSTANCE}static has(E){return h.create(E)}static equals(E,F){return r.create(E,F)}static notEquals(E,F){return m.create(E,F)}static regex(E,F){return i.create(E,F)}static in(E,F){return l.create(E,F)}static not(E){return S.create(E)}static and(...E){return a.create(E)}static or(...E){return s.create(E)}static greater(E,F){return f.create(E,F)}static less(E,F){return p.create(E,F)}static deserialize(E,F=!1){if(!!E)return this._deserializeOrExpression(E,F)}static _deserializeOrExpression(E,F){let B=E.split("||");return s.create(B.map(Y=>this._deserializeAndExpression(Y,F)))}static _deserializeAndExpression(E,F){let B=E.split("&&");return a.create(B.map(Y=>this._deserializeOne(Y,F)))}static _deserializeOne(E,F){if(E=E.trim(),E.indexOf("!=")>=0){let B=E.split("!=");return m.create(B[0].trim(),this._deserializeValue(B[1],F))}if(E.indexOf("==")>=0){let B=E.split("==");return r.create(B[0].trim(),this._deserializeValue(B[1],F))}if(E.indexOf("=~")>=0){let B=E.split("=~");return i.create(B[0].trim(),this._deserializeRegexValue(B[1],F))}if(E.indexOf(" in ")>=0){let B=E.split(" in ");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const B=E.split(">=");return c.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const B=E.split(">");return f.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const B=E.split("<=");return t.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const B=E.split("<");return p.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(E)?S.create(E.substr(1).trim()):h.create(E)}static _deserializeValue(E,F){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let B=/^'([^']*)'$/.exec(E);return B?B[1].trim():E}static _deserializeRegexValue(E,F){if((0,b.isFalsyOrWhitespace)(E)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=E.indexOf("/"),Y=E.lastIndexOf("/");if(B===Y||B<0){if(F)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let fe=E.slice(B+1,Y),V=E[Y+1]==="i"?"i":"";try{return new RegExp(fe,V)}catch(z){if(F)throw new Error(`bad regexp-value '${E}', parse error: ${z}`);return console.warn(`bad regexp-value '${E}', parse error: ${z}`),null}}}e.ContextKeyExpr=k;function n(v,E){return v.cmp(E)}class P{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class d{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class h{constructor(E){this.key=E,this.type=2}static create(E){const F=y.get(E);return typeof F=="boolean"?F?d.INSTANCE:P.INSTANCE:new h(E)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=h;class r{constructor(E,F){this.key=E,this.value=F,this.type=4}static create(E,F){if(typeof F=="boolean")return F?h.create(E):S.create(E);const B=y.get(E);return typeof B=="boolean"?F===(B?"true":"false")?d.INSTANCE:P.INSTANCE:new r(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class l{constructor(E,F){this.key=E,this.valueKey=F,this.type=10}static create(E,F){return new l(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}evaluate(E){const F=E.getValue(this.valueKey),B=E.getValue(this.key);return Array.isArray(F)?F.indexOf(B)>=0:typeof B=="string"&&typeof F=="object"&&F!==null?C.call(F,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return g.create(this)}}e.ContextKeyInExpr=l;class g{constructor(E){this._actual=E,this.type=11}static create(E){return new g(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new g(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class m{constructor(E,F){this.key=E,this.value=F,this.type=5}static create(E,F){if(typeof F=="boolean")return F?S.create(E):h.create(E);const B=y.get(E);return typeof B=="boolean"?F===(B?"true":"false")?P.INSTANCE:d.INSTANCE:new m(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class S{constructor(E){this.key=E,this.type=3}static create(E){const F=y.get(E);return typeof F=="boolean"?F?P.INSTANCE:d.INSTANCE:new S(E)}cmp(E){return E.type!==this.type?this.type-E.type:w(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=S;class f{constructor(E,F){this.key=E,this.value=F,this.type=12}static create(E,F){return new f(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class c{constructor(E,F){this.key=E,this.value=F,this.type=13}static create(E,F){return new c(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class p{constructor(E,F){this.key=E,this.value=F,this.type=14}static create(E,F){return new p(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=p;class t{constructor(E,F){this.key=E,this.value=F,this.type=15}static create(E,F){return new t(E,F)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}evaluate(E){return parseFloat(E.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(E,F){this.key=E,this.regexp=F,this.type=7}static create(E,F){return new i(E,F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const F=this.regexp?this.regexp.source:"",B=E.regexp?E.regexp.source:"";return F<B?-1:F>B?1:0}equals(E){if(E.type===this.type){const F=this.regexp?this.regexp.source:"",B=E.regexp?E.regexp.source:"";return this.key===E.key&&F===B}return!1}evaluate(E){let F=E.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return o.create(this)}}e.ContextKeyRegexExpr=i;class o{constructor(E){this._actual=E,this.type=8}static create(E){return new o(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new o(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;class a{constructor(E){this.expr=E,this.type=6}static create(E){return a._normalizeArr(E)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Y=n(this.expr[F],E.expr[F]);if(Y!==0)return Y}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(E))return!1;return!0}static _normalizeArr(E){const F=[];let B=!1;for(const Y of E)if(!!Y){if(Y.type===1){B=!0;continue}if(Y.type===0)return P.INSTANCE;if(Y.type===6){F.push(...Y.expr);continue}F.push(Y)}if(F.length===0&&B)return d.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(n);F.length>1;){const Y=F[F.length-1];if(Y.type!==9)break;F.pop();const fe=F.pop(),V=s.create(Y.expr.map(z=>a.create([z,fe])));V&&(F.push(V),F.sort(n))}return F.length===1?F[0]:new a(F)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new a(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let F of this.expr)E.push(F.negate());return s.create(E)}}e.ContextKeyAndExpr=a;class s{constructor(E){this.expr=E,this.type=9}static create(E){const F=s._normalizeArr(E);if(F.length!==0)return F.length===1?F[0]:new s(F)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Y=n(this.expr[F],E.expr[F]);if(Y!==0)return Y}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(E.expr[F]))return!1;return!0}return!1}evaluate(E){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(E))return!0;return!1}static _normalizeArr(E){let F=[],B=!1;if(E){for(let Y=0,fe=E.length;Y<fe;Y++){const V=E[Y];if(!!V){if(V.type===0){B=!0;continue}if(V.type===1)return[d.INSTANCE];if(V.type===9){F=F.concat(V.expr);continue}F.push(V)}}if(F.length===0&&B)return[P.INSTANCE];F.sort(n)}return F}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let F of this.expr)E.push(...F.keys());return E}map(E){return new s(this.expr.map(F=>F.map(E)))}negate(){let E=[];for(let B of this.expr)E.push(B.negate());const F=B=>B.type===9?B.expr:[B];for(;E.length>1;){const B=E.shift(),Y=E.shift(),fe=[];for(const V of F(B))for(const z of F(Y))fe.push(k.and(V,z));E.unshift(k.or(...fe))}return E[0]}}e.ContextKeyOrExpr=s;class u extends h{constructor(E,F,B){super(E);this._defaultValue=F,typeof B=="object"?u._info.push(Object.assign(Object.assign({},B),{key:E})):B!==!0&&u._info.push({key:E,description:B,type:F!=null?typeof F:void 0})}static all(){return u._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(E){return k.equals(this.key,E)}notEqualsTo(E){return k.notEquals(this.key,E)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(v,E){return v<E?-1:v>E?1:0}function _(v,E,F,B){return v<F?-1:v>F?1:E<B?-1:E>B?1:0}}),define(be[150],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],_e([0,1,8,4]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,P){if(typeof n=="undefined"||n===null)return typeof P=="undefined"||P===null;if(typeof P=="undefined"||P===null)return!1;if(typeof n=="string"||typeof P=="string"){let d=typeof n=="string"?n:n.value,h=typeof P=="string"?P:P.value;return b.equalsIgnoreCase(d,h)}return n._lower===P._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=y;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[151],_e([0,1,8,26]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,b.compareIgnoreCase)(h.id,r.id)===0}e.areSameExtensions=A;class T{constructor(r,l){this.version=l,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?A(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(h,r){return`${h}.${r}`}e.getExtensionId=y;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(h,r){return C(y(h,r))}e.getGalleryExtensionId=D;function k(h,r){const l=[],g=m=>{for(const S of l)if(S.some(f=>A(r(f),r(m))))return S;return null};for(const m of h){const S=g(m);S?S.push(m):l.push([m])}return l}e.groupByExtension=k;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function P(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function d(h){const r=new Set;for(const l of h)l.malicious&&r.add(l.id.id);return r}e.getMaliciousExtensionsSet=d}),define(be[64],_e([0,1,126,13,2,4,8,10,22]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var n;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var P;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(P=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function h(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=h;function r(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function l(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=l;var g;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(z,ee){super(z);this.code=ee}}e.FileSystemProviderError=m;function S(V,z){const ee=new m(V.toString(),z);return c(ee,z),ee}e.createFileSystemProviderError=S;function f(V){return V||S((0,b.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=f;function c(V,z){return V.name=z?`${z} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=c;function p(V){if(!V)return g.Unknown;if(V instanceof m)return V.code;const z=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!z)return g.Unknown;switch(z[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=p;function t(V){if(V instanceof w)return V.fileOperationResult;switch(p(V)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(z,ee,$){this.resource=z,this.operation=ee,this.target=$}isOperation(z){return this.operation===z}}e.FileOperationEvent=o;var a;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class s{constructor(z,ee){this.ignorePathCasing=ee,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=z;for(const $ of z)switch($.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(z,...ee){return this.doContains(z,{includeChildren:!1},...ee)}affects(z,...ee){return this.doContains(z,{includeChildren:!0},...ee)}doContains(z,ee,...$){var R,L,M,U,G,X;if(!z)return!1;const se=$.length>0;return!!((!se||$.includes(1))&&(((R=this.added)===null||R===void 0?void 0:R.get(z))||ee.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(z)))||(!se||$.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(z))||ee.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(z)))||(!se||$.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(z))||ee.includeChildren&&((X=this.deleted)===null||X===void 0?void 0:X.findSuperstr(z))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(z){const ee=[],$=z===1?this.added:z===0?this.updated:this.deleted;if($)for(const[,R]of $)ee.push(R);return ee}filter(z){return new s(this.changes.filter(ee=>z(ee)),this.ignorePathCasing)}}e.FileChangesEvent=s;function u(V,z,ee){return!V||!z||V===z||z.length>V.length?!1:(z.charAt(z.length-1)!==I.sep&&(z+=I.sep),ee?(0,y.startsWithIgnoreCase)(V,z):V.indexOf(z)===0)}e.isParent=u;class w extends Error{constructor(z,ee,$){super(z);this.fileOperationResult=ee,this.options=$}static isFileOperationError(z){return z instanceof Error&&!(0,C.isUndefinedOrNull)(z.fileOperationResult)}}e.FileOperationError=w;var _;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var v;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(v=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function E(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=E;async function F(V,z){if(!z.canHandleResource(A.URI.from({scheme:V.scheme})))return new Promise(ee=>{const $=z.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===V.scheme&&R.added&&($.dispose(),ee())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<B.KB?(0,b.localize)(1,null,z.toFixed(0)):z<B.MB?(0,b.localize)(2,null,(z/B.KB).toFixed(2)):z<B.GB?(0,b.localize)(3,null,(z/B.MB).toFixed(2)):z<B.TB?(0,b.localize)(4,null,(z/B.GB).toFixed(2)):(0,b.localize)(5,null,(z/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Y;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function fe(V){return{maxFileSize:V===0?300*B.MB:16*B.GB,maxHeapSize:V===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=fe}),define(be[65],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...A){this._entries=new Map;for(let[T,y]of A)this.set(T,y)}set(A,T){const y=this._entries.get(A);return this._entries.set(A,T),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=b}),define(be[152],_e([0,1,12,146,89,4,65,11]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(r){var l;super("cyclic dependency between services");this.message=(l=r.findCycleSlow())!==null&&l!==void 0?l:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class n{constructor(r=new y.ServiceCollection,l=!1,g){this._activeInstantiations=new Set,this._services=r,this._strict=l,this._parent=g,this._services.set(T.IInstantiationService,this)}createChild(r){return new n(r,this._strict,this)}invokeFunction(r,...l){let g=d.traceInvocation(r),m=!1;try{return r({get:(f,c)=>{if(m)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(f,g);if(!p&&c!==T.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return p}},...l)}finally{m=!0,g.stop()}}createInstance(r,...l){let g,m;return r instanceof A.SyncDescriptor?(g=d.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(l),g)):(g=d.traceCreation(r),m=this._createInstance(r,l,g)),g.stop(),m}_createInstance(r,l=[],g){let m=T._util.getServiceDependencies(r).sort((c,p)=>c.index-p.index),S=[];for(const c of m){let p=this._getOrCreateServiceInstance(c.id,g);if(!p&&this._strict&&!c.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${c.id}.`);S.push(p)}let f=m.length>0?m[0].index:l.length;if(l.length!==f){console.warn(`[createInstance] First service dependency of ${r.name} at position ${f+1} conflicts with ${l.length} static arguments`);let c=f-l.length;c>0?l=l.concat(new Array(c)):l=l.slice(0,f)}return new r(...[...l,...S])}_setServiceInstance(r,l){if(this._services.get(r)instanceof A.SyncDescriptor)this._services.set(r,l);else if(this._parent)this._parent._setServiceInstance(r,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let l=this._services.get(r);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):l}_getOrCreateServiceInstance(r,l){let g=this._getServiceInstanceOrDescriptor(r);return g instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,g,l.branch(r,!0)):(l.branch(r,!1),g)}_safeCreateAndCacheServiceInstance(r,l,g){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,l,g)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,l,g){const m=new I.Graph(c=>c.id.toString());let S=0;const f=[{id:r,desc:l,_trace:g}];for(;f.length;){const c=f.pop();if(m.lookupOrInsertNode(c),S++>1e3)throw new k(m);for(let p of T._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(p.id);if(!t&&!p.optional&&console.warn(`[createInstance] ${r} depends on ${p.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const i={id:p.id,desc:t,_trace:c._trace.branch(p.id,!0)};m.insertEdge(c,i),f.push(i)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:p}of c){if(this._getServiceInstanceOrDescriptor(p.id)instanceof A.SyncDescriptor){const i=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,i)}m.removeNode(p)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,l,g=[],m,S){if(this._services.get(r)instanceof A.SyncDescriptor)return this._createServiceInstance(l,g,m,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,l,g,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(r,l=[],g,m){if(g){const S=new C.IdleValue(()=>this._createInstance(r,l,m));return new Proxy(Object.create(null),{get(f,c){if(c in f)return f[c];let p=S.value,t=p[c];return typeof t!="function"||(t=t.bind(p),f[c]=t),t},set(f,c,p){return S.value[c]=p,!0}})}else return this._createInstance(r,l,m)}}e.InstantiationService=n;var P;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(P||(P={}));class d{constructor(r,l){this.type=r,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return D?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return D?new d(0,r.name):d._None}branch(r,l){let g=new d(2,r.toString());return this._dep.push([r,l,g]),g}stop(){let r=Date.now()-this._start;d._totals+=r;let l=!1;function g(S,f){let c=[],p=new Array(S+1).join("	");for(const[t,i,o]of f._dep)if(i&&o){l=!0,c.push(`${p}CREATES -> ${t}`);let a=g(S+1,o);a&&c.push(a)}else c.push(`${p}uses -> ${t}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||l)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(be[18],_e([0,1,4,6,21,3,60]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class n extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(D.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(D.Error,this.format(o))}else this.log(D.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let o=0;o<t.length;o++){let a=t[o];if(typeof a=="object")try{a=JSON.stringify(a)}catch(s){}i+=(o>0?" ":"")+a}return i}}e.AbstractMessageLogger=n;class P extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...i){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}debug(t,...i){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}info(t,...i){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}warn(t,...i){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...i):console.warn(`[main ${C()}]`,t,...i))}error(t,...i){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...i):console.error(`[main ${C()}]`,t,...i))}critical(t,...i){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...i):console.error(`[main ${C()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class d extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends k{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const o of this.logServices)o.trace(t,...i)}debug(t,...i){for(const o of this.logServices)o.debug(t,...i)}info(t,...i){for(const o of this.logServices)o.info(t,...i)}warn(t,...i){for(const o of this.logServices)o.warn(t,...i)}error(t,...i){for(const o of this.logServices)o.error(t,...i)}critical(t,...i){for(const o of this.logServices)o.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class l extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=l;class g extends I.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}createLogger(t,i){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,(i==null?void 0:i.always)?D.Trace:this.logLevel,i),this.loggers.set(t.toString(),o),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=m;function S(p){if(p.verbose)return D.Trace;if(typeof p.logLevel=="string"){const t=f(p.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function f(p){switch(p){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=f;function c(p){switch(p){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=c}),define(be[90],_e([0,1,4,127,47]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(r,l){return l-r}D.compare=k;const n=Object.create(null);n[D.Error]=(0,I.localize)(0,null),n[D.Warning]=(0,I.localize)(1,null),n[D.Info]=(0,I.localize)(2,null);function P(r){return n[r]||""}D.toString=P;function d(r){switch(r){case A.default.Error:return D.Error;case A.default.Warning:return D.Warning;case A.default.Info:return D.Info;case A.default.Ignore:return D.Hint}}D.fromSeverity=d;function h(r){switch(r){case D.Error:return A.default.Error;case D.Warning:return A.default.Warning;case D.Info:return A.default.Info;case D.Hint:return A.default.Ignore}}D.toSeverity=h}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const k="";function n(d){return P(d,!0)}D.makeKey=n;function P(d,h){let r=[k];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(k),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(k),d.severity!==void 0&&d.severity!==null?r.push(y.toString(d.severity)):r.push(k),d.message&&h?r.push(d.message.replace("\xA6","\\\xA6")):r.push(k),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(k),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(k),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(k),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}D.makeKeyOptionalMessage=P})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(be[153],_e([0,1,47,4,3]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=D});var Ve=this&&this.__decorate||function(Q,e,b,I){var A=arguments.length,T=A<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,b):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,b,I);else for(var C=Q.length-1;C>=0;C--)(y=Q[C])&&(T=(A<3?y(T):A>3?y(e,b,T):y(e,b))||T);return A>3&&T&&Object.defineProperty(e,b,T),T},qe=this&&this.__param||function(Q,e){return function(b,I){e(b,I,Q)}};define(be[154],_e([0,1,4,20,6,11]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends A.Disposable{constructor(P,d){super();this.deferred=new T.DeferredPromise,d.withProgress(P,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=Ve([qe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends A.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(P){this.stop();const d=++this.currentOperationId,h=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:h.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(be[29],_e([0,1,10,42]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,C){I.ok(b.isString(y)),I.ok(b.isObject(C)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,C)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(be[91],_e([0,1,29,3]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[A(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;b.Registry.add(e.Extensions.JSONContribution,y)}),define(be[66],_e([0,1,124,3,29,10,91]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=A.Registry.as(y.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,S=!0){this.registerConfigurations([m],S)}registerConfigurations(m,S=!0){const f=[];m.forEach(c=>{f.push(...this.validateAndRegisterProperties(c,S,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(m){const S=[],f=c=>{if(c.properties)for(const p in c.properties)S.push(p),delete this.configurationProperties[p],this.removeFromSchema(p,c.properties[p]);c.allOf&&c.allOf.forEach(p=>f(p))};for(const c of m){f(c);const p=this.configurationContributors.indexOf(c);p!==-1&&this.configurationContributors.splice(p,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(m){const S=[],f=[];for(const c of m)for(const p in c)if(S.push(p),e.OVERRIDE_PROPERTY_PATTERN.test(p)){this.defaultValues[p]=Object.assign(Object.assign({},this.defaultValues[p]||{}),c[p]);const t={type:"object",default:this.defaultValues[p],description:b.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId};f.push(P(p)),this.configurationProperties[p]=t,this.defaultLanguageConfigurationOverridesNode.properties[p]=t}else{this.defaultValues[p]=c[p];const t=this.configurationProperties[p];t&&(this.updatePropertyDefaultValue(p,t),this.updateSchema(p,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(m){const S=[];for(const f of m)for(const c in f)if(S.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const p=this.configurationProperties[c];p&&(this.updatePropertyDefaultValue(c,p),this.updateSchema(c,p))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const S of m)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,S=!0,f,c=3){var p;c=T.isUndefinedOrNull(m.scope)?c:m.scope;let t=[],i=m.properties;if(i)for(let a in i){if(S&&r(a)){delete i[a];continue}const s=i[a];if(this.updatePropertyDefaultValue(a,s),e.OVERRIDE_PROPERTY_PATTERN.test(a)?s.scope=void 0:(s.scope=T.isUndefinedOrNull(s.scope)?c:s.scope,s.requireTrust=T.isUndefinedOrNull(s.requireTrust)?!!((p=f==null?void 0:f.requireTrustForConfigurations)===null||p===void 0?void 0:p.includes(a)):s.requireTrust),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),t.push(a)}let o=m.allOf;if(o)for(let a of o)t.push(...this.validateAndRegisterProperties(a,S,f,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const S=f=>{let c=f.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let p=f.allOf;p&&p.forEach(S)};S(m)}updateSchema(m,S){switch(e.allSettings.properties[m]=S,S.scope){case 1:e.applicationSettings.properties[m]=S;break;case 2:e.machineSettings.properties[m]=S;break;case 6:e.machineOverridableSettings.properties[m]=S;break;case 3:e.windowSettings.properties[m]=S;break;case 4:e.resourceSettings.properties[m]=S;break;case 5:e.resourceSettings.properties[m]=S,this.resourceLanguageSettingsSchema.properties[m]=S;break}}removeFromSchema(m,S){switch(delete e.allSettings.properties[m],S.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const S=`[${m}]`,f={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,f),e.allSettings.properties[S]=f,e.applicationSettings.properties[S]=f,e.machineSettings.properties[S]=f,e.machineOverridableSettings.properties[S]=f,e.windowSettings.properties[S]=f,e.resourceSettings.properties[S]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,S){let f=this.defaultValues[m];T.isUndefined(f)&&(f=S.default),T.isUndefined(f)&&(f=d(S.type)),S.default=f}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function P(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=P;function d(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new k;A.Registry.add(e.Extensions.Configuration,h);function r(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?b.localize(5,null,g):h.getConfigurationProperties()[g]!==void 0?b.localize(6,null,g):null:b.localize(4,null)}e.validateProperty=r;function l(){const g=[],m=h.getConfigurationProperties();for(const S of Object.keys(m))g.push([S,m[S].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=l}),define(be[92],_e([0,1,24,10,2,29,4,66]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof A.URI)}e.isConfigurationOverrides=D;var k;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function P(i,o){const a=o?i?o.keys.filter(F=>i.keys.indexOf(F)===-1):[...o.keys]:[],s=i?o?i.keys.filter(F=>o.keys.indexOf(F)===-1):[...i.keys]:[],u=[];if(o&&i){for(const F of i.keys)if(o.keys.indexOf(F)!==-1){const B=m(i.contents,F),Y=m(o.contents,F);b.equals(B,Y)||u.push(F)}}const w=[],_=F=>{const B={};for(const Y of F)for(const fe of Y.identifiers)B[p(fe)]=Y;return B},v=o?_(o.overrides):{},E=i?_(i.overrides):{};if(Object.keys(v).length)for(const F of a){const B=v[F];B&&w.push([(0,C.overrideIdentifierFromKey)(F),B.keys])}if(Object.keys(E).length)for(const F of s){const B=E[F];B&&w.push([(0,C.overrideIdentifierFromKey)(F),B.keys])}if(Object.keys(v).length&&Object.keys(E).length)for(const F of u){const B=E[F],Y=v[F];if(B&&Y){const fe=P({contents:B.contents,keys:B.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});w.push([(0,C.overrideIdentifierFromKey)(F),[...fe.added,...fe.removed,...fe.updated]])}}return{added:a,removed:s,updated:u,overrides:w}}e.compare=P;function d(i,o){const a=[];for(const s of Object.keys(i))if(C.OVERRIDE_PROPERTY_PATTERN.test(s)){const u={};for(const w in i[s])u[w]=i[s][w];a.push({identifiers:[(0,C.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(u),contents:h(u,o)})}return a}e.toOverrides=d;function h(i,o){const a=Object.create(null);for(let s in i)r(a,s,i[s],o);return a}e.toValuesTree=h;function r(i,o,a,s){const u=o.split("."),w=u.pop();let _=i;for(let v=0;v<u.length;v++){let E=u[v],F=_[E];switch(typeof F){case"undefined":F=_[E]=Object.create(null);break;case"object":break;default:s(`Ignoring ${o} as ${u.slice(0,v+1).join(".")} is ${JSON.stringify(F)}`);return}_=F}if(typeof _=="object"&&_!==null)try{_[w]=a}catch(v){s(`Ignoring ${o} as ${u.join(".")} is ${JSON.stringify(_)}`)}else s(`Ignoring ${o} as ${u.join(".")} is ${JSON.stringify(_)}`)}e.addToValueTree=r;function l(i,o){const a=o.split(".");g(i,a)}e.removeFromValueTree=l;function g(i,o){const a=o.shift();if(o.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const s=i[a];typeof s=="object"&&!Array.isArray(s)&&(g(s,o),Object.keys(s).length===0&&delete i[a])}}function m(i,o,a){function s(_,v){let E=_;for(const F of v){if(typeof E!="object"||E===null)return;E=E[F]}return E}const u=o.split("."),w=s(i,u);return typeof w=="undefined"?a:w}e.getConfigurationValue=m;function S(i,o,a){Object.keys(o).forEach(s=>{s!=="__proto__"&&(s in i?I.isObject(i[s])&&I.isObject(o[s])?S(i[s],o[s],a):a&&(i[s]=o[s]):i[s]=o[s])})}e.merge=S;function f(){const i=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=f;function c(){const i=Object.create(null),o=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let a in o){let s=o[a].default;r(i,a,s,u=>console.error(`Conflict in default settings: ${u}`))}return i}e.getDefaultValues=c;function p(i){return`[${i}]`}e.keyFromOverrideIdentifier=p;function t(i,o,a){const s=i.inspect(o),u=i.inspect(a);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:s.defaultValue}e.getMigratedSettingValue=t}),define(be[155],_e([0,1,44,22,15,10,24,2,66,92,29,6,3]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},i=[],o=[]){this._contents=t,this._keys=i,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const o=this.getContentsForOverrideIdentifer(i);return o?t?(0,k.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const a of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[a],u=i[a];u&&(typeof s=="object"&&typeof u=="object"?(s=y.deepClone(s),this.mergeContents(s,u)):s=u),o[a]=s}return new h(o,this.keys,this.overrides)}merge(...t){const i=y.deepClone(this.contents),o=y.deepClone(this.overrides),a=[...this.keys];for(const s of t){this.mergeContents(i,s.contents);for(const u of s.overrides){const[w]=o.filter(_=>A.equals(_.identifiers,u.identifiers));w?this.mergeContents(w.contents,u.contents):o.push(y.deepClone(u))}for(const u of s.keys)a.indexOf(u)===-1&&a.push(u)}return new h(i,a,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const o of Object.keys(i)){if(o in t&&T.isObject(t[o])&&T.isObject(i[o])){this.mergeContents(t[o],i[o]);continue}t[o]=y.deepClone(i[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,k.addToValueTree)(this.contents,t,i,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let o=0;o<i;o++)t.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class r extends h{constructor(){const t=(0,k.getDefaultValues)(),i=(0,k.getConfigurationKeys)(),o=[];for(const a of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(a)&&o.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,k.toValuesTree)(t[a],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,i,o)}}e.DefaultConfigurationModel=r;class l{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._untrustedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get untrustedConfigurations(){return this._untrustedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!T.isUndefinedOrNull(t)){const o=this.doParseContent(t);this.parseRaw(o,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:o,keys:a,overrides:s,untrusted:u}=this.doParseRaw(t,i);this._configurationModel=new h(o,a,s),this._untrustedConfigurations=u||[]}doParseContent(t){let i={},o=null,a=[],s=[],u=[];function w(v){Array.isArray(a)?a.push(v):o&&(a[o]=v)}let _={onObjectBegin:()=>{let v={};w(v),s.push(a),a=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{a=s.pop()},onArrayBegin:()=>{let v=[];w(v),s.push(a),a=v,o=null},onArrayEnd:()=>{a=s.pop()},onLiteralValue:w,onError:(v,E,F)=>{u.push({error:v,offset:E,length:F})}};if(t)try{b.visit(t,_),i=a[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return i}doParseRaw(t,i){const o=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,o,!0,i);t=a.raw;const s=(0,k.toValuesTree)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),u=Object.keys(t),w=(0,k.toOverrides)(t,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:s,keys:u,overrides:w,untrusted:a.untrusted}}filter(t,i,o,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.isUntrusted))return{raw:t,untrusted:[]};const s={},u=[];for(let w in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(w)&&o){const _=this.filter(t[w],i,!1,a);s[w]=_.raw,u.push(..._.untrusted)}else{const _=i[w],v=_?typeof _.scope!="undefined"?_.scope:3:void 0;(v===void 0||a.scopes===void 0||a.scopes.includes(v))&&(a.isUntrusted&&(_==null?void 0:_.requireTrust)?u.push(w):s[w]=t[w])}return{raw:s,untrusted:u}}}e.ConfigurationModelParser=l;class g extends P.Disposable{constructor(t,i,o,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getUntrustedSettings(){return this.parser.untrustedConfigurations}}e.UserSettings=g;class m{constructor(t,i,o=new h,a=new h,s=new I.ResourceMap,u=new h,w=new I.ResourceMap,_=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=a,this._folderConfigurations=s,this._memoryConfiguration=u,this._memoryConfigurationByResource=w,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(t)}updateValue(t,i,o={}){let a;o.resource?(a=this._memoryConfigurationByResource.get(o.resource),a||(a=new h,this._memoryConfigurationByResource.set(o.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,o){const a=this.getConsolidateConfigurationModel(i,o),s=this.getFolderConfigurationModelForResource(i.resource,o),u=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),_=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),v=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),E=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,B=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,Y=i.overrideIdentifier?u.override(i.overrideIdentifier).getValue(t):u.getValue(t),fe=a.getValue(t),V=A.distinct(A.flatten(a.overrides.map(z=>z.identifiers))).filter(z=>a.getOverrideValue(t,z)!==void 0);return{defaultValue:w,userValue:_,userLocalValue:v,userRemoteValue:E,workspaceValue:F,workspaceFolderValue:B,memoryValue:Y,value:fe,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:E!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:i.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:u.getValue(t),override:i.overrideIdentifier?u.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const o=i.filter(a=>D.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const s=(0,D.overrideIdentifierFromKey)(a),u=this._defaultConfiguration.getKeysForOverrideIdentifier(s),w=t.getKeysForOverrideIdentifier(s),_=[...w.filter(v=>u.indexOf(v)===-1),...u.filter(v=>w.indexOf(v)===-1),...u.filter(v=>!y.equals(this._defaultConfiguration.override(s).getValue(v),t.override(s).getValue(v)))];return[s,_]});return this.updateDefaultConfiguration(t),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:o,removed:a,overrides:s}=(0,k.compare)(this.localUserConfiguration,t),u=[...i,...o,...a];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:o,removed:a,overrides:s}=(0,k.compare)(this.remoteUserConfiguration,t);let u=[...i,...o,...a];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:o,removed:a,overrides:s}=(0,k.compare)(this.workspaceConfiguration,t);let u=[...i,...o,...a];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:s}}compareAndUpdateFolderConfiguration(t,i){const o=this.folderConfigurations.get(t),{added:a,updated:s,removed:u,overrides:w}=(0,k.compare)(o,i);let _=[...a,...s,...u];return(_.length||!o)&&this.updateFolderConfiguration(t,i),{keys:_,overrides:w}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:a,removed:s,overrides:u}=(0,k.compare)(i,void 0);return{keys:[...o,...a,...s],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(o=this.getFolderConsolidatedConfiguration(a.uri)||o);const s=this._memoryConfigurationByResource.get(t);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=o.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=o}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const o=i.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:o,overrides:a,keys:s}=this._folderConfigurations.get(i);return t.push([i,{contents:o,overrides:a,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((u,w)=>(u.set(C.URI.revive(w[0]),this.parseConfigurationModel(w[1])),u),new I.ResourceMap);return new m(i,o,new h,a,s,new h,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function S(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const t=new Set,i=new Map;for(const a of p)a.keys.forEach(s=>t.add(s)),a.overrides.forEach(([s,u])=>{const w=(0,I.getOrSet)(i,s,new Set);u.forEach(_=>w.add(_))});const o=[];return i.forEach((a,s)=>o.push([s,[...a.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=S;class f{constructor(t,i,o,a){this.change=t,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=a,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(w=>s.add(w)),t.overrides.forEach(([,w])=>w.forEach(_=>s.add(_))),this.affectedKeys=[...s.values()];const u=new h;this.affectedKeys.forEach(w=>u.setValue(w,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,s=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!y.equals(a,s)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let o=(0,k.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof o=="object"&&(a=Object.keys(o)[0]);){if(t=t[a],!t)return!1;o=o[a]}return!0}}e.ConfigurationChangeEvent=f;class c extends f{constructor(t,i,o,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=o,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=c}),define(be[67],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(C,D=A.Unknown,k){super(C);this._message=C,this._code=D,this._detail=k,this.isHandled=D===A.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===A.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===A.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}}e.RemoteAuthorityResolverError=T}),define(be[93],_e([0,1,19]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function A(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=A;function T(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(k=>T(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function C(D){var k;return(k=y(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(be[156],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,y=5){let C;return C=T(D=>{const k=typeof D=="string"?D:D.data;let n=this._terminalBufferMap.get(A);if(n){n.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(A),y);n={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(A),C.dispose()}},this._terminalBufferMap.set(A,n)}),C}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=b}),define(be[157],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(be[158],_e([0,1,4,6,29,3,157,36]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(g){function m(S){return S&&typeof S=="object"&&typeof S.id=="string"}g.isThemeColor=m})(D=e.ThemeColor||(e.ThemeColor={}));function k(g){return{id:g}}e.themeColorFromId=k;var n;(function(g){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}g.isThemeIcon=m;const S=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function f(t){const i=S.exec(t);if(!!i){let[,o]=i;return{id:o}}}g.fromString=f;function c(t,i){let o=t.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),i&&(o=`${o}~${i}`),{id:o}}g.modify=c;function p(t,i){var o,a;return t.id===i.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((a=i.color)===null||a===void 0?void 0:a.id)}g.isEqual=p,g.asClassNameArray=C.CSSIcon.asClassNameArray,g.asClassName=C.CSSIcon.asClassName,g.asCSSSelector=C.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function P(g){switch(g){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,I.toDisposable)(()=>{const S=this.themingParticipants.indexOf(m);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new d;A.Registry.add(e.Extensions.ThemingContribution,h);function r(g){return h.onColorThemeChange(g)}e.registerThemingParticipant=r;class l extends I.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,S){let f=this.theme.getColor(m);return f&&S&&(f=S(f,this.theme)),f?f.toString():null}}e.Themable=l}),define(be[159],_e([0,1,29,158,3,128,91,11,36]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,S,f,c){const p=this.iconsById[m];if(p){if(f&&!p.description){p.description=f,this.iconSchema.properties[m].markdownDescription=`${f} $(${m})`;const o=this.iconReferenceSchema.enum.indexOf(m);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=f),this._onDidChange.fire()}return p}let t={id:m,description:f,defaults:S,deprecationMessage:c};this.iconsById[m]=t;let i={$ref:"#/definitions/icons"};return c&&(i.deprecationMessage=c),f&&(i.markdownDescription=`${f}: $(${m})`),this.iconSchema.properties[m]=i,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const S=this.iconReferenceSchema.enum.indexOf(m);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,S){const f=this.iconFontsById[m];if(f)return f;let c={id:m,definition:S};return this.iconFontsById[m]=c,this._onDidChange.fire(),c}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(p,t)=>p.id.localeCompare(t.id),S=p=>{for(;I.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of c.filter(t=>!!t.description).sort(m))f.push(`|<i class="${S(p)}"></i>|${p.id}|${I.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const p of c.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(m))f.push(`|<i class="${S(p)}"></i>|${p.id}|`);return f.join(`
`)}}const n=new k;b.Registry.add(e.Extensions.IconContribution,n);function P(g,m,S,f){return n.registerIcon(g,m,S,f)}e.registerIcon=P;function d(){return n}e.getIconRegistry=d;function h(){for(const g of D.iconRegistry.all)n.registerIcon(g.id,g.definition,g.description);D.iconRegistry.onDidRegister(g=>n.registerIcon(g.id,g.definition,g.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let r=b.Registry.as(y.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,n.getIconSchema());const l=new C.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);n.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=P("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=P("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=P("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(be[48],_e([0,1,2,25,4,22]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function C(d){const h=d;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=C;function D(d){const h=d;return!!(h&&typeof h=="object"&&b.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(h,r,l,g){this._id=h,this._configuration=l,this._ignorePathCasing=g,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class n{constructor(h,r){this.raw=r,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,I.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function P(d){return new n({uri:d,index:0,name:(0,I.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=P}),define(be[160],_e([0,1,4,129,48,2,21,13,25,107,44,19,58,37,93]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const l=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(ee){return(typeof ee=="string"?(0,C.extname)(ee):(0,D.extname)(ee))===l}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function m(ee){return ee.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function S(ee){return ee.hasOwnProperty("folderUri")}e.isRecentFolder=S;function f(ee){return ee.hasOwnProperty("fileUri")}e.isRecentFile=f;function c(ee){const $=ee;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=c;function p(ee){if(ee.configuration)return{id:ee.id,configPath:ee.configuration};if(ee.folders.length===1)return{id:ee.id,uri:ee.folders[0].uri}}e.toWorkspaceIdentifier=p;function t(ee){const $=ee;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function i(ee){const $=ee;if($==null?void 0:$.uri)return{id:$.id,uri:T.URI.revive($.uri)};const R=ee;if(R==null?void 0:R.configPath)return{id:R.id,configPath:T.URI.revive(R.configPath)};if(ee==null?void 0:ee.id)return{id:ee.id}}e.reviveIdentifier=i;function o(ee,$){return D.extUriBiasedIgnorePathCase.isEqualOrParent(ee,$.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function a(ee){return s(ee)||u(ee)}e.isStoredWorkspaceFolder=a;function s(ee){const $=ee;return typeof($==null?void 0:$.path)=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=s;function u(ee){const $=ee;return typeof($==null?void 0:$.uri)=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=u;function w(ee,$,R,L,M=!y.isWindows,U){if(ee.scheme!==L.scheme)return{name:R,uri:ee.toString(!0)};let G=$?void 0:U.relativePath(L,ee);if(G!==void 0)G.length===0?G=".":y.isWindows&&ee.scheme===P.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(ee.scheme===P.Schemas.file)G=ee.fsPath,y.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,h.toSlashes)(G)));else{if(!U.isEqualAuthority(ee.authority,L.authority))return{name:R,uri:ee.toString(!0)};G=ee.path}return{name:R,path:G}}e.getStoredWorkspaceFolder=w;function _(ee,$,R){let L=[],M=new Set;const U=R.dirname($);for(let G of ee){let X=null;if(s(G))G.path&&(X=R.resolvePath(U,G.path));else if(u(G))try{X=T.URI.parse(G.uri),X.path[0]!=="/"&&(X=X.with({path:"/"+X.path}))}catch(se){console.warn(se)}if(X){let se=R.getComparisonKey(X);if(!M.has(se)){M.add(se);const pe=G.name||R.basenameOrAuthority(X);L.push(new A.WorkspaceFolder({uri:X,name:pe,index:L.length},G))}}}return L}e.toWorkspaceFolders=_;function v(ee,$,R,L,M){let U=E($,ee);const G=M.dirname($),X=M.dirname(L),se=[],pe=F(U.folders);for(const We of U.folders){const x=s(We)?M.resolvePath(G,We.path):T.URI.parse(We.uri);let q;R?q=!1:q=!s(We)||(0,C.isAbsolute)(We.path),se.push(w(x,q,We.name,X,pe,M))}const Te={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},xe=k.setProperty(ee,["folders"],se,Te);let Ae=k.applyEdits(ee,xe);return U.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Ae=k.applyEdits(Ae,k.removeProperty(Ae,["remoteAuthority"],Te))),Ae}e.rewriteWorkspaceFileForNewLocation=v;function E(ee,$){let R=n.parse($);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(L=>a(L));else throw new Error(`${ee} looks like an invalid workspace file.`);return R}function F(ee){return y.isWindows?ee.some($=>s($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function B(ee){return ee.workspace&&typeof ee.workspace=="object"&&typeof ee.workspace.id=="string"&&typeof ee.workspace.configPath=="string"}function Y(ee){return typeof ee.folderUri=="string"}function fe(ee){return typeof ee.fileUri=="string"}function V(ee,$){const R={workspaces:[],files:[]};if(ee){const L=function(U,G){for(let X=0;X<U.length;X++)try{G(U[X],X)}catch(se){$.warn(`Error restoring recent entry ${JSON.stringify(U[X])}: ${se.toString()}. Skip entry.`)}},M=ee;if(Array.isArray(M.entries))L(M.entries,U=>{const G=U.label,X=U.remoteAuthority;B(U)?R.workspaces.push({label:G,remoteAuthority:X,workspace:{id:U.workspace.id,configPath:T.URI.parse(U.workspace.configPath)}}):Y(U)?R.workspaces.push({label:G,remoteAuthority:X,folderUri:T.URI.parse(U.folderUri)}):fe(U)&&R.files.push({label:G,remoteAuthority:X,fileUri:T.URI.parse(U.fileUri)})});else{const U=ee;Array.isArray(U.workspaces3)&&L(U.workspaces3,(G,X)=>{const se=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[X]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?R.workspaces.push({label:se,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&R.workspaces.push({label:se,folderUri:T.URI.parse(G)})}),Array.isArray(U.files2)&&L(U.files2,(G,X)=>{const se=Array.isArray(U.fileLabels)&&U.fileLabels[X]||void 0;typeof G=="string"&&R.files.push({label:se,fileUri:T.URI.parse(G)})})}}return R}e.restoreRecentlyOpened=V;function z(ee){const $={entries:[]};for(const R of ee.workspaces)S(R)?$.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):$.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of ee.files)$.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return $}e.toStoreData=z}),define(be[68],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(be[161],_e([0,1,2,3]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(C=>({name:C.name,group:C.group,resource:b.URI.revive(C.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(be[49],_e([0,1,19,4]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,C){C===null?this._providerInfo.delete(y):this._providerInfo.set(y,C)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(be[162],_e([0,1,11]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,C,D){this._deferredPromises=new Map,this._id=y,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of k.values())n.complete()}catch(n){for(const P of k.values())P.error(n)}})()},0)}get whenReady(){return this._init}get(y,C){let D=this._value[y];return typeof D=="undefined"&&(D=C),D}update(y,C){this._value[y]=C;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const k=new b.DeferredPromise;return this._deferredPromises.set(y,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class A extends I{constructor(y,C){super(y.identifier.value,!0,C);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=A}),define(be[14],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class I{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=I});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[163],_e([0,1,26,3]),function(Q,e,b,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(C,D){A.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(C.identifier),tt(this,A,D,"f"),Me(this,A,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return Me(this,A,"f").get(this._id,C)}store(C,D){return Me(this,A,"f").store(this._id,C,D)}delete(C){return Me(this,A,"f").delete(this._id,C)}}e.ExtensionSecrets=T,A=new WeakMap}),define(be[94],_e([0,1,4,3]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(be[69],_e([0,1,3]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=y=>{let C=A.get(y);return C||(C={children:new Map,bus:new b.Emitter},A.set(y,C)),C};e.getPrivateApiFor=T}),define(be[70],_e([0,1,4,3,14]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function D(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public}}C.fromApiTunnel=D;function k(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public}}C.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,n,P,d){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=Ve([qe(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)},zt=this&&this.__rest||function(Q,e){var b={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(b[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(b[I[A]]=Q[I[A]]);return b};define(be[7],_e([0,1,15,12,83,22,8,10,2,31,64,67,69]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d){"use strict";var h,r,l,g,m,S,f,c,p,t,i,o,a,s,u,w;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function _(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let v=l=class{constructor(O){h.set(this,void 0),tt(this,h,O,"f")}static from(...O){let re=O;return new l(function(){if(re){for(const De of re)De&&typeof De.dispose=="function"&&De.dispose();re=void 0}})}dispose(){typeof Me(this,h,"f")=="function"&&(Me(this,h,"f").call(this),tt(this,h,void 0,"f"))}};h=new WeakMap,v=l=Ve([_],v),e.Disposable=v;let E=g=class{constructor(O,re){if(O<0)throw(0,I.illegalArgument)("line must be non-negative");if(re<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=O,this._character=re}static Min(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isBefore(re)&&(re=Ke)}return re}static Max(...O){if(O.length===0)throw new TypeError;let re=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isAfter(re)&&(re=Ke)}return re}static isPosition(O){if(!O)return!1;if(O instanceof g)return!0;let{line:re,character:De}=O;return typeof re=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,re=0){if(O===null||re===null)throw(0,I.illegalArgument)();let De;return typeof O=="undefined"?De=0:typeof O=="number"?De=O:(De=typeof O.lineDelta=="number"?O.lineDelta:0,re=typeof O.characterDelta=="number"?O.characterDelta:0),De===0&&re===0?this:new g(this.line+De,this.character+re)}with(O,re=this.character){if(O===null||re===null)throw(0,I.illegalArgument)();let De;return typeof O=="undefined"?De=this.line:typeof O=="number"?De=O:(De=typeof O.line=="number"?O.line:this.line,re=typeof O.character=="number"?O.character:this.character),De===this.line&&re===this.character?this:new g(De,re)}toJSON(){return{line:this.line,character:this.character}}};E=g=Ve([_],E),e.Position=E;let F=m=class{constructor(O,re,De,Ke){let et,st;if(typeof O=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new E(O,re),st=new E(De,Ke)):O instanceof E&&re instanceof E&&(et=O,st=re),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(O){return O instanceof m?!0:O?E.isPosition(O.start)&&E.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof m?this.contains(O._start)&&this.contains(O._end):O instanceof E?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const re=E.Max(O.start,this._start),De=E.Min(O.end,this._end);if(!re.isAfter(De))return new m(re,De)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const re=E.Min(O.start,this._start),De=E.Max(O.end,this.end);return new m(re,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,re=this.end){if(O===null||re===null)throw(0,I.illegalArgument)();let De;return O?E.isPosition(O)?De=O:(De=O.start||this.start,re=O.end||this.end):De=this.start,De.isEqual(this._start)&&re.isEqual(this.end)?this:new m(De,re)}toJSON(){return[this.start,this.end]}};F=m=Ve([_],F),e.Range=F;let B=S=class extends F{constructor(O,re,De,Ke){let et,st;if(typeof O=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new E(O,re),st=new E(De,Ke)):O instanceof E&&re instanceof E&&(et=O,st=re),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(O){return O instanceof S?!0:O?F.isRange(O)&&E.isPosition(O.anchor)&&E.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=S=Ve([_],B),e.Selection=B;class Y{constructor(O,re,De){if(typeof O!="string"||O.length===0)throw(0,I.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,I.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(re),this.connectionToken=De}}e.ResolvedAuthority=Y;class fe extends Error{constructor(O,re=P.RemoteAuthorityResolverErrorCode.Unknown,De){super(O);this._message=O,this._code=re,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,fe.prototype)}static NotAvailable(O,re){return new fe(O,P.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(O){return new fe(O,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=fe;var V;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var z;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=f=class{constructor(O,re){this._range=O,this._newText=re}static isTextEdit(O){return O instanceof f?!0:O?F.isRange(O)&&typeof O.newText=="string":!1}static replace(O,re){return new f(O,re)}static insert(O,re){return f.replace(new F(O,O),re)}static delete(O){return f.replace(O,"")}static setEndOfLine(O){const re=new f(new F(new E(0,0),new E(0,0)),"");return re.newEol=O,re}get range(){return this._range}set range(O){if(O&&!F.isRange(O))throw(0,I.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,I.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,I.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=f=Ve([_],ee),e.TextEdit=ee;var $;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellOutput=4]="CellOutput",N[N.CellReplace=5]="CellReplace",N[N.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let R=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,re,De,Ke){this._edits.push({_type:1,from:O,to:re,options:De,metadata:Ke})}createFile(O,re,De){this._edits.push({_type:1,from:void 0,to:O,options:re,metadata:De})}deleteFile(O,re,De){this._edits.push({_type:1,from:O,to:void 0,options:re,metadata:De})}replaceNotebookMetadata(O,re,De){this._edits.push({_type:3,metadata:De,uri:O,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(O,re,De,Ke,et){let st,ct,yt=[],Dt;if(xt.isNotebookRange(re)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(Ke)?(st=re.start,ct=re.end,yt=De,Dt=Ke):typeof re=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(Ke)&&(st=re,ct=De,yt=Ke,Dt=et),st===void 0||ct===void 0)throw new Error("Invalid arguments");(st!==ct||yt.length>0)&&this._edits.push({_type:5,uri:O,index:st,count:ct-st,cells:yt,metadata:Dt})}replaceNotebookCellMetadata(O,re,De,Ke){this._edits.push({_type:3,metadata:Ke,uri:O,edit:{editType:8,index:re,metadata:De}})}replace(O,re,De,Ke){this._edits.push({_type:2,uri:O,edit:new ee(re,De),metadata:Ke})}insert(O,re,De,Ke){this.replace(O,new F(re,re),De,Ke)}delete(O,re,De){this.replace(O,re,"",De)}has(O){return this._edits.some(re=>re._type===2&&re.uri.toString()===O.toString())}set(O,re){if(re)for(const De of re)De&&this._edits.push({_type:2,uri:O,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ke=this._edits[De];Ke._type===2&&Ke.uri.toString()===O.toString()&&(this._edits[De]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(O){const re=[];for(let De of this._edits)De._type===2&&De.uri.toString()===O.toString()&&re.push(De.edit);return re}entries(){const O=new T.ResourceMap;for(let re of this._edits)if(re._type===2){let De=O.get(re.uri);De||(De=[re.uri,[]],O.set(re.uri,De)),De[1].push(re.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};R=Ve([_],R),e.WorkspaceEdit=R;let L=c=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof c?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=c._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,re=this._tabstop++){if(typeof O=="function"){const De=new c;De._tabstop=this._tabstop,O(De),this._tabstop=De._tabstop,O=De.value}else O=c._escape(O);return this.value+="${",this.value+=re,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,re=this._tabstop++){const De=O.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(O,re){if(typeof re=="function"){const De=new c;De._tabstop=this._tabstop,re(De),this._tabstop=De._tabstop,re=De.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,re&&(this.value+=":",this.value+=re),this.value+="}",this}};L=c=Ve([_],L),e.SnippetString=L;var M;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=p=class{constructor(O,re){if(this.uri=O,re)if(re instanceof F)this.range=re;else if(re instanceof E)this.range=new F(re,re);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof p?!0:O?F.isRange(O.range)&&D.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=p=Ve([_],G),e.Location=G;let X=class{constructor(O,re){this.location=O,this.message=re}static is(O){return O?typeof O.message=="string"&&O.location&&F.isRange(O.location.range)&&D.URI.isUri(O.location.uri):!1}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.location.range.isEqual(re.location.range)&&O.location.uri.toString()===re.location.uri.toString()}};X=Ve([_],X),e.DiagnosticRelatedInformation=X;let se=class{constructor(O,re,De=U.Error){if(!F.isRange(O))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=O,this.message=re,this.severity=De}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,re){return O===re?!0:!O||!re?!1:O.message===re.message&&O.severity===re.severity&&O.code===re.code&&O.severity===re.severity&&O.source===re.source&&O.range.isEqual(re.range)&&(0,b.equals)(O.tags,re.tags)&&(0,b.equals)(O.relatedInformation,re.relatedInformation,X.isEqual)}};se=Ve([_],se),e.Diagnostic=se;let pe=class{constructor(O,re){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,A.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=re}};pe=Ve([_],pe),e.Hover=pe;var Te;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Te=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(O,re=Te.Text){this.range=O,this.kind=re}toJSON(){return{range:this.range,kind:Te[this.kind]}}};xe=Ve([_],xe),e.DocumentHighlight=xe;var Ae;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ae=e.SymbolKind||(e.SymbolKind={}));var We;(function(N){N[N.Deprecated=1]="Deprecated"})(We=e.SymbolTag||(e.SymbolTag={}));let x=t=class{constructor(O,re,De,Ke,et){this.name=O,this.kind=re,this.containerName=et,typeof De=="string"&&(this.containerName=De),Ke instanceof G?this.location=Ke:De instanceof F&&(this.location=new G(Ke,De)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};x=t=Ve([_],x),e.SymbolInformation=x;let q=i=class{constructor(O,re,De,Ke,et){this.name=O,this.detail=re,this.kind=De,this.range=Ke,this.selectionRange=et,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};q=i=Ve([_],q),e.DocumentSymbol=q;var ne;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(O,re){this.title=O,this.kind=re}};le=Ve([_],le),e.CodeAction=le;let me=o=class{constructor(O){this.value=O}append(O){return new o(this.value?this.value+o.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+o.sep)}};me.sep=".",me=o=Ve([_],me),e.CodeActionKind=me,me.Empty=new me(""),me.QuickFix=me.Empty.append("quickfix"),me.Refactor=me.Empty.append("refactor"),me.RefactorExtract=me.Refactor.append("extract"),me.RefactorInline=me.Refactor.append("inline"),me.RefactorRewrite=me.Refactor.append("rewrite"),me.Source=me.Empty.append("source"),me.SourceOrganizeImports=me.Source.append("organizeImports"),me.SourceFixAll=me.Source.append("fixAll");let Se=class{constructor(O,re){if(this.range=O,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=Ve([_],Se),e.SelectionRange=Se;class Oe{constructor(O,re,De,Ke,et,st){this.kind=O,this.name=re,this.detail=De,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class ge{constructor(O,re){this.fromRanges=re,this.from=O}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(O,re){this.fromRanges=re,this.to=O}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(O,re){this.range=O,this.command=re}get isResolved(){return!!this.command}};Pe=Ve([_],Pe),e.CodeLens=Pe;let $e=a=class{constructor(O,re=!1){r.set(this,void 0),tt(this,r,new A.MarkdownString(O,{supportThemeIcons:re}),"f")}static isMarkdownString(O){return O instanceof a?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Me(this,r,"f").value}set value(O){Me(this,r,"f").value=O}get isTrusted(){return Me(this,r,"f").isTrusted}set isTrusted(O){Me(this,r,"f").isTrusted=O}get supportThemeIcons(){return Me(this,r,"f").supportThemeIcons}appendText(O){return Me(this,r,"f").appendText(O),this}appendMarkdown(O){return Me(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,re){return Me(this,r,"f").appendCodeblock(re!=null?re:"",O),this}};r=new WeakMap,$e=a=Ve([_],$e),e.MarkdownString=$e;let Ee=class{constructor(O,re){this.label=O,this.documentation=re}};Ee=Ve([_],Ee),e.ParameterInformation=Ee;let je=class{constructor(O,re){this.label=O,this.documentation=re,this.parameters=[]}};je=Ve([_],je),e.SignatureInformation=je;let H=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};H=Ve([_],H),e.SignatureHelp=H;var te;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(ve=e.InlineHintKind||(e.InlineHintKind={}));let Le=class{constructor(O,re,De){this.text=O,this.range=re,this.kind=De}};Le=Ve([_],Le),e.InlineHint=Le;var He;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(N){N[N.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let W=class{constructor(O,re){this.label=O,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};W=Ve([_],W),e.CompletionItem=W;let ie=class{constructor(O=[],re=!1){this.items=O,this.isIncomplete=re}};ie=Ve([_],ie),e.CompletionList=ie;var ce;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ce=e.ViewColumn||(e.ViewColumn={}));var j;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(j=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Z;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ae;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(he=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ze;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(re){switch(re){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Be=class{constructor(O,re){if(re&&!D.URI.isUri(re))throw(0,I.illegalArgument)("target");if(!F.isRange(O)||O.isEmpty)throw(0,I.illegalArgument)("range");this.range=O,this.target=re}};Be=Ve([_],Be),e.DocumentLink=Be;let Ne=class{constructor(O,re,De,Ke){this.red=O,this.green=re,this.blue=De,this.alpha=Ke}};Ne=Ve([_],Ne),e.Color=Ne;let Ge=class{constructor(O,re){if(re&&!(re instanceof Ne))throw(0,I.illegalArgument)("color");if(!F.isRange(O)||O.isEmpty)throw(0,I.illegalArgument)("range");this.range=O,this.color=re}};Ge=Ve([_],Ge),e.ColorInformation=Ge;let nt=class{constructor(O){if(!O||typeof O!="string")throw(0,I.illegalArgument)("label");this.label=O}};nt=Ve([_],nt),e.ColorPresentation=nt;var dt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Je;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Je=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=s=class{constructor(O,re){if(typeof O!="string"||typeof re!="string")throw(0,I.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};wt.Clean=new s("clean","Clean"),wt.Build=new s("build","Build"),wt.Rebuild=new s("rebuild","Rebuild"),wt.Test=new s("test","Test"),wt=s=Ve([_],wt),e.TaskGroup=wt;function we(N){let O="";for(let re=0;re<N.length;re++)O+=N[re].replace(/,/g,",,")+",";return O}let de=class{constructor(O,re,De){if(typeof O!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=O,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=De):this._options=re)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,I.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let re of this._args)O.push(re);return we(O)}};de=Ve([_],de),e.ProcessExecution=de;let oe=class{constructor(O,re,De){if(this._args=[],Array.isArray(re)){if(!O)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,I.illegalArgument)("command");this._command=O,this._args=re,this._options=De}else{if(typeof O!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=O,this._options=re}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,I.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)O.push(typeof re=="string"?re:re.value);return we(O)}};oe=Ve([_],oe),e.ShellExecution=oe;var K;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(K=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class Ie{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ie;let Qe=u=class{constructor(O,re,De,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof re=="string"?(this._name=this.name=re,this._source=this.source=De,this.execution=Ke,ct=et,this.__deprecated=!0):re===Re.Global||re===Re.Workspace?(this.target=re,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st):(this.target=re,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof de?this._definition={type:u.ProcessType,id:this._execution.computeId()}:this._execution instanceof oe?this._definition={type:u.ShellType,id:this._execution.computeId()}:this._execution instanceof Ie?this._definition={type:u.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:u.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const re=this._definition.type;(u.EmptyType===re||u.ProcessType===re||u.ShellType===re||u.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=u=Ve([_],Qe),e.Task=Qe;var Ze;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,re=ht.None){this.collapsibleState=re,D.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=Ve([_],ut),e.TreeItem=ut;var ht;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ye=class{constructor(O,re){this.id=O,this.color=re}};Ye=Ve([_],Ye),e.ThemeIcon=Ye,Ye.File=new Ye("file"),Ye.Folder=new Ye("folder");let ot=class{constructor(O){this.id=O}};ot=Ve([_],ot),e.ThemeColor=ot;var ft;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(O,re){if(typeof O!="string"&&(!O||!D.URI.isUri(O)&&!D.URI.isUri(O.uri)))throw(0,I.illegalArgument)("base");if(typeof re!="string")throw(0,I.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=D.URI.file(O),this.base=O):D.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=re}};at=Ve([_],at),e.RelativePattern=at;let Et=class{constructor(O,re,De,Ke){this.enabled=typeof O=="boolean"?O:!0,typeof re=="string"&&(this.condition=re),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};Et=Ve([_],Et),e.Breakpoint=Et;let vt=class extends Et{constructor(O,re,De,Ke,et){super(re,De,Ke,et);if(O===null)throw(0,I.illegalArgument)("location");this.location=O}};vt=Ve([_],vt),e.SourceBreakpoint=vt;let Ct=class extends Et{constructor(O,re,De,Ke,et){super(re,De,Ke,et);this.functionName=O}};Ct=Ve([_],Ct),e.FunctionBreakpoint=Ct;let Pt=class extends Et{constructor(O,re,De,Ke,et,st,ct){super(Ke,et,st,ct);if(!re)throw(0,I.illegalArgument)("dataId");this.label=O,this.dataId=re,this.canPersist=De}};Pt=Ve([_],Pt),e.DataBreakpoint=Pt;let At=class{constructor(O,re,De){this.command=O,this.args=re||[],this.options=De}};At=Ve([_],At),e.DebugAdapterExecutable=At;let _t=class{constructor(O,re){this.port=O,this.host=re}};_t=Ve([_],_t),e.DebugAdapterServer=_t;let Qt=class{constructor(O){this.path=O}};Qt=Ve([_],Qt),e.DebugAdapterNamedPipeServer=Qt;let Yt=class{constructor(O){this.implementation=O}};Yt=Ve([_],Yt),e.DebugAdapterInlineImplementation=Yt;let gt=class{constructor(O,re){this.range=O,this.expression=re}};gt=Ve([_],gt),e.EvaluatableExpression=gt;let Jt=class{constructor(O,re){this.range=O,this.text=re}};Jt=Ve([_],Jt),e.InlineValueText=Jt;let St=class{constructor(O,re,De=!0){this.range=O,this.variableName=re,this.caseSensitiveLookup=De}};St=Ve([_],St),e.InlineValueVariableLookup=St;let Vt=class{constructor(O,re){this.range=O,this.expression=re}};Vt=Ve([_],Vt),e.InlineValueEvaluatableExpression=Vt;let Xt=class{constructor(O,re){this.frameId=O,this.stoppedLocation=re}};Xt=Ve([_],Xt),e.InlineValueContext=Xt;var jt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(jt=e.FileChangeType||(e.FileChangeType={}));let lt=w=class extends Error{constructor(O,re=n.FileSystemProviderErrorCode.Unknown,De){var Ke;super(D.URI.isUri(O)?O.toString(!0):O);this.code=(Ke=De==null?void 0:De.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,n.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(O){return new w(O,n.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(O){return new w(O,n.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(O){return new w(O,n.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(O){return new w(O,n.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(O){return new w(O,n.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(O){return new w(O,n.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};lt=w=Ve([_],lt),e.FileSystemError=lt;let Zt=class{constructor(O,re,De){this.start=O,this.end=re,this.kind=De}};Zt=Ve([_],Zt),e.FoldingRange=Zt;var Tt;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Bt;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Bt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var cn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(cn=e.CommentMode||(e.CommentMode={}));class wn{constructor(O,re=[]){this.tokenTypes=O,this.tokenModifiers=re}}e.SemanticTokensLegend=wn;function dn(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class en{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let re=0,De=O.tokenTypes.length;re<De;re++)this._tokenTypeStrToInt.set(O.tokenTypes[re],re);for(let re=0,De=O.tokenModifiers.length;re<De;re++)this._tokenModifierStrToInt.set(O.tokenModifiers[re],re)}}push(O,re,De,Ke,et){if(typeof O=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(O,re,De,Ke,et);if(F.isRange(O)&&typeof re=="string"&&dn(De))return this._push(O,re,De);throw(0,I.illegalArgument)()}_push(O,re,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ke=O.start.line,et=O.start.character,st=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(re);let yt=0;if(De)for(const Dt of De){if(!this._tokenModifierStrToInt.has(Dt))throw new Error("`tokenModifier` is not in the provided legend");const kt=this._tokenModifierStrToInt.get(Dt);yt|=1<<kt>>>0}this._pushEncoded(Ke,et,st,ct,yt)}_pushEncoded(O,re,De,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Dt=0,kt=0;for(let It=0;It<yt;It++){let Lt=this._data[5*It],ln=this._data[5*It+1];Lt===0?(Lt=Dt,ln+=kt):Lt+=Dt,this._data[5*It]=Lt,this._data[5*It+1]=ln,Dt=Lt,kt=ln}}let st=O,ct=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=O,this._prevChar=re}static _sortAndDeltaEncode(O){let re=[];const De=O.length/5|0;for(let ct=0;ct<De;ct++)re[ct]=ct;re.sort((ct,yt)=>{const Dt=O[5*ct],kt=O[5*yt];if(Dt===kt){const It=O[5*ct+1],Lt=O[5*yt+1];return It-Lt}return Dt-kt});const Ke=new Uint32Array(O.length);let et=0,st=0;for(let ct=0;ct<De;ct++){const yt=5*re[ct],Dt=O[yt+0],kt=O[yt+1],It=O[yt+2],Lt=O[yt+3],ln=O[yt+4],An=Dt-et,Ln=An===0?kt-st:kt,un=5*ct;Ke[un+0]=An,Ke[un+1]=Ln,Ke[un+2]=It,Ke[un+3]=Lt,Ke[un+4]=ln,et=Dt,st=kt}return Ke}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(en._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=en;class qt{constructor(O,re){this.resultId=re,this.data=O}}e.SemanticTokens=qt;class Ot{constructor(O,re,De){this.start=O,this.deleteCount=re,this.data=De}}e.SemanticTokensEdit=Ot;class bn{constructor(O,re){this.resultId=re,this.edits=O}}e.SemanticTokensEdits=bn;var tn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var nn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(nn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new Ye("arrow-left")},Kt=Ve([_],Kt),e.QuickInputButtons=Kt;var _n;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(_n=e.ExtensionKind||(e.ExtensionKind={}));class Rt{constructor(O,re,De){this.badge=O,this.tooltip=re,this.color=De}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Rt;let rn=class{constructor(O){this.kind=O}};rn=Ve([_],rn),e.ColorTheme=rn;var En;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(En=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(O,re){if(O<0)throw(0,I.illegalArgument)("start must be positive");if(re<0)throw(0,I.illegalArgument)("end must be positive");O<=re?(this._start=O,this._end=re):(this._start=re,this._end=O)}static isNotebookRange(O){return O instanceof xt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let re=this._start,De=this._end;return O.start!==void 0&&(re=O.start),O.end!==void 0&&(De=O.end),re===this._start&&De===this._end?this:new xt(re,De)}}e.NotebookRange=xt;class sn{constructor(O,re){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=re)}with(O){let{inputCollapsed:re,outputCollapsed:De}=O,Ke=zt(O,["inputCollapsed","outputCollapsed"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),De===void 0?De=this.outputCollapsed:De===null&&(De=void 0),re===this.inputCollapsed&&De===this.outputCollapsed&&Object.keys(Ke).length===0?this:new sn(Object.assign({inputCollapsed:re,outputCollapsed:De},Ke))}}e.NotebookCellMetadata=sn;class Nt{constructor(O=!0){var re;typeof O=="object"?(Object.assign(this,O),this.trusted=(re=O.trusted)!==null&&re!==void 0?re:!0):this.trusted=O}with(O){let{trusted:re}=O,De=zt(O,["trusted"]);return re===void 0?re=this.trusted:re===null&&(re=void 0),re===this.trusted&&Object.keys(De).length===0?this:new Nt(Object.assign({trusted:re},De))}}e.NotebookDocumentMetadata=Nt;class Ft{constructor(O,re,De,Ke,et,st){this.kind=O,this.source=re,this.language=De,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(re=>Ft.isNotebookCellData(re))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ft;class hn{constructor(O,re){this.cells=O,this.metadata=re!=null?re:new Nt}}e.NotebookData=hn;class $t{constructor(O,re,De){if(this.mime=O,this.value=re,this.metadata=De,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof $t}}e.NotebookCellOutputItem=$t;class Fe{constructor(O,re,De){this.outputs=O,typeof re=="string"?(this.id=re,this.metadata=De):(this.id=(0,k.generateUuid)(),this.metadata=re!=null?re:De)}}e.NotebookCellOutput=Fe;var on;(function(N){N[N.Markdown=1]="Markdown",N[N.Code=2]="Code"})(on=e.NotebookCellKind||(e.NotebookCellKind={}));var an;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(an=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var yn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(yn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Sn{constructor(O,re,De,Ke,et,st){this.text=O,this.alignment=re,this.command=De,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=Sn;var fn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));let Gt=class{constructor(O,re){this.label=O,this.timestamp=re}};Gt=Ve([_],Gt),e.TimelineItem=Gt;var Dn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Dn=e.ExtensionMode||(e.ExtensionMode={}));var Cn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Cn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var kn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(kn=e.StandardTokenType||(e.StandardTokenType={}));class In{constructor(O,re){this.ranges=O,this.wordPattern=re}}e.LinkedEditingRanges=In;var mn;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(mn=e.TestResultState||(e.TestResultState={}));var gn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(gn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var pn;(function(N){N[N.Pending=0]="Pending",N[N.Resolved=1]="Resolved"})(pn=e.TestItemStatus||(e.TestItemStatus={}));const Ut=(N,O,re,De)=>{let Ke=re;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){De(Ke,et)||(Ke=et,N.bus.fire([3,O,et]))}}},Wt=(N,O)=>N===O,Pn=(N,O)=>N===O?!0:!N||!O?!1:N.isEqual(O);class J{constructor(O,re,De,Ke){this.label=re,this.data=Ke;const et=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new T.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Ut(et,"range",void 0,Pn),description:Ut(et,"description",void 0,Wt),runnable:Ut(et,"runnable",!0,Wt),debuggable:Ut(et,"debuggable",!0,Wt),status:Ut(et,"status",pn.Resolved,Wt),error:Ut(et,"error",void 0,Wt)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,d.getPrivateApiFor)(this);O.parent&&(0,d.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof J))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,d.getPrivateApiFor)(this);if(re.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);re.children.set(O.id,O),re.bus.fire([0,O])}}e.TestItemImpl=J;class ue{constructor(O){this.message=O,this.severity=gn.Error}static diff(O,re,De){const Ke=new ue(O);return Ke.expectedOutput=re,Ke.actualOutput=De,Ke}}e.TestMessage=ue;var ke;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(ke=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var rt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(rt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore"})(bt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[95],_e([0,1,42,19,8,120,86,7,15]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function n(r,l){l?k.set(r,l):k.delete(r)}e.setWordDefinitionFor=n;function P(r){return k.get(r)}e.getWordDefinitionFor=P;class d extends T.MirrorTextModel{constructor(l,g,m,S,f,c,p,t){super(g,m,S,f);this._proxy=l,this._languageId=c,this._isDirty=p,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,D.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===I.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(g){return g?l._getTextInRange(g):l.getText()},get eol(){return l._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(g){return l._lineAt(g)},offsetAt(g){return l._offsetAt(g)},positionAt(g){return l._positionAt(g)},validateRange(g){return l._validateRange(g)},validatePosition(g){return l._validatePosition(g)},getWordRangeAtPosition(g,m){return l._getWordRangeAtPosition(g,m)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,b.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,b.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const g=this._validateRange(l);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const m=this._eol,S=g.start.line,f=g.end.line,c=[];c.push(this._lines[S].substring(g.start.character));for(let p=S+1;p<f;p++)c.push(this._lines[p]);return c.push(this._lines[f].substring(0,g.end.character)),c.join(m)}_lineAt(l){let g;if(l instanceof C.Position?g=l.line:typeof l=="number"&&(g=l),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new h(g,this._lines[g],g===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(l),m=this._lines[g.index].length;return new C.Position(g.index,Math.min(g.remainder,m))}_validateRange(l){if(!(l instanceof C.Range))throw new Error("Invalid argument");const g=this._validatePosition(l.start),m=this._validatePosition(l.end);return g===l.start&&m===l.end?l:new C.Range(g.line,g.character,m.line,m.character)}_validatePosition(l){if(!(l instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:g,character:m}=l,S=!1;if(g<0)g=0,m=0,S=!0;else if(g>=this._lines.length)g=this._lines.length-1,m=this._lines[g].length,S=!0;else{const f=this._lines[g].length;m<0?(m=0,S=!0):m>f&&(m=f,S=!0)}return S?new C.Position(g,m):l}_getWordRangeAtPosition(l,g){const m=this._validatePosition(l);if(!g)g=P(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const S=(0,y.getWordAtText)(m.character+1,(0,y.ensureValidWordDefinition)(g),this._lines[m.line],0);if(S)return new C.Range(m.line,S.startColumn-1,m.line,S.endColumn-1)}}e.ExtHostDocumentData=d;class h{constructor(l,g,m){this._line=l,this._text=g,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(be[164],_e([0,1,7,3,88,6,59,22,2,31]),function(Q,e,b,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(d,h,r,l){this._notebook=r,this._selector=l,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(m=>{const S=this._cellUris.get(m.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(m=>g(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const d=[],h=[];for(const r of this._notebook.getCells())r.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),h.push(r.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(d){var h,r;if(!d){let f="";for(const c of this._cells)f+=c.document.getText()+`
`;return f=f.slice(0,-1),f}if(d.isEmpty)return"";const l=this.locationAt(d.start),g=this.locationAt(d.end),m=this._cells[(h=this._cellUris.get(l.uri))!==null&&h!==void 0?h:-1],S=this._cells[(r=this._cellUris.get(g.uri))!==null&&r!==void 0?r:-1];if(!m||!S)return"";if(m===S)return m.document.getText(new b.Range(l.range.start,g.range.end));{const f=m.document.getText(new b.Range(l.range.start,new b.Position(m.document.lineCount,0))),c=S.document.getText(new b.Range(new b.Position(0,0),g.range.end));return f+`
`+c}}offsetAt(d){const h=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(h.index-1),l=this._cells[h.index].document.offsetAt(d.with(h.remainder));return r+l}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),l=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(l)}const h=this._cellUris.get(d.uri);if(h!==void 0){const r=this._cellLines.getAccumulatedValue(h-1);return new b.Position(r+d.range.start.line,d.range.start.character)}return new b.Position(0,0)}locationAt(d){b.Range.isRange(d)||(d=new b.Range(d,d));const h=this._cellLines.getIndexOf(d.start.line);let r=h;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const l=new b.Position(h.remainder,d.start.character),g=new b.Position(r.remainder,d.end.character),m=new b.Range(l,g),S=this._cells[h.index];return new b.Location(S.document.uri,S.document.validateRange(m))}contains(d){return this._cellUris.has(d)}validateRange(d){const h=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(h,r)}validatePosition(d){const h=this._cellLines.getIndexOf(d.line),r=new b.Position(h.remainder,d.character),l=this._cells[h.index].document.validatePosition(r),g=this._cellLines.getAccumulatedValue(h.index-1);return new b.Position(g+l.line,l.character)}}e.ExtHostNotebookConcatDocument=n}),define(be[165],_e([0,1,7,14,3]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(C){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?b.ColorThemeKind.Light:C==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[71],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class I{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(be[166],_e([0,1,23]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function A(C,D){if(D){const k=new I,n=(h,r)=>{if(r instanceof ArrayBuffer){const l=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(r)){const l=T(r);if(l){const g=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:l,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},P=JSON.stringify(C,n),d=k.buffers.map(h=>{const r=new Uint8Array(h);return b.VSBuffer.wrap(r)});return{message:P,buffers:d}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=A;function T(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(C,D){const k=D.map(d=>{const h=new ArrayBuffer(d.byteLength);return new Uint8Array(h).set(d.buffer),h}),n=D.length?(d,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:l}=r,g=k[l];if(r.view)switch(r.view.type){case 1:return new Int8Array(g,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return h}:void 0;return{message:JSON.parse(C,n),arrayBuffers:k}}e.deserializeWebviewMessage=y}),define(be[72],_e([0,1,2]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(T,y,C){const D=T.webviewResourceRoot.replace("{{resource}}",C.scheme+A(C)).replace("{{uuid}}",y);return b.URI.parse(D)}e.asWebviewUri=I;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(be[167],_e([0,1,3,6,72,31]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,k,n){this._proxy=D,this._editors=k,this._initData=n,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const d of this._insets.values())P.indexOf(d.editor)<0&&d.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,n,P,d){let h;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===D){h=c;break}if(!h)throw new Error("not a visible editor");const r=this,l=this._handlePool++,g=new b.Emitter,m=new b.Emitter,S=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,A.asWebviewUri)(r._initData,this._uuid,c)}get cspSource(){return r._initData.webviewCspSource}set options(c){this._options=c,r._proxy.$setOptions(l,c)}get options(){return this._options}set html(c){this._html=c,r._proxy.$setHtml(l,c)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(c){return r._proxy.$postMessage(l,c)}},f=new class{constructor(){this.editor=D,this.line=k,this.height=n,this.webview=S,this.onDidDispose=m.event}dispose(){r._insets.has(l)&&(r._insets.delete(l),r._proxy.$disposeEditorInset(l),m.fire(),m.dispose(),g.dispose())}};return this._proxy.$createEditorInset(l,h.id,h.value.document.uri,k+1,n,P||{},d.identifier,d.extensionLocation),this._insets.set(l,{editor:D,inset:f,onDidReceiveMessage:g}),f}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const n=this._insets.get(D);n&&n.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=y}),define(be[168],_e([0,1,3,63,139,4,6,22,29,15,51,24,36,159]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",d.Codicon.window,(0,A.localize)(0,null));var r;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var l;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={}));function g(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=g;function m(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=m;class S extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(u,w,_){var v;const E=this.get(u.id);if(E)return E;const F=u;return F.openCommandActionDescriptor=(_==null?void 0:_.donotRegisterOpenCommand)?void 0:(v=F.openCommandActionDescriptor)!==null&&v!==void 0?v:{id:F.id},(0,C.getOrSet)(this.viewContainers,w,[]).push(F),(_==null?void 0:_.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:w}),F}deregisterViewContainer(u){for(const w of this.viewContainers.keys()){const _=this.viewContainers.get(w),v=_==null?void 0:_.indexOf(u);if(v!==-1){_==null||_.splice(v,1),_.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:u,viewContainerLocation:w});return}}}get(u){return this.all.filter(w=>w.id===u)[0]}getViewContainers(u){return[...this.viewContainers.get(u)||[]]}getViewContainerLocation(u){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(_=>(_==null?void 0:_.id)===u.id).length>0)[0]}getDefaultViewContainer(u){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===u)}}D.Registry.add(r.ViewContainersRegistry,new S);var f;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function c(s,u){var w,_,v,E;const F=(w=s.group)!==null&&w!==void 0?w:f.More,B=(_=u.group)!==null&&_!==void 0?_:f.More;return F!==B?F.localeCompare(B):((v=s.order)!==null&&v!==void 0?v:5)-((E=u.order)!==null&&E!==void 0?E:5)}class p extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new n.SetMap}registerViews(u,w){this.registerViews2([{views:u,viewContainer:w}])}registerViews2(u){u.forEach(({views:w,viewContainer:_})=>this.addViews(w,_)),this._onViewsRegistered.fire(u)}deregisterViews(u,w){const _=this.removeViews(u,w);_.length&&this._onViewsDeregistered.fire({views:_,viewContainer:w})}moveViews(u,w){for(const _ of this._views.keys())if(_!==w){const v=this.removeViews(u,_);v.length&&(this.addViews(v,w),this._onDidChangeContainer.fire({views:v,from:_,to:w}))}}getViews(u){return this._views.get(u)||[]}getView(u){for(const w of this._viewContainers){const _=(this._views.get(w)||[]).filter(v=>v.id===u)[0];if(_)return _}return null}getViewContainer(u){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(v=>v.id===u)[0])return w;return null}registerViewWelcomeContent(u,w){return this._viewWelcomeContents.add(u,w),this._onDidChangeViewWelcomeContent.fire(u),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(u,w),this._onDidChangeViewWelcomeContent.fire(u)})}registerViewWelcomeContent2(u,w){const _=new Map;for(const[v,E]of w)this._viewWelcomeContents.add(u,E),_.set(v,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(u,E),this._onDidChangeViewWelcomeContent.fire(u)}));return this._onDidChangeViewWelcomeContent.fire(u),_}getViewWelcomeContent(u){const w=[];return this._viewWelcomeContents.forEach(u,_=>w.push(_)),w.sort(c)}addViews(u,w){let _=this._views.get(w);_||(_=[],this._views.set(w,_),this._viewContainers.push(w));for(const v of u){if(this.getView(v.id)!==null)throw new Error((0,A.localize)(1,null,v.id));_.push(v)}}removeViews(u,w){const _=this._views.get(w);if(!_)return[];const v=[],E=[];for(const F of _)u.includes(F)?v.push(F):E.push(F);return v.length&&(E.length?this._views.set(w,E):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),v}}D.Registry.add(r.ViewsRegistry,new p),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var i;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(u,w){this.resolved=!1,this._hasResolve=!1,(0,P.mixin)(this,u),this._hasResolve=!!w,this.resolve=async _=>{var v,E;if(w&&!this.resolved){const F=await w(_);F&&(this.tooltip=(v=this.tooltip)!==null&&v!==void 0?v:F.tooltip,this.command=(E=this.command)!==null&&E!==void 0?E:F.command)}_.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(be[169],_e([0,1,2,149,160,18,150,168]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(l){return(g,...m)=>l(g.get(I.ICommandService),...m)}class k{static execute(g,m){const S={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return g.executeCommand("_files.newWindow",S)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(l,g){return l.get(A.IWorkspacesService).removeRecentlyOpened([g])});class n{static execute(g,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?b.URI.parse(m):b.URI.file(m):m=b.URI.revive(m),g.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=n,n.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(n.ID,D(n.execute));class P{static execute(g,m){const S=typeof m=="string"?{extensionId:m}:m;return g.executeCommand("workbench.action.openIssueReporter",S)}}e.OpenIssueReporter=P,P.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(l,g){const m=l.get(A.IWorkspacesService);let S;const f=g.uri,c=g.label,p=g.remoteAuthority;return g.type==="workspace"?S={workspace:await m.getWorkspaceIdentifier(f),label:c,remoteAuthority:p}:g.type==="folder"?S={folderUri:f,label:c,remoteAuthority:p}:S={fileUri:f,label:c,remoteAuthority:p},m.addRecentlyOpened([S])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(l){return l.get(A.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(l,g){const m=l.get(T.ILogService),S=l.get(y.IEnvironmentService);S.isExtensionDevelopment&&!!S.extensionTestsLocationURI&&m.setLevel(g)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(l){return l.get(T.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(l,g){const m=l.get(C.IViewDescriptorService),S=m.getViewContainerById(g.destinationId);if(!!S){for(const f of g.viewIds){const c=m.getViewDescriptorById(f);(c==null?void 0:c.canMoveView)&&m.moveViewsToContainer([c],S,C.ViewVisibilityState.Default)}await l.get(C.IViewsService).openViewContainer(S.id,!0)}});class d{static execute(g,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):g.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=d,d.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:d.ID,handler:D(d.execute),description:{description:"Move Views",args:[]}});class h{static execute(g,m){return g.executeCommand("_workbench.open",m)}}h.ID="vscode.open",I.CommandsRegistry.registerCommand(h.ID,D(h.execute));class r{static execute(g,m,S,f,c){return g.executeCommand("_workbench.diff",[m,S,f])}}r.ID="vscode.diff",I.CommandsRegistry.registerCommand(r.ID,D(r.execute))}),define(be[170],_e([0,1,3,11,140]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,k,n){const P={command:C};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof n=="number"){const d=setTimeout(()=>{clearTimeout(d);const h=this.pendingRequests.get(P.seq);if(h){this.pendingRequests.delete(P.seq);const r={type:"response",seq:0,request_seq:P.seq,success:!1,command:C,message:(0,A.localize)(0,null,n,C)};h(r)}},n)}return k&&this.pendingRequests.set(P.seq,k),P.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,I.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,k)=>C.set(k,D)),await(0,I.timeout)(500),C.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[171],_e([0,1,8,2,13,24,19]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(i,o,a){return i.replace(C,function(s,u){return o&&u.length>0&&u[0]!=="_"?s:a&&a.hasOwnProperty(u)?a[u]:s})}e.formatPII=D;function k(i){const o={};for(const a of Object.keys(i))a.startsWith("!")||(o[a]=i[a]);return o}e.filterExceptionsFromTelemetry=k;function n(i){return i.configuration.request==="attach"&&!P(i)}e.isSessionAttach=n;function P(i){let o=i.configuration.type;if(!!o)return o==="vslsShare"&&(o=i.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(o,"extensionhost")||(0,b.equalsIgnoreCase)(o,"pwa-extensionhost")?i:i.parentSession?P(i.parentSession):void 0}e.getExtensionHostDebugSession=P;function d(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=d;function h(i,o,a){let s,u=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,_=null;for(;_=w.exec(i);){let v=_.index+1,E=v+_[0].length;if(v<=o&&E>=a){s=_[0],u=v;break}}if(s){let v=/\w+/g,E=null;for(;(E=v.exec(s))&&!(E.index+1+u+E[0].length>=a););E&&(s=s.substring(0,v.lastIndex))}return s?{start:u,end:u+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(i){return!!(i&&i.match(r))}e.isUri=l;function g(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(l(i.path))return I.URI.parse(i.path);if((0,A.isAbsolute)(i.path))return I.URI.file(i.path)}return i.path}function m(i){if(typeof i.path=="object"){const o=I.URI.revive(i.path);if(o)return o.scheme===y.Schemas.file?o.fsPath:o.toString()}return i.path}function S(i,o){const a=o?g:m,s=(0,T.deepClone)(i);return c(s,(u,w)=>{u&&w&&(w.path=a(w))}),s}e.convertToDAPaths=S;function f(i,o){const a=o?g:m,s=(0,T.deepClone)(i);return c(s,(u,w)=>{!u&&w&&(w.path=a(w))}),s}e.convertToVSCPaths=f;function c(i,o){switch(i.type){case"event":const a=i;switch(a.event){case"output":o(!1,a.body.source);break;case"loadedSource":o(!1,a.body.source);break;case"breakpoint":o(!1,a.body.breakpoint.source);break;default:break}break;case"request":const s=i;switch(s.command){case"setBreakpoints":o(!0,s.arguments.source);break;case"breakpointLocations":o(!0,s.arguments.source);break;case"source":o(!0,s.arguments.source);break;case"gotoTargets":o(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(w=>o(!1,w));break;default:break}break;case"response":const u=i;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(w=>o(!1,w.source));break;case"loadedSources":u.body.sources.forEach(w=>o(!1,w));break;case"scopes":u.body.scopes.forEach(w=>o(!1,w.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(w=>o(!1,w.source));break;case"setBreakpoints":u.body.breakpoints.forEach(w=>o(!1,w.source));break;default:break}break}}function p(i){return i.filter(o=>{var a;return!((a=o.presentation)===null||a===void 0?void 0:a.hidden)}).sort((o,a)=>o.presentation?a.presentation?o.presentation.group?a.presentation.group?o.presentation.group!==a.presentation.group?o.presentation.group.localeCompare(a.presentation.group):t(o.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(o.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=p;function t(i,o){return typeof i!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:i-o}}),define(be[73],_e([0,1,28,19,13,21,63]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(_){_[_.Markdown=1]="Markdown",_[_.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{},trusted:!0};var k;(function(_){_[_.Idle=1]="Idle",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var n;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.CellClearOutput=3]="CellClearOutput",_[_.CellsClearOutput=4]="CellsClearOutput",_[_.ChangeLanguage=5]="ChangeLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.Unknown=12]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata"})(h=e.CellEditType||(e.CellEditType={}));function r(_){const v=l.parse(_);return v?v.notebook.toString():_.toString()}e.getCellUndoRedoComparisonKey=r;var l;(function(_){_.scheme=I.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function E(fe,V){return fe.with({scheme:_.scheme,fragment:`ch${V.toString().padStart(7,"0")}${fe.scheme!==I.Schemas.file?fe.scheme:""}`})}_.generate=E;function F(fe){if(fe.scheme===_.scheme){const V=v.exec(fe.fragment);if(!!V)return{handle:Number(V[1]),notebook:fe.with({scheme:fe.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}_.parse=F;function B(fe,V){return fe.with({scheme:I.Schemas.vscodeNotebookCellMetadata,fragment:`ch${V.toString().padStart(7,"0")}${fe.scheme!==I.Schemas.file?fe.scheme:""}`})}_.generateCellMetadataUri=B;function Y(fe){if(fe.scheme===I.Schemas.vscodeNotebookCellMetadata){const V=v.exec(fe.fragment);if(!!V)return{handle:Number(V[1]),notebook:fe.with({scheme:fe.fragment.substr(V[0].length)||I.Schemas.file,fragment:null})}}}_.parseCellMetadataUri=Y})(l=e.CellUri||(e.CellUri={}));const g=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(_){var v,E;return(E=(v=g.get(_))===null||v===void 0?void 0:v.alwaysSecure)!==null&&E!==void 0?E:!1}e.mimeTypeIsAlwaysSecure=m;function S(_){var v,E;return(E=(v=g.get(_))===null||v===void 0?void 0:v.supportedByCore)!==null&&E!==void 0?E:!1}e.mimeTypeSupportedByCore=S;function f(_){var v,E;return(E=(v=g.get(_))===null||v===void 0?void 0:v.mergeable)!==null&&E!==void 0?E:!1}e.mimeTypeIsMergeable=f;function c(_,v){return T.isWindows&&(_=_.replace(/\//g,"\\"),v=v.replace(/\//g,"\\")),b.match(_,v)}function p(_,v,E){let F=0;for(let B=0;B<v.length;B++){if(c(v[B],_))return F;F++}for(let B=0;B<E.length;B++){if(c(E[B],_))return F;F++}return F}function t(_,v,E){return _.sort((F,B)=>p(F,v,E)-p(B,v,E))}e.sortMimeTypes=t;function i(_,v,E,F=(B,Y)=>B===Y){const B=[];function Y(z,ee,$){if(!(ee===0&&$.length===0)){const R=B[B.length-1];R&&R.start+R.deleteCount===z?(R.deleteCount+=ee,R.toInsert.push(...$)):B.push({start:z,deleteCount:ee,toInsert:$})}}let fe=0,V=0;for(;;){if(fe===_.length){Y(fe,0,v.slice(V));break}if(V===v.length){Y(fe,_.length-fe,[]);break}const z=_[fe],ee=v[V];if(F(z,ee)){fe+=1,V+=1;continue}E(ee)?(Y(fe,1,[]),fe+=1):(Y(fe,0,[ee]),V+=1)}return B}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(_){_.default="default",_.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(_){const v=_;return!!((typeof v.include=="string"||b.isRelativePattern(v.include))&&(typeof v.exclude=="string"||b.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=a;function s(_,v,E){if(Array.isArray(_.viewType)&&_.viewType.indexOf(v)>=0||_.viewType===v)return!0;if(_.filenamePattern){let F=a(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,B=a(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(b.match(F,(0,A.basename)(E.fsPath).toLowerCase()))return!(B&&b.match(B,(0,A.basename)(E.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class u{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let E=0;E<this.textModel.cells.length;E++)v[E]=this.textModel.cells[E].getHashValue();return v}}e.CellSequence=u,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var w;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={})),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX="notebook/"}),define(be[172],_e([0,1,142,4,63]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[173],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=b;function I(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=I}),define(be[96],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=I;var A;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=T;class y{add(k){}update(k){}remove(k,n){}complete(){}}e.IncrementalChangeCollector=y;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const n=this.createChangeCollector();for(const P of k)switch(P[0]){case 0:{const d=P[1];if(d.parent){if(this.items.has(d.parent)){const h=this.items.get(d.parent);h.children.add(d.item.extId);const r=this.createItem(d,h);this.items.set(d.item.extId,r),n.add(r)}}else{this.roots.add(d.item.extId);const h=this.createItem(d);this.items.set(d.item.extId,h),n.add(h)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=P[1],h=this.items.get(d.extId);if(!h)break;d.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(h,d),n.update(h);break}case 2:{const d=this.items.get(P[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const h=[[P[1]]];for(;h.length;)for(const r of h.pop()){const l=this.items.get(r);l&&(h.push(l.children),this.items.delete(r),n.remove(l,l!==d),l.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}n.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=C}),define(be[174],_e([0,1,13,46,10,24,21,58,143]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(P,d,h){this._contributedVariables=new Map,this._context=P,this._labelService=d,h&&(this._envVariablesPromise=h.then(r=>this.prepareEnv(r)))}prepareEnv(P){if(y.isWindows){const d=Object.create(null);return Object.keys(P).forEach(h=>{d[h.toLowerCase()]=P[h]}),d}return P}resolveWithEnvironment(P,d,h){return this.recursiveResolve(this.prepareEnv(P),d?d.uri:void 0,h)}async resolveAsync(P,d){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,d)}async resolveAnyBase(P,d,h,r){const l=T.deepClone(d);return y.isWindows&&l.windows?Object.keys(l.windows).forEach(g=>l[g]=l.windows[g]):y.isMacintosh&&l.osx?Object.keys(l.osx).forEach(g=>l[g]=l.osx[g]):y.isLinux&&l.linux&&Object.keys(l.linux).forEach(g=>l[g]=l.linux[g]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,l,h,r)}async resolveAnyAsync(P,d,h){return this.resolveAnyBase(P,d,h)}async resolveAnyMap(P,d,h){const r=new Map;return{newConfig:await this.resolveAnyBase(P,d,h,r),resolvedVariables:r}}resolveWithInteractionReplace(P,d,h,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,d,h,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,d){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,d)}recursiveResolve(P,d,h,r,l){if(A.isString(h))return this.resolveString(P,d,h,r,l);if(A.isArray(h))return h.map(g=>this.recursiveResolve(P,d,g,r,l));if(A.isObject(h)){let g=Object.create(null);return Object.keys(h).forEach(m=>{const S=this.resolveString(P,d,m,r,l);g[S]=this.recursiveResolve(P,d,h[m],r,l)}),g}return h}resolveString(P,d,h,r,l){return h.replace(k.VARIABLE_REGEXP,(m,S)=>{if(S.includes(k.VARIABLE_LHS))return m;let f=this.evaluateSingleVariable(P,m,S,d,r);return l&&l.set(S,f),f})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,d,h,r,l){let g;const m=h.split(":");m.length>1&&(h=m[0],g=m[1]);const S=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,D.localize)(0,null,d))},f=()=>{const p=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,d,b.basename(p)))},c=()=>{if(g){const p=this._context.getFolderUri(g);if(p)return p;throw new Error((0,D.localize)(2,null,d,g))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,d)):new Error((0,D.localize)(4,null,d))};switch(h){case"env":if(g){if(P){const p=P[y.isWindows?g.toLowerCase():g];if(A.isString(p))return p}return""}throw new Error((0,D.localize)(5,null,d));case"config":if(g){const p=this._context.getConfigurationValue(r,g);if(A.isUndefinedOrNull(p))throw new Error((0,D.localize)(6,null,d,g));if(A.isObject(p))throw new Error((0,D.localize)(7,null,d,g));return p}throw new Error((0,D.localize)(8,null,d));case"command":return this.resolveFromMap(d,g,l,"command");case"input":return this.resolveFromMap(d,g,l,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return r||g?(0,C.normalizeDriveLetter)(this.fsPath(c())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(c()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,D.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,d));case"file":return S();case"fileWorkspaceFolder":return f();case"relativeFile":return r||g?b.relative(this.fsPath(c()),S()):S();case"relativeFileDirname":const i=b.dirname(S());if(r||g){const u=b.relative(this.fsPath(c()),i);return u.length===0?".":u}return i;case"fileDirname":return b.dirname(S());case"fileExtname":return b.extname(S());case"fileBasename":return b.basename(S());case"fileBasenameNoExtension":const o=b.basename(S());return o.slice(0,o.length-b.extname(o).length);case"fileDirnameBasename":return b.basename(b.dirname(S()));case"execPath":const a=this._context.getExecPath();return a||d;case"execInstallFolder":const s=this._context.getAppRoot();return s||d;case"pathSeparator":return b.sep;default:try{const u=g?`${h}:${g}`:h;return this.resolveFromMap(d,u,l,void 0)}catch(u){return d}}}}resolveFromMap(P,d,h,r){if(d&&h){const l=r===void 0?h[d]:h[r+":"+d];if(typeof l=="string")return l;throw new Error((0,D.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[175],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var I;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function P(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(be[176],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[9],_e([0,1,15,83,230,57,24,10,2,32,62,144,90,73,176,7]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(we){function de(K){const{selectionStartLineNumber:Re,selectionStartColumn:Ie,positionLineNumber:Qe,positionColumn:Ze}=K,ut=new l.Position(Re-1,Ie-1),ht=new l.Position(Qe-1,Ze-1);return new l.Selection(ut,ht)}we.to=de;function oe(K){const{anchor:Re,active:Ie}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}we.from=oe})(g=e.Selection||(e.Selection={}));var m;(function(we){function de(K){if(!!K){const{start:Re,end:Ie}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}we.from=de;function oe(K){if(!!K){const{startLineNumber:Re,startColumn:Ie,endLineNumber:Qe,endColumn:Ze}=K;return new l.Range(Re-1,Ie-1,Qe-1,Ze-1)}}we.to=oe})(m=e.Range||(e.Range={}));var S;(function(we){function de(oe){switch(oe){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 4:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=de})(S=e.TokenType||(e.TokenType={}));var f;(function(we){function de(K){return new l.Position(K.lineNumber-1,K.column-1)}we.to=de;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}we.from=oe})(f=e.Position||(e.Position={}));var c;(function(we){function de(K){switch(K){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=de;function oe(K){switch(K){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=oe})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var p;(function(we){function de(K){let Re;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},m.from(K.range)),{message:K.message,source:K.source,code:Re,severity:i.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,b.coalesce)(K.tags.map(c.from)):void 0})}we.from=de;function oe(K){var Re;const Ie=new l.Diagnostic(m.to(K),K.message,i.to(K.severity));return Ie.source=K.source,Ie.code=(0,C.isString)(K.code)?K.code:(Re=K.code)===null||Re===void 0?void 0:Re.value,Ie.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Ie.tags=K.tags&&(0,b.coalesce)(K.tags.map(c.to)),Ie}we.to=oe})(p=e.Diagnostic||(e.Diagnostic={}));var t;(function(we){function de(K){return Object.assign(Object.assign({},m.from(K.location.range)),{message:K.message,resource:K.location.uri})}we.from=de;function oe(K){return new l.DiagnosticRelatedInformation(new l.Location(K.resource,m.to(K)),K.message)}we.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(we){function de(K){switch(K){case l.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}we.from=de;function oe(K){switch(K){case d.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=oe})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(we){function de(K){return typeof K=="number"&&K>=l.ViewColumn.One?K-1:K===l.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}we.from=de;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(o=e.ViewColumn||(e.ViewColumn={}));function a(we){return typeof we.range!="undefined"}function s(we){return we.length===0?!0:!!a(we[0])}e.isDecorationOptionsArr=s;var u;(function(we){function de(Ze){return Ze.map(we.from)}we.fromMany=de;function oe(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function K(Ze){let ut;if(oe(Ze)){const{language:ft,value:at}=Ze;ut={value:"```"+ft+`
`+at+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ze)?ut={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ut={value:Ze}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Ye=ft=>{try{let at=D.URI.parse(ft,!0);at=at.with({query:Re(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new A.Renderer;return ot.link=Ye,ot.image=ft=>Ye(I.parseHrefAndDimensions(ft).href),A(ut.value,{renderer:ot}),ut}we.from=K;function Re(Ze,ut){if(!Ze)return Ze;let ht;try{ht=(0,T.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Ye=!1;return ht=(0,y.cloneAndChange)(ht,ot=>{if(D.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=ot,Ye=!0,ft}else return}),Ye?JSON.stringify(ht):Ze}function Ie(Ze){const ut=new l.MarkdownString(Ze.value,Ze.supportThemeIcons);return ut.isTrusted=Ze.isTrusted,ut}we.to=Ie;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:we.from(Ze)}we.fromStrict=Qe})(u=e.MarkdownString||(e.MarkdownString={}));function w(we){return s(we)?we.map(de=>({range:m.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?u.fromMany(de.hoverMessage):de.hoverMessage?u.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):we.map(de=>({range:m.from(de)}))}e.fromRangeOrRangeWithMessage=w;function _(we){return typeof we=="undefined"?we:typeof we=="string"?D.URI.file(we):we}e.pathOrURIToURI=_;var v;(function(we){function de(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?_(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=de})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var E;(function(we){function de(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?_(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}we.from=de})(E=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(we){function de(oe){if(typeof oe=="undefined")return oe;switch(oe){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=de})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(we){function de(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?F.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?E.from(oe.light):void 0,dark:oe.dark?E.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?_(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}we.from=de})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(we){function de(K){return{text:K.newText,eol:K.newEol&&te.from(K.newEol),range:m.from(K.range)}}we.from=de;function oe(K){const Re=new l.TextEdit(m.to(K.range),K.text);return Re.newEol=typeof K.eol=="undefined"?void 0:te.to(K.eol),Re}we.to=oe})(Y=e.TextEdit||(e.TextEdit={}));var fe;(function(we){function de(K,Re,Ie){var Qe,Ze,ut;const ht={edits:[]};if(K instanceof l.WorkspaceEdit)for(let Ye of K._allEntries())if(Ye._type===1)ht.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const ot=Re==null?void 0:Re.getDocument(Ye.uri);ht.edits.push({_type:2,resource:Ye.uri,edit:Y.from(Ye.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Ye.metadata})}else Ye._type===3?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(Qe=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Ye._type===4?(Ye.newOutputs&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(ze.from)}}),Ye.newMetadata&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:8,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(Ze=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(he.from)}}):Ye._type===6&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:7,outputId:Ye.outputId,items:((ut=Ye.newOutputItems)===null||ut===void 0?void 0:ut.map(ye.from))||[],append:Ye.append}});return ht}we.from=de;function oe(K){const Re=new l.WorkspaceEdit;for(const Ie of K.edits)Ie.edit?Re.replace(D.URI.revive(Ie.resource),m.to(Ie.edit.range),Ie.edit.text):Re.renameFile(D.URI.revive(Ie.oldUri),D.URI.revive(Ie.newUri),Ie.options);return Re}we.to=oe})(fe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(we){const de=Object.create(null);de[l.SymbolKind.File]=0,de[l.SymbolKind.Module]=1,de[l.SymbolKind.Namespace]=2,de[l.SymbolKind.Package]=3,de[l.SymbolKind.Class]=4,de[l.SymbolKind.Method]=5,de[l.SymbolKind.Property]=6,de[l.SymbolKind.Field]=7,de[l.SymbolKind.Constructor]=8,de[l.SymbolKind.Enum]=9,de[l.SymbolKind.Interface]=10,de[l.SymbolKind.Function]=11,de[l.SymbolKind.Variable]=12,de[l.SymbolKind.Constant]=13,de[l.SymbolKind.String]=14,de[l.SymbolKind.Number]=15,de[l.SymbolKind.Boolean]=16,de[l.SymbolKind.Array]=17,de[l.SymbolKind.Object]=18,de[l.SymbolKind.Key]=19,de[l.SymbolKind.Null]=20,de[l.SymbolKind.EnumMember]=21,de[l.SymbolKind.Struct]=22,de[l.SymbolKind.Event]=23,de[l.SymbolKind.Operator]=24,de[l.SymbolKind.TypeParameter]=25;function oe(Re){return typeof de[Re]=="number"?de[Re]:6}we.from=oe;function K(Re){for(const Ie in de)if(de[Ie]===Re)return Number(Ie);return l.SymbolKind.Property}we.to=K})(V=e.SymbolKind||(e.SymbolKind={}));var z;(function(we){function de(K){switch(K){case l.SymbolTag.Deprecated:return 1}}we.from=de;function oe(K){switch(K){case 1:return l.SymbolTag.Deprecated}}we.to=oe})(z=e.SymbolTag||(e.SymbolTag={}));var ee;(function(we){function de(K){return{name:K.name,kind:V.from(K.kind),tags:K.tags&&K.tags.map(z.from),containerName:K.containerName,location:U.from(K.location)}}we.from=de;function oe(K){const Re=new l.SymbolInformation(K.name,V.to(K.kind),K.containerName,U.to(K.location));return Re.tags=K.tags&&K.tags.map(z.to),Re}we.to=oe})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(we){function de(K){var Re,Ie;const Qe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:m.from(K.range),selectionRange:m.from(K.selectionRange),kind:V.from(K.kind),tags:(Ie=(Re=K.tags)===null||Re===void 0?void 0:Re.map(z.from))!==null&&Ie!==void 0?Ie:[]};return K.children&&(Qe.children=K.children.map(de)),Qe}we.from=de;function oe(K){const Re=new l.DocumentSymbol(K.name,K.detail,V.to(K.kind),m.to(K.range),m.to(K.selectionRange));return(0,b.isNonEmptyArray)(K.tags)&&(Re.tags=K.tags.map(z.to)),K.children&&(Re.children=K.children.map(oe)),Re}we.to=oe})($=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(we){function de(oe){const K=new l.CallHierarchyItem(V.to(oe.kind),oe.name,oe.detail||"",D.URI.revive(oe.uri),m.to(oe.range),m.to(oe.selectionRange));return K._sessionId=oe._sessionId,K._itemId=oe._itemId,K}we.to=de})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(we){function de(oe){return new l.CallHierarchyIncomingCall(R.to(oe.from),oe.fromRanges.map(K=>m.to(K)))}we.to=de})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(we){function de(oe){return new l.CallHierarchyOutgoingCall(R.to(oe.to),oe.fromRanges.map(K=>m.to(K)))}we.to=de})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(we){function de(K){return{range:K.range&&m.from(K.range),uri:K.uri}}we.from=de;function oe(K){return new l.Location(D.URI.revive(K.uri),m.to(K.range))}we.to=oe})(U=e.location||(e.location={}));var G;(function(we){function de(K){const Re=K,Ie=K;return{originSelectionRange:Re.originSelectionRange?m.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ie.uri,range:m.from(Re.targetRange?Re.targetRange:Ie.range),targetSelectionRange:Re.targetSelectionRange?m.from(Re.targetSelectionRange):void 0}}we.from=de;function oe(K){return{targetUri:D.URI.revive(K.uri),targetRange:m.to(K.range),targetSelectionRange:K.targetSelectionRange?m.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?m.to(K.originSelectionRange):void 0}}we.to=oe})(G=e.DefinitionLink||(e.DefinitionLink={}));var X;(function(we){function de(K){return{range:m.from(K.range),contents:u.fromMany(K.contents)}}we.from=de;function oe(K){return new l.Hover(K.contents.map(u.to),m.to(K.range))}we.to=oe})(X=e.Hover||(e.Hover={}));var se;(function(we){function de(K){return{range:m.from(K.range),expression:K.expression}}we.from=de;function oe(K){return new l.EvaluatableExpression(m.to(K.range),K.expression)}we.to=oe})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(we){function de(K){if(K instanceof l.InlineValueText)return{type:"text",range:m.from(K.range),text:K.text};if(K instanceof l.InlineValueVariableLookup)return{type:"variable",range:m.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}we.from=de;function oe(K){switch(K.type){case"text":return{range:m.to(K.range),text:K.text};case"variable":return{range:m.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:m.to(K.range),expression:K.expression}}}we.to=oe})(pe=e.InlineValue||(e.InlineValue={}));var Te;(function(we){function de(K){return{frameId:K.frameId,stoppedLocation:m.from(K.stoppedLocation)}}we.from=de;function oe(K){return new l.InlineValueContext(K.frameId,m.to(K.stoppedLocation))}we.to=oe})(Te=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(we){function de(K){return{range:m.from(K.range),kind:K.kind}}we.from=de;function oe(K){return new l.DocumentHighlight(m.to(K.range),K.kind)}we.to=oe})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ae;(function(we){function de(oe){switch(oe){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=de})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(we){function de(oe){return{triggerKind:Ae.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=de})(We=e.CompletionContext||(e.CompletionContext={}));var x;(function(we){function de(K){switch(K){case l.CompletionItemTag.Deprecated:return 1}}we.from=de;function oe(K){switch(K){case 1:return l.CompletionItemTag.Deprecated}}we.to=oe})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(we){const de=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function oe(Ie){var Qe;return(Qe=de.get(Ie))!==null&&Qe!==void 0?Qe:9}we.from=oe;const K=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Re(Ie){var Qe;return(Qe=K.get(Ie))!==null&&Qe!==void 0?Qe:l.CompletionItemKind.Property}we.to=Re})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(we){function de(oe,K){var Re;const Ie=new l.CompletionItem(typeof oe.label=="string"?oe.label:oe.label.name);return typeof oe.label!="string"&&(Ie.label2=oe.label),Ie.insertText=oe.insertText,Ie.kind=q.to(oe.kind),Ie.tags=(Re=oe.tags)===null||Re===void 0?void 0:Re.map(x.to),Ie.detail=oe.detail,Ie.documentation=I.isMarkdownString(oe.documentation)?u.to(oe.documentation):oe.documentation,Ie.sortText=oe.sortText,Ie.filterText=oe.filterText,Ie.preselect=oe.preselect,Ie.commitCharacters=oe.commitCharacters,k.Range.isIRange(oe.range)?Ie.range=m.to(oe.range):typeof oe.range=="object"&&(Ie.range={inserting:m.to(oe.range.insert),replacing:m.to(oe.range.replace)}),Ie.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Ie.insertText=new l.SnippetString(oe.insertText):(Ie.insertText=oe.insertText,Ie.textEdit=Ie.range instanceof l.Range?new l.TextEdit(Ie.range,Ie.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Ie.additionalTextEdits=oe.additionalTextEdits.map(Qe=>Y.to(Qe))),Ie.command=K&&oe.command?K.fromInternal(oe.command):void 0,Ie}we.to=de})(ne=e.CompletionItem||(e.CompletionItem={}));var le;(function(we){function de(K){return{label:K.label,documentation:K.documentation?u.fromStrict(K.documentation):void 0}}we.from=de;function oe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?u.to(K.documentation):K.documentation}}we.to=oe})(le=e.ParameterInformation||(e.ParameterInformation={}));var me;(function(we){function de(K){return{label:K.label,documentation:K.documentation?u.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(le.from):[],activeParameter:K.activeParameter}}we.from=de;function oe(K){return{label:K.label,documentation:I.isMarkdownString(K.documentation)?u.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(le.to):[],activeParameter:K.activeParameter}}we.to=oe})(me=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(we){function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(me.from):[]}}we.from=de;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(me.to):[]}}we.to=oe})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(we){function de(K){var Re;return{text:K.text,range:m.from(K.range),kind:ge.from((Re=K.kind)!==null&&Re!==void 0?Re:l.InlineHintKind.Other),description:K.description&&u.fromStrict(K.description),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}we.from=de;function oe(K){const Re=new l.InlineHint(K.text,m.to(K.range),ge.to(K.kind));return Re.whitespaceAfter=K.whitespaceAfter,Re.whitespaceBefore=K.whitespaceBefore,Re.description=I.isMarkdownString(K.description)?u.to(K.description):K.description,Re}we.to=oe})(Oe=e.InlineHint||(e.InlineHint={}));var ge;(function(we){function de(K){return K}we.from=de;function oe(K){return K}we.to=oe})(ge=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(we){function de(K){return{range:m.from(K.range),url:K.target,tooltip:K.tooltip}}we.from=de;function oe(K){let Re;if(K.url)try{Re=typeof K.url=="string"?D.URI.parse(K.url,!0):D.URI.revive(K.url)}catch(Ie){}return new l.DocumentLink(m.to(K.range),Re)}we.to=oe})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(we){function de(K){const Re=new l.ColorPresentation(K.label);return K.textEdit&&(Re.textEdit=Y.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(Ie=>Y.to(Ie))),Re}we.to=de;function oe(K){return{label:K.label,textEdit:K.textEdit?Y.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>Y.from(Re)):void 0}}we.from=oe})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(we){function de(K){return new l.Color(K[0],K[1],K[2],K[3])}we.to=de;function oe(K){return[K.red,K.green,K.blue,K.alpha]}we.from=oe})($e=e.Color||(e.Color={}));var Ee;(function(we){function de(K){return{range:m.from(K.range)}}we.from=de;function oe(K){return new l.SelectionRange(m.to(K.range))}we.to=oe})(Ee=e.SelectionRange||(e.SelectionRange={}));var je;(function(we){function de(oe){switch(oe){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=de})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(we){function de(K){switch(K){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=de;function oe(K){switch(K){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=oe})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(we){function de(K){if(K===l.EndOfLine.CRLF)return 1;if(K===l.EndOfLine.LF)return 0}we.from=de;function oe(K){if(K===1)return l.EndOfLine.CRLF;if(K===0)return l.EndOfLine.LF}we.to=oe})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(we){function de(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=de})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(we){function de(oe){const K={start:oe.start+1,end:oe.end+1};return oe.kind&&(K.kind=He.from(oe.kind)),K}we.from=de})(Le=e.FoldingRange||(e.FoldingRange={}));var He;(function(we){function de(oe){if(oe)switch(oe){case l.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}we.from=de})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(we){function de(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?m.from(oe.selection):void 0,override:typeof oe.override=="boolean"?P.EditorOverride.DISABLED:void 0}}we.from=de})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(we){function de(K){return K instanceof l.RelativePattern||typeof K=="string"?K:oe(K)?new l.RelativePattern(K.base,K.pattern):K}we.from=de;function oe(K){const Re=K;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var W;(function(we){function de(oe){if(oe){if(Array.isArray(oe))return oe.map(de);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Xe.from(K.pattern),exclusive:K.exclusive}}}else return}we.from=de})(W=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(we){function de(K){return{start:K.start,end:K.end}}we.from=de;function oe(K){return new l.NotebookRange(K.start,K.end)}we.to=oe})(ie=e.NotebookRange||(e.NotebookRange={}));var ce;(function(we){function de(oe){return new l.NotebookCellMetadata().with(Object.assign(Object.assign({},oe),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}we.to=de})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(we){function de(K){return K}we.from=de;function oe(K){return new l.NotebookDocumentMetadata().with(K)}we.to=oe})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Z;(function(we){function de(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}we.to=de;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}we.from=oe})(Z=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ae;(function(we){function de(K){switch(K){case l.NotebookCellKind.Markdown:return h.CellKind.Markdown;case l.NotebookCellKind.Code:default:return h.CellKind.Code}}we.from=de;function oe(K){switch(K){case h.CellKind.Markdown:return l.NotebookCellKind.Markdown;case h.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=oe})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(we){function de(K){var Re;return{cellKind:ae.from(K.kind),language:K.language,source:K.source,metadata:Object.assign(Object.assign({},K.metadata),Z.from((Re=K.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:K.outputs?K.outputs.map(ze.from):[]}}we.from=de;function oe(K){return new l.NotebookCellData(ae.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(ze.to):void 0,K.metadata?ce.to(K.metadata):void 0)}we.to=oe})(he=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(we){function de(K){return{mime:K.mime,value:K.value,metadata:K.metadata}}we.from=de;function oe(K){return new l.NotebookCellOutputItem(K.mime,K.value,K.metadata)}we.to=oe})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ze;(function(we){function de(K){return{outputId:K.id,outputs:K.outputs.map(ye.from),metadata:K.metadata}}we.from=de;function oe(K){const Re=K.outputs.map(ye.to);return new l.NotebookCellOutput(Re,K.outputId,K.metadata)}we.to=oe})(ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Be;(function(we){function de(Ie){if(Ie!=null){if(Ie instanceof l.RelativePattern||typeof Ie=="string")return Ie;if(Re(Ie))return new l.RelativePattern(Ie.base,Ie.pattern);if(K(Ie))return{include:Xe.from(Ie.include)||void 0,exclude:Xe.from(Ie.exclude)||void 0}}}we.from=de;function oe(Ie){return typeof Ie=="string"?Ie:Re(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}we.to=oe;function K(Ie){const Qe=Ie,Ze=Xe.from(Qe.include);if(!(Ze&&Ze instanceof l.RelativePattern||typeof Ze=="string"))return!1;const ut=Xe.from(Qe.exclude);return!!(ut&&ut instanceof l.RelativePattern||typeof ut=="string")}function Re(Ie){const Qe=Ie;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(Be=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ne;(function(we){function de(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?v.from(oe.top):void 0}}we.from=de})(Ne=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(we){function de(oe,K,Re){const Ie=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ie,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=de})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(we){function de(oe){var K,Re;return{transientOutputs:(K=oe==null?void 0:oe.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:Object.assign(Object.assign({},oe==null?void 0:oe.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Re=oe==null?void 0:oe.transientDocumentMetadata)!==null&&Re!==void 0?Re:{}}}we.from=de})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(we){function de(K){var Re;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Re=K.provides)!==null&&Re!==void 0?Re:[]}}we.from=de;function oe(K){return{uri:D.URI.revive(K.uri),provides:K.provides}}we.to=oe})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(we){function de(K){return{message:u.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?U.from(K.location):void 0}}we.from=de;function oe(K){const Re=new l.TestMessage(typeof K.message=="string"?K.message:u.to(K.message));return Re.severity=K.severity,Re.actualOutput=K.actualOutput,Re.expectedOutput=K.expectedOutput,Re}we.to=oe})(it=e.TestMessage||(e.TestMessage={}));var Je;(function(we){function de(Ie){var Qe,Ze;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:(Qe=Ie.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Ie.description||null,runnable:(Ze=Ie.runnable)!==null&&Ze!==void 0?Ze:!0,error:Ie.error&&u.fromStrict(Ie.error)||null}}we.from=de;function oe(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:!1,description:Ie.description||null,error:null,runnable:!0}}we.fromResultSnapshot=oe;function K(Ie){return{id:Ie.extId,label:Ie.label,uri:D.URI.revive(Ie.uri),range:m.to(Ie.range||void 0),addChild:()=>{},dispose:()=>{},status:l.TestItemStatus.Pending,data:void 0,debuggable:Ie.debuggable,description:Ie.description||void 0,runnable:Ie.runnable}}we.toPlain=K;function Re(Ie){const Qe=new l.TestItemImpl(Ie.extId,Ie.label,D.URI.revive(Ie.uri),void 0);return Qe.range=m.to(Ie.range||void 0),Qe.debuggable=Ie.debuggable,Qe.description=Ie.description||void 0,Qe.runnable=Ie.runnable,Qe}we.to=Re})(Je=e.TestItem||(e.TestItem={}));var mt;(function(we){const de=(K,Re)=>Object.assign(Object.assign({},Je.toPlain(K.item)),{taskStates:K.tasks.map(Ie=>({state:Ie.state,duration:Ie.duration,messages:Ie.messages.map(it.to)})),children:K.children.map(Ie=>Re.get(Ie)).filter(C.isDefined).map(Ie=>de(Ie,Re))});function oe(K){const Re=[],Ie=new Map;for(const Qe of K.items)Ie.set(Qe.item.extId,Qe),Qe.direct&&Re.push(Qe);return{completedAt:K.completedAt,results:Re.map(Qe=>de(Qe,Ie))}}we.to=oe})(mt=e.TestResults||(e.TestResults={}));var wt;(function(we){function de(oe){switch(oe){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=de})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[177],_e([0,1,2,12,7,9,45]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,n,P,d={timeout:1500,errors:3}){this._logService=k,this._documents=n,this._mainThreadBulkEdits=P,this._thresholds=d,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(n,P,d)=>{const r={dispose:this._callbacks.push([n,P,k])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(k,n){const P=b.URI.revive(k);let d=!1;const h=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let l of[...this._callbacks]){if(d)break;const g=this._documents.getDocument(P),m=await this._deliverEventAsyncAndBlameBadListeners(l,{document:g,reason:T.TextDocumentSaveReason.to(n)});r.push(m)}}finally{clearTimeout(h)}return r}_deliverEventAsyncAndBlameBadListeners([k,n,P],d){const h=this._badListeners.get(k);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,k,n,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const l=this._badListeners.get(k);this._badListeners.set(k,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,n,P,d){const h=[],r=Date.now(),{document:l,reason:g}=d,{version:m}=l,S=Object.freeze({document:l,reason:g,waitUntil(f){if(Object.isFrozen(h))throw(0,I.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(f))}});try{n.apply(P,[S])}catch(f){return Promise.reject(f)}return Object.freeze(h),new Promise((f,c)=>{const p=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(p),f(t)}).catch(t=>{clearTimeout(p),c(t)})}).then(f=>{const c={edits:[]};for(const p of f)if(Array.isArray(p)&&p.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:i,range:o}of p)c.edits.push({_type:2,resource:l.uri,edit:{range:o&&T.Range.from(o),text:t,eol:i&&T.EndOfLine.from(i)}});if(c.edits.length!==0)return m===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(be[178],_e([0,1,3,11,28,2,9,7]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(P,d,h,r,l){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,h&&(this._config+=1),r&&(this._config+=2),l&&(this._config+=4);const g=(0,A.parse)(d),m=P(S=>{if(!h)for(let f of S.created){const c=T.URI.revive(f);g(c.fsPath)&&this._onDidCreate.fire(c)}if(!r)for(let f of S.changed){const c=T.URI.revive(f);g(c.fsPath)&&this._onDidChange.fire(c)}if(!l)for(let f of S.deleted){const c=T.URI.revive(f);g(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(P,d,h){this._logService=d,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,d,h,r){return new D(this._onFileSystemEvent.event,P,d,h,r)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,d){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(h=>({oldUri:T.URI.revive(h.source),newUri:T.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,d){return(h,r,l)=>{const g=function(S){h.call(r,S)};return g.extension=P,d.event(g,void 0,l)}}async $onWillRunFileOperation(P,d,h,r){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(l=>({oldUri:T.URI.revive(l.source),newUri:T.URI.revive(l.target)}))},h,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(l=>T.URI.revive(l.target))},h,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(l=>T.URI.revive(l.target))},h,r)}}async _fireWillEvent(P,d,h,r){const l=new Set,g=[];if(await P.fireAsync(d,r,async(S,f)=>{var c;const p=Date.now(),t=await Promise.resolve(S);t instanceof C.WorkspaceEdit&&(g.push(t),l.add((c=f.extension.displayName)!==null&&c!==void 0?c:f.extension.identifier.value)),Date.now()-p>h&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),!r.isCancellationRequested&&g.length!==0){const m={edits:[]};for(let S of g){let{edits:f}=y.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(l)}}}}e.ExtHostFileSystemEventService=k}),define(be[179],_e([0,1,19,24,2,9,7,73]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(d,h,r,l){this.start=d,this.deletedCount=h,this.deletedItems=r,this.items=l}static asApiEvents(d){return d.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(r=>r.apiCell)}))}}class k{constructor(d,h,r){var l;this._notebook=d,this._extHostDocument=h,this._cellData=r,this.handle=r.handle,this.uri=A.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(l=r.metadata)!==null&&l!==void 0?l:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(d,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const d=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return d._notebook.getCellIndex(d)},notebook:d._notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get latestExecutionSummary(){return d._previousResult}})}return this._cell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,h,r){const l=r.map(T.NotebookCellOutputItem.to),g=this._outputs.find(m=>m.id===d);g&&(h||(g.outputs.length=0),g.outputs.push(...l))}setMetadata(d){this._internalMetadata=d,this._metadata=T.NotebookCellMetadata.to(d),this._previousResult=T.NotebookCellPreviousExecutionResult.to(d)}}e.ExtHostCell=k;class n{constructor(d,h,r,l,g,m,S){this._proxy=d,this._textDocumentsAndEditors=h,this._textDocuments=r,this._emitter=l,this._viewType=g,this._metadata=m,this.uri=S,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===b.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(h){return h=d._validateIndex(h),d._cells[h].apiCell},getCells(h){return(h?d._getCells(h):d._cells).map(l=>l.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,h){this._versionId=d.versionId,this._isDirty=h;for(const r of d.rawEvents)r.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===C.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(d){return d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){return d.start<0&&(d=d.with({start:0})),d.end>this._cells.length&&(d=d.with({end:this._cells.length})),d}_getCells(d){d=this._validateRange(d);const h=[];for(let r=d.start;r<d.end;r++)h.push(this._cells[r]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,h){if(!this._disposed){const r=[],l=[],g=[];d.reverse().forEach(m=>{const f=m[2].map(t=>{const i=new k(this,this._textDocumentsAndEditors,t);return h||l.push(k.asModelAddData(this.apiNotebook,t)),i}),c=new D(m[0],m[1],[],f),p=this._cells.splice(m[0],m[1],...f);for(let t of p)g.push(t.uri),c.deletedItems.push(t.apiCell);r.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:g}),h||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(r)}))}}_moveCell(d,h){const r=this._cells.splice(d,1);this._cells.splice(h,0,...r);const l=[new D(d,1,r.map(g=>g.apiCell),[]),new D(h,0,[],r)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(l)}))}_setCellOutputs(d,h){const r=this._cells[d];r.setOutputs(h),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,h,r,l){const g=this._cells[d];g.setOutputItems(h,r,l),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(d,h){const r=this._cells[d];r.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(r.uri,h)}_changeCellMetadata(d,h){var r;const l=this._cells[d],g=l.internalMetadata,m=l.apiCell.metadata;l.setMetadata(h);const S=l.apiCell.metadata;if((0,I.equals)(m,S)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:l.apiCell})),g.runState!==h.runState){const f=(r=h.runState)!==null&&r!==void 0?r:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,executionState:f}))}}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(h=>h.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(be[180],_e([0,1,7,9]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,k){this._throwIfFinalized(),!(C===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:k.map(I.NotebookCellData.from)})}}class T{constructor(C,D,k,n,P,d){this.id=C,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=n,this._viewColumn=d}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,k){C._proxy.$tryRevealRange(C.id,I.NotebookRange.from(D),k!=null?k:b.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const k=new A(this.document.version);return D(k),C._applyEdit(k.finalize())},setDecorations(D,k){return C.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let n=0;n<C.cellEdits.length;n++){if(k<0){D.push(C.cellEdits[n]),k++;continue}const d=D[k],h=C.cellEdits[n];if(d.editType===1&&h.editType===1&&d.index===h.index){d.cells.push(...C.cellEdits[n].cells),d.count+=C.cellEdits[n].count;continue}D.push(C.cellEdits[n]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=T}),define(be[181],_e([0,1,9,154,134,20,52]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,d,h){const r=this._handles++,{title:l,location:g,cancellable:m}=d,S={label:(0,A.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(r,{location:b.ProgressLocation.from(g),title:l,source:S,cancellable:m},P),this._withProgress(r,h,!!m)}_withProgress(P,d,h){let r;h&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,r));const l=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let g;try{g=d(new k(this._proxy,P),h&&r?r.token:T.CancellationToken.None)}catch(m){throw l(P),m}return g.then(m=>l(P),m=>l(P)),g}$acceptProgressCanceled(P){const d=this._mapHandleToCancellationSource.get(P);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=C;function D(n,P){return n.message=P.message,typeof P.increment=="number"&&(typeof n.increment=="number"?n.increment+=P.increment:n.increment=P.increment),n}class k extends I.Progress{constructor(P,d){super(h=>this.throttledReport(h));this._proxy=P,this._handle=d}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([(0,y.throttle)(100,(n,P)=>D(n,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[97],_e([0,1,42,12,54,9,7]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(d,h){const r=C._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=C,C._Keys=new A.IdGenerator("TextEditorDecorationType");class D{constructor(d,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,h){this._throwIfFinalized();let r=null;if(d instanceof y.Position)r=new y.Range(d,d);else if(d instanceof y.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,h,!1)}insert(d,h){this._throwIfFinalized(),this._pushEdit(new y.Range(d,d),h,!0)}delete(d){this._throwIfFinalized();let h=null;if(d instanceof y.Range)h=d;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(d,h,r){const l=this._document.validateRange(d);this._collectedEdits.push({range:l,text:h,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==y.EndOfLine.LF&&d!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=D;class k{constructor(d,h,r,l){this._proxy=d,this._id=h,this._accept(r),this._logService=l;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(m){g._setTabSize(m)},get insertSpaces(){return g._insertSpaces},set insertSpaces(m){g._setInsertSpaces(m)},get cursorStyle(){return g._cursorStyle},set cursorStyle(m){g._setCursorStyle(m)},get lineNumbers(){return g._lineNumbers},set lineNumbers(m){g._setLineNumbers(m)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const h=Math.floor(d);return h>0?h:null}if(typeof d=="string"){const h=parseInt(d,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(d){const h=this._validateTabSize(d);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const h=this._validateInsertSpaces(d);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const h={};let r=!1;if(typeof d.tabSize!="undefined"){const l=this._validateTabSize(d.tabSize);l==="auto"?(r=!0,h.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,r=!0,h.tabSize=l)}if(typeof d.insertSpaces!="undefined"){const l=this._validateInsertSpaces(d.insertSpaces);l==="auto"?(r=!0,h.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,r=!0,h.insertSpaces=l)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,h.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,h.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(d){d.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=k;class n{constructor(d,h,r,l,g,m,S,f){this.id=d,this._proxy=h,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new k(this._proxy,this.id,m,r),this._visibleRanges=S,this._viewColumn=f;const c=this;this.value=Object.freeze({get document(){return l.getValue()},set document(p){throw(0,I.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(p){if(!(p instanceof y.Selection))throw(0,I.illegalArgument)("selection");c._selections=[p],c._trySetSelection()},get selections(){return c._selections},set selections(p){if(!Array.isArray(p)||p.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");c._selections=p,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(p){throw(0,I.readonly)("visibleRanges")},get options(){return c._options.value},set options(p){c._disposed||c._options.assign(p)},get viewColumn(){return c._viewColumn},set viewColumn(p){throw(0,I.readonly)("viewColumn")},edit(p,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new D(l.getValue(),t);return p(i),c._applyEdit(i)},insertSnippet(p,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=c._selections.map(a=>T.Range.from(a));else if(t instanceof y.Position){const{lineNumber:a,column:s}=T.Position.from(t);o=[{startLineNumber:a,startColumn:s,endLineNumber:a,endColumn:s}]}else if(t instanceof y.Range)o=[T.Range.from(t)];else{o=[];for(const a of t)if(a instanceof y.Range)o.push(T.Range.from(a));else{const{lineNumber:s,column:u}=T.Position.from(a);o.push({startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u})}}return h.$tryInsertSnippet(d,p.value,o,i)},setDecorations(p,t){const i=t.length===0;i&&!c._hasDecorationsForKey.has(p.key)||(i?c._hasDecorationsForKey.delete(p.key):c._hasDecorationsForKey.add(p.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return h.$trySetDecorations(d,p.key,T.fromRangeOrRangeWithMessage(t));{const o=new Array(4*t.length);for(let a=0,s=t.length;a<s;a++){const u=t[a];o[4*a]=u.start.line+1,o[4*a+1]=u.start.character+1,o[4*a+2]=u.end.line+1,o[4*a+3]=u.end.character+1}return h.$trySetDecorationsFast(d,p.key,o)}}))},revealRange(p,t){c._runOnProxy(()=>h.$tryRevealRange(d,T.Range.from(p),t||y.TextEditorRevealType.Default))},show(p){h.$tryShowEditor(d,T.ViewColumn.from(p))},hide(){h.$tryHideEditor(d)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,b.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,b.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,b.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,b.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const h=d.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const r=h.edits.map(g=>g.range);r.sort((g,m)=>g.end.line===m.end.line?g.end.character===m.end.character?g.start.line===m.start.line?g.start.character-m.start.character:g.start.line-m.start.line:g.end.character-m.end.character:g.end.line-m.end.line);for(let g=0,m=r.length-1;g<m;g++){const S=r[g].end;if(r[g+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=h.edits.map(g=>({range:T.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,l,{setEndOfLine:typeof h.setEndOfLine=="number"?T.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(be[182],_e([0,1,137,25,2,3,6,11,7,10,15,9,20]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(g,m){if((0,k.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let S;return Array.isArray(g.highlights)&&(S=g.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),S=S.length?S:void 0),{label:g.label,highlights:S}}}class r{constructor(m,S,f){this._proxy=m,this.commands=S,this.logService=f,this.treeViews=new Map;function c(p){return p&&p.$treeViewId&&p.$treeItemHandle}S.registerArgumentProcessor({processArgument:p=>c(p)?this.convertArgument(p):Array.isArray(p)&&p.length>0?p.map(t=>c(t)?this.convertArgument(t):t):p})}registerTreeDataProvider(m,S,f){const c=this.createTreeView(m,{treeDataProvider:S},f);return{dispose:()=>c.dispose()}}createTreeView(m,S,f){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany}),p=this.createExtHostTreeView(m,S,f);return{get onDidCollapseElement(){return p.onDidCollapseElement},get onDidExpandElement(){return p.onDidExpandElement},get selection(){return p.selectedElements},get onDidChangeSelection(){return p.onDidChangeSelection},get visible(){return p.visible},get onDidChangeVisibility(){return p.onDidChangeVisibility},get message(){return p.message},set message(t){p.message=t},get title(){return p.title},set title(t){p.title=t},get description(){return p.description},set description(t){p.description=t},reveal:(t,i)=>p.reveal(t,i),dispose:async()=>{await c,this.treeViews.delete(m),p.dispose()}}}$getChildren(m,S){const f=this.treeViews.get(m);return f?f.getChildren(S):Promise.reject(new Error((0,b.localize)(0,null,m)))}async $hasResolve(m){const S=this.treeViews.get(m);if(!S)throw new Error((0,b.localize)(1,null,m));return S.hasResolve}$resolve(m,S,f){const c=this.treeViews.get(m);if(!c)throw new Error((0,b.localize)(2,null,m));return c.resolveTreeItem(S,f)}$setExpanded(m,S,f){const c=this.treeViews.get(m);if(!c)throw new Error((0,b.localize)(3,null,m));c.setExpanded(S,f)}$setSelection(m,S){const f=this.treeViews.get(m);if(!f)throw new Error((0,b.localize)(4,null,m));f.setSelection(S)}$setVisible(m,S){const f=this.treeViews.get(m);if(!f)throw new Error((0,b.localize)(5,null,m));f.setVisible(S)}createExtHostTreeView(m,S,f){const c=new l(m,S,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(m,c),c}convertArgument(m){const S=this.treeViews.get(m.$treeViewId);return S?S.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class l extends y.Disposable{constructor(m,S,f,c,p,t){super();if(this.viewId=m,this.proxy=f,this.commands=c,this.logService=p,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const s of t.contributes.views[a])s.id===m&&(this._title=s.name);this.dataProvider=S.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let i,o;this._register(T.Event.debounce(this._onDidChangeData.event,(a,s)=>(a||(a={message:!1,elements:[]}),s.element!==!1&&(i||(i=new Promise(u=>o=u),this.refreshPromise=this.refreshPromise.then(()=>i)),a.elements.push(s.element)),s.message&&(a.message=!0),a),200,!0)(({message:a,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const u=o;return i=null,this.refresh(s).then(()=>u())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}getChildren(m){const S=m?this.getExtensionElement(m):void 0;if(m&&!S)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const f=this.getChildrenNodes(m);return(f?Promise.resolve(f):this.fetchChildrenNodes(S)).then(c=>c.map(p=>p.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,S){S=S||{select:!0,focus:!1};const f=(0,k.isUndefinedOrNull)(S.select)?!0:S.select,c=(0,k.isUndefinedOrNull)(S.focus)?!1:S.focus,p=(0,k.isUndefinedOrNull)(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(o=>o.item)},{select:f,focus:c,expand:p})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:c,expand:p})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,S){const f=this.getExtensionElement(m);f&&(S?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(m){(0,n.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,S){var f;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(m);if(c){const p=this.nodes.get(c);if(p){const t=(f=await this.dataProvider.resolveTreeItem(p.extensionItem,c,S))!==null&&f!==void 0?f:p.extensionItem;return p.item.tooltip=this.getTooltip(t.tooltip),p.item.command=this.getCommand(p.disposableStore,t.command),p.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(S=>S?this.resolveUnknownParentChain(S).then(f=>this.resolveTreeNode(S,f[f.length-1]).then(c=>(f.push(c),f))):Promise.resolve([]))}resolveParent(m){const S=this.nodes.get(m);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,S){const f=this.nodes.get(m);return f?Promise.resolve(f):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(c=>this.createHandle(m,c,S,!0)).then(c=>this.getChildren(S?S.item.handle:void 0).then(()=>{const p=this.getExtensionElement(c);if(p){const t=this.nodes.get(p);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(m){if(m){let S;if(typeof m=="string"){const f=this.getExtensionElement(m);S=f?this.nodes.get(f):void 0}else S=m;return S&&S.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const S=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=m?this.nodes.get(m):void 0,c=await this.dataProvider.getChildren(m);if(S.token.isCancellationRequested)return[];const p=await Promise.all((0,n.coalesce)(c||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,f):null}));return S.token.isCancellationRequested?[]:(0,n.coalesce)(p)}finally{S.dispose()}}refresh(m){if(m.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(m);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const S=new Set,f=m.map(p=>this.nodes.get(p));for(const p of f)if(p&&!S.has(p.item.handle)){let t=p;for(;t&&t.parent&&f.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&S.add(p.item.handle)}const c=[];return S.forEach(p=>{const t=this.elements.get(p);if(t){const i=this.nodes.get(t);i&&(!i.parent||!S.has(i.parent.item.handle))&&c.push(p)}}),c}refreshHandles(m){const S={};return Promise.all(m.map(f=>this.refreshNode(f).then(c=>{c&&(S[f]=c.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(m){const S=this.getExtensionElement(m);if(S){const f=this.nodes.get(S);if(f)return this.clearChildren(S),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(S)).then(c=>{if(c){const p=this.createTreeNode(S,c,f.parent);return this.updateNodeCache(S,p,f,f.parent),f.dispose(),p}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,S,f){const c=this.createTreeNode(m,S,f);if(S.id&&this.elements.has(c.item.handle))throw new Error((0,b.localize)(6,null,S.id));return this.addNodeToCache(m,c),this.addNodeToParentCache(c,f),c}getTooltip(m){return D.MarkdownString.isMarkdownString(m)?P.MarkdownString.from(m):m}getCommand(m,S){return S?this.commands.toInternal(S,m):void 0}createTreeNode(m,S,f){const c=new y.DisposableStore,p=this.createHandle(m,S,f),t=this.getLightIconPath(S);return{item:{handle:p,parentHandle:f?f.item.handle:void 0,label:h(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(c,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:(0,k.isUndefinedOrNull)(S.collapsibleState)?D.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:f,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(m){return m.iconPath instanceof D.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:S,label:f,resourceUri:c},p,t){if(S)return`${l.ID_HANDLE_PREFIX}/${S}`;const i=h(f,this.extension),o=p?p.item.handle:l.LABEL_HANDLE_PREFIX;let a=i?i.label:c?(0,I.basename)(c):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const s=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,u=this.getChildrenNodes(p)||[];let w,_=0;do{if(w=`${o}/${_}:${a}`,t||!this.elements.has(w)||s===w)break;_++}while(_<=u.length);return w}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof D.ThemeIcon))return typeof m.iconPath=="string"||A.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof D.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return A.URI.isUri(m)?m:A.URI.file(m)}addNodeToCache(m,S){this.elements.set(S.item.handle,m),this.nodes.set(m,S)}updateNodeCache(m,S,f,c){this.elements.delete(S.item.handle),this.nodes.delete(m),S.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(m,S);const p=this.getChildrenNodes(c)||[],t=p.filter(i=>i.item.handle===f.item.handle)[0];t&&p.splice(p.indexOf(t),1,S)}addNodeToParentCache(m,S){S?(S.children||(S.children=[]),S.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const S=this.nodes.get(m);if(S){if(S.children)for(const f of S.children){const c=this.elements.get(f.item.handle);c&&this.clear(c)}S.children=void 0}}else this.clearAll()}clear(m){const S=this.nodes.get(m);if(S){if(S.children)for(const f of S.children){const c=this.elements.get(f.item.handle);c&&this.clear(c)}this.nodes.delete(m),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}l.LABEL_HANDLE_PREFIX="0",l.ID_HANDLE_PREFIX="1"}),define(be[183],_e([0,1,15,11,20,10,69,9,7,96]),function(Q,e,b,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class n{constructor(){this.testIdsToInternal=new Map}getTestById(g,m){if(m!==void 0){const S=this.testIdsToInternal.get(m),f=S==null?void 0:S.get(g);if(f)return[S,f]}return(0,b.mapFind)(this.testIdsToInternal.values(),S=>{const f=S.get(g);return f&&[S,f]})}createForHierarchy(g=()=>{}){return new r(this.createIdMap(d++),g)}createIdMap(g){const m=new h(g);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=n;var P;(function(l){l[l.Disconnected=0]="Disconnected",l[l.IsChild=1]="IsChild",l[l.IsParent=2]="IsParent",l[l.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let d=0;class h{constructor(g){this.id=g,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(g){if(this.map.has(g.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${g.item.extId}`);this.map.set(g.item.extId,g),g.parent||this._roots.add(g)}has(g){return this.map.has(g)}delete(g){const m=this.map.get(g);return m?(this.map.delete(g),this._roots.delete(m),!0):!1}get(g){return this.map.get(g)}comparePositions(g,m){const S=typeof g=="string"?this.map.get(g):g,f=typeof m=="string"?this.map.get(m):m;if(!S||!f)return 0;if(S===f)return 3;for(let c=this.map.get(f.parent);c;c=this.map.get(c.parent))if(c===S)return 1;for(let c=this.map.get(S.parent);c;c=this.map.get(c.parent))if(c===f)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class r{constructor(g,m){this.testIdToInternal=g,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(g,m){this.addItem(g,m,null)}getTestByReference(g){return this.testItemToInternal.get(g)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const m=this.diff[this.diff.length-1];if(m&&g[0]===1){if(m[0]===1&&m[1].extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}if(m[0]===0&&m[1].item.extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,m){var S;const f=this.testIdToInternal.object.get(g);if(!!f){if((f.expandLevels===void 0||m>f.expandLevels)&&(f.expandLevels=m),f.expand===1){const c=this.refreshChildren(f);return c.isSettled?this.expandChildren(f,m-1):c.p.then(()=>this.expandChildren(f,m-1))}else if(f.expand===3)return((S=f.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?f.initialExpand.p.then(()=>this.expandChildren(f,m-1)):this.expandChildren(f,m-1)}}dispose(){var g;for(const m of this.testItemToInternal.values())(g=m.discoverCts)===null||g===void 0||g.dispose(!0),(0,y.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(g,m){const S=g==null?void 0:g.actual.id;switch(m[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(g);break;case 0:this.addItem(m[1],g.src.controller,g);break;case 3:const[f,c,p]=m;switch(c){case"status":this.updateExpandability(g);break;case"range":this.pushDiff([1,{extId:S,item:{range:C.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:C.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[c]:p!=null?p:null}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(g,m,S){if(!(g instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);if(this.testItemToInternal.has(g))throw new Error(`Attempted to add a single TestItem ${g.id} multiple times to the tree`);if(this.testIdToInternal.object.has(g.id))throw new Error(`Attempted to insert a duplicate test item ID ${g.id}`);const f=S?S.item.extId:null,c=g.resolveHandler?1:0,p=S==null?void 0:S.expandLevels,t={controller:m,tree:this.testIdToInternal.object.id},i={actual:g,parent:f,item:C.TestItem.from(g),expandLevels:p?p-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(i),this.testItemToInternal.set(g,i),this.pushDiff([0,{parent:f,src:t,expand:c,item:i.item}]);const o=(0,y.getPrivateApiFor)(g);o.parent=S==null?void 0:S.actual,o.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const a of o.children.values())this.testItemToInternal.has(a)||this.addItem(a,m,i)}updateExpandability(g){var m;let S;g.actual.resolveHandler?g.actual.status===D.TestItemStatus.Pending?S=g.discoverCts?2:1:((m=g.initialExpand)===null||m===void 0||m.complete(),S=3):S=0,S!==g.expand&&(g.expand=S,this.pushDiff([1,{extId:g.actual.id,expand:S}]),S===1&&g.expandLevels!==void 0&&this.refreshChildren(g))}expandChildren(g,m){if(!(m<0)){const S=[...g.actual.children.values()].map(f=>this.expand(f.id,m)).filter(I.isThenable);if(S.length)return Promise.all(S).then(()=>{})}}refreshChildren(g){if(g.discoverCts&&g.discoverCts.dispose(!0),!g.actual.resolveHandler){const m=new I.DeferredPromise;return m.complete(),m}return g.expand=2,g.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(g),g.initialExpand=new I.DeferredPromise,g.actual.resolveHandler(g.discoverCts.token),g.initialExpand}pushExpandStateUpdate(g){this.pushDiff([1,{extId:g.actual.id,expand:g.expand}])}removeItem(g){var m;this.pushDiff([2,g.actual.id]);const S=[g];for(;S.length;){const f=S.pop();if(!!f){(m=f.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(f.item.extId),this.testItemToInternal.delete(f.actual);for(const c of f.actual.children.values())S.push(this.testIdToInternal.object.get(c.id))}}}flushDiff(){const g=this.collectDiff();g.length&&this.publishDiff(g)}}e.SingleUseTestCollection=r}),define(be[184],_e([0,1,26,3,13]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=T;class y{constructor(n){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let P of n.activationEvents)P==="onUri"&&(P=`onUri:${b.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(n)}}keepOnly(n){const P=new Set;n.forEach(d=>P.add(b.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>P.has(b.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,P){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const d=y._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(d.map(h=>h.identifier)),P.length>0){const h=new Set;P.forEach(r=>h.add(b.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!h.has(b.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(n){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this._arcs.has(g)?this._arcs.get(g).push(m):this._arcs.set(g,[m])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,m){const S=P.getArcs(g);for(let f=0;f<S.length;f++)if(!m.has(S[f]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let g of n){const m=b.ExtensionIdentifier.toKey(g.identifier);if(d.set(m,g),g.extensionDependencies)for(let S of g.extensionDependencies){const f=b.ExtensionIdentifier.toKey(S);P.addArc(m,f)}}let h=new Set;P.getNodes().filter(g=>P.getArcs(g).length===0).forEach(g=>h.add(g));let r=P.getNodes().filter(g=>!h.has(g)),l;do{l=!1;for(let g=0;g<r.length;g++){const m=r[g];P.hasOnlyGoodArcs(m,h)&&(r.splice(g,1),g--,h.add(m),l=!0)}}while(l);return r.map(g=>d.get(g))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const P=this._activationMap.get(n);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const P=this._extensionsMap.get(b.ExtensionIdentifier.toKey(n));return P||void 0}}e.ExtensionDescriptionRegistry=y;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function D(k,n){const P=k.isBuiltin?0:k.isUnderDevelopment?2:1,d=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(P!==d)return P-d;const h=A.posix.basename(k.extensionLocation.path),r=A.posix.basename(n.extensionLocation.path);return h<r?-1:h>r?1:0}}),define(be[185],_e([0,1,23]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(C){const D=b.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(be[33],_e([0,1,3,2,4,26,151]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class C{constructor(S){this.dependency=S}}e.MissingDependencyError=C;var D;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(S,f,c,p){this.codeLoadingTime=S,this.activateCallTime=f,this.activateResolvedTime=c,this.activationReason=p}}e.ActivationTimes=k;class n{constructor(S,f){this.description=S,this.value=f}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var P;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function d(m){m.enableProposedApi||h(m)}e.checkProposedApiEnabled=d;function h(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=h;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function l(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=l;class g{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(S,f){}_activateById(S,f){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,f,c,p,t){}_onExtensionRuntimeError(S,f){}_onExtensionHostExit(S){}}e.NullExtensionService=g}),define(be[186],_e([0,1,132,26,33,18]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class C{constructor(l,g,m,S){this.startup=l,this.codeLoadingTime=g,this.activateCallTime=m,this.activateResolvedTime=S}}e.ExtensionActivationTimes=C,C.NONE=new C(!1,-1,-1,-1);class D{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,g){return l===-1||g===-1?-1:g-l}build(){return new C(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class k{constructor(l,g,m,S,f,c){this.activationFailed=l,this.activationFailedError=g,this.activationTimes=m,this.module=S,this.exports=f,this.subscriptions=c}}e.ActivatedExtension=k;class n extends k{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=n;class P extends k{constructor(){super(!1,null,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class d extends k{constructor(l){super(!0,l,C.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=d;let h=class{constructor(l,g,m,S,f){this._logService=f,this._registry=l,this._resolvedExtensionsSet=new Set,g.forEach(c=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,m.forEach(c=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(c),c)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const g=I.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(g)}getActivatedExtension(l){const g=I.ExtensionIdentifier.toKey(l),m=this._activatedExtensions.get(g);if(!m)throw new Error("Extension `"+l.value+"` is not known or not activated");return m}activateByEvent(l,g){if(this._alreadyActivatedEvents[l])return y;const m=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(m.map(S=>({id:S.identifier,reason:{startup:g,extensionId:S.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,g){const m=this._registry.getExtensionDescription(l);if(!m)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:m.identifier,reason:g}])}_handleActivateRequest(l,g,m){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(l.id))){g[I.ExtensionIdentifier.toKey(l.id)]=l;return}const S=this._registry.getExtensionDescription(l.id);if(!S){this._host.onExtensionActivationError(l.id,new A.MissingDependencyError(l.id.value));const p=new Error(`Unknown dependency '${l.id.value}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(l.id),new d(p));return}const f=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let c=!0;for(let p=0,t=f.length;p<t;p++){const i=f[p];if(!this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(i))){const o=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(i));if(!(o&&!o.activationFailed)){if(o&&o.activationFailed){this._host.onExtensionActivationError(S.identifier,b.localize(0,null,S.displayName||S.identifier.value,i));const u=new Error(`Dependency ${i} failed to activate`);u.detail=o.activationFailedError,this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new d(u));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(i))){c=!1,g[I.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(i)),reason:l.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){c=!1,g[I.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:l.reason};continue}this._host.onExtensionActivationError(S.identifier,new A.MissingDependencyError(i));const s=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(I.ExtensionIdentifier.toKey(S.identifier),new d(s));return}}}c?g[I.ExtensionIdentifier.toKey(S.identifier)]=l:m.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(f=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(f.id))),l.length===0))return Promise.resolve(void 0);const g=Object.create(null),m=[];for(let f=0,c=l.length;f<c;f++)this._handleActivateRequest(l[f],g,m);for(let f=0,c=m.length;f<c;f++){const p=I.ExtensionIdentifier.toKey(m[f].id);g[p]&&delete g[p]}const S=Object.keys(g).map(f=>g[f]);return m.length===0?Promise.all(S.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(S).then(f=>this._activateExtensions(m))}_activateExtension(l,g){const m=I.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const S=this._activatingExtensions.get(m);if(S)return S;const f=this._host.actualActivateExtension(l,g).then(void 0,c=>(this._host.onExtensionActivationError(l,b.localize(1,null,l.value,c.message)),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(c),new d(c))).then(c=>{this._activatedExtensions.set(m,c),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,f),f}};h=Ve([qe(4,T.ILogService)],h),e.ExtensionsActivator=h}),define(be[187],_e([0,1,12]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,b.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=I}),define(be[98],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const I=[];function A(C){const D=new b(!0,C);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=A;function T(C){const D=new b(!1,C);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(C){return I[C].sid}e.getStringIdentifierForProxy=y}),define(be[5],_e([0,1,2,98,57]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(c){c[c.Markdown=1]="Markdown",c[c.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var n;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var d;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(d=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(c){c.name="$ident";function p(i,o){return Object.defineProperty(i,c.name,{value:o,enumerable:!0}),i}c.mixin=p;function t(i){return i[c.name]}c.of=t})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(p){return p._id=r._n++,p}}e.IdObject=r,r._n=0;var l;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(c){if(c&&c.edits)for(const p of c.edits)typeof p.resource=="object"?p.resource=b.URI.revive(p.resource):(p.newUri=b.URI.revive(p.newUri),p.oldUri=b.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,A.revive)(p.metadata));return c}e.reviveWorkspaceEditDto=S;var f;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],_e([0,1,5,3,4]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(C){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,k){return this._proxy.$setPassword(C,D,k)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(be[75],_e([0,1,4,18,5,14]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(A.MainContext.MainThreadTelemetry)}report(D,k,n){const P=this.getUsageKey(D,k);this._reportedUsages.has(P)||(this._reportedUsages.add(P),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,k){}})}),define(be[188],_e([0,1,3,5,7,26]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,n,P={}){const d=T.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(d)||[],r=n.sort().join(" ");let l=h.find(g=>g.scopes===r);if(l)return l.result;{const g=this._getSession(D,d,k,n,P);l={scopes:r,result:g},h.push(l),this._inFlightRequests.set(d,h);try{await g}finally{const m=h.findIndex(S=>S.scopes===r);m>-1&&(h.splice(m),this._inFlightRequests.set(d,h))}return g}}async _getSession(D,k,n,P,d={}){await this._proxy.$ensureProvider(n);const h=D.displayName||D.name;return this._proxy.$getSession(n,P,k,h,d)}async removeSession(D,k){const n=this._authenticationProviders.get(D);return n?n.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,n,P){var d;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:n,options:P!=null?P:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===D)||this._providers.push({id:D,label:k});const h=n.onDidChangeSessions(r=>{var l,g,m;this._proxy.$sendDidChangeSessions(D,{added:(l=r.added)!==null&&l!==void 0?l:[],changed:(g=r.changed)!==null&&g!==void 0?g:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(d=P==null?void 0:P.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new A.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(D);const r=this._providers.findIndex(l=>l.id===D);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const n=this._authenticationProviders.get(D);if(n)return Promise.resolve(n.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(n=>{this._providers.some(P=>P.id===n.id)||this._providers.push(n)}),k.forEach(n=>{const P=this._providers.findIndex(d=>d.id===n.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(be[189],_e([0,1,5,14,9]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=A.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=Ve([qe(0,I.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[190],_e([0,1,5]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(T){const y=T.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(C){return y.$writeText(C)}})}}e.ExtHostClipboard=I}),define(be[76],_e([0,1,10,7,9,24,5,15,18,57,32,38,2,6,4,14]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=i,this.converter=new m(this,o=>{const a=this._apiCommands.get(o);return(a==null?void 0:a.result)===f.Void?a:void 0},i),this._argumentProcessors=[{processArgument(o){return(0,k.revive)(o)}},{processArgument(o){return(0,T.cloneAndChange)(o,function(a){if(n.Range.isIRange(a))return A.Range.to(a);if(P.Position.isIPosition(a))return A.Position.to(a);if(n.Range.isIRange(a.range)&&d.URI.isUri(a.uri))return A.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...o)=>{const a=t.args.map((u,w)=>{if(!u.validate(o[w]))throw new Error(`Invalid argument '${u.name}' when running '${t.id}', received: ${o[w]}`);return u.convert(o[w])}),s=await this.executeCommand(t.internalId,...a);return t.result.convert(s,o,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,o,a,s){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:o,thisArg:a,description:s}),t&&this._proxy.$registerCommand(i),new I.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,o){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const a=(0,T.cloneAndChange)(i,function(s){if(s instanceof I.Position)return A.Position.from(s);if(s instanceof I.Range)return A.Range.from(s);if(s instanceof I.Location)return A.location.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,a,o);return(0,k.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw s}}}async _executeContributedCommand(t,i){const o=this._commands.get(t);if(!o)throw new Error("Unknown command");let{callback:a,thisArg:s,description:u}=o;if(u)for(let w=0;w<u.args.length;w++)try{(0,b.validateConstraint)(i[w],u.args[w].constraint)}catch(_){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${u.args[w].name}' - ${u.args[w].description}`)}try{return await a.apply(s,i)}catch(w){if(t===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...i);_&&(t=_.command)}throw this._logService.error(w,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(o=>this._argumentProcessors.reduce((a,s)=>s.processArgument(a),o)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(o=>o[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,o]of this._commands){let{description:a}=o;a&&(t[i]=a)}return Promise.resolve(t)}};g=Ve([qe(0,l.IExtHostRpcService),qe(1,D.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,i,o){this._commands=t,this._lookupApiCommand=i,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const o={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return o;const a=this._lookupApiCommand(t.command);if(a)o.id=a.internalId,o.arguments=a.args.map((s,u)=>s.convert(t.arguments&&t.arguments[u]));else if((0,C.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),i.add((0,h.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),o.$ident=s,o.id=this.delegatingCommandId,o.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return o}}fromInternal(t){const i=y.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class S{constructor(t,i,o,a){this.name=t,this.description=i,this.validate=o,this.convert=a}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new S(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",p=>d.URI.isUri(p),p=>p),S.Position=new S("position","A position in a text document",p=>I.Position.isPosition(p),A.Position.from),S.Range=new S("range","A range in a text document",p=>I.Range.isRange(p),A.Range.from),S.Selection=new S("selection","A selection in a text document",p=>I.Selection.isSelection(p),A.Selection.from),S.Number=new S("number","",p=>typeof p=="number",p=>p),S.String=new S("string","",p=>typeof p=="string",p=>p),S.CallHierarchyItem=new S("item","A call hierarchy item",p=>p instanceof I.CallHierarchyItem,A.CallHierarchyItem.to);class f{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=f,f.Void=new f("no result",p=>p);class c{constructor(t,i,o,a,s){this.id=t,this.internalId=i,this.description=o,this.args=a,this.result=s}}e.ApiCommand=c}),define(be[191],_e([0,1,6,9,7,62,76,169,15,87]),function(Q,e,b,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const n=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,l)=>{if(!(0,D.isFalsyOrEmpty)(r)){class g extends A.SymbolInformation{static to(S){const f=new g(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new A.Location(l[0],I.Range.to(S.range)));return f.detail=S.detail,f.range=f.location.range,f.selectionRange=I.Range.to(S.selectionRange),f.children=S.children?S.children.map(g.to):[],f}}return r.map(g.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(l=>A.Position.isPosition(l)),r=>r.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(l=>{let g;for(const m of l.reverse())g=new A.SelectionRange(I.Range.to(m),g);return g}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const l=[];if(Array.isArray(r))for(let g of r)l.push(...g[1].map(I.WorkspaceSymbol.to));return l})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return I.WorkspaceEdit.to(r)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const l=(0,k.decodeSemanticTokensDto)(r);if(l.type==="full")return new A.SemanticTokens(l.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const l=(0,k.decodeSemanticTokensDto)(r);if(l.type==="full")return new A.SemanticTokens(l.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,l,g)=>{if(!r)return new A.CompletionList([]);const m=r.suggestions.map(S=>I.CompletionItem.to(S,g));return new A.CompletionList(m,r.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return I.SignatureHelp.to(r)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,l,g)=>d(m=>new A.CodeLens(I.Range.to(m.range),m.command&&g.fromInternal(m.command)))(r))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.Range.isRange(r),r=>A.Selection.isSelection(r)?I.Selection.from(r):I.Range.from(r)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,l,g)=>d(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(m.command)}else{const S=new A.CodeAction(m.title,m.kind?new A.CodeActionKind(m.kind):void 0);return m.edit&&(S.edit=I.WorkspaceEdit.to(m.edit)),m.command&&(S.command=g.fromInternal(m.command)),S.isPreferred=m.isPreferred,S}})(r))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(l=>new A.ColorInformation(I.Range.to(l.range),I.Color.to(l.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",r=>r instanceof A.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:I.Range.from(r.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(I.InlineHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(l=>I.NotebookExclusiveDocumentPattern.to(l))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[I.ViewColumn.from(r.viewColumn),I.TextEditorOpenOptions.from(r)]).optional()],y.ApiCommandResult.Void)];class P{constructor(l){this._disposables=new b.DisposableStore,this._commands=l}static register(l){return n.forEach(l.registerApiCommand,l),new P(l).registerCommands()}registerCommands(){const l=g=>(...m)=>g(this._commands,...m);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,l(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:g=>typeof g=="string"}]}),this._register(C.OpenIssueReporter.ID,l(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:g=>typeof g=="string"||typeof g=="object"&&typeof g.extensionId=="string"}]})}_register(l,g,m){const S=this._commands.registerCommand(!1,l,g,this,m);this._disposables.add(S)}}e.ExtHostApiCommands=P;function d(r){return l=>{if(Array.isArray(l))return l.map(r)}}function h(r){if(!!Array.isArray(r)){const l=[];for(const g of r)T.isLocationLink(g)?l.push(I.DefinitionLink.to(g)):l.push(I.location.to(g));return l}}}),define(be[192],_e([0,1,11,52,3,6,2,62,26,9,7,5]),function(Q,e,b,I,A,T,y,C,D,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(c,p,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadComments),p.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const o=this._commentControllers.get(i.handle);return o||i}else if(i&&i.$mid===7){const o=this._commentControllers.get(i.commentControlHandle);if(!o)return i;const a=o.getCommentThread(i.commentThreadHandle);return a||i}else if(i&&i.$mid===8){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const a=o.getCommentThread(i.thread.commentThreadHandle);return a?{thread:a,text:i.text}:i}else if(i&&i.$mid===9){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const a=o.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let s=i.commentUniqueId,u=a.getCommentByUniqueId(s);return u||i}else if(i&&i.$mid===10){const o=this._commentControllers.get(i.thread.commentControlHandle);if(!o)return i;const a=o.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let s=i.text,u=i.commentUniqueId,w=a.getCommentByUniqueId(u);return w?(w.body=s,w):i}return i}})}createCommentController(c,p,t){const i=d.handlePool++,o=new r(c,i,this._proxy,p,t);this._commentControllers.set(o.handle,o);const a=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(c.identifier))||[];return a.push(o),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(c.identifier),a),o}$createCommentThreadTemplate(c,p,t){const i=this._commentControllers.get(c);!i||i.$createCommentThreadTemplate(p,t)}async $updateCommentThreadTemplate(c,p,t){const i=this._commentControllers.get(c);!i||i.$updateCommentThreadTemplate(p,t)}$deleteCommentThread(c,p){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(p)}$provideCommentingRanges(c,p,t){const i=this._commentControllers.get(c);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(y.URI.revive(p));return(0,b.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(o,t)).then(a=>a?a.map(s=>k.Range.from(s)):void 0)}$toggleReaction(c,p,t,i,o){const a=this._commentControllers.get(c);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const s=a.getCommentThread(p);if(s){const u=s.getCommentByUniqueId(i.uniqueIdInThread);if(a!==void 0&&u&&a.reactionHandler)return a.reactionHandler(u,m(o))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class h{constructor(c,p,t,i,o,a,s){this._proxy=c,this._commentController=p,this._id=t,this._uri=i,this._range=o,this._comments=a,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${p.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),p={};c("range")&&(p.range=k.Range.from(this._range)),c("label")&&(p.label=this.label),c("contextValue")&&(p.contextValue=this.contextValue),c("comments")&&(p.comments=this._comments.map(t=>l(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(p.collapseState=S(this._collapseState)),c("canReply")&&(p.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,p)}}getCommentByUniqueId(c){for(let p of this._commentsMap){let t=p[0],i=p[1];if(c===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,Ve([(0,I.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class r{constructor(c,p,t,i,o){this._extension=c,this._handle=p,this._proxy=t,this._id=i,this._label=o,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,o)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,p,t,i){if(typeof c=="string"){const o=new h(this._proxy,this,c,p,t,i,this._extension.identifier);return this._threads.set(o.handle,o),o}else{const o=new h(this._proxy,this,void 0,c,p,t,this._extension.identifier);return this._threads.set(o.handle,o),o}}$createCommentThreadTemplate(c,p){const t=new h(this._proxy,this,void 0,y.URI.revive(c),k.Range.to(p),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,p){let t=this._threads.get(c);t&&(t.range=k.Range.to(p))}$deleteCommentThread(c){let p=this._threads.get(c);p&&p.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function l(f,c,p,t){let i=t.get(p);i||(i=++f.commentHandle,t.set(p,i));const o=p.author&&p.author.iconPath?p.author.iconPath.toString():void 0;return{mode:p.mode,contextValue:p.contextValue,uniqueIdInThread:i,body:k.MarkdownString.from(p.body),userName:p.author.name,userIconPath:o,label:p.label,commentReactions:p.reactions?p.reactions.map(a=>g(a)):void 0}}function g(f){return{label:f.label,iconPath:f.iconPath?k.pathOrURIToURI(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted}}function m(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?y.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1}}function S(f){if(f!==void 0)switch(f){case n.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(be[99],_e([0,1,2,5,7,4,14,18,15,8,13]),function(Q,e,b,I,A,T,y,C,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class vn{constructor(h,r){this._logService=r,this._provider=new Map,this._proxy=h.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,r){const l=vn._handlePool++;this._provider.set(l,{provider:h,extensionId:r}),this._proxy.$registerDecorationProvider(l,r.value);const g=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(l,null);return}let S=(0,D.asArray)(m);if(S.length<=vn._maxEventSize){this._proxy.$onDidChange(l,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,S.length);const f=S.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,D.groupBy)(f,(t,i)=>t.rank-i.rank||(0,k.compare)(t.uri.path,i.uri.path));let p=[];e:for(let t of c){let i;for(let o of t){let a=(0,n.dirname)(o.uri.path);if(i!==a&&(i=a,p.push(o.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(l,p)});return new A.Disposable(()=>{g==null||g.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(h,r,l){if(!this._provider.has(h))return Object.create(null);const g=Object.create(null),{provider:m,extensionId:S}=this._provider.get(h);return await Promise.all(r.map(async f=>{try{const{uri:c,id:p}=f,t=await Promise.resolve(m.provideFileDecoration(b.URI.revive(c),l));if(!t)return;try{A.FileDecoration.validate(t),g[p]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${S.value}': ${i}`)}}catch(c){this._logService.error(c)}})),g}};P._handlePool=0,P._maxEventSize=250,P=Ve([qe(0,y.IExtHostRpcService),qe(1,C.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[193],_e([0,1,131,90,2,5,7,9,3,18,22]),function(Q,e,b,I,A,T,y,C,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(r,l,g,m,S){this._name=r,this._owner=l,this._maxDiagnosticsPerFile=g,this._proxy=m,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,l){if(!r){this.clear();return}this._checkDisposed();let g=[];if(A.URI.isUri(r)){if(!l){this.delete(r);return}this._data.set(r,l.slice()),g=[r]}else if(Array.isArray(r)){g=[];let S;r=[...r].sort(P._compareIndexedTuplesByUri);for(const f of r){const[c,p]=f;if((!S||c.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=c,g.push(c),this._data.set(c,[])),p){const t=this._data.get(c);t&&t.push(...p)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(g),!!this._proxy){const m=[];for(let S of g){let f=[];const c=this._data.get(S);if(c)if(c.length>this._maxDiagnosticsPerFile){f=[];const p=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of c)if(i.severity===p[t]&&f.push(C.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;f.push({severity:I.MarkerSeverity.Info,message:(0,b.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=c.map(p=>C.Diagnostic.from(p));m.push([S,f])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,l){this._checkDisposed();for(let g of this._data.keys())r.apply(l,[g,this.get(g),this])}get(r){this._checkDisposed();const l=this._data.get(r);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,l){return r[0].toString()<l[0].toString()?-1:r[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=P;let d=class Ht{constructor(r,l){this._logService=l,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Ht._debouncer,50),Ht._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,l){return r?r.concat(l):l}static _mapper(r){const l=[],g=new Set;for(const m of r)typeof m=="string"?g.has(m)||(g.add(m),l.push(A.URI.parse(m))):g.has(m.toString())||(g.add(m.toString()),l.push(m));return Object.freeze(l),{uris:l}}createDiagnosticCollection(r,l){const{_collections:g,_proxy:m,_onDidChangeDiagnostics:S,_logService:f}=this,c=new class{$changeMany(i,o){m.$changeMany(i,o),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,o.length===0?"CLEARING":o)}$clear(i){m.$clear(i),f.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){m.dispose()}};let p;if(!l)l="_generated_diagnostic_collection_name_#"+Ht._idPool++,p=l;else if(!g.has(l))p=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do p=l+Ht._idPool++;while(g.has(p))}return new class extends P{constructor(){super(l,p,Ht._maxDiagnosticsPerFile,c,S);g.set(p,this)}dispose(){super.dispose(),g.delete(p)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const l=new Map,g=[];for(const m of this._collections.values())m.forEach((S,f)=>{let c=l.get(S.toString());typeof c=="undefined"&&(c=g.length,l.set(S.toString(),c),g.push([S,[]])),g[c][1]=g[c][1].concat(...f)});return g}}_getDiagnostics(r){let l=[];for(let g of this._collections.values())g.has(r)&&(l=l.concat(g.get(r)));return l}$acceptMarkersChange(r){if(!this._mirrorCollection){const l="_generated_mirror",g=new P(l,l,Ht._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(l,g),this._mirrorCollection=g}for(const[l,g]of r)this._mirrorCollection.set(A.URI.revive(l),g.map(C.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Ve([qe(1,k.ILogService)],d),e.ExtHostDiagnostics=d}),define(be[194],_e([0,1,2,5]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(C=>C?C.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(C=>C?b.URI.revive(C):void 0)}}e.ExtHostDialogs=A}),define(be[195],_e([0,1,12,2,7,5,19,20,8]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(P,d,h){this._documentsAndEditors=d,this._logService=h,this._documentContentProviders=new Map,this._proxy=P.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,d){if(Object.keys(y.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const h=k._handlePool++;this._documentContentProviders.set(h,d),this._proxy.$registerTextContentProvider(h,P);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(l=>{if(l.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(h,l).then(g=>{if(!(!g&&typeof g!="string")){const m=this._documentsAndEditors.getDocument(l);if(!!m){const S=(0,D.splitLines)(g);if(!m.equalLines(S))return this._proxy.$onVirtualDocumentChange(l,g)}}},b.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(P,d){const h=this._documentContentProviders.get(P);return h?Promise.resolve(h.provideTextDocumentContent(I.URI.revive(d),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[196],_e([0,1,3,6,2,5,95,9,10,24]),function(Q,e,b,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(d,h){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const l of r)this._onDidRemoveDocument.fire(l.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const l of r)this._onDidAddDocument.fire(l.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!!d){const h=this._documentsAndEditors.getDocument(d);if(h)return h}}getDocument(d){const h=this.getDocumentData(d);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return h.document}ensureDocumentData(d){const h=this._documentsAndEditors.getDocument(d);if(h)return Promise.resolve(h);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(l=>{this._documentLoader.delete(d.toString());const g=A.URI.revive(l);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(g))},l=>(this._documentLoader.delete(d.toString()),Promise.reject(l))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(h=>A.URI.revive(h))}$acceptModelModeChanged(d,h){const r=A.URI.revive(d),l=this._documentsAndEditors.getDocument(r);if(!l)throw new Error("unknown document");this._onDidRemoveDocument.fire(l.document),l._acceptLanguageId(h),this._onDidAddDocument.fire(l.document)}$acceptModelSaved(d){const h=A.URI.revive(d),r=this._documentsAndEditors.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,h){const r=A.URI.revive(d),l=this._documentsAndEditors.getDocument(r);if(!l)throw new Error("unknown document");l._acceptIsDirty(h),this._onDidChangeDocument.fire({document:l.document,contentChanges:[]})}$acceptModelChanged(d,h,r){const l=A.URI.revive(d),g=this._documentsAndEditors.getDocument(l);if(!g)throw new Error("unknown document");g._acceptIsDirty(r),g.onEvents(h),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:g.document,contentChanges:h.changes.map(m=>({range:C.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(d,h){(0,y.setWordDefinitionFor)(d,h)}}e.ExtHostDocuments=n}),define(be[39],_e([0,1,42,3,6,2,4,5,95,14,97,9,18,22,19,43,108]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(c,p){this._extHostRpc=c,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const p=[],t=[],i=[];if(c.removedDocuments)for(const o of c.removedDocuments){const a=T.URI.revive(o),s=this._documents.get(a);(s==null?void 0:s.unref())&&(this._documents.delete(a),p.push(s.value))}if(c.addedDocuments)for(const o of c.addedDocuments){const a=T.URI.revive(o.uri);let s=this._documents.get(a);if(s&&a.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);s||(s=new m(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),a,o.lines,o.EOL,o.versionId,o.modeId,o.isDirty,o.notebook)),this._documents.set(a,s),t.push(s.value)),s.ref()}if(c.removedEditors)for(const o of c.removedEditors){const a=this._editors.get(o);this._editors.delete(o),a&&i.push(a)}if(c.addedEditors)for(const o of c.addedEditors){const a=T.URI.revive(o.documentUri);b.ok(this._documents.has(a),`document '${a}' does not exist`),b.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const s=this._documents.get(a).value,u=new n.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>s.document),o.selections.map(P.Selection.to),o.options,o.visibleRanges.map(w=>P.Range.to(w)),typeof o.editorPosition=="number"?P.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,u)}c.newActiveEditor!==void 0&&(b.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,A.dispose)(p),(0,A.dispose)(i),c.removedDocuments&&this._onDidRemoveDocuments.fire(p),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var p;return(p=this._documents.get(c))===null||p===void 0?void 0:p.value}allDocuments(){return l.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const p=this._editors.get(this._activeEditorId);return c?p:p==null?void 0:p.value}}allEditors(){return[...this._editors.values()]}};S=Ve([qe(0,k.IExtHostRpcService),qe(1,d.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[197],_e([0,1,2,5,6,7,9,118,8,23]),function(Q,e,b,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const r=this._schemes.indexOf(h);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),r=[];let l,g,m=14,S=14;for(const f of h){let c=l?(0,D.commonPrefixLength)(l,f):0;for(c===0?g=1:g=S;c<f.length;c++)c+1===f.length?(m=S,S=9):S+=1,r.push([g,f.toUpperCase().charCodeAt(c),S]),r.push([g,f.toLowerCase().charCodeAt(c),S]),g=S;l=f,S=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new C.StateMachine(r)}}provideDocumentLinks(h){this._initStateMachine();const r=[],l=C.LinkComputer.computeLinks({getLineContent(g){return h.lineAt(g-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const g of l){const m=y.DocumentLink.to(g);m.target&&r.push(m)}return r}}class P{constructor(h,r){this._extHostLanguageFeatures=r,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,r,l,g={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(m,l);let S=2;g.isCaseSensitive&&(S+=1024),g.isReadonly&&(S+=2048),typeof l.copy=="function"&&(S+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(S+=4),this._proxy.$registerFileSystemProvider(m,r,S).catch(c=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${r}`),console.error(c)});const f=l.onDidChangeFile(c=>{const p=[];for(const t of c){let{uri:i,type:o}=t;if(i.scheme===r){let a;switch(o){case T.FileChangeType.Changed:a=0;break;case T.FileChangeType.Created:a=1;break;case T.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:i,type:a})}}this._proxy.$onFileSystemChange(m,p)});return(0,A.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(h){const{type:r,ctime:l,mtime:g,size:m}=h;return{type:r,ctime:l,mtime:g,size:m}}$stat(h,r){return Promise.resolve(this._getFsProvider(h).stat(b.URI.revive(r))).then(P._asIStat)}$readdir(h,r){return Promise.resolve(this._getFsProvider(h).readDirectory(b.URI.revive(r)))}$readFile(h,r){return Promise.resolve(this._getFsProvider(h).readFile(b.URI.revive(r))).then(l=>k.VSBuffer.wrap(l))}$writeFile(h,r,l,g){return Promise.resolve(this._getFsProvider(h).writeFile(b.URI.revive(r),l.buffer,g))}$delete(h,r,l){return Promise.resolve(this._getFsProvider(h).delete(b.URI.revive(r),l))}$rename(h,r,l,g){return Promise.resolve(this._getFsProvider(h).rename(b.URI.revive(r),b.URI.revive(l),g))}$copy(h,r,l,g){const m=this._getFsProvider(h);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(b.URI.revive(r),b.URI.revive(l),g))}$mkdir(h,r){return Promise.resolve(this._getFsProvider(h).createDirectory(b.URI.revive(r)))}$watch(h,r,l,g){const m=this._getFsProvider(h).watch(b.URI.revive(l),g);this._watches.set(r,m)}$unwatch(h,r){const l=this._watches.get(r);l&&(l.dispose(),this._watches.delete(r))}$open(h,r,l){const g=this._getFsProvider(h);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(b.URI.revive(r),l))}$close(h,r){const l=this._getFsProvider(h);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(r))}$read(h,r,l,g){const m=this._getFsProvider(h);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const S=k.VSBuffer.alloc(g);return Promise.resolve(m.read(r,l,S.buffer,0,g)).then(f=>S.slice(0,f))}$write(h,r,l,g){const m=this._getFsProvider(h);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,l,g.buffer,0,g.byteLength))}_getFsProvider(h){const r=this._fsProvider.get(h);if(!r){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return r}}e.ExtHostFileSystem=P}),define(be[77],_e([0,1,5,64,7,23,4,14,49]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Mt{constructor(P,d){const h=P.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return h.$stat(r).catch(Mt._handleError)},readDirectory(r){return h.$readdir(r).catch(Mt._handleError)},createDirectory(r){return h.$mkdir(r).catch(Mt._handleError)},async readFile(r){return h.$readFile(r).then(l=>l.buffer).catch(Mt._handleError)},writeFile(r,l){return h.$writeFile(r,T.VSBuffer.wrap(l)).catch(Mt._handleError)},delete(r,l){return h.$delete(r,Object.assign({recursive:!1,useTrash:!1},l)).catch(Mt._handleError)},rename(r,l,g){return h.$rename(r,l,Object.assign({overwrite:!1},g)).catch(Mt._handleError)},copy(r,l,g){return h.$copy(r,l,Object.assign({overwrite:!1},g)).catch(Mt._handleError)},isWritableFileSystem(r){const l=d.getCapabilities(r);if(typeof l=="number")return!(l&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new A.FileSystemError(String(P));if(P.name==="ENOPRO")throw A.FileSystemError.Unavailable(P.message);switch(P.name){case I.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(P.message);case I.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(P.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(P.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(P.message);case I.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(P.message);case I.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(P.message);default:throw new A.FileSystemError(P.message,P.name)}}};k=Ve([qe(0,C.IExtHostRpcService),qe(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(be[198],_e([0,1,6,5]),function(Q,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=A}),define(be[199],_e([0,1,2,24,9,7,11,5,8,32,15,10,115,6,87,54,68,55,12]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(x,q){this._documents=x,this._provider=q}provideDocumentSymbols(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ne,q)).then(le=>{if(!(0,n.isFalsyOrEmpty)(le))return le[0]instanceof T.DocumentSymbol?le.map(A.DocumentSymbol.from):f._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(x){var q;x=x.slice(0).sort((me,Se)=>{let Oe=me.location.range.start.compareTo(Se.location.range.start);return Oe===0&&(Oe=Se.location.range.end.compareTo(me.location.range.end)),Oe});const ne=[],le=[];for(const me of x){const Se={name:me.name||"!!MISSING: name!!",kind:A.SymbolKind.from(me.kind),tags:((q=me.tags)===null||q===void 0?void 0:q.map(A.SymbolTag.from))||[],detail:"",containerName:me.containerName,range:A.Range.from(me.location.range),selectionRange:A.Range.from(me.location.range),children:[]};for(;;){if(le.length===0){le.push(Se),ne.push(Se);break}const Oe=le[le.length-1];if(k.Range.containsRange(Oe.range,Se.range)&&!k.Range.equalsRange(Oe.range,Se.range)){Oe.children&&Oe.children.push(Se),le.push(Se);break}le.pop()}}return ne}}class c{constructor(x,q,ne){this._documents=x,this._commands=q,this._provider=ne,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,q){const ne=this._documents.getDocument(x),le=await this._provider.provideCodeLenses(ne,q);if(!(!le||q.isCancellationRequested)){const me=this._cache.add(le),Se=new h.DisposableStore;this._disposables.set(me,Se);const Oe={cacheId:me,lenses:[]};for(let ge=0;ge<le.length;ge++)Oe.lenses.push({cacheId:[me,ge],range:A.Range.from(le[ge].range),command:this._commands.toInternal(le[ge].command,Se)});return Oe}}async resolveCodeLens(x,q){var ne;const le=x.cacheId&&this._cache.get(...x.cacheId);if(!!le){let me;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?me=le:me=await this._provider.resolveCodeLens(le,q),me||(me=le),!q.isCancellationRequested){const Se=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!Se)return x.command=this._commands.toInternal((ne=me.command)!==null&&ne!==void 0?ne:c._badCmd,Se),x}}}releaseCodeLenses(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(We){return Array.isArray(We)?We.map(A.DefinitionLink.from):We?[A.DefinitionLink.from(We)]:[]}class t{constructor(x,q){this._documents=x,this._provider=q}provideDefinition(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDefinition(le,me,ne)).then(p)}}class i{constructor(x,q){this._documents=x,this._provider=q}provideDeclaration(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDeclaration(le,me,ne)).then(p)}}class o{constructor(x,q){this._documents=x,this._provider=q}provideImplementation(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideImplementation(le,me,ne)).then(p)}}class a{constructor(x,q){this._documents=x,this._provider=q}provideTypeDefinition(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(le,me,ne)).then(p)}}class s{constructor(x,q){this._documents=x,this._provider=q}provideHover(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideHover(le,me,ne)).then(Se=>{if(!(!Se||(0,n.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=le.getWordRangeAtPosition(me)),Se.range||(Se.range=new T.Range(me,me)),A.Hover.from(Se)})}}class u{constructor(x,q){this._documents=x,this._provider=q}provideEvaluatableExpression(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(le,me,ne)).then(Se=>{if(Se)return A.EvaluatableExpression.from(Se)})}}class w{constructor(x,q){this._documents=x,this._provider=q}provideInlineValues(x,q,ne,le){const me=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideInlineValues(me,A.Range.to(q),A.InlineValueContext.to(ne),le)).then(Se=>{if(Array.isArray(Se))return Se.map(Oe=>A.InlineValue.from(Oe))})}}class _{constructor(x,q){this._documents=x,this._provider=q}provideDocumentHighlights(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(le,me,ne)).then(Se=>{if(Array.isArray(Se))return Se.map(A.DocumentHighlight.from)})}}class v{constructor(x,q){this._documents=x,this._provider=q}provideLinkedEditingRanges(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,me,ne)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,n.coalesce)(Se.ranges.map(A.Range.from)),wordPattern:Se.wordPattern}})}}class E{constructor(x,q){this._documents=x,this._provider=q}provideReferences(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideReferences(me,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.location.from)})}}class F{constructor(x,q,ne,le,me,Se,Oe){this._documents=x,this._commands=q,this._diagnostics=ne,this._provider=le,this._logService=me,this._extension=Se,this._apiDeprecation=Oe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(x,q,ne,le){const me=this._documents.getDocument(x),Se=d.Selection.isISelection(q)?A.Selection.to(q):A.Range.to(q),Oe=[];for(const Ce of this._diagnostics.getDiagnostics(x))if(Se.intersection(Ce.range)&&Oe.push(Ce)>F._maxCodeActionsPerFile)break;const ge={diagnostics:Oe,only:ne.only?new T.CodeActionKind(ne.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ne.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(me,Se,ge,le)).then(Ce=>{var Pe;if(!(!(0,n.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const $e=this._cache.add(Ce),Ee=new h.DisposableStore;this._disposables.set($e,Ee);const je=[];for(let H=0;H<Ce.length;H++){const te=Ce[H];!te||(F._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,Ee)})):(ge.only&&(te.kind?ge.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[$e,H],title:te.title,command:te.command&&this._commands.toInternal(te.command,Ee),diagnostics:te.diagnostics&&te.diagnostics.map(A.Diagnostic.from),edit:te.edit&&A.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:(Pe=te.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:$e,actions:je}}})}async resolveCodeAction(x,q){var ne;const[le,me]=x,Se=this._cache.get(le,me);if(!(!Se||F._isCommand(Se))&&!!this._provider.resolveCodeAction){const Oe=(ne=await this._provider.resolveCodeAction(Se,q))!==null&&ne!==void 0?ne:Se;return(Oe==null?void 0:Oe.edit)?A.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}F._maxCodeActionsPerFile=1e3;class B{constructor(x,q){this._documents=x,this._provider=q}provideDocumentFormattingEdits(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,q,ne)).then(me=>{if(Array.isArray(me))return me.map(A.TextEdit.from)})}}class Y{constructor(x,q){this._documents=x,this._provider=q}provideDocumentRangeFormattingEdits(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Range.to(q);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(me,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.TextEdit.from)})}}class fe{constructor(x,q){this._documents=x,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(x,q,ne,le,me){const Se=this._documents.getDocument(x),Oe=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Oe,ne,le,me)).then(ge=>{if(Array.isArray(ge))return ge.map(A.TextEdit.from)})}}class V{constructor(x,q){this._provider=x,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(x,q){const ne=C.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(x,q)).then(le=>{if((0,n.isNonEmptyArray)(le)){for(const me of le)if(!!me){if(!me.name){this._logService.warn("INVALID SymbolInformation, lacks name",me);continue}const Se=C.IdObject.mixin(A.WorkspaceSymbol.from(me));this._symbolCache.set(Se._id,me),ne.symbols.push(Se)}}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(x,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const ne=this._symbolCache.get(x._id);if(ne){const le=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ne,q));return le&&(0,I.mixin)(x,A.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(x){const q=this._resultCache.get(x);if(q){for(let[ne,le]=q;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(x)}}}class z{constructor(x,q,ne){this._documents=x,this._provider=q,this._logService=ne}static supportsResolving(x){return typeof x.prepareRename=="function"}provideRenameEdits(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(me,Se,ne,le)).then(Oe=>{if(!!Oe)return A.WorkspaceEdit.from(Oe)},Oe=>{const ge=z._asMessage(Oe);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(x,q,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(x),me=A.Position.to(q);return(0,y.asPromise)(()=>this._provider.prepareRename(le,me,ne)).then(Se=>{let Oe,ge;if(T.Range.isRange(Se)?(Oe=Se,ge=le.getText(Se)):(0,P.isObject)(Se)&&(Oe=Se.range,ge=Se.placeholder),!!Oe){if(Oe.start.line>me.line||Oe.end.line<me.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Oe),text:ge}}},Se=>{const Oe=z._asMessage(Se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class ee{constructor(x,q){this.resultId=x,this.tokens=q}}class ${constructor(x,q){this._documents=x,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(x,q,ne){const le=this._documents.getDocument(x),me=q!==0?this._previousResults.get(q):null;return(0,y.asPromise)(()=>me&&typeof me.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,me.resultId,ne):this._provider.provideDocumentSemanticTokens(le,ne)).then(Se=>(me&&this._previousResults.delete(q),Se?(Se=$._fixProvidedSemanticTokens(Se),this._send($._convertToEdits(me,Se),Se)):null))}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return $._isSemanticTokens(x)?$._isCorrectSemanticTokens(x)?x:new T.SemanticTokens(new Uint32Array(x.data),x.resultId):$._isSemanticTokensEdits(x)?$._isCorrectSemanticTokensEdits(x)?x:new T.SemanticTokensEdits(x.edits.map(q=>new T.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const q of x.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,q){if(!$._isSemanticTokens(q)||!x||!x.tokens)return q;const ne=x.tokens,le=ne.length,me=q.data,Se=me.length;let Oe=0;const ge=Math.min(le,Se);for(;Oe<ge&&ne[Oe]===me[Oe];)Oe++;if(Oe===le&&Oe===Se)return new T.SemanticTokensEdits([],q.resultId);let Ce=0;const Pe=ge-Oe;for(;Ce<Pe&&ne[le-Ce-1]===me[Se-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Ce,data:me.subarray(Oe,Se-Ce)}],q.resultId)}_send(x,q){if($._isSemanticTokens(x)){const ne=this._nextResultId++;return this._previousResults.set(ne,new ee(x.resultId,x.data)),(0,r.encodeSemanticTokensDto)({id:ne,type:"full",data:x.data})}if($._isSemanticTokensEdits(x)){const ne=this._nextResultId++;return $._isSemanticTokens(q)?this._previousResults.set(ne,new ee(q.resultId,q.data)):this._previousResults.set(ne,new ee(x.resultId)),(0,r.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(x.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class R{constructor(x,q){this._documents=x,this._provider=q}provideDocumentRangeSemanticTokens(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,A.Range.to(q),ne)).then(me=>me?this._send(me):null)}_send(x){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=R;class L{constructor(x,q,ne,le,me){this._documents=x,this._commands=q,this._provider=ne,this._apiDeprecation=le,this._extension=me,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q),Oe=me.getWordRangeAtPosition(Se)||new T.Range(Se,Se),ge=Oe.with({end:Se}),Ce=new m.StopWatch(!0),Pe=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(me,Se,le,A.CompletionContext.to(ne)));if(!!Pe&&!le.isCancellationRequested){const $e=Array.isArray(Pe)?new T.CompletionList(Pe):Pe,Ee=L.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),je=new h.DisposableStore;this._disposables.set(Ee,je);const H=[],te={x:Ee,b:H,a:{replace:A.Range.from(Oe),insert:A.Range.from(ge)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<$e.items.length;ve++){const Le=$e.items[ve],He=this._convertCompletionItem(Le,[Ee,ve],ge,Oe);H.push(He)}return te}}async resolveCompletionItem(x,q){if(typeof this._provider.resolveCompletionItem=="function"){const ne=this._cache.get(...x);if(!!ne){const le=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ne,q));if(!!le)return this._convertCompletionItem(le,x)}}}releaseCompletionItems(x){var q;(q=this._disposables.get(x))===null||q===void 0||q.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,q,ne,le){var me;const Se=this._disposables.get(q[0]);if(!Se)throw Error("DisposableStore is missing...");const Oe={x:q,a:(me=x.label)!==null&&me!==void 0?me:"",o:x.label2,b:x.kind!==void 0?A.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(A.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(x.command,Se)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=x.textEdit.newText):typeof x.insertText=="string"?Oe.h=x.insertText:x.insertText instanceof T.SnippetString&&(Oe.h=x.insertText.value,Oe.i|=4);let ge;return x.textEdit?ge=x.textEdit.range:x.range&&(ge=x.range),T.Range.isRange(ge)?Oe.j=A.Range.from(ge):ge&&(!(ne==null?void 0:ne.isEqual(ge.inserting))||!(le==null?void 0:le.isEqual(ge.replacing)))&&(Oe.j={insert:A.Range.from(ge.inserting),replace:A.Range.from(ge.replacing)}),Oe}}class M{constructor(x,q){this._documents=x,this._provider=q,this._cache=new g.Cache("SignatureHelp")}provideSignatureHelp(x,q,ne,le){const me=this._documents.getDocument(x),Se=A.Position.to(q),Oe=this.reviveContext(ne);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(me,Se,le,Oe)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},A.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(x){let q;if(x.activeSignatureHelp){const ne=A.SignatureHelp.to(x.activeSignatureHelp),le=this._cache.get(x.activeSignatureHelp.id,0);le?(q=le,q.activeSignature=ne.activeSignature,q.activeParameter=ne.activeParameter):q=ne}return Object.assign(Object.assign({},x),{activeSignatureHelp:q})}releaseSignatureHelp(x){this._cache.delete(x)}}class U{constructor(x,q){this._documents=x,this._provider=q}provideInlineHints(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideInlineHints(le,A.Range.to(q),ne)).then(me=>me?{hints:me.map(A.InlineHint.from)}:void 0)}}class G{constructor(x,q){this._documents=x,this._provider=q,this._cache=new g.Cache("DocumentLink")}provideLinks(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ne,q)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(A.DocumentLink.from)};{const me=this._cache.add(le),Se={links:[],id:me};for(let Oe=0;Oe<le.length;Oe++){const ge=A.DocumentLink.from(le[Oe]);ge.cacheId=[me,Oe],Se.links.push(ge)}return Se}}})}resolveLink(x,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...x);return ne?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ne,q)).then(le=>le&&A.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(x){this._cache.delete(x)}}class X{constructor(x,q){this._documents=x,this._provider=q}provideColors(x,q){const ne=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ne,q)).then(le=>Array.isArray(le)?le.map(Se=>({color:A.Color.from(Se.color),range:A.Range.from(Se.range)})):[])}provideColorPresentations(x,q,ne){const le=this._documents.getDocument(x),me=A.Range.to(q.range),Se=A.Color.to(q.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:le,range:me},ne)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(A.ColorPresentation.from)})}}class se{constructor(x,q){this._documents=x,this._provider=q}provideFoldingRanges(x,q,ne){const le=this._documents.getDocument(x);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(le,q,ne)).then(me=>{if(!!Array.isArray(me))return me.map(A.FoldingRange.from)})}}class pe{constructor(x,q,ne){this._documents=x,this._provider=q,this._logService=ne}provideSelectionRanges(x,q,ne){const le=this._documents.getDocument(x),me=q.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(le,me,ne)).then(Se=>{if(!(0,n.isNonEmptyArray)(Se))return[];if(Se.length!==me.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let ge=0;ge<me.length;ge++){const Ce=[];Oe.push(Ce);let Pe=me[ge],$e=Se[ge];for(;;){if(!$e.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from($e)),!$e.parent)break;Pe=$e.range,$e=$e.parent}}return Oe})}}class Te{constructor(x,q){this._documents=x,this._provider=q,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(x,q,ne){const le=this._documents.getDocument(x),me=A.Position.to(q),Se=await this._provider.prepareCallHierarchy(le,me,ne);if(!!Se){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Oe,ge)):[this._cacheAndConvertItem(Oe,Se)]}}async provideCallsTo(x,q,ne){const le=this._itemFromCache(x,q);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!me)return me.map(Se=>({from:this._cacheAndConvertItem(x,Se.from),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}async provideCallsFrom(x,q,ne){const le=this._itemFromCache(x,q);if(!le)throw new Error("missing call hierarchy item");const me=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!me)return me.map(Se=>({to:this._cacheAndConvertItem(x,Se.to),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,q){var ne;const le=this._cache.get(x),me={_sessionId:x,_itemId:le.size.toString(36),name:q.name,detail:q.detail,kind:A.SymbolKind.from(q.kind),uri:q.uri,range:A.Range.from(q.range),selectionRange:A.Range.from(q.selectionRange),tags:(ne=q.tags)===null||ne===void 0?void 0:ne.map(A.SymbolTag.from)};return le.set(me._itemId,q),me}_itemFromCache(x,q){const ne=this._cache.get(x);return ne==null?void 0:ne.get(q)}}class xe{constructor(x,q){this.adapter=x,this.extension=q}}class Ae{constructor(x,q,ne,le,me,Se,Oe){this._adapter=new Map,this._uriTransformer=q,this._proxy=x.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=me,this._logService=Se,this._apiDeprecation=Oe}_transformDocumentSelector(x){return(0,n.coalesce)((0,n.asArray)(x).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:A.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new T.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return Ae._handlePool++}_withAdapter(x,q,ne,le,me=!1){const Se=this._adapter.get(x);if(!Se)return Promise.resolve(le);if(Se.adapter instanceof q){let Oe;Se.extension&&(Oe=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${q.name}'`));const ge=ne(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Pe=>{me&&Pe instanceof S.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,q){const ne=this._nextHandle();return this._adapter.set(ne,new xe(x,q)),ne}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,q,ne,le){const me=this._addNewAdapter(new f(this._documents,ne),x),Se=le&&le.label||Ae._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(me,this._transformDocumentSelector(q),Se),this._createDisposable(me)}$provideDocumentSymbols(x,q,ne){return this._withAdapter(x,f,le=>le.provideDocumentSymbols(b.URI.revive(q),ne),void 0)}registerCodeLensProvider(x,q,ne){const le=this._nextHandle(),me=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new c(this._documents,this._commands.converter,ne),x)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(q),me);let Se=this._createDisposable(le);if(me!==void 0){const Oe=ne.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(me));Se=T.Disposable.from(Se,Oe)}return Se}$provideCodeLenses(x,q,ne){return this._withAdapter(x,c,le=>le.provideCodeLenses(b.URI.revive(q),ne),void 0)}$resolveCodeLens(x,q,ne){return this._withAdapter(x,c,le=>le.resolveCodeLens(q,ne),void 0)}$releaseCodeLenses(x,q){this._withAdapter(x,c,ne=>Promise.resolve(ne.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(x,q,ne){const le=this._addNewAdapter(new t(this._documents,ne),x);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDefinition(x,q,ne,le){return this._withAdapter(x,t,me=>me.provideDefinition(b.URI.revive(q),ne,le),[])}registerDeclarationProvider(x,q,ne){const le=this._addNewAdapter(new i(this._documents,ne),x);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDeclaration(x,q,ne,le){return this._withAdapter(x,i,me=>me.provideDeclaration(b.URI.revive(q),ne,le),[])}registerImplementationProvider(x,q,ne){const le=this._addNewAdapter(new o(this._documents,ne),x);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideImplementation(x,q,ne,le){return this._withAdapter(x,o,me=>me.provideImplementation(b.URI.revive(q),ne,le),[])}registerTypeDefinitionProvider(x,q,ne){const le=this._addNewAdapter(new a(this._documents,ne),x);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideTypeDefinition(x,q,ne,le){return this._withAdapter(x,a,me=>me.provideTypeDefinition(b.URI.revive(q),ne,le),[])}registerHoverProvider(x,q,ne,le){const me=this._addNewAdapter(new s(this._documents,ne),x);return this._proxy.$registerHoverProvider(me,this._transformDocumentSelector(q)),this._createDisposable(me)}$provideHover(x,q,ne,le){return this._withAdapter(x,s,me=>me.provideHover(b.URI.revive(q),ne,le),void 0)}registerEvaluatableExpressionProvider(x,q,ne,le){const me=this._addNewAdapter(new u(this._documents,ne),x);return this._proxy.$registerEvaluatableExpressionProvider(me,this._transformDocumentSelector(q)),this._createDisposable(me)}$provideEvaluatableExpression(x,q,ne,le){return this._withAdapter(x,u,me=>me.provideEvaluatableExpression(b.URI.revive(q),ne,le),void 0)}registerInlineValuesProvider(x,q,ne,le){const me=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new w(this._documents,ne),x);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(q),me);let Oe=this._createDisposable(Se);if(me!==void 0){const ge=ne.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(me));Oe=T.Disposable.from(Oe,ge)}return Oe}$provideInlineValues(x,q,ne,le,me){return this._withAdapter(x,w,Se=>Se.provideInlineValues(b.URI.revive(q),ne,le,me),void 0)}registerDocumentHighlightProvider(x,q,ne){const le=this._addNewAdapter(new _(this._documents,ne),x);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentHighlights(x,q,ne,le){return this._withAdapter(x,_,me=>me.provideDocumentHighlights(b.URI.revive(q),ne,le),void 0)}registerLinkedEditingRangeProvider(x,q,ne){const le=this._addNewAdapter(new v(this._documents,ne),x);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideLinkedEditingRanges(x,q,ne,le){return this._withAdapter(x,v,async me=>{const Se=await me.provideLinkedEditingRanges(b.URI.revive(q),ne,le);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Ae._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(x,q,ne){const le=this._addNewAdapter(new E(this._documents,ne),x);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideReferences(x,q,ne,le,me){return this._withAdapter(x,E,Se=>Se.provideReferences(b.URI.revive(q),ne,le,me),void 0)}registerCodeActionProvider(x,q,ne,le){var me,Se;const Oe=new h.DisposableStore,ge=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(q),{providedKinds:(me=le==null?void 0:le.providedCodeActionKinds)===null||me===void 0?void 0:me.map(Ce=>Ce.value),documentation:(Se=le==null?void 0:le.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Oe)}))},Ae._extLabel(x),Boolean(ne.resolveCodeAction)),Oe.add(this._createDisposable(ge)),Oe}$provideCodeActions(x,q,ne,le,me){return this._withAdapter(x,F,Se=>Se.provideCodeActions(b.URI.revive(q),ne,le,me),void 0)}$resolveCodeAction(x,q,ne){return this._withAdapter(x,F,le=>le.resolveCodeAction(q,ne),void 0)}$releaseCodeActions(x,q){this._withAdapter(x,F,ne=>Promise.resolve(ne.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(x,q,ne){const le=this._addNewAdapter(new B(this._documents,ne),x);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentFormattingEdits(x,q,ne,le){return this._withAdapter(x,B,me=>me.provideDocumentFormattingEdits(b.URI.revive(q),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(x,q,ne){const le=this._addNewAdapter(new Y(this._documents,ne),x);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(x,q,ne,le,me){return this._withAdapter(x,Y,Se=>Se.provideDocumentRangeFormattingEdits(b.URI.revive(q),ne,le,me),void 0)}registerOnTypeFormattingEditProvider(x,q,ne,le){const me=this._addNewAdapter(new fe(this._documents,ne),x);return this._proxy.$registerOnTypeFormattingSupport(me,this._transformDocumentSelector(q),le,x.identifier),this._createDisposable(me)}$provideOnTypeFormattingEdits(x,q,ne,le,me,Se){return this._withAdapter(x,fe,Oe=>Oe.provideOnTypeFormattingEdits(b.URI.revive(q),ne,le,me,Se),void 0)}registerWorkspaceSymbolProvider(x,q){const ne=this._addNewAdapter(new V(q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(x,q,ne){return this._withAdapter(x,V,le=>le.provideWorkspaceSymbols(q,ne),{symbols:[]})}$resolveWorkspaceSymbol(x,q,ne){return this._withAdapter(x,V,le=>le.resolveWorkspaceSymbol(q,ne),void 0)}$releaseWorkspaceSymbols(x,q){this._withAdapter(x,V,ne=>ne.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(x,q,ne){const le=this._addNewAdapter(new z(this._documents,ne,this._logService),x);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(q),z.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(x,q,ne,le,me){return this._withAdapter(x,z,Se=>Se.provideRenameEdits(b.URI.revive(q),ne,le,me),void 0)}$resolveRenameLocation(x,q,ne,le){return this._withAdapter(x,z,me=>me.resolveRenameLocation(b.URI.revive(q),ne,le),void 0)}registerDocumentSemanticTokensProvider(x,q,ne,le){const me=this._nextHandle(),Se=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(me,new xe(new $(this._documents,ne),x)),this._proxy.$registerDocumentSemanticTokensProvider(me,this._transformDocumentSelector(q),le,Se);let Oe=this._createDisposable(me);if(Se){const ge=ne.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Oe=T.Disposable.from(Oe,ge)}return Oe}$provideDocumentSemanticTokens(x,q,ne,le){return this._withAdapter(x,$,me=>me.provideDocumentSemanticTokens(b.URI.revive(q),ne,le),null,!0)}$releaseDocumentSemanticTokens(x,q){this._withAdapter(x,$,ne=>ne.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(x,q,ne,le){const me=this._addNewAdapter(new R(this._documents,ne),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(me,this._transformDocumentSelector(q),le),this._createDisposable(me)}$provideDocumentRangeSemanticTokens(x,q,ne,le){return this._withAdapter(x,R,me=>me.provideDocumentRangeSemanticTokens(b.URI.revive(q),ne,le),null,!0)}registerCompletionItemProvider(x,q,ne,le){const me=this._addNewAdapter(new L(this._documents,this._commands.converter,ne,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(me,this._transformDocumentSelector(q),le,L.supportsResolving(ne),`${x.identifier.value}(${le.join("")})`),this._createDisposable(me)}$provideCompletionItems(x,q,ne,le,me){return this._withAdapter(x,L,Se=>Se.provideCompletionItems(b.URI.revive(q),ne,le,me),void 0)}$resolveCompletionItem(x,q,ne){return this._withAdapter(x,L,le=>le.resolveCompletionItem(q,ne),void 0)}$releaseCompletionItems(x,q){this._withAdapter(x,L,ne=>ne.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(x,q,ne,le){const me=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,Se=this._addNewAdapter(new M(this._documents,ne),x);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(q),me),this._createDisposable(Se)}$provideSignatureHelp(x,q,ne,le,me){return this._withAdapter(x,M,Se=>Se.provideSignatureHelp(b.URI.revive(q),ne,le,me),void 0)}$releaseSignatureHelp(x,q){this._withAdapter(x,M,ne=>ne.releaseSignatureHelp(q),void 0)}registerInlineHintsProvider(x,q,ne){const le=typeof ne.onDidChangeInlineHints=="function"?this._nextHandle():void 0,me=this._addNewAdapter(new U(this._documents,ne),x);this._proxy.$registerInlineHintsProvider(me,this._transformDocumentSelector(q),le);let Se=this._createDisposable(me);if(le!==void 0){const Oe=ne.onDidChangeInlineHints(ge=>this._proxy.$emitInlineHintsEvent(le));Se=T.Disposable.from(Se,Oe)}return Se}$provideInlineHints(x,q,ne,le){return this._withAdapter(x,U,me=>me.provideInlineHints(b.URI.revive(q),ne,le),void 0)}registerDocumentLinkProvider(x,q,ne){const le=this._addNewAdapter(new G(this._documents,ne),x);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(q),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(x,q,ne){return this._withAdapter(x,G,le=>le.provideLinks(b.URI.revive(q),ne),void 0)}$resolveDocumentLink(x,q,ne){return this._withAdapter(x,G,le=>le.resolveLink(q,ne),void 0)}$releaseDocumentLinks(x,q){this._withAdapter(x,G,ne=>ne.releaseLinks(q),void 0)}registerColorProvider(x,q,ne){const le=this._addNewAdapter(new X(this._documents,ne),x);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentColors(x,q,ne){return this._withAdapter(x,X,le=>le.provideColors(b.URI.revive(q),ne),[])}$provideColorPresentations(x,q,ne,le){return this._withAdapter(x,X,me=>me.provideColorPresentations(b.URI.revive(q),ne,le),void 0)}registerFoldingRangeProvider(x,q,ne){const le=this._nextHandle(),me=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new se(this._documents,ne),x)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(q),me);let Se=this._createDisposable(le);if(me!==void 0){const Oe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(me));Se=T.Disposable.from(Se,Oe)}return Se}$provideFoldingRanges(x,q,ne,le){return this._withAdapter(x,se,me=>me.provideFoldingRanges(b.URI.revive(q),ne,le),void 0)}registerSelectionRangeProvider(x,q,ne){const le=this._addNewAdapter(new pe(this._documents,ne,this._logService),x);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideSelectionRanges(x,q,ne,le){return this._withAdapter(x,pe,me=>me.provideSelectionRanges(b.URI.revive(q),ne,le),[])}registerCallHierarchyProvider(x,q,ne){const le=this._addNewAdapter(new Te(this._documents,ne),x);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$prepareCallHierarchy(x,q,ne,le){return this._withAdapter(x,Te,me=>Promise.resolve(me.prepareSession(b.URI.revive(q),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(x,q,ne,le){return this._withAdapter(x,Te,me=>me.provideCallsTo(q,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(x,q,ne,le){return this._withAdapter(x,Te,me=>me.provideCallsFrom(q,ne,le),void 0)}$releaseCallHierarchy(x,q){this._withAdapter(x,Te,ne=>Promise.resolve(ne.releaseSession(q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,D.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:Ae._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:Ae._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?Ae._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?Ae._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:Ae._serializeRegExp(x.beforeText),afterText:x.afterText?Ae._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?Ae._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(Ae._serializeOnEnterRule)}setLanguageConfiguration(x,q,ne){let{wordPattern:le}=ne;if(le&&(0,D.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(q,le):this._documents.setWordDefinitionFor(q,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const me=this._nextHandle(),Se={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ae._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ae._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ae._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(me,q,Se),this._createDisposable(me)}$setWordDefinitions(x){for(const q of x)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Ae,Ae._handlePool=0}),define(be[200],_e([0,1,5,9,7]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(C,D){this._proxy=C.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,D){var k;const n=C.version,P=I.Position.from(D),d=await this._proxy.$tokensAtPosition(C.uri,P),h={type:A.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new A.Range(D.line,D.character,D.line,D.character)};if(!d)return h;const r={range:I.Range.to(d.range),type:I.TokenType.to(d.type)};return!r.range.contains(D)||n!==C.version?h:r}}e.ExtHostLanguages=T}),define(be[201],_e([0,1,5,18,33]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(C){return C&&C.title}let y=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,k,n,P,d){const h={extension:D};let r;typeof P=="string"||T(P)?r=[P,...d]:(h.modal=P&&P.modal,h.useCustom=P&&P.useCustom,r=d),h.useCustom&&(0,A.checkProposedApiEnabled)(D);const l=[];for(let g=0;g<r.length;g++){const m=r[g];if(typeof m=="string")l.push({title:m,handle:g,isCloseAffordance:!1});else if(typeof m=="object"){let{title:S,isCloseAffordance:f}=m;l.push({title:S,isCloseAffordance:!!f,handle:g})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,n,h,l).then(g=>{if(typeof g=="number")return r[g]})}};y=Ve([qe(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(be[202],_e([0,1,11,23,20,3,56,54,6,22,8,10,2,68,5,9,7,73,179,180]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class c{constructor(s,u){const w=c._Keys.nextId();s.$registerNotebookEditorDecorationType(w,l.NotebookDecorationRenderOptions.from(u)),this.value={key:w,dispose(){s.$removeNotebookEditorDecorationType(w)}}}}e.NotebookEditorDecorationType=c,c._Keys=new C.IdGenerator("NotebookEditorDecorationType");class p{constructor(s,u,w,_,v,E){this._textDocumentsAndEditors=w,this._textDocuments=_,this.logService=v,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new k.ResourceMap,this._statusBarCache=new h.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(r.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(r.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(r.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:F=>{var B;if(F&&F.$mid===12){const Y=(B=F.notebookEditor)===null||B===void 0?void 0:B.notebookUri,fe=F.cell.handle,V=this._documents.get(Y),z=V==null?void 0:V.getCell(fe);if(z)return z.apiCell}return F}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[u,w]of this._editors)if(w.apiEditor===s)return u}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const u=this._documents.get(s);if(!u)throw new Error(`NO notebook document for '${s}'`);return u}_getProviderData(s){const u=this._notebookContentProviders.get(s);if(!u)throw new Error(`NO provider for '${s}'`);return u}registerNotebookContentProvider(s,u,w,_){var v,E,F;if((0,n.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:s,provider:w});let B;w.onDidChangeNotebookContentOptions&&(B=w.onDidChangeNotebookContentOptions(()=>{const V=l.NotebookDocumentContentOptions.from(w.options);this._notebookProxy.$updateNotebookProviderOptions(u,V)}));const Y=(v=_==null?void 0:_.viewOptions)===null||v===void 0?void 0:v.filenamePattern.map(V=>l.NotebookExclusiveDocumentPattern.from(V)).filter(V=>V!==void 0);((E=_==null?void 0:_.viewOptions)===null||E===void 0?void 0:E.filenamePattern)&&!Y&&console.warn(`Notebook content provider view options file name pattern is invalid ${(F=_==null?void 0:_.viewOptions)===null||F===void 0?void 0:F.filenamePattern}`);const fe=l.NotebookDocumentContentOptions.from(_);return this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation,description:s.description},u,{transientOutputs:fe.transientOutputs,transientCellMetadata:fe.transientCellMetadata,transientDocumentMetadata:fe.transientDocumentMetadata,viewOptions:(_==null?void 0:_.viewOptions)&&Y?{displayName:_.viewOptions.displayName,filenamePattern:Y,exclusive:_.viewOptions.exclusive||!1}:void 0}),new g.Disposable(()=>{B==null||B.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}registerNotebookCellStatusBarItemProvider(s,u,w){const _=p._notebookStatusBarItemProviderHandlePool++,v=typeof w.onDidChangeCellStatusBarItems=="function"?p._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(_,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(_,v,u);let E;return v!==void 0&&(E=w.onDidChangeCellStatusBarItems(F=>this._notebookProxy.$emitCellStatusBarEvent(v))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(_),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(_,v),E&&E.dispose()})}createNotebookEditorDecorationType(s){return new c(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const u=this._documents.get(s);if(u)return u.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenDocument(s),_=this._documents.get(d.URI.revive(w));return(0,P.assertIsDefined)(_==null?void 0:_.apiNotebook)}async showNotebookDocument(s,u){var w;d.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let _;typeof u=="object"?_={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(l.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:_={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,_),E=v&&((w=this._editors.get(v))===null||w===void 0?void 0:w.apiEditor);if(E)return E;throw v?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,u,w,_){var v;const E=this._notebookStatusBarItemProviders.get(s),F=d.URI.revive(u),B=this._documents.get(F);if(!(!B||!E)){const Y=B.getCellFromIndex(w);if(!!Y){const fe=await E.provideCellStatusBarItems(Y.apiCell,_);if(!!fe){const V=new D.DisposableStore,z=this._statusBarCache.add([V]),ee=(v=fe&&fe.map($=>l.NotebookStatusBarItem.from($,this._commandsConverter,V)))!==null&&v!==void 0?v:void 0;return{cacheId:z,items:ee}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,u,w,_){if((0,n.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const v=this._handlePool++;this._notebookSerializer.set(v,w);const E=l.NotebookDocumentContentOptions.from(_);return this._notebookProxy.$registerNotebookSerializer(v,{id:s.identifier,location:s.extensionLocation,description:s.description},u,E),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(v)})}async $dataToNotebook(s,u,w){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const v=await _.deserializeNotebook(u.buffer,w);return{metadata:l.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(l.NotebookCellData.from)}}async $notebookToData(s,u,w){const _=this._notebookSerializer.get(s);if(!_)throw new Error("NO serializer found");const v=await _.serializeNotebook({metadata:l.NotebookDocumentMetadata.to(u.metadata),cells:u.cells.map(l.NotebookCellData.to)},w);return I.VSBuffer.wrap(v)}cancelOneNotebookCellExecution(s){const u=this._activeExecutions.get(s.uri);u==null||u.cancel()}async $openNotebook(s,u,w,_,v){const{provider:E}=this._getProviderData(s),F=await E.openNotebook(d.URI.revive(u),{backupId:w,untitledDocumentData:_==null?void 0:_.buffer},v);return{metadata:l.NotebookDocumentMetadata.from(F.metadata),cells:F.cells.map(l.NotebookCellData.from)}}async $saveNotebook(s,u,w){const _=this._getNotebookDocument(d.URI.revive(u)),{provider:v}=this._getProviderData(s);return await v.saveNotebook(_.apiNotebook,w),!0}async $saveNotebookAs(s,u,w,_){const v=this._getNotebookDocument(d.URI.revive(u)),{provider:E}=this._getProviderData(s);return await E.saveNotebookAs(d.URI.revive(w),v.apiNotebook,_),!0}async $backupNotebook(s,u,w){var _;const v=this._getNotebookDocument(d.URI.revive(u)),E=this._getProviderData(s),F=(_=this._extensionStoragePaths.workspaceValue(E.extension))!==null&&_!==void 0?_:this._extensionStoragePaths.globalValue(E.extension),B=String((0,y.hash)([v.uri.toString(),this._backupIdPool++])),Y=d.URI.joinPath(F,B),fe=await E.provider.backupNotebook(v.apiNotebook,{destination:Y},w);return v.updateBackup(fe),fe.id}$acceptModelChanged(s,u,w){this._getNotebookDocument(d.URI.revive(s)).acceptModelChanged(u,w)}$acceptDirtyStateChanged(s,u){const w=this._getNotebookDocument(d.URI.revive(s));w.acceptModelChanged({rawEvents:[],versionId:w.apiNotebook.version},u)}$acceptModelSaved(s){const u=this._getNotebookDocument(d.URI.revive(s));this._onDidSaveNotebookDocument.fire(u.apiNotebook)}$acceptEditorPropertiesChanged(s,u){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,u);const w=this._editors.get(s);if(!w)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);u.visibleRanges&&w._acceptVisibleRanges(u.visibleRanges.ranges.map(l.NotebookRange.to)),u.selections&&w._acceptSelections(u.selections.selections.map(l.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:w.apiEditor,visibleRanges:w.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:w.apiEditor,selections:w.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const u in s){const w=this._editors.get(u);if(!w)throw new Error(`unknown text editor: ${u}. known editors: ${[...this._editors.keys()]} `);w._acceptViewColumn(l.ViewColumn.to(s[u]))}}$acceptDocumentPropertiesChanged(s,u){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,u);const w=this._getNotebookDocument(d.URI.revive(s));w.acceptDocumentPropertiesChanged(u),u.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:w.apiNotebook})}_createExtHostEditor(s,u,w){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const _=new f.ExtHostNotebookEditor(u,this._notebookEditorsProxy,s,w.visibleRanges.map(l.NotebookRange.to),w.selections.map(l.NotebookRange.to),typeof w.viewColumn=="number"?l.ViewColumn.to(w.viewColumn):void 0);this._editors.set(u,_)}$acceptDocumentAndEditorsDelta(s){var u,w,_;if(s.removedDocuments)for(const E of s.removedDocuments){const F=d.URI.revive(E),B=this._documents.get(F);B&&(B.dispose(),this._documents.delete(F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:B.apiNotebook.getCells().map(Y=>Y.document.uri)}),this._onDidCloseNotebookDocument.fire(B.apiNotebook));for(const Y of this._editors.values())Y.notebookData.uri.toString()===F.toString()&&this._editors.delete(Y.id)}if(s.addedDocuments){const E=[];for(const F of s.addedDocuments){const B=d.URI.revive(F.uri),Y=F.viewType;if(this._documents.has(B))throw new Error(`adding EXISTING notebook ${B} `);const fe=this,V=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(z){fe._onDidChangeNotebookCells.fire(z)},emitCellOutputsChange(z){fe._onDidChangeCellOutputs.fire(z)},emitCellMetadataChange(z){fe._onDidChangeCellMetadata.fire(z)},emitCellExecutionStateChange(z){fe._onDidChangeCellExecutionState.fire(z)}},Y,F.metadata?l.NotebookDocumentMetadata.to(F.metadata):new g.NotebookDocumentMetadata,B);V.acceptModelChanged({versionId:F.versionId,rawEvents:[{kind:m.NotebookCellsChangeType.Initialize,changes:[[0,0,F.cells]]}]},!1),E.push(...F.cells.map(z=>S.ExtHostCell.asModelAddData(V.apiNotebook,z))),(u=this._documents.get(B))===null||u===void 0||u.dispose(),this._documents.set(B,V),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this._onDidOpenNotebookDocument.fire(V.apiNotebook)}}if(s.addedEditors)for(const E of s.addedEditors){if(this._editors.has(E.id))return;const F=d.URI.revive(E.documentUri),B=this._documents.get(F);B&&this._createExtHostEditor(B,E.id,E)}const v=[];if(s.removedEditors)for(const E of s.removedEditors){const F=this._editors.get(E);F&&(this._editors.delete(E),((w=this._activeNotebookEditor)===null||w===void 0?void 0:w.id)===F.id&&(this._activeNotebookEditor=void 0),v.push(F))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(F=>this._editors.get(F)).filter(F=>!!F);const E=new Set;this._visibleNotebookEditors.forEach(F=>E.add(F.id));for(const F of this._editors.values()){const B=E.has(F.id);F._acceptVisibility(B)}this._visibleNotebookEditors=[...this._editors.values()].map(F=>F).filter(F=>F.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((_=this._activeNotebookEditor)===null||_===void 0?void 0:_.apiEditor)}createNotebookCellExecution(s,u,w){const _=this.lookupNotebookDocument(s);if(!_)throw new Error(`Invalid uri: ${s} `);const v=_.getCellFromIndex(u);if(!v)throw new Error(`Invalid cell index: ${s}, ${u} `);if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const E=new i(s,_,v,this._notebookDocumentsProxy);this._activeExecutions.set(v.uri,E);const F=E.onDidChangeState(()=>{E.state===t.Resolved&&(E.dispose(),F.dispose(),this._activeExecutions.delete(v.uri))});return E.asApiObject()}}e.ExtHostNotebookController=p,p._notebookStatusBarItemProviderHandlePool=0;var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class i extends D.Disposable{constructor(s,u,w,_){super();this._uri=s,this._document=u,this._cell=w,this._proxy=_,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new A.CancellationTokenSource),this._collector=new o(10,v=>this.applyEdits(v)),this._executionOrder=w.internalMetadata.executionOrder,this.mixinMetadata({runState:g.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const u={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([u])}cellIndexToHandle(s){const u=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!u)return u.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(u){s._executionOrder=u,s.mixinMetadata({executionOrder:u})},start(u){var w;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:g.NotebookCellExecutionState.Executing,runStartTime:(w=u==null?void 0:u.startTime)!==null&&w!==void 0?w:null})},end(u){var w,_;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:g.NotebookCellExecutionState.Idle,lastRunSuccess:(w=u==null?void 0:u.success)!==null&&w!==void 0?w:null,runEndTime:(_=u==null?void 0:u.endTime)!==null&&_!==void 0?_:null})},clearOutput(u){return s.verifyStateForOutput(),this.replaceOutput([],u)},async appendOutput(u,w){s.verifyStateForOutput();const _=s.cellIndexToHandle(w);if(typeof _=="number")return u=Array.isArray(u)?u:[u],s.applyEditSoon({editType:2,handle:_,append:!0,outputs:u.map(l.NotebookCellOutput.from)})},async replaceOutput(u,w){s.verifyStateForOutput();const _=s.cellIndexToHandle(w);if(typeof _=="number")return u=Array.isArray(u)?u:[u],s.applyEditSoon({editType:2,handle:_,outputs:u.map(l.NotebookCellOutput.from)})},async appendOutputItems(u,w){return s.verifyStateForOutput(),u=Array.isArray(u)?u:[u],s.applyEditSoon({editType:7,append:!0,items:u.map(l.NotebookCellOutputItem.from),outputId:w})},async replaceOutputItems(u,w){return s.verifyStateForOutput(),u=Array.isArray(u)?u:[u],s.applyEditSoon({editType:7,items:u.map(l.NotebookCellOutputItem.from),outputId:w})},token:s._tokenSource.token})}}class o{constructor(s,u){this.delay=s,this.callback=u,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,b.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const u=this.batch;return this.batch=[],this.callback(u)})),this.waitPromise}}}),define(be[203],_e([0,1,3,6,5,2,9,72]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class D{constructor(n,P,d){this._initData=P,this._extHostNotebook=d,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(n,P,d,h,r,l){for(let _ of this._kernelData.values())if(_.controller.id===P)throw new Error(`notebook controller with id '${P}' ALREADY exist`);const g=this._handlePool++,m=this,S=()=>console.warn(`NO execute handler from notebook controller '${i.id}' of extension: '${n.identifier}'`);let f=!1;const c=new I.DisposableStore,p=new b.Emitter,t=new b.Emitter,i={id:P,viewType:d,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:h||n.identifier.value,preloads:l?l.map(y.NotebookKernelPreload.from):[]};let o=r!=null?r:S,a;this._proxy.$addKernel(g,i).catch(_=>{console.log(_),f=!0});let s=0;const u=()=>{if(!f){const _=++s;Promise.resolve().then(()=>{_===s&&this._proxy.$updateKernel(g,i)})}},w={get id(){return i.id},get viewType(){return i.viewType},onDidChangeNotebookAssociation:p.event,get label(){return i.label},set label(_){var v;i.label=(v=_!=null?_:n.displayName)!==null&&v!==void 0?v:n.name,u()},get detail(){var _;return(_=i.detail)!==null&&_!==void 0?_:""},set detail(_){i.detail=_,u()},get description(){var _;return(_=i.description)!==null&&_!==void 0?_:""},set description(_){i.description=_,u()},get supportedLanguages(){return i.supportedLanguages},set supportedLanguages(_){i.supportedLanguages=_,u()},get hasExecutionOrder(){var _;return(_=i.hasExecutionOrder)!==null&&_!==void 0?_:!1},set hasExecutionOrder(_){i.hasExecutionOrder=_,u()},get preloads(){return i.preloads?i.preloads.map(y.NotebookKernelPreload.to):[]},get executeHandler(){return o},set executeHandler(_){o=_!=null?_:S},get interruptHandler(){return a},set interruptHandler(_){a=_,i.supportsInterrupt=Boolean(_),u()},createNotebookCellExecutionTask(_){if(f)throw new Error("notebook controller is DISPOSED");return m._extHostNotebook.createNotebookCellExecution(_.notebook.uri,_.index,i.id)},dispose:()=>{f||(f=!0,this._kernelData.delete(g),c.dispose(),p.dispose(),t.dispose(),this._proxy.$removeKernel(g))},onDidReceiveMessage:t.event,postMessage(_,v){return m._proxy.$postMessage(g,v&&m._extHostNotebook.getIdByEditor(v),_)},asWebviewUri(_){return(0,C.asWebviewUri)(m._initData.environment,String(g),_)},updateNotebookAffinity(_,v){m._proxy.$updateNotebookPriority(g,_.uri,v)}};return this._kernelData.set(g,{extensionId:n.identifier,controller:w,onDidChangeSelection:p,onDidReceiveMessage:t}),w}$acceptSelection(n,P,d){const h=this._kernelData.get(n);h&&h.onDidChangeSelection.fire({selected:d,notebook:this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P)).apiNotebook})}async $executeCells(n,P,d){const h=this._kernelData.get(n);if(!!h){const r=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P));if(!r)throw new Error("MISSING notebook");const l=[];for(let g of d){const m=r.getCell(g);m&&l.push(m.apiCell)}try{await h.controller.executeHandler.call(h.controller,l,r.apiNotebook,h.controller)}catch(g){console.error(g)}}}async $cancelCells(n,P,d){const h=this._kernelData.get(n);if(!!h){const r=this._extHostNotebook.lookupNotebookDocument(T.URI.revive(P));if(!r)throw new Error("MISSING notebook");h.controller.interruptHandler&&await h.controller.interruptHandler.call(h.controller,r.apiNotebook);for(let l of d){const g=r.getCell(l);g&&this._extHostNotebook.cancelOneNotebookCellExecution(g)}}}$acceptRendererMessage(n,P,d){const h=this._kernelData.get(n);if(!!h){const r=this._extHostNotebook.getEditorById(P);if(!r)throw new Error(`send message for UNKNOWN editor: ${P}`);h.onDidReceiveMessage.fire(Object.freeze({editor:r.apiEditor,message:d}))}}}e.ExtHostNotebookKernels=D}),define(be[100],_e([0,1,5,3,6,23,4,14]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends A.Disposable{constructor(r,l,g,m){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,l,g),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(l=>this._proxy.$clear(l,r))}show(r,l){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof r=="boolean"?r:l)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(r,l){super(r,!1,void 0,l)}append(r){super.append(r),this._id.then(l=>this._proxy.$append(l,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class n extends D{constructor(r,l,g){super(r,!0,l,g)}append(r){throw new Error("Not supported")}}class P{constructor(r,l){this.name=r,this._channel=l}append(r){this._channel.then(l=>l.append(r))}appendLine(r){this._channel.then(l=>l.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,l){this._channel.then(g=>g.show(r,l))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=P;let d=class{constructor(r){this._proxy=r.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,l){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new n(r,l,this._proxy)}};d=Ve([qe(0,C.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(be[204],_e([0,1,11,20,3,6,5,2,7,12,15,47]),function(Q,e,b,I,A,T,y,C,D,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(h,r,l){const g=h.getProxy(y.MainContext.MainThreadQuickOpen);class m{constructor(a,s){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=s}showQuickPick(a,s,u,w=I.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(a),v=++this._instances,E=g.$show(v,{title:u==null?void 0:u.title,placeHolder:u==null?void 0:u.placeHolder,matchOnDescription:u==null?void 0:u.matchOnDescription,matchOnDetail:u==null?void 0:u.matchOnDetail,ignoreFocusLost:u==null?void 0:u.ignoreFocusOut,canPickMany:u==null?void 0:u.canPickMany},w),F={},B=E.then(()=>F);return Promise.race([B,_]).then(Y=>{if(Y!==F)return _.then(fe=>{const V=[];for(let z=0;z<fe.length;z++){const ee=fe[z];let $,R,L,M,U;typeof ee=="string"?$=ee:($=ee.label,R=ee.description,L=ee.detail,M=ee.picked,U=ee.alwaysShow),V.push({label:$,description:R,handle:z,detail:L,picked:M,alwaysShow:U})}return u&&typeof u.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{u.onDidSelectItem(fe[z])}),g.$setItems(v,V),E.then(z=>{if(typeof z=="number")return fe[z];if(Array.isArray(z))return z.map(ee=>fe[ee])})})}).then(void 0,Y=>{if(!(0,k.isPromiseCanceledError)(Y))return g.$setError(v,Y),Promise.reject(Y)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,s=I.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,g.$input(a,typeof this._validateInput=="function",s).then(void 0,u=>{if(!(0,k.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(a){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,s=I.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!!u){const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(_=>_.uri.toString()===u.uri.toString())}}createQuickPick(a,s){const u=new t(a,s,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}createInputBox(a){const s=new i(a,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(a,s){const u=this._sessions.get(a);u&&u._fireDidChangeValue(s)}$onDidAccept(a){const s=this._sessions.get(a);s&&s._fireDidAccept()}$onDidChangeActive(a,s){const u=this._sessions.get(a);u instanceof t&&u._fireDidChangeActive(s)}$onDidChangeSelection(a,s){const u=this._sessions.get(a);u instanceof t&&u._fireDidChangeSelection(s)}$onDidTriggerButton(a,s){const u=this._sessions.get(a);u&&u._fireDidTriggerButton(s)}$onDidHide(a){const s=this._sessions.get(a);s&&s._fireDidHide()}}class S{constructor(a,s){this._extensionId=a,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((s,u)=>{const w=s===D.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(w,s)}),this.update({buttons:a.map((s,u)=>({iconPath:f(s.iconPath),tooltip:s.tooltip,handle:s===D.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const s=this._handlesToButtons.get(a);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(a){if(!this._disposed){for(const s of Object.keys(a)){const u=a[s];this._pendingUpdate[s]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function f(o){if(o instanceof D.ThemeIcon)return{id:o.id};const a=p(o),s=c(o);return{dark:typeof a=="string"?C.URI.file(a):a,light:typeof s=="string"?C.URI.file(s):s}}function c(o){return typeof o=="object"&&"light"in o?o.light:o}function p(o){return typeof o=="object"&&"dark"in o?o.dark:o}class t extends S{constructor(a,s,u){super(a,u);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((s,u)=>{this._handlesToItems.set(u,s),this._itemsToHandles.set(s,u)}),this.update({items:a.map((s,u)=>({label:s.label,description:s.description,handle:u,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(a){const s=(0,n.coalesce)(a.map(u=>this._handlesToItems.get(u)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(a){const s=(0,n.coalesce)(a.map(u=>this._handlesToItems.get(u)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class i extends S{constructor(a,s){super(a,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?P.default.Error:P.default.Ignore})}}return new m(r,l)}e.createExtHostQuickOpen=d}),define(be[205],_e([0,1,2,3,52,6,11,5,15,112,18,26,33]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(a){if(a)return typeof a.iconPath=="string"?b.URI.file(a.iconPath):a.iconPath}function r(a,s){if(!a.iconPath&&!s.iconPath)return 0;if(a.iconPath){if(!s.iconPath)return 1}else return-1;const u=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,w=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,k.comparePaths)(u,w)}function l(a,s){let u=0;if(a.strikeThrough!==s.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==s.faded)return a.faded?1:-1;if(a.tooltip!==s.tooltip)return(a.tooltip||"").localeCompare(s.tooltip||"");if(u=r(a,s),u!==0)return u;if(a.light&&s.light)u=r(a.light,s.light);else{if(a.light)return 1;if(s.light)return-1}if(u!==0)return u;if(a.dark&&s.dark)u=r(a.dark,s.dark);else{if(a.dark)return 1;if(s.dark)return-1}return u}function g(a,s){if(a.command!==s.command)return a.command<s.command?-1:1;if(a.title!==s.title)return a.title<s.title?-1:1;if(a.tooltip!==s.tooltip){if(a.tooltip!==void 0&&s.tooltip!==void 0)return a.tooltip<s.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(a.arguments===s.arguments)return 0;if(a.arguments)if(s.arguments){if(a.arguments.length!==s.arguments.length)return a.arguments.length-s.arguments.length}else return 1;else return-1;for(let u=0;u<a.arguments.length;u++){const w=a.arguments[u],_=s.arguments[u];if(w!==_)return w<_?-1:1}return 0}function m(a,s){let u=(0,k.comparePaths)(a.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(u!==0)return u;if(a.command&&s.command)u=g(a.command,s.command);else{if(a.command)return 1;if(s.command)return-1}if(u!==0)return u;if(a.decorations&&s.decorations)u=l(a.decorations,s.decorations);else{if(a.decorations)return 1;if(s.decorations)return-1}return u}function S(a,s){for(let u=0;u<a.length;u++)if(a[u]!==s[u])return!1;return!0}function f(a,s){return a.command===s.command&&a.title===s.title&&a.tooltip===s.tooltip&&(a.arguments&&s.arguments?S(a.arguments,s.arguments):a.arguments===s.arguments)}function c(a,s){return(0,D.equals)(a,s,f)}class p{constructor(s,u,w){this._extension=s,this._proxy=u,this._sourceControlHandle=w,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,d.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,u){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,u)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=p;class t{constructor(s,u,w,_,v){this._proxy=s,this._commands=u,this._sourceControlHandle=w,this._id=_,this._label=v,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,u){const w=this._resourceStatesCommandsMap.get(s);return w?(0,y.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],u)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const u=[...this._resourceStates].sort(m),_=(0,D.sortedDiff)(this._resourceSnapshot,u,m).map(F=>{const B=F.toInsert.map(Y=>{const fe=this._resourceHandlePool++;this._resourceStatesMap.set(fe,Y);const V=Y.resourceUri,z=h(Y.decorations),ee=Y.decorations&&h(Y.decorations.light)||z,$=Y.decorations&&h(Y.decorations.dark)||z,R=[];let L;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"){const pe=new T.DisposableStore;L=this._commands.converter.toInternal(Y.command,pe),this._resourceStatesDisposablesMap.set(fe,pe)}else this._resourceStatesCommandsMap.set(fe,Y.command);ee&&R.push(ee),$&&$.toString()!==(ee==null?void 0:ee.toString())&&R.push($);const M=Y.decorations&&Y.decorations.tooltip||"",U=Y.decorations&&!!Y.decorations.strikeThrough,G=Y.decorations&&!!Y.decorations.faded,X=Y.contextValue||"";return{rawResource:[fe,V,R,M,U,G,X,L],handle:fe}});return{start:F.start,deleteCount:F.deleteCount,toInsert:B}}),v=_.map(({start:F,deleteCount:B,toInsert:Y})=>[F,B,Y.map(fe=>fe.rawResource)]),E=_.reverse();for(const{start:F,deleteCount:B,toInsert:Y}of E){const fe=Y.map(z=>z.handle),V=this._handlesSnapshot.splice(F,B,...fe);for(const z of V)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),(s=this._resourceStatesDisposablesMap.get(z))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=u,v}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(s,u,w,_,v,E){this._proxy=u,this._commands=w,this._id=_,this._label=v,this._rootUri=E,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new p(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,v,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const u=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:u})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&c(this._statusBarCommands,s))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const u=(s||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:u})}}get selected(){return this._selected}createResourceGroup(s,u){const w=new t(this._proxy,this._commands,this.handle,s,u),_=I.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,_),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const s=[],u=[];for(const[w,_]of this.createdResourceGroups){_.dispose();const v=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});I.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),v.dispose(),this._groups.delete(w.handle),this._proxy.$unregisterGroup(this.handle,w.handle)}),s.push([w.handle,w.id,w.label,w.features]);const E=w._takeResourceStateSnapshot();E.length>0&&u.push([w.handle,E]),this._groups.set(w.handle,w)}this._proxy.$registerGroups(this.handle,s,u),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(u=>{const w=u._takeResourceStateSnapshot();w.length!==0&&s.push([u.handle,w])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ve([(0,A.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ve([(0,A.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let o=class Tn{constructor(s,u,w){this._commands=u,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=s.getProxy(C.MainContext.MainThreadSCM),this._telemetry=s.getProxy(C.MainContext.MainThreadTelemetry),u.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const v=this._sourceControls.get(_.sourceControlHandle);if(!v)return _;const E=v.getResourceGroup(_.groupHandle);return E?E.getResourceState(_.handle):_}else if(_&&_.$mid===4){const v=this._sourceControls.get(_.sourceControlHandle);return v?v.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const v=this._sourceControls.get(_.handle);return v||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,u,w,_){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,u,w,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const v=Tn._handlePool++,E=new i(s,this._proxy,this._commands,u,w,_);this._sourceControls.set(v,E);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(s.identifier))||[];return F.push(E),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(s.identifier),F),E}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const u=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(s.identifier)),w=u&&u[u.length-1];return w&&w.inputBox}$provideOriginalResource(s,u,w){const _=b.URI.revive(u);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,_.toString());const v=this._sourceControls.get(s);return!v||!v.quickDiffProvider||!v.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>v.quickDiffProvider.provideOriginalResource(_,w)).then(E=>E||null)}$onInputBoxValueChange(s,u){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const w=this._sourceControls.get(s);return w&&w.inputBox.$onInputBoxValueChange(u),Promise.resolve(void 0)}$executeResourceCommand(s,u,w,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,u,w);const v=this._sourceControls.get(s);if(!v)return Promise.resolve(void 0);const E=v.getResourceGroup(u);return E?E.$executeResourceCommand(w,_):Promise.resolve(void 0)}$validateInput(s,u,w){this.logService.trace("ExtHostSCM#$validateInput",s);const _=this._sourceControls.get(s);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>_.inputBox.validateInput(u,w)).then(v=>v?Promise.resolve([v.message,v.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var u,w;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((u=this._sourceControls.get(s))===null||u===void 0||u.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((w=this._sourceControls.get(this._selectedSourceControlHandle))===null||w===void 0||w.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};o._handlePool=0,o=Ve([qe(2,n.ILogService)],o),e.ExtHostSCM=o});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[206],_e([0,1,7,5,135,6]),function(Q,e,b,I,A,T){"use strict";var y,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(d,h,r,l,g=b.StatusBarAlignment.Left,m,S){y.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,y,d,"f"),tt(this,C,h,"f"),this._id=D.ID_GEN++,this._statusId=r,this._statusName=l,this._alignment=g,this._priority=m,this._accessibilityInformation=S}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!D.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Me(this,C,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Me(this,C,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let h=this._color;this._backgroundColor&&(h=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,h,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const h={message:d};return this._messages.unshift(h),this._update(),new b.Disposable(()=>{const r=this._messages.indexOf(h);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(d,h){this._proxy=d.getProxy(I.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new k(this)}createStatusBarEntry(d,h,r,l,g){return new D(this._proxy,this._commands,d,h,r,l,g)}setStatusBarMessage(d,h){const r=this._statusMessage.setMessage(d);let l;return typeof h=="number"?l=setTimeout(()=>r.dispose(),h):typeof h!="undefined"&&h.then(()=>r.dispose(),()=>r.dispose()),new b.Disposable(()=>{r.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=n}),define(be[78],_e([0,1,5,3,4]),function(Q,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(C){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,k){return this._proxy.$getValue(C,D).then(n=>n||k)}setValue(C,D,k){return this._proxy.$setValue(C,D,k)}$acceptValue(C,D,k){this._onDidChangeStorage.fire({shared:C,key:D,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(be[79],_e([0,1,4,27,18,77,2]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,n,P){var d;this._logService=n,this._extHostFileSystem=P,this._workspace=(d=k.workspace)!==null&&d!==void 0?d:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,P=y.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=y.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),P}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(k){if(this._value)return y.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return y.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=Ve([qe(0,I.IExtHostInitDataService),qe(1,A.ILogService),qe(2,T.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(be[40],_e([0,1,3,5,4,2,14,6,7,136,12,173,20,31,156]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class l{constructor(t,i,o,a){this._proxy=t,this._id=i,this._creationOptions=o,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(u=>this._pidPromiseComplete=u);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(u,w=!0){s._checkDisposed(),s._proxy.$sendText(s._id,u,w)},show(u){s._checkDisposed(),s._proxy.$show(s._id,u)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,i,o,a,s,u,w,_,v,E,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:o,env:a,icon:s,initialText:u,waitOnExit:w,strictEnv:_,hideFromUser:v,isFeatureTerminal:E,isExtensionOwnedTerminal:F})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=l;class g{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let m=1,S=class extends C.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=i.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[o,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new l(this._proxy,(0,h.generateUuid)(),t,t.name),o=new g(t.pty);return i.createExtensionTerminal().then(a=>{const s=this._setupExtHostProcessListeners(a,o);this._terminalProcessDisposables[a]=s}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new g(i),s=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(t);o&&(this._activeTerminal=o,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const o=this._getTerminalById(t);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:i})}async $acceptTerminalDimensions(t,i,o){const a=this._getTerminalById(t);a&&a.setDimensions(i,o)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,o){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,o)}async $acceptTerminalTitleChange(t,i){const o=this._getTerminalById(t);o&&(o.name=i)}async $acceptTerminalClosed(t,i){const o=this._getTerminalObjectIndexById(this._terminals,t);if(o!==null){const a=this._terminals.splice(o,1)[0];a.setExitCode(i),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,i,o,a){if(i){const w=this._getTerminalObjectIndexById(this._terminals,i);if(w!==null){this._terminals[w]._id=t,this._onDidOpenTerminal.fire(this.terminals[w]),this._terminals[w].isOpen=!0;return}}const s={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:T.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},u=new l(this._proxy,t,s,o);this._terminals.push(u),this._onDidOpenTerminal.fire(u.value),u.isOpen=!0}async $acceptTerminalProcessId(t,i){const o=this._getTerminalById(t);o&&o._setProcessId(i)}async $startExtensionTerminal(t,i){const o=this._getTerminalById(t);if(!o)return{message:(0,k.localize)(0,null,t)};o.isOpen||await new Promise(s=>{const u=this.onDidOpenTerminal(async w=>{w===o.value&&(u.dispose(),s())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const o=new C.DisposableStore;o.add(i.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),o.add(i.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,i.onProcessData),o.add(i.onProcessExit(s=>this._onProcessExit(t,s))),i.onProcessOverrideDimensions&&o.add(i.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,i);const a=this._extensionTerminalAwaitingStart[t];return a&&i instanceof g&&(i.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),o}$acceptProcessAckDataEvent(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.input(i)}$acceptProcessResize(t,i,o){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(i,o)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,i){var o;(o=this._terminalProcesses.get(t))===null||o===void 0||o.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(t,o))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(o=>this._proxy.$sendProcessCwd(t,o))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const o=this._getTerminalById(t);if(!o)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const s=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const u=[],w={terminal:o.value,line:i},_=[];for(const F of this._linkProviders)_.push(new Promise(async B=>{s.token.onCancellationRequested(()=>B({provider:F,links:[]}));const Y=await F.provideTerminalLinks(w,s.token)||[];s.token.isCancellationRequested||B({provider:F,links:Y})}));const v=await Promise.all(_);if(s.token.isCancellationRequested)return[];const E=new Map;for(const F of v)F&&F.links.length>0&&u.push(...F.links.map(B=>{const Y={id:m++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return E.set(Y.id,{provider:F.provider,link:B}),Y}));return this._terminalLinkCache.set(t,E),u}$activateLink(t,i){var o;const a=(o=this._terminalLinkCache.get(t))===null||o===void 0?void 0:o.get(i);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const o=this._terminalProcessDisposables[t];o&&(o.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const o=this._getTerminalObjectIndexById(t,i);return o!==null?t[o]:null}_getTerminalObjectIndexById(t,i){let o=null;return t.some((a,s)=>a._id===i?(o=s,!0):!1),o}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new f,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const o=(0,P.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const o=i[0],a=new f(i[1]);this._setEnvironmentVariableCollection(o,a)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};S=Ve([qe(1,y.IExtHostRpcService)],S),e.BaseExtHostTerminalService=S;class f{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:D.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const o=this.map.get(t);(!o||o.value!==i.value||o.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((o,a)=>t.call(i,a,o,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let c=class extends S{constructor(t){super(!1,t)}createTerminal(t,i,o){throw new n.NotSupportedError}createTerminalFromOptions(t){throw new n.NotSupportedError}getDefaultShell(t,i){throw new n.NotSupportedError}getDefaultShellArgs(t,i){throw new n.NotSupportedError}$getAvailableProfiles(t){throw new n.NotSupportedError}async $getDefaultShellAndArgs(t){throw new n.NotSupportedError}};c=Ve([qe(0,y.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(be[207],_e([0,1,3,15,5,97,9,7]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(n,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const P=this._extHostDocumentsAndEditors.allEditors();return n?P:P.map(d=>d.value)}async showTextDocument(n,P,d){let h;typeof P=="number"?h={position:y.ViewColumn.from(P),preserveFocus:d}:typeof P=="object"?h={position:y.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?y.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:h={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(n.uri,h),l=r&&this._extHostDocumentsAndEditors.getEditor(r);if(l)return l.value;throw r?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n){return new T.TextEditorDecorationType(this._proxy,n).value}$acceptEditorPropertiesChanged(n,P){const d=this._extHostDocumentsAndEditors.getEditor(n);if(!d)throw new Error("unknown text editor");if(P.options&&d._acceptOptions(P.options),P.selections){const h=P.selections.selections.map(y.Selection.to);d._acceptSelections(h)}if(P.visibleRanges){const h=I.coalesce(P.visibleRanges.map(y.Range.to));d._acceptVisibleRanges(h)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const h=C.TextEditorSelectionChangeKind.fromValue(P.selections.source),r=P.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:h})}if(P.visibleRanges){const h=I.coalesce(P.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const P in n){const d=this._extHostDocumentsAndEditors.getEditor(P);if(!d)throw new Error("Unknown text editor");const h=y.ViewColumn.to(n[P]);d.value.viewColumn!==h&&(d._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=D});var zt=this&&this.__rest||function(Q,e){var b={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(b[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(b[I[A]]=Q[I[A]]);return b};define(be[208],_e([0,1,2,4,5,6,7]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class C{constructor(n,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(A.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:d=>{var h,r;if(d&&d.$mid===11){const l=d.uri===void 0?void 0:b.URI.revive(d.uri);return(r=(h=this._itemsBySourceAndUriMap.get(d.source))===null||h===void 0?void 0:h.get(D(l)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(n,P,d,h,r){const l=this._providers.get(n);return l==null?void 0:l.provideTimeline(b.URI.revive(P),d,h,r)}registerTimelineProvider(n,P,d,h){const r=new T.DisposableStore,l=this.convertTimelineItem(P.id,h,r).bind(this);let g;P.onDidChange&&(g=P.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:P.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:n,onDidChange:void 0,async provideTimeline(S,f,c,p){var t;(p==null?void 0:p.resetCache)&&(r.clear(),(t=m.get(P.id))===null||t===void 0||t.clear());const i=await P.provideTimeline(S,f,c);if(i!=null){const o=l(S,p);return Object.assign(Object.assign({},i),{source:P.id,items:i.items.map(o)})}},dispose(){var S;for(const f of m.values())(S=f.get(P.id))===null||S===void 0||S.clear();g==null||g.dispose(),r.dispose()}}))}convertTimelineItem(n,P,d){return(h,r)=>{let l;if(r==null?void 0:r.cacheResults){let g=this._itemsBySourceAndUriMap.get(n);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(n,g));const m=D(h);l=g.get(m),l===void 0&&(l=new Map,g.set(m,l))}return g=>{var m,S;const{iconPath:f}=g,c=zt(g,["iconPath"]),p=`${n}|${(m=g.id)!==null&&m!==void 0?m:g.timestamp}`;l==null||l.set(p,g);let t,i,o;return g.iconPath&&(f instanceof y.ThemeIcon?o={id:f.id}:b.URI.isUri(f)?(t=f,i=f):{light:t,dark:i}=f),Object.assign(Object.assign({},c),{id:(S=c.id)!==null&&S!==void 0?S:void 0,handle:p,source:n,command:g.command?P.toInternal(g.command,d):void 0,icon:t,iconDark:i,themeIcon:o,accessibilityInformation:g.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,T.toDisposable)(()=>{var d;for(const h of this._itemsBySourceAndUriMap.values())(d=h.get(n.id))===null||d===void 0||d.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=C;function D(k){return k==null?void 0:k.toString()}}),define(be[209],_e([0,1,6,19,2,5]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,n,P){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const d=P.schemes.find(h=>!y.supportedSchemes.has(h));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,n),this._proxy.$registerUriOpener(k,P.schemes,D,P.label),(0,b.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,n){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const d=A.URI.revive(k);return P.canOpenExternalUri(d,n)}async $openUri(D,k,n){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(A.URI.revive(k.resolvedUri),{sourceUri:A.URI.revive(k.sourceUri)},n)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(be[210],_e([0,1,5,2,6,12,26]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(k,n){if(this.handles.has(y.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const P=C.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(k)),this.handlers.set(P,n),this._proxy.$registerUriHandler(P,k),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(k)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(k,n){const P=this.handlers.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(I.URI.revive(n))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(k){return I.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[50],_e([0,1,23,3,2,145,166,72,5]),function(Q,e,b,I,A,T,y,C,D){"use strict";var k,n,P,d,h,r,l,g,m,S,f,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.serializeMessage=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(v,E,F,B,Y,fe,V){k.set(this,void 0),n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),l.set(this,""),g.set(this,void 0),m.set(this,!1),S.set(this,!1),f.set(this,!1),this._onMessageEmitter=new I.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new I.Emitter),this._onDidDispose=Me(this,c,"f").event,tt(this,k,v,"f"),tt(this,n,E,"f"),tt(this,g,F,"f"),tt(this,d,B,"f"),tt(this,h,Y,"f"),tt(this,r,fe,"f"),tt(this,f,t(fe),"f"),tt(this,P,V,"f")}dispose(){tt(this,m,!0,"f"),Me(this,c,"f").fire(),Me(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return tt(this,S,!0,"f"),(0,C.asWebviewUri)(Me(this,d,"f"),Me(this,k,"f"),v)}get cspSource(){return Me(this,d,"f").webviewCspSource.replace("{{uuid}}",Me(this,k,"f"))}get html(){return this.assertNotDisposed(),Me(this,l,"f")}set html(v){this.assertNotDisposed(),Me(this,l,"f")!==v&&(tt(this,l,v,"f"),!Me(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(tt(this,S,!0,"f"),Me(this,P,"f").report("Webview vscode-resource: uris",Me(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,n,"f").$setHtml(Me(this,k,"f"),v))}get options(){return this.assertNotDisposed(),Me(this,g,"f")}set options(v){this.assertNotDisposed(),Me(this,n,"f").$setOptions(Me(this,k,"f"),s(Me(this,r,"f"),Me(this,h,"f"),v)),tt(this,g,v,"f")}async postMessage(v){if(Me(this,m,"f"))return!1;const E=i(v,{serializeBuffersForPostMessage:Me(this,f,"f")});return Me(this,n,"f").$postMessage(Me(this,k,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Me(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,k=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,l=new WeakMap,g=new WeakMap,m=new WeakMap,S=new WeakMap,f=new WeakMap,c=new WeakMap;function t(_){if(!_.enableProposedApi)return!1;try{const v=(0,T.normalizeVersion)((0,T.parseVersion)(_.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=56}catch(v){return!1}}e.shouldSerializeBuffersForPostMessage=t;function i(_,v){if(v.serializeBuffersForPostMessage){const E=[],F=(Y,fe)=>{if(fe&&fe instanceof ArrayBuffer){let V=E.findIndex(z=>z.original===fe);if(V===-1){const z=new Uint8Array(fe),ee=b.VSBuffer.wrap(z);V=E.length,E.push({original:fe,vsBuffer:ee})}return{$$vscode_array_buffer_reference$$:!0,index:V}}return fe};return{message:JSON.stringify(_,F),buffers:E.map(Y=>Y.vsBuffer)}}else return{message:JSON.stringify(_),buffers:[]}}e.serializeMessage=i;class o{constructor(v,E,F,B,Y){this.initData=E,this.workspace=F,this._logService=B,this._deprecationService=Y,this._webviews=new Map,this._webviewProxy=v.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(v,E,...F){const B=this.getWebview(v);if(B){const{message:Y}=(0,y.deserializeWebviewMessage)(E,F);B._onMessageEmitter.fire(Y)}}$onMissingCsp(v,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,E,F){const B=new p(v,this._webviewProxy,u(E),this.initData,this.workspace,F,this._deprecationService);return this._webviews.set(v,B),B._onDidDispose(()=>{this._webviews.delete(v)}),B}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=o;function a(_){return{id:_.identifier,location:_.extensionLocation}}e.toExtensionData=a;function s(_,v,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||w(_,v)}}e.serializeWebviewOptions=s;function u(_){var v;return{enableCommandUris:_.enableCommandUris,enableScripts:_.enableScripts,portMapping:_.portMapping,localResourceRoots:(v=_.localResourceRoots)===null||v===void 0?void 0:v.map(E=>A.URI.from(E))}}e.reviveOptions=u;function w(_,v){return[...((v==null?void 0:v.getWorkspaceFolders())||[]).map(E=>E.uri),_.extensionLocation]}}),define(be[211],_e([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,o){const a=this.key(t,i.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const s=new h(i,o);return this._documents.set(a,s),s}delete(t,i){const o=this.key(t,i.uri);this._documents.delete(o)}key(t,i){return`${t}@@@${i}`}}var l;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(l||(l={}));class g{constructor(){this._providers=new Map}addTextProvider(t,i,o){return this.add(0,t,i,o)}addCustomProvider(t,i,o){return this.add(1,t,i,o)}get(t){return this._providers.get(t)}add(t,i,o,a){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:o,provider:a}),new d.Disposable(()=>this._providers.delete(i))}}class m{constructor(t,i,o,a,s){this._extHostDocuments=i,this._extensionStoragePaths=o,this._extHostWebview=a,this._extHostWebviewPanels=s,this._editorProviders=new g,this._documents=new r,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,o,a){const s=new A.DisposableStore;return S(o)?(s.add(this._editorProviders.addTextProvider(i,t,o)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),i,a.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(i,t,o)),this.supportEditing(o)&&s.add(o.onDidChangeCustomDocument(u=>{const w=this.getCustomDocumentEntry(i,u.document.uri);if(f(u)){const _=w.addEdit(u);this._proxy.$onDidEdit(u.document.uri,i,_,u.label)}else this._proxy.$onContentChange(u.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),i,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(s,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,o,a,s){var u;const w=this._editorProviders.get(i);if(!w)throw new Error(`No provider found for '${i}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${i}'`);const _=C.URI.revive(t),v=await w.provider.openCustomDocument(_,{backupId:o,untitledDocumentData:a==null?void 0:a.buffer},s);let E;return this.supportEditing(w.provider)&&this._extensionStoragePaths&&(E=(u=this._extensionStoragePaths.workspaceValue(w.extension))!==null&&u!==void 0?u:this._extensionStoragePaths.globalValue(w.extension)),this._documents.add(i,v,E),{editable:this.supportEditing(w.provider)}}async $disposeCustomDocument(t,i){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${i}'`);const a=C.URI.revive(t),{document:s}=this.getCustomDocumentEntry(i,a);this._documents.delete(i,s),s.dispose()}async $resolveWebviewEditor(t,i,o,a,s,u){const w=this._editorProviders.get(o);if(!w)throw new Error(`No provider found for '${o}'`);const _=D.ViewColumn.to(s),v=this._extHostWebview.createNewWebview(i,a.webviewOptions,w.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(i,o,a.title,_,a.panelOptions,v),F=C.URI.revive(t);switch(w.type){case 1:{const{document:B}=this.getCustomDocumentEntry(o,F);return w.provider.resolveCustomEditor(B,E,u)}case 0:{const B=this._extHostDocuments.getDocument(F);return w.provider.resolveCustomTextEditor(B,E,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,o){this.getCustomDocumentEntry(i,t).disposeEdits(o)}async $onMoveCustomEditor(t,i,o){const a=this._editorProviders.get(o);if(!a)throw new Error(`No provider found for '${o}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const u=C.URI.revive(i),w=this._extHostDocuments.getDocument(u);await a.provider.moveCustomTextEditor(w,s,b.CancellationToken.None)}async $undo(t,i,o,a){return this.getCustomDocumentEntry(i,t).undo(o,a)}async $redo(t,i,o,a){return this.getCustomDocumentEntry(i,t).redo(o,a)}async $revert(t,i,o){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(a.document,o),a.disposeBackup()}async $onSave(t,i,o){const a=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(a.document,o),a.disposeBackup()}async $onSaveAs(t,i,o,a){const s=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(s.document,C.URI.revive(o),a)}async $backup(t,i,o){const a=this.getCustomDocumentEntry(i,t),u=await this.getCustomEditorProvider(i).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},o);return a.updateBackup(u),u.id}getCustomDocumentEntry(t,i){const o=this._documents.get(t,C.URI.revive(i));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(t){const i=this._editorProviders.get(t),o=i==null?void 0:i.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function S(p){return typeof p.resolveCustomTextEditor=="function"}function f(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function c(p){const t=p.scheme===T.Schemas.file||p.scheme===T.Schemas.untitled?p.fsPath:p.toString();return(0,I.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[212],_e([0,1,3,6,2,31,9,50,5,7]),function(Q,e,b,I,A,T,y,C,D,k){"use strict";var n,P,d,h,r,l,g,m,S,f,c,p,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends I.Disposable{constructor(u,w,_,v,E,F,B){super();n.set(this,void 0),P.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),l.set(this,void 0),g.set(this,void 0),m.set(this,void 0),S.set(this,!0),f.set(this,!0),c.set(this,!1),p.set(this,this._register(new b.Emitter)),this.onDidDispose=Me(this,p,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,n,u,"f"),tt(this,P,w,"f"),tt(this,d,_,"f"),tt(this,r,F,"f"),tt(this,m,E,"f"),tt(this,l,v,"f"),tt(this,h,B,"f")}dispose(){Me(this,c,"f")||(tt(this,c,!0,"f"),Me(this,p,"f").fire(),Me(this,P,"f").$disposeWebview(Me(this,n,"f")),Me(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,h,"f")}get viewType(){return this.assertNotDisposed(),Me(this,d,"f")}get title(){return this.assertNotDisposed(),Me(this,l,"f")}set title(u){this.assertNotDisposed(),Me(this,l,"f")!==u&&(tt(this,l,u,"f"),Me(this,P,"f").$setTitle(Me(this,n,"f"),u))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(u){this.assertNotDisposed(),Me(this,g,"f")!==u&&(tt(this,g,u,"f"),Me(this,P,"f").$setIconPath(Me(this,n,"f"),A.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Me(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,m,"f")=="number"&&Me(this,m,"f")<0))return Me(this,m,"f")}get active(){return this.assertNotDisposed(),Me(this,f,"f")}get visible(){return this.assertNotDisposed(),Me(this,S,"f")}_updateViewState(u){Me(this,c,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(tt(this,f,u.active,"f"),tt(this,S,u.visible,"f"),tt(this,m,u.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(u,w){this.assertNotDisposed(),Me(this,P,"f").$reveal(Me(this,n,"f"),{viewColumn:u?y.ViewColumn.from(u):void 0,preserveFocus:!!w})}assertNotDisposed(){if(Me(this,c,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,l=new WeakMap,g=new WeakMap,m=new WeakMap,S=new WeakMap,f=new WeakMap,c=new WeakMap,p=new WeakMap,t=new WeakMap;class o{constructor(u,w,_){this.webviews=w,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(u,w,_,v,E={}){const F=typeof v=="object"?v.viewColumn:v,B={viewColumn:y.ViewColumn.from(F),preserveFocus:typeof v=="object"&&!!v.preserveFocus},Y=(0,C.shouldSerializeBuffersForPostMessage)(u),fe=o.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(u),fe,w,{title:_,panelOptions:a(E),webviewOptions:(0,C.serializeWebviewOptions)(u,this.workspace,E),serializeBuffersForPostMessage:Y},B);const V=this.webviews.createNewWebview(fe,E,u);return this.createNewWebviewPanel(fe,w,_,F,E,V)}$onDidChangeWebviewPanelViewStates(u){const w=Object.keys(u);w.sort((_,v)=>{const E=u[_],F=u[v];return E.active?1:F.active?-1:+E.visible-+F.visible});for(const _ of w){const v=this.getWebviewPanel(_);if(!!v){const E=u[_];v._updateViewState({active:E.active,visible:E.visible,viewColumn:y.ViewColumn.to(E.position)})}}}async $onDidDisposeWebviewPanel(u){const w=this.getWebviewPanel(u);w==null||w.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,w,_){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:_,extension:u}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(u)}),new k.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(u,w,_,v){const E=this._serializers.get(w);if(!E)throw new Error(`No serializer found for '${w}'`);const{serializer:F,extension:B}=E,Y=this.webviews.createNewWebview(u,_.webviewOptions,B),fe=this.createNewWebviewPanel(u,w,_.title,v,_.panelOptions,Y);await F.deserializeWebviewPanel(fe,_.state)}createNewWebviewPanel(u,w,_,v,E,F){const B=new i(u,this._proxy,w,_,v,E,F);return this._webviewPanels.set(u,B),B}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=o;function a(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[213],_e([0,1,3,6,50,5,7]),function(Q,e,b,I,A,T,y){"use strict";var C,D,k,n,P,d,h,r,l,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends I.Disposable{constructor(c,p,t,i,o,a){super();C.set(this,void 0),D.set(this,void 0),k.set(this,void 0),n.set(this,void 0),P.set(this,!1),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),l.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=Me(this,l,"f").event,g.set(this,this._register(new b.Emitter)),this.onDidDispose=Me(this,g,"f").event,tt(this,k,t,"f"),tt(this,h,i,"f"),tt(this,C,c,"f"),tt(this,D,p,"f"),tt(this,n,o,"f"),tt(this,d,a,"f")}dispose(){Me(this,P,"f")||(tt(this,P,!0,"f"),Me(this,g,"f").fire(),Me(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,h,"f")}set title(c){this.assertNotDisposed(),Me(this,h,"f")!==c&&(tt(this,h,c,"f"),Me(this,D,"f").$setWebviewViewTitle(Me(this,C,"f"),c))}get description(){return this.assertNotDisposed(),Me(this,r,"f")}set description(c){this.assertNotDisposed(),Me(this,r,"f")!==c&&(tt(this,r,c,"f"),Me(this,D,"f").$setWebviewViewDescription(Me(this,C,"f"),c))}get visible(){return Me(this,d,"f")}get webview(){return Me(this,n,"f")}get viewType(){return Me(this,k,"f")}_setVisible(c){c===Me(this,d,"f")||Me(this,P,"f")||(tt(this,d,c,"f"),Me(this,l,"f").fire())}show(c){this.assertNotDisposed(),Me(this,D,"f").$show(Me(this,C,"f"),!!c)}assertNotDisposed(){if(Me(this,P,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,k=new WeakMap,n=new WeakMap,P=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,l=new WeakMap,g=new WeakMap;class S{constructor(c,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,p,t,i){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(c),p,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(c,p,t,i,o){const a=this._viewProviders.get(p);if(!a)throw new Error(`No view provider found for '${p}'`);const{provider:s,extension:u}=a,w=this._extHostWebview.createNewWebview(c,{},u),_=new m(c,this._proxy,p,t,w,!0);this._webviewViews.set(c,_),await s.resolveWebviewView(_,{state:i},o)}async $onDidChangeWebviewViewVisibility(c,p){this.getWebviewView(c)._setVisible(p)}async $disposeWebviewView(c){const p=this.getWebviewView(c);this._webviewViews.delete(c),p.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const p=this._webviewViews.get(c);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=S}),define(be[101],_e([0,1,3,5,2,19,8,4,14]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Rn{constructor(P){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Rn.InitialState,this._proxy=P.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,d){let h;if(typeof P=="string"){h=P;try{P=A.URI.parse(P)}catch(r){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,y.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,h,d)}async asExternalUri(P,d){if((0,y.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(P.scheme))return Promise.reject(`Invalid scheme '${P.scheme}'`);const h=await this._proxy.$asExternalUri(P,d);return A.URI.from(h)}};k.InitialState={focused:!0},k=Ve([qe(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(be[214],_e([0,1,18,5,27,14]),function(Q,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends b.AbstractLogger{constructor(D,k){super();this._proxy=D.getProxy(I.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...k){this.getLevel()<=b.LogLevel.Trace&&this._proxy.$log(this._logFile,b.LogLevel.Trace,Array.from(arguments))}debug(D,...k){this.getLevel()<=b.LogLevel.Debug&&this._proxy.$log(this._logFile,b.LogLevel.Debug,Array.from(arguments))}info(D,...k){this.getLevel()<=b.LogLevel.Info&&this._proxy.$log(this._logFile,b.LogLevel.Info,Array.from(arguments))}warn(D,...k){this.getLevel()<=b.LogLevel.Warning&&this._proxy.$log(this._logFile,b.LogLevel.Warning,Array.from(arguments))}error(D,...k){this.getLevel()<=b.LogLevel.Error&&this._proxy.$log(this._logFile,b.LogLevel.Error,Array.from(arguments))}critical(D,...k){this.getLevel()<=b.LogLevel.Critical&&this._proxy.$log(this._logFile,b.LogLevel.Critical,Array.from(arguments))}flush(){}};y=Ve([qe(0,T.IExtHostRpcService),qe(1,A.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(be[215],_e([0,1,11,20,12,3,6,113,187,98,23]),function(Q,e,b,I,A,T,y,C,D,k,n){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(a,s){try{return JSON.stringify(a,s)}catch(u){return"null"}}function h(a,s){return JSON.stringify(a,s)}function r(a){return a?(s,u)=>u&&u.$mid===1?a.transformOutgoing(u):u:null}var l;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},S=Symbol.for("rpcProtocol"),f=Symbol.for("rpcProxy");class c extends y.Disposable{constructor(s,u=null,w=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=u,this._uriTransformer=w,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let _=0,v=k.ProxyIdentifier.count;_<v;_++)this._locals[_]=null,this._proxies[_]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(_=>this._receiveOneMessage(_))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,C.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:u,sid:w}=s;return this._proxies[u]||(this._proxies[u]=this._createProxy(u,w)),this._proxies[u]}_createProxy(s,u){let w={get:(_,v)=>(typeof v=="string"&&!_[v]&&v.charCodeAt(0)===36&&(_[v]=(...E)=>this._remoteCall(s,v,E)),v===f?u:_[v])};return new Proxy(Object.create(null),w)}set(s,u){return this._locals[s.nid]=u,u}assertRegistered(s){for(let u=0,w=s.length;u<w;u++){const _=s[u];if(!this._locals[_.nid])throw new Error(`Missing actor ${_.sid} (isMain: ${_.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const u=s.byteLength,w=p.read(s,0),_=w.readUInt8(),v=w.readUInt32();switch(_){case 1:case 2:{let{rpcId:E,method:F,args:B}=t.deserializeRequestJSONArgs(w);this._uriTransformer&&(B=(0,C.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(u,v,E,F,B,_===2);break}case 3:case 4:{let{rpcId:E,method:F,args:B}=t.deserializeRequestMixedArgs(w);this._uriTransformer&&(B=(0,C.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(u,v,E,F,B,_===4);break}case 5:{this._logger&&this._logger.logIncoming(u,v,0,"ack"),this._onDidReceiveAcknowledge(v);break}case 6:{this._receiveCancel(u,v);break}case 7:{this._receiveReply(u,v,void 0);break}case 9:{let E=t.deserializeReplyOKJSON(w);this._uriTransformer&&(E=(0,C.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReply(u,v,E);break}case 8:{let E=t.deserializeReplyOKVSBuffer(w);this._receiveReply(u,v,E);break}case 10:{let E=t.deserializeReplyErrError(w);this._uriTransformer&&(E=(0,C.transformIncomingURIs)(E,this._uriTransformer)),this._receiveReplyErr(u,v,E);break}case 11:{this._receiveReplyErr(u,v,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,u,w,_,v,E){this._logger&&this._logger.logIncoming(s,u,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(w)}.${_}(`,v);const F=String(u);let B,Y;if(E){const V=new I.CancellationTokenSource;v.push(V.token),B=this._invokeHandler(w,_,v),Y=()=>V.cancel()}else B=this._invokeHandler(w,_,v),Y=m;this._cancelInvokedHandlers[F]=Y;const fe=t.serializeAcknowledged(u);this._logger&&this._logger.logOutgoing(fe.byteLength,u,1,"ack"),this._protocol.send(fe),B.then(V=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyOK(u,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,u,1,"reply:",V),this._protocol.send(z)},V=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyErr(u,V);this._logger&&this._logger.logOutgoing(z.byteLength,u,1,"replyErr:",V),this._protocol.send(z)})}_receiveCancel(s,u){this._logger&&this._logger.logIncoming(s,u,1,"receiveCancel");const w=String(u);this._cancelInvokedHandlers[w]&&this._cancelInvokedHandlers[w]()}_receiveReply(s,u,w){this._logger&&this._logger.logIncoming(s,u,0,"receiveReply:",w);const _=String(u);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const v=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_],v.resolveOk(w)}}_receiveReplyErr(s,u,w){this._logger&&this._logger.logIncoming(s,u,0,"receiveReplyErr:",w);const _=String(u);if(!!this._pendingRPCReplies.hasOwnProperty(_)){const v=this._pendingRPCReplies[_];delete this._pendingRPCReplies[_];let E;w&&(w.$isError?(E=new Error,E.name=w.name,E.message=w.message,E.stack=w.stack):E=w),v.resolveErr(E)}}_invokeHandler(s,u,w){try{return Promise.resolve(this._doInvokeHandler(s,u,w))}catch(_){return Promise.reject(_)}}_doInvokeHandler(s,u,w){const _=this._locals[s];if(!_)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(s));let v=_[u];if(typeof v!="function")throw new Error("Unknown method "+u+" on actor "+(0,k.getStringIdentifierForProxy)(s));return v.apply(_,w)}_remoteCall(s,u,w){if(this._isDisposed)return Promise.reject(A.canceled());let _=null;if(w.length>0&&I.CancellationToken.isCancellationToken(w[w.length-1])&&(_=w.pop()),_&&_.isCancellationRequested)return Promise.reject(A.canceled());const v=t.serializeRequestArguments(w,this._uriReplacer),E=++this._lastMessageId,F=String(E),B=new D.LazyPromise;_&&_.onCancellationRequested(()=>{const fe=t.serializeCancel(E);this._logger&&this._logger.logOutgoing(fe.byteLength,E,0,"cancel"),this._protocol.send(t.serializeCancel(E))}),this._pendingRPCReplies[F]=B,this._onWillSendRequest(E);const Y=t.serializeRequest(E,s,u,v,!!_);return this._logger&&this._logger.logOutgoing(Y.byteLength,E,0,`request: ${(0,k.getStringIdentifierForProxy)(s)}.${u}(`,w),this._protocol.send(Y),B}}e.RPCProtocol=c,P=S,c.UNRESPONSIVE_TIME=3*1e3;class p{constructor(s,u){this._buff=s,this._offset=u}static alloc(s,u,w){let _=new p(n.VSBuffer.alloc(w+1+4),0);return _.writeUInt8(s),_.writeUInt32(u),_}static read(s,u){return new p(s,u)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const w=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,w}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,w}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const u=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,u}static sizeMixedArray(s,u){let w=0;w+=1;for(let _=0,v=s.length;_<v;_++){const E=s[_],F=u[_];switch(w+=1,F){case 1:w+=this.sizeLongString(E);break;case 2:w+=this.sizeVSBuffer(E);break;case 3:break}}return w}writeMixedArray(s,u){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let w=0,_=s.length;w<_;w++){const v=s[w];switch(u[w]){case 1:this.writeUInt8(1),this.writeLongString(v);break;case 2:this.writeUInt8(2),this.writeVSBuffer(v);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let u=new Array(s);for(let w=0;w<s;w++)switch(this.readUInt8()){case 1:u[w]=this.readLongString();break;case 2:u[w]=this.readVSBuffer();break;case 3:u[w]=void 0;break}return u}}class t{static _arrayContainsBufferOrUndefined(s){for(let u=0,w=s.length;u<w;u++)if(s[u]instanceof n.VSBuffer||typeof s[u]=="undefined")return!0;return!1}static serializeRequestArguments(s,u){if(this._arrayContainsBufferOrUndefined(s)){let w=[],_=[];for(let v=0,E=s.length;v<E;v++){const F=s[v];F instanceof n.VSBuffer?(w[v]=F,_[v]=2):typeof F=="undefined"?(w[v]=n.VSBuffer.alloc(0),_[v]=3):(w[v]=n.VSBuffer.fromString(h(F,u)),_[v]=1)}return{type:"mixed",args:w,argsType:_}}return{type:"simple",args:h(s,u)}}static serializeRequest(s,u,w,_,v){return _.type==="mixed"?this._requestMixedArgs(s,u,w,_.args,_.argsType,v):this._requestJSONArgs(s,u,w,_.args,v)}static _requestJSONArgs(s,u,w,_,v){const E=n.VSBuffer.fromString(w),F=n.VSBuffer.fromString(_);let B=0;B+=p.sizeUInt8(),B+=p.sizeShortString(E),B+=p.sizeLongString(F);let Y=p.alloc(v?2:1,s,B);return Y.writeUInt8(u),Y.writeShortString(E),Y.writeLongString(F),Y.buffer}static deserializeRequestJSONArgs(s){const u=s.readUInt8(),w=s.readShortString(),_=s.readLongString();return{rpcId:u,method:w,args:JSON.parse(_)}}static _requestMixedArgs(s,u,w,_,v,E){const F=n.VSBuffer.fromString(w);let B=0;B+=p.sizeUInt8(),B+=p.sizeShortString(F),B+=p.sizeMixedArray(_,v);let Y=p.alloc(E?4:3,s,B);return Y.writeUInt8(u),Y.writeShortString(F),Y.writeMixedArray(_,v),Y.buffer}static deserializeRequestMixedArgs(s){const u=s.readUInt8(),w=s.readShortString(),_=s.readMixedArray(),v=new Array(_.length);for(let E=0,F=_.length;E<F;E++){const B=_[E];typeof B=="string"?v[E]=JSON.parse(B):v[E]=B}return{rpcId:u,method:w,args:v}}static serializeAcknowledged(s){return p.alloc(5,s,0).buffer}static serializeCancel(s){return p.alloc(6,s,0).buffer}static serializeReplyOK(s,u,w){return typeof u=="undefined"?this._serializeReplyOKEmpty(s):u instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(s,u):this._serializeReplyOKJSON(s,d(u,w))}static _serializeReplyOKEmpty(s){return p.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,u){let w=0;w+=p.sizeVSBuffer(u);let _=p.alloc(8,s,w);return _.writeVSBuffer(u),_.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,u){const w=n.VSBuffer.fromString(u);let _=0;_+=p.sizeLongString(w);let v=p.alloc(9,s,_);return v.writeLongString(w),v.buffer}static deserializeReplyOKJSON(s){const u=s.readLongString();return JSON.parse(u)}static serializeReplyErr(s,u){return u?this._serializeReplyErrEror(s,u):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,u){const w=n.VSBuffer.fromString(d(A.transformErrorForSerialization(u),null));let _=0;_+=p.sizeLongString(w);let v=p.alloc(10,s,_);return v.writeLongString(w),v.buffer}static deserializeReplyErrError(s){const u=s.readLongString();return JSON.parse(u)}static _serializeReplyErrEmpty(s){return p.alloc(11,s,0).buffer}}var i;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var o;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(o||(o={}))}),define(be[216],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const b=function(T){const y=C=>{self.removeEventListener("message",y);const D=C.data;Object.defineProperties(self,{postMessage:{value(k,n){D.postMessage(k,n)}},onmessage:{get(){return D.onmessage},set(k){D.onmessage=k}}}),D.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",y)}.toString();class I extends EventTarget{constructor(T,y,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${b})('${y}'))`,k=new Blob([D],{type:"application/javascript"}),n=URL.createObjectURL(k),P=new MessageChannel,d=n,h={type:"_newWorker",id:d,port:P.port2,url:n,options:C};T(h,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};P.port1.postMessage(r),URL.revokeObjectURL(n),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(r){P.port1.onmessage=r}},onmessageerror:{get(){return P.port1.onmessageerror},set(r){P.port1.onmessageerror=r}}}),P.port1.addEventListener("messageerror",r=>{const l=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(l)}),P.port1.addEventListener("message",r=>{const l=new MessageEvent("message",{data:r.data});this.dispatchEvent(l)}),P.port1.start()}}e.NestedWorker=I}),define(be[217],_e([0,1,4]),function(Q,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(be[218],_e([0,1,19,13,21,2,4,217]),function(Q,e,b,I,A,T,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(n,P){this.localUserHome=n,this.remoteAgentService=P,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||A.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||n})()}async userHome(n){return(n==null?void 0:n.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?I.win32:I.posix)}async fileURI(n){let P="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const h=n.indexOf("/",2);h===-1?(P=n.substring(2),n="/"):(P=n.substring(2,h),n=n.substring(h)||"/")}return T.URI.from({scheme:b.Schemas.file,authority:P,path:n,query:"",fragment:""})}};D=Ve([qe(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(be[102],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,C){this.line=y,this.character=C}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,C){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class I{constructor(y,C,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,C),this.end=new b(D,k)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],_e([0,1,15,28,24,37,8,4,13,12,102]),function(Q,e,b,I,A,T,y,C,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",d=" characters skipped \u27EB",h=(P.length+d.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var r;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function g(R){return!!R.preview}e.resultIsMatch=g;function m(R){return!!R.resource}e.isFileMatch=m;function S(R){return!!R.message}e.isProgressMessage=S;var f;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class c{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=c;class p{constructor(L,M,U){this.ranges=M;const G=Array.isArray(M)?M:[M];if(U&&U.matchLines===1&&t(G)){L=(0,y.getNLines)(L,U.matchLines);let X="",se=0,pe=0;const Te=Math.floor(U.charsPerLine/5),xe=[];for(const Ae of G){const We=Math.max(Ae.startColumn-Te,0),x=Ae.startColumn+U.charsPerLine;if(We>pe+Te+h){const q=P+(We-pe)+d;X+=q+L.slice(We,x),se+=We-(pe+q.length)}else X+=L.slice(pe,x);xe.push(new o(0,Ae.startColumn-se,Ae.endColumn-se)),pe=x}this.preview={text:X,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const X=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,b.mapArrayOrNot)(M,se=>new i(se.startLineNumber-X,se.startColumn,se.endLineNumber-X,se.endColumn))}}}}e.TextSearchMatch=p;function t(R){const L=R[0].startLineNumber;for(const M of R)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class i{constructor(L,M,U,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=U,this.endColumn=G}}e.SearchRange=i;class o extends i{constructor(L,M,U){super(L,M,L,U)}}e.OneLineRange=o;var a;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function s(R,L=!0){const M=R&&R.files&&R.files.exclude,U=L&&R&&R.search&&R.search.exclude;if(!(!M&&!U)){if(!M||!U)return M||U;let G=Object.create(null);return G=A.mixin(G,A.deepClone(M)),G=A.mixin(G,A.deepClone(U),!0),G}}e.getExcludes=s;function u(R,L){return R.excludePattern&&I.match(R.excludePattern,L)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&I.match(R.includePattern,L)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(M=>{const U=M.folder.fsPath;if(T.isEqualOrParent(L,U)){const G=D.relative(U,L);return!M.includePattern||!!I.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var w;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class _ extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=_;function v(R){const L=R.message;if((0,k.isPromiseCanceledError)(R))return new _(L,w.canceled);try{const M=JSON.parse(L);return new _(M.message,M.code)}catch(M){return new _(L,w.other)}}e.deserializeSearchError=v;function E(R){const L={message:R.message,code:R.code};return new Error(JSON.stringify(L))}e.serializeSearchError=E;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function B(R){return R.type==="success"}e.isSerializedSearchSuccess=B;function Y(R){return!!R.path}e.isSerializedFileMatch=Y;function fe(R,L){const M=R.searchPath?R.searchPath:R.relativePath;return(0,y.fuzzyContains)(M,L)}e.isFilePatternMatch=fe;class V{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function z(R,L){const M=Object.assign(Object.assign({},R||{}),L||{});return Object.keys(M).filter(U=>{const G=M[U];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=z;class ee{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let U=L.includePattern;M.includePattern&&(U?U=Object.assign(Object.assign({},U),M.includePattern):U=M.includePattern),U&&(this._parsedIncludeExpression=I.parse(U))}includedInQuerySync(L,M,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,U))}includedInQuery(L,M,U){return Promise.resolve(this._parsedExcludeExpression(L,M,U)).then(X=>!!X).then(X=>X?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,U)).then(se=>!!se):Promise.resolve(!0)).then(X=>X)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=ee;function $(R){for(const L in R)if(typeof R[L]!="boolean")return!0;return!1}}),define(be[30],_e([0,1,15,11,20,3,22,19,81,25,8,10,2,138,4,18,153,48,49,27,14,7,41,5]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f,c,p,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(F,B,Y){return new k.ExtUri(fe=>w(fe,Y)).isEqual(F,B)}function a(F,B,Y){return o(F.uri,B.uri,Y)?0:(0,n.compare)(F.uri.toString(),B.uri.toString())}function s(F,B,Y){return F.index!==B.index?F.index<B.index?-1:1:o(F.uri,B.uri,Y)?(0,n.compare)(F.name,B.name):(0,n.compare)(F.uri.toString(),B.uri.toString())}function u(F,B,Y,fe){const V=F.slice(0).sort((ee,$)=>Y(ee,$,fe)),z=B.slice(0).sort((ee,$)=>Y(ee,$,fe));return(0,b.delta)(V,z,(ee,$)=>Y(ee,$,fe))}function w(F,B){const Y=B.getCapabilities(F.scheme);return!(Y&&Y&1024)}class _ extends m.Workspace{constructor(B,Y,fe,V,z,ee){super(B,fe.map($=>new m.WorkspaceFolder($)),V,ee);this._name=Y,this._isUntitled=z,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(ee),fe.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(B,Y,fe,V){if(!B)return{workspace:null,added:[],removed:[]};const{id:z,name:ee,folders:$,configuration:R,isUntitled:L}=B,M=[],U=Y;Y?$.forEach((pe,Te)=>{const xe=d.URI.revive(pe.uri),Ae=_._findFolder(fe||Y,xe,V);Ae?(Ae.name=pe.name,Ae.index=pe.index,M.push(Ae)):M.push({uri:xe,name:pe.name,index:Te})}):M.push(...$.map(({uri:pe,name:Te,index:xe})=>({uri:d.URI.revive(pe),name:Te,index:xe}))),M.sort((pe,Te)=>pe.index<Te.index?-1:1);const G=new _(z,ee,M,R?d.URI.revive(R):null,!!L,pe=>w(pe,V)),{added:X,removed:se}=u(U?U.workspaceFolders:[],G.workspaceFolders,a,V);return{workspace:G,added:X,removed:se}}static _findFolder(B,Y,fe){for(let V=0;V<B.folders.length;V++){const z=B.workspaceFolders[V];if(o(z.uri,Y,fe))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(B,Y){return Y&&this._structure.get(B)&&(B=(0,k.dirname)(B)),this._structure.findSubstr(B)}resolveWorkspaceFolder(B){return this._structure.get(B)}}let v=class{constructor(B,Y,fe,V){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=fe,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=B.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=B.getProxy(i.MainContext.MainThreadMessageService);const z=Y.workspace;this._confirmedWorkspace=z?new _(z.id,z.name,[],z.configuration?d.URI.revive(z.configuration):null,!!z.isUntitled,ee=>w(ee,fe)):void 0}$initializeWorkspace(B,Y){this._trusted=Y,this.$acceptWorkspaceData(B),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(B,Y,fe,...V){const z=[];if(Array.isArray(V)&&V.forEach(M=>{d.URI.isUri(M.uri)&&!z.some(U=>o(U.uri,M.uri,this._extHostFileSystemInfo))&&z.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[Y,fe].some(M=>typeof M!="number"||M<0)||fe===0&&z.length===0)return!1;const ee=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(Y+fe>ee.length)return!1;const $=ee.slice(0);$.splice(Y,fe,...z.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<$.length;M++){const U=$[M];if($.some((G,X)=>X!==M&&o(U.uri,G.uri,this._extHostFileSystemInfo)))return!1}$.forEach((M,U)=>M.index=U);const{added:R,removed:L}=u(ee,$,s,this._extHostFileSystemInfo);if(R.length===0&&L.length===0)return!1;if(this._proxy){const M=B.displayName||B.name;this._proxy.$updateWorkspaceFolders(M,Y,fe,z).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,h.localize)(0,null,M,U.toString()),{extension:B},[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(B,Y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,Y)}async getWorkspaceFolder2(B,Y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(B,Y)}async resolveWorkspaceFolder(B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(B)}getPath(){if(!!this._actualWorkspace){const{folders:B}=this._actualWorkspace;if(B.length!==0)return B[0].uri.fsPath}}getRelativePath(B,Y){let fe,V="";if(typeof B=="string"?(fe=d.URI.file(B),V=B):typeof B!="undefined"&&(fe=B,V=B.fsPath),!fe)return V;const z=this.getWorkspaceFolder(fe,!0);if(!z)return V;typeof Y=="undefined"&&this._actualWorkspace&&(Y=this._actualWorkspace.folders.length>1);let ee=(0,k.relativePath)(z.uri,fe);return Y&&z.name&&(ee=`${z.name}/${ee}`),ee}trySetWorkspaceFolders(B){this._actualWorkspace&&(this._unconfirmedWorkspace=_.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:B,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(B){const{workspace:Y,added:fe,removed:V}=_.toExtHostWorkspace(B,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=Y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:fe,removed:V}))}findFiles(B,Y,fe,V,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let ee;if(Y===null?ee=!1:Y&&(typeof Y=="string"?ee=Y:ee=Y.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:R}=E(B);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)($),(0,P.withUndefinedAsNull)(R),(0,P.withUndefinedAsNull)(ee),(0,P.withUndefinedAsNull)(fe),z).then(L=>Array.isArray(L)?L.map(M=>d.URI.revive(M)):[])}async findTextInFiles(B,Y,fe,V,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const ee=this._requestIdProvider.getNext(),$=typeof Y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:Y.previewOptions,{includePattern:R,folder:L}=E(Y.include),M=typeof Y.exclude=="string"?Y.exclude:Y.exclude?Y.exclude.pattern:void 0,U={ignoreSymlinks:typeof Y.followSymlinks=="boolean"?!Y.followSymlinks:void 0,disregardIgnoreFiles:typeof Y.useIgnoreFiles=="boolean"?!Y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof Y.useGlobalIgnoreFiles=="boolean"?!Y.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof Y.useDefaultExcludes=="boolean"?!Y.useDefaultExcludes:!0,fileEncoding:Y.encoding,maxResults:Y.maxResults,previewOptions:$,afterContext:Y.afterContext,beforeContext:Y.beforeContext,includePattern:R,excludePattern:M},G=!1;if(this._activeSearchCallbacks[ee]=X=>{if(!G){const se=d.URI.revive(X.resource);X.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?fe({uri:se,preview:{text:pe.preview.text,matches:(0,b.mapArrayOrNot)(pe.preview.matches,Te=>new p.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))},ranges:(0,b.mapArrayOrNot)(pe.ranges,Te=>new p.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))}):fe({uri:se,text:pe.text,lineNumber:pe.lineNumber})})}},z.isCancellationRequested)return{};try{const X=await this._proxy.$startTextSearch(B,(0,P.withUndefinedAsNull)(L),U,ee,z);return delete this._activeSearchCallbacks[ee],X||{}}catch(X){throw delete this._activeSearchCallbacks[ee],X}}$handleTextSearchResult(B,Y){this._activeSearchCallbacks[Y]&&this._activeSearchCallbacks[Y](B)}saveAll(B){return this._proxy.$saveAll(B)}resolveProxy(B){return this._proxy.$resolveProxy(B)}get trusted(){return this._trusted}requestWorkspaceTrust(B){const Y=this._proxy.$requestWorkspaceTrust(B);return(B==null?void 0:B.modal)?Y:Promise.resolve(this._trusted)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Ve([qe(0,c.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,S.IExtHostFileSystemInfo),qe(3,l.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function E(F){let B,Y;return F&&(typeof F=="string"?B=F:(B=F.pattern,Y=F.baseFolder||d.URI.file(F.base))),{includePattern:B,folder:Y}}}),define(be[34],_e([0,1,24,3,30,5,7,155,66,10,11,4,14,18,2]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(i,o){if(o){const a=o.split(".");let s=i;for(let u=0;s&&u<a.length;u++)s=s[a[u]];return s}}function g(i){return i instanceof r.URI}function m(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function S(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function f(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function c(i){if(g(i))return{resource:i};if(m(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(S(i))return{overrideIdentifier:i.languageId};if(f(i))return{resource:i.uri};if(i===null)return{resource:null}}let p=class{constructor(o,a,s){this._proxy=o.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=s,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new t(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,a){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,a))}};p=Ve([qe(0,d.IExtHostRpcService),qe(1,A.IExtHostWorkspace),qe(2,h.ILogService)],p),e.ExtHostConfiguration=p;class t{constructor(o,a,s,u){this._onDidChangeConfiguration=new I.Emitter,this._proxy=o,this._logService=u,this._extHostWorkspace=a,this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,a){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,s))}getConfiguration(o,a,s){const u=c(a)||{},w=this._toReadonlyValue(o?l(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,u,s==null?void 0:s.identifier);function _(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(E){return typeof l(w,E)!="undefined"},get:(E,F)=>{this._validateConfigurationAccess(o?`${o}.${E}`:E,u,s==null?void 0:s.identifier);let B=l(w,E);if(typeof B=="undefined")B=F;else{let Y;const fe=(V,z)=>{let ee;const $=()=>{Y=Y||(0,b.deepClone)(w),ee=ee||l(Y,z)};return(0,k.isObject)(V)?new Proxy(V,{get:(R,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return $(),()=>ee;if(Y)return ee=ee||l(Y,z),ee[L];const M=R[L];return typeof L=="string"?fe(M,`${z}.${L}`):M},set:(R,L,M)=>($(),ee&&(ee[L]=M),!0),deleteProperty:(R,L)=>($(),ee&&delete ee[L],!0),defineProperty:(R,L,M)=>($(),ee&&Object.defineProperty(ee,L,M),!0)}):V};B=fe(B,E)}return B},update:(E,F,B,Y)=>{E=o?`${o}.${E}`:E;const fe=_(B);return F!==void 0?this._proxy.$updateConfigurationOption(fe,E,F,u,Y):this._proxy.$removeConfigurationOption(fe,E,u,Y)},inspect:E=>{var F,B,Y,fe,V,z,ee,$;E=o?`${o}.${E}`:E;const R=(0,b.deepClone)(this._configuration.inspect(E,u,this._extHostWorkspace.workspace));if(R)return{key:E,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(B=R.user)===null||B===void 0?void 0:B.value,workspaceValue:(Y=R.workspace)===null||Y===void 0?void 0:Y.value,workspaceFolderValue:(fe=R.workspaceFolder)===null||fe===void 0?void 0:fe.value,defaultLanguageValue:(V=R.default)===null||V===void 0?void 0:V.override,globalLanguageValue:(z=R.user)===null||z===void 0?void 0:z.override,workspaceLanguageValue:(ee=R.workspace)===null||ee===void 0?void 0:ee.override,workspaceFolderLanguageValue:($=R.workspaceFolder)===null||$===void 0?void 0:$.override,languageIds:R.overrideIdentifiers}}};return typeof w=="object"&&(0,b.mixin)(v,w,!1),Object.freeze(v)}_toReadonlyValue(o){const a=s=>(0,k.isObject)(s)?new Proxy(s,{get:(u,w)=>a(u[w]),set:(u,w,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(u,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(u,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return a(o)}_validateConfigurationAccess(o,a,s){const u=D.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),w=s?`[${s.value}] `:"";if(u===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){(a==null?void 0:a.resource)&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,a){const s=new C.ConfigurationChangeEvent(o,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,w)=>s.affectsConfiguration(u,c(w))})}_toMap(o){return o.reduce((a,s)=>(a.set(s[0],s[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[103],_e([0,1,2,11,3,5,7,30,39,34,20,40,14,27,4,19,21,18,75,172,12]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(V){function z(R){if(R){const L=R;return L&&!!L.process}else return!1}V.is=z;function ee(R){if(R!=null){const L={process:R.process,args:R.args};return R.options&&(L.options=o.from(R.options)),L}}V.from=ee;function $(R){if(R!=null)return new y.ProcessExecution(R.process,R.args,R.options)}V.to=$})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(V){function z($){if($!=null)return $}V.from=z;function ee($){if($!=null)return $}V.to=ee})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(V){function z(R){if(R){const L=R;return L&&(!!L.commandLine||!!L.command)}else return!1}V.is=z;function ee(R){if(R!=null){const L={};return R.commandLine!==void 0?L.commandLine=R.commandLine:(L.command=R.command,L.args=R.args),R.options&&(L.options=s.from(R.options)),L}}V.from=ee;function $(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new y.ShellExecution(R.commandLine,R.options):new y.ShellExecution(R.command,R.args?R.args:[],R.options)}V.to=$})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var w;(function(V){function z(R){if(R){let L=R;return L&&L.customExecution==="customExecution"}else return!1}V.is=z;function ee(R){return{customExecution:"customExecution"}}V.from=ee;function $(R,L){return L.get(R)}V.to=$})(w=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(V){function z(ee,$){let R;return ee.scope!==void 0&&typeof ee.scope!="number"?R=ee.scope.uri:ee.scope!==void 0&&typeof ee.scope=="number"&&(ee.scope===y.TaskScope.Workspace&&$&&$.workspaceFile?R=$.workspaceFile:R=f.USER_TASKS_GROUP_KEY),{id:ee._id,workspaceFolder:R}}V.from=z})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(V){function z(R,L){if(R==null)return[];const M=[];for(let U of R){const G=ee(U,L);G&&M.push(G)}return M}V.fromMany=z;function ee(R,L){if(R!=null){let M;R.execution instanceof y.ProcessExecution?M=a.from(R.execution):R.execution instanceof y.ShellExecution?M=u.from(R.execution):R.execution&&R.execution instanceof y.CustomExecution&&(M=w.from(R.execution));const U=t.from(R.definition);let G;if(R.scope?typeof R.scope=="number"?G=R.scope:G=R.scope.uri:G=y.TaskScope.Workspace,!(!U||!G)){const X=R.group?R.group.id:void 0;return{_id:R._id,definition:U,name:R.name,source:{extensionId:L.identifier.value,label:R.source,scope:G},execution:M,isBackground:R.isBackground,group:X,presentationOptions:i.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}}}V.from=ee;async function $(R,L,M){if(R!=null){let U;a.is(R.execution)?U=a.to(R.execution):u.is(R.execution)?U=u.to(R.execution):w.is(R.execution)&&(U=w.to(R._id,M));const G=t.to(R.definition);let X;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?X=R.source.scope:X=await L.resolveWorkspaceFolder(b.URI.revive(R.source.scope)):X=y.TaskScope.Workspace),!(!G||!X)){const se=new y.Task(G,X,R.name,R.source.label,U,R.problemMatchers);return R.isBackground!==void 0&&(se.isBackground=R.isBackground),R.group!==void 0&&(se.group=y.TaskGroup.from(R.group)),R.presentationOptions&&(se.presentationOptions=i.to(R.presentationOptions)),R._id&&(se._id=R._id),R.detail&&(se.detail=R.detail),se}}}V.to=$})(v=e.TaskDTO||(e.TaskDTO={}));var E;(function(V){function z($){return $}V.from=z;function ee($){if(!!$)return Object.assign(Object.create(null),$)}V.to=ee})(E=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(z,ee,$){this._id=ee,this._task=$,p.set(this,void 0),tt(this,p,z,"f")}get task(){return this._task}terminate(){Me(this,p,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}p=new WeakMap;var B;(function(V){function z(ee){return{id:ee._id,task:void 0}}V.from=z})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let Y=class{constructor(z,ee,$,R,L,M,U,G){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=R,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,ee,$){if(!$)return new y.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:ee,provider:$,extension:z}),this._proxy.$registerTaskProvider(R,ee),new y.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(z,ee){this._proxy.$registerTaskSystem(z,ee)}fetchTasks(z){return this._proxy.$fetchTasks(E.from(z)).then(async ee=>{const $=[];for(let R of ee){const L=await v.to(R,this._workspaceProvider,this._providedCustomExecutions2);L&&$.push(L)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(ee=>z.push(ee)),z}terminateTask(z){if(!(z instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,ee,$){const R=this._providedCustomExecutions2.get(z.id);if(R){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,R),this._terminalService.attachPtyToTerminal(ee,await R.callback($))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const ee=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:ee})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const ee=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:ee,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const ee=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:ee,exitCode:z.exitCode})}$provideTasks(z,ee){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const R=[],L=(0,I.asPromise)(()=>$.provider.provideTasks(n.CancellationToken.None)).then(M=>this.provideTasksInternal(ee,R,$,M));return new Promise(M=>{L.then(U=>{Promise.all(R).then(()=>{M(U)})})})}async $resolveTask(z,ee){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(ee.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${ee.definition.type}] cannot be resolved by provider of type [${$.type}].`);const R=await v.to(ee,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const L=await $.provider.resolveTask(R,n.CancellationToken.None);if(!!L){this.checkDeprecation(L,$);const M=v.from(L,$.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return w.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(z,ee,$){const R=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,ee.execution)}async getTaskExecution(z,ee){if(typeof z=="string"){const L=this._taskExecutionPromises.get(z);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let $=this._taskExecutionPromises.get(z.id);if($)return $;const R=new Promise(async(L,M)=>{const U=ee||await v.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);U?L(new F(this,z.id,U)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,R),R.then(L=>(this._taskExecutions.set(z.id,L),L),L=>Promise.reject(L))}checkDeprecation(z,ee){z._deprecated&&this._deprecationService.report("Task.constructor",ee.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),R=$.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=$.next()}};Y=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,S.IExtHostApiDeprecationService)],Y),e.ExtHostTaskBase=Y;let fe=class extends Y{constructor(z,ee,$,R,L,M,U,G){super(z,ee,$,R,L,M,U,G);this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(z,ee){if(!ee.execution)throw new Error("Tasks to execute must include an execution");const $=v.from(ee,z);if($===void 0)throw new Error("Task is not valid");if(w.is($.execution))await this.addCustomExecution($,ee,!1);else throw new c.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution($),ee);return this._proxy.$executeTask($).catch(L=>{throw new Error(L)}),R}provideTasksInternal(z,ee,$,R){const L=[];if(R)for(let M of R){this.checkDeprecation(M,$),(!M.definition||!z[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const U=v.from(M,$.extension);U&&w.is(U.execution)?(L.push(U),ee.push(this.addCustomExecution(U,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:$.extension}}async resolveTaskInternal(z){if(w.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,ee){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(z,ee,$){}};fe=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,P.IExtHostTerminalService),qe(6,m.ILogService),qe(7,S.IExtHostApiDeprecationService)],fe),e.WorkerExtHostTask=fe,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)},zt=this&&this.__rest||function(Q,e){var b={};for(var I in Q)Object.prototype.hasOwnProperty.call(Q,I)&&e.indexOf(I)<0&&(b[I]=Q[I]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(Q);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,I[A])&&(b[I[A]]=Q[I[A]]);return b};define(be[219],_e([0,1,15,11,23,20,3,53,43,6,24,10,2,31,5,39,14,69,9,7,30,183,96]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f,c,p,t){"use strict";var i,o,a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const u=($,R)=>`${$}:${R.toString()}`;let w=class{constructor(R,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new p.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new _(this.proxy),this.workspaceObservers=new z(this.proxy),this.textDocumentObservers=new ee(this.proxy,L)}registerTestController(R,L){const M=(0,h.generateUuid)();this.controllers.set(M,{instance:L,extensionId:R}),this.proxy.$registerTestController(M);const U=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const X of U)(G=this.testControllers.get(X))===null||G===void 0||G.subscribeFn(M,L)},0),new f.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,L=T.CancellationToken.None){const M=U=>U.map(this.getInternalTestForReference,this).filter(P.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:R.exclude?M(R.exclude).map(U=>U.testId):void 0,tests:M(R.tests),debug:R.debug},L)}createTestRunTask(R,L,M,U=!0){return this.runQueue.createTestRunTask(R,L,M,U)}$publishTestResults(R){this.results=Object.freeze(R.map(L=>(0,n.deepFreeze)(S.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,L){const M=d.URI.revive(L),U=u(R,M);if(!this.testControllers.has(U)){const G=new T.CancellationTokenSource;let X;if(R===1){let Ae=this.documents.getDocument(M);if(!Ae){const We=new k.DisposableStore;Ae=await new Promise(x=>{We.add((0,I.disposableTimeout)(()=>x(void 0),5e3)),We.add(this.documents.onDidAddDocuments(q=>{const ne=q.find(le=>le.document.uri.toString()===M.toString());ne&&x(ne)}))}).finally(()=>We.dispose())}if(Ae){const We=await this.workspace.getWorkspaceFolder2(M,!1);X=x=>x.createDocumentTestRoot?x.createDocumentTestRoot(Ae.document,G.token):(0,e.createDefaultDocumentTestRoot)(x,Ae.document,We,G.token)}}else{const Ae=await this.workspace.getWorkspaceFolder2(M,!1);Ae&&(X=We=>We.createWorkspaceTestRoot(Ae,G.token))}if(!!X){const se=async(Ae,We)=>{try{const x=await X(We);x&&Te.addRoot(x,Ae)}catch(x){console.error(x)}},pe=new k.DisposableStore,Te=pe.add(this.ownedTests.createForHierarchy(Ae=>this.proxy.$publishDiff(R,L,Ae)));pe.add((0,k.toDisposable)(()=>G.dispose(!0)));const xe=[];for(const[Ae,We]of this.controllers)xe.push(se(Ae,We.instance));Promise.all(xe).then(()=>Te.pushDiff([3,-1])),this.testControllers.set(U,{store:pe,collection:Te,subscribeFn:se})}}}async $expandTest(R,L){const M=(0,b.mapFind)(this.testControllers.values(),U=>U.collection.treeId===R.src.tree?U:void 0);await(M==null?void 0:M.collection.expand(R.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,L){var M;const U=d.URI.revive(L),G=u(R,U);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(R,L,M){R===1?this.textDocumentObservers.acceptDiff(d.URI.revive(L),M):this.workspaceObservers.acceptDiff(d.URI.revive(L),M)}async $runTestsForProvider(R,L){const M=this.controllers.get(R.tests[0].src.controller);if(!!M){const U=R.tests.map(({testId:se,src:pe})=>this.ownedTests.getTestById(se,pe==null?void 0:pe.tree)).filter(P.isDefined).map(([se,pe])=>pe),G=R.excludeExtIds.map(se=>this.ownedTests.getTestById(se)).filter(P.isDefined).filter(([se,pe])=>U.some(Te=>se.comparePositions(Te,pe)===1));if(!!U.length){const X={tests:U.map(se=>B.unwrap(se.actual)),exclude:G.map(([,se])=>B.unwrap(se.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:v.fromInternal(R),token:L,extensionId:M.extensionId,req:X,doRun:()=>M.instance.runTests(X,L)})}}}$lookupTest(R){const L=this.ownedTests.getTestById(R.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:U,discoverCts:G,expandLevels:X}=M,se=zt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(se)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&L!==void 0?L:(0,b.mapFind)(this.testControllers.values(),U=>U.collection.getTestByReference(R)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(R)}};w=Ve([qe(0,g.IExtHostRpcService),qe(1,l.IExtHostDocumentsAndEditors),qe(2,c.IExtHostWorkspace)],w),e.ExtHostTesting=w;class _{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let L=this.state.get(R.extensionId);L||(L={queue:[],current:void 0},this.state.set(R.extensionId,L));const M=new I.DeferredPromise,U=()=>{const G=[],X=new Set;L.current={publicReq:R.req,factory:se=>{const pe=new E(se,R.dto,X,this.proxy);return G.push(pe),R.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,G).finally(()=>M.complete())};return L.queue.push(U),L.queue.length===1&&U(),M.p}createTestRunTask(R,L,M,U){var G,X;const se=this.state.get(R);if((se==null?void 0:se.current.publicReq)===L)return se.current.factory(M);const pe=v.fromPublic(L),Te=new E(M,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(X=(G=L.exclude)===null||G===void 0?void 0:G.map(xe=>xe.id))!==null&&X!==void 0?X:[],id:pe.id,tests:L.tests.map(xe=>xe.id),persist:U}),Te.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Te}invokeRunner(R,L,M,U){try{const G=M();return(0,I.isThenable)(G)?G.then(()=>this.handleInvokeResult(R,L,U,void 0)).catch(X=>this.handleInvokeResult(R,L,U,X)):this.handleInvokeResult(R,L,U,void 0)}catch(G){return this.handleInvokeResult(R,L,U,G)}}async handleInvokeResult(R,L,M,U){const G=this.state.get(R);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(R),await Promise.all(M.map(X=>X.onEnd.wait())))}}class v{constructor(R,L,M){this.id=R,this.include=L,this.exclude=M}static fromPublic(R){var L,M;return new v((0,h.generateUuid)(),new Set(R.tests.map(U=>U.id)),new Set((M=(L=R.exclude)===null||L===void 0?void 0:L.map(U=>U.id))!==null&&M!==void 0?M:D.Iterable.empty()))}static fromInternal(R){return new v(R.runId,new Set(R.tests.map(L=>L.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let L=R;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class E{constructor(R,L,M,U){this.name=R,i.set(this,void 0),o.set(this,void 0),a.set(this,(0,h.generateUuid)()),s.set(this,void 0),this.onEnd=new I.Barrier,tt(this,i,U,"f"),tt(this,o,L,"f"),tt(this,s,M,"f"),U.$startedTestRunTask(L.id,{id:Me(this,a,"f"),name:R,running:!0})}setState(R,L,M){Me(this,o,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,i,"f").$updateTestStateInRun(Me(this,o,"f").id,Me(this,a,"f"),R.id,L,M))}appendMessage(R,L){Me(this,o,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,i,"f").$appendTestMessageInRun(Me(this,o,"f").id,Me(this,a,"f"),R.id,S.TestMessage.from(L)))}appendOutput(R){Me(this,i,"f").$appendOutputToRun(Me(this,o,"f").id,Me(this,a,"f"),A.VSBuffer.fromString(R))}end(){Me(this,i,"f").$finishedTestRunTask(Me(this,o,"f").id,Me(this,a,"f")),this.onEnd.open()}ensureTestIsKnown(R){const L=Me(this,s,"f");if(!L.has(R.id)){const M=[];for(;M.unshift(S.TestItem.from(R)),!(L.has(R.id)||(L.add(R.id),!R.parent));)R=R.parent;Me(this,i,"f").$addTestsToRun(Me(this,o,"f").id,M)}}}i=new WeakMap,o=new WeakMap,a=new WeakMap,s=new WeakMap;const F=async($,R,L,M)=>{if(!!L){const U=await $.createWorkspaceTestRoot(L,M);if(!!U){M.onCancellationRequested(()=>{B.removeFilter(R)});const G=B.getWrapperForTestItem(U,R);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=F;class B extends f.TestItemImpl{constructor(R,L,M){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=L,this.actualParent=M,!(R instanceof f.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const U=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(R).bus.event(X=>{switch(X[0]){case 3:this[X[1]]=X[2];break;case 0:const se=B.getWrapperForTestItem(X[1],this.filterDocument,this);(0,m.getPrivateApiFor)(se).parent=R,se.refreshMatch();break;default:U.bus.fire(X)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,L,M){let U=this.wrapperMap.get(L);if(U==null?void 0:U.has(R))return U.get(R);U||(U=new WeakMap,this.wrapperMap.set(L,U));const G=new B(R,L,M);return U.set(R,G),G}static unwrap(R){return R instanceof B?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R;const L=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const G=B.getWrapperForTestItem(U,this.filterDocument,this);G.hasNodeMatchingFilter?this.children.has(G.id)||this.addChild(G):G.dispose()}const M=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==L&&((R=this.actualParent)===null||R===void 0||R.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=B,B.wrapperMap=new WeakMap;class Y extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,S.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:L,removed:M}=this;return{get added(){return[...R].map(U=>U.revived)},get updated(){return[...L].map(U=>U.revived)},get removed(){return[...M].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class fe extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let L=[];for(const M of R){const U=this.items.get(M);U&&L.push(U.revived)}return L}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,L){return Object.assign(Object.assign({},R),{revived:S.TestItem.toPlain(R.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new Y(this.changeEmitter)}}e.MirroredTestCollection=fe;class V{constructor(){this.resources=new Map}checkout(R){var L,M;const U=R.toString(),G=(L=this.resources.get(U))!==null&&L!==void 0?L:this.createObserverData(R);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,C.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(R);if(M)return M}}eventuallyDispose(R){return(0,I.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const L=new fe,M=this.listen(R,G=>L.apply(G)),U={observers:0,tests:L,listener:M};return this.resources.set(R.toString(),U),U}unlisten(R){var L;const M=R.toString(),U=this.resources.get(M);U&&(U.observers=-1,(L=U.pendingDeletion)===null||L===void 0||L.dispose(),U.listener.dispose(),this.resources.delete(M))}}class z extends V{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){this.proxy.$subscribeToDiffs(0,R);const M=R.toString();return this.diffListeners.set(M,L),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(M)})}}class ee extends V{constructor(R,L){super();this.proxy=R,this.documents=L,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){if(!this.documents.getDocument(R))return new f.Disposable(()=>{});const U=R.toString();return this.diffListeners.set(U,L),this.proxy.$subscribeToDiffs(1,R),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(U)})}}}),define(be[220],_e([0,1,15,51,28,58,22,19,13,25,8,10,2,116,141,92,48,175,218,41]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(_,v,E,F){this.configurationService=_,this.workspaceContextService=v,this.editorGroupsService=E,this.pathService=F}text(_,v,E={}){_=this.getContentPattern(_,E);const F=this.configurationService.getValue(),B=v&&v.some(fe=>!this.configurationService.getValue({resource:fe}).search.useRipgrep),Y=this.commonQuery(v==null?void 0:v.map(g.toWorkspaceFolder),E);return Object.assign(Object.assign({},Y),{type:2,contentPattern:_,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:F.search.usePCRE2||B||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles})}getContentPattern(_,v){const E=this.configurationService.getValue();_.isRegExp&&(_.pattern=_.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},_),{wordSeparators:E.editor.wordSeparators});return this.isCaseSensitive(_,v)&&(F.isCaseSensitive=!0),this.isMultiline(_)&&(F.isMultiline=!0),F}file(_,v={}){const E=this.commonQuery(_,v);return Object.assign(Object.assign({},E),{type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey})}handleIncludeExclude(_,v){return _?(_=Array.isArray(_)?_.map(a):a(_),v?this.parseSearchPaths(_):{pattern:t(...Array.isArray(_)?_:[_])}):{}}commonQuery(_=[],v={}){const E=this.handleIncludeExclude(v.includePattern,v.expandPatterns),F=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),B=_.length>1,Y=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,v,F)):_.map(z=>this.getFolderQueryForRoot(z,v,F,B))).filter(z=>!!z),fe={_reason:v._reason,folderQueries:Y,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:F.pattern,includePattern:E.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const ee=b.coalesce(b.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(L=>L.resource)))).filter(R=>(0,f.pathIncludedInQuery)(fe,R.fsPath)),$=this.commonQueryFromFileList(ee);return Object.assign(Object.assign({},fe),$)}const V=v.extraFileResources&&v.extraFileResources.filter(z=>(0,f.pathIncludedInQuery)(fe,z.fsPath));return fe.extraFileResources=V&&V.length?V:void 0,fe}commonQueryFromFileList(_){const v=[],E=new y.ResourceMap,F={};let B=!1;return _.forEach(Y=>{var fe,V;if(Y.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(Y)){const ee=(V=(fe=this.workspaceContextService.getWorkspaceFolder(Y))===null||fe===void 0?void 0:fe.uri)!==null&&V!==void 0?V:Y.with({path:D.dirname(Y.fsPath)});let $=E.get(ee);$||(B=!0,$={folder:ee,includePattern:{}},v.push($),E.set(ee,$));const R=D.relative(ee.fsPath,Y.fsPath);(0,P.assertIsDefined)($.includePattern)[R.replace(/\\/g,"/")]=!0}else Y.fsPath&&(B=!0,F[Y.fsPath]=!0)}),{folderQueries:v,includePattern:F,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(_,v){if(v.isSmartCase){if(_.isRegExp){if(n.containsUppercaseCharacter(_.pattern,!0))return!0}else if(n.containsUppercaseCharacter(_.pattern))return!0}return!!_.isCaseSensitive}isMultiline(_){return _.isMultiline||_.isRegExp&&(0,h.isMultilineRegexSource)(_.pattern)||_.pattern.indexOf(`
`)>=0?!0:!!_.isMultiline}parseSearchPaths(_){const v=$=>D.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),F=(Array.isArray(_)?_:i(_)).map($=>{const R=this.pathService.resolvedUserHome;return R?(0,T.untildify)($,R.scheme===C.Schemas.file?R.fsPath:R.path):$}),B=I.groupBy(F,$=>v($)?"searchPaths":"exprSegments"),Y=(B.exprSegments||[]).map($=>n.rtrim($,"/")).map($=>n.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),o($))),fe={},V=this.expandSearchPathPatterns(B.searchPaths||[]);V&&V.length&&(fe.searchPaths=V);const z=b.flatten(Y),ee=t(...z);return ee&&(fe.pattern=ee),fe}getExcludesForFolder(_,v){return v.disregardExcludeSettings?void 0:(0,f.getExcludes)(_,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(_){if(!_||!_.length)return[];const v=b.flatten(_.map(F=>{let{pathPortion:B,globPortion:Y}=p(F);Y&&(Y=s(Y));const fe=this.expandOneSearchPath(B);return b.flatten(fe.map(V=>this.resolveOneSearchPathPattern(V,Y)))})),E=new Map;return v.forEach(F=>{const B=F.searchPath.toString(),Y=E.get(B);Y?F.pattern&&(Y.pattern=Y.pattern||{},Y.pattern[F.pattern]=!0):E.set(B,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(_){if(D.isAbsolute(_)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==C.Schemas.file?[{searchPath:v[0].uri.with({path:_})}]:[{searchPath:d.URI.file(D.normalize(_))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(_=a(_),_.startsWith("../")||_===".."){const F=D.posix.resolve(v.path,_);return[{searchPath:v.with({path:F})}]}const E=s(_);return[{searchPath:v,pattern:E}]}else{if(_==="./"||_===".\\")return[];{const v=_.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(v){const E=v[1],F=this.workspaceContextService.getWorkspace().folders.filter(B=>B.name===E);if(F.length)return F.map(B=>{const Y=v[2];return{searchPath:B.uri,pattern:Y&&s(Y)}});{const B=r.localize(0,null,E);throw new Error(B)}}}}return[]}resolveOneSearchPathPattern(_,v){const E=_.pattern&&v?`${_.pattern}/${v}`:_.pattern||v,F=[{searchPath:_.searchPath,pattern:E}];return E&&!E.endsWith("**")&&F.push({searchPath:_.searchPath,pattern:E+"/**"}),F}getFolderQueryForSearchPath(_,v,E){const F=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(_.searchPath),v,E,!1);return F?Object.assign(Object.assign({},F),{includePattern:_.pattern}):null}getFolderQueryForRoot(_,v,E,F){let B;const Y=d.URI.isUri(_)?_:_.uri;if(E.searchPaths){const $=E.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,Y))[0];if($&&!$.pattern)return null;$&&(B=$.pattern)}const fe=this.configurationService.getValue({resource:Y}),V=this.getExcludesForFolder(fe,v),z=Object.assign(Object.assign({},V||{}),B||{}),ee=d.URI.isUri(_)?(0,k.basename)(_):_.name;return{folder:Y,folderName:F?ee:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:fe.files&&fe.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!fe.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!fe.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!fe.search.followSymlinks}}};c=Ve([qe(0,l.IConfigurationService),qe(1,g.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,S.IPathService)],c),e.QueryBuilder=c;function p(w){const _=w.match(/[\*\{\}\(\)\[\]\?]/);if(_){const v=_.index,E=w.substr(0,v).match(/[/|\\][^/\\]*$/);if(E){let F=w.substr(0,E.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:w.substr((E.index||0)+1)}}}return{pathPortion:w}}function t(...w){return w.length?w.reduce((_,v)=>(_[v]=!0,_),Object.create(null)):void 0}function i(w){return A.splitGlobAware(w,",").map(_=>_.trim()).filter(_=>!!_.length)}function o(w){return[`**/${w}/**`,`**/${w}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function a(w){return w.replace(/\\/g,"/")}function s(w){return a(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(w,_){w=b.distinct(w,F=>F.toString());const v=[],E=_.getWorkspace();return w&&w.forEach(F=>{let B;if(_.getWorkbenchState()===2)B=(0,k.relativePath)(E.folders[0].uri,F),B&&B!=="."&&(B="./"+B);else{const Y=_.getWorkspaceFolder(F);if(Y){const fe=Y.name;if(E.folders.filter(z=>z.name===fe).length===1){const z=(0,k.relativePath)(Y.uri,F);z===""?B=`./${Y.name}`:B=`./${Y.name}/${z}`}else B=F.fsPath}}B&&v.push(B)}),v}e.resolveResourcesForSearchIncludes=u}),define(be[221],_e([0,1,25,2,20,12,4,220,41,48]),function(Q,e,b,I,A,T,y,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function P(l,g){const m=g.activationEvents;if(!m)return Promise.resolve(void 0);const S=[],f=[];for(const a of m)if(/^workspaceContains:/.test(a)){const s=a.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||l.forceUsingSearch?f.push(s):S.push(s)}if(S.length===0&&f.length===0)return Promise.resolve(void 0);let c;const p=new Promise((a,s)=>{c=a}),t=a=>c({activationEvent:a}),i=Promise.all(S.map(a=>d(l,a,t))).then(()=>{}),o=h(l,g.identifier,f,t);return Promise.all([i,o]).then(()=>{c(void 0)}),p}e.checkActivateWorkspaceContainsExtension=P;async function d(l,g,m){for(const S of l.folders)if(await l.exists(b.joinPath(I.URI.revive(S),g))){m(`workspaceContains:${g}`);return}}async function h(l,g,m,S){if(m.length===0)return Promise.resolve(void 0);const f=new A.CancellationTokenSource,c=l.checkExists(l.folders,m,f.token),p=setTimeout(async()=>{f.cancel(),S(`workspaceContainsTimeout:${m.join(",")}`)},n);let t=!1;try{t=await c}catch(i){T.isPromiseCanceledError(i)||T.onUnexpectedError(i)}f.dispose(),clearTimeout(p),t&&S(`workspaceContains:${m.join(",")}`)}function r(l,g,m,S){const f=l.get(y.IInstantiationService),c=l.get(D.ISearchService),t=f.createInstance(C.QueryBuilder).file(g.map(i=>(0,k.toWorkspaceFolder)(I.URI.revive(i))),{_reason:"checkExists",includePattern:m,exists:!0});return c.fileSearch(t,S).then(i=>!!i.limitHit,i=>T.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(Q,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(Q,b):A?A.value=b:e.set(Q,b),b},Me=this&&this.__classPrivateFieldGet||function(Q,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!I:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(Q):I?I.value:e.get(Q)};define(be[35],_e([0,1,133,13,80,25,11,6,22,2,18,5,34,186,78,30,33,184,12,26,23,162,7,67,4,27,79,14,65,70,40,3,221,74,163]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f,c,p,t,i,o,a,s,u,w,_,v,E,F,B,Y){"use strict";var fe,V,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let ee=class Fn extends C.Disposable{constructor(M,U,G,X,se,pe,Te,xe,Ae,We){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=G,this._initData=Te,this._extHostWorkspace=X,this._extHostConfiguration=se,this._logService=pe,this._extHostTunnelService=Ae,this._extHostTerminalService=We,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new B.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=M.createChild(new w.ServiceCollection([r.IExtHostStorage,this._storage],[B.IExtHostSecretState,this._secretState]));const x=new Set;this._initData.hostExtensions.forEach(q=>x.add(f.ExtensionIdentifier.toKey(q))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(q,ne)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(q,ne)},actualActivateExtension:async(q,ne)=>{if(x.has(f.ExtensionIdentifier.toKey(q)))return await this._mainThreadExtensionsProxy.$activateExtension(q,ne),new h.HostExtension;const le=this._registry.getExtensionDescription(q);return this._activateExtension(le,ne)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){S.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(se=>se.identifier).filter(se=>this.isActivated(se)).map(se=>this._deactivate(se))}catch(U){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,U){return this._activator.activateByEvent(M,U)}_activateById(M,U){return this._activator.activateById(M,U)}activateByIdWithErrors(M,U){return this._activateById(M,U).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=D.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(X=>M.set(k.URI.file(X).fsPath,G))});this._extensionPathIndex=Promise.all(U).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return U;const G=this._activator.getActivatedExtension(M);if(!G)return U;try{typeof G.module.deactivate=="function"&&(U=Promise.resolve(G.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,C.dispose)(G.subscriptions)}catch(X){}return U}async _activateExtension(M,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,U).then(G=>{const X=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,U),this._logExtensionActivationTimes(M,U,"success",X),G},G=>{throw this._logExtensionActivationTimes(M,U,"failure"),G})}_logExtensionActivationTimes(M,U,G,X){const se=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},se),X||{}),{outcome:G}))}_doActivateExtension(M,U){const G=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const X=this._getEntryPoint(M);if(!X)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const se=new h.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,X),se),this._loadExtensionContext(M)]).then(pe=>(A.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Fn._callActivate(this._logService,M.identifier,pe[0],pe[1],se))).then(pe=>(A.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),pe))}_loadExtensionContext(M){const U=new p.ExtensionGlobalMemento(M,this._storage),G=new p.ExtensionMemento(M.identifier.value,!1,this._storage),X=new Y.ExtensionSecrets(M,this._secretState),se=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([U.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let xe;return Object.freeze({globalState:U,workspaceState:G,secrets:X,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ae){return I.join(M.extensionLocation.fsPath,Ae)},get storagePath(){var Ae;return(Ae=Te._storagePath.workspaceValue(M))===null||Ae===void 0?void 0:Ae.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(M).fsPath},get logPath(){return I.join(Te._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Te._initData.logsLocation,M.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(M)},get globalStorageUri(){return Te._storagePath.globalValue(M)},get extensionMode(){return se},get extension(){return xe===void 0&&(xe=new R(Te,M.identifier,M,pe)),xe},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(M),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,U,G,X,se){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,U,G,X,se).then(pe=>new h.ActivatedExtension(!1,null,se.build(),G,pe,X.subscriptions))}static _callActivateOptional(M,U,G,X,se){if(typeof G.activate=="function")try{se.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${U.value}`);const pe=typeof global=="object"?global:self,Te=G.activate.apply(pe,[X]);return se.activateCallStop(),se.activateResolveStart(),Promise.resolve(Te).then(xe=>(se.activateResolveStop(),xe))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(G)}_activateOneStartupFinished(M,U){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:U}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const U of M.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(M,U)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,se=>{this._logService.error(se)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(se=>this._handleWorkspaceContainsEagerExtensions(se.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(U),X=Promise.all([M,G]).then(()=>{});return Promise.race([X,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(M,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,U){if(!this.isActivated(U.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:M.map(pe=>pe.uri),forceUsingSearch:G,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Te,xe)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Te,xe)},se=await(0,F.checkActivateWorkspaceContainsExtension)(X,U);if(!!se)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:se.activationEvent}).then(void 0,pe=>this._logService.error(pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:U}=this._initData.environment;if(!M||!U)throw new Error(b.localize(0,null));const G=await this._loadCommonJSModule(null,U,new h.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(b.localize(1,null,U.toString()));return new Promise((X,se)=>{const pe=(Ae,We)=>{Ae?se(Ae):X(typeof We=="number"&&We>0?1:0)},Te=(0,T.originalFSPath)(U),xe=G.run(Te,pe);xe&&xe.then&&xe.then(()=>{X(0)}).catch(Ae=>{se(Ae.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,U){return this._resolvers[M]=U,(0,C.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,U){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const X=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const se=this._resolvers[X];if(!se)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{A.mark(`code/extHost/willResolveAuthority/${X}`);const pe=await se.resolve(M,{resolveAttempt:U});A.mark(`code/extHost/didResolveAuthorityOK/${X}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(se));const Te={authority:M,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},xe={extensionHostEnv:pe.extensionHostEnv,trust:pe.trust};return{type:"ok",value:{authority:Te,options:xe,tunnelInformation:{environmentTunnels:pe.environmentTunnels}}}}catch(pe){if(A.mark(`code/extHost/didResolveAuthorityError/${X}`),pe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,U){return U===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,U),!0):!1}async $deltaExtensions(M,U){M.forEach(X=>X.extensionLocation=k.URI.revive(X.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(U.map(async X=>{const se=this._registry.getExtensionDescription(X);if(!!se){const pe=await this._hostUtils.realpath(se.extensionLocation.fsPath);G.delete(k.URI.file(pe).fsPath)}})),await Promise.all(M.map(async X=>{const se=await this._hostUtils.realpath(X.extensionLocation.fsPath);G.set(k.URI.file(se).fsPath,X)})),this._registry.deltaExtensions(M,U),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let U=c.VSBuffer.alloc(M),G=Math.random()%256;for(let X=0;X<M;X++)U.writeUInt8(G,X);return U}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};ee=Ve([qe(0,o.IInstantiationService),qe(1,e.IHostUtils),qe(2,u.IExtHostRpcService),qe(3,l.IExtHostWorkspace),qe(4,d.IExtHostConfiguration),qe(5,n.ILogService),qe(6,a.IExtHostInitDataService),qe(7,s.IExtensionStoragePaths),qe(8,_.IExtHostTunnelService),qe(9,v.IExtHostTerminalService)],ee),e.AbstractExtHostExtensionService=ee;function $(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class R{constructor(M,U,G,X){fe.set(this,void 0),V.set(this,void 0),z.set(this,void 0),tt(this,fe,M,"f"),tt(this,V,U,"f"),tt(this,z,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=I.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=X}get isActive(){return Me(this,fe,"f").isActivated(Me(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,fe,"f").getExtensionExports(Me(this,z,"f"))}activate(){return Me(this,fe,"f").activateByIdWithErrors(Me(this,z,"f"),{startup:!1,extensionId:Me(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,fe=new WeakMap,V=new WeakMap,z=new WeakMap}),define(be[104],_e([0,1,13,2,3,11,5,7,170,30,35,39,174,34,171,14,4,10,46]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let f=class{constructor(u,w,_,v,E){this._workspaceService=w,this._extensionService=_,this._editorsService=v,this._configurationService=E,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=u.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new p(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(B=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,w){const _=u;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let v=`debug:${encodeURIComponent(_.path||"")}`,E="?";return w&&(v+=`${E}session=${encodeURIComponent(w.id)}`,E="&"),v+=`${E}ref=${_.sourceReference}`,I.URI.parse(v)}else{if(_.path)return I.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const w=[];for(const _ of u.getAllExtensionDescriptions())if(_.contributes){const v=_.contributes.debuggers;if(v&&v.length>0)for(const E of v)(0,r.isDebuggerMainContribution)(E)&&w.push(E.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(w=>u.push(w)),u}addBreakpoints(u){this.startBreakpoints();const w=u.filter(E=>{const F=E.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,E),!0)});this.fireBreakpointChanges(w,[],[]);const _=[],v=new Map;for(const E of w)if(E instanceof C.SourceBreakpoint){let F=v.get(E.location.uri.toString());F||(F={type:"sourceMulti",uri:E.location.uri,lines:[]},v.set(E.location.uri.toString(),F),_.push(F)),F.lines.push({id:E.id,enabled:E.enabled,condition:E.condition,hitCondition:E.hitCondition,logMessage:E.logMessage,line:E.location.range.start.line,character:E.location.range.start.character})}else E instanceof C.FunctionBreakpoint&&_.push({type:"function",id:E.id,enabled:E.enabled,hitCondition:E.hitCondition,logMessage:E.logMessage,condition:E.condition,functionName:E.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(u){this.startBreakpoints();const w=u.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],w,[]);const _=w.filter(F=>F instanceof C.SourceBreakpoint).map(F=>F.id),v=w.filter(F=>F instanceof C.FunctionBreakpoint).map(F=>F.id),E=w.filter(F=>F instanceof C.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(_,v,E)}startDebugging(u,w,_){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,w,{parentSessionID:_.parentSession?_.parentSession.id:void 0,repl:_.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,w,_){if(!w)return new C.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:v,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,_,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,v),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(E=>E.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(u,w,_){if(!_)return new C.Disposable(()=>{});if(!this.definesDebugType(u,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:v,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,v),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(E=>E.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(u,w){if(!w)return new C.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:_,factory:w}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==w)})}async $runInTerminal(u,w){return Promise.resolve(void 0)}async $substituteVariables(u,w){if(!this._variableResolver){const[E,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(E||[],this._editorsService,F)}let _;const v=await this.getFolder(u);return v&&(_={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,w)}createDebugAdapter(u,w){if(u.type==="implementation")return new o(u.implementation)}createSignService(){}async $startDASession(u,w){const _=this,v=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const F=this.convertToDto(E),B=this.createDebugAdapter(F,v);if(!B)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const Y=B;return this._debugAdapters.set(u,Y),this.getDebugAdapterTrackers(v).then(fe=>(fe&&this._debugAdaptersTrackers.set(u,fe),Y.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const z=V,ee={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);ee.body={signature:$},Y.sendResponse(ee)}else throw new Error("no signer")}catch($){ee.success=!1,ee.message=$.message,Y.sendResponse(ee)}}else fe&&fe.onDidSendMessage&&fe.onDidSendMessage(V),V=(0,r.convertToVSCPaths)(V,!0),_._debugServiceProxy.$acceptDAMessage(u,V)}),Y.onError(V=>{fe&&fe.onError&&fe.onError(V),this._debugServiceProxy.$acceptDAError(u,V.name,V.message,V.stack)}),Y.onExit(V=>{fe&&fe.onExit&&fe.onExit((0,m.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,m.withNullAsUndefined)(V),void 0)}),fe&&fe.onWillStartSession&&fe.onWillStartSession(),Y.startSession()))})}$sendDAMessage(u,w){w=(0,r.convertToDAPaths)(w,!1);const _=this._debugAdaptersTrackers.get(u);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(w);const v=this._debugAdapters.get(u);v&&v.sendMessage(w)}$stopDASession(u){const w=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),w&&w.onWillStopSession&&w.onWillStopSession();const _=this._debugAdapters.get(u);return this._debugAdapters.delete(u),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const w=[],_=[],v=[];if(u.added)for(const E of u.added){const F=E.id;if(F&&!this._breakpoints.has(F)){let B;if(E.type==="function")B=new C.FunctionBreakpoint(E.functionName,E.enabled,E.condition,E.hitCondition,E.logMessage);else if(E.type==="data")B=new C.DataBreakpoint(E.label,E.dataId,E.canPersist,E.enabled,E.hitCondition,E.condition,E.logMessage);else{const Y=I.URI.revive(E.uri);B=new C.SourceBreakpoint(new C.Location(Y,new C.Position(E.line,E.character)),E.enabled,E.condition,E.hitCondition,E.logMessage)}B._id=F,this._breakpoints.set(F,B),w.push(B)}}if(u.removed)for(const E of u.removed){const F=this._breakpoints.get(E);F&&(this._breakpoints.delete(E),_.push(F))}if(u.changed){for(const E of u.changed)if(E.id){const F=this._breakpoints.get(E.id);if(F){if(F instanceof C.FunctionBreakpoint&&E.type==="function"){const B=F;B.enabled=E.enabled,B.condition=E.condition,B.hitCondition=E.hitCondition,B.logMessage=E.logMessage,B.functionName=E.functionName}else if(F instanceof C.SourceBreakpoint&&E.type==="source"){const B=F;B.enabled=E.enabled,B.condition=E.condition,B.hitCondition=E.hitCondition,B.logMessage=E.logMessage,B.location=new C.Location(I.URI.revive(E.uri),new C.Position(E.line,E.character))}v.push(F)}}}this.fireBreakpointChanges(w,_,v)}$provideDebugConfigurations(u,w,_){return(0,T.asPromise)(async()=>{const v=this.getConfigProviderByHandle(u);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const E=await this.getFolder(w);return v.provideDebugConfigurations(E,_)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(u,w,_,v){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(u);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(w);return E.resolveDebugConfiguration(F,_,v)})}$resolveDebugConfigurationWithSubstitutedVariables(u,w,_,v){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(u);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(w);return E.resolveDebugConfigurationWithSubstitutedVariables(F,_,v)})}async $provideDebugAdapter(u,w){const _=this.getAdapterDescriptorFactoryByHandle(u);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(w);return this.getAdapterDescriptor(_,v).then(E=>{if(!E)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(E)})}async $acceptDebugSessionStarted(u){const w=await this.getSession(u);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(u){const w=await this.getSession(u);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,w){const _=await this.getSession(u);_&&_._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(u,w){const v={session:await this.getSession(u),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(u){if(u instanceof C.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof C.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const w=this._adapterFactories.filter(_=>_.type===u);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(u){const w=this._adapterFactories.filter(_=>_.handle===u);if(w.length>0)return w[0].factory}getConfigProviderByHandle(u){const w=this._configProviders.filter(_=>_.handle===u);if(w.length>0)return w[0].provider}definesDebugType(u,w){if(u.contributes){const _=u.contributes.debuggers;if(_&&_.length>0){for(const v of _)if(v.label&&v.type&&v.type===w)return!0}}return!1}getDebugAdapterTrackers(u){const _=u.configuration.type,v=this._trackerFactories.filter(E=>E.type===_||E.type==="*").map(E=>(0,T.asPromise)(()=>E.factory.createDebugAdapterTracker(u)).then(F=>F,F=>null));return Promise.race([Promise.all(v).then(E=>{const F=E.filter(B=>!!B);if(F.length>0)return new i(F)}),new Promise((E,F)=>{const B=setTimeout(()=>{clearTimeout(B),F(new Error("timeout"))},1e3)})]).catch(E=>{})}async getAdapterDescriptor(u,w){const _=w.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new C.DebugAdapterServer(_));if(u){const E=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>u.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,E))).then(F=>{if(F)return F})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,v))}daExecutableFromPackage(u,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,w,_){(u.length>0||w.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:w,changed:_}))}async getSession(u){if(u)if(typeof u=="string"){const w=this._debugSessions.get(u);if(w)return w}else{let w=this._debugSessions.get(u.id);if(!w){const _=await this.getFolder(u.folderUri);w=new c(this._debugServiceProxy,u.id,u.type,u.name,_,u.configuration),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(u){if(u){const w=I.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};f=Ve([qe(0,l.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],f),e.ExtHostDebugServiceBase=f;class c{constructor(u,w,_,v,E,F){this._debugServiceProxy=u,this._id=w,this._type=_,this._name=v,this._workspaceFolder=E,this._configuration=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,w)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=c;class p{constructor(u){this.value=Object.freeze({append(w){u.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=p;class t extends d.AbstractVariableResolverService{constructor(u,w,_,v){super({getFolderUri:E=>{const F=u.filter(B=>B.name===E);if(F&&F.length>0)return F[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(E,F)=>_.getConfiguration(void 0,E).get(F),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(w){const E=w.activeEditor();if(E)return b.normalize(E.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(w&&v){const E=w.activeEditor();if(E){const F=v.getWorkspaceFolder(E.document.uri);if(F)return b.normalize(F.uri.fsPath)}}},getSelectedText:()=>{if(w){const E=w.activeEditor();if(E&&!E.selection.isEmpty)return E.document.getText(E.selection)}},getLineNumber:()=>{if(w){const E=w.activeEditor();if(E)return String(E.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=t;class i{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(w=>w.onError?w.onError(u):void 0)}onExit(u,w){this.trackers.forEach(_=>_.onExit?_.onExit(u,w):void 0)}}class o extends D.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(u,w,_,v,E){super(u,w,_,v,E)}createVariableResolver(u,w,_){return new t(u,w,_)}};a=Ve([qe(0,l.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,n.IExtHostExtensionService),qe(3,P.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],a),e.WorkerExtHostDebugService=a}),define(be[222],_e([0,1,80,2,5,34,33,26,14,27,4,35,46,18]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(f,c,p,t,i,o,a){this._apiFactory=f,this._extensionRegistry=c,this._instaService=p,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=o,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,c,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,c,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let c of f.nodeModuleName)this._factories.set(c,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(c=>f.alternativeModuleName(c))}};r=Ve([qe(2,n.IInstantiationService),qe(3,T.IExtHostConfiguration),qe(4,P.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,h.ILogService)],r),e.RequireInterceptor=r;class l{constructor(f,c,p,t,i){this._apiFactory=f,this._extensionPaths=c,this._extensionRegistry=p,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,c){const p=this._extensionPaths.findSubstr(c.fsPath);if(p){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(p.identifier));return t||(t=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(p.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,o)=>t+=`	${o} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(f,c){this.nodeModuleName="keytar";const{environment:p}=c,t=f.getProxy(A.MainContext.MainThreadKeytar);if(p.appRoot){let i=p.appRoot.fsPath;d.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,o)=>t.$getPassword(i,o),setPassword:(i,o,a)=>t.$setPassword(i,o,a),deletePassword:(i,o)=>t.$deletePassword(i,o),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(f,c){return this._impl}alternativeModuleName(f){const c=f.length;if(!(c<=7||!this.alternativeNames)){const p=c-7;if((f.charAt(p)==="/"||f.charAt(p)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}}};g=Ve([qe(0,D.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],g);let m=class{constructor(f,c,p){this._extensionPaths=f,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(A.MainContext.MainThreadTelemetry);const t=p.getProxy(A.MainContext.MainThreadWindow);this._impl=(i,o)=>{const a=I.URI.parse(i);return o?this.callOriginal(i,o):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,i,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,i,{}):this.callOriginal(i,o)}}load(f,c,p){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=p(f),this._impl}callOriginal(f,c){return this.sendNoForwardTelemetry(),this._original(f,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ve([qe(2,D.IExtHostRpcService)],m)}),define(be[223],_e([0,1,11,12,80,6,2,5,215,18,61,65,27,152,14,71,35,40]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(c,p,t,i){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const o=new D.RPCProtocol(c,null,i);p=S._transform(p,o);const a=new P.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());a.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},p)),a.set(r.IExtHostRpcService,new r.ExtHostRpcService(o)),a.set(l.IURITransformerService,new l.URITransformerService(i)),a.set(g.IHostUtils,t);const s=new h.InstantiationService(a,!0),u=s.invokeFunction(E=>E.get(m.IExtHostTerminalService));this._disposables.add(u),this._logService=s.invokeFunction(E=>E.get(k.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",p),this._extensionService=s.invokeFunction(E=>E.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(E=>{Error.prepareStackTrace=(F,B)=>{let Y="",fe,V;for(const z of B)Y+=`
	at ${z.toString()}`,V=z.getFileName(),!fe&&V&&(fe=E.findSubstr(V));return w.set(F,fe),`${F.name||"Error"}: ${F.message||""}${Y}`}});const _=o.getProxy(C.MainContext.MainThreadExtensionService),v=o.getProxy(C.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(E=>{const F=I.transformErrorForSerialization(E),B=w.get(E);B?_.$onExtensionRuntimeError(B.identifier,F):v.$onUnexpectedError(F)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const p=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),p]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,p){c.extensions.forEach(i=>i.extensionLocation=y.URI.revive(p.transformIncomingURIs(i.extensionLocation))),c.environment.appRoot=y.URI.revive(p.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(i=>y.URI.revive(p.transformIncomingURIs(i)))),c.environment.extensionTestsLocationURI=y.URI.revive(p.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=y.URI.revive(p.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=y.URI.revive(p.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=y.URI.revive(p.transformIncomingURIs(c.logsLocation)),c.logFile=y.URI.revive(p.transformIncomingURIs(c.logFile)),c.workspace=p.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=S}),define(be[224],_e([0,1,13,20,60,28,25,55,41]),function(Q,e,b,I,A,T,y,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(d,h,r){this.config=d,this.provider=h,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const h=this.config.folderQueries||[];return new Promise((r,l)=>{const g=m=>{this.resultCount++,d(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const S=m.toString(),f=b.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,f)||this.matchFile(g,{base:m,basename:f})}),Promise.all(h.map(m=>this.searchInFolder(m,g))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{l(new Error((0,A.toErrorMessage)(m)))})})}async searchInFolder(d,h){const r=new I.CancellationTokenSource,l=this.getSearchOptionsForFolder(d),g=this.initDirectoryTree(),m=new D.QueryGlobTester(this.config,d),S=!m.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(r),f=C.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,r.token),p=f.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(i=>{const o=b.posix.relative(d.folder.path,i.path);if(S){const a=b.basename(i.path);this.matchFile(h,{base:d.folder,relativePath:o,basename:a});return}this.addDirectoryEntries(g,d.folder,o,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,m,h),{providerTime:p,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,D.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},h,r,l){if(r===this.filePattern){const m=b.basename(this.filePattern);this.matchFile(l,{base:h,relativePath:this.filePattern,basename:m})}function g(m){const S=b.basename(m),f=b.dirname(m);let c=d[f];c||(c=d[f]=[],g(f)),c.push({base:h,relativePath:m,basename:S})}g(r)}matchDirectoryTree({rootEntries:d,pathToEntries:h},r,l){const g=this,m=this.filePattern;function S(f){const c=T.hasSiblingFn(()=>f.map(p=>p.basename));for(let p=0,t=f.length;p<t;p++){const i=f[p],{relativePath:o,basename:a}=i;if(!!r.includedInQuerySync(o,a,m!==a?c:void 0)){const s=h[o];if(s)S(s);else{if(o===m)continue;g.matchFile(l,i)}if(g.isLimitHit)break}}}S(d)}matchFile(d,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(h))}}class n{constructor(){this.sessions=new Map}fileSearch(d,h,r,l){const g=this.getSessionTokenSource(d.cacheKey),m=new k(d,h,g&&g.token);let S=0;const f=c=>{S+=c.length,r(c.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(m,n.BATCH_SIZE,f,l).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:c.stats}}))}clearCache(d){const h=this.getSessionTokenSource(d);h&&h.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new I.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:y.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,h,r,l){l.onCancellationRequested(()=>{d.cancel()});const g=S=>{S&&(m.push(S),h>0&&m.length>=h&&(r(m),m=[]))};let m=[];return d.search(g).then(S=>(m.length&&r(m),S),S=>(m.length&&r(m),Promise.reject(S)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(be[225],_e([0,1,13,15,20,60,25,28,2,41,19,10]),function(Q,e,b,I,A,T,y,C,D,k,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(f,c,p){this.query=f,this.provider=c,this.fileUtils=p,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,c){const p=this.query.folderQueries||[],t=new A.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((i,o)=>{this.collector=new r(f);let a=!1;const s=(u,w)=>{if(!a&&!this.isLimitHit){const _=this.resultSize(u);g(u)&&typeof this.query.maxResults=="number"&&this.resultCount+_>this.query.maxResults&&(this.isLimitHit=!0,a=!0,t.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const v=this.resultSize(u);this.resultCount+=v,(v>0||!g(u))&&this.collector.add(u,w)}};Promise.all(p.map((u,w)=>this.searchInFolder(u,_=>s(_,w),t.token))).then(u=>{t.dispose(),this.collector.flush();const w=u.some(_=>!!_&&!!_.limitHit);i({limitHit:this.isLimitHit||w,messages:(0,I.flatten)(u.map(_=>(_==null?void 0:_.message)?(0,P.isArray)(_.message)?_.message:[_.message]:[])),stats:{type:"textSearchProvider"}})},u=>{t.dispose();const w=(0,T.toErrorMessage)(u);o(new Error(w))})})}resultSize(f){return g(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,c){const p=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:p.slice(0,c),preview:{matches:t.slice(0,c),text:f.preview.text},uri:f.uri}}async searchInFolder(f,c,p){const t=new k.QueryGlobTester(this.query,f),i=[],o={report:u=>{if(!!this.validateProviderResult(u)){const w=f.folder.scheme===n.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(u.uri))):void 0,_=y.relativePath(f.folder,u.uri);_&&i.push(t.includedInQuery(_,b.basename(_),w).then(v=>{v&&c(u)}))}}},a=this.getSearchOptionsForFolder(f),s=await this.provider.provideTextSearchResults(h(this.query.contentPattern),a,o,p);return await Promise.all(i),s}validateProviderResult(f){if(g(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const c=(0,k.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),p=(0,k.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),t={folder:D.URI.from(f.folder),excludes:p,includes:c,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function h(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class r{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,c=>this.sendItems(c))}add(f,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!y.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(l(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=r;function l(S){return g(S)?{preview:{matches:(0,I.mapArrayOrNot)(S.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:S.preview.text},ranges:(0,I.mapArrayOrNot)(S.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function g(S){return!!S.preview}e.extensionResultIsMatch=g;class m{constructor(f,c){this.maxBatchSize=f,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,c){!f||this.addItemToBatch(f,c)}addItems(f,c){!f||this.addItemsToBatch(f,c)}addItemToBatch(f,c){this.batch.push(f),this.batchSize+=c,this.onUpdate()}addItemsToBatch(f,c){this.batch=this.batch.concat(f),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(be[105],_e([0,1,6,5,4,224,14,71,18,2,225]),function(Q,e,b,I,A,T,y,C,D,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let P=class{constructor(l,g,m){this.extHostRpc=l,this._uriTransformer=g,this._logService=m,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,g){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const m=this._handlePool++;return this._textSearchProvider.set(m,g),this._proxy.$registerTextSearchProvider(m,this._transformScheme(l)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(l,g){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const m=this._handlePool++;return this._fileSearchProvider.set(m,g),this._proxy.$registerFileSearchProvider(m,this._transformScheme(l)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(l,g,m,S){const f=d(m),c=this._fileSearchProvider.get(l);if(c)return this._fileSearchManager.fileSearch(f,c,p=>{this._proxy.$handleFileMatch(l,g,p.map(t=>t.resource))},S);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,g,m,S){const f=this._textSearchProvider.get(l);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const c=d(m);return this.createTextSearchManager(c,f).search(t=>this._proxy.$handleTextMatch(l,g,t),S)}createTextSearchManager(l,g){return new n.TextSearchManager(l,g,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};P=Ve([qe(0,y.IExtHostRpcService),qe(1,C.IURITransformerService),qe(2,D.ILogService)],P),e.ExtHostSearch=P;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(h),extraFileResources:r.extraFileResources&&r.extraFileResources.map(l=>k.URI.revive(l))})}e.reviveQuery=d;function h(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(be[226],_e([0,1,130,20,12,3,47,2,123,85,117,59,64,5,191,190,76,192,34,193,194,195,177,196,39,35,197,178,199,200,201,100,181,204,205,206,78,40,207,182,9,7,210,50,101,30,33,51,167,198,93,99,103,104,105,18,71,14,27,202,165,70,75,188,208,164,79,77,213,211,212,189,49,219,209,74,161,94,203,67,102]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f,c,p,t,i,o,a,s,u,w,_,v,E,F,B,Y,fe,V,z,ee,$,R,L,M,U,G,X,se,pe,Te,xe,Ae,We,x,q,ne,le,me,Se,Oe,ge,Ce,Pe,$e,Ee,je,H,te,ve,Le,He,Ue,Xe,W,ie,ce,j,Z,ae,he,ye,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Be(Ne){const Ge=Ne.get(Oe.IExtHostInitDataService),nt=Ne.get(W.IExtHostFileSystemInfo),dt=Ne.get(ve.IExtHostConsumerFileSystem),it=Ne.get(a.IExtHostExtensionService),Je=Ne.get(X.IExtHostWorkspace),mt=Ne.get(ae.IExtHostTelemetry),wt=Ne.get(S.IExtHostConfiguration),we=Ne.get(me.IURITransformerService),de=Ne.get(Se.IExtHostRpcService),oe=Ne.get(V.IExtHostStorage),K=Ne.get(te.IExtensionStoragePaths),Re=Ne.get(le.ILogService),Ie=Ne.get(Pe.IExtHostTunnelService),Qe=Ne.get($e.IExtHostApiDeprecationService),Ze=Ne.get(G.IExtHostWindow),ut=Ne.get(j.IExtHostSecretState);de.set(h.ExtHostContext.ExtHostFileSystemInfo,nt),de.set(h.ExtHostContext.ExtHostLogService,Re),de.set(h.ExtHostContext.ExtHostWorkspace,Je),de.set(h.ExtHostContext.ExtHostConfiguration,wt),de.set(h.ExtHostContext.ExtHostExtensionService,it),de.set(h.ExtHostContext.ExtHostStorage,oe),de.set(h.ExtHostContext.ExtHostTunnelService,Ie),de.set(h.ExtHostContext.ExtHostWindow,Ze),de.set(h.ExtHostContext.ExtHostSecretState,ut),de.set(h.ExtHostContext.ExtHostTelemetry,mt);const ht=de.set(h.ExtHostContext.ExtHostDecorations,Ne.get(We.IExtHostDecorations)),Ye=de.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Ne.get(o.IExtHostDocumentsAndEditors)),ot=de.set(h.ExtHostContext.ExtHostCommands,Ne.get(g.IExtHostCommands)),ft=de.set(h.ExtHostContext.ExtHostTerminalService,Ne.get(z.IExtHostTerminalService)),at=de.set(h.ExtHostContext.ExtHostDebugService,Ne.get(q.IExtHostDebugService)),Et=de.set(h.ExtHostContext.ExtHostSearch,Ne.get(ne.IExtHostSearch)),vt=de.set(h.ExtHostContext.ExtHostTask,Ne.get(x.IExtHostTask)),Ct=de.set(h.ExtHostContext.ExtHostOutputService,Ne.get(E.IExtHostOutputService)),Pt=de.set(h.ExtHostContext.ExtHostEditorTabs,new Z.ExtHostEditorTabs),At=de.set(h.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(de)),_t=de.set(h.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(de,Ye)),Qt=de.set(h.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(de,Ye,Re)),Yt=de.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Re,_t,de.getProxy(h.MainContext.MainThreadBulkEdits))),gt=de.set(h.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(de,ot,Ye,_t,Re,K)),Jt=de.set(h.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(de,Ge,gt)),St=de.set(h.ExtHostContext.ExtHostEditors,new ee.ExtHostEditors(de,Ye)),Vt=de.set(h.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(de.getProxy(h.MainContext.MainThreadTreeViews),ot,Re)),Xt=de.set(h.ExtHostContext.ExtHostEditorInsets,new Te.ExtHostEditorInsets(de.getProxy(h.MainContext.MainThreadEditorInsets),St,Ge.environment)),jt=de.set(h.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(de,Re)),lt=de.set(h.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(de,we,_t,ot,jt,Re,Qe)),Zt=de.set(h.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(de,lt)),Tt=de.set(h.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(de,Re,Ye)),Bt=de.set(h.ExtHostContext.ExtHostQuickOpen,(0,B.createExtHostQuickOpen)(de,Je,ot)),cn=de.set(h.ExtHostContext.ExtHostSCM,new Y.ExtHostSCM(de,ot,Re)),wn=de.set(h.ExtHostContext.ExtHostComments,new m.ExtHostComments(de,ot,_t)),dn=de.set(h.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(de.getProxy(h.MainContext.MainThreadProgress))),en=de.set(h.ExtHostContext.ExtHosLabelService,new xe.ExtHostLabelService(de)),qt=de.set(h.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(de)),Ot=de.set(h.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(de)),bn=de.set(h.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(de,ot)),tn=de.set(h.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(de,Ge.environment,Je,Re,Qe)),nn=de.set(h.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(de,tn,Je)),Kt=de.set(h.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(de,_t,K,tn,nn)),_n=de.set(h.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(de,tn)),Rt=de.set(h.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(de,Ye,Je)),rn=de.set(h.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(de)),En=(0,pe.values)(h.ExtHostContext);de.assertRegistered(En);const xt=new Xe.ExtHostBulkEdits(de,Ye),sn=new l.ExtHostClipboard(de),Nt=new v.ExtHostMessageService(de,Re),Ft=new c.ExtHostDialogs(de),hn=new fe.ExtHostStatusBar(de,ot.converter),$t=new _.ExtHostLanguages(de,_t);return r.ExtHostApiCommands.register(ot),function(Fe,on,an){const pt=function(){let J=!Fe.isUnderDevelopment;function ue(ke){J||(Re.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")ue(rt);else{const bt=rt;typeof bt.scheme=="undefined"&&ue(rt),!Fe.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,se.throwProposedApiError)(Fe)}return rt}}(),yn={getSession(J,ue,ke){return Ot.getSession(Fe,J,ue,ke)},get onDidChangeSessions(){return Ot.onDidChangeSessions},registerAuthenticationProvider(J,ue,ke,rt){return Ot.registerAuthenticationProvider(J,ue,ke,rt)},get onDidChangeAuthenticationProviders(){return(0,se.checkProposedApiEnabled)(Fe),Ot.onDidChangeAuthenticationProviders},get providers(){return(0,se.checkProposedApiEnabled)(Fe),Ot.providers},logout(J,ue){return(0,se.checkProposedApiEnabled)(Fe),Ot.removeSession(J,ue)}},Sn={registerCommand(J,ue,ke){return ot.registerCommand(!0,J,ue,ke)},registerTextEditorCommand(J,ue,ke){return ot.registerCommand(!0,J,(...rt)=>{const bt=St.getActiveTextEditor();if(!bt){Re.warn("Cannot execute "+J+" because there is no active text editor.");return}return bt.edit(N=>{ue.apply(ke,[bt,N,...rt])}).then(N=>{N||Re.warn("Edits from command "+J+" were not applied.")},N=>{Re.warn("An error occurred while running command "+J,N)})})},registerDiffInformationCommand:(J,ue,ke)=>((0,se.checkProposedApiEnabled)(Fe),ot.registerCommand(!0,J,async(...rt)=>{const bt=Ye.activeEditor(!0);if(!bt){Re.warn("Cannot execute "+J+" because there is no active text editor.");return}const N=await St.getDiffInformation(bt.id);ue.apply(ke,[N,...rt])})),executeCommand(J,...ue){return ot.executeCommand(J,...ue)},getCommands(J=!1){return ot.getCommands(J)}},fn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var J,ue;return(ue=(J=Ge.environment.appRoot)===null||J===void 0?void 0:J.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return ft.getDefaultShell(!1,an)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ue){return Ze.openUri(J,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(J){return J.scheme===Ge.environment.appUriScheme?At.createAppUri(J):Ze.asExternalUri(J,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Ae.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(fn);const Gt=Ge.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Dn={registerTestController(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.registerTestController(Fe.identifier.value,J)},createDocumentTestObserver(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.createTextDocumentTestObserver(J)},createWorkspaceTestObserver(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.createWorkspaceTestObserver(J)},runTests(J){return(0,se.checkProposedApiEnabled)(Fe),Rt.runTests(J)},createTestItem(J,ue){return new L.TestItemImpl(J.id,J.label,J.uri,ue)},createTestRunTask(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),Rt.createTestRunTask(Fe.identifier.value,J,ue,ke)},get onDidChangeTestResults(){return(0,se.checkProposedApiEnabled)(Fe),Rt.onResultsChanged},get testResults(){return(0,se.checkProposedApiEnabled)(Fe),Rt.results}},Cn={getExtension(J){const ue=on.getExtensionDescription(J);if(ue)return new a.Extension(it,Fe.identifier,ue,Gt)},get all(){return on.getAllExtensionDescriptions().map(J=>new a.Extension(it,Fe.identifier,J,Gt))},get onDidChange(){return on.onDidChange}},kn={createDiagnosticCollection(J){return jt.createDiagnosticCollection(Fe.identifier,J)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:J=>jt.getDiagnostics(J),getLanguages(){return $t.getLanguages()},setTextDocumentLanguage(J,ue){return $t.changeLanguage(J.uri,ue)},match(J,ue){return(0,P.score)(R.LanguageSelector.from(J),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(J,ue,ke){return lt.registerCodeActionProvider(Fe,pt(J),ue,ke)},registerCodeLensProvider(J,ue){return lt.registerCodeLensProvider(Fe,pt(J),ue)},registerDefinitionProvider(J,ue){return lt.registerDefinitionProvider(Fe,pt(J),ue)},registerDeclarationProvider(J,ue){return lt.registerDeclarationProvider(Fe,pt(J),ue)},registerImplementationProvider(J,ue){return lt.registerImplementationProvider(Fe,pt(J),ue)},registerTypeDefinitionProvider(J,ue){return lt.registerTypeDefinitionProvider(Fe,pt(J),ue)},registerHoverProvider(J,ue){return lt.registerHoverProvider(Fe,pt(J),ue,Fe.identifier)},registerEvaluatableExpressionProvider(J,ue){return lt.registerEvaluatableExpressionProvider(Fe,pt(J),ue,Fe.identifier)},registerInlineValuesProvider(J,ue){return lt.registerInlineValuesProvider(Fe,pt(J),ue,Fe.identifier)},registerDocumentHighlightProvider(J,ue){return lt.registerDocumentHighlightProvider(Fe,pt(J),ue)},registerLinkedEditingRangeProvider(J,ue){return lt.registerLinkedEditingRangeProvider(Fe,pt(J),ue)},registerReferenceProvider(J,ue){return lt.registerReferenceProvider(Fe,pt(J),ue)},registerRenameProvider(J,ue){return lt.registerRenameProvider(Fe,pt(J),ue)},registerDocumentSymbolProvider(J,ue,ke){return lt.registerDocumentSymbolProvider(Fe,pt(J),ue,ke)},registerWorkspaceSymbolProvider(J){return lt.registerWorkspaceSymbolProvider(Fe,J)},registerDocumentFormattingEditProvider(J,ue){return lt.registerDocumentFormattingEditProvider(Fe,pt(J),ue)},registerDocumentRangeFormattingEditProvider(J,ue){return lt.registerDocumentRangeFormattingEditProvider(Fe,pt(J),ue)},registerOnTypeFormattingEditProvider(J,ue,ke,...rt){return lt.registerOnTypeFormattingEditProvider(Fe,pt(J),ue,[ke].concat(rt))},registerDocumentSemanticTokensProvider(J,ue,ke){return lt.registerDocumentSemanticTokensProvider(Fe,pt(J),ue,ke)},registerDocumentRangeSemanticTokensProvider(J,ue,ke){return lt.registerDocumentRangeSemanticTokensProvider(Fe,pt(J),ue,ke)},registerSignatureHelpProvider(J,ue,ke,...rt){return typeof ke=="object"?lt.registerSignatureHelpProvider(Fe,pt(J),ue,ke):lt.registerSignatureHelpProvider(Fe,pt(J),ue,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(J,ue,...ke){return lt.registerCompletionItemProvider(Fe,pt(J),ue,ke)},registerDocumentLinkProvider(J,ue){return lt.registerDocumentLinkProvider(Fe,pt(J),ue)},registerColorProvider(J,ue){return lt.registerColorProvider(Fe,pt(J),ue)},registerFoldingRangeProvider(J,ue){return lt.registerFoldingRangeProvider(Fe,pt(J),ue)},registerSelectionRangeProvider(J,ue){return lt.registerSelectionRangeProvider(Fe,J,ue)},registerCallHierarchyProvider(J,ue){return lt.registerCallHierarchyProvider(Fe,J,ue)},setLanguageConfiguration:(J,ue)=>lt.setLanguageConfiguration(Fe,J,ue),getTokenInformationAtPosition(J,ue){return(0,se.checkProposedApiEnabled)(Fe),$t.tokenAtPosition(J,ue)},registerInlineHintsProvider(J,ue){return(0,se.checkProposedApiEnabled)(Fe),lt.registerInlineHintsProvider(Fe,J,ue)}},In={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(J,ue,ke){const rt=await(C.URI.isUri(J)?Promise.resolve(mn.openTextDocument(J)):Promise.resolve(J));return St.showTextDocument(rt,ue,ke)},createTextEditorDecorationType(J){return St.createTextEditorDecorationType(J)},onDidChangeActiveTextEditor(J,ue,ke){return St.onDidChangeActiveTextEditor(J,ue,ke)},onDidChangeVisibleTextEditors(J,ue,ke){return St.onDidChangeVisibleTextEditors(J,ue,ke)},onDidChangeTextEditorSelection(J,ue,ke){return St.onDidChangeTextEditorSelection(J,ue,ke)},onDidChangeTextEditorOptions(J,ue,ke){return St.onDidChangeTextEditorOptions(J,ue,ke)},onDidChangeTextEditorVisibleRanges(J,ue,ke){return St.onDidChangeTextEditorVisibleRanges(J,ue,ke)},onDidChangeTextEditorViewColumn(J,ue,ke){return St.onDidChangeTextEditorViewColumn(J,ue,ke)},onDidCloseTerminal(J,ue,ke){return ft.onDidCloseTerminal(J,ue,ke)},onDidOpenTerminal(J,ue,ke){return ft.onDidOpenTerminal(J,ue,ke)},onDidChangeActiveTerminal(J,ue,ke){return ft.onDidChangeActiveTerminal(J,ue,ke)},onDidChangeTerminalDimensions(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),ft.onDidChangeTerminalDimensions(J,ue,ke)},onDidWriteTerminalData(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),ft.onDidWriteTerminalData(J,ue,ke)},get state(){return Ze.state},onDidChangeWindowState(J,ue,ke){return Ze.onDidChangeWindowState(J,ue,ke)},showInformationMessage(J,...ue){return Nt.showMessage(Fe,y.default.Info,J,ue[0],ue.slice(1))},showWarningMessage(J,...ue){return Nt.showMessage(Fe,y.default.Warning,J,ue[0],ue.slice(1))},showErrorMessage(J,...ue){return Nt.showMessage(Fe,y.default.Error,J,ue[0],ue.slice(1))},showQuickPick(J,ue,ke){return Bt.showQuickPick(J,!!Fe.enableProposedApi,ue,ke)},showWorkspaceFolderPick(J){return Bt.showWorkspaceFolderPick(J)},showInputBox(J,ue){return Bt.showInput(J,ue)},showOpenDialog(J){return Ft.showOpenDialog(J)},showSaveDialog(J){return Ft.showSaveDialog(J)},createStatusBarItem(J,ue){let ke,rt,bt,N;return J&&typeof J!="number"?(ke=J.id,rt=J.name,bt=J.alignment,ue=J.priority,N=J.accessibilityInformation):(ke=Fe.identifier.value,rt=b.localize(0,null,Fe.displayName||Fe.name),bt=J),hn.createStatusBarEntry(ke,rt,bt,ue,N)},setStatusBarMessage(J,ue){return hn.setStatusBarMessage(J,ue)},withScmProgress(J){return Qe.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),dn.withProgress(Fe,{location:L.ProgressLocation.SourceControl},(ue,ke)=>J({report(rt){}}))},withProgress(J,ue){return dn.withProgress(Fe,J,ue)},createOutputChannel(J){return Ct.createOutputChannel(J)},createWebviewPanel(J,ue,ke,rt){return nn.createWebviewPanel(Fe,J,ue,ke,rt)},createWebviewTextEditorInset(J,ue,ke,rt){return(0,se.checkProposedApiEnabled)(Fe),Xt.createWebviewEditorInset(J,ue,ke,rt,Fe)},createTerminal(J,ue,ke){return typeof J=="object"?"pty"in J?ft.createExtensionTerminal(J):(J.message&&(0,se.checkProposedApiEnabled)(Fe),J.icon&&(0,se.checkProposedApiEnabled)(Fe),ft.createTerminalFromOptions(J)):ft.createTerminal(J,ue,ke)},registerTerminalLinkProvider(J){return ft.registerLinkProvider(J)},registerTreeDataProvider(J,ue){return Vt.registerTreeDataProvider(J,ue,Fe)},createTreeView(J,ue){return Vt.createTreeView(J,ue,Fe)},registerWebviewPanelSerializer:(J,ue)=>nn.registerWebviewPanelSerializer(Fe,J,ue),registerCustomEditorProvider:(J,ue,ke={})=>Kt.registerCustomEditorProvider(Fe,J,ue,ke),registerFileDecorationProvider(J){return ht.registerFileDecorationProvider(J,Fe.identifier)},registerUriHandler(J){return At.registerUriHandler(Fe.identifier,J)},createQuickPick(){return Bt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Bt.createInputBox(Fe.identifier)},get activeColorTheme(){return qt.activeColorTheme},onDidChangeActiveColorTheme(J,ue,ke){return qt.onDidChangeActiveColorTheme(J,ue,ke)},registerWebviewViewProvider(J,ue,ke){return _n.registerWebviewViewProvider(Fe,J,ue,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,se.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(J,ue,ke)},get visibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorSelection(J,ue,ke)},onDidChangeNotebookEditorVisibleRanges(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorVisibleRanges(J,ue,ke)},showNotebookDocument(J,ue){return(0,se.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(J,ue)},registerExternalUriOpener(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),rn.registerExternalUriOpener(Fe.identifier,J,ue,ke)},get openEditors(){return(0,se.checkProposedApiEnabled)(Fe),Pt.tabs},get onDidChangeOpenEditors(){return(0,se.checkProposedApiEnabled)(Fe),Pt.onDidChangeTabs}},mn={get rootPath(){return Qe.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Je.getPath()},set rootPath(J){throw A.readonly()},getWorkspaceFolder(J){return Je.getWorkspaceFolder(J)},get workspaceFolders(){return Je.getWorkspaceFolders()},get name(){return Je.name},set name(J){throw A.readonly()},get workspaceFile(){return Je.workspaceFile},set workspaceFile(J){throw A.readonly()},updateWorkspaceFolders:(J,ue,...ke)=>Je.updateWorkspaceFolders(Fe,J,ue||0,...ke),onDidChangeWorkspaceFolders:function(J,ue,ke){return Je.onDidChangeWorkspace(J,ue,ke)},asRelativePath:(J,ue)=>Je.getRelativePath(J,ue),findFiles:(J,ue,ke,rt)=>Je.findFiles(R.GlobPattern.from(J),R.GlobPattern.from(ue),ke,Fe.identifier,rt),findTextInFiles:(J,ue,ke,rt)=>{let bt,N;return typeof ue=="object"?(bt=ue,N=ke):(bt={},N=ue,rt=ke),Je.findTextInFiles(J,bt||{},N,Fe.identifier,rt)},saveAll:J=>Je.saveAll(J),applyEdit(J){return xt.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ue,ke,rt)=>Tt.createFileSystemWatcher(R.GlobPattern.from(J),ue,ke,rt),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw A.readonly()},openTextDocument(J){let ue;const ke=J;if(typeof J=="string")ue=Promise.resolve(C.URI.file(J));else if(C.URI.isUri(J))ue=Promise.resolve(J);else if(!ke||typeof ke=="object")ue=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>_t.ensureDocumentData(rt).then(bt=>bt.document))},onDidOpenTextDocument:(J,ue,ke)=>_t.onDidAddDocument(J,ue,ke),onDidCloseTextDocument:(J,ue,ke)=>_t.onDidRemoveDocument(J,ue,ke),onDidChangeTextDocument:(J,ue,ke)=>_t.onDidChangeDocument(J,ue,ke),onDidSaveTextDocument:(J,ue,ke)=>_t.onDidSaveDocument(J,ue,ke),onWillSaveTextDocument:(J,ue,ke)=>Yt.getOnWillSaveTextDocumentEvent(Fe)(J,ue,ke),onDidChangeConfiguration:(J,ue,ke)=>an.onDidChangeConfiguration(J,ue,ke),getConfiguration(J,ue){return ue=arguments.length===1?void 0:ue,an.getConfiguration(J,ue,Fe)},registerTextDocumentContentProvider(J,ue){return Qt.registerTextDocumentContentProvider(J,ue)},registerTaskProvider:(J,ue)=>(Qe.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Fe,J,ue)),registerFileSystemProvider(J,ue,ke){return Zt.registerFileSystemProvider(Fe.identifier,J,ue,ke)},get fs(){return dt.value},registerFileSearchProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),Et.registerFileSearchProvider(J,ue)),registerTextSearchProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),Et.registerTextSearchProvider(J,ue)),registerRemoteAuthorityResolver:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),it.registerRemoteAuthorityResolver(J,ue)),registerResourceLabelFormatter:J=>((0,se.checkProposedApiEnabled)(Fe),en.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ue,ke)=>Tt.onDidCreateFile(J,ue,ke),onDidDeleteFiles:(J,ue,ke)=>Tt.onDidDeleteFile(J,ue,ke),onDidRenameFiles:(J,ue,ke)=>Tt.onDidRenameFile(J,ue,ke),onWillCreateFiles:(J,ue,ke)=>Tt.getOnWillCreateFileEvent(Fe)(J,ue,ke),onWillDeleteFiles:(J,ue,ke)=>Tt.getOnWillDeleteFileEvent(Fe)(J,ue,ke),onWillRenameFiles:(J,ue,ke)=>Tt.getOnWillRenameFileEvent(Fe)(J,ue,ke),openTunnel:J=>((0,se.checkProposedApiEnabled)(Fe),Ie.openTunnel(Fe,J).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,se.checkProposedApiEnabled)(Fe),Ie.getTunnels()},onDidChangeTunnels:(J,ue,ke)=>((0,se.checkProposedApiEnabled)(Fe),Ie.onDidChangeTunnels(J,ue,ke)),registerPortAttributesProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),Ie.registerPortsAttributesProvider(J,ue)),registerTimelineProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),bn.registerTimelineProvider(J,ue,Fe.identifier,ot.converter)),get isTrusted(){return Je.trusted},requestWorkspaceTrust:J=>((0,se.checkProposedApiEnabled)(Fe),Je.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ue,ke)=>Je.onDidGrantWorkspaceTrust(J,ue,ke)},gn={get inputBox(){return Qe.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(Fe)},createSourceControl(J,ue,ke){return cn.createSourceControl(Fe,J,ue,ke)}},pn={createCommentController(J,ue){return wn.createCommentController(Fe,J,ue)}},Ut={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(J,ue,ke){return at.onDidStartDebugSession(J,ue,ke)},onDidTerminateDebugSession(J,ue,ke){return at.onDidTerminateDebugSession(J,ue,ke)},onDidChangeActiveDebugSession(J,ue,ke){return at.onDidChangeActiveDebugSession(J,ue,ke)},onDidReceiveDebugSessionCustomEvent(J,ue,ke){return at.onDidReceiveDebugSessionCustomEvent(J,ue,ke)},onDidChangeBreakpoints(J,ue,ke){return at.onDidChangeBreakpoints(J,ue,ke)},registerDebugConfigurationProvider(J,ue,ke){return at.registerDebugConfigurationProvider(J,ue,ke||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ue){return at.registerDebugAdapterDescriptorFactory(Fe,J,ue)},registerDebugAdapterTrackerFactory(J,ue){return at.registerDebugAdapterTrackerFactory(J,ue)},startDebugging(J,ue,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(J,ue,{parentSession:ke}):at.startDebugging(J,ue,ke||{})},stopDebugging(J){return at.stopDebugging(J)},addBreakpoints(J){return at.addBreakpoints(J)},removeBreakpoints(J){return at.removeBreakpoints(J)},asDebugSourceUri(J,ue){return at.asDebugSourceUri(J,ue)}},Wt={registerTaskProvider:(J,ue)=>vt.registerTaskProvider(Fe,J,ue),fetchTasks:J=>vt.fetchTasks(J),executeTask:J=>vt.executeTask(Fe,J),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(J,ue,ke)=>vt.onDidStartTask(J,ue,ke),onDidEndTask:(J,ue,ke)=>vt.onDidEndTask(J,ue,ke),onDidStartTaskProcess:(J,ue,ke)=>vt.onDidStartTaskProcess(J,ue,ke),onDidEndTaskProcess:(J,ue,ke)=>vt.onDidEndTaskProcess(J,ue,ke)},Pn={openNotebookDocument:J=>((0,se.checkProposedApiEnabled)(Fe),gt.openNotebookDocument(J)),get onDidOpenNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,se.checkProposedApiEnabled)(Fe),gt.notebookDocuments.map(J=>J.apiNotebook)},registerNotebookSerializer(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.registerNotebookSerializer(Fe,J,ue,ke)},registerNotebookContentProvider:(J,ue,ke)=>((0,se.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,J,ue,ke)),registerNotebookCellStatusBarItemProvider:(J,ue)=>((0,se.checkProposedApiEnabled)(Fe),gt.registerNotebookCellStatusBarItemProvider(Fe,J,ue)),createNotebookEditorDecorationType(J){return(0,se.checkProposedApiEnabled)(Fe),gt.createNotebookEditorDecorationType(J)},onDidChangeNotebookDocumentMetadata(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookDocumentMetadata(J,ue,ke)},onDidChangeNotebookCells(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(J,ue,ke)},onDidChangeCellExecutionState(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(J,ue,ke)},onDidChangeCellOutputs(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(J,ue,ke)},onDidChangeCellMetadata(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(J,ue,ke)},createConcatTextDocument(J,ue){return(0,se.checkProposedApiEnabled)(Fe),new H.ExtHostNotebookConcatDocument(gt,_t,J,ue)},createNotebookCellExecutionTask(J,ue,ke){return(0,se.checkProposedApiEnabled)(Fe),gt.createNotebookCellExecution(J,ue,ke)},createNotebookController(J,ue,ke,rt,bt){return(0,se.checkProposedApiEnabled)(Fe),Jt.createNotebookController(Fe,J,ue,ke,rt,bt)}};return{version:Ge.version,authentication:yn,commands:Sn,comments:pn,debug:Ut,env:fn,extensions:Cn,languages:kn,notebook:Pn,scm:gn,tasks:Wt,test:Dn,window:In,workspace:mn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:d.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:n.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:C.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlineHint:L.InlineHint,InlineHintKind:L.InlineHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ze.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Be}),define(be[227],_e([0,1,61,100,30,99,34,76,39,40,103,104,105,79,78,70,75,101,77,49,74,94]),function(Q,e,b,I,A,T,y,C,D,k,n,P,d,h,r,l,g,m,S,f,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,b.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,b.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,b.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,b.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo),(0,b.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,b.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,b.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,b.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,b.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,b.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,b.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,b.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,b.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,b.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry)}),define(be[228],_e([0,1,226,35,222,7,11,5]),function(Q,e,b,I,A,T,y,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var l;const g=(l=self.trustedTypes)===null||l===void 0?void 0:l.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...f)=>{f.forEach(i=>{var o;if(!((o=self.trustedTypes)===null||o===void 0?void 0:o.isScript(i)))throw new Error("TrustedScripts only, please")});const c=f.slice(0,-1).join(","),p=f.pop().toString();return`(function anonymous(${c}) {
${p}
})`}});function m(...S){return g?self.eval(g.createScript("",...S)):new Function(...S)}r.create=m})(k||(k={}));class n extends A.RequireInterceptor{_installInterceptor(){}getModule(l,g){for(let m of this._alternatives){let S=m(l);if(S){l=S;break}}if(this._factories.has(l))return this._factories.get(l).load(l,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);h(l,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(b.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,g,m){var S,f,c,p,t,i,o,a;g=g.with({path:d(g.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const s=await fetch(g.toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),s.status!==200)throw new Error(s.statusText);const u=await s.text(),w=`${g.toString(!0)}#vscode-extension`,_=`${u}
//# sourceURL=${w}`;let v;try{v=k.create((f=(S=P._ttpExtensionScripts)===null||S===void 0?void 0:S.createScript("module"))!==null&&f!==void 0?f:"module",(p=(c=P._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&p!==void 0?p:"exports",(i=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(a=(o=P._ttpExtensionScripts)===null||o===void 0?void 0:o.createScript(_))!==null&&a!==void 0?a:_)}catch(Y){throw l?console.error(`Loading code for extension ${l.value} failed: ${Y.message}`):console.error(`Loading code failed: ${Y.message}`),console.error(`${g.toString(!0)}${typeof Y.line=="number"?` line ${Y.line}`:""}${typeof Y.column=="number"?` column ${Y.column}`:""}`),console.error(Y),Y}const E={},F={exports:E},B=Y=>{const fe=this._fakeModules.getModule(Y,g);if(fe===void 0)throw new Error(`Cannot load module '${Y}'`);return fe};try{return m.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),v(F,E,B),F.exports!==E?F.exports:E}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(l){throw new Error("Not supported")}async _waitForDebuggerAttachment(l=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const g=Date.now()+l;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(D=self.trustedTypes)===null||D===void 0?void 0:D.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,l){return r.endsWith(l)?r:r+l}function h(r,l){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(f,c){const p=console[f];console[f]=function(){r.$logExtensionHostMessage({type:"__$console",severity:c,arguments:S(arguments)}),l&&p.apply(console,arguments)}}const m=1e5;function S(f){const c=[],p=[];if(f.length)for(let t=0;t<f.length;t++){if(typeof f[t]=="undefined")f[t]="undefined";else if(f[t]instanceof Error){const i=f[t];i.stack?f[t]=i.stack:f[t]=i.toString()}p.push(f[t])}try{const t=JSON.stringify(p,function(i,o){if(o&&typeof o=="object"){if(c.indexOf(o)!==-1)return"[Circular]";c.push(o)}return o});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[229],_e([0,1,61,18,35,228,214]),function(Q,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,b.registerSingleton)(I.ILogService,y.ExtHostLogService)}),define(be[231],_e([0,1,23,3,185,223,216,13,80,227,229]),function(Q,e,b,I,A,T,y,C,D){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const n=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:S=>S}),m=self.Worker;Worker=function(S,f){const c=`importScripts('${S}');`;f=f||{},f.name=f.name||C.basename(S.toString());const p=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(p);return new m(g?g.createScriptURL(t):t,f)}}else self.Worker=class extends y.NestedWorker{constructor(g,m){super(P,g,Object.assign({name:C.basename(g.toString())},m))}};const d=new class{exit(g){n()}async exists(g){return!0}async realpath(g){return g}};class h{constructor(){const m=new MessageChannel,S=new I.Emitter;let f=!1;P(m.port2,[m.port2]),m.port1.onmessage=c=>{const{data:p}=c;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const t=b.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,A.isMessageOfType)(t,2)){f=!0,l("received terminate message from renderer");return}S.fire(t)},this.protocol={onMessage:S.event,send:c=>{if(!f){const p=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);m.port1.postMessage(p,[p])}}}}}function r(g){return new Promise(m=>{const S=g.onMessage(f=>{S.dispose();const c=JSON.parse(f.toString());g.send((0,A.createMessageOfType)(0)),m({protocol:g,initData:c})});g.send((0,A.createMessageOfType)(1))})}let l=g=>n();(function(){const m=new h;D.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(S=>{D.mark("code/extHost/didWaitForInitData");const f=new T.ExtensionHostMain(S.protocol,S.initData,d,null);l=c=>f.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/633562da380f9161ea2fd783e561eed508cfbbea/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
